/*
    JSXGraph 1.5.0

    Copyright 2008-2023
        Matthias Ehmann,
        Michael Gerhaeuser,
        Carsten Miller,
        Bianca Valentin,
        Andreas Walter,
        Alfred Wassermann,
        Peter Wilfahrt

    This file is part of JSXGraph.

    JSXGraph is free software dual licensed under the GNU LGPL or MIT License.

    You can redistribute it and/or modify it under the terms of the

      * GNU Lesser General Public License as published by
        the Free Software Foundation, either version 3 of the License, or
        (at your option) any later version
      OR
      * MIT License: https://github.com/jsxgraph/jsxgraph/blob/master/LICENSE.MIT

    JSXGraph is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License and
    the MIT License along with JSXGraph. If not, see <https://www.gnu.org/licenses/>
    and <https://opensource.org/licenses/MIT/>.
*/

/**
 * UTF-8 Decoder by Bjoern Hoehrmann
 *
 * Copyright (c) 2008-2009 Bjoern Hoehrmann <bjoern@hoehrmann.de>
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this
 * software and associated documentation files (the "Software"), to deal in the Software
 * without restriction, including without limitation the rights to use, copy, modify, merge,
 * publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons
 * to whom the Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all copies or
 * substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING
 * BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */
var __webpack_modules__={351:(t,e,i)=>{i.d(e,{Z:()=>n});var s,r=i(765),o="1.5.0";s={version:o,licenseText:"JSXGraph v1.5.0 Copyright (C) see https://jsxgraph.org",COORDS_BY_USER:1,COORDS_BY_SCREEN:2,OBJECT_TYPE_ARC:1,OBJECT_TYPE_ARROW:2,OBJECT_TYPE_AXIS:3,OBJECT_TYPE_AXISPOINT:4,OBJECT_TYPE_TICKS:5,OBJECT_TYPE_CIRCLE:6,OBJECT_TYPE_CONIC:7,OBJECT_TYPE_CURVE:8,OBJECT_TYPE_GLIDER:9,OBJECT_TYPE_IMAGE:10,OBJECT_TYPE_LINE:11,OBJECT_TYPE_POINT:12,OBJECT_TYPE_SLIDER:13,OBJECT_TYPE_CAS:14,OBJECT_TYPE_GXTCAS:15,OBJECT_TYPE_POLYGON:16,OBJECT_TYPE_SECTOR:17,OBJECT_TYPE_TEXT:18,OBJECT_TYPE_ANGLE:19,OBJECT_TYPE_INTERSECTION:20,OBJECT_TYPE_TURTLE:21,OBJECT_TYPE_VECTOR:22,OBJECT_TYPE_OPROJECT:23,OBJECT_TYPE_GRID:24,OBJECT_TYPE_TANGENT:25,OBJECT_TYPE_HTMLSLIDER:26,OBJECT_TYPE_CHECKBOX:27,OBJECT_TYPE_INPUT:28,OBJECT_TYPE_BUTTON:29,OBJECT_TYPE_TRANSFORMATION:30,OBJECT_TYPE_FOREIGNOBJECT:31,OBJECT_TYPE_VIEW3D:32,OBJECT_TYPE_POINT3D:33,OBJECT_TYPE_LINE3D:34,OBJECT_TYPE_PLANE3D:35,OBJECT_TYPE_CURVE3D:36,OBJECT_TYPE_SURFACE3D:37,OBJECT_CLASS_POINT:1,OBJECT_CLASS_LINE:2,OBJECT_CLASS_CIRCLE:3,OBJECT_CLASS_CURVE:4,OBJECT_CLASS_AREA:5,OBJECT_CLASS_OTHER:6,OBJECT_CLASS_TEXT:7,OBJECT_CLASS_3D:8,GENTYPE_ABC:1,GENTYPE_AXIS:2,GENTYPE_MID:3,GENTYPE_REFLECTION:4,GENTYPE_MIRRORELEMENT:5,GENTYPE_REFLECTION_ON_LINE:4,GENTYPE_REFLECTION_ON_POINT:5,GENTYPE_TANGENT:6,GENTYPE_PARALLEL:7,GENTYPE_BISECTORLINES:8,GENTYPE_BOARDIMG:9,GENTYPE_BISECTOR:10,GENTYPE_NORMAL:11,GENTYPE_POINT:12,GENTYPE_GLIDER:13,GENTYPE_INTERSECTION:14,GENTYPE_CIRCLE:15,GENTYPE_CIRCLE2POINTS:16,GENTYPE_LINE:17,GENTYPE_TRIANGLE:18,GENTYPE_QUADRILATERAL:19,GENTYPE_TEXT:20,GENTYPE_POLYGON:21,GENTYPE_REGULARPOLYGON:22,GENTYPE_SECTOR:23,GENTYPE_ANGLE:24,GENTYPE_PLOT:25,GENTYPE_SLIDER:26,GENTYPE_TRUNCATE:27,GENTYPE_JCODE:28,GENTYPE_MOVEMENT:29,GENTYPE_COMBINED:30,GENTYPE_RULER:31,GENTYPE_SLOPETRIANGLE:32,GENTYPE_PERPSEGMENT:33,GENTYPE_LABELMOVEMENT:34,GENTYPE_VECTOR:35,GENTYPE_NONREFLEXANGLE:36,GENTYPE_REFLEXANGLE:37,GENTYPE_PATH:38,GENTYPE_DERIVATIVE:39,GENTYPE_DELETE:41,GENTYPE_COPY:42,GENTYPE_MIRROR:43,GENTYPE_ROTATE:44,GENTYPE_ABLATION:45,GENTYPE_MIGRATE:46,GENTYPE_VECTORCOPY:47,GENTYPE_POLYGONCOPY:48,GENTYPE_CTX_TYPE_G:51,GENTYPE_CTX_TYPE_P:52,GENTYPE_CTX_TRACE:53,GENTYPE_CTX_VISIBILITY:54,GENTYPE_CTX_CCVISIBILITY:55,GENTYPE_CTX_MPVISIBILITY:56,GENTYPE_CTX_WITHLABEL:57,GENTYPE_CTX_LABEL:58,GENTYPE_CTX_FIXED:59,GENTYPE_CTX_STROKEWIDTH:60,GENTYPE_CTX_LABELSIZE:61,GENTYPE_CTX_SIZE:62,GENTYPE_CTX_FACE:63,GENTYPE_CTX_STRAIGHT:64,GENTYPE_CTX_ARROW:65,GENTYPE_CTX_COLOR:66,GENTYPE_CTX_RADIUS:67,GENTYPE_CTX_COORDS:68,GENTYPE_CTX_TEXT:69,GENTYPE_CTX_ANGLERADIUS:70,GENTYPE_CTX_DOTVISIBILITY:71,GENTYPE_CTX_FILLOPACITY:72,GENTYPE_CTX_PLOT:73,GENTYPE_CTX_SCALE:74,GENTYPE_CTX_INTVAL:75,GENTYPE_CTX_POINT1:76,GENTYPE_CTX_POINT2:77,GENTYPE_CTX_LABELSTICKY:78,GENTYPE_CTX_TYPE_I:79,GENTYPE_CTX_HASINNERPOINTS:80,GENTYPE_CTX_SNAPWIDTH:81,GENTYPE_CTX_SNAPTOGRID:82},r.Z.extendConstants(r.Z,s);const n=s},705:(t,e,i)=>{i.d(e,{Z:()=>h});var s=i(765),r=i(351),o=i(88),n=i(109),a=i(275);s.Z.Coords=function(t,e,i,s){this.board=i,this.usrCoords=[],this.scrCoords=[],this.emitter=!n.Z.exists(s)||s,this.emitter&&o.Z.eventify(this),this.setCoordinates(t,e,!1,!0)},s.Z.extend(s.Z.Coords.prototype,{normalizeUsrCoords:function(){Math.abs(this.usrCoords[0])>a.Z.eps&&(this.usrCoords[1]/=this.usrCoords[0],this.usrCoords[2]/=this.usrCoords[0],this.usrCoords[0]=1)},usr2screen:function(t){var e=Math.round,i=this.board,s=this.usrCoords,r=i.origin.scrCoords;!0===t?(this.scrCoords[0]=e(s[0]),this.scrCoords[1]=e(s[0]*r[1]+s[1]*i.unitX),this.scrCoords[2]=e(s[0]*r[2]-s[2]*i.unitY)):(this.scrCoords[0]=s[0],this.scrCoords[1]=s[0]*r[1]+s[1]*i.unitX,this.scrCoords[2]=s[0]*r[2]-s[2]*i.unitY)},screen2usr:function(){var t=this.board.origin.scrCoords,e=this.scrCoords,i=this.board;this.usrCoords[0]=1,this.usrCoords[1]=(e[1]-t[1])/i.unitX,this.usrCoords[2]=(t[2]-e[2])/i.unitY},distance:function(t,e){var i,s,o=0,n=this.usrCoords,h=this.scrCoords;if(t===r.Z.COORDS_BY_USER){if(i=e.usrCoords,(o=(s=n[0]-i[0])*s)>a.Z.eps*a.Z.eps)return Number.POSITIVE_INFINITY;o+=(s=n[1]-i[1])*s,o+=(s=n[2]-i[2])*s}else i=e.scrCoords,o+=(s=h[1]-i[1])*s,o+=(s=h[2]-i[2])*s;return Math.sqrt(o)},setCoordinates:function(t,e,i,s){var o=this.usrCoords,n=this.scrCoords,a=[o[0],o[1],o[2]],h=[n[0],n[1],n[2]];return t===r.Z.COORDS_BY_USER?(2===e.length?(o[0]=1,o[1]=e[0],o[2]=e[1]):(o[0]=e[0],o[1]=e[1],o[2]=e[2],this.normalizeUsrCoords()),this.usr2screen(i)):(2===e.length?(n[1]=e[0],n[2]=e[1]):(n[1]=e[1],n[2]=e[2]),this.screen2usr()),!this.emitter||s||h[1]===n[1]&&h[2]===n[2]||this.triggerEventHandlers(["update"],[a,h]),this},copy:function(t,e){return void 0===e&&(e=0),this[t].slice(e)},isReal:function(){return!isNaN(this.usrCoords[1]+this.usrCoords[2])&&Math.abs(this.usrCoords[0])>a.Z.eps},__evt__update:function(t,e){},__evt:function(){}});const h=s.Z.Coords},218:(t,e,i)=>{i.d(e,{Z:()=>d});var s=i(765),r=i(275),o=i(922),n=i(336),a=i(309),h=i(705),l=i(351),c=i(109);s.Z.CoordsElement=function(t,e){var i;for(c.Z.exists(t)||(t=[1,0,0]),i=0;i<t.length;++i)t[i]=parseFloat(t[i]);this.coords=new h.Z(l.Z.COORDS_BY_USER,t,this.board),this.initialCoords=new h.Z(l.Z.COORDS_BY_USER,t,this.board),this.position=null,this.isConstrained=!1,this.onPolygon=!1,this.slideObject=null,this.slideObjects=[],this.needsUpdateFromParent=!0,this.groups=[],this.Xjc=null,this.Yjc=null,this.methodMap=c.Z.deepCopy(this.methodMap,{move:"moveTo",moveTo:"moveTo",moveAlong:"moveAlong",visit:"visit",glide:"makeGlider",makeGlider:"makeGlider",intersect:"makeIntersection",makeIntersection:"makeIntersection",X:"X",Y:"Y",free:"free",setPosition:"setGliderPosition",setGliderPosition:"setGliderPosition",addConstraint:"addConstraint",dist:"Dist",onPolygon:"onPolygon"}),c.Z.exists(this.element)&&this.addAnchor(t,e),this.isDraggable=!0},s.Z.extend(s.Z.CoordsElement.prototype,{updateConstraint:function(){return this},updateCoords:function(t){return this.needsUpdate?(c.Z.exists(t)||(t=!1),c.Z.evaluate(this.visProp.frozen)||this.updateConstraint(),this.type===l.Z.OBJECT_TYPE_GLIDER&&(this.isConstrained&&(t=!1),t?this.updateGliderFromParent():this.updateGlider()),this.updateTransform(t),this):this},updateGlider:function(){var t,e,i,s,n,a,d,u,p,_,f,b,g,m,v,Z,C,y,P,E=2*Math.PI,O=!1,x=this.slideObject,w=[];if(this.needsUpdateFromParent=!1,x.elementClass===l.Z.OBJECT_CLASS_CIRCLE)c.Z.evaluate(this.visProp.isgeonext)&&(E=1),m=o.Z.projectPointToCircle(this,x,this.board),v=o.Z.rad([x.center.X()+1,x.center.Y()],x.center,this)/E;else if(x.elementClass===l.Z.OBJECT_CLASS_LINE){if(this.onPolygon){if(e=x.point1.coords.usrCoords,s=(i=x.point2.coords.usrCoords)[t=1]-e[t],Math.abs(s)<r.Z.eps&&(s=i[t=2]-e[t]),d=(o.Z.projectPointToLine(this,x,this.board).usrCoords[t]-e[t])/s,a=x.parentPolygon,d<0){for(t=0;t<a.borders.length;t++)if(x===a.borders[t]){x=a.borders[(t-1+a.borders.length)%a.borders.length];break}}else if(d>1)for(t=0;t<a.borders.length;t++)if(x===a.borders[t]){x=a.borders[(t+1+a.borders.length)%a.borders.length];break}x.id!==this.slideObject.id&&(this.slideObject=x)}e=x.point1.coords,i=x.point2.coords,(s=e.distance(l.Z.COORDS_BY_USER,i))<r.Z.eps?(m=e,O=!0,v=0):(m=o.Z.projectPointToLine(this,x,this.board),e=e.usrCoords.slice(0),i=i.usrCoords.slice(0),Math.abs(i[0])<r.Z.eps?(s=i[t=1],Math.abs(s)<r.Z.eps&&(s=i[t=2]),v=((s=(m.usrCoords[t]-e[t])/s)>=0?1:-1)*(s=Math.abs(s))/(s+1)):Math.abs(e[0])<r.Z.eps?(s=e[t=1],Math.abs(s)<r.Z.eps&&(s=e[t=2]),v=(s=(m.usrCoords[t]-i[t])/s)<0?(1-2*s)/(1-s):1/(s+1)):(s=i[t=1]-e[t],Math.abs(s)<r.Z.eps&&(s=i[t=2]-e[t]),v=(m.usrCoords[t]-e[t])/s)),Z=c.Z.evaluate(this.visProp.snapwidth),c.Z.evaluate(Z)>0&&Math.abs(this._smax-this._smin)>=r.Z.eps&&(n=(v=Math.max(Math.min(v,1),0))*(this._smax-this._smin)+this._smin,v=((n=Math.round(n/Z)*Z)-this._smin)/(this._smax-this._smin),this.update(!0)),e=x.point1.coords,!c.Z.evaluate(x.visProp.straightfirst)&&Math.abs(e.usrCoords[0])>r.Z.eps&&v<0&&(m=e,O=!0,v=0),i=x.point2.coords,!c.Z.evaluate(x.visProp.straightlast)&&Math.abs(i.usrCoords[0])>r.Z.eps&&v>1&&(m=i,O=!0,v=1)}else if(x.type===l.Z.OBJECT_TYPE_TURTLE)this.updateConstraint(),m=(C=o.Z.projectPointToTurtle(this,x,this.board))[0],v=C[1];else if(x.elementClass===l.Z.OBJECT_CLASS_CURVE)if(x.type===l.Z.OBJECT_TYPE_ARC||x.type===l.Z.OBJECT_TYPE_SECTOR)m=o.Z.projectPointToCircle(this,x,this.board),_=o.Z.rad(x.radiuspoint,x.center,this),u=0,p=o.Z.rad(x.radiuspoint,x.center,x.anglepoint),v=_,("minor"===(Z=c.Z.evaluate(x.visProp.selection))&&p>Math.PI||"major"===Z&&p<Math.PI)&&(u=p,p=2*Math.PI),(_<u||_>p)&&(v=p,(_<u&&_>.5*u||_>p&&_>.5*p+Math.PI)&&(v=u),this.needsUpdateFromParent=!0,this.updateGliderFromParent()),E=p-u,this.visProp.isgeonext&&(E=1),Math.abs(E)>r.Z.eps&&(v/=E);else if(this.updateConstraint(),x.transformations.length>0){for(P=!1,(C=x.getTransformationSource())[0]&&(P=C[0],w.push(x),w.push(C[1]));C[0]&&c.Z.exists(C[1]._transformationSource);)C=C[1].getTransformationSource(),w.push(C[1]);if(y=this.coords.usrCoords,P){for(t=0;t<w.length;t++)w[t].updateTransformMatrix(),g=r.Z.inverse(w[t].transformMat),y=r.Z.matVecMult(g,y);for(f=new h.Z(l.Z.COORDS_BY_USER,y,this.board).usrCoords,y=(b=o.Z.projectCoordsToCurve(f[1],f[2],this.position||0,w[w.length-1],this.board))[0].usrCoords,t=w.length-2;t>=0;t--)y=r.Z.matVecMult(w[t].transformMat,y);b[0]=new h.Z(l.Z.COORDS_BY_USER,y,this.board)}else x.updateTransformMatrix(),g=r.Z.inverse(x.transformMat),y=r.Z.matVecMult(g,y),f=new h.Z(l.Z.COORDS_BY_USER,y,this.board).usrCoords,b=o.Z.projectCoordsToCurve(f[1],f[2],this.position||0,x,this.board);m=b[0],v=b[1]}else m=(C=o.Z.projectPointToCurve(this,x,this.board))[0],v=C[1];else c.Z.isPoint(x)&&(m=o.Z.projectPointToPoint(this,x,this.board),v=this.position);this.coords.setCoordinates(l.Z.COORDS_BY_USER,m.usrCoords,O),this.position=v},updateGliderFromParent:function(){var t,e,i,s,n,a,d,u,p,_,f,b,g=this.slideObject,m=[],v=2*Math.PI;if(this.needsUpdateFromParent){if(g.elementClass===l.Z.OBJECT_CLASS_CIRCLE)i=g.Radius(),c.Z.evaluate(this.visProp.isgeonext)&&(v=1),n=[g.center.X()+i*Math.cos(this.position*v),g.center.Y()+i*Math.sin(this.position*v)];else if(g.elementClass===l.Z.OBJECT_CLASS_LINE)t=g.point1.coords.usrCoords,e=g.point2.coords.usrCoords,0===t[0]&&0===t[1]&&0===t[2]||0===e[0]&&0===e[1]&&0===e[2]?n=[0,0,0]:Math.abs(e[0])<r.Z.eps?(s=Math.min(Math.abs(this.position),1-r.Z.eps),s/=1-s,this.position<0&&(s=-s),n=[t[0]+s*e[0],t[1]+s*e[1],t[2]+s*e[2]]):Math.abs(t[0])<r.Z.eps?(s=Math.max(this.position,r.Z.eps),s=(s=Math.min(s,2-r.Z.eps))>1?(s-1)/(s-2):(1-s)/s,n=[e[0]+s*t[0],e[1]+s*t[1],e[2]+s*t[2]]):(s=this.position,n=[t[0]+s*(e[0]-t[0]),t[1]+s*(e[1]-t[1]),t[2]+s*(e[2]-t[2])]);else if(g.type===l.Z.OBJECT_TYPE_TURTLE)this.coords.setCoordinates(l.Z.COORDS_BY_USER,[g.Z(this.position),g.X(this.position),g.Y(this.position)]),this.updateConstraint(),n=o.Z.projectPointToTurtle(this,g,this.board)[0].usrCoords;else if(g.elementClass===l.Z.OBJECT_CLASS_CURVE){for(u=!1,(a=g.getTransformationSource())[0]&&(u=a[0],m.push(g),m.push(a[1]));a[0]&&c.Z.exists(a[1]._transformationSource);)a=a[1].getTransformationSource(),m.push(a[1]);if(u?this.coords.setCoordinates(l.Z.COORDS_BY_USER,[m[m.length-1].Z(this.position),m[m.length-1].X(this.position),m[m.length-1].Y(this.position)]):this.coords.setCoordinates(l.Z.COORDS_BY_USER,[g.Z(this.position),g.X(this.position),g.Y(this.position)]),g.type===l.Z.OBJECT_TYPE_ARC||g.type===l.Z.OBJECT_TYPE_SECTOR)p=o.Z.rad([g.center.X()+1,g.center.Y()],g.center,g.radiuspoint),_=0,b=o.Z.rad(g.radiuspoint,g.center,g.anglepoint),("minor"===g.visProp.selection&&b>Math.PI||"major"===g.visProp.selection&&b<Math.PI)&&(_=b,b=2*Math.PI),v=b-_,c.Z.evaluate(this.visProp.isgeonext)&&(v=1),((f=this.position*v)<_||f>b)&&(((f=b)<_&&f>.5*_||f>b&&f>.5*b+Math.PI)&&(f=_),this.position=f,Math.abs(v)>r.Z.eps&&(this.position/=v)),i=g.Radius(),n=[g.center.X()+i*Math.cos(this.position*v+p),g.center.Y()+i*Math.sin(this.position*v+p)];else if(this.updateConstraint(),u)for(n=o.Z.projectPointToCurve(this,m[m.length-1],this.board)[0].usrCoords,d=m.length-2;d>=0;d--)n=new h.Z(l.Z.COORDS_BY_USER,r.Z.matVecMult(m[d].transformMat,n),this.board).usrCoords;else n=o.Z.projectPointToCurve(this,g,this.board)[0].usrCoords}else c.Z.isPoint(g)&&(n=o.Z.projectPointToPoint(this,g,this.board).usrCoords);this.coords.setCoordinates(l.Z.COORDS_BY_USER,n,!1)}else this.needsUpdateFromParent=!0},updateRendererGeneric:function(t){return this.needsUpdate&&this.board.renderer?(this.visPropCalc.visible&&(this.isReal=!isNaN(this.coords.usrCoords[1]+this.coords.usrCoords[2]),this.isReal=Math.abs(this.coords.usrCoords[0])>r.Z.eps&&this.isReal,this.isReal||this.updateVisibility(!1)),this.visPropCalc.visible&&this.board.renderer[t](this),this.hasLabel&&this.visPropCalc.visible&&this.label&&this.label.visPropCalc.visible&&this.isReal&&(this.label.update(),this.board.renderer.updateText(this.label)),this.setDisplayRendNode(),this.needsUpdate=!1,this):this},X:function(){return this.coords.usrCoords[1]},Y:function(){return this.coords.usrCoords[2]},Z:function(){return this.coords.usrCoords[0]},XEval:function(){return this.coords.usrCoords[1]},YEval:function(){return this.coords.usrCoords[2]},ZEval:function(){return this.coords.usrCoords[0]},Dist:function(t){return this.isReal&&t.isReal?this.coords.distance(l.Z.COORDS_BY_USER,t.coords):NaN},snapToGrid:function(t){return this.handleSnapToGrid(t)},handleSnapToPoints:function(t){var e,i,s,r,n,a,h,d,u=0,p=1/0,_=null,f=c.Z.evaluate(this.visProp.ignoredsnaptopoints),b=!1;if(r=this.board.objectsList.length,f&&(h=f.length),c.Z.evaluate(this.visProp.snaptopoints)||t){for(n=c.Z.evaluate(this.visProp.attractorunit),a=c.Z.evaluate(this.visProp.attractordistance),e=0;e<r;e++){if(i=this.board.objectsList[e],f){for(b=!1,d=0;d<h;d++)if(i===this.board.select(f[d])){b=!0;break}if(b)continue}c.Z.isPoint(i)&&i!==this&&i.visPropCalc.visible&&(s=o.Z.projectPointToPoint(this,i,this.board),(u="screen"===n?s.distance(l.Z.COORDS_BY_SCREEN,this.coords):s.distance(l.Z.COORDS_BY_USER,this.coords))<a&&u<p&&(p=u,_=s))}null!==_&&this.coords.setCoordinates(l.Z.COORDS_BY_USER,_.usrCoords)}return this},snapToPoints:function(t){return this.handleSnapToPoints(t)},handleAttractors:function(){var t,e,i,s,r=0,n=c.Z.evaluate(this.visProp.attractorunit),a=c.Z.evaluate(this.visProp.attractordistance),d=c.Z.evaluate(this.visProp.snatchdistance),u=c.Z.evaluate(this.visProp.attractors),p=u.length;if(0!==a){for(t=0;t<p;t++)if(e=this.board.select(u[t]),c.Z.exists(e)&&e!==this){if(c.Z.isPoint(e)?i=o.Z.projectPointToPoint(this,e,this.board):e.elementClass===l.Z.OBJECT_CLASS_LINE?(s=o.Z.projectCoordsToSegment(this.coords.usrCoords,e.point1.coords.usrCoords,e.point2.coords.usrCoords),i=!c.Z.evaluate(e.visProp.straightfirst)&&s[1]<0?e.point1.coords:!c.Z.evaluate(e.visProp.straightlast)&&s[1]>1?e.point2.coords:new h.Z(l.Z.COORDS_BY_USER,s[0],this.board)):e.elementClass===l.Z.OBJECT_CLASS_CIRCLE?i=o.Z.projectPointToCircle(this,e,this.board):e.elementClass===l.Z.OBJECT_CLASS_CURVE?i=o.Z.projectPointToCurve(this,e,this.board)[0]:e.type===l.Z.OBJECT_TYPE_TURTLE?i=o.Z.projectPointToTurtle(this,e,this.board)[0]:e.type===l.Z.OBJECT_TYPE_POLYGON&&(i=new h.Z(l.Z.COORDS_BY_USER,o.Z.projectCoordsToPolygon(this.coords.usrCoords,e),this.board)),(r="screen"===n?i.distance(l.Z.COORDS_BY_SCREEN,this.coords):i.distance(l.Z.COORDS_BY_USER,this.coords))<a){this.type===l.Z.OBJECT_TYPE_GLIDER&&(e===this.slideObject||this.slideObject&&this.onPolygon&&this.slideObject.parentPolygon===e)||this.makeGlider(e);break}r>=d&&(e===this.slideObject||this.slideObject&&this.onPolygon&&this.slideObject.parentPolygon===e)&&this.popSlideObject()}return this}},setPositionDirectly:function(t,e){var i,s,o,n,d=this.coords;if(this.relativeCoords)return s=new h.Z(t,e,this.board),c.Z.evaluate(this.visProp.islabel)?(o=a.Z.subtract(s.scrCoords,d.scrCoords),this.relativeCoords.scrCoords[1]+=o[1],this.relativeCoords.scrCoords[2]+=o[2]):(o=a.Z.subtract(s.usrCoords,d.usrCoords),this.relativeCoords.usrCoords[1]+=o[1],this.relativeCoords.usrCoords[2]+=o[2]),this;for(this.coords.setCoordinates(t,e),this.handleSnapToGrid(),this.handleSnapToPoints(),this.handleAttractors(),i=this.transformations.length-1;i>=0;i--)t===l.Z.COORDS_BY_SCREEN?n=new h.Z(t,e,this.board).usrCoords:(2===e.length&&(e=[1].concat(e)),n=e),this.initialCoords.setCoordinates(l.Z.COORDS_BY_USER,r.Z.matVecMult(r.Z.inverse(this.transformations[i].matrix),n));return this.prepareUpdate().update(),this.board.isSuspendedUpdate&&this.type===l.Z.OBJECT_TYPE_GLIDER&&this.updateGlider(),this},setPositionByTransform:function(t,e){var i;return e=new h.Z(t,e,this.board),i=this.board.create("transform",e.usrCoords.slice(1),{type:"translate"}),this.transformations.length>0&&this.transformations[this.transformations.length-1].isNumericMatrix?this.transformations[this.transformations.length-1].melt(i):this.addTransform(this,i),this.prepareUpdate().update(),this},setPosition:function(t,e){return this.setPositionDirectly(t,e)},setGliderPosition:function(t){return this.type===l.Z.OBJECT_TYPE_GLIDER&&(this.position=t,this.board.update()),this},makeGlider:function(t){var e,i,r,o=this.board.select(t),n=!1;if(o.type===l.Z.OBJECT_TYPE_POLYGON){for(e=Number.MAX_VALUE,i=0;i<o.borders.length;i++)(r=s.Z.Math.Geometry.distPointLine(this.coords.usrCoords,o.borders[i].stdform))<e&&(e=r,t=o.borders[i]);o=this.board.select(t),n=!0}if(!c.Z.exists(o))throw new Error("JSXGraph: slide object undefined.");if(o.type===l.Z.OBJECT_TYPE_TICKS)throw new Error("JSXGraph: gliders on ticks are not possible.");return this.slideObject=this.board.select(t),this.slideObjects.push(this.slideObject),this.addParents(t),this.type=l.Z.OBJECT_TYPE_GLIDER,this.elType="glider",this.visProp.snapwidth=-1,this.slideObject.addChild(this),this.isDraggable=!0,this.onPolygon=n,this.generatePolynomial=function(){return this.slideObject.generatePolynomial(this)},this.updateGlider(),this.needsUpdateFromParent=!0,this.updateGliderFromParent(),this},popSlideObject:function(){this.slideObjects.length>0&&(this.slideObjects.pop(),this.slideObject.removeChild(this),0===this.slideObjects.length?(this.type=this._org_type,this.type===l.Z.OBJECT_TYPE_POINT?this.elType="point":this.elementClass===l.Z.OBJECT_CLASS_TEXT?this.elType="text":this.type===l.Z.OBJECT_TYPE_IMAGE?this.elType="image":this.type===l.Z.OBJECT_TYPE_FOREIGNOBJECT&&(this.elType="foreignobject"),this.slideObject=null):this.slideObject=this.slideObjects[this.slideObjects.length-1])},free:function(){var t,e;if(this.type!==l.Z.OBJECT_TYPE_GLIDER){if(this.transformations.length=0,delete this.updateConstraint,this.isConstrained=!1,this.isDraggable)return;this.isDraggable=!0,this.elementClass===l.Z.OBJECT_CLASS_POINT&&(this.type=l.Z.OBJECT_TYPE_POINT,this.elType="point"),this.XEval=function(){return this.coords.usrCoords[1]},this.YEval=function(){return this.coords.usrCoords[2]},this.ZEval=function(){return this.coords.usrCoords[0]},this.Xjc=null,this.Yjc=null}for(t in this.board.objects)this.board.objects.hasOwnProperty(t)&&(e=this.board.objects[t]).descendants&&(delete e.descendants[this.id],delete e.childElements[this.id],this.hasLabel&&(delete e.descendants[this.label.id],delete e.childElements[this.label.id]));this.ancestors={},this.slideObject=null,this.slideObjects=[],this.elementClass===l.Z.OBJECT_CLASS_POINT?(this.type=l.Z.OBJECT_TYPE_POINT,this.elType="point"):this.elementClass===l.Z.OBJECT_CLASS_TEXT?(this.type=this._org_type,this.elType="text"):this.elementClass===l.Z.OBJECT_CLASS_OTHER&&(this.type=this._org_type,this.elType="image")},addConstraint:function(t){var e,i,s=[],r=["X","Y"],o=function(t){return function(){return t}},n=function(t){return function(){return t.Value()}};for(this.elementClass===l.Z.OBJECT_CLASS_POINT&&(this.type=l.Z.OBJECT_TYPE_CAS),this.isDraggable=!1,e=0;e<t.length;e++)i=t[e],c.Z.isString(i)?(s[e]=this.board.jc.snippet(i,!0,null,!0),this.addParentsFromJCFunctions([s[e]]),2===t.length&&(this[r[e]+"jc"]=t[e])):c.Z.isFunction(i)?s[e]=i:c.Z.isNumber(i)?s[e]=o(i):c.Z.isObject(i)&&c.Z.isFunction(i.Value)&&(s[e]=n(i)),s[e].origin=i;return 1===t.length?this.updateConstraint=function(){var t=s[0]();return c.Z.isArray(t)?this.coords.setCoordinates(l.Z.COORDS_BY_USER,t):this.coords=t,this}:2===t.length?(this.XEval=s[0],this.YEval=s[1],this.addParents([s[0].origin,s[1].origin]),this.updateConstraint=function(){return this.coords.setCoordinates(l.Z.COORDS_BY_USER,[this.XEval(),this.YEval()]),this}):(this.ZEval=s[0],this.XEval=s[1],this.YEval=s[2],this.addParents([s[0].origin,s[1].origin,s[2].origin]),this.updateConstraint=function(){return this.coords.setCoordinates(l.Z.COORDS_BY_USER,[this.ZEval(),this.XEval(),this.YEval()]),this}),this.isConstrained=!0,this.prepareUpdate().update(),this.board.isSuspendedUpdate||(this.updateVisibility().updateRenderer(),this.hasLabel&&this.label.fullUpdate()),this},addAnchor:function(t,e){this.relativeCoords=e?new h.Z(l.Z.COORDS_BY_SCREEN,t.slice(0,2),this.board):new h.Z(l.Z.COORDS_BY_USER,t,this.board),this.element.addChild(this),e&&this.addParents(this.element),this.XEval=function(){var t,e,i;return c.Z.evaluate(this.visProp.islabel)?(i=c.Z.evaluate(this.visProp.offset),t=parseFloat(i[0]),e=this.element.getLabelAnchor(),new h.Z(l.Z.COORDS_BY_SCREEN,[t+this.relativeCoords.scrCoords[1]+e.scrCoords[1],0],this.board).usrCoords[1]):(e=this.element.getTextAnchor(),this.relativeCoords.usrCoords[1]+e.usrCoords[1])},this.YEval=function(){var t,e,i;return c.Z.evaluate(this.visProp.islabel)?(i=c.Z.evaluate(this.visProp.offset),t=-parseFloat(i[1]),e=this.element.getLabelAnchor(),new h.Z(l.Z.COORDS_BY_SCREEN,[0,t+this.relativeCoords.scrCoords[2]+e.scrCoords[2]],this.board).usrCoords[2]):(e=this.element.getTextAnchor(),this.relativeCoords.usrCoords[2]+e.usrCoords[2])},this.ZEval=c.Z.createFunction(1,this.board,""),this.updateConstraint=function(){this.coords.setCoordinates(l.Z.COORDS_BY_USER,[this.ZEval(),this.XEval(),this.YEval()])},this.isConstrained=!0,this.updateConstraint()},updateTransform:function(t){var e;if(0===this.transformations.length)return this;for(e=0;e<this.transformations.length;e++)this.transformations[e].update();return this},addTransform:function(t,e){var i,s=c.Z.isArray(e)?e:[e],r=s.length;for(0===this.transformations.length&&(this.baseElement=t),i=0;i<r;i++)this.transformations.push(s[i]);return this},startAnimation:function(t,e,i){var s=c.Z.evaluate(t),r=c.Z.evaluate(e),o=this;return i=c.Z.evaluate(i)||250,this.type!==l.Z.OBJECT_TYPE_GLIDER||c.Z.exists(this.intervalCode)||(this.intervalCode=window.setInterval((function(){o._anim(s,r)}),i),c.Z.exists(this.intervalCount)||(this.intervalCount=0)),this},stopAnimation:function(){return c.Z.exists(this.intervalCode)&&(window.clearInterval(this.intervalCode),delete this.intervalCode),this},moveAlong:function(t,e,i){i=i||{};var s,r,o,a,h,d=[],u=[],p=e/this.board.attr.animationdelay,_=function(e,i){return function(){return t[e][i]}};if(c.Z.isArray(t)){for(o=t.length,s=0;s<o;s++)c.Z.isPoint(t[s])?u[s]=t[s]:u[s]={elementClass:l.Z.OBJECT_CLASS_POINT,X:_(s,0),Y:_(s,1)};if(0===(e=e||0))return this.setPosition(l.Z.COORDS_BY_USER,[u[u.length-1].X(),u[u.length-1].Y()]),this.board.update(this);if(!c.Z.exists(i.interpolate)||i.interpolate)for(r=n.Z.Neville(u),s=0;s<p;s++)d[s]=[],d[s][0]=r[0]((p-s)/p*r[3]()),d[s][1]=r[1]((p-s)/p*r[3]());else{for(o=t.length-1,s=0;s<p;++s)h=s/p*o-(a=Math.floor(s/p*o)),d[s]=[],d[s][0]=(1-h)*u[a].X()+h*u[a+1].X(),d[s][1]=(1-h)*u[a].Y()+h*u[a+1].Y();d.push([u[o].X(),u[o].Y()]),d.reverse()}this.animationPath=d}else c.Z.isFunction(t)&&(this.animationPath=t,this.animationStart=(new Date).getTime());return this.animationCallback=i.callback,this.board.addAnimation(this),this},moveTo:function(t,e,i){i=i||{},t=new h.Z(l.Z.COORDS_BY_USER,t,this.board);var s,o=this.board.attr.animationdelay,n=Math.ceil(e/o),a=[],d=this.coords.usrCoords[1],u=this.coords.usrCoords[2],p=t.usrCoords[1]-d,_=t.usrCoords[2]-u,f=function(t){return i.effect&&"<>"===i.effect?Math.pow(Math.sin(t/n*Math.PI/2),2):t/n};if(!c.Z.exists(e)||0===e||Math.abs(t.usrCoords[0]-this.coords.usrCoords[0])>r.Z.eps)return this.setPosition(l.Z.COORDS_BY_USER,t.usrCoords),this.board.update(this);if(!c.Z.exists(i.callback)&&Math.abs(p)<r.Z.eps&&Math.abs(_)<r.Z.eps)return this;for(s=n;s>=0;s--)a[n-s]=[t.usrCoords[0],d+p*f(s),u+_*f(s)];return this.animationPath=a,this.animationCallback=i.callback,this.board.addAnimation(this),this},visit:function(t,e,i){t=new h.Z(l.Z.COORDS_BY_USER,t,this.board);var s,r,o,n=this.board.attr.animationdelay,a=[],d=this.coords.usrCoords[1],u=this.coords.usrCoords[2],p=t.usrCoords[1]-d,_=t.usrCoords[2]-u,f=function(t){var e=t<o/2?2*t/o:2*(o-t)/o;return i.effect&&"<>"===i.effect?Math.pow(Math.sin(e*Math.PI/2),2):e};for(c.Z.isNumber(i)?i={repeat:i}:(i=i||{},c.Z.exists(i.repeat)||(i.repeat=1)),o=Math.ceil(e/(n*i.repeat)),r=0;r<i.repeat;r++)for(s=o;s>=0;s--)a[r*(o+1)+o-s]=[t.usrCoords[0],d+p*f(s),u+_*f(s)];return this.animationPath=a,this.animationCallback=i.callback,this.board.addAnimation(this),this},_anim:function(t,e){var i,s,r,n,a,h,c,d,u;return this.intervalCount+=1,this.intervalCount>e&&(this.intervalCount=0),this.slideObject.elementClass===l.Z.OBJECT_CLASS_LINE?(c=this.slideObject.point1.coords.scrCoords,d=this.slideObject.point2.coords.scrCoords,i=Math.round((d[1]-c[1])*this.intervalCount/e),s=Math.round((d[2]-c[2])*this.intervalCount/e),t>0?n=this.slideObject.point1:(n=this.slideObject.point2,i*=-1,s*=-1),this.coords.setCoordinates(l.Z.COORDS_BY_SCREEN,[n.coords.scrCoords[1]+i,n.coords.scrCoords[2]+s])):this.slideObject.elementClass===l.Z.OBJECT_CLASS_CURVE?(a=t>0?Math.round(this.intervalCount/e*this.board.canvasWidth):Math.round((e-this.intervalCount)/e*this.board.canvasWidth),this.coords.setCoordinates(l.Z.COORDS_BY_SCREEN,[a,0]),u=o.Z.projectPointToCurve(this,this.slideObject,this.board),this.coords=u[0],this.position=u[1]):this.slideObject.elementClass===l.Z.OBJECT_CLASS_CIRCLE&&(r=2*Math.PI,r*=t<0?this.intervalCount/e:(e-this.intervalCount)/e,h=this.slideObject.Radius(),this.coords.setCoordinates(l.Z.COORDS_BY_USER,[this.slideObject.center.coords.usrCoords[1]+h*Math.cos(r),this.slideObject.center.coords.usrCoords[2]+h*Math.sin(r)])),this.board.update(this),this},getTextAnchor:function(){return this.coords},getLabelAnchor:function(){return this.coords},getParents:function(){var t=[this.Z(),this.X(),this.Y()];return 0!==this.parents.length&&(t=this.parents),this.type===l.Z.OBJECT_TYPE_GLIDER&&(t=[this.X(),this.Y(),this.slideObject.id]),t}}),s.Z.CoordsElement.create=function(t,e,i,s,r,o){var n,a,h=!1;for(a=0;a<i.length;a++)(c.Z.isFunction(i[a])||c.Z.isString(i[a]))&&(h=!0);if(h)(n=new t(e,[0,0],s,r,o)).addConstraint(i);else if(c.Z.isNumber(i[0])&&c.Z.isNumber(i[1]))n=new t(e,i,s,r,o),c.Z.exists(s.slideobject)?n.makeGlider(s.slideobject):n.baseElement=n,n.isDraggable=!0;else{if(!c.Z.isObject(i[0])||!c.Z.isTransformationOrArray(i[1]))return!1;(n=new t(e,[0,0],s,r,o)).addTransform(i[0],i[1]),n.isDraggable=!1}return n.handleSnapToGrid(),n.handleSnapToPoints(),n.handleAttractors(),n.addParents(i),n};const d=s.Z.CoordsElement},958:(t,e,i)=>{i.d(e,{Z:()=>u});var s=i(765),r=i(351),o=i(705),n=i(275),a=i(309),h=i(766),l=i(88),c=i(327),d=i(109);s.Z.GeometryElement=function(t,e,i,s){var o,n,a;if(this.needsUpdate=!0,this.isDraggable=!1,this.isReal=!0,this.childElements={},this.hasLabel=!1,this.highlighted=!1,this.notExistingParents={},this.traces={},this.numTraces=0,this.transformations=[],this.baseElement=null,this.descendants={},this.ancestors={},this.parents=[],this.symbolic={},this.rendNode=null,this.elType="",this.dump=!0,this.subs={},this.inherits=[],this._pos=-1,this.stdform=[1,0,0,0,1,1,0,0],this.methodMap={setLabel:"setLabel",label:"label",setName:"setName",getName:"getName",addTransform:"addTransform",setProperty:"setAttribute",setAttribute:"setAttribute",addChild:"addChild",animate:"animate",on:"on",off:"off",trigger:"trigger",addTicks:"addTicks",removeTicks:"removeTicks",removeAllTicks:"removeAllTicks"},this.quadraticform=[[1,0,0],[0,1,0],[0,0,1]],this.visProp={},this.visPropCalc={visible:!1},l.Z.eventify(this),this.mouseover=!1,this.lastDragTime=new Date,arguments.length>0){for(n in this.board=t,this.type=i,this._org_type=i,this.elementClass=s||r.Z.OBJECT_CLASS_OTHER,this.id=e.id,o=e.name,d.Z.exists(o)||(o=this.board.generateName(this)),""!==o&&(this.board.elementsByName[o]=this),this.name=o,this.needsRegularUpdate=e.needsregularupdate,d.Z.clearVisPropOld(this),a=this.resolveShortcuts(e))a.hasOwnProperty(n)&&this._set(n,a[n]);this.visProp.draft=a.draft&&a.draft.draft}},s.Z.extend(s.Z.GeometryElement.prototype,{addChild:function(t){var e,i;for(e in this.childElements[t.id]=t,this.addDescendants(t),t.ancestors[this.id]=this,this.descendants)if(this.descendants.hasOwnProperty(e))for(i in this.descendants[e].ancestors[this.id]=this,this.ancestors)this.ancestors.hasOwnProperty(i)&&(this.descendants[e].ancestors[this.ancestors[i].id]=this.ancestors[i]);for(e in this.ancestors)if(this.ancestors.hasOwnProperty(e))for(i in this.descendants)this.descendants.hasOwnProperty(i)&&(this.ancestors[e].descendants[this.descendants[i].id]=this.descendants[i]);return this},addDescendants:function(t){var e;for(e in this.descendants[t.id]=t,t.childElements)t.childElements.hasOwnProperty(e)&&this.addDescendants(t.childElements[e]);return this},addParents:function(t){var e,i,s;for(i=(s=d.Z.isArray(t)?t:arguments).length,e=0;e<i;++e)d.Z.exists(s[e])&&(d.Z.isId(this.board,s[e])?this.parents.push(s[e]):d.Z.exists(s[e].id)&&this.parents.push(s[e].id));this.parents=d.Z.uniqueArray(this.parents)},setParents:function(t){this.parents=[],this.addParents(t)},addParentsFromJCFunctions:function(t){var e,i,s;for(e=0;e<t.length;e++)for(i in t[e].deps)s=t[e].deps[i],this.addParents(s),s.addChild(this);return this},removeChild:function(t){return delete this.childElements[t.id],this.removeDescendants(t),delete t.ancestors[this.id],this},removeDescendants:function(t){var e;for(e in delete this.descendants[t.id],t.childElements)t.childElements.hasOwnProperty(e)&&this.removeDescendants(t.childElements[e]);return this},countChildren:function(){var t,e,i=0;for(t in e=this.childElements)e.hasOwnProperty(t)&&t.indexOf("Label")<0&&i++;return i},getName:function(){return this.name},addTransform:function(t){return this},draggable:function(){return this.isDraggable&&!d.Z.evaluate(this.visProp.fixed)&&this.type!==r.Z.OBJECT_TYPE_GLIDER},setPosition:function(t,e){var i,s,o,n,a=[];if(!d.Z.exists(this.parents))return this;for(o=this.parents.length,s=0;s<o;++s)if(i=this.board.select(this.parents[s]),d.Z.isPoint(i)){if(!i.draggable())return this;a.push(i)}for(3===e.length&&(e=e.slice(1)),n=this.board.create("transform",e,{type:"translate"}),(o=a.length)>0?n.applyOnce(a):this.transformations.length>0&&this.transformations[this.transformations.length-1].isNumericMatrix?this.transformations[this.transformations.length-1].melt(n):this.addTransform(n),s=0;s<o;++s)a[s].type===r.Z.OBJECT_TYPE_GLIDER&&a[s].updateGlider();return this},setPositionDirectly:function(t,e,i){var s=new o.Z(t,e,this.board,!1),n=new o.Z(t,i,this.board,!1),h=a.Z.subtract(s.usrCoords,n.usrCoords);return this.setPosition(r.Z.COORDS_BY_USER,h),this},generatePolynomial:function(){return[]},animate:function(t,e,i){i=i||{};var s,r,o,n=this.board.attr.animationdelay,a=Math.ceil(e/n),h=this,l=function(t,e,i){var s,r,n,l,d;for(s=c.Z.rgb2hsv(t),n=((r=c.Z.rgb2hsv(e))[0]-s[0])/a,l=(r[1]-s[1])/a,d=(r[2]-s[2])/a,h.animationData[i]=[],o=0;o<a;o++)h.animationData[i][a-o-1]=c.Z.hsv2rgb(s[0]+(o+1)*n,s[1]+(o+1)*l,s[2]+(o+1)*d)},u=function(t,e,i,s){var r,n;if(t=parseFloat(t),e=parseFloat(e),!isNaN(t)&&!isNaN(e))for(n=(e-t)/a,h.animationData[i]=[],o=0;o<a;o++)r=t+(o+1)*n,h.animationData[i][a-o-1]=s?Math.floor(r):r};for(s in this.animationData={},t)if(t.hasOwnProperty(s))switch(r=s.toLowerCase()){case"strokecolor":case"fillcolor":l(this.visProp[r],t[s],r);break;case"size":if(!d.Z.isPoint(this))break;u(this.visProp[r],t[s],r,!0);break;case"strokeopacity":case"strokewidth":case"fillopacity":u(this.visProp[r],t[s],r,!1)}return this.animationCallback=i.callback,this.board.addAnimation(this),this},update:function(){return d.Z.evaluate(this.visProp.trace)&&this.cloneToBackground(),this},updateRenderer:function(){return this},fullUpdate:function(t){return this.prepareUpdate().update().updateVisibility(t).updateRenderer()},setDisplayRendNode:function(t){var e,i,s,r,o;if(void 0===t&&(t=this.visPropCalc.visible),t===this.visPropOld.visible)return this;for(this.board.renderer.display(this,t),i=this.inherits.length,s=0;s<i;s++)if(o=this.inherits[s],d.Z.isArray(o))for(r=o.length,e=0;e<r;e++)d.Z.exists(o[e])&&d.Z.exists(o[e].rendNode)&&"inherit"===d.Z.evaluate(o[e].visProp.visible)&&o[e].setDisplayRendNode(t);else d.Z.exists(o)&&d.Z.exists(o.rendNode)&&"inherit"===d.Z.evaluate(o.visProp.visible)&&o.setDisplayRendNode(t);return this.hasLabel&&d.Z.exists(this.label)&&d.Z.exists(this.label.rendNode)&&"inherit"===d.Z.evaluate(this.label.visProp.visible)&&this.label.setDisplayRendNode(t),this},hide:function(){return this.setAttribute({visible:!1}),this},hideElement:function(){return this.hide(),this},show:function(){return this.setAttribute({visible:!0}),this},showElement:function(){return this.show(),this},updateVisibility:function(t){var e,i,s,r,o,n;if(this.needsUpdate){for(void 0!==t?this.visPropCalc.visible=t:(n=d.Z.evaluate(this.visProp.visible),d.Z.exists(this.hiddenByParent)&&this.hiddenByParent&&(n=!1),"inherit"!==n&&(this.visPropCalc.visible=n)),i=this.inherits.length,s=0;s<i;s++)if(o=this.inherits[s],d.Z.isArray(o))for(r=o.length,e=0;e<r;e++)d.Z.exists(o[e])&&"inherit"===d.Z.evaluate(o[e].visProp.visible)&&o[e].prepareUpdate().updateVisibility(this.visPropCalc.visible);else d.Z.exists(o)&&"inherit"===d.Z.evaluate(o.visProp.visible)&&o.prepareUpdate().updateVisibility(this.visPropCalc.visible);d.Z.exists(this.label)&&d.Z.exists(this.label.visProp)&&d.Z.evaluate(this.label.visProp.visible)&&this.label.prepareUpdate().updateVisibility(this.visPropCalc.visible)}return this},_set:function(t,e){var i;if(t=t.toLocaleLowerCase(),this.visProp.hasOwnProperty(t)&&t.indexOf("color")>=0&&d.Z.isString(e)&&9===e.length&&"#"===e.charAt(0))e=c.Z.rgba2rgbo(e),this.visProp[t]=e[0],this.visProp[t.replace("color","opacity")]=e[1];else if(null===e||!d.Z.isObject(e)||d.Z.exists(e.id)||d.Z.exists(e.name))this.visProp[t]=e;else for(i in this.visProp[t]={},e)e.hasOwnProperty(i)&&(this.visProp[t][i.toLocaleLowerCase()]=e[i])},resolveShortcuts:function(t){var e,i,s,r=["traceattributes","traceAttributes"];for(e in h.Z.shortcuts)if(h.Z.shortcuts.hasOwnProperty(e)){if(d.Z.exists(t[e]))for(i=0;i<h.Z.shortcuts[e].length;i++)d.Z.exists(t[h.Z.shortcuts[e][i]])||(t[h.Z.shortcuts[e][i]]=t[e]);for(s=0;s<r.length;s++)d.Z.isObject(t[r[s]])&&(t[r[s]]=this.resolveShortcuts(t[r[s]]))}return t},setLabel:function(t){this.hasLabel||this.setAttribute({withlabel:!0}),this.setLabelText(t)},setLabelText:function(t){return d.Z.exists(this.label)&&(t=t.replace(/</g,"&lt;").replace(/>/g,"&gt;"),this.label.setText(t)),this},setName:function(t){t=t.replace(/</g,"&lt;").replace(/>/g,"&gt;"),"slider"!==this.elType&&this.setLabelText(t),this.setAttribute({name:t})},setProperty:function(){s.Z.deprecated("setProperty()","setAttribute()"),this.setAttribute.apply(this,arguments)},setAttribute:function(t){var e,i,o,n,a,h,l,u,p,_={};for(e=0;e<arguments.length;e++)h=arguments[e],d.Z.isString(h)?(u=h.split(":"),_[d.Z.trim(u[0])]=d.Z.trim(u[1])):d.Z.isArray(h)?_[h[0]]=h[1]:s.Z.extend(_,h);for(e in _=this.resolveShortcuts(_))if(_.hasOwnProperty(e)){if(n=e.replace(/\s+/g,"").toLowerCase(),a=_[e],d.Z.isObject(a)&&d.Z.exists(this.visProp[n])){if(this.visProp[n]=d.Z.merge(this.visProp[n],a),this.type===r.Z.OBJECT_TYPE_TICKS&&d.Z.exists(this.labels))for(o=this.labels.length,i=0;i<o;i++)this.labels[i].setAttribute(a);else if(d.Z.exists(this[n]))if(d.Z.isArray(this[n]))for(i=0;i<this[n].length;i++)this[n][i].setAttribute(a);else this[n].setAttribute(a);continue}switch(p=this.visProp[n],n){case"name":p=this.name,delete this.board.elementsByName[this.name],this.name=a,this.board.elementsByName[this.name]=this;break;case"needsregularupdate":this.needsRegularUpdate=!("false"===a||!1===a),this.board.renderer.setBuffering(this,this.needsRegularUpdate?"auto":"static");break;case"labelcolor":l=(a=c.Z.rgba2rgbo(a))[1],a=a[0],0===l&&d.Z.exists(this.label)&&this.hasLabel&&this.label.hideElement(),d.Z.exists(this.label)&&this.hasLabel&&(this.label.visProp.strokecolor=a,this.board.renderer.setObjectStrokeColor(this.label,a,l)),this.elementClass===r.Z.OBJECT_CLASS_TEXT&&(this.visProp.strokecolor=a,this.visProp.strokeopacity=l,this.board.renderer.setObjectStrokeColor(this,a,l));break;case"infoboxtext":d.Z.isString(a)?this.infoboxText=a:this.infoboxText=!1;break;case"visible":this.visProp.visible="false"!==a&&("true"===a||a),this.setDisplayRendNode(d.Z.evaluate(this.visProp.visible)),d.Z.evaluate(this.visProp.visible)&&d.Z.exists(this.updateSize)&&this.updateSize();break;case"face":d.Z.isPoint(this)&&(this.visProp.face=a,this.board.renderer.changePointStyle(this));break;case"trace":"false"===a||!1===a?(this.clearTrace(),this.visProp.trace=!1):this.visProp.trace="pause"!==a;break;case"gradient":this.visProp.gradient=a,this.board.renderer.setGradient(this);break;case"gradientsecondcolor":a=c.Z.rgba2rgbo(a),this.visProp.gradientsecondcolor=a[0],this.visProp.gradientsecondopacity=a[1],this.board.renderer.updateGradient(this);break;case"gradientsecondopacity":this.visProp.gradientsecondopacity=a,this.board.renderer.updateGradient(this);break;case"withlabel":this.visProp.withlabel=a,d.Z.evaluate(a)?(this.label||this.createLabel(),this.label.setAttribute({visible:"inherit"})):this.label&&this.hasLabel&&this.label.setAttribute({visible:!1}),this.hasLabel=a;break;case"radius":this.type!==r.Z.OBJECT_TYPE_ANGLE&&this.type!==r.Z.OBJECT_TYPE_SECTOR||this.setRadius(a);break;case"rotate":(this.elementClass===r.Z.OBJECT_CLASS_TEXT&&"internal"===d.Z.evaluate(this.visProp.display)||this.type===r.Z.OBJECT_TYPE_IMAGE)&&this.addRotation(a);break;case"ticksdistance":this.type===r.Z.OBJECT_TYPE_TICKS&&d.Z.isNumber(a)&&(this.ticksFunction=this.makeTicksFunction(a));break;case"generatelabelvalue":this.type===r.Z.OBJECT_TYPE_TICKS&&d.Z.isFunction(a)&&(this.generateLabelValue=a);break;case"onpolygon":this.type===r.Z.OBJECT_TYPE_GLIDER&&(this.onPolygon=!!a);break;case"disabled":d.Z.exists(this.rendNodeTag)&&(this.rendNodeTag.disabled=!!a);break;case"checked":d.Z.exists(this.rendNodeTag)&&(this.rendNodeCheckbox.checked=!!a);break;case"maxlength":d.Z.exists(this.rendNodeTag)&&(this.rendNodeTag.maxlength=!!a);break;case"layer":this.board.renderer.setLayer(this,d.Z.evaluate(a)),this._set(n,a);break;case"tabindex":d.Z.exists(this.rendNode)&&(this.rendNode.setAttribute("tabindex",a),this._set(n,a));break;default:d.Z.exists(this.visProp[n])&&(!s.Z.Validator[n]||s.Z.Validator[n]&&s.Z.Validator[n](a)||s.Z.Validator[n]&&d.Z.isFunction(a)&&s.Z.Validator[n](a()))&&(a=(!a.toLowerCase||"false"!==a.toLowerCase())&&a,this._set(n,a))}this.triggerEventHandlers(["attribute:"+n],[p,a,this])}return this.triggerEventHandlers(["attribute"],[_,this]),d.Z.evaluate(this.visProp.needsregularupdate)?this.board.update(this):this.board.fullUpdate(),this},getProperty:function(){s.Z.deprecated("getProperty()","getAttribute()"),this.getProperty.apply(this,arguments)},getAttribute:function(t){var e;switch(t=t.toLowerCase()){case"needsregularupdate":e=this.needsRegularUpdate;break;case"labelcolor":e=this.label.visProp.strokecolor;break;case"infoboxtext":e=this.infoboxText;break;case"withlabel":e=this.hasLabel;break;default:e=this.visProp[t]}return e},setDash:function(t){return this.setAttribute({dash:t}),this},prepareUpdate:function(){return this.needsUpdate=!0,this},remove:function(){return this.board.renderer.remove(this.board.renderer.getElementById(this.id)),this.hasLabel&&this.board.renderer.remove(this.board.renderer.getElementById(this.label.id)),this},getTextAnchor:function(){return new o.Z(r.Z.COORDS_BY_USER,[0,0],this.board)},getLabelAnchor:function(){return new o.Z(r.Z.COORDS_BY_USER,[0,0],this.board)},setArrow:function(t,e){return this.visProp.firstarrow=t,this.visProp.lastarrow=e,e&&(this.type=r.Z.OBJECT_TYPE_VECTOR,this.elType="arrow"),this.prepareUpdate().update().updateVisibility().updateRenderer(),this},createGradient:function(){var t=d.Z.evaluate(this.visProp.gradient);"linear"!==t&&"radial"!==t||this.board.renderer.setGradient(this)},createLabel:function(){var t,e=this;return s.Z.elements.text?((t=d.Z.deepCopy(this.visProp.label,null)).id=this.id+"Label",t.isLabel=!0,t.anchor=this,t.priv=this.visProp.priv,this.visProp.withlabel&&(this.label=s.Z.elements.text(this.board,[0,0,function(){return d.Z.isFunction(e.name)?e.name():e.name}],t),this.label.needsUpdate=!0,this.label.dump=!1,this.label.fullUpdate(),this.hasLabel=!0)):s.Z.debug("JSXGraph: Can't create label: text element is not available. Make sure you include base/text"),this},highlight:function(t){return t=d.Z.def(t,!1),!d.Z.evaluate(this.visProp.highlight)||this.highlighted&&!t||(this.highlighted=!0,this.board.highlightedObjects[this.id]=this,this.board.renderer.highlight(this)),this},noHighlight:function(){return this.highlighted&&(this.highlighted=!1,delete this.board.highlightedObjects[this.id],this.board.renderer.noHighlight(this)),this},clearTrace:function(){var t;for(t in this.traces)this.traces.hasOwnProperty(t)&&this.board.renderer.remove(this.traces[t]);return this.numTraces=0,this},cloneToBackground:function(){return this},bounds:function(){return[0,0,0,0]},normalize:function(){return this.stdform=n.Z.normalize(this.stdform),this},toJSON:function(){var t,e,i=['{"name":',this.name];for(e in i.push(', "id":'+this.id),t=[],this.visProp)this.visProp.hasOwnProperty(e)&&d.Z.exists(this.visProp[e])&&t.push('"'+e+'":'+this.visProp[e]);return i.push(', "visProp":{'+t.toString()+"}"),i.push("}"),i.join("")},addRotation:function(t){var e,i,s,o,n,a=this;return(this.elementClass===r.Z.OBJECT_CLASS_TEXT&&"internal"===d.Z.evaluate(this.visProp.display)||this.type===r.Z.OBJECT_TYPE_IMAGE)&&0!==t&&(e=this.board.create("transform",[function(){return-a.X()},function(){return-a.Y()}],{type:"translate"}),i=this.board.create("transform",[function(){return a.X()},function(){return a.Y()}],{type:"translate"}),s=this.board.create("transform",[function(){return a.board.unitX/a.board.unitY},function(){return 1}],{type:"scale"}),o=this.board.create("transform",[function(){return a.board.unitY/a.board.unitX},function(){return 1}],{type:"scale"}),n=this.board.create("transform",[function(){return d.Z.evaluate(t)*Math.PI/180}],{type:"rotate"}),e.bindTo(this),s.bindTo(this),n.bindTo(this),o.bindTo(this),i.bindTo(this)),this},highlightStrokeColor:function(t){return s.Z.deprecated("highlightStrokeColor()","setAttribute()"),this.setAttribute({highlightStrokeColor:t}),this},strokeColor:function(t){return s.Z.deprecated("strokeColor()","setAttribute()"),this.setAttribute({strokeColor:t}),this},strokeWidth:function(t){return s.Z.deprecated("strokeWidth()","setAttribute()"),this.setAttribute({strokeWidth:t}),this},fillColor:function(t){return s.Z.deprecated("fillColor()","setAttribute()"),this.setAttribute({fillColor:t}),this},highlightFillColor:function(t){return s.Z.deprecated("highlightFillColor()","setAttribute()"),this.setAttribute({highlightFillColor:t}),this},labelColor:function(t){return s.Z.deprecated("labelColor()","setAttribute()"),this.setAttribute({labelColor:t}),this},dash:function(t){return s.Z.deprecated("dash()","setAttribute()"),this.setAttribute({dash:t}),this},visible:function(t){return s.Z.deprecated("visible()","setAttribute()"),this.setAttribute({visible:t}),this},shadow:function(t){return s.Z.deprecated("shadow()","setAttribute()"),this.setAttribute({shadow:t}),this},getType:function(){return this.elType},getParents:function(){return d.Z.isArray(this.parents)?this.parents:[]},snapToGrid:function(){return this},snapToPoints:function(){return this},getAttributes:function(){var t,e=d.Z.deepCopy(this.visProp),i=[],s=i.length;for(e.id=this.id,e.name=this.name,t=0;t<s;t++)delete e[i[t]];return e},hasPoint:function(t,e){return!1},addTicks:function(t){return""!==t.id&&d.Z.exists(t.id)||(t.id=this.id+"_ticks_"+(this.ticks.length+1)),this.board.renderer.drawTicks(t),this.ticks.push(t),t.id},removeAllTicks:function(){var t;if(d.Z.exists(this.ticks)){for(t=this.ticks.length-1;t>=0;t--)this.removeTicks(this.ticks[t]);this.ticks=[],this.board.update()}},removeTicks:function(t){var e,i;if(d.Z.exists(this.defaultTicks)&&this.defaultTicks===t&&(this.defaultTicks=null),d.Z.exists(this.ticks))for(e=this.ticks.length-1;e>=0;e--)if(this.ticks[e]===t){if(this.board.removeObject(this.ticks[e]),this.ticks[e].ticks)for(i=0;i<this.ticks[e].ticks.length;i++)d.Z.exists(this.ticks[e].labels[i])&&this.board.removeObject(this.ticks[e].labels[i]);delete this.ticks[e];break}},getSnapSizes:function(){var t,e,i;return t=d.Z.evaluate(this.visProp.snapsizex),e=d.Z.evaluate(this.visProp.snapsizey),t<=0&&this.board.defaultAxes&&this.board.defaultAxes.x.defaultTicks&&(t=(i=this.board.defaultAxes.x.defaultTicks).ticksDelta*(d.Z.evaluate(i.visProp.minorticks)+1)),e<=0&&this.board.defaultAxes&&this.board.defaultAxes.y.defaultTicks&&(e=(i=this.board.defaultAxes.y.defaultTicks).ticksDelta*(d.Z.evaluate(i.visProp.minorticks)+1)),[t,e]},handleSnapToGrid:function(t,e){var i,o,n,a,h,l,c,u,p,_,f,b=d.Z.evaluate(this.visProp.attracttogrid),g=d.Z.evaluate(this.visProp.attractorunit),m=d.Z.evaluate(this.visProp.attractordistance);return!d.Z.exists(this.coords)||d.Z.evaluate(this.visProp.fixed)||(d.Z.evaluate(this.visProp.snaptogrid)||b||!0===t)&&(i=this.coords.usrCoords[1],o=this.coords.usrCoords[2],_=(p=this.getSnapSizes())[0],f=p[1],_>0&&f>0&&(u=this.board.getBoundingBox(),n=Math.round(i/_)*_,a=Math.round(o/f)*f,h=new s.Z.Coords(r.Z.COORDS_BY_USER,[n,a],this.board),(!b||h.distance("screen"===g?r.Z.COORDS_BY_SCREEN:r.Z.COORDS_BY_USER,this.coords)<m)&&(i=n,o=a,e||(l=Math.min(u[0],u[2]),c=Math.max(u[0],u[2]),i<l?i+=_:i>c&&(i-=_),l=Math.min(u[1],u[3]),c=Math.max(u[1],u[3]),o<l?o+=f:o>c&&(o-=f)),this.coords.setCoordinates(r.Z.COORDS_BY_USER,[i,o])))),this},getBoundingBox:function(){var t,e,i,s,o,n=[1/0,1/0,-1/0,-1/0];if(this.type===r.Z.OBJECT_TYPE_POLYGON){if((e=this.vertices.length-1)<=0)return n;for(t=0;t<e;t++)i=this.vertices[t].X(),n[0]=i<n[0]?i:n[0],n[2]=i>n[2]?i:n[2],i=this.vertices[t].Y(),n[1]=i<n[1]?i:n[1],n[3]=i>n[3]?i:n[3]}else if(this.elementClass===r.Z.OBJECT_CLASS_CIRCLE)s=this.center.X(),o=this.center.Y(),n=[s-this.radius,o+this.radius,s+this.radius,o-this.radius];else if(this.elementClass===r.Z.OBJECT_CLASS_CURVE){if(0===(e=this.vertices.length))return n;for(t=0;t<e;t++)i=this.points[t].coords.usrCoords[1],n[0]=i<n[0]?i:n[0],n[2]=i>n[2]?i:n[2],i=this.points[t].coords.usrCoords[1],n[1]=i<n[1]?i:n[1],n[3]=i>n[3]?i:n[3]}return n},addEvent:s.Z.shortcut(s.Z.GeometryElement.prototype,"on"),removeEvent:s.Z.shortcut(s.Z.GeometryElement.prototype,"off"),__evt__over:function(t){},__evt__mouseover:function(t){},__evt__out:function(t){},__evt__mouseout:function(t){},__evt__move:function(t){},__evt__mousemove:function(t){},__evt__drag:function(t){},__evt__mousedrag:function(t){},__evt__pendrag:function(t){},__evt__touchdrag:function(t){},__evt__keydrag:function(t){},__evt__down:function(t){},__evt__mousedown:function(t){},__evt__pendown:function(t){},__evt__touchdown:function(t){},__evt__up:function(t){},__evt__mouseup:function(t){},__evt__penup:function(t){},__evt__touchup:function(t){},__evt__attribute:function(t,e){},__evt__attribute_:function(t,e,i){},__evt:function(){}});const u=s.Z.GeometryElement},573:(t,e,i)=>{i.d(e,{Z:()=>u});var s=i(765),r=i(351),o=i(958),n=i(632),a=i(503),h=i(109),l=i(275),c=i(218),d=function(){this._val=parseFloat(this.rendNodeRange.value),this.rendNodeOut.value=this.rendNodeRange.value,this.board.update()};s.Z.Text=function(t,e,i,s){this.constructor(t,i,r.Z.OBJECT_TYPE_TEXT,r.Z.OBJECT_CLASS_TEXT),this.element=this.board.select(i.anchor),this.coordsConstructor(e,h.Z.evaluate(this.visProp.islabel)),this.content="",this.plaintext="",this.plaintextOld=null,this.orgText="",this.needsSizeUpdate=!1,this.hiddenByParent=!1,this.size=[1,1],this.id=this.board.setId(this,"T"),this.board.renderer.drawText(this),this.board.finalizeAdding(this),this.setText(s),h.Z.isString(this.content)&&this.notifyParents(this.content),this.elType="text",this.methodMap=h.Z.deepCopy(this.methodMap,{setText:"setTextJessieCode",move:"setCoords"})},s.Z.Text.prototype=new o.Z,h.Z.copyPrototypeMethods(s.Z.Text,c.Z,"coordsConstructor"),s.Z.extend(s.Z.Text.prototype,{hasPoint:function(t,e){var i,s,r,o,n,a,c,d;return h.Z.isObject(h.Z.evaluate(this.visProp.precision))?(c=this.board._inputDevice,d=h.Z.evaluate(this.visProp.precision[c])):d=this.board.options.precision.hasPoint,this.transformations.length>0&&(t=(i=l.Z.matVecMult(l.Z.inverse(this.board.renderer.joinTransforms(this,this.transformations)),[1,t,e]))[1],e=i[2]),s=(i="right"===(n=this.getAnchorX())?this.coords.scrCoords[1]-this.size[0]:"middle"===n?this.coords.scrCoords[1]-.5*this.size[0]:this.coords.scrCoords[1])+this.size[0],r=(o="top"===(a=this.getAnchorY())?this.coords.scrCoords[2]+this.size[1]:"middle"===a?this.coords.scrCoords[2]+.5*this.size[1]:this.coords.scrCoords[2])-this.size[1],"all"===h.Z.evaluate(this.visProp.dragarea)?t>=i-d&&t<s+d&&e>=r-d&&e<=o+d:e>=r-d&&e<=o+d&&(t>=i-d&&t<=i+2*d||t>=s-2*d&&t<=s+d)},_createFctUpdateText:function(t){var e,i,s,r=h.Z.evaluate(this.visProp.parse),o=h.Z.evaluate(this.visProp.usemathjax),n=h.Z.evaluate(this.visProp.usekatex),a=!1;if(this.orgText=t,h.Z.isFunction(t))this.updateText=function(){s=t().toString(),this.plaintext=!r||o||n?s:this.replaceSub(this.replaceSup(this.convertGeonextAndSketchometry2CSS(s)))};else if(h.Z.isNumber(t)?this.content=h.Z.toFixed(t,h.Z.evaluate(this.visProp.digits)):h.Z.isString(t)&&r&&(h.Z.evaluate(this.visProp.useasciimathml)?this.content="'`"+t+"`'":o||n?(this.content=this.valueTagToJessieCode(t),this.content=this.content.replace(/\\/g,"\\\\")):this.content=this.poorMansTeX(this.valueTagToJessieCode(t)),a=!0),a){for(i in(e=this.board.jc.snippet(this.content,!0,"",!1)).deps)this.addParents(e.deps[i]),e.deps[i].addChild(this);this.updateText=function(){this.plaintext=this.unescapeTicks(e())}}else this.updateText=function(){this.plaintext=t}},_setText:function(t){return this._createFctUpdateText(t),this.updateText(),this.fullUpdate(),this.board.infobox&&this.id===this.board.infobox.id||this.updateSize(),this},setTextJessieCode:function(t){var e;return this.visProp.castext=t,e=h.Z.isFunction(t)?function(){return h.Z.sanitizeHTML(t())}:h.Z.isNumber(t)?t:h.Z.sanitizeHTML(t),this._setText(e)},setText:function(t){return this._setText(t)},updateSize:function(){var t,e,i,s=h.Z.evaluate(this.visProp.display);return a.Z.isBrowser&&"no"!==this.board.renderer.type?(i=this.rendNode,"html"===s||"vml"===this.board.renderer.type?h.Z.exists(i.offsetWidth)?(e=this,window.setTimeout((function(){e.size=[i.offsetWidth,i.offsetHeight],e.needsUpdate=!0,e.updateRenderer()}),0)):this.size=this.crudeSizeEstimate():"internal"===s&&("svg"===this.board.renderer.type?(e=this,window.setTimeout((function(){try{t=i.getBBox(),e.size=[t.width,t.height],e.needsUpdate=!0,e.updateRenderer()}catch(t){}}),0)):"canvas"===this.board.renderer.type&&(this.size=this.crudeSizeEstimate())),this):this},crudeSizeEstimate:function(){var t=parseFloat(h.Z.evaluate(this.visProp.fontsize));return[t*this.plaintext.length*.45,.9*t]},utf8_decode:function(t){return t.replace(/&#x(\w+);/g,(function(t,e){return String.fromCharCode(parseInt(e,16))}))},replaceSub:function(t){if(!t.indexOf)return t;for(var e,i=t.indexOf("_{");i>=0;)(e=(t=t.substr(0,i)+t.substr(i).replace(/_\{/,"<sub>")).substr(i).indexOf("}"))>=0&&(t=t.substr(0,e)+t.substr(e).replace(/\}/,"</sub>")),i=t.indexOf("_{");for(i=t.indexOf("_");i>=0;)i=(t=t.substr(0,i)+t.substr(i).replace(/_(.?)/,"<sub>$1</sub>")).indexOf("_");return t},replaceSup:function(t){if(!t.indexOf)return t;for(var e,i=t.indexOf("^{");i>=0;)(e=(t=t.substr(0,i)+t.substr(i).replace(/\^\{/,"<sup>")).substr(i).indexOf("}"))>=0&&(t=t.substr(0,e)+t.substr(e).replace(/\}/,"</sup>")),i=t.indexOf("^{");for(i=t.indexOf("^");i>=0;)i=(t=t.substr(0,i)+t.substr(i).replace(/\^(.?)/,"<sup>$1</sup>")).indexOf("^");return t},getSize:function(){return this.size},setCoords:function(t,e){var i,s,o;return h.Z.isArray(t)&&t.length>1&&(e=t[1],t=t[0]),h.Z.evaluate(this.visProp.islabel)&&h.Z.exists(this.element)?(s=(t-(i=this.element.getLabelAnchor()).usrCoords[1])*this.board.unitX,o=-(e-i.usrCoords[2])*this.board.unitY,this.relativeCoords.setCoordinates(r.Z.COORDS_BY_SCREEN,[s,o])):this.coords.setCoordinates(r.Z.COORDS_BY_USER,[t,e]),this.fullUpdate(),this},update:function(t){return this.needsUpdate?(this.updateCoords(t),this.updateText(),"internal"===h.Z.evaluate(this.visProp.display)&&h.Z.isString(this.plaintext)&&(this.plaintext=this.utf8_decode(this.plaintext)),this.checkForSizeUpdate(),this.needsSizeUpdate&&this.updateSize(),this):this},checkForSizeUpdate:function(){this.board.infobox&&this.id===this.board.infobox.id?this.needsSizeUpdate=!1:(this.needsSizeUpdate=this.plaintextOld!==this.plaintext,this.needsSizeUpdate&&(this.plaintextOld=this.plaintext))},updateRenderer:function(){return h.Z.evaluate(this.visProp.autoposition)&&this.setAutoPosition().updateConstraint(),this.updateRendererGeneric("updateText")},expandShortMath:function(t){return t.replace(/([)0-9.])\s*([(a-zA-Z_])/g,"$1*$2")},generateTerm:function(t,e,i){var s,r,o,a,l='""';if(o=(t=(t=(t=(t=(t=(t=(t=(t=(t=(t=(t=t||"").replace(/\r/g,"")).replace(/\n/g,"")).replace(/"/g,"'")).replace(/'/g,"\\'")).replace(/&amp;arc;/g,"&ang;")).replace(/<arc\s*\/>/g,"&ang;")).replace(/&lt;arc\s*\/&gt;/g,"&ang;")).replace(/&lt;sqrt\s*\/&gt;/g,"&radic;")).replace(/&lt;value&gt;/g,"<value>")).replace(/&lt;\/value&gt;/g,"</value>")).indexOf("<value>"),a=t.indexOf("</value>"),o>=0)for(;o>=0;)l+=' + "'+this.replaceSub(this.replaceSup(t.slice(0,o)))+'"',r=(r=t.slice(o+7,a)).replace(/\s+/g,""),!0===e&&(r=this.expandShortMath(r)),(s=(s=(s=i?r:n.Z.geonext2JS(r,this.board)).replace(/\\"/g,"'")).replace(/\\'/g,"'")).indexOf("toFixed")<0&&h.Z.isNumber(h.Z.bind(this.board.jc.snippet(s,!0,"",!1),this)())?l+="+("+s+").toFixed("+h.Z.evaluate(this.visProp.digits)+")":l+="+("+s+")",o=(t=t.slice(a+8)).indexOf("<value>"),a=t.indexOf("</value>");return l+=' + "'+this.replaceSub(this.replaceSup(t))+'"',l=(l=(l=this.convertGeonextAndSketchometry2CSS(l)).replace(/&amp;/g,"&")).replace(/"/g,"'")},valueTagToJessieCode:function(t){var e,i,s,r,o=[],n='"';if(s=(t=(t=(t=(t=(t=t||"").replace(/\r/g,"")).replace(/\n/g,"")).replace(/&lt;value&gt;/g,"<value>")).replace(/&lt;\/value&gt;/g,"</value>")).indexOf("<value>"),r=t.indexOf("</value>"),s>=0)for(;s>=0;)o.push(n+this.escapeTicks(t.slice(0,s))+n),i=(i=t.slice(s+7,r)).replace(/\s+/g,""),(e=(e=i=this.expandShortMath(i)).replace(/\\"/g,"'").replace(/\\'/g,"'")).indexOf("toFixed")<0&&h.Z.isNumber(h.Z.bind(this.board.jc.snippet(e,!0,"",!1),this)())?o.push("("+e+").toFixed("+h.Z.evaluate(this.visProp.digits)+")"):o.push("("+e+")"),s=(t=t.slice(r+8)).indexOf("<value>"),r=t.indexOf("</value>");return o.push(n+this.escapeTicks(t)+n),o.join(" + ").replace(/&amp;/g,"&")},poorMansTeX:function(t){return t=t.replace(/<arc\s*\/*>/g,"&ang;").replace(/&lt;arc\s*\/*&gt;/g,"&ang;").replace(/<sqrt\s*\/*>/g,"&radic;").replace(/&lt;sqrt\s*\/*&gt;/g,"&radic;"),this.convertGeonextAndSketchometry2CSS(this.replaceSub(this.replaceSup(t)))},escapeTicks:function(t){return t.replace(/"/g,"%22").replace(/'/g,"%27")},unescapeTicks:function(t){return t.replace(/%22/g,'"').replace(/%27/g,"'")},convertGeonext2CSS:function(t){return h.Z.isString(t)&&(t=(t=(t=(t=t.replace(/(<|&lt;)overline(>|&gt;)/g,"<span style=text-decoration:overline;>")).replace(/(<|&lt;)\/overline(>|&gt;)/g,"</span>")).replace(/(<|&lt;)arrow(>|&gt;)/g,"<span style=text-decoration:overline;>")).replace(/(<|&lt;)\/arrow(>|&gt;)/g,"</span>")),t},convertSketchometry2CSS:function(t){return h.Z.isString(t)&&(t=(t=(t=(t=t.replace(/(<|&lt;)sketchofont(>|&gt;)/g,"<span style=font-family:sketchometry-light;font-weight:500;>")).replace(/(<|&lt;)\/sketchofont(>|&gt;)/g,"</span>")).replace(/(<|&lt;)sketchometry-light(>|&gt;)/g,"<span style=font-family:sketchometry-light;font-weight:500;>")).replace(/(<|&lt;)\/sketchometry-light(>|&gt;)/g,"</span>")),t},convertGeonextAndSketchometry2CSS:function(t){return t=this.convertGeonext2CSS(t),t=this.convertSketchometry2CSS(t)},notifyParents:function(t){var e,i=null;t=(t=t.replace(/&lt;value&gt;/g,"<value>")).replace(/&lt;\/value&gt;/g,"</value>");do{null!==(i=(e=/<value>([\w\s*/^\-+()[\],<>=!]+)<\/value>/).exec(t))&&(n.Z.findDependencies(this,i[1],this.board),t=(t=t.substr(i.index)).replace(e,""))}while(null!==i);return this},getParents:function(){var t;return t=void 0!==this.relativeCoords?[this.relativeCoords.usrCoords[1],this.relativeCoords.usrCoords[2],this.orgText]:[this.Z(),this.X(),this.Y(),this.orgText],0!==this.parents.length&&(t=this.parents),t},bounds:function(){var t=this.coords.usrCoords;return h.Z.evaluate(this.visProp.islabel)||0===this.board.unitY||0===this.board.unitX?[0,0,0,0]:[t[1],t[2]+this.size[1]/this.board.unitY,t[1]+this.size[0]/this.board.unitX,t[2]]},getAnchorX:function(){var t=h.Z.evaluate(this.visProp.anchorx);if("auto"===t)switch(this.visProp.position){case"top":case"bot":return"middle";case"rt":case"lrt":case"urt":return"left";default:return"right"}return t},getAnchorY:function(){var t=h.Z.evaluate(this.visProp.anchory);if("auto"===t)switch(this.visProp.position){case"top":case"ulft":case"urt":return"bottom";case"bot":case"lrt":case"llft":return"top";default:return"middle"}return t},getNumberofConflicts:function(t,e,i,s){var r,o,n,a,h=0;for(a=this.board.options.precision.hasPoint,this.board.options.precision.hasPoint=.25*(i+s),r=0,n=this.board.objectsList.length;r<n;r++)(o=this.board.objectsList[r]).visPropCalc.visible&&"axis"!==o.elType&&"ticks"!==o.elType&&o!==this.board.infobox&&o!==this&&o.hasPoint(t,e)&&h++;return this.board.options.precision.hasPoint=a,h},setAutoPosition:function(){var t,e,i,s,r,o,n,a,l,c,d,u,p,_,f,b,g=this.size[0],m=this.size[1],v={conflicts:1/0,angle:0,r:0},Z=2*Math.PI/12;if(this===this.board.infobox||!this.visPropCalc.visible||!h.Z.evaluate(this.visProp.islabel)||!this.element)return this;if(c=h.Z.evaluate(this.visProp.offset),i=(r=this.element.getLabelAnchor()).scrCoords[1],s=r.scrCoords[2],p=c[0],_=c[1],0===(l=this.getNumberofConflicts(i+p,s-_,g,m)))return this;for(28,a=.2*(d=12),o=Math.atan2(_,p),v.conflicts=l,v.angle=o,v.r=d;v.conflicts>0&&d<28;){for(u=1,n=o+Z;u<12&&v.conflicts>0&&(t=i+d*(f=Math.cos(n)),e=s-d*(b=Math.sin(n)),(l=this.getNumberofConflicts(t,e,g,m))<v.conflicts&&(v.conflicts=l,v.angle=n,v.r=d),0!==v.conflicts);u++)n+=Z;d+=a}return d=v.r,f=Math.cos(v.angle),b=Math.sin(v.angle),this.visProp.offset=[d*f,d*b],this.visProp.anchorx=f<-.2?"right":f>.2?"left":"middle",this}}),s.Z.createText=function(t,e,i){var r,o=h.Z.copyAttributes(i,t.options,"text"),n=e.slice(0,-1),a=e[e.length-1];if(o.anchor=o.parent||o.anchor,!(r=c.Z.create(s.Z.Text,t,n,o,a)))throw new Error("JSXGraph: Can't create text with parent types '"+typeof e[0]+"' and '"+typeof e[1]+"'.\nPossible parent types: [x,y], [z,x,y], [element,transformation]");return 0!==o.rotate&&"internal"===o.display&&r.addRotation(o.rotate),r},s.Z.registerElement("text",s.Z.createText),s.Z.createHTMLSlider=function(t,e,i){var r,o,n=h.Z.copyAttributes(i,t.options,"htmlslider");if(2!==e.length||2!==e[0].length||3!==e[1].length)throw new Error("JSXGraph: Can't create htmlslider with parent types '"+typeof e[0]+"' and '"+typeof e[1]+"'.\nPossible parents are: [[x,y], [min, start, max]]");n.anchor=n.parent||n.anchor,n.fixed=n.fixed||!0,o=[e[0][0],e[0][1],'<form style="display:inline"><input type="range" /><span></span><input type="text" /></form>'],(r=s.Z.createText(t,o,n)).type=h.Z.OBJECT_TYPE_HTMLSLIDER,r.rendNodeForm=r.rendNode.childNodes[0],r.rendNodeRange=r.rendNodeForm.childNodes[0],r.rendNodeRange.min=e[1][0],r.rendNodeRange.max=e[1][2],r.rendNodeRange.step=n.step,r.rendNodeRange.value=e[1][1],r.rendNodeLabel=r.rendNodeForm.childNodes[1],r.rendNodeLabel.id=r.rendNode.id+"_label",n.withlabel&&(r.rendNodeLabel.innerHTML=r.name+"="),r.rendNodeOut=r.rendNodeForm.childNodes[2],r.rendNodeOut.value=e[1][1];try{r.rendNodeForm.id=r.rendNode.id+"_form",r.rendNodeRange.id=r.rendNode.id+"_range",r.rendNodeOut.id=r.rendNode.id+"_out"}catch(t){s.Z.debug(t)}return r.rendNodeRange.style.width=n.widthrange+"px",r.rendNodeRange.style.verticalAlign="middle",r.rendNodeOut.style.width=n.widthout+"px",r._val=e[1][1],s.Z.supportsVML()?a.Z.addEvent(r.rendNodeForm,"change",d,r):a.Z.addEvent(r.rendNodeForm,"input",d,r),r.Value=function(){return this._val},r},s.Z.registerElement("htmlslider",s.Z.createHTMLSlider);const u=s.Z.Text},765:(t,e,i)=>{i.d(e,{Z:()=>r});var s={};"object"!=typeof JXG||JXG.extend||(s=JXG),s.extend=function(t,e,i,s){var r;for(r in i=i||!1,s=s||!1,e)(!i||i&&e.hasOwnProperty(r))&&(t[s?r.toLowerCase():r]=e[r])},s.defineConstant=function(t,e,i,r){(r=r||!1)&&s.exists(t[e])||Object.defineProperty(t,e,{value:i,writable:!1,enumerable:!0,configurable:!1})},s.extendConstants=function(t,e,i,s){var r,o;for(r in i=i||!1,s=s||!1,e)(!i||i&&e.hasOwnProperty(r))&&(o=s?r.toUpperCase():r,this.defineConstant(t,o,e[r]))},s.extend(s,{boards:{},readers:{},elements:{},registerElement:function(t,e){t=t.toLowerCase(),this.elements[t]=e},registerReader:function(t,e){var i,s;for(i=0;i<e.length;i++)s=e[i].toLowerCase(),"function"!=typeof this.readers[s]&&(this.readers[s]=t)},shortcut:function(t,e){return function(){return t[e].apply(this,arguments)}},getRef:function(t,e){return s.deprecated("JXG.getRef()","Board.select()"),t.select(e)},getReference:function(t,e){return s.deprecated("JXG.getReference()","Board.select()"),t.select(e)},getBoardByContainerId:function(t){var e;for(e in JXG.boards)if(JXG.boards.hasOwnProperty(e)&&JXG.boards[e].container===t)return JXG.boards[e];return null},deprecated:function(t,e){var i=t+" is deprecated.";e&&(i+=" Please use "+e+" instead."),s.warn(i)},warn:function(t){"object"==typeof window&&window.console&&console.warn?console.warn("WARNING:",t):"object"==typeof document&&document.getElementById("warning")&&(document.getElementById("debug").innerHTML+="WARNING: "+t+"<br />")},debugInt:function(t){var e,i;for(e=0;e<arguments.length;e++)i=arguments[e],"object"==typeof window&&window.console&&console.log?console.log(i):"object"==typeof document&&document.getElementById("debug")&&(document.getElementById("debug").innerHTML+=i+"<br/>")},debugWST:function(t){var e=new Error;s.debugInt.apply(this,arguments),e&&e.stack&&(s.debugInt("stacktrace"),s.debugInt(e.stack.split("\n").slice(1).join("\n")))},debugLine:function(t){var e=new Error;s.debugInt.apply(this,arguments),e&&e.stack&&s.debugInt("Called from",e.stack.split("\n").slice(2,3).join("\n"))},debug:function(t){s.debugInt.apply(this,arguments)}});const r=s},922:(t,e,i)=>{i.d(e,{Z:()=>c});var s=i(765),r=i(351),o=i(705),n=i(275),a=i(336),h=i(109),l=i(421);n.Z.Geometry={},s.Z.extend(n.Z.Geometry,{angle:function(t,e,i){var r,o,n,a,h=[],l=[],c=[];return s.Z.deprecated("Geometry.angle()","Geometry.rad()"),t.coords?(h[0]=t.coords.usrCoords[1],h[1]=t.coords.usrCoords[2]):(h[0]=t[0],h[1]=t[1]),e.coords?(l[0]=e.coords.usrCoords[1],l[1]=e.coords.usrCoords[2]):(l[0]=e[0],l[1]=e[1]),i.coords?(c[0]=i.coords.usrCoords[1],c[1]=i.coords.usrCoords[2]):(c[0]=i[0],c[1]=i[1]),r=h[0]-l[0],o=h[1]-l[1],n=c[0]-l[0],a=c[1]-l[1],Math.atan2(r*a-o*n,r*n+o*a)},trueAngle:function(t,e,i){return 57.29577951308232*this.rad(t,e,i)},rad:function(t,e,i){var s,r,o,n,a,h,l;return t.coords?(s=t.coords.usrCoords[1],r=t.coords.usrCoords[2]):(s=t[0],r=t[1]),e.coords?(o=e.coords.usrCoords[1],n=e.coords.usrCoords[2]):(o=e[0],n=e[1]),i.coords?(a=i.coords.usrCoords[1],h=i.coords.usrCoords[2]):(a=i[0],h=i[1]),(l=Math.atan2(h-n,a-o)-Math.atan2(r-n,s-o))<0&&(l+=6.283185307179586),l},angleBisector:function(t,e,i,s){var n,a,l,c,d,u=t.coords.usrCoords,p=e.coords.usrCoords,_=i.coords.usrCoords;return h.Z.exists(s)||(s=t.board),0===p[0]?new o.Z(r.Z.COORDS_BY_USER,[1,.5*(u[1]+_[1]),.5*(u[2]+_[2])],s):(c=u[1]-p[1],d=u[2]-p[2],n=Math.atan2(d,c),c=_[1]-p[1],d=_[2]-p[2],l=.5*(n+(a=Math.atan2(d,c))),n>a&&(l+=Math.PI),c=Math.cos(l)+p[1],d=Math.sin(l)+p[2],new o.Z(r.Z.COORDS_BY_USER,[1,c,d],s))},reflection:function(t,e,i){var s,n,a,l,c,d,u=e.coords.usrCoords,p=t.point1.coords.usrCoords,_=t.point2.coords.usrCoords;return h.Z.exists(i)||(i=e.board),l=_[1]-p[1],c=_[2]-p[2],s=u[1]-p[1],d=(l*(u[2]-p[2])-c*s)/(l*l+c*c),n=u[1]+2*d*c,a=u[2]-2*d*l,new o.Z(r.Z.COORDS_BY_USER,[n,a],i)},rotation:function(t,e,i,s){var n,a,l,c,d,u,p=e.coords.usrCoords,_=t.coords.usrCoords;return h.Z.exists(s)||(s=e.board),n=p[1]-_[1],a=p[2]-_[2],d=n*(l=Math.cos(i))-a*(c=Math.sin(i))+_[1],u=n*c+a*l+_[2],new o.Z(r.Z.COORDS_BY_USER,[d,u],s)},perpendicular:function(t,e,i){var s,a,l,c,d,u=t.point1.coords.usrCoords,p=t.point2.coords.usrCoords,_=e.coords.usrCoords;return h.Z.exists(i)||(i=e.board),e===t.point1?(s=u[1]+p[2]-u[2],a=u[2]-p[1]+u[1],d=u[0]*p[0],Math.abs(d)<n.Z.eps&&(s=p[2],a=-p[1]),c=[d,s,a],l=!0):e===t.point2?(s=p[1]+u[2]-p[2],a=p[2]-u[1]+p[1],d=u[0]*p[0],Math.abs(d)<n.Z.eps&&(s=u[2],a=-u[1]),c=[d,s,a],l=!1):Math.abs(n.Z.innerProduct(_,t.stdform,3))<n.Z.eps?(s=_[1]+p[2]-_[2],a=_[2]-p[1]+_[1],d=p[0],Math.abs(d)<n.Z.eps&&(s=p[2],a=-p[1]),l=!0,Math.abs(d)>n.Z.eps&&Math.abs(s-_[1])<n.Z.eps&&Math.abs(a-_[2])<n.Z.eps&&(s=_[1]+u[2]-_[2],a=_[2]-u[1]+_[1],l=!1),c=[d,s,a]):(c=[0,t.stdform[1],t.stdform[2]],c=n.Z.crossProduct(c,_),c=n.Z.crossProduct(c,t.stdform),l=!0),[new o.Z(r.Z.COORDS_BY_USER,c,i),l]},circumcenterMidpoint:function(){s.Z.deprecated("Geometry.circumcenterMidpoint()","Geometry.circumcenter()"),this.circumcenter.apply(this,arguments)},circumcenter:function(t,e,i,s){var a,l,c,d,u=t.coords.usrCoords,p=e.coords.usrCoords,_=i.coords.usrCoords;return h.Z.exists(s)||(s=t.board),a=[p[0]-u[0],-p[2]+u[2],p[1]-u[1]],l=[.5*(u[0]+p[0]),.5*(u[1]+p[1]),.5*(u[2]+p[2])],c=n.Z.crossProduct(a,l),a=[_[0]-p[0],-_[2]+p[2],_[1]-p[1]],l=[.5*(p[0]+_[0]),.5*(p[1]+_[1]),.5*(p[2]+_[2])],d=n.Z.crossProduct(a,l),new o.Z(r.Z.COORDS_BY_USER,n.Z.crossProduct(c,d),s)},distance:function(t,e,i){var s,r=0;for(i||(i=Math.min(t.length,e.length)),s=0;s<i;s++)r+=(t[s]-e[s])*(t[s]-e[s]);return Math.sqrt(r)},affineDistance:function(t,e,i){var s;return(s=this.distance(t,e,i))>n.Z.eps&&(Math.abs(t[0])<n.Z.eps||Math.abs(e[0])<n.Z.eps)?1/0:s},affineRatio:function(t,e,i){var s;return h.Z.exists(t.usrCoords)&&(t=t.usrCoords),h.Z.exists(e.usrCoords)&&(e=e.usrCoords),h.Z.exists(i.usrCoords)&&(i=i.usrCoords),s=e[1]-t[1],Math.abs(s)>n.Z.eps?(i[1]-t[1])/s:(i[2]-t[2])/(e[2]-t[2])},sortVertices:function(t){for(var e,i=l.Z.each(t,l.Z.coordsArray),s=i.length,r=null;i[0][0]===i[s-1][0]&&i[0][1]===i[s-1][1]&&i[0][2]===i[s-1][2];)r=i.pop(),s--;return e=i[0],i.sort((function(t,i){return(t[2]===e[2]&&t[1]===e[1]?-1/0:Math.atan2(t[2]-e[2],t[1]-e[1]))-(i[2]===e[2]&&i[1]===e[1]?-1/0:Math.atan2(i[2]-e[2],i[1]-e[1]))})),null!==r&&i.push(r),i},signedTriangle:function(t,e,i){var s=l.Z.coordsArray(t),r=l.Z.coordsArray(e),o=l.Z.coordsArray(i);return.5*((r[1]-s[1])*(o[2]-s[2])-(r[2]-s[2])*(o[1]-s[1]))},signedPolygon:function(t,e){var i,s,r=0,o=l.Z.each(t,l.Z.coordsArray);for(void 0===e&&(e=!0),e?o.unshift(o[o.length-1]):o=this.sortVertices(o),s=o.length,i=1;i<s;i++)r+=o[i-1][1]*o[i][2]-o[i][1]*o[i-1][2];return.5*r},GrahamScan:function(t){var e,i=1,s=l.Z.each(t,l.Z.coordsArray),r=s.length;for(r=(s=this.sortVertices(s)).length,e=2;e<r;e++){for(;this.signedTriangle(s[i-1],s[i],s[e])<=0;){if(i>1)i-=1;else if(e===r-1)break;e+=1}i+=1,s=h.Z.swap(s,i,e)}return s.slice(0,i)},calcStraight:function(t,e,i,s){var o,a,l,c,d,u,p,_,f,b;if(h.Z.exists(s)||(s=10),u=h.Z.evaluate(t.visProp.straightfirst),p=h.Z.evaluate(t.visProp.straightlast),Math.abs(e.scrCoords[0])<n.Z.eps&&(u=!0),Math.abs(i.scrCoords[0])<n.Z.eps&&(p=!0),(u||p)&&((_=[])[0]=t.stdform[0]-t.stdform[1]*t.board.origin.scrCoords[1]/t.board.unitX+t.stdform[2]*t.board.origin.scrCoords[2]/t.board.unitY,_[1]=t.stdform[1]/t.board.unitX,_[2]=-t.stdform[2]/t.board.unitY,!isNaN(_[0]+_[1]+_[2]))){if(!1,!1,o=!u&&Math.abs(e.usrCoords[0])>=n.Z.eps&&e.scrCoords[1]>=0&&e.scrCoords[1]<=t.board.canvasWidth&&e.scrCoords[2]>=0&&e.scrCoords[2]<=t.board.canvasHeight,a=!p&&Math.abs(i.usrCoords[0])>=n.Z.eps&&i.scrCoords[1]>=0&&i.scrCoords[1]<=t.board.canvasWidth&&i.scrCoords[2]>=0&&i.scrCoords[2]<=t.board.canvasHeight,c=(l=this.meetLineBoard(_,t.board,s))[0],d=l[1],!o&&!a){if(!u&&p&&!this.isSameDirection(e,i,c)&&!this.isSameDirection(e,i,d))return;if(u&&!p&&!this.isSameDirection(i,e,c)&&!this.isSameDirection(i,e,d))return}o?a||(b=this.isSameDir(e,i,c,d)?d:c):a?f=this.isSameDir(e,i,c,d)?c:d:this.isSameDir(e,i,c,d)?(f=c,b=d):(b=c,f=d),f&&e.setCoordinates(r.Z.COORDS_BY_USER,f.usrCoords),b&&i.setCoordinates(r.Z.COORDS_BY_USER,b.usrCoords)}},calcLineDelimitingPoints:function(t,e,i){var s,o,a,l,c,d,u,p,_,f,b;if(c=h.Z.evaluate(t.visProp.straightfirst),d=h.Z.evaluate(t.visProp.straightlast),Math.abs(e.scrCoords[0])<n.Z.eps&&(c=!0),Math.abs(i.scrCoords[0])<n.Z.eps&&(d=!0),(u=[])[0]=t.stdform[0]-t.stdform[1]*t.board.origin.scrCoords[1]/t.board.unitX+t.stdform[2]*t.board.origin.scrCoords[2]/t.board.unitY,u[1]=t.stdform[1]/t.board.unitX,u[2]=-t.stdform[2]/t.board.unitY,!isNaN(u[0]+u[1]+u[2])){if(f=!c,b=!d,o=t.board.getBoundingBox(),t.getSlope()>=0?(a=this.projectPointToLine({coords:{usrCoords:[1,o[2],o[1]]}},t,t.board),l=this.projectPointToLine({coords:{usrCoords:[1,o[0],o[3]]}},t,t.board)):(a=this.projectPointToLine({coords:{usrCoords:[1,o[0],o[1]]}},t,t.board),l=this.projectPointToLine({coords:{usrCoords:[1,o[2],o[3]]}},t,t.board)),!f&&!b){if(!c&&!d){if(s=e.distance(r.Z.COORDS_BY_USER,i),Math.abs(e.distance(r.Z.COORDS_BY_USER,a)+a.distance(r.Z.COORDS_BY_USER,i)-s)>n.Z.eps)return;if(Math.abs(e.distance(r.Z.COORDS_BY_USER,l)+l.distance(r.Z.COORDS_BY_USER,i)-s)>n.Z.eps)return}if(!c&&d&&!this.isSameDirection(e,i,a)&&!this.isSameDirection(e,i,l))return;if(c&&!d&&!this.isSameDirection(i,e,a)&&!this.isSameDirection(i,e,l))return}f?b||(_=this.isSameDir(e,i,a,l)?l:a):b?p=this.isSameDir(e,i,a,l)?a:l:this.isSameDir(e,i,a,l)?(p=a,_=l):(_=a,p=l),p&&e.setCoordinates(r.Z.COORDS_BY_USER,p.usrCoords),_&&i.setCoordinates(r.Z.COORDS_BY_USER,_.usrCoords)}},calcLabelQuadrant:function(t){return t<0&&(t+=2*Math.PI),["rt","urt","top","ulft","lft","llft","lrt"][Math.floor((t+Math.PI/8)/(Math.PI/4))%8]},isSameDir:function(t,e,i,s){var r=e.usrCoords[1]-t.usrCoords[1],o=e.usrCoords[2]-t.usrCoords[2],a=s.usrCoords[1]-i.usrCoords[1],h=s.usrCoords[2]-i.usrCoords[2];return Math.abs(e.usrCoords[0])<n.Z.eps&&(r=e.usrCoords[1],o=e.usrCoords[2]),Math.abs(t.usrCoords[0])<n.Z.eps&&(r=-t.usrCoords[1],o=-t.usrCoords[2]),r*a+o*h>=0},isSameDirection:function(t,e,i){var s,r,o,a,h=!1;return s=e.usrCoords[1]-t.usrCoords[1],r=e.usrCoords[2]-t.usrCoords[2],o=i.usrCoords[1]-t.usrCoords[1],a=i.usrCoords[2]-t.usrCoords[2],Math.abs(s)<n.Z.eps&&(s=0),Math.abs(r)<n.Z.eps&&(r=0),Math.abs(o)<n.Z.eps&&(o=0),Math.abs(a)<n.Z.eps&&(a=0),(s>=0&&o>=0||s<=0&&o<=0)&&(h=r>=0&&a>=0||r<=0&&a<=0),h},det3p:function(t,e,i){return(t[1]-i[1])*(e[2]-i[2])-(e[1]-i[1])*(t[2]-i[2])},windingNumber:function(t,e,i){var s,r,o,a,l,c,d=0,u=e.length,p=t[1],_=t[2],f=0;if(0===u)return 0;if((i=i||!1)&&(f=1),isNaN(p)||isNaN(_))return 1;if(h.Z.exists(e[0].coords)?(s=e[0].coords,r=e[u-1].coords):(s=e[0],r=e[u-1]),s.usrCoords[1]===p&&s.usrCoords[2]===_)return 1;for(c=0;c<u-f;c++)if(h.Z.exists(e[c].coords)?(r=e[c].coords.usrCoords,o=e[(c+1)%u].coords.usrCoords):(r=e[c].usrCoords,o=e[(c+1)%u].usrCoords),!(0===r[0]||0===o[0]||isNaN(r[1])||isNaN(o[1])||isNaN(r[2])||isNaN(o[2]))){if(o[2]===_){if(o[1]===p)return 1;if(r[2]===_&&o[1]>p==r[1]<p)return 0}if(r[2]<_!=o[2]<_)if(l=2*(o[2]>r[2]?1:0)-1,r[1]>=p)if(o[1]>p)d+=l;else{if(0===(a=this.det3p(r,o,t)))return 0;a>0+n.Z.eps==o[2]>r[2]&&(d+=l)}else o[1]>p&&(a=this.det3p(r,o,t))>0+n.Z.eps==o[2]>r[2]&&(d+=l)}return d},pnpoly:function(t,e,i,s){var n,a,l,c,d,u,p,_,f=i,b=!1;for(s===r.Z.COORDS_BY_USER?(c=(u=new o.Z(r.Z.COORDS_BY_USER,[t,e],this.board)).scrCoords[1],d=u.scrCoords[2]):(c=t,d=e),n=0,a=(l=i.length)-2;n<l-1;a=n++)p=h.Z.exists(f[n].coords)?f[n].coords:f[n],_=h.Z.exists(f[a].coords)?f[a].coords:f[a],p.scrCoords[2]>d!=_.scrCoords[2]>d&&c<(_.scrCoords[1]-p.scrCoords[1])*(d-p.scrCoords[2])/(_.scrCoords[2]-p.scrCoords[2])+p.scrCoords[1]&&(b=!b);return b},intersectionFunction:function(t,e,i,a,l,c){var d,u,p=this;return d=e.elementClass===r.Z.OBJECT_CLASS_CURVE&&(e.type===r.Z.OBJECT_TYPE_ARC||e.type===r.Z.OBJECT_TYPE_SECTOR),u=i.elementClass===r.Z.OBJECT_CLASS_CURVE&&(i.type===r.Z.OBJECT_TYPE_ARC||i.type===r.Z.OBJECT_TYPE_SECTOR),e.elementClass!==r.Z.OBJECT_CLASS_CURVE&&i.elementClass!==r.Z.OBJECT_CLASS_CURVE||e.elementClass!==r.Z.OBJECT_CLASS_CURVE&&e.elementClass!==r.Z.OBJECT_CLASS_CIRCLE||i.elementClass!==r.Z.OBJECT_CLASS_CURVE&&i.elementClass!==r.Z.OBJECT_CLASS_CIRCLE?e.elementClass===r.Z.OBJECT_CLASS_CURVE&&!d&&i.elementClass===r.Z.OBJECT_CLASS_LINE||i.elementClass===r.Z.OBJECT_CLASS_CURVE&&!u&&e.elementClass===r.Z.OBJECT_CLASS_LINE?function(){return p.meetCurveLine(e,i,a,e.board,c)}:e.type===r.Z.OBJECT_TYPE_POLYGON||i.type===r.Z.OBJECT_TYPE_POLYGON?e.elementClass===r.Z.OBJECT_CLASS_LINE?function(){return p.meetPolygonLine(i,e,a,e.board,c)}:i.elementClass===r.Z.OBJECT_CLASS_LINE?function(){return p.meetPolygonLine(e,i,a,e.board,c)}:function(){return p.meetPathPath(e,i,a,e.board)}:e.elementClass===r.Z.OBJECT_CLASS_LINE&&i.elementClass===r.Z.OBJECT_CLASS_LINE?function(){var t,s,n=h.Z.evaluate(e.visProp.straightfirst),l=h.Z.evaluate(e.visProp.straightlast),d=h.Z.evaluate(i.visProp.straightfirst),u=h.Z.evaluate(i.visProp.straightlast);return h.Z.evaluate(c)||n&&l&&d&&u?p.meet(e.stdform,i.stdform,a,e.board):(t=p.meetSegmentSegment(e.point1.coords.usrCoords,e.point2.coords.usrCoords,i.point1.coords.usrCoords,i.point2.coords.usrCoords),s=!n&&t[1]<0||!l&&t[1]>1||!d&&t[2]<0||!u&&t[2]>1?[0,NaN,NaN]:t[0],new o.Z(r.Z.COORDS_BY_USER,s,e.board))}:function(){var t,l,_,f=p.meet(e.stdform,i.stdform,a,e.board),b=!0;return c?f:(e.elementClass!==r.Z.OBJECT_CLASS_LINE||(t=h.Z.evaluate(e.visProp.straightfirst),l=h.Z.evaluate(e.visProp.straightlast),t&&l||(_=p.affineRatio(e.point1.coords,e.point2.coords,f),!(!l&&_>1+n.Z.eps||!t&&_<0-n.Z.eps))))&&(i.elementClass!==r.Z.OBJECT_CLASS_LINE||(t=h.Z.evaluate(i.visProp.straightfirst),l=h.Z.evaluate(i.visProp.straightlast),t&&l||(_=p.affineRatio(i.point1.coords,i.point2.coords,f),!(!l&&_>1+n.Z.eps||!t&&_<0-n.Z.eps))))?d&&((b=p.coordsOnArc(e,f))&&u&&(b=p.coordsOnArc(i,f)),!b)?new o.Z(s.Z.COORDS_BY_USER,[0,NaN,NaN],e.board):f:new o.Z(s.Z.COORDS_BY_USER,[0,NaN,NaN],e.board)}:function(){return p.meetCurveCurve(e,i,a,l,e.board)}},coordsOnArc:function(t,e){var i=this.rad(t.radiuspoint,t.center,e.usrCoords.slice(1)),s=0,r=this.rad(t.radiuspoint,t.center,t.anglepoint),o=h.Z.evaluate(t.visProp.selection);return("minor"===o&&r>Math.PI||"major"===o&&r<Math.PI)&&(s=r,r=2*Math.PI),!(i<s||i>r)},meet:function(t,e,i,s){var r=n.Z.eps;return Math.abs(t[3])<r&&Math.abs(e[3])<r?this.meetLineLine(t,e,i,s):Math.abs(t[3])>=r&&Math.abs(e[3])<r?this.meetLineCircle(e,t,i,s):Math.abs(t[3])<r&&Math.abs(e[3])>=r?this.meetLineCircle(t,e,i,s):this.meetCircleCircle(t,e,i,s)},meetLineBoard:function(t,e,i){var s,a,l,c,d=[];for(h.Z.exists(i)||(i=0),d[0]=n.Z.crossProduct(t,[i,0,1]),d[1]=n.Z.crossProduct(t,[i,1,0]),d[2]=n.Z.crossProduct(t,[-i-e.canvasHeight,0,1]),d[3]=n.Z.crossProduct(t,[-i-e.canvasWidth,1,0]),l=0;l<4;l++)if(Math.abs(d[l][0])>n.Z.eps){for(c=2;c>0;c--)d[l][c]/=d[l][0];d[l][0]=1}return Math.abs(d[1][0])<n.Z.eps?(s=d[0],a=d[2]):Math.abs(d[0][0])<n.Z.eps?(s=d[1],a=d[3]):d[1][2]<0?(s=d[0],a=d[3][2]>e.canvasHeight?d[2]:d[3]):d[1][2]>e.canvasHeight?(s=d[2],a=d[3][2]<0?d[0]:d[3]):(s=d[1],a=d[3][2]<0?d[0]:d[3][2]>e.canvasHeight?d[2]:d[3]),[s=new o.Z(r.Z.COORDS_BY_SCREEN,s.slice(1),e),a=new o.Z(r.Z.COORDS_BY_SCREEN,a.slice(1),e)]},meetLineLine:function(t,e,i,s){var a=isNaN(t[5]+e[5])?[0,0,0]:n.Z.crossProduct(t,e);return new o.Z(r.Z.COORDS_BY_USER,a,s)},meetLineCircle:function(t,e,i,s){var a,h,l,c,d,u,p,_,f;return e[4]<n.Z.eps?Math.abs(n.Z.innerProduct([1,e[6],e[7]],t,3))<n.Z.eps?new o.Z(r.Z.COORDS_BY_USER,e.slice(6,8),s):new o.Z(r.Z.COORDS_BY_USER,[NaN,NaN],s):(l=e[0],h=e.slice(1,3),a=e[3],c=t[0],d=t.slice(1,3),u=a,(_=(p=h[0]*d[1]-h[1]*d[0])*p-4*u*(a*c*c-(h[0]*d[0]+h[1]*d[1])*c+l))>-n.Z.eps*n.Z.eps?(f=[(-p+(_=Math.sqrt(Math.abs(_))))/(2*u),(-p-_)/(2*u)],0===i?new o.Z(r.Z.COORDS_BY_USER,[-f[0]*-d[1]-c*d[0],-f[0]*d[0]-c*d[1]],s):new o.Z(r.Z.COORDS_BY_USER,[-f[1]*-d[1]-c*d[0],-f[1]*d[0]-c*d[1]],s)):new o.Z(r.Z.COORDS_BY_USER,[0,0,0],s))},meetCircleCircle:function(t,e,i,s){var a;return t[4]<n.Z.eps?Math.abs(this.distance(t.slice(6,2),e.slice(6,8))-e[4])<n.Z.eps?new o.Z(r.Z.COORDS_BY_USER,t.slice(6,8),s):new o.Z(r.Z.COORDS_BY_USER,[0,0,0],s):e[4]<n.Z.eps?Math.abs(this.distance(e.slice(6,2),t.slice(6,8))-t[4])<n.Z.eps?new o.Z(r.Z.COORDS_BY_USER,e.slice(6,8),s):new o.Z(r.Z.COORDS_BY_USER,[0,0,0],s):(a=[e[3]*t[0]-t[3]*e[0],e[3]*t[1]-t[3]*e[1],e[3]*t[2]-t[3]*e[2],0,1,1/0,1/0,1/0],a=n.Z.normalize(a),this.meetLineCircle(a,t,i,s))},meetCurveCurve:function(t,e,i,s,n,l){var c;return c=h.Z.exists(l)&&"newton"===l?a.Z.generalizedNewton(t,e,i,s):3===t.bezierDegree||3===e.bezierDegree?this.meetBezierCurveRedBlueSegments(t,e,i):this.meetCurveRedBlueSegments(t,e,i),new o.Z(r.Z.COORDS_BY_USER,c,n)},meetCurveLine:function(t,e,i,s,o){var n,a;return h.Z.exists(s)||(s=t.board),t.elementClass===r.Z.OBJECT_CLASS_CURVE?(n=t,a=e):(n=e,a=t),this.meetCurveLineDiscrete(n,a,i,s,!o)},meetCurveLineContinuous:function(t,e,i,s,h){var l,c,d,u,p,_,f,b,g,m,v,Z,C,y=n.Z.eps,P=n.Z.eps;for(u=this.meetCurveLineDiscrete(t,e,i,s,h),p=u.usrCoords[1],_=u.usrCoords[2],c=function(e){var i,s;return e>t.maxX()||e<t.minX()?1/0:(i=p-t.X(e))*i+(s=_-t.Y(e))*s},d=function(i){var s=e.stdform[0]+e.stdform[1]*t.X(i)+e.stdform[2]*t.Y(i);return s*s},50,b=(t.maxX()-t.minX())/50,g=t.minX(),Z=1e-4,v=NaN,m=0;m<50&&(l=a.Z.root(c,[Math.max(g,t.minX()),Math.min(g+b,t.maxX())]),!((C=Math.abs(c(l)))<=Z&&(v=l,(Z=C)<y)));m++)g+=b;return l=v,C=d(l=a.Z.root(d,[Math.max(l-b,t.minX()),Math.min(l+b,t.maxX())])),f=isNaN(C)||Math.abs(C)>P?0:1,new o.Z(r.Z.COORDS_BY_USER,[f,t.X(l),t.Y(l)],s)},meetCurveLineDiscrete:function(t,e,i,s,a){var l,c,d,u,p,_,f,b=e.point1.coords.usrCoords,g=e.point2.coords.usrCoords,m=0,v=t.numberPoints,Z=h.Z.evaluate(e.visProp.straightfirst),C=h.Z.evaluate(e.visProp.straightlast);for(_=new o.Z(r.Z.COORDS_BY_USER,[0,NaN,NaN],s),0===b[0]?b=[1,g[1]+e.stdform[2],g[2]-e.stdform[1]]:0===g[0]&&(g=[1,b[1]+e.stdform[2],b[2]-e.stdform[1]]),u=t.points[0].usrCoords,l=1;l<v;l+=t.bezierDegree)if(d=u.slice(0),u=t.points[l].usrCoords,this.distance(d,u)>n.Z.eps)for(f=3===t.bezierDegree?this.meetBeziersegmentBeziersegment([t.points[l-1].usrCoords.slice(1),t.points[l].usrCoords.slice(1),t.points[l+1].usrCoords.slice(1),t.points[l+2].usrCoords.slice(1)],[b.slice(1),g.slice(1)],a):[this.meetSegmentSegment(d,u,b,g)],c=0;c<f.length;c++)if(0<=(p=f[c])[1]&&p[1]<=1){if(m===i)return a&&(!Z&&p[2]<0||!C&&p[2]>1)?_:_=new o.Z(r.Z.COORDS_BY_USER,p[0],s);m+=1}return _},meetCurveRedBlueSegments:function(t,e,i){var s,r,o,n,a,h,l,c,d,u=0,p=e.numberPoints,_=t.numberPoints;if(p<=1||_<=1)return[0,NaN,NaN];for(s=1;s<_;s++)for(o=t.points[s-1].usrCoords,n=t.points[s].usrCoords,c=Math.min(o[1],n[1]),d=Math.max(o[1],n[1]),h=e.points[0].usrCoords,r=1;r<p;r++)if(a=h,h=e.points[r].usrCoords,Math.min(a[1],h[1])<d&&Math.max(a[1],h[1])>c&&(l=this.meetSegmentSegment(o,n,a,h))[1]>=0&&l[2]>=0&&(l[1]<1&&l[2]<1||s===_-1&&1===l[1]||r===p-1&&1===l[2])){if(u===i)return l[0];u++}return[0,NaN,NaN]},meetSegmentSegment:function(t,e,i,s){var r,o,a,h=n.Z.crossProduct(t,e),l=n.Z.crossProduct(i,s),c=n.Z.crossProduct(h,l);return Math.abs(c[0])<n.Z.eps?[c,1/0,1/0]:(c[1]/=c[0],c[2]/=c[0],c[0]/=c[0],a=t[o=Math.abs(e[1]-e[0]*t[1])<n.Z.eps?2:1]/t[0],r=(c[o]-a)/(0!==e[0]?e[o]/e[0]-a:e[o]),a=i[o=Math.abs(s[1]-s[0]*i[1])<n.Z.eps?2:1]/i[0],[c,r,(c[o]-a)/(0!==s[0]?s[o]/s[0]-a:s[o])])},meetPathPath:function(t,e,i,a){var h,l,c,d;return(c=(h=s.Z.Math.Clip._getPath(t,a)).length)>0&&this.distance(h[0].coords.usrCoords,h[c-1].coords.usrCoords,3)<n.Z.eps&&h.pop(),(c=(l=s.Z.Math.Clip._getPath(e,a)).length)>0&&this.distance(l[0].coords.usrCoords,l[c-1].coords.usrCoords,3)<n.Z.eps*n.Z.eps&&l.pop(),i<0||s.Z.Math.Clip.isEmptyCase(h,l,"intersection")?new o.Z(r.Z.COORDS_BY_USER,[0,0,0],a):(s.Z.Math.Clip.makeDoublyLinkedList(h),s.Z.Math.Clip.makeDoublyLinkedList(l),i<(d=s.Z.Math.Clip.findIntersections(h,l,a)[0]).length?d[i].coords:new o.Z(r.Z.COORDS_BY_USER,[0,0,0],a))},meetPolygonLine:function(t,e,i,s,n){var a,h,l,c=[0,0,0],d=t.borders.length,u=[];for(a=0;a<d;a++)l=t.borders[a],h=this.meetSegmentSegment(l.point1.coords.usrCoords,l.point2.coords.usrCoords,e.point1.coords.usrCoords,e.point2.coords.usrCoords),(!n||h[2]>=0&&h[2]<1)&&h[1]>=0&&h[1]<1&&u.push(h[0]);return i>=0&&i<u.length&&(c=u[i]),new o.Z(r.Z.COORDS_BY_USER,c,s)},_bezierSplit:function(t){var e,i,s,r,o,n;return e=[.5*(t[0][0]+t[1][0]),.5*(t[0][1]+t[1][1])],i=[.5*(t[1][0]+t[2][0]),.5*(t[1][1]+t[2][1])],s=[.5*(t[2][0]+t[3][0]),.5*(t[2][1]+t[3][1])],n=[.5*((r=[.5*(e[0]+i[0]),.5*(e[1]+i[1])])[0]+(o=[.5*(i[0]+s[0]),.5*(i[1]+s[1])])[0]),.5*(r[1]+o[1])],[[t[0],e,r,n],[n,o,s,t[3]]]},_bezierBbox:function(t){var e=[];return 4===t.length?(e[0]=Math.min(t[0][0],t[1][0],t[2][0],t[3][0]),e[1]=Math.max(t[0][1],t[1][1],t[2][1],t[3][1]),e[2]=Math.max(t[0][0],t[1][0],t[2][0],t[3][0]),e[3]=Math.min(t[0][1],t[1][1],t[2][1],t[3][1])):(e[0]=Math.min(t[0][0],t[1][0]),e[1]=Math.max(t[0][1],t[1][1]),e[2]=Math.max(t[0][0],t[1][0]),e[3]=Math.min(t[0][1],t[1][1])),e},_bezierOverlap:function(t,e){return t[2]>=e[0]&&t[0]<=e[2]&&t[1]>=e[3]&&t[3]<=e[1]},_bezierListConcat:function(t,e,i,s){var r,o=h.Z.exists(s),n=0,a=e.length,l=t.length;for(l>0&&a>0&&(1===t[l-1][1]&&0===e[0][1]||o&&1===t[l-1][2]&&0===e[0][2])&&(n=1),r=n;r<a;r++)o&&(e[r][2]*=.5,e[r][2]+=s),e[r][1]*=.5,e[r][1]+=i,t.push(e[r])},_bezierMeetSubdivision:function(t,e,i){var s,r,o,n,a,h,l,c,d,u,p,_,f=[];return r=this._bezierBbox(e),s=this._bezierBbox(t),this._bezierOverlap(r,s)?i<5?(h=(o=this._bezierSplit(t))[0],l=o[1],n=(o=this._bezierSplit(e))[0],a=o[1],this._bezierListConcat(f,this._bezierMeetSubdivision(h,n,i+1),0,0),this._bezierListConcat(f,this._bezierMeetSubdivision(h,a,i+1),0,.5),this._bezierListConcat(f,this._bezierMeetSubdivision(l,n,i+1),.5,0),this._bezierListConcat(f,this._bezierMeetSubdivision(l,a,i+1),.5,.5),f):(p=[1].concat(t[0]),_=[1].concat(t[3]),d=[1].concat(e[0]),u=[1].concat(e[3]),(c=this.meetSegmentSegment(p,_,d,u))[1]>=0&&c[2]>=0&&c[1]<=1&&c[2]<=1?[c]:[]):[]},_bezierLineMeetSubdivision:function(t,e,i,s){var r,o,n,a,h,l,c,d,u,p,_=[];return r=this._bezierBbox(e),o=this._bezierBbox(t),s&&!this._bezierOverlap(o,r)?[]:i<5?(a=(n=this._bezierSplit(t))[0],h=n[1],this._bezierListConcat(_,this._bezierLineMeetSubdivision(a,e,i+1),0),this._bezierListConcat(_,this._bezierLineMeetSubdivision(h,e,i+1),.5),_):(u=[1].concat(t[0]),p=[1].concat(t[3]),c=[1].concat(e[0]),d=[1].concat(e[1]),(l=this.meetSegmentSegment(u,p,c,d))[1]>=0&&l[1]<=1&&(!s||l[2]>=0&&l[2]<=1)?[l]:[])},meetBeziersegmentBeziersegment:function(t,e,i){var s,r,o;for((s=4===t.length&&4===e.length?this._bezierMeetSubdivision(t,e,0):this._bezierLineMeetSubdivision(t,e,0,i)).sort((function(t,e){return 1e7*(t[1]-e[1])+(t[2]-e[2])})),r=[],o=0;o<s.length;o++)0!==o&&s[o][1]===s[o-1][1]&&s[o][2]===s[o-1][2]||r.push(s[o]);return r},meetBezierCurveRedBlueSegments:function(t,e,i){var s,o,a,h,l,c,d,u,p,_,f=0,b=0,g=e.numberPoints,m=t.numberPoints,v=[];if(g<e.bezierDegree+1||m<t.bezierDegree+1)return[0,NaN,NaN];for(g-=e.bezierDegree,m-=t.bezierDegree,t.type===r.Z.OBJECT_TYPE_SECTOR&&(f=3,m-=3),e.type===r.Z.OBJECT_TYPE_SECTOR&&(b=3,g-=3),o=f;o<m;o+=t.bezierDegree)for(c=[(s=t.points)[o].usrCoords.slice(1),s[o+1].usrCoords.slice(1)],3===t.bezierDegree&&(c[2]=s[o+2].usrCoords.slice(1),c[3]=s[o+3].usrCoords.slice(1)),u=this._bezierBbox(c),a=b;a<g;a+=e.bezierDegree)if(d=[(s=e.points)[a].usrCoords.slice(1),s[a+1].usrCoords.slice(1)],3===e.bezierDegree&&(d[2]=s[a+2].usrCoords.slice(1),d[3]=s[a+3].usrCoords.slice(1)),p=this._bezierBbox(d),this._bezierOverlap(u,p)){if(0===(_=this.meetBeziersegmentBeziersegment(c,d)).length)continue;for(h=0;h<_.length;h++)(l=_[h])[1]<-n.Z.eps||l[1]>1+n.Z.eps||l[2]<-n.Z.eps||l[2]>1+n.Z.eps||v.push(l);if(v.length>i)return v[i][0]}return v.length>i?v[i][0]:[0,NaN,NaN]},bezierSegmentEval:function(t,e){var i,s,r,o=1-t;return s=0,r=0,s+=(i=o*o*o)*e[0][0],r+=i*e[0][1],s+=(i=3*t*o*o)*e[1][0],r+=i*e[1][1],s+=(i=3*t*t*o)*e[2][0],r+=i*e[2][1],[1,s+=(i=t*t*t)*e[3][0],r+=i*e[3][1]]},bezierArc:function(t,e,i,s,r){var o,a,h,l,c,d,u,p,_,f,b,g,m,v,Z,C,y,P=.5*Math.PI,E=e[1],O=e[2],x=e[0],w=[],S=[];for(c=this.distance(e,t),E/=x,O/=x,d=this.rad(t.slice(1),e.slice(1),i.slice(1)),-1===r&&(d=2*Math.PI-d),(o=t)[1]/=o[0],o[2]/=o[0],o[0]/=o[0],l=o.slice(0),s?(w=[E,E+.333*(o[1]-E),E+.666*(o[1]-E),o[1]],S=[O,O+.333*(o[2]-O),O+.666*(o[2]-O),o[2]]):(w=[o[1]],S=[o[2]]);d>n.Z.eps;)d>P?(u=P,d-=P):(u=d,d=0),y=[[1,0,0],[E*(1-(p=Math.cos(r*u)))+O*(_=Math.sin(r*u)),p,-_],[O*(1-p)-E*_,_,p]],l=[(Z=n.Z.matVecMult(y,o))[0]/Z[0],Z[1]/Z[0],Z[2]/Z[0]],f=o[1]-E,b=o[2]-O,g=l[1]-E,m=l[2]-O,C=Math.sqrt((f+g)*(f+g)+(b+m)*(b+m)),v=Math.abs(m-b)>n.Z.eps?(f+g)*(c/C-.5)/(m-b)*8/3:(b+m)*(c/C-.5)/(f-g)*8/3,a=[1,o[1]-v*b,o[2]+v*f],h=[1,l[1]+v*m,l[2]-v*g],w=w.concat([a[1],h[1],l[1]]),S=S.concat([a[2],h[2],l[2]]),o=l.slice(0);return s&&(w=w.concat([l[1]+.333*(E-l[1]),l[1]+.666*(E-l[1]),E]),S=S.concat([l[2]+.333*(O-l[2]),l[2]+.666*(O-l[2]),O])),[w,S]},projectPointToCircle:function(t,e,i){var s,a,l,c,d,u=e.center.coords.usrCoords;return h.Z.exists(i)||(i=t.board),h.Z.isPoint(t)?(s=t.coords.distance(r.Z.COORDS_BY_USER,e.center.coords),a=t.coords.usrCoords):(s=t.distance(r.Z.COORDS_BY_USER,e.center.coords),a=t.usrCoords),Math.abs(s)<n.Z.eps&&(s=n.Z.eps),d=e.Radius()/s,l=u[1]+d*(a[1]-u[1]),c=u[2]+d*(a[2]-u[2]),new o.Z(r.Z.COORDS_BY_USER,[l,c],i)},projectPointToLine:function(t,e,i){var s,a=[0,e.stdform[1],e.stdform[2]];return h.Z.exists(i)||(i=h.Z.exists(t.coords)?t.board:e.board),s=h.Z.exists(t.coords)?t.coords.usrCoords:t.usrCoords,a=n.Z.crossProduct(a,s),new o.Z(r.Z.COORDS_BY_USER,n.Z.crossProduct(a,e.stdform),i)},projectCoordsToSegment:function(t,e,i){var s,r=[i[1]-e[1],i[2]-e[2]],o=[t[1]-e[1],t[2]-e[2]];return Math.abs(r[0])<n.Z.eps&&Math.abs(r[1])<n.Z.eps?[e,0]:(s=n.Z.innerProduct(o,r),[[1,(s/=n.Z.innerProduct(r,r))*r[0]+e[1],s*r[1]+e[2]],s])},projectCoordsToBeziersegment:function(t,e,i){var r;return r=s.Z.Math.Numerics.fminbr((function(s){var r=[1,e.X(i+s),e.Y(i+s)];return r[1]-=t[1],r[2]-=t[2],r[1]*r[1]+r[2]*r[2]}),[0,1]),[[1,e.X(r+i),e.Y(r+i)],r]},projectPointToCurve:function(t,e,i){h.Z.exists(i)||(i=t.board);var s=t.X(),r=t.Y(),o=t.position||0;return this.projectCoordsToCurve(s,r,o,e,i)},projectCoordsToCurve:function(t,e,i,s,n){var l,c,d,u,p,_,f,b,g,m,v,Z,C,y,P,E,O,x,w,S,T=Number.POSITIVE_INFINITY;if(h.Z.exists(n)||(n=s.board),"plot"===h.Z.evaluate(s.visProp.curvetype)){if(i=0,p=T,l=0===s.numberPoints?[0,1,1]:[s.Z(0),s.X(0),s.Y(0)],s.numberPoints>1)for(b=[1,t,e],3===s.bezierDegree?u=0:v=[s.Z(0),s.X(0),s.Y(0)],d=0;d<s.numberPoints-1;d++)3===s.bezierDegree?C=this.projectCoordsToBeziersegment(b,s,u):(Z=[s.Z(d+1),s.X(d+1),s.Y(d+1)],C=this.projectCoordsToSegment(b,v,Z)),f=C[1],g=C[0],0<=f&&f<=1?(_=this.distance(g,b),m=d+f):f<0?(g=v,_=this.distance(v,b),m=d):f>1&&d===s.numberPoints-2&&(g=Z,_=this.distance(g,b),m=s.numberPoints-1),_<p&&(p=_,i=m,l=g),3===s.bezierDegree?(u++,d+=2):v=Z;c=new o.Z(r.Z.COORDS_BY_USER,l,n)}else{for(y=function(i){var r,o;return i<s.minX()||i>s.maxX()?1/0:(r=t-s.X(i))*r+(o=e-s.Y(i))*o},O=y(i),50,w=s.minX(),x=((S=s.maxX())-w)/50,P=w,d=0;d<50;d++)((E=y(P))<O||O===1/0||isNaN(O))&&(i=P,O=E),P+=x;i=(i=(i=a.Z.fminbr(y,[Math.max(i-x,w),Math.min(i+x,S)]))<w?w:i)>S?S:i,c=new o.Z(r.Z.COORDS_BY_USER,[s.X(i),s.Y(i)],n)}return[s.updateTransform(c),i]},projectCoordsToPolygon:function(t,e){var i,r,o,n,a,h=e.vertices.length,l=1/0;for(i=0;i<h-1;i++)0<=(o=s.Z.Math.Geometry.projectCoordsToSegment(t,e.vertices[i].coords.usrCoords,e.vertices[i+1].coords.usrCoords))[1]&&o[1]<=1?(r=s.Z.Math.Geometry.distance(o[0],t,3),n=o[0]):o[1]<0?(r=s.Z.Math.Geometry.distance(e.vertices[i].coords.usrCoords,t,3),n=e.vertices[i].coords.usrCoords):(r=s.Z.Math.Geometry.distance(e.vertices[i+1].coords.usrCoords,t,3),n=e.vertices[i+1].coords.usrCoords),r<l&&(a=n.slice(0),l=r);return a},projectPointToTurtle:function(t,e,i){var s,n,a,l,c,d,u,p,_,f,b=0,g=0,m=Number.POSITIVE_INFINITY,v=e.objects.length;for(h.Z.exists(i)||(i=t.board),c=0;c<v;c++)(u=e.objects[c]).elementClass===r.Z.OBJECT_CLASS_CURVE&&(s=(_=this.projectPointToCurve(t,u))[0],f=_[1],(d=this.distance(s.usrCoords,t.coords.usrCoords))<m&&(a=s.usrCoords[1],l=s.usrCoords[2],n=f,m=d,p=u,g=b),b+=u.numberPoints);return s=new o.Z(r.Z.COORDS_BY_USER,[a,l],i),[p.updateTransform(s),n+g]},projectPointToPoint:function(t,e){return e.coords},projectPointToBoard:function(t,e){var i,s,r,o=e||t.board,a=[[1,1,0,0,3,0,1],[-1,2,1,0,1,2,1],[-1,1,2,2,1,2,3],[1,2,3,0,3,2,3]],h=t.coords||t,l=o.getBoundingBox();for(i=0;i<4;i++)(r=a[i])[0]*h.usrCoords[r[1]]<r[0]*l[r[2]]&&((s=n.Z.crossProduct([1,l[r[3]],l[r[4]]],[1,l[r[5]],l[r[6]]]))[3]=0,s=n.Z.normalize(s),h=this.projectPointToLine({coords:h},{stdform:s},o));return h},distPointLine:function(t,e){var i,s=e[1],r=e[2],o=e[0];return Math.abs(s)+Math.abs(r)<n.Z.eps?Number.POSITIVE_INFINITY:(i=s*t[1]+r*t[2]+o,s*=s,r*=r,Math.abs(i)/Math.sqrt(s+r))},reuleauxPolygon:function(t,e){var i,s=2*Math.PI,r=s/e,o=(e-1)/2,a=0,h=function(h,l){return function(c,d){var u=(c%s+s)%s,p=Math.floor(u/r)%e;return d||(a=t[0].Dist(t[o]),i=n.Z.Geometry.rad([t[0].X()+1,t[0].Y()],t[0],t[o%e])),isNaN(p)?p:(u=.5*u+p*r*.5+i,t[p][h]()+a*Math[l](u))}};return[h("X","cos"),h("Y","sin"),0,s]},meet3Planes:function(t,e,i,s,r,o){var a,h,l,c,d,u=[0,0,0];for(a=n.Z.crossProduct(r,t),h=n.Z.crossProduct(t,i),l=n.Z.crossProduct(i,r),c=n.Z.innerProduct(t,l,3),d=0;d<3;d++)u[d]=(e*l[d]+s*a[d]+o*h[d])/c;return u},meetPlanePlane:function(t,e,i,s){var r,o,a,l=[0,0,0],c=[0,0,0];for(r=0;r<3;r++)l[r]=h.Z.evaluate(t[r]),c[r]=h.Z.evaluate(e[r]);for(o=n.Z.crossProduct(l,c),r=0;r<3;r++)l[r]=h.Z.evaluate(i[r]),c[r]=h.Z.evaluate(s[r]);return a=n.Z.crossProduct(l,c),n.Z.crossProduct(o,a)},project3DTo3DPlane:function(t,e,i){var s,r;return i=i||[0,0,0],s=n.Z.norm(e),r=(n.Z.innerProduct(t,e,3)-n.Z.innerProduct(i,e,3))/s,n.Z.axpy(-r,e,t)},getPlaneBounds:function(t,e,i,s,r){var o,n,h,l,c;return t[2]+e[0]!==0?(h=[[t[0],e[0]],[t[1],e[1]]],l=[s-i[0],s-i[1]],o=(c=a.Z.Gauss(h,l))[0],n=c[1],l=[r-i[0],r-i[1]],[o,(c=a.Z.Gauss(h,l))[0],n,c[1]]):null}});const c=n.Z.Geometry},785:(t,e,i)=>{i.d(e,{Z:()=>h});var s=i(765),r=i(275),o=i(109);s.Z.Math.DoubleBits=function(){var t,e,i,s,r,o,n,a,h=new Float64Array(1),l=new Uint32Array(h.buffer);void 0!==Float64Array&&(h[0]=1,!0,1072693248===l[1]?(t=function(t){return h[0]=t,[l[0],l[1]]},e=function(t,e){return l[0]=t,l[1]=e,h[0]},i=function(t){return h[0]=t,l[0]},s=function(t){return h[0]=t,l[1]},this.doubleBits=t,this.pack=e,this.lo=i,this.hi=s):1072693248===l[0]&&(r=function(t){return h[0]=t,[l[1],l[0]]},o=function(t,e){return l[1]=t,l[0]=e,h[0]},n=function(t){return h[0]=t,l[1]},a=function(t){return h[0]=t,l[0]},this.doubleBits=r,this.pack=o,this.lo=n,this.hi=a))},s.Z.extend(s.Z.Math.DoubleBits.prototype,{sign:function(t){return this.hi(t)>>>31},exponent:function(t){return(this.hi(t)<<1>>>21)-1023},fraction:function(t){var e=this.lo(t),i=this.hi(t),s=1048575&i;return 2146435072&i&&(s+=1<<20),[e,s]},denormalized:function(t){return!(2146435072&this.hi(t))}});var n=new s.Z.Math.DoubleBits,a=function(t,e){if(void 0!==t&&void 0!==e){if(r.Z.IntervalArithmetic.isInterval(t)){if(!r.Z.IntervalArithmetic.isSingleton(t))throw new TypeError("JXG.Math.IntervalArithmetic: interval `lo` must be a singleton");this.lo=t.lo}else this.lo=t;if(r.Z.IntervalArithmetic.isInterval(e)){if(!r.Z.IntervalArithmetic.isSingleton(e))throw new TypeError("JXG.Math.IntervalArithmetic: interval `hi` must be a singleton");this.hi=e.hi}else this.hi=e}else{if(void 0!==t)return Array.isArray(t)?new a(t[0],t[1]):new a(t,t);this.lo=this.hi=0}};s.Z.extend(a.prototype,{print:function(){console.log("[",this.lo,this.hi,"]")},set:function(t,e){return this.lo=t,this.hi=e,this},bounded:function(t,e){return this.set(r.Z.IntervalArithmetic.prev(t),r.Z.IntervalArithmetic.next(e))},boundedSingleton:function(t){return this.bounded(t,t)},assign:function(t,e){if("number"!=typeof t||"number"!=typeof e)throw new TypeError("JXG.Math.Interval#assign: arguments must be numbers");return isNaN(t)||isNaN(e)||t>e?this.setEmpty():this.set(t,e)},setEmpty:function(){return this.set(Number.POSITIVE_INFINITY,Number.NEGATIVE_INFINITY)},setWhole:function(){return this.set(Number.NEGATIVE_INFINITY,Number.POSITIVE_INFINITY)},open:function(t,e){return this.assign(r.Z.IntervalArithmetic.next(t),r.Z.IntervalArithmetic.prev(e))},halfOpenLeft:function(t,e){return this.assign(r.Z.IntervalArithmetic.next(t),e)},halfOpenRight:function(t,e){return this.assign(t,r.Z.IntervalArithmetic.prev(e))},toArray:function(){return[this.lo,this.hi]},clone:function(){return(new a).set(this.lo,this.hi)}}),s.Z.Math.IntervalArithmetic={Interval:function(t,e){return new a(t,e)},isInterval:function(t){return null!==t&&"object"==typeof t&&"number"==typeof t.lo&&"number"==typeof t.hi},isSingleton:function(t){return t.lo===t.hi},add:function(t,e){return o.Z.isNumber(t)&&(t=this.Interval(t)),o.Z.isNumber(e)&&(e=this.Interval(e)),new a(this.addLo(t.lo,e.lo),this.addHi(t.hi,e.hi))},sub:function(t,e){return o.Z.isNumber(t)&&(t=this.Interval(t)),o.Z.isNumber(e)&&(e=this.Interval(e)),new a(this.subLo(t.lo,e.hi),this.subHi(t.hi,e.lo))},mul:function(t,e){var i,s,r,n,h;return o.Z.isNumber(t)&&(t=this.Interval(t)),o.Z.isNumber(e)&&(e=this.Interval(e)),this.isEmpty(t)||this.isEmpty(e)?this.EMPTY.clone():(i=t.lo,s=t.hi,r=e.lo,n=e.hi,h=new a,i<0?s>0?r<0?n>0?(h.lo=Math.min(this.mulLo(i,n),this.mulLo(s,r)),h.hi=Math.max(this.mulHi(i,r),this.mulHi(s,n))):(h.lo=this.mulLo(s,r),h.hi=this.mulHi(i,r)):n>0?(h.lo=this.mulLo(i,n),h.hi=this.mulHi(s,n)):(h.lo=0,h.hi=0):r<0?n>0?(h.lo=this.mulLo(i,n),h.hi=this.mulHi(i,r)):(h.lo=this.mulLo(s,n),h.hi=this.mulHi(i,r)):n>0?(h.lo=this.mulLo(i,n),h.hi=this.mulHi(s,r)):(h.lo=0,h.hi=0):s>0?r<0?n>0?(h.lo=this.mulLo(s,r),h.hi=this.mulHi(s,n)):(h.lo=this.mulLo(s,r),h.hi=this.mulHi(i,n)):n>0?(h.lo=this.mulLo(i,r),h.hi=this.mulHi(s,n)):(h.lo=0,h.hi=0):(h.lo=0,h.hi=0),h)},div:function(t,e){return o.Z.isNumber(t)&&(t=this.Interval(t)),o.Z.isNumber(e)&&(e=this.Interval(e)),this.isEmpty(t)||this.isEmpty(e)?this.EMPTY.clone():this.zeroIn(e)?0!==e.lo?0!==e.hi?this.divZero(t):this.divNegative(t,e.lo):0!==e.hi?this.divPositive(t,e.hi):this.EMPTY.clone():this.divNonZero(t,e)},positive:function(t){return new a(t.lo,t.hi)},negative:function(t){return o.Z.isNumber(t)?new a(-t):new a(-t.hi,-t.lo)},isEmpty:function(t){return t.lo>t.hi},isWhole:function(t){return t.lo===-1/0&&t.hi===1/0},zeroIn:function(t){return this.hasValue(t,0)},hasValue:function(t,e){return!this.isEmpty(t)&&(t.lo<=e&&e<=t.hi)},hasInterval:function(t,e){return!!this.isEmpty(t)||!this.isEmpty(e)&&e.lo<=t.lo&&t.hi<=e.hi},intervalsOverlap:function(t,e){return!this.isEmpty(t)&&!this.isEmpty(e)&&(t.lo<=e.lo&&e.lo<=t.hi||e.lo<=t.lo&&t.lo<=e.hi)},divNonZero:function(t,e){var i=t.lo,s=t.hi,r=e.lo,o=e.hi,n=new a;return s<0?o<0?(n.lo=this.divLo(s,r),n.hi=this.divHi(i,o)):(n.lo=this.divLo(i,r),n.hi=this.divHi(s,o)):i<0?o<0?(n.lo=this.divLo(s,o),n.hi=this.divHi(i,o)):(n.lo=this.divLo(i,r),n.hi=this.divHi(s,r)):o<0?(n.lo=this.divLo(s,o),n.hi=this.divHi(i,r)):(n.lo=this.divLo(i,o),n.hi=this.divHi(s,r)),n},divPositive:function(t,e){return 0===t.lo&&0===t.hi?t:this.zeroIn(t)?this.WHOLE:t.hi<0?new a(Number.NEGATIVE_INFINITY,this.divHi(t.hi,e)):new a(this.divLo(t.lo,e),Number.POSITIVE_INFINITY)},divNegative:function(t,e){return 0===t.lo&&0===t.hi?t:this.zeroIn(t)?this.WHOLE:t.hi<0?new a(this.divLo(t.hi,e),Number.POSITIVE_INFINITY):new a(Number.NEGATIVE_INFINITY,this.divHi(t.lo,e))},divZero:function(t){return 0===t.lo&&0===t.hi?t:this.WHOLE},fmod:function(t,e){var i,s;return o.Z.isNumber(t)&&(t=this.Interval(t)),o.Z.isNumber(e)&&(e=this.Interval(e)),this.isEmpty(t)||this.isEmpty(e)?this.EMPTY.clone():(i=t.lo<0?e.lo:e.hi,s=(s=t.lo/i)<0?Math.ceil(s):Math.floor(s),this.sub(t,this.mul(e,new a(s))))},multiplicativeInverse:function(t){return o.Z.isNumber(t)&&(t=this.Interval(t)),this.isEmpty(t)?this.EMPTY.clone():this.zeroIn(t)?0!==t.lo?0!==t.hi?this.WHOLE:new a(Number.NEGATIVE_INFINITY,this.divHi(1,t.lo)):0!==t.hi?new a(this.divLo(1,t.hi),Number.POSITIVE_INFINITY):this.EMPTY.clone():new a(this.divLo(1,t.hi),this.divHi(1,t.lo))},pow:function(t,e){var i,s;if(o.Z.isNumber(t)&&(t=this.Interval(t)),this.isEmpty(t))return this.EMPTY.clone();if(this.isInterval(e)){if(!this.isSingleton(e))return this.EMPTY.clone();e=e.lo}return 0===e?0===t.lo&&0===t.hi?this.EMPTY.clone():this.ONE.clone():e<0?this.pow(this.multiplicativeInverse(t),-e):e%1==0?t.hi<0?(i=this.powLo(-t.hi,e),s=this.powHi(-t.lo,e),1==(1&e)?new a(-s,-i):new a(i,s)):t.lo<0?1==(1&e)?new a(-this.powLo(-t.lo,e),this.powHi(t.hi,e)):new a(0,this.powHi(Math.max(-t.lo,t.hi),e)):new a(this.powLo(t.lo,e),this.powHi(t.hi,e)):(console.warn("power is not an integer, you should use nth-root instead, returning an empty interval"),this.EMPTY.clone())},sqrt:function(t){return o.Z.isNumber(t)&&(t=this.Interval(t)),this.nthRoot(t,2)},nthRoot:function(t,e){var i,s,r,n,h;if(o.Z.isNumber(t)&&(t=this.Interval(t)),this.isEmpty(t)||e<0)return this.EMPTY.clone();if(this.isInterval(e)){if(!this.isSingleton(e))return this.EMPTY.clone();e=e.lo}return i=1/e,t.hi<0?e%1==0&&1==(1&e)?(s=this.powHi(-t.lo,i),r=this.powLo(-t.hi,i),new a(-s,-r)):this.EMPTY.clone():t.lo<0?(n=this.powHi(t.hi,i),e%1==0&&1==(1&e)?(h=-this.powHi(-t.lo,i),new a(h,n)):new a(0,n)):new a(this.powLo(t.lo,i),this.powHi(t.hi,i))},exp:function(t){return o.Z.isNumber(t)&&(t=this.Interval(t)),this.isEmpty(t)?this.EMPTY.clone():new a(this.expLo(t.lo),this.expHi(t.hi))},log:function(t){var e;return o.Z.isNumber(t)&&(t=this.Interval(t)),this.isEmpty(t)?this.EMPTY.clone():(e=t.lo<=0?Number.NEGATIVE_INFINITY:this.logLo(t.lo),new a(e,this.logHi(t.hi)))},ln:function(t){return this.log(t)},log10:function(t){return this.isEmpty(t)?this.EMPTY.clone():this.div(this.log(t),this.log(new a(10,10)))},log2:function(t){return this.isEmpty(t)?this.EMPTY.clone():this.div(this.log(t),this.log(new a(2,2)))},hull:function(t,e){var i=this.isEmpty(t),s=this.isEmpty(e);return i&&s?this.EMPTY.clone():i?e.clone():s?t.clone():new a(Math.min(t.lo,e.lo),Math.max(t.hi,e.hi))},intersection:function(t,e){var i,s;return this.isEmpty(t)||this.isEmpty(e)?this.EMPTY.clone():(i=Math.max(t.lo,e.lo))<=(s=Math.min(t.hi,e.hi))?new a(i,s):this.EMPTY.clone()},union:function(t,e){if(!this.intervalsOverlap(t,e))throw new Error("Interval#unions do not overlap");return new a(Math.min(t.lo,e.lo),Math.max(t.hi,e.hi))},difference:function(t,e){if(this.isEmpty(t)||this.isWhole(e))return this.EMPTY.clone();if(this.intervalsOverlap(t,e)){if(t.lo<e.lo&&e.hi<t.hi)throw new Error("Interval.difference: difference creates multiple intervals");return e.lo<=t.lo&&e.hi===1/0||e.hi>=t.hi&&e.lo===-1/0?this.EMPTY.clone():e.lo<=t.lo?(new a).halfOpenLeft(e.hi,t.hi):(new a).halfOpenRight(t.lo,e.lo)}return t.clone()},width:function(t){return this.isEmpty(t)?0:this.subHi(t.hi,t.lo)},abs:function(t){return o.Z.isNumber(t)&&(t=this.Interval(t)),this.isEmpty(t)?this.EMPTY.clone():t.lo>=0?t.clone():t.hi<=0?this.negative(t):new a(0,Math.max(-t.lo,t.hi))},max:function(t,e){var i=this.isEmpty(t),s=this.isEmpty(e);return i&&s?this.EMPTY.clone():i?e.clone():s?t.clone():new a(Math.max(t.lo,e.lo),Math.max(t.hi,e.hi))},min:function(t,e){var i=this.isEmpty(t),s=this.isEmpty(e);return i&&s?this.EMPTY.clone():i?e.clone():s?t.clone():new a(Math.min(t.lo,e.lo),Math.min(t.hi,e.hi))},onlyInfinity:function(t){return!isFinite(t.lo)&&t.lo===t.hi},_handleNegative:function(t){var e;return t.lo<0&&(t.lo===-1/0?(t.lo=0,t.hi=1/0):(e=Math.ceil(-t.lo/this.piTwiceLow),t.lo+=this.piTwiceLow*e,t.hi+=this.piTwiceLow*e)),t},cos:function(t){var e,i,s,r,o,n,h,l;return this.isEmpty(t)||this.onlyInfinity(t)?this.EMPTY.clone():(e=(new a).set(t.lo,t.hi),this._handleNegative(e),i=this.PI_TWICE,s=this.fmod(e,i),this.width(s)>=i.lo?new a(-1,1):s.lo>=this.piHigh?(r=this.cos(this.sub(s,this.PI)),this.negative(r)):(o=s.lo,n=s.hi,h=this.cosLo(n),l=this.cosHi(o),n<=this.piLow?new a(h,l):n<=i.lo?new a(-1,Math.max(h,l)):new a(-1,1)))},sin:function(t){return this.isEmpty(t)||this.onlyInfinity(t)?this.EMPTY.clone():this.cos(this.sub(t,this.PI_HALF))},tan:function(t){var e,i,s;return this.isEmpty(t)||this.onlyInfinity(t)?this.EMPTY.clone():(e=(new a).set(t.lo,t.hi),this._handleNegative(e),s=this.PI,(i=this.fmod(e,s)).lo>=this.piHalfLow&&(i=this.sub(i,s)),i.lo<=-this.piHalfLow||i.hi>=this.piHalfLow?this.WHOLE.clone():new a(this.tanLo(i.lo),this.tanHi(i.hi)))},asin:function(t){var e,i;return this.isEmpty(t)||t.hi<-1||t.lo>1?this.EMPTY.clone():(e=t.lo<=-1?-this.piHalfHigh:this.asinLo(t.lo),i=t.hi>=1?this.piHalfHigh:this.asinHi(t.hi),new a(e,i))},acos:function(t){var e,i;return this.isEmpty(t)||t.hi<-1||t.lo>1?this.EMPTY.clone():(e=t.hi>=1?0:this.acosLo(t.hi),i=t.lo<=-1?this.piHigh:this.acosHi(t.lo),new a(e,i))},atan:function(t){return this.isEmpty(t)?this.EMPTY.clone():new a(this.atanLo(t.lo),this.atanHi(t.hi))},sinh:function(t){return this.isEmpty(t)?this.EMPTY.clone():new a(this.sinhLo(t.lo),this.sinhHi(t.hi))},cosh:function(t){return this.isEmpty(t)?this.EMPTY.clone():t.hi<0?new a(this.coshLo(t.hi),this.coshHi(t.lo)):t.lo>=0?new a(this.coshLo(t.lo),this.coshHi(t.hi)):new a(1,this.coshHi(-t.lo>t.hi?t.lo:t.hi))},tanh:function(t){return this.isEmpty(t)?this.EMPTY.clone():new a(this.tanhLo(t.lo),this.tanhHi(t.hi))},equal:function(t,e){return this.isEmpty(t)?this.isEmpty(e):!this.isEmpty(e)&&t.lo===e.lo&&t.hi===e.hi},notEqual:function(t,e){return this.isEmpty(t)?!this.isEmpty(e):this.isEmpty(e)||t.hi<e.lo||t.lo>e.hi},lt:function(t,e){return o.Z.isNumber(t)&&(t=this.Interval(t)),o.Z.isNumber(e)&&(e=this.Interval(e)),!this.isEmpty(t)&&!this.isEmpty(e)&&t.hi<e.lo},gt:function(t,e){return o.Z.isNumber(t)&&(t=this.Interval(t)),o.Z.isNumber(e)&&(e=this.Interval(e)),!this.isEmpty(t)&&!this.isEmpty(e)&&t.lo>e.hi},leq:function(t,e){return o.Z.isNumber(t)&&(t=this.Interval(t)),o.Z.isNumber(e)&&(e=this.Interval(e)),!this.isEmpty(t)&&!this.isEmpty(e)&&t.hi<=e.lo},geq:function(t,e){return o.Z.isNumber(t)&&(t=this.Interval(t)),o.Z.isNumber(e)&&(e=this.Interval(e)),!this.isEmpty(t)&&!this.isEmpty(e)&&t.lo>=e.hi},piLow:3.141592653589793,piHigh:3.1415926535897936,piHalfLow:1.5707963267948966,piHalfHigh:1.5707963267948968,piTwiceLow:6.283185307179586,piTwiceHigh:6.283185307179587,identity:function(t){return t},_prev:function(t){return t===1/0?t:this.nextafter(t,-1/0)},_next:function(t){return t===-1/0?t:this.nextafter(t,1/0)},prev:function(t){return this._prev(t)},next:function(t){return this._next(t)},toInteger:function(t){return t<0?Math.ceil(t):Math.floor(t)},addLo:function(t,e){return this.prev(t+e)},addHi:function(t,e){return this.next(t+e)},subLo:function(t,e){return this.prev(t-e)},subHi:function(t,e){return this.next(t-e)},mulLo:function(t,e){return this.prev(t*e)},mulHi:function(t,e){return this.next(t*e)},divLo:function(t,e){return this.prev(t/e)},divHi:function(t,e){return this.next(t/e)},intLo:function(t){return this.toInteger(this.prev(t))},intHi:function(t){return this.toInteger(this.next(t))},logLo:function(t){return this.prev(Math.log(t))},logHi:function(t){return this.next(Math.log(t))},expLo:function(t){return this.prev(Math.exp(t))},expHi:function(t){return this.next(Math.exp(t))},sinLo:function(t){return this.prev(Math.sin(t))},sinHi:function(t){return this.next(Math.sin(t))},cosLo:function(t){return this.prev(Math.cos(t))},cosHi:function(t){return this.next(Math.cos(t))},tanLo:function(t){return this.prev(Math.tan(t))},tanHi:function(t){return this.next(Math.tan(t))},asinLo:function(t){return this.prev(Math.asin(t))},asinHi:function(t){return this.next(Math.asin(t))},acosLo:function(t){return this.prev(Math.acos(t))},acosHi:function(t){return this.next(Math.acos(t))},atanLo:function(t){return this.prev(Math.atan(t))},atanHi:function(t){return this.next(Math.atan(t))},sinhLo:function(t){return this.prev(r.Z.sinh(t))},sinhHi:function(t){return this.next(r.Z.sinh(t))},coshLo:function(t){return this.prev(r.Z.cosh(t))},coshHi:function(t){return this.next(r.Z.cosh(t))},tanhLo:function(t){return this.prev(r.Z.tanh(t))},tanhHi:function(t){return this.next(r.Z.tanh(t))},sqrtLo:function(t){return this.prev(Math.sqrt(t))},sqrtHi:function(t){return this.next(Math.sqrt(t))},powLo:function(t,e){var i;if(e%1!=0)return this.prev(Math.pow(t,e));for(i=1==(1&e)?t:1,e>>=1;e>0;)t=this.mulLo(t,t),1==(1&e)&&(i=this.mulLo(t,i)),e>>=1;return i},powHi:function(t,e){var i;if(e%1!=0)return this.next(Math.pow(t,e));for(i=1==(1&e)?t:1,e>>=1;e>0;)t=this.mulHi(t,t),1==(1&e)&&(i=this.mulHi(t,i)),e>>=1;return i},disable:function(){this.next=this.prev=this.identity},enable:function(){this.prev=function(t){return this._prev(t)},this.next=function(t){return this._next(t)}},SMALLEST_DENORM:Math.pow(2,-1074),UINT_MAX:-1>>>0,nextafter:function(t,e){var i,s;return isNaN(t)||isNaN(e)?NaN:t===e?t:0===t?e<0?-this.SMALLEST_DENORM:this.SMALLEST_DENORM:(s=n.hi(t),i=n.lo(t),e>t==t>0?i===this.UINT_MAX?(s+=1,i=0):i+=1:0===i?(i=this.UINT_MAX,s-=1):i-=1,n.pack(i,s))}},s.Z.Math.IntervalArithmetic.PI=new a(r.Z.IntervalArithmetic.piLow,r.Z.IntervalArithmetic.piHigh),s.Z.Math.IntervalArithmetic.PI_HALF=new a(r.Z.IntervalArithmetic.piHalfLow,r.Z.IntervalArithmetic.piHalfHigh),s.Z.Math.IntervalArithmetic.PI_TWICE=new a(r.Z.IntervalArithmetic.piTwiceLow,r.Z.IntervalArithmetic.piTwiceHigh),s.Z.Math.IntervalArithmetic.ZERO=new a(0),s.Z.Math.IntervalArithmetic.ONE=new a(1),s.Z.Math.IntervalArithmetic.WHOLE=(new a).setWhole(),s.Z.Math.IntervalArithmetic.EMPTY=(new a).setEmpty();const h=s.Z.Math.IntervalArithmetic},275:(t,e,i)=>{i.d(e,{Z:()=>a});var s,r=i(765),o=i(109),n=function(t){var e,i;return t.memo||(e={},i=Array.prototype.join,t.memo=function(){var r=i.call(arguments);return e[r]!==s?e[r]:e[r]=t.apply(this,arguments)}),t.memo};r.Z.Math={eps:1e-6,relDif:function(t,e){var i=Math.abs(t),s=Math.abs(e);return 0===(s=Math.max(i,s))?0:Math.abs(t-e)/s},mod:function(t,e){return t-Math.floor(t/e)*e},vector:function(t,e){var i,s;for(e=e||0,i=[],s=0;s<t;s++)i[s]=e;return i},matrix:function(t,e,i){var s,r,o;for(i=i||0,e=e||t,s=[],r=0;r<t;r++)for(s[r]=[],o=0;o<e;o++)s[r][o]=i;return s},identity:function(t,e){var i,r;for(e===s&&"number"!=typeof e&&(e=t),i=this.matrix(t,e),r=0;r<Math.min(t,e);r++)i[r][r]=1;return i},frustum:function(t,e,i,s,r,o){var n=this.matrix(4,4);return n[0][0]=2*r/(e-t),n[0][1]=0,n[0][2]=(e+t)/(e-t),n[0][3]=0,n[1][0]=0,n[1][1]=2*r/(s-i),n[1][2]=(s+i)/(s-i),n[1][3]=0,n[2][0]=0,n[2][1]=0,n[2][2]=-(o+r)/(o-r),n[2][3]=-o*r*2/(o-r),n[3][0]=0,n[3][1]=0,n[3][2]=-1,n[3][3]=0,n},projection:function(t,e,i,s){var r=i*Math.tan(t/2),o=r*e;return this.frustum(-o,o,-r,r,i,s)},matVecMult:function(t,e){var i,s,r,o=t.length,n=e.length,a=[];if(3===n)for(i=0;i<o;i++)a[i]=t[i][0]*e[0]+t[i][1]*e[1]+t[i][2]*e[2];else for(i=0;i<o;i++){for(s=0,r=0;r<n;r++)s+=t[i][r]*e[r];a[i]=s}return a},matMatMult:function(t,e){var i,s,r,o,n=t.length,a=n>0?e[0].length:0,h=e.length,l=this.matrix(n,a);for(i=0;i<n;i++)for(s=0;s<a;s++){for(r=0,o=0;o<h;o++)r+=t[i][o]*e[o][s];l[i][s]=r}return l},transpose:function(t){var e,i,s,r,o;for(r=t.length,o=t.length>0?t[0].length:0,e=this.matrix(o,r),i=0;i<o;i++)for(s=0;s<r;s++)e[i][s]=t[s][i];return e},inverse:function(t){var e,i,s,r,o,n,a,h=t.length,l=[],c=[],d=[];for(e=0;e<h;e++){for(l[e]=[],i=0;i<h;i++)l[e][i]=t[e][i];c[e]=e}for(i=0;i<h;i++){for(o=Math.abs(l[i][i]),n=i,e=i+1;e<h;e++)Math.abs(l[e][i])>o&&(o=Math.abs(l[e][i]),n=e);if(o<=this.eps)return[];if(n>i){for(s=0;s<h;s++)a=l[i][s],l[i][s]=l[n][s],l[n][s]=a;a=c[i],c[i]=c[n],c[n]=a}for(r=1/l[i][i],e=0;e<h;e++)l[e][i]*=r;for(l[i][i]=r,s=0;s<h;s++)if(s!==i){for(e=0;e<h;e++)e!==i&&(l[e][s]-=l[e][i]*l[i][s]);l[i][s]=-r*l[i][s]}}for(e=0;e<h;e++){for(s=0;s<h;s++)d[c[s]]=l[e][s];for(s=0;s<h;s++)l[e][s]=d[s]}return l},innerProduct:function(t,e,i){var r,n=0;for(i!==s&&o.Z.isNumber(i)||(i=t.length),r=0;r<i;r++)n+=t[r]*e[r];return n},crossProduct:function(t,e){return[t[1]*e[2]-t[2]*e[1],t[2]*e[0]-t[0]*e[2],t[0]*e[1]-t[1]*e[0]]},norm:function(t,e){var i,r=0;for(e!==s&&o.Z.isNumber(e)||(e=t.length),i=0;i<e;i++)r+=t[i]*t[i];return Math.sqrt(r)},axpy:function(t,e,i){var s,r=e.length,o=[];for(s=0;s<r;s++)o[s]=t*e[s]+i[s];return o},factorial:n((function(t){return t<0?NaN:0===(t=Math.floor(t))||1===t?1:t*this.factorial(t-1)})),binomial:n((function(t,e){var i,s;if(e>t||e<0)return NaN;if(e=Math.round(e),t=Math.round(t),0===e||e===t)return 1;for(i=1,s=0;s<e;s++)i*=t-s,i/=s+1;return i})),cosh:Math.cosh||function(t){return.5*(Math.exp(t)+Math.exp(-t))},sinh:Math.sinh||function(t){return.5*(Math.exp(t)-Math.exp(-t))},acosh:Math.acosh||function(t){return Math.log(t+Math.sqrt(t*t-1))},asinh:Math.asinh||function(t){return t===-1/0?t:Math.log(t+Math.sqrt(t*t+1))},cot:function(t){return 1/Math.tan(t)},acot:function(t){return(t>=0?.5:-.5)*Math.PI-Math.atan(t)},nthroot:function(t,e){var i=1/e;return e<=0||Math.floor(e)!==e?NaN:0===t?0:t>0?Math.exp(i*Math.log(t)):e%2==1?-Math.exp(i*Math.log(-t)):NaN},cbrt:Math.cbrt||function(t){return this.nthroot(t,3)},pow:function(t,e){return 0===t?0===e?1:0:Math.floor(e)===e?Math.pow(t,e):t>0?Math.exp(e*Math.log(t)):NaN},ratpow:function(t,e,i){var s;return 0===e?1:0===i?NaN:(s=this.gcd(e,i),this.nthroot(this.pow(t,e/s),i/s))},log10:function(t){return Math.log(t)/Math.log(10)},log2:function(t){return Math.log(t)/Math.log(2)},log:function(t,e){return void 0!==e&&o.Z.isNumber(e)?Math.log(t)/Math.log(e):Math.log(t)},sign:Math.sign||function(t){return 0===(t=+t)||isNaN(t)?t:t>0?1:-1},squampow:function(t,e){var i;if(Math.floor(e)===e){for(i=1,e<0&&(t=1/t,e*=-1);0!==e;)1&e&&(i*=t),e>>=1,t*=t;return i}return this.pow(t,e)},gcd:function(t,e){var i;if(t=Math.abs(t),e=Math.abs(e),!o.Z.isNumber(t)||!o.Z.isNumber(e))return NaN;for(e>t&&(i=t,t=e,e=i);;){if(0===(t%=e))return e;if(0===(e%=t))return t}},lcm:function(t,e){var i;return o.Z.isNumber(t)&&o.Z.isNumber(e)?0!==(i=t*e)?i/this.gcd(t,e):0:NaN},erf:function(t){return this.ProbFuncs.erf(t)},erfc:function(t){return this.ProbFuncs.erfc(t)},erfi:function(t){return this.ProbFuncs.erfi(t)},ndtr:function(t){return this.ProbFuncs.ndtr(t)},ndtri:function(t){return this.ProbFuncs.ndtri(t)},lt:function(t,e){return t<e},leq:function(t,e){return t<=e},gt:function(t,e){return t>e},geq:function(t,e){return t>=e},eq:function(t,e){return t===e},neq:function(t,e){return t!==e},and:function(t,e){return t&&e},not:function(t){return!t},or:function(t,e){return t||e},xor:function(t,e){return(t||e)&&!(t&&e)},normalize:function(t){var e,i,s=2*t[3],r=t[4]/s;return t[5]=r,t[6]=-t[1]/s,t[7]=-t[2]/s,isFinite(r)?Math.abs(r)>=1?(t[0]=(t[6]*t[6]+t[7]*t[7]-r*r)/(2*r),t[1]=-t[6]/r,t[2]=-t[7]/r,t[3]=1/(2*r),t[4]=1):(i=r<=0?-1:1,t[0]=i*(t[6]*t[6]+t[7]*t[7]-r*r)*.5,t[1]=-i*t[6],t[2]=-i*t[7],t[3]=i/2,t[4]=i*r):(e=Math.sqrt(t[1]*t[1]+t[2]*t[2]),t[0]/=e,t[1]/=e,t[2]/=e,t[3]=0,t[4]=1),t},toGL:function(t){var e,i,s;if(e="function"==typeof Float32Array?new Float32Array(16):new Array(16),4!==t.length&&4!==t[0].length)return e;for(i=0;i<4;i++)for(s=0;s<4;s++)e[i+4*s]=t[i][s];return e},Vieta:function(t){var e,i,s,r=t.length,o=[];for(o=t.slice(),e=1;e<r;++e){for(s=o[e],o[e]*=o[e-1],i=e-1;i>=1;--i)o[i]+=o[i-1]*s;o[0]+=s}return o}};const a=r.Z.Math},336:(t,e,i)=>{i.d(e,{Z:()=>h});var s=i(765),r=i(109),o=i(503),n=i(275),a={rk4:{s:4,A:[[0,0,0,0],[.5,0,0,0],[0,.5,0,0],[0,0,1,0]],b:[1/6,1/3,1/3,1/6],c:[0,.5,.5,1]},heun:{s:2,A:[[0,0],[1,0]],b:[.5,.5],c:[0,1]},euler:{s:1,A:[[0]],b:[1],c:[0]}};n.Z.Numerics={Gauss:function(t,e){var i,s,o,a,h,l=n.Z.eps,c=t.length>0?t[0].length:0;if(c!==e.length||c!==t.length)throw new Error("JXG.Math.Numerics.Gauss: Dimensions don't match. A must be a square matrix and b must be of the same length as A.");for(a=[],h=e.slice(0,c),i=0;i<c;i++)a[i]=t[i].slice(0,c);for(s=0;s<c;s++){for(i=c-1;i>s;i--)if(Math.abs(a[i][s])>l)if(Math.abs(a[s][s])<l)r.Z.swap(a,i,s),r.Z.swap(h,i,s);else for(a[i][s]/=a[s][s],h[i]-=a[i][s]*h[s],o=s+1;o<c;o++)a[i][o]-=a[i][s]*a[s][o];if(Math.abs(a[s][s])<l)throw new Error("JXG.Math.Numerics.Gauss(): The given matrix seems to be singular.")}return this.backwardSolve(a,h,!0),h},backwardSolve:function(t,e,i){var s,r,o,n,a;for(s=i?e:e.slice(0,e.length),r=t.length,o=t.length>0?t[0].length:0,n=r-1;n>=0;n--){for(a=o-1;a>n;a--)s[n]-=t[n][a]*s[a];s[n]/=t[n][n]}return s},gaussBareiss:function(t){var e,i,s,r,o,a,h,l,c,d=n.Z.eps;if((h=t.length)<=0)return 0;for(t[0].length<h&&(h=t[0].length),l=[],r=0;r<h;r++)l[r]=t[r].slice(0,h);for(i=1,s=1,e=0;e<h-1;e++){if(a=l[e][e],Math.abs(a)<d){for(r=e+1;r<h&&!(Math.abs(l[r][e])>=d);r++);if(r===h)return 0;for(o=e;o<h;o++)c=l[r][o],l[r][o]=l[e][o],l[e][o]=c;s=-s,a=l[e][e]}for(r=e+1;r<h;r++)for(o=e+1;o<h;o++)c=a*l[r][o]-l[r][e]*l[e][o],l[r][o]=c/i;i=a}return s*l[h-1][h-1]},det:function(t){return 2===t.length&&2===t[0].length?t[0][0]*t[1][1]-t[1][0]*t[0][1]:this.gaussBareiss(t)},Jacobi:function(t){var e,i,s,r,o,a,h,l,c,d=n.Z.eps*n.Z.eps,u=0,p=t.length,_=[[0,0,0],[0,0,0],[0,0,0]],f=[[0,0,0],[0,0,0],[0,0,0]],b=0;for(e=0;e<p;e++){for(i=0;i<p;i++)_[e][i]=0,f[e][i]=t[e][i],u+=Math.abs(f[e][i]);_[e][e]=1}if(1===p)return[f,_];if(u<=0)return[f,_];u/=p*p;do{for(l=0,c=0,i=1;i<p;i++)for(e=0;e<i;e++)if((r=Math.abs(f[e][i]))>c&&(c=r),l+=r,r>=d){for(r=.5*Math.atan2(2*f[e][i],f[e][e]-f[i][i]),o=Math.sin(r),a=Math.cos(r),s=0;s<p;s++)h=f[s][e],f[s][e]=a*h+o*f[s][i],f[s][i]=-o*h+a*f[s][i],h=_[s][e],_[s][e]=a*h+o*_[s][i],_[s][i]=-o*h+a*_[s][i];for(f[e][e]=a*f[e][e]+o*f[i][e],f[i][i]=-o*f[e][i]+a*f[i][i],f[e][i]=0,s=0;s<p;s++)f[e][s]=f[s][e],f[i][s]=f[s][i]}b+=1}while(Math.abs(l)/u>d&&b<2e3);return[f,_]},NewtonCotes:function(t,e,i){var s,o,n,a=0,h=i&&r.Z.isNumber(i.number_of_nodes)?i.number_of_nodes:28,l={trapez:!0,simpson:!0,milne:!0},c=i&&i.integration_type&&l.hasOwnProperty(i.integration_type)&&l[i.integration_type]?i.integration_type:"milne",d=(t[1]-t[0])/h;switch(c){case"trapez":for(a=.5*(e(t[0])+e(t[1])),s=t[0],o=0;o<h-1;o++)a+=e(s+=d);a*=d;break;case"simpson":if(h%2>0)throw new Error("JSXGraph:  INT_SIMPSON requires config.number_of_nodes dividable by 2.");for(n=h/2,a=e(t[0])+e(t[1]),s=t[0],o=0;o<n-1;o++)a+=2*e(s+=2*d);for(s=t[0]-d,o=0;o<n;o++)a+=4*e(s+=2*d);a*=d/3;break;default:if(h%4>0)throw new Error("JSXGraph: Error in INT_MILNE: config.number_of_nodes must be a multiple of 4");for(n=.25*h,a=7*(e(t[0])+e(t[1])),s=t[0],o=0;o<n-1;o++)a+=14*e(s+=4*d);for(s=t[0]-3*d,o=0;o<n;o++)a+=32*(e(s+=4*d)+e(s+2*d));for(s=t[0]-2*d,o=0;o<n;o++)a+=12*e(s+=4*d);a*=2*d/45}return a},Romberg:function(t,e,i){var s,o,n,a,h,l,c,d,u=[],p=0,_=1/0,f=i&&r.Z.isNumber(i.max_iterations)?i.max_iterations:20,b=i&&r.Z.isNumber(i.eps)?i.eps:i.eps||1e-7;for(s=t[0],n=(o=t[1])-s,h=1,u[0]=.5*n*(e(s)+e(o)),l=0;l<f;++l){for(a=0,n*=.5,h*=2,d=1,c=1;c<h;c+=2)a+=e(s+c*n);for(u[l+1]=.5*u[l]+a*n,p=u[l+1],c=l-1;c>=0;--c)d*=4,u[c]=u[c+1]+(u[c+1]-u[c])/(d-1),p=u[c];if(Math.abs(p-_)<b*Math.abs(p))break;_=p}return p},GaussLegendre:function(t,e,i){var s,o,n,a,h,l,c,d,u=0,p=[],_=[],f=i&&r.Z.isNumber(i.n)?i.n:12;if(f>18&&(f=18),p[2]=[.5773502691896257],_[2]=[1],p[4]=[.33998104358485626,.8611363115940526],_[4]=[.6521451548625461,.34785484513745385],p[6]=[.2386191860831969,.6612093864662645,.932469514203152],_[6]=[.46791393457269104,.3607615730481386,.17132449237917036],p[8]=[.1834346424956498,.525532409916329,.7966664774136267,.9602898564975363],_[8]=[.362683783378362,.31370664587788727,.22238103445337448,.10122853629037626],p[10]=[.14887433898163122,.4333953941292472,.6794095682990244,.8650633666889845,.9739065285171717],_[10]=[.29552422471475287,.26926671930999635,.21908636251598204,.1494513491505806,.06667134430868814],p[12]=[.1252334085114689,.3678314989981802,.5873179542866175,.7699026741943047,.9041172563704749,.9815606342467192],_[12]=[.24914704581340277,.2334925365383548,.20316742672306592,.16007832854334622,.10693932599531843,.04717533638651183],p[14]=[.10805494870734367,.31911236892788974,.5152486363581541,.6872929048116855,.827201315069765,.9284348836635735,.9862838086968123],_[14]=[.2152638534631578,.2051984637212956,.18553839747793782,.15720316715819355,.12151857068790319,.08015808715976021,.03511946033175186],p[16]=[.09501250983763744,.2816035507792589,.45801677765722737,.6178762444026438,.755404408355003,.8656312023878318,.9445750230732326,.9894009349916499],_[16]=[.1894506104550685,.18260341504492358,.16915651939500254,.14959598881657674,.12462897125553388,.09515851168249279,.062253523938647894,.027152459411754096],p[18]=[.0847750130417353,.2518862256915055,.41175116146284263,.5597708310739475,.6916870430603532,.8037049589725231,.8926024664975557,.9558239495713977,.9915651684209309],_[18]=[.1691423829631436,.16427648374583273,.15468467512626524,.14064291467065065,.12255520671147846,.10094204410628717,.07642573025488905,.0497145488949698,.02161601352648331],p[3]=[0,.7745966692414834],_[3]=[.8888888888888888,.5555555555555556],p[5]=[0,.5384693101056831,.906179845938664],_[5]=[.5688888888888889,.47862867049936647,.23692688505618908],p[7]=[0,.4058451513773972,.7415311855993945,.9491079123427585],_[7]=[.4179591836734694,.3818300505051189,.27970539148927664,.1294849661688697],p[9]=[0,.3242534234038089,.6133714327005904,.8360311073266358,.9681602395076261],_[9]=[.3302393550012598,.31234707704000286,.26061069640293544,.1806481606948574,.08127438836157441],p[11]=[0,.26954315595234496,.5190961292068118,.7301520055740494,.8870625997680953,.978228658146057],_[11]=[.2729250867779006,.26280454451024665,.23319376459199048,.18629021092773426,.1255803694649046,.05566856711617366],p[13]=[0,.2304583159551348,.44849275103644687,.6423493394403402,.8015780907333099,.9175983992229779,.9841830547185881],_[13]=[.2325515532308739,.22628318026289723,.2078160475368885,.17814598076194574,.13887351021978725,.09212149983772845,.04048400476531588],p[15]=[0,.20119409399743451,.3941513470775634,.5709721726085388,.7244177313601701,.8482065834104272,.937273392400706,.9879925180204854],_[15]=[.2025782419255613,.19843148532711158,.1861610000155622,.16626920581699392,.13957067792615432,.10715922046717194,.07036604748810812,.03075324199611727],p[17]=[0,.17848418149584785,.3512317634538763,.5126905370864769,.6576711592166907,.7815140038968014,.8802391537269859,.9506755217687678,.9905754753144174],_[17]=[.17944647035620653,.17656270536699264,.16800410215645004,.15404576107681028,.13513636846852548,.11188384719340397,.08503614831717918,.0554595293739872,.02414830286854793],s=t[0],o=t[1],a=f+1>>1,c=p[f],d=_[f],l=.5*(o-s),h=.5*(o+s),!0&f)for(u=d[0]*e(h),n=1;n<a;++n)u+=d[n]*(e(h+l*c[n])+e(h-l*c[n]));else for(u=0,n=0;n<a;++n)u+=d[n]*(e(h+l*c[n])+e(h-l*c[n]));return l*u},_rescale_error:function(t,e,i){var s,r,o=2220446049250313e-31;return t=Math.abs(t),0!==i&&0!==t&&(t=(s=Math.pow(200*t/i,1.5))<1?i*s:i),e>20041683600089728e-310&&(r=50*o*e)>t&&(t=r),t},_gaussKronrod:function(t,e,i,s,r,o,n){var a,h,l,c,d,u,p,_,f,b,g,m=t[0],v=t[1],Z=.5*(m+v),C=.5*(v-m),y=Math.abs(C),P=e(Z),E=0,O=P*o[i-1],x=Math.abs(O),w=0,S=[],T=[];for(i%2==0&&(E=P*r[i/2-1]),a=Math.floor((i-1)/2),d=0;d<a;d++)b=(_=e(Z-(p=C*s[u=2*d+1])))+(f=e(Z+p)),S[u]=_,T[u]=f,E+=r[d]*b,O+=o[u]*b,x+=o[u]*(Math.abs(_)+Math.abs(f));for(a=Math.floor(i/2),d=0;d<a;d++)_=e(Z-(p=C*s[g=2*d])),f=e(Z+p),S[g]=_,T[g]=f,O+=o[g]*(_+f),x+=o[g]*(Math.abs(_)+Math.abs(f));for(l=.5*O,w=o[i-1]*Math.abs(P-l),d=0;d<i-1;d++)w+=o[d]*(Math.abs(S[d]-l)+Math.abs(T[d]-l));return c=(O-E)*C,x*=y,w*=y,h=O*=C,n.abserr=this._rescale_error(c,x,w),n.resabs=x,n.resasc=w,h},GaussKronrod15:function(t,e,i){return this._gaussKronrod(t,e,8,[.9914553711208126,.9491079123427585,.8648644233597691,.7415311855993945,.5860872354676911,.4058451513773972,.20778495500789848,0],[.1294849661688697,.27970539148927664,.3818300505051189,.4179591836734694],[.022935322010529224,.06309209262997856,.10479001032225019,.14065325971552592,.1690047266392679,.19035057806478542,.20443294007529889,.20948214108472782],i)},GaussKronrod21:function(t,e,i){return this._gaussKronrod(t,e,11,[.9956571630258081,.9739065285171717,.9301574913557082,.8650633666889845,.7808177265864169,.6794095682990244,.5627571346686047,.4333953941292472,.2943928627014602,.14887433898163122,0],[.06667134430868814,.1494513491505806,.21908636251598204,.26926671930999635,.29552422471475287],[.011694638867371874,.032558162307964725,.054755896574351995,.07503967481091996,.0931254545836976,.10938715880229764,.12349197626206584,.13470921731147334,.14277593857706009,.14773910490133849,.1494455540029169],i)},GaussKronrod31:function(t,e,i){return this._gaussKronrod(t,e,16,[.9980022986933971,.9879925180204854,.9677390756791391,.937273392400706,.8972645323440819,.8482065834104272,.790418501442466,.7244177313601701,.650996741297417,.5709721726085388,.4850818636402397,.3941513470775634,.29918000715316884,.20119409399743451,.1011420669187175,0],[.03075324199611727,.07036604748810812,.10715922046717194,.13957067792615432,.16626920581699392,.1861610000155622,.19843148532711158,.2025782419255613],[.005377479872923349,.015007947329316122,.02546084732671532,.03534636079137585,.04458975132476488,.05348152469092809,.06200956780067064,.06985412131872826,.07684968075772038,.08308050282313302,.08856444305621176,.09312659817082532,.09664272698362368,.09917359872179196,.10076984552387559,.10133000701479154],i)},_workspace:function(t,e){return{limit:e,size:0,nrmax:0,i:0,alist:[t[0]],blist:[t[1]],rlist:[0],elist:[0],order:[0],level:[0],qpsrt:function(){var t,e,i,s,r,o=this.size-1,n=this.limit,a=this.nrmax,h=this.order[a];if(o<2)return this.order[0]=0,this.order[1]=1,void(this.i=h);for(t=this.elist[h];a>0&&t>this.elist[this.order[a-1]];)this.order[a]=this.order[a-1],a--;for(r=o<n/2+2?o:n-o+1,i=a+1;i<r&&t<this.elist[this.order[i]];)this.order[i-1]=this.order[i],i++;for(this.order[i-1]=h,e=this.elist[o],s=r-1;s>i-2&&e>=this.elist[this.order[s]];)this.order[s+1]=this.order[s],s--;this.order[s+1]=o,h=this.order[a],this.i=h,this.nrmax=a},set_initial_result:function(t,e){this.size=1,this.rlist[0]=t,this.elist[0]=e},update:function(t,e,i,s,r,o,n,a){var h=this.i,l=this.size,c=this.level[this.i]+1;a>s?(this.alist[h]=r,this.rlist[h]=n,this.elist[h]=a,this.level[h]=c,this.alist[l]=t,this.blist[l]=e,this.rlist[l]=i,this.elist[l]=s,this.level[l]=c):(this.blist[h]=e,this.rlist[h]=i,this.elist[h]=s,this.level[h]=c,this.alist[l]=r,this.blist[l]=o,this.rlist[l]=n,this.elist[l]=a,this.level[l]=c),this.size++,c>this.maximum_level&&(this.maximum_level=c),this.qpsrt()},retrieve:function(){var t=this.i;return{a:this.alist[t],b:this.blist[t],r:this.rlist[t],e:this.elist[t]}},sum_results:function(){var t,e=this.size,i=0;for(t=0;t<e;t++)i+=this.rlist[t];return i},subinterval_too_small:function(t,e,i){var s=1.0000000000000222*(Math.abs(e)+22250738585072014e-321);return Math.abs(t)<=s&&Math.abs(i)<=s}}},Qag:function(t,e,i){var o,a,h,l,c,d,u,p,_,f,b,g,m,v,Z,C,y,P,E=this._workspace(t,1e3),O=i&&r.Z.isNumber(i.limit)?i.limit:15,x=i&&r.Z.isNumber(i.epsrel)?i.epsrel:1e-7,w=i&&r.Z.isNumber(i.epsabs)?i.epsabs:1e-7,S=i&&r.Z.isFunction(i.q)?i.q:this.GaussKronrod15,T={},M=0,N=0,A=0,k=0,R=0,D=0,L=0,B=0,I=0,Y=0;if(O>E.limit&&s.Z.warn("iteration limit exceeds available workspace"),w<=0&&(x<50*n.Z.eps||x<5e-29)&&s.Z.warn("tolerance cannot be acheived with given epsabs and epsrel"),h=S.apply(this,[t,e,T]),l=T.abserr,c=T.resabs,d=T.resasc,E.set_initial_result(h,l),u=Math.max(w,x*Math.abs(h)),l<=11102230246251565e-30*c&&l>u)return h,s.Z.warn("cannot reach tolerance because of roundoff error on first attempt"),-1/0;if(l<=u&&l!==d||0===l)return h;if(1===O)return h,s.Z.warn("a maximum of one iteration was insufficient"),-1/0;o=h,a=l,M=1;do{R=0,D=0,L=0,B=0,I=0,Y=0,g=(y=E.retrieve()).a,m=y.b,v=y.r,Z=y.e,p=g,f=_=.5*(g+m),b=m,R=S.apply(this,[[p,_],e,T]),B=T.abserr,C=T.resasc,D=S.apply(this,[[f,b],e,T]),a+=(Y=B+(I=T.abserr))-Z,o+=(L=R+D)-v,C!==B&&T.resasc!==I&&(P=v-L,Math.abs(P)<=1e-5*Math.abs(L)&&Y>=.99*Z&&N++,M>=10&&Y>Z&&A++),a>(u=Math.max(w,x*Math.abs(o)))&&((N>=6||A>=20)&&(k=2),E.subinterval_too_small(p,f,b)&&(k=3)),E.update(p,_,R,B,f,b,D,I),g=(y=E.retrieve()).a_i,m=y.b_i,v=y.r_i,Z=y.e_i,M++}while(M<O&&!k&&a>u);return E.sum_results()},I:function(t,e){return this.Qag(t,e,{q:this.GaussKronrod15,limit:15,epsrel:1e-7,epsabs:1e-7})},Newton:function(t,e,i){var s,o=0,a=n.Z.eps,h=t.apply(i,[e]);for(r.Z.isArray(e)&&(e=e[0]);o<50&&Math.abs(h)>a;)s=this.D(t,i)(e),Math.abs(s)>a?e-=h/s:e+=.2*Math.random()-1,h=t.apply(i,[e]),o+=1;return e},root:function(t,e,i){return this.chandrupatla(t,e,i)},generalizedNewton:function(t,e,i,s){var r,o,a,h,l,c,d,u,p,_,f,b,g,m,v=0;for(this.generalizedNewton.t1memo?(r=this.generalizedNewton.t1memo,o=this.generalizedNewton.t2memo):(r=i,o=s),_=(u=t.X(r)-e.X(o))*u+(p=t.Y(r)-e.Y(o))*p,f=this.D(t.X,t),b=this.D(e.X,e),g=this.D(t.Y,t),m=this.D(e.Y,e);_>n.Z.eps&&v<10;)a=f(r),h=-b(o),l=g(r),r-=((c=-m(o))*u-h*p)/(d=a*c-h*l),o-=(a*p-l*u)/d,_=(u=t.X(r)-e.X(o))*u+(p=t.Y(r)-e.Y(o))*p,v+=1;return this.generalizedNewton.t1memo=r,this.generalizedNewton.t2memo=o,Math.abs(r)<Math.abs(o)?[t.X(r),t.Y(r)]:[e.X(o),e.Y(o)]},Neville:function(t){var e=[],i=function(i){return function(s,r){var o,a,h,l=n.Z.binomial,c=t.length,d=c-1,u=0,p=0;if(!r)for(h=1,o=0;o<c;o++)e[o]=l(d,o)*h,h*=-1;for(a=s,o=0;o<c;o++){if(0===a)return t[o][i]();h=e[o]/a,a-=1,u+=t[o][i]()*h,p+=h}return u/p}};return[i("X"),i("Y"),0,function(){return t.length-1}]},splineDef:function(t,e){var i,s,r,o=Math.min(t.length,e.length),n=[],a=[],h=[],l=[],c=[],d=[];if(2===o)return[0,0];for(s=0;s<o;s++)i={X:t[s],Y:e[s]},h.push(i);for(h.sort((function(t,e){return t.X-e.X})),s=0;s<o;s++)t[s]=h[s].X,e[s]=h[s].Y;for(s=0;s<o-1;s++)l.push(t[s+1]-t[s]);for(s=0;s<o-2;s++)c.push(6*(e[s+2]-e[s+1])/l[s+1]-6*(e[s+1]-e[s])/l[s]);for(n.push(2*(l[0]+l[1])),a.push(c[0]),s=0;s<o-3;s++)r=l[s+1]/n[s],n.push(2*(l[s+1]+l[s+2])-r*l[s+1]),a.push(c[s+1]-r*a[s]);for(d[o-3]=a[o-3]/n[o-3],s=o-4;s>=0;s--)d[s]=(a[s]-l[s+1]*d[s+1])/n[s];for(s=o-3;s>=0;s--)d[s+1]=d[s];return d[0]=0,d[o-1]=0,d},splineEval:function(t,e,i,s){var o,n,a,h,l,c,d,u=Math.min(e.length,i.length),p=1,_=!1,f=[];for(r.Z.isArray(t)?(p=t.length,_=!0):t=[t],o=0;o<p;o++){if(t[o]<e[0]||e[o]>e[u-1])return NaN;for(n=1;n<u&&!(t[o]<=e[n]);n++);a=i[n-=1],h=(i[n+1]-i[n])/(e[n+1]-e[n])-(e[n+1]-e[n])/6*(s[n+1]+2*s[n]),l=s[n]/2,c=(s[n+1]-s[n])/(6*(e[n+1]-e[n])),d=t[o]-e[n],f.push(a+(h+(l+c*d)*d)*d)}return _?f:f[0]},generatePolynomialTerm:function(t,e,i,s){var r,o=[];for(r=e;r>=0;r--)o=o.concat(["(",t[r].toPrecision(s),")"]),r>1?o=o.concat(["*",i,"<sup>",r,"<","/sup> + "]):1===r&&(o=o.concat(["*",i," + "]));return o.join("")},lagrangePolynomial:function(t){var e=[],i=this,s=function(i,s){var r,o,n,a,h=t.length,l=0,c=0;if(!s)for(r=0;r<h;r++){for(e[r]=1,n=t[r].X(),o=0;o<h;o++)o!==r&&(e[r]*=n-t[o].X());e[r]=1/e[r]}for(r=0;r<h;r++){if(i===(n=t[r].X()))return t[r].Y();c+=a=e[r]/(i-n),l+=a*t[r].Y()}return l/c};return s.getTerm=function(e,s,r){return i.lagrangePolynomialTerm(t,e,s,r)()},s},lagrangePolynomialTerm:function(t,e,i,r){return function(){var a,h,l,c,d,u,p=t.length,_=[],f=[],b=[],g=!0;for(i=i||"x",void 0===r&&(r=" * "),a=p-1,c=0;c<p;c++)b[c]=0;for(l=0;l<p;l++){for(d=t[l].Y(),u=t[l].X(),_=[],c=0;c<p;c++)c!==l&&(d/=u-t[c].X(),_.push(t[c].X()));for(f=[1].concat(n.Z.Vieta(_)),c=0;c<f.length;c++)b[c]+=(c%2==1?-1:1)*f[c]*d}for(h="",c=0;c<b.length;c++)d=b[c],Math.abs(d)<n.Z.eps||(s.Z.exists(e)&&(d=o.Z._round10(d,-e)),g?(h+=d>0?d:"-"+-d,g=!1):h+=d>0?" + "+d:" - "+-d,a-c>1?h+=r+i+"^"+(a-c):a-c==1&&(h+=r+i));return h}},_initCubicPoly:function(t,e,i,s){return[t,i,-3*t+3*e-2*i-s,2*t-2*e+i+s]},CardinalSpline:function(t,e,i){var s,o,a,h,l=[],c=this;return h=r.Z.isFunction(e)?e:function(){return e},void 0===i&&(i="uniform"),o=function(e){return function(r,o){var d,u,p,_,f,b,g,m,v,Z;if(t.length<2)return NaN;if(!o)for(a=h(),p={X:function(){return 2*t[0].X()-t[1].X()},Y:function(){return 2*t[0].Y()-t[1].Y()},Dist:function(t){var e=this.X()-t.X(),i=this.Y()-t.Y();return Math.sqrt(e*e+i*i)}},_={X:function(){return 2*t[t.length-1].X()-t[t.length-2].X()},Y:function(){return 2*t[t.length-1].Y()-t[t.length-2].Y()},Dist:function(t){var e=this.X()-t.X(),i=this.Y()-t.Y();return Math.sqrt(e*e+i*i)}},Z=(s=[p].concat(t,[_])).length,l[e]=[],d=0;d<Z-3;d++)"centripetal"===i?(g=s[d].Dist(s[d+1]),m=s[d+2].Dist(s[d+1]),v=s[d+3].Dist(s[d+2]),g=Math.sqrt(g),m=Math.sqrt(m),v=Math.sqrt(v),m<n.Z.eps&&(m=1),g<n.Z.eps&&(g=m),v<n.Z.eps&&(v=m),f=(s[d+1][e]()-s[d][e]())/g-(s[d+2][e]()-s[d][e]())/(m+g)+(s[d+2][e]()-s[d+1][e]())/m,b=(s[d+2][e]()-s[d+1][e]())/m-(s[d+3][e]()-s[d+1][e]())/(v+m)+(s[d+3][e]()-s[d+2][e]())/v,f*=m,b*=m,l[e][d]=c._initCubicPoly(s[d+1][e](),s[d+2][e](),a*f,a*b)):l[e][d]=c._initCubicPoly(s[d+1][e](),s[d+2][e](),a*(s[d+2][e]()-s[d][e]()),a*(s[d+3][e]()-s[d+1][e]()));return isNaN(r)?NaN:(Z=t.length,r<=0?t[0][e]():r>=Z?t[Z-1][e]():(d=Math.floor(r))===r?t[d][e]():(r-=d,void 0===(u=l[e][d])?NaN:((u[3]*r+u[2])*r+u[1])*r+u[0]))}},[o("X"),o("Y"),0,function(){return t.length-1}]},CatmullRomSpline:function(t,e){return this.CardinalSpline(t,.5,e)},regressionPolynomial:function(t,e,i){var s,o,a,h,l,c,d="";if(r.Z.isPoint(t)&&r.Z.isFunction(t.Value))o=function(){return t.Value()};else if(r.Z.isFunction(t))o=t;else{if(!r.Z.isNumber(t))throw new Error("JSXGraph: Can't create regressionPolynomial from degree of type'"+typeof t+"'.");o=function(){return t}}if(3===arguments.length&&r.Z.isArray(e)&&r.Z.isArray(i))l=0;else if(2===arguments.length&&r.Z.isArray(e)&&e.length>0&&r.Z.isPoint(e[0]))l=1;else{if(!(2===arguments.length&&r.Z.isArray(e)&&e.length>0&&e[0].usrCoords&&e[0].scrCoords))throw new Error("JSXGraph: Can't create regressionPolynomial. Wrong parameters.");l=2}return(c=function(t,c){var u,p,_,f,b,g,m,v,Z,C=e.length;if(Z=Math.floor(o()),!c){if(1===l)for(a=[],h=[],u=0;u<C;u++)a[u]=e[u].X(),h[u]=e[u].Y();if(2===l)for(a=[],h=[],u=0;u<C;u++)a[u]=e[u].usrCoords[1],h[u]=e[u].usrCoords[2];if(0===l)for(a=[],h=[],u=0;u<C;u++)r.Z.isFunction(e[u])?a.push(e[u]()):a.push(e[u]),r.Z.isFunction(i[u])?h.push(i[u]()):h.push(i[u]);for(_=[],p=0;p<C;p++)_.push([1]);for(u=1;u<=Z;u++)for(p=0;p<C;p++)_[p][u]=_[p][u-1]*a[p];b=h,f=n.Z.transpose(_),g=n.Z.matMatMult(f,_),m=n.Z.matVecMult(f,b),s=n.Z.Numerics.Gauss(g,m),d=n.Z.Numerics.generatePolynomialTerm(s,Z,"x",3)}for(v=s[Z],u=Z-1;u>=0;u--)v=v*t+s[u];return v}).getTerm=function(){return d},c},bezier:function(t){var e,i,s=function(s){return function(r,o){var n=3*Math.floor(r),a=r%1,h=1-a;return o||(i=3*Math.floor((t.length-1)/3),e=Math.floor(i/3)),r<0?t[0][s]():r>=e?t[i][s]():isNaN(r)?NaN:h*h*(h*t[n][s]()+3*a*t[n+1][s]())+(3*h*t[n+2][s]()+a*t[n+3][s]())*a*a}};return[s("X"),s("Y"),0,function(){return Math.floor(t.length/3)}]},bspline:function(t,e){var i,s=function(s){return function(r,o){var n,a,h,l,c=t.length,d=c-1,u=e;if(d<=0)return NaN;if(d+2<=u&&(u=d+1),r<=0)return t[0][s]();if(r>=d-u+2)return t[d][s]();for(h=Math.floor(r)+u-1,i=function(t,e){var i,s=[];for(i=0;i<t+e+1;i++)s[i]=i<e?0:i<=t?i-e+1:t-e+2;return s}(d,u),l=function(t,e,i,s){var r,o,n,a,h,l=[];for(e[s]<=t&&t<e[s+1]?l[s]=1:l[s]=0,r=2;r<=i;r++)for(o=s-r+1;o<=s;o++)n=o<=s-r+1||o<0?0:l[o],a=o>=s?0:l[o+1],h=e[o+r-1]-e[o],l[o]=0===h?0:(t-e[o])/h*n,0!=(h=e[o+r]-e[o+1])&&(l[o]+=(e[o+r]-t)/h*a);return l}(r,i,u,h),n=0,a=h-u+1;a<=h;a++)a<c&&a>=0&&(n+=t[a][s]()*l[a]);return n}};return[s("X"),s("Y"),0,function(){return t.length-1}]},D:function(t,e){return r.Z.exists(e)?function(i,s){var r=1e-5;return(t.apply(e,[i+r,s])-t.apply(e,[i-r,s]))/2e-5}:function(e,i){var s=1e-5;return(t(e+s,i)-t(e-s,i))/2e-5}},_riemannValue:function(t,e,i,s){var r,o,n,a;if(s<0&&("trapezoidal"!==i&&(t+=s),s*=-1,"lower"===i?i="upper":"upper"===i&&(i="lower")),a=.01*s,"right"===i)r=e(t+s);else if("middle"===i)r=e(t+.5*s);else if("left"===i||"trapezoidal"===i)r=e(t);else if("lower"===i){for(r=e(t),n=t+a;n<=t+s;n+=a)(o=e(n))<r&&(r=o);(o=e(t+s))<r&&(r=o)}else if("upper"===i){for(r=e(t),n=t+a;n<=t+s;n+=a)(o=e(n))>r&&(r=o);(o=e(t+s))>r&&(r=o)}else r="random"===i?e(t+s*Math.random()):"simpson"===i?(e(t)+4*e(t+.5*s)+e(t+s))/6:e(t);return r},riemann:function(t,e,i,s,o){var n,a,h,l,c,d,u,p=[],_=[],f=0,b=s,g=0;if(r.Z.isArray(t)?(c=t[0],l=t[1]):l=t,(e=Math.floor(e))<=0)return[p,_,g];for(a=(o-s)/e,n=0;n<e;n++)h=this._riemannValue(b,l,i,a),p[f]=b,_[f]=h,f+=1,b+=a,"trapezoidal"===i&&(h=l(b)),p[f]=b,_[f]=h,f+=1;for(n=0;n<e;n++)h=c?this._riemannValue(b,c,i,-a):0,p[f]=b,_[f]=h,f+=1,b-=a,"trapezoidal"===i&&c&&(h=c(b)),p[f]=b,_[f]=h,"trapezoidal"!==i?(d=h,u=_[2*(e-1)-2*n]):(u=.5*(l(b+a)+l(b)),d=c?.5*(c(b+a)+c(b)):0),g+=(u-d)*a,p[f+=1]=b,_[f]=_[2*(e-1)-2*n],f+=1;return[p,_,g]},riemannsum:function(t,e,i,r,o){return s.Z.deprecated("Numerics.riemannsum()","Numerics.riemann()"),this.riemann(t,e,i,r,o)[2]},rungeKutta:function(t,e,i,s,o){var n,h,l,c,d,u,p=[],_=[],f=(i[1]-i[0])/s,b=i[0],g=e.length,m=[],v=0;for(r.Z.isString(t)&&(t=a[t]||a.euler),u=t.s,n=0;n<g;n++)p[n]=e[n];for(h=0;h<s;h++){for(m[v]=[],n=0;n<g;n++)m[v][n]=p[n];for(v+=1,c=[],l=0;l<u;l++){for(n=0;n<g;n++)_[n]=0;for(d=0;d<l;d++)for(n=0;n<g;n++)_[n]+=t.A[l][d]*f*c[d][n];for(n=0;n<g;n++)_[n]+=p[n];c.push(o(b+t.c[l]*f,_))}for(n=0;n<g;n++)_[n]=0;for(d=0;d<u;d++)for(n=0;n<g;n++)_[n]+=t.b[d]*c[d][n];for(n=0;n<g;n++)p[n]=p[n]+f*_[n];b+=f}return m},maxIterationsRoot:80,maxIterationsMinimize:500,findBracket:function(t,e,i){var s,o,n,a,h,l,c,d,u,p;if(r.Z.isArray(e))return e;for(s=e,n=t.call(i,s),p=(a=[s-.1*(o=0===s?1:s),s+.1*o,s-1,s+1,s-.5*o,s+.5*o,s-.6*o,s+.6*o,s-1*o,s+1*o,s-2*o,s+2*o,s-5*o,s+5*o,s-10*o,s+10*o,s-50*o,s+50*o,s-100*o,s+100*o]).length,u=0;u<p&&(h=a[u],!(n*(l=t.call(i,h))<=0));u++);return h<s&&(c=s,s=h,h=c,d=n,n=l,l=d),[s,n,h,l]},fzero:function(t,e,i){var s,o,a,h,l,c,d,u,p,_,f,b,g,m,v,Z=n.Z.eps,C=this.maxIterationsRoot,y=0;if(r.Z.isArray(e)){if(e.length<2)throw new Error("JXG.Math.Numerics.fzero: length of array x0 has to be at least two.");s=e[0],h=t.call(i,s),o=e[1],l=t.call(i,o)}else s=(d=this.findBracket(t,e,i))[0],h=d[1],o=d[2],l=d[3];if(Math.abs(h)<=Z)return s;if(Math.abs(l)<=Z)return o;if(h*l>0)return r.Z.isArray(e)?this.fminbr(t,[s,o],i):this.Newton(t,s,i);for(a=s,c=h;y<C;){if(u=o-s,Math.abs(c)<Math.abs(l)&&(s=o,o=a,a=s,h=l,l=c,c=h),b=2*Z*Math.abs(o)+.5*Z,v=.5*(a-o),Math.abs(v)<=b||Math.abs(l)<=Z)return o;Math.abs(u)>=b&&Math.abs(h)>Math.abs(l)&&(_=a-o,s===a?(g=_*(p=l/h),m=1-p):(g=(f=l/h)*(_*(m=h/c)*(m-(p=l/c))-(o-s)*(p-1)),m=(m-1)*(p-1)*(f-1)),g>0?m=-m:g=-g,g<.75*_*m-.5*Math.abs(b*m)&&g<Math.abs(u*m*.5)&&(v=g/m)),Math.abs(v)<b&&(v=v>0?b:-b),s=o,h=l,o+=v,((l=t.call(i,o))>0&&c>0||l<0&&c<0)&&(a=s,c=h),y++}return o},chandrupatla:function(t,e,i){var s,o,a,h,l,c,d,u,p,_,f,b,g,m,v,Z,C,y,P,E,O=0,x=this.maxIterationsRoot,w=1+.001*Math.random(),S=.5*w,T=n.Z.eps;if(r.Z.isArray(e)){if(e.length<2)throw new Error("JXG.Math.Numerics.fzero: length of array x0 has to be at least two.");s=e[0],o=t.call(i,s),a=e[1],h=t.call(i,a)}else s=(l=this.findBracket(t,e,i))[0],o=l[1],a=l[2],h=l[3];if(o*h>0)return r.Z.isArray(e)?this.fminbr(t,[s,a],i):this.Newton(t,s,i);c=s,d=a,_=o,f=h;do{if(p=c+S*(d-c),g=t.call(i,p),Math.sign(g)===Math.sign(_)?(u=c,c=p,b=_,_=g):(u=d,d=c,b=f,f=_),m=c=p,v=_=g,Math.abs(f)<Math.abs(_)&&(m=d,v=f),(Z=(2*T*Math.abs(m)+5e-6)/Math.abs(d-c))>.5||0===v)break;C=(c-d)/(u-d),y=(_-f)/(b-f),P=1-Math.sqrt(1-C),E=Math.sqrt(C),(S=P<y&&y<E?_/(f-_)*(b/(f-b))+_/(b-_)*(f/(b-f))*((u-c)/(d-c)):.5*w)<Z&&(S=Z),S>1-Z&&(S=1-Z),O++}while(O<=x);return m},fminbr:function(t,e,i){var s,o,a,h,l,c,d,u,p,_,f,b,g,m,v,Z,C=.5*(3-Math.sqrt(5)),y=n.Z.eps,P=n.Z.eps,E=this.maxIterationsMinimize,O=0;if(!r.Z.isArray(e)||e.length<2)throw new Error("JXG.Math.Numerics.fminbr: length of array x0 has to be at least two.");for(a=h=(s=e[0])+C*((o=e[1])-s),l=h,c=d=t.call(i,h),u=d;O<E;){if(p=o-s,_=.5*(s+o),f=P*Math.abs(a)+y/3,Math.abs(a-_)+.5*p<=2*f)return a;b=C*(a<_?o-a:s-a),Math.abs(a-l)>=f&&(g=(a-h)*(m=(a-h)*(c-u))-(a-l)*(v=(a-l)*(c-d)),(m=2*(m-v))>0?g=-g:m=-m,Math.abs(g)<Math.abs(b*m)&&g>m*(s-a+2*f)&&g<m*(o-a-2*f)&&(b=g/m)),Math.abs(b)<f&&(b=b>0?f:-f),v=a+b,(Z=t.call(i,v))<=c?(v<a?o=a:s=a,h=l,l=a,a=v,d=u,u=c,c=Z):(v<a?s=v:o=v,Z<=u||l===a?(h=l,l=v,d=u,u=Z):(Z<=d||h===a||h===l)&&(h=v,d=Z)),O+=1}return a},RamerDouglasPeucker:function(t,e){var i,s,r,o=[],a=[],h=function(t,e,i,s,r){var o=function(t,e,i){var s,r,o,a,h,l,c,d,u,p,_,f=1e4,b=0,g=e;if(i-e<2)return[-1,0];if(o=t[e].scrCoords,a=t[i].scrCoords,isNaN(o[1])||isNaN(o[2]))return[NaN,e];if(isNaN(a[1])||isNaN(a[2]))return[NaN,i];for(r=e+1;r<i;r++){if(h=t[r].scrCoords,isNaN(h[1])||isNaN(h[2]))return[NaN,r];l=(l=(l=h[1]-o[1])==1/0?f:l)===-1/0?-f:l,c=(c=(c=h[2]-o[2])==1/0?f:c)===-1/0?-f:c,(p=(d=(d=(d=a[1]-o[1])==1/0?f:d)===-1/0?-f:d)*d+(u=(u=(u=a[2]-o[2])==1/0?f:u)===-1/0?-f:u)*u)>=n.Z.eps?((_=(l*d+c*u)/p)<0?_=0:_>1&&(_=1),s=(l-=_*d)*l+(c-=_*u)*c):(_=0,s=l*l+c*c),s>b&&(b=s,g=r)}return[Math.sqrt(b),g]}(t,e,i),a=o[1];if(isNaN(o[0])){h(t,e,a-1,s,r),r.push(t[a]);do{++a}while(a<=i&&isNaN(t[a].scrCoords[1]+t[a].scrCoords[2]));a<=i&&r.push(t[a]),h(t,a+1,i,s,r)}else o[0]>s?(h(t,e,a,s,r),h(t,a,i,s,r)):r.push(t[i])};for(r=t.length,i=0;;){for(;i<r&&isNaN(t[i].scrCoords[1]+t[i].scrCoords[2]);)i+=1;for(s=i+1;s<r&&!isNaN(t[s].scrCoords[1]+t[s].scrCoords[2]);)s+=1;if(s--,i<r&&s>i&&((a=[])[0]=t[i],h(t,i,s,e,a),o=o.concat(a)),i>=r)break;s<r-1&&o.push(t[s+1]),i=s+1}return o},RamerDouglasPeuker:function(t,e){return s.Z.deprecated("Numerics.RamerDouglasPeuker()","Numerics.RamerDouglasPeucker()"),this.RamerDouglasPeucker(t,e)},Visvalingam:function(t,e){var i,r,o,n,a,h,l,c,d,u=[],p=[],_=[];if((r=t.length)<=2)return t;for(u[0]={used:!0,lft:null,node:null},a=0,i=1;i<r-1;i++)o=Math.abs(s.Z.Math.Numerics.det([t[i-1].usrCoords,t[i].usrCoords,t[i+1].usrCoords])),isNaN(o)||(d={v:o,idx:i},p.push(d),u[i]={used:!0,lft:a,node:d},u[a].rt=i,a=i);for(u[r-1]={used:!0,rt:null,lft:a,node:null},u[a].rt=r-1,n=-1/0;p.length>e;)p.sort((function(t,e){return e.v-t.v})),u[i=p.pop().idx].used=!1,n=u[i].node.v,a=u[i].lft,h=u[i].rt,u[a].rt=h,u[h].lft=a,null!==(l=u[a].lft)&&(o=Math.abs(s.Z.Math.Numerics.det([t[l].usrCoords,t[a].usrCoords,t[h].usrCoords])),u[a].node.v=o>=n?o:n),null!==(c=u[h].rt)&&(o=Math.abs(s.Z.Math.Numerics.det([t[a].usrCoords,t[h].usrCoords,t[c].usrCoords])),u[h].node.v=o>=n?o:n);_=[t[i=0]];do{i=u[i].rt,_.push(t[i])}while(null!==u[i].rt);return _}};const h=n.Z.Numerics},309:(t,e,i)=>{i.d(e,{Z:()=>n});var s=i(765),r=i(275),o=i(109);r.Z.Statistics={sum:function(t){var e,i=t.length,s=0;for(e=0;e<i;e++)s+=t[e];return s},prod:function(t){var e,i=t.length,s=1;for(e=0;e<i;e++)s*=t[e];return s},mean:function(t){return t.length>0?this.sum(t)/t.length:0},median:function(t){var e,i;return t.length>0?(ArrayBuffer.isView(t)?(e=new Float64Array(t)).sort():(e=t.slice(0)).sort((function(t,e){return t-e})),1&(i=e.length)?e[parseInt(.5*i,10)]:.5*(e[.5*i-1]+e[.5*i])):0},percentile:function(t,e){var i,s,r,n,a,h=[];if(t.length>0){for(ArrayBuffer.isView(t)?(i=new Float64Array(t)).sort():(i=t.slice(0)).sort((function(t,e){return t-e})),s=i.length,n=o.Z.isArray(e)?e:[e],r=0;r<n.length;r++)a=s*n[r]*.01,parseInt(a,10)===a?h.push(.5*(i[a-1]+i[a])):h.push(i[parseInt(a,10)]);return o.Z.isArray(e)?h:h[0]}return 0},variance:function(t){var e,i,s,r=t.length;if(r>1){for(e=this.mean(t),i=0,s=0;s<r;s++)i+=(t[s]-e)*(t[s]-e);return i/(t.length-1)}return 0},sd:function(t){return Math.sqrt(this.variance(t))},weightedMean:function(t,e){if(t.length!==e.length)throw new Error("JSXGraph error (Math.Statistics.weightedMean): Array dimension mismatch.");return t.length>0?this.mean(this.multiply(t,e)):0},max:function(t){return Math.max.apply(this,t)},min:function(t){return Math.min.apply(this,t)},range:function(t){return[this.min(t),this.max(t)]},abs:function(t){var e,i,s;if(o.Z.isArray(t))if(t.map)s=t.map(Math.abs);else for(i=t.length,s=[],e=0;e<i;e++)s[e]=Math.abs(t[e]);else s=ArrayBuffer.isView(t)?t.map(Math.abs):Math.abs(t);return s},add:function(t,e){var i,s,r=[];if(t=o.Z.evalSlider(t),e=o.Z.evalSlider(e),o.Z.isArray(t)&&o.Z.isNumber(e))for(s=t.length,i=0;i<s;i++)r[i]=t[i]+e;else if(o.Z.isNumber(t)&&o.Z.isArray(e))for(s=e.length,i=0;i<s;i++)r[i]=t+e[i];else if(o.Z.isArray(t)&&o.Z.isArray(e))for(s=Math.min(t.length,e.length),i=0;i<s;i++)r[i]=t[i]+e[i];else r=t+e;return r},div:function(t,e){var i,s,r=[];if(t=o.Z.evalSlider(t),e=o.Z.evalSlider(e),o.Z.isArray(t)&&o.Z.isNumber(e))for(s=t.length,i=0;i<s;i++)r[i]=t[i]/e;else if(o.Z.isNumber(t)&&o.Z.isArray(e))for(s=e.length,i=0;i<s;i++)r[i]=t/e[i];else if(o.Z.isArray(t)&&o.Z.isArray(e))for(s=Math.min(t.length,e.length),i=0;i<s;i++)r[i]=t[i]/e[i];else r=t/e;return r},divide:function(){s.Z.deprecated("Statistics.divide()","Statistics.div()"),r.Z.Statistics.div.apply(r.Z.Statistics,arguments)},mod:function(t,e,i){var s,n,a=[],h=function(t,e){return t%e};if((i=o.Z.def(i,!1))&&(h=r.Z.mod),t=o.Z.evalSlider(t),e=o.Z.evalSlider(e),o.Z.isArray(t)&&o.Z.isNumber(e))for(n=t.length,s=0;s<n;s++)a[s]=h(t[s],e);else if(o.Z.isNumber(t)&&o.Z.isArray(e))for(n=e.length,s=0;s<n;s++)a[s]=h(t,e[s]);else if(o.Z.isArray(t)&&o.Z.isArray(e))for(n=Math.min(t.length,e.length),s=0;s<n;s++)a[s]=h(t[s],e[s]);else a=h(t,e);return a},multiply:function(t,e){var i,s,r=[];if(t=o.Z.evalSlider(t),e=o.Z.evalSlider(e),o.Z.isArray(t)&&o.Z.isNumber(e))for(s=t.length,i=0;i<s;i++)r[i]=t[i]*e;else if(o.Z.isNumber(t)&&o.Z.isArray(e))for(s=e.length,i=0;i<s;i++)r[i]=t*e[i];else if(o.Z.isArray(t)&&o.Z.isArray(e))for(s=Math.min(t.length,e.length),i=0;i<s;i++)r[i]=t[i]*e[i];else r=t*e;return r},subtract:function(t,e){var i,s,r=[];if(t=o.Z.evalSlider(t),e=o.Z.evalSlider(e),o.Z.isArray(t)&&o.Z.isNumber(e))for(s=t.length,i=0;i<s;i++)r[i]=t[i]-e;else if(o.Z.isNumber(t)&&o.Z.isArray(e))for(s=e.length,i=0;i<s;i++)r[i]=t-e[i];else if(o.Z.isArray(t)&&o.Z.isArray(e))for(s=Math.min(t.length,e.length),i=0;i<s;i++)r[i]=t[i]-e[i];else r=t-e;return r},TheilSenRegression:function(t){var e,i,s=[],o=[],n=[];for(e=0;e<t.length;e++){for(o.length=0,i=0;i<t.length;i++)Math.abs(t[i].usrCoords[1]-t[e].usrCoords[1])>r.Z.eps&&(o[i]=(t[i].usrCoords[2]-t[e].usrCoords[2])/(t[i].usrCoords[1]-t[e].usrCoords[1]));s[e]=this.median(o),n.push(t[e].usrCoords[2]-s[e]*t[e].usrCoords[1])}return[this.median(n),this.median(s),-1]},generateGaussian:function(t,e){var i,s,r;if(this.hasSpare)return this.hasSpare=!1,this.spare*e+t;do{r=(i=2*Math.random()-1)*i+(s=2*Math.random()-1)*s}while(r>=1||0===r);return r=Math.sqrt(-2*Math.log(r)/r),this.spare=s*r,this.hasSpare=!0,t+e*i*r}};const n=r.Z.Statistics},766:(t,e,i)=>{i.d(e,{Z:()=>h});var s=i(765),r=i(351),o=i(275),n=i(327),a=i(109);s.Z.Options={jc:{enabled:!0,compile:!0},board:{boundingBox:[-5,5,5,-5],maxBoundingBox:[-1/0,1/0,1/0,-1/0],zoomFactor:1,zoomX:1,zoomY:1,title:"",description:"",showCopyright:!0,axis:!1,defaultAxes:{x:{name:"x",fixed:!0,ticks:{label:{visible:"inherit",anchorX:"middle",anchorY:"top",fontSize:12,offset:[0,-3]},tickEndings:[0,1],majorTickEndings:[1,1],drawZero:!1,needsRegularUpdate:!1,visible:"inherit"}},y:{name:"y",fixed:!0,ticks:{label:{visible:"inherit",anchorX:"right",anchorY:"middle",fontSize:12,offset:[-6,0]},tickEndings:[1,0],majorTickEndings:[1,1],drawZero:!1,needsRegularUpdate:!1,visible:"inherit"}}},showNavigation:!0,showZoom:!0,showReload:!1,showScreenshot:!1,screenshot:{scale:1,type:"png",symbol:"⌘",css:"background-color:#eeeeee; opacity:1.0; border:2px solid black; border-radius:10px; text-align:center",cssButton:"padding: 4px 10px; border: solid #356AA0 1px; border-radius: 5px; position: absolute; right: 2ex; top: 2ex; background-color: rgba(255, 255, 255, 0.3);"},showFullscreen:!1,fullscreen:{symbol:'<svg height="1em" width="1em" version="1.1" viewBox="10 10 18 18"><path fill="#666" d="m 10,16 2,0 0,-4 4,0 0,-2 L 10,10 l 0,6 0,0 z"></path><path fill="#666" d="m 20,10 0,2 4,0 0,4 2,0 L 26,10 l -6,0 0,0 z"></path><path fill="#666" d="m 24,24 -4,0 0,2 L 26,26 l 0,-6 -2,0 0,4 0,0 z"></path><path fill="#666" d="M 12,20 10,20 10,26 l 6,0 0,-2 -4,0 0,-4 0,0 z"></path></svg>',scale:.85,id:null},showClearTraces:!1,keepAspectRatio:!1,ignoreLabels:!0,maxNameLength:1,document:!1,takeFirst:!1,takeSizeFromFile:!1,renderer:"auto",animationDelay:35,maxFrameRate:40,registerEvents:!0,minimizeReflow:"none",offsetX:0,offsetY:0,zoom:{enabled:!0,factorX:1.25,factorY:1.25,wheel:!0,needShift:!0,min:1e-4,max:1e4,pinchHorizontal:!0,pinchVertical:!0,pinchSensitivity:7},pan:{enabled:!0,needShift:!0,needTwoFingers:!1},browserPan:!1,drag:{enabled:!0},keyboard:{enabled:!0,dx:10,dy:10,panShift:!0,panCtrl:!1},resize:{enabled:!0,throttle:10},moveTarget:null,selection:{enabled:!1,name:"selectionPolygon",needShift:!1,needCtrl:!0,withLines:!1,vertices:{visible:!1},fillColor:"#ffff00",visible:!1},showInfobox:!0,logging:{enabled:!1}},navbar:{strokeColor:"#333333",fillColor:"transparent",highlightFillColor:"#aaaaaa",padding:"2px",position:"absolute",fontSize:"14px",cursor:"pointer",zIndex:"100",right:"5px",bottom:"5px"},elements:{strokeColor:n.Z.palette.blue,highlightStrokeColor:"#c3d9ff",fillColor:n.Z.palette.red,highlightFillColor:"none",strokeOpacity:1,highlightStrokeOpacity:1,fillOpacity:1,highlightFillOpacity:1,gradient:null,gradientSecondColor:"#ffffff",gradientSecondOpacity:1,gradientStartOffset:0,gradientEndOffset:1,gradientAngle:0,gradientCX:.5,gradientCY:.5,gradientR:.5,gradientFX:.5,gradientFY:.5,gradientFR:0,transitionDuration:100,transitionProperties:["fill","fill-opacity","stroke","stroke-opacity","stroke-width"],strokeWidth:2,highlightStrokeWidth:2,fixed:!1,frozen:!1,withLabel:!1,visible:!0,priv:!1,layer:0,dash:0,shadow:{enabled:!1,color:[0,0,0],opacity:1,blur:3,blend:.1,offset:[5,5]},trace:!1,traceAttributes:{},highlight:!0,needsRegularUpdate:!0,snapToGrid:!1,scalable:!0,rotatable:!0,dragToTopOfLayer:!1,precision:"inherit",draft:{draft:!1,strokeColor:"#565656",fillColor:"#565656",strokeOpacity:.8,fillOpacity:.8,strokeWidth:1},isLabel:!1,tabindex:0},ticks:{generateLabelText:null,generateLabelValue:null,drawLabels:!1,label:{},beautifulScientificTickLabels:!1,useUnicodeMinus:!0,anchor:"left",drawZero:!1,insertTicks:!1,minTicksDistance:10,minorHeight:4,majorHeight:10,tickEndings:[1,1],majorTickEndings:[1,1],ignoreInfiniteTickEndings:!0,minorTicks:4,ticksPerLabel:!1,scale:1,scaleSymbol:"",labels:[],maxLabelLength:5,precision:3,digits:3,ticksDistance:1,face:"|",strokeOpacity:1,strokeWidth:1,strokeColor:"#000000",highlightStrokeColor:"#888888",fillColor:"none",highlightFillColor:"none",visible:"inherit",includeBoundaries:!1,type:"linear"},hatch:{drawLabels:!1,drawZero:!0,majorHeight:20,anchor:"middle",face:"|",strokeWidth:2,strokeColor:n.Z.palette.blue,ticksDistance:.2},precision:{touch:30,touchMax:100,mouse:4,pen:4,epsilon:1e-4,hasPoint:4},layer:{numlayers:20,unused9:19,unused8:18,unused7:17,unused6:16,unused5:15,unused4:14,unused3:13,unused2:12,unused1:11,unused0:10,text:9,point:9,glider:9,arc:8,line:7,circle:6,curve:5,turtle:5,polygon:3,sector:3,angle:3,integral:3,axis:2,ticks:2,grid:1,image:0,trace:0},angle:{withLabel:!0,radius:"auto",type:"sector",orthoType:"square",orthoSensitivity:1,fillColor:n.Z.palette.orange,highlightFillColor:n.Z.palette.orange,strokeColor:n.Z.palette.orange,fillOpacity:.3,highlightFillOpacity:.3,radiuspoint:{withLabel:!1,visible:!1,name:""},pointsquare:{withLabel:!1,visible:!1,name:""},dot:{visible:!1,strokeColor:"none",fillColor:"#000000",size:2,face:"o",withLabel:!1,name:""},label:{position:"top",offset:[0,0],strokeColor:n.Z.palette.blue},arc:{visible:!1,fillColor:"none"}},arc:{selection:"auto",hasInnerPoints:!1,label:{anchorX:"auto",anchorY:"auto"},firstArrow:!1,lastArrow:!1,fillColor:"none",highlightFillColor:"none",strokeColor:n.Z.palette.blue,highlightStrokeColor:"#c3d9ff",useDirection:!1,center:{},radiusPoint:{},anglePoint:{}},arrow:{firstArrow:!1,lastArrow:{type:1,highlightSize:6,size:6}},axis:{name:"",needsRegularUpdate:!1,strokeWidth:1,lastArrow:{type:1,highlightSize:8,size:8},strokeColor:"#666666",highlightStrokeWidth:1,highlightStrokeColor:"#888888",withTicks:!0,straightFirst:!0,straightLast:!0,margin:-4,withLabel:!1,scalable:!1,ticks:{label:{offset:[4,-9],parse:!1,needsRegularUpdate:!1,display:"internal",visible:"inherit",layer:9},visible:"inherit",needsRegularUpdate:!1,strokeWidth:1,strokeColor:"#666666",highlightStrokeColor:"#888888",drawLabels:!0,drawZero:!1,insertTicks:!0,minTicksDistance:5,minorHeight:10,majorHeight:-1,tickEndings:[0,1],majorTickEndings:[1,1],minorTicks:4,ticksDistance:1,strokeOpacity:.25},point1:{needsRegularUpdate:!1,visible:!1},point2:{needsRegularUpdate:!1,visible:!1},tabindex:-1,label:{position:"lft",offset:[10,10]}},bisector:{strokeColor:"#000000",point:{visible:!1,fixed:!1,withLabel:!1,name:""}},bisectorlines:{line1:{strokeColor:"#000000"},line2:{strokeColor:"#000000"}},boxplot:{dir:"vertical",smallWidth:.5,strokeWidth:2,strokeColor:n.Z.palette.blue,fillColor:n.Z.palette.blue,fillOpacity:.2,highlightStrokeWidth:2,highlightStrokeColor:n.Z.palette.blue,highlightFillColor:n.Z.palette.blue,highlightFillOpacity:.1},button:{disabled:!1,display:"html"},cardinalspline:{createPoints:!0,isArrayOfCoordinates:!1,points:{strokeOpacity:.05,fillOpacity:.05,highlightStrokeOpacity:1,highlightFillOpacity:1,withLabel:!1,name:"",fixed:!1}},chart:{chartStyle:"line",colors:["#B02B2C","#3F4C6B","#C79810","#D15600","#FFFF88","#c3d9ff","#4096EE","#008C00"],highlightcolors:null,fillcolor:null,highlightonsector:!1,highlightbysize:!1,fillOpacity:.6,withLines:!1,label:{}},checkbox:{disabled:!1,checked:!1,display:"html"},circle:{hasInnerPoints:!1,fillColor:"none",highlightFillColor:"none",strokeColor:n.Z.palette.blue,highlightStrokeColor:"#c3d9ff",center:{visible:!1,withLabel:!1,fixed:!1,fillColor:n.Z.palette.red,strokeColor:n.Z.palette.red,highlightFillColor:"#c3d9ff",highlightStrokeColor:"#c3d9ff",name:""},point2:{visible:!1,withLabel:!1,fixed:!1,name:""},label:{position:"urt"}},circumcircle:{fillColor:"none",highlightFillColor:"none",strokeColor:n.Z.palette.blue,highlightStrokeColor:"#c3d9ff",center:{visible:!1,fixed:!1,withLabel:!1,fillColor:n.Z.palette.red,strokeColor:n.Z.palette.red,highlightFillColor:"#c3d9ff",highlightStrokeColor:"#c3d9ff",name:""}},circumcirclearc:{fillColor:"none",highlightFillColor:"none",strokeColor:n.Z.palette.blue,highlightStrokeColor:"#c3d9ff",center:{visible:!1,withLabel:!1,fixed:!1,name:""}},circumcirclesector:{useDirection:!0,fillColor:n.Z.palette.yellow,highlightFillColor:n.Z.palette.yellow,fillOpacity:.3,highlightFillOpacity:.3,strokeColor:n.Z.palette.blue,highlightStrokeColor:"#c3d9ff",point:{visible:!1,fixed:!1,withLabel:!1,name:""}},conic:{fillColor:"none",highlightFillColor:"none",strokeColor:n.Z.palette.blue,highlightStrokeColor:"#c3d9ff",foci:{fixed:!1,visible:!1,withLabel:!1,name:""},center:{visible:!1,withLabel:!1,name:""},point:{withLabel:!1,name:""},line:{visible:!1}},curve:{strokeWidth:1,strokeColor:n.Z.palette.blue,fillColor:"none",fixed:!0,useQDT:!1,handDrawing:!1,curveType:null,RDPsmoothing:!1,numberPointsHigh:1600,numberPointsLow:400,doAdvancedPlot:!0,recursionDepthHigh:17,recursionDepthLow:15,doAdvancedPlotOld:!1,plotVersion:2,label:{position:"lft"},firstArrow:!1,lastArrow:!1},foreignobject:{attractors:[],fixed:!0,visible:!0},glider:{label:{}},grid:{needsRegularUpdate:!1,hasGrid:!1,gridX:1,gridY:1,strokeColor:"#c0c0c0",strokeOpacity:.5,strokeWidth:1,dash:0,snapToGrid:!1,snapSizeX:10,snapSizeY:10},group:{needsRegularUpdate:!0},htmlslider:{widthRange:100,widthOut:34,step:.01,frozen:!0,isLabel:!1,strokeColor:"#000000",display:"html",anchorX:"left",anchorY:"middle",withLabel:!1},image:{imageString:null,fillOpacity:1,highlightFillOpacity:.6,cssClass:"JXGimage",highlightCssClass:"JXGimageHighlight",rotate:0,snapSizeX:1,snapSizeY:1,attractors:[]},incircle:{fillColor:"none",highlightFillColor:"none",strokeColor:n.Z.palette.blue,highlightStrokeColor:"#c3d9ff",center:{visible:!1,fixed:!1,withLabel:!1,fillColor:n.Z.palette.red,strokeColor:n.Z.palette.red,highlightFillColor:"#c3d9ff",highlightStrokeColor:"#c3d9ff",name:""}},inequality:{fillColor:n.Z.palette.red,fillOpacity:.2,strokeColor:"none",inverse:!1},infobox:{distanceX:-20,distanceY:25,fontSize:12,isLabel:!1,strokeColor:"#bbbbbb",display:"html",anchorX:"left",anchorY:"middle",cssClass:"JXGinfobox",rotate:0,visible:!0,parse:!1,transitionDuration:0,needsRegularUpdate:!1},integral:{axis:"x",withLabel:!0,fixed:!0,strokeWidth:0,strokeOpacity:0,fillColor:n.Z.palette.red,fillOpacity:.3,highlightFillColor:n.Z.palette.red,highlightFillOpacity:.2,curveLeft:{visible:!0,withLabel:!1,color:n.Z.palette.red,fillOpacity:.8,layer:9},baseLeft:{visible:!1,fixed:!1,withLabel:!1,name:""},curveRight:{visible:!0,withLabel:!1,color:n.Z.palette.red,fillOpacity:.8,layer:9},baseRight:{visible:!1,fixed:!1,withLabel:!1,name:""},label:{fontSize:20}},input:{disabled:!1,maxlength:524288,display:"html"},intersection:{alwaysIntersect:!0},label:{visible:"inherit",strokeColor:"#000000",strokeOpacity:1,highlightStrokeOpacity:.666666,highlightStrokeColor:"#000000",fixed:!0,position:"urt",offset:[10,10],autoPosition:!1},legend:{style:"vertical",labels:["1","2","3","4","5","6","7","8"],colors:["#B02B2C","#3F4C6B","#C79810","#D15600","#FFFF88","#c3d9ff","#4096EE","#008C00"],rowHeight:20,strokeWidth:5},line:{firstArrow:!1,lastArrow:!1,margin:0,straightFirst:!0,straightLast:!0,fillColor:"none",highlightFillColor:"none",strokeColor:n.Z.palette.blue,highlightStrokeColor:"#c3d9ff",withTicks:!1,point1:{visible:!1,withLabel:!1,fixed:!1,name:""},point2:{visible:!1,withLabel:!1,fixed:!1,name:""},ticks:{drawLabels:!0,label:{offset:[4,-9]},drawZero:!1,insertTicks:!1,minTicksDistance:50,minorHeight:4,majorHeight:-1,minorTicks:4,defaultDistance:1,strokeOpacity:.3,visible:"inherit"},label:{position:"llft"},snapToGrid:!1,snapSizeX:1,snapSizeY:1,touchFirstPoint:!1,touchLastPoint:!1,lineCap:"butt"},locus:{translateToOrigin:!1,translateTo10:!1,stretch:!1,toOrigin:null,to10:null},metapostspline:{createPoints:!0,isArrayOfCoordinates:!1,points:{strokeOpacity:.05,fillOpacity:.05,highlightStrokeOpacity:1,highlightFillOpacity:1,withLabel:!1,name:"",fixed:!1}},mirrorelement:{fixed:!0,point:{},center:{},type:"Euclidean"},normal:{strokeColor:"#000000",point:{visible:!1,fixed:!1,withLabel:!1,name:""}},orthogonalprojection:{},parallel:{strokeColor:"#000000",point:{visible:!1,fixed:!1,withLabel:!1,name:""},label:{position:"llft"}},perpendicular:{strokeColor:"#000000",straightFirst:!0,straightLast:!0},perpendicularsegment:{strokeColor:"#000000",straightFirst:!1,straightLast:!1,point:{visible:!1,fixed:!0,withLabel:!1,name:""}},point:{withLabel:!0,label:{},style:5,face:"o",size:3,sizeUnit:"screen",strokeWidth:2,transitionProperties:["fill","fill-opacity","stroke","stroke-opacity","stroke-width","width","height","rx","ry"],fillColor:n.Z.palette.red,strokeColor:n.Z.palette.red,highlightFillColor:"#c3d9ff",highlightStrokeColor:"#c3d9ff",zoom:!1,showInfobox:"inherit",infoboxDigits:"auto",draft:!1,attractors:[],attractorUnit:"user",attractorDistance:0,snatchDistance:0,snapToGrid:!1,attractToGrid:!1,snapSizeX:1,snapSizeY:1,snapToPoints:!1,ignoredSnapToPoints:[]},polygon:{hasInnerPoints:!1,fillColor:n.Z.palette.yellow,highlightFillColor:n.Z.palette.yellow,fillOpacity:.3,highlightFillOpacity:.2,withLines:!0,borders:{withLabel:!1,strokeWidth:1,highlightStrokeWidth:1,layer:5,label:{position:"top"},visible:"inherit"},vertices:{layer:9,withLabel:!1,name:"",strokeColor:n.Z.palette.red,fillColor:n.Z.palette.red,fixed:!1,visible:"inherit"},label:{offset:[0,0]}},polygonalchain:{fillColor:"none",highlightFillColor:"none"},prescribedangle:{anglePoint:{size:2,visible:!1,withLabel:!1}},reflection:{fixed:!0,center:{},type:"Euclidean"},regularpolygon:{hasInnerPoints:!1,fillColor:n.Z.palette.yellow,highlightFillColor:n.Z.palette.yellow,fillOpacity:.3,highlightFillOpacity:.2,withLines:!0,borders:{withLabel:!1,strokeWidth:1,highlightStrokeWidth:1,layer:5,label:{position:"top"}},vertices:{layer:9,withLabel:!0,strokeColor:n.Z.palette.red,fillColor:n.Z.palette.red,fixed:!1},label:{offset:[0,0]}},riemannsum:{withLabel:!1,fillOpacity:.3,fillColor:n.Z.palette.yellow},sector:{fillColor:n.Z.palette.yellow,highlightFillColor:n.Z.palette.yellow,fillOpacity:.3,highlightFillOpacity:.3,highlightOnSector:!1,highlightStrokeWidth:0,selection:"auto",arc:{visible:!1,fillColor:"none"},radiusPoint:{visible:!1,withLabel:!1},center:{visible:!1,withLabel:!1},anglePoint:{visible:!1,withLabel:!1},label:{offset:[0,0],anchorX:"auto",anchorY:"auto"}},segment:{label:{position:"top"}},semicircle:{center:{visible:!1,withLabel:!1,fixed:!1,fillColor:n.Z.palette.red,strokeColor:n.Z.palette.red,highlightFillColor:"#eeeeee",highlightStrokeColor:n.Z.palette.red,name:""}},slider:{snapWidth:-1,precision:2,digits:2,firstArrow:!1,lastArrow:!1,withTicks:!0,withLabel:!0,suffixLabel:null,unitLabel:null,postLabel:null,layer:9,showInfobox:!1,name:"",visible:!0,strokeColor:"#000000",highlightStrokeColor:"#888888",fillColor:"#ffffff",highlightFillColor:"none",size:6,point1:{needsRegularUpdate:!1,showInfobox:!1,withLabel:!1,visible:!1,fixed:!0,name:""},point2:{needsRegularUpdate:!1,showInfobox:!1,withLabel:!1,visible:!1,fixed:!0,name:""},baseline:{needsRegularUpdate:!1,visible:"inherit",fixed:!0,scalable:!1,tabindex:null,name:"",strokeWidth:1,strokeColor:"#000000",highlightStrokeColor:"#888888"},ticks:{needsRegularUpdate:!1,fixed:!0,drawLabels:!1,digits:2,includeBoundaries:1,drawZero:!0,label:{offset:[-4,-14],display:"internal"},minTicksDistance:30,insertTicks:!0,minorHeight:4,majorHeight:5,minorTicks:0,defaultDistance:1,strokeOpacity:1,strokeWidth:1,tickEndings:[0,1],majortickEndings:[0,1],strokeColor:"#000000",visible:"inherit"},highline:{strokeWidth:3,visible:"inherit",fixed:!0,tabindex:null,name:"",strokeColor:"#000000",highlightStrokeColor:"#888888"},label:{visible:"inherit",strokeColor:"#000000"},moveOnUp:!0},comb:{frequency:.2,width:.4,angle:Math.PI/3,reverse:!1,point1:{visible:!1,withLabel:!1,fixed:!1,name:""},point2:{visible:!1,withLabel:!1,fixed:!1,name:""},curve:{strokeWidth:1,strokeColor:"#000000",fillColor:"none"}},slopetriangle:{fillColor:n.Z.palette.red,fillOpacity:.4,highlightFillColor:n.Z.palette.red,highlightFillOpacity:.3,borders:{lastArrow:{type:1,size:6}},glider:{fixed:!0,visible:!1,withLabel:!1},baseline:{visible:!1,withLabel:!1,name:""},basepoint:{visible:!1,withLabel:!1,name:""},tangent:{visible:!1,withLabel:!1,name:""},toppoint:{visible:!1,withLabel:!1,name:""},label:{visible:!0}},stepfunction:{},tapemeasure:{strokeColor:"#000000",strokeWidth:2,highlightStrokeColor:"#000000",withTicks:!0,withLabel:!0,precision:2,digits:2,point1:{visible:"inherit",strokeColor:"#000000",fillColor:"#ffffff",fillOpacity:0,highlightFillOpacity:.1,size:6,snapToPoints:!0,attractorUnit:"screen",attractorDistance:20,showInfobox:!1,withLabel:!1,name:""},point2:{visible:"inherit",strokeColor:"#000000",fillColor:"#ffffff",fillOpacity:0,highlightFillOpacity:.1,size:6,snapToPoints:!0,attractorUnit:"screen",attractorDistance:20,showInfobox:!1,withLabel:!1,name:""},ticks:{drawLabels:!1,drawZero:!0,insertTicks:!0,minorHeight:8,majorHeight:16,minorTicks:4,tickEndings:[0,1],majorTickEndings:[0,1],defaultDistance:.1,strokeOpacity:1,strokeWidth:1,strokeColor:"#000000",visible:"inherit"},label:{position:"top"}},text:{fontSize:12,fontUnit:"px",digits:2,parse:!0,useCaja:!1,isLabel:!1,strokeColor:"#000000",highlightStrokeColor:"#000000",highlightStrokeOpacity:.666666,cssDefaultStyle:"font-family: Arial, Helvetica, Geneva, sans-serif;",highlightCssDefaultStyle:"font-family: Arial, Helvetica, Geneva, sans-serif;",cssStyle:"",highlightCssStyle:"",transitionProperties:["color","opacity"],useASCIIMathML:!1,useMathJax:!1,useKatex:!1,display:"html",anchor:null,anchorX:"left",anchorY:"middle",cssClass:"JXGtext",highlightCssClass:"JXGtext",dragArea:"all",withLabel:!1,rotate:0,visible:!0,snapSizeX:1,snapSizeY:1,attractors:[]},tracecurve:{strokeColor:"#000000",fillColor:"none",numberPoints:100},turtle:{strokeWidth:1,fillColor:"none",strokeColor:"#000000",arrow:{strokeWidth:2,withLabel:!1,strokeColor:n.Z.palette.red,lastArrow:!0}},shortcuts:{color:["strokeColor","fillColor"],opacity:["strokeOpacity","fillOpacity"],highlightColor:["highlightStrokeColor","highlightFillColor"],highlightOpacity:["highlightStrokeOpacity","highlightFillOpacity"],strokeWidth:["strokeWidth","highlightStrokeWidth"]}},s.Z.Validator=function(){var t,e=function(t){return a.Z.isString(t)},i=function(t){return Math.abs(t-Math.round(t))<o.Z.eps},r=function(t){return i(t)&&t>0},n=function(t){return t>0},h=function(t){return t>=0},l={},c={attractorDistance:h,color:e,defaultDistance:a.Z.isNumber,display:function(t){return"html"===t||"internal"===t},doAdvancedPlot:!1,draft:!1,drawLabels:!1,drawZero:!1,face:function(t){return a.Z.exists(s.Z.normalizePointFace(t))},factor:a.Z.isNumber,fillColor:e,fillOpacity:a.Z.isNumber,firstArrow:!1,fontSize:i,dash:i,gridX:a.Z.isNumber,gridY:a.Z.isNumber,hasGrid:!1,highlightFillColor:e,highlightFillOpacity:a.Z.isNumber,highlightStrokeColor:e,highlightStrokeOpacity:a.Z.isNumber,insertTicks:!1,lastArrow:!1,layer:function(t){return i(t)&&t>=0},majorHeight:i,minorHeight:i,minorTicks:h,minTicksDistance:r,numberPointsHigh:r,numberPointsLow:r,opacity:a.Z.isNumber,radius:a.Z.isNumber,RDPsmoothing:!1,renderer:function(t){return"vml"===t||"svg"===t||"canvas"===t||"no"===t},right:function(t){return/^[0-9]+px$/.test(t)},showCopyright:!1,showInfobox:!1,showNavigation:!1,size:h,snapSizeX:n,snapSizeY:n,snapWidth:a.Z.isNumber,snapToGrid:!1,snatchDistance:h,straightFirst:!1,straightLast:!1,stretch:!1,strokeColor:e,strokeOpacity:a.Z.isNumber,strokeWidth:h,takeFirst:!1,takeSizeFromFile:!1,to10:!1,toOrigin:!1,translateTo10:!1,translateToOrigin:!1,useASCIIMathML:!1,useDirection:!1,useMathJax:!1,withLabel:!1,withTicks:!1,zoom:!1};for(t in c)c.hasOwnProperty(t)&&(l[t.toLowerCase()]=c[t]);return l}(),s.Z.normalizePointFace=function(t){return{cross:"x",x:"x",circle:"o",o:"o",square:"[]","[]":"[]",plus:"+","+":"+",divide:"|","|":"|",minus:"-","-":"-",diamond:"<>","<>":"<>",triangleup:"^",a:"^","^":"^",triangledown:"v",v:"v",triangleleft:"<","<":"<",triangleright:">",">":">"}[t]},s.Z.useStandardOptions=function(t){var e,i,o,n,a=s.Z.Options,h=t.hasGrid;for(e in t.options.grid.hasGrid=a.grid.hasGrid,t.options.grid.gridX=a.grid.gridX,t.options.grid.gridY=a.grid.gridY,t.options.grid.gridColor=a.grid.gridColor,t.options.grid.gridOpacity=a.grid.gridOpacity,t.options.grid.gridDash=a.grid.gridDash,t.options.grid.snapToGrid=a.grid.snapToGrid,t.options.grid.snapSizeX=a.grid.SnapSizeX,t.options.grid.snapSizeY=a.grid.SnapSizeY,t.takeSizeFromFile=a.takeSizeFromFile,n=function(t,e){t.visProp.fillcolor=e.fillColor,t.visProp.highlightfillcolor=e.highlightFillColor,t.visProp.strokecolor=e.strokeColor,t.visProp.highlightstrokecolor=e.highlightStrokeColor},t.objects)if(t.objects.hasOwnProperty(e))if((o=t.objects[e]).elementClass===r.Z.OBJECT_CLASS_POINT)n(o,a.point);else if(o.elementClass===r.Z.OBJECT_CLASS_LINE)for(n(o,a.line),i=0;i<o.ticks.length;i++)o.ticks[i].majorTicks=a.line.ticks.majorTicks,o.ticks[i].minTicksDistance=a.line.ticks.minTicksDistance,o.ticks[i].visProp.minorheight=a.line.ticks.minorHeight,o.ticks[i].visProp.majorheight=a.line.ticks.majorHeight;else o.elementClass===r.Z.OBJECT_CLASS_CIRCLE?n(o,a.circle):o.type===r.Z.OBJECT_TYPE_ANGLE?n(o,a.angle):o.type===r.Z.OBJECT_TYPE_ARC?n(o,a.arc):o.type===r.Z.OBJECT_TYPE_POLYGON?n(o,a.polygon):o.type===r.Z.OBJECT_TYPE_CONIC?n(o,a.conic):o.type===r.Z.OBJECT_TYPE_CURVE?n(o,a.curve):o.type===r.Z.OBJECT_TYPE_SECTOR&&(o.arc.visProp.fillcolor=a.sector.fillColor,o.arc.visProp.highlightfillcolor=a.sector.highlightFillColor,o.arc.visProp.fillopacity=a.sector.fillOpacity,o.arc.visProp.highlightfillopacity=a.sector.highlightFillOpacity);t.fullUpdate(),h&&!t.hasGrid?t.removeGrids(t):!h&&t.hasGrid&&t.create("grid",[])},s.Z.useBlackWhiteOptions=function(t){var e=s.Z.Options;e.point.fillColor=n.Z.rgb2bw(e.point.fillColor),e.point.highlightFillColor=n.Z.rgb2bw(e.point.highlightFillColor),e.point.strokeColor=n.Z.rgb2bw(e.point.strokeColor),e.point.highlightStrokeColor=n.Z.rgb2bw(e.point.highlightStrokeColor),e.line.fillColor=n.Z.rgb2bw(e.line.fillColor),e.line.highlightFillColor=n.Z.rgb2bw(e.line.highlightFillColor),e.line.strokeColor=n.Z.rgb2bw(e.line.strokeColor),e.line.highlightStrokeColor=n.Z.rgb2bw(e.line.highlightStrokeColor),e.circle.fillColor=n.Z.rgb2bw(e.circle.fillColor),e.circle.highlightFillColor=n.Z.rgb2bw(e.circle.highlightFillColor),e.circle.strokeColor=n.Z.rgb2bw(e.circle.strokeColor),e.circle.highlightStrokeColor=n.Z.rgb2bw(e.circle.highlightStrokeColor),e.arc.fillColor=n.Z.rgb2bw(e.arc.fillColor),e.arc.highlightFillColor=n.Z.rgb2bw(e.arc.highlightFillColor),e.arc.strokeColor=n.Z.rgb2bw(e.arc.strokeColor),e.arc.highlightStrokeColor=n.Z.rgb2bw(e.arc.highlightStrokeColor),e.polygon.fillColor=n.Z.rgb2bw(e.polygon.fillColor),e.polygon.highlightFillColor=n.Z.rgb2bw(e.polygon.highlightFillColor),e.sector.fillColor=n.Z.rgb2bw(e.sector.fillColor),e.sector.highlightFillColor=n.Z.rgb2bw(e.sector.highlightFillColor),e.curve.strokeColor=n.Z.rgb2bw(e.curve.strokeColor),e.grid.gridColor=n.Z.rgb2bw(e.grid.gridColor),s.Z.useStandardOptions(t)},s.Z.Options.normalizePointFace=s.Z.normalizePointFace;const h=s.Z.Options},632:(t,e,i)=>{i.d(e,{Z:()=>n});var s=i(765),r=i(351),o=i(109);s.Z.GeonextParser={replacePow:function(t){var e,i,s,r,o,n,a,h,l,c,d,u;for(c=(t=t.replace(/(\s*)\^(\s*)/g,"^")).indexOf("^"),r=-1;c>=0&&c<t.length-1;){if(r===c)throw new Error("JSXGraph: Error while parsing expression '"+t+"'");if(r=c,l=t.slice(0,c),d=t.slice(c+1),")"===l.charAt(l.length-1)){for(e=1,i=l.length-2;i>=0&&e>0;)")"===(s=l.charAt(i))?e++:"("===s&&(e-=1),i-=1;if(0!==e)throw new Error("JSXGraph: Missing '(' in expression");for(o="",a=l.substring(0,i+1),h=i;h>=0&&a.substr(h,1).match(/([\w.]+)/);)o=RegExp.$1+o,h-=1;o=(o+=l.substring(i+1,l.length)).replace(/([()+*%^\-/\][])/g,"\\$1")}else o="[\\w\\.]+";if(d.match(/^([\w.]*\()/)){for(e=1,i=RegExp.$1.length;i<d.length&&e>0;)")"===(s=d.charAt(i))?e-=1:"("===s&&(e+=1),i+=1;if(0!==e)throw new Error("JSXGraph: Missing ')' in expression");n=(n=d.substring(0,i)).replace(/([()+*%^\-/[\]])/g,"\\$1")}else n="[\\w\\.]+";u=new RegExp("("+o+")\\^("+n+")"),c=(t=t.replace(u,"pow($1,$2)")).indexOf("^")}return t},replaceIf:function(t){var e,i,s,r,o,n,a,h,l,c="",d=null,u=null,p=null;if((s=t.indexOf("If("))<0)return t;for(t=t.replace(/""/g,"0");s>=0;){for(e=t.slice(0,s),i=t.slice(s+3),o=1,r=0,n=-1,a=-1;r<i.length&&o>0;)")"===(h=i.charAt(r))?o-=1:"("===h?o+=1:","===h&&1===o&&(n<0?n=r:a=r),r+=1;if(l=i.slice(0,r-1),i=i.slice(r),n<0)return"";if(a<0)return"";d=l.slice(0,n),u=l.slice(n+1,a),p=l.slice(a+1),c+=e+"(("+(d=this.replaceIf(d))+")?("+(u=this.replaceIf(u))+"):("+(p=this.replaceIf(p))+"))",d=null,u=null,s=(t=i).indexOf("If(")}return c+=i},replaceNameById:function(t,e,i){var s,r,o,n,a=0,h=["X","Y","L","V"],l=function(t){return i?"$('"+t+"')":t};for(n=0;n<h.length;n++)for(a=t.indexOf(h[n]+"(");a>=0;)a>=0&&(s=t.indexOf(")",a+2))>=0&&(r=(r=t.slice(a+2,s)).replace(/\\(['"])?/g,"$1"),(o=e.elementsByName[r])&&(t=t.slice(0,a+2)+(i?"$('":"")+l(o.id)+t.slice(s))),s=t.indexOf(")",a+2),a=t.indexOf(h[n]+"(",s);for(a=t.indexOf("Dist(");a>=0;)a>=0&&(s=t.indexOf(",",a+5))>=0&&(r=(r=t.slice(a+5,s)).replace(/\\(['"])?/g,"$1"),(o=e.elementsByName[r])&&(t=t.slice(0,a+5)+l(o.id)+t.slice(s))),s=t.indexOf(",",a+5),a=t.indexOf(",",s),(s=t.indexOf(")",a+1))>=0&&(r=(r=t.slice(a+1,s)).replace(/\\(['"])?/g,"$1"),(o=e.elementsByName[r])&&(t=t.slice(0,a+1)+l(o.id)+t.slice(s))),s=t.indexOf(")",a+1),a=t.indexOf("Dist(",s);for(h=["Deg","Rad"],n=0;n<h.length;n++)for(a=t.indexOf(h[n]+"(");a>=0;)a>=0&&(s=t.indexOf(",",a+4))>=0&&(r=(r=t.slice(a+4,s)).replace(/\\(['"])?/g,"$1"),(o=e.elementsByName[r])&&(t=t.slice(0,a+4)+l(o.id)+t.slice(s))),s=t.indexOf(",",a+4),a=t.indexOf(",",s),(s=t.indexOf(",",a+1))>=0&&(r=(r=t.slice(a+1,s)).replace(/\\(['"])?/g,"$1"),(o=e.elementsByName[r])&&(t=t.slice(0,a+1)+l(o.id)+t.slice(s))),s=t.indexOf(",",a+1),a=t.indexOf(",",s),(s=t.indexOf(")",a+1))>=0&&(r=(r=t.slice(a+1,s)).replace(/\\(['"])?/g,"$1"),(o=e.elementsByName[r])&&(t=t.slice(0,a+1)+l(o.id)+t.slice(s))),s=t.indexOf(")",a+1),a=t.indexOf(h[n]+"(",s);return t},replaceIdByObj:function(t){var e=/(X|Y|L)\(([\w_]+)\)/g;return t=t.replace(e,"$('$2').$1()"),e=/(V)\(([\w_]+)\)/g,t=t.replace(e,"$('$2').Value()"),e=/(Dist)\(([\w_]+),([\w_]+)\)/g,t=t.replace(e,"dist($('$2'), $('$3'))"),e=/(Deg)\(([\w_]+),([ \w[\w_]+),([\w_]+)\)/g,t=t.replace(e,"deg($('$2'),$('$3'),$('$4'))"),e=/Rad\(([\w_]+),([\w_]+),([\w_]+)\)/g,t=t.replace(e,"rad($('$1'),$('$2'),$('$3'))"),e=/N\((.+)\)/g,t=t.replace(e,"($1)")},geonext2JS:function(t,e){var i,s,r,o=["Abs","ACos","ASin","ATan","Ceil","Cos","Exp","Factorial","Floor","Log","Max","Min","Random","Round","Sin","Sqrt","Tan","Trunc"],n=["abs","acos","asin","atan","ceil","cos","exp","factorial","floor","log","max","min","random","round","sin","sqrt","tan","ceil"];for(s=t=(t=(t=t.replace(/&lt;/g,"<")).replace(/&gt;/g,">")).replace(/&amp;/g,"&"),s=this.replaceNameById(s,e),s=this.replaceIf(s),s=this.replacePow(s),s=this.replaceIdByObj(s),r=0;r<o.length;r++)i=new RegExp(["(\\W|^)(",o[r],")"].join(""),"ig"),s=s.replace(i,["$1",n[r]].join(""));return s=(s=(s=(s=(s=s.replace(/True/g,"true")).replace(/False/g,"false")).replace(/fasle/g,"false")).replace(/Pi/g,"PI")).replace(/"/g,"'")},findDependencies:function(t,e,i){var s,n,a,h;for(n in o.Z.exists(i)||(i=t.board),s=i.elementsByName)s.hasOwnProperty(n)&&n!==t.name&&(s[n].elementClass===r.Z.OBJECT_CLASS_TEXT&&o.Z.evaluate(s[n].visProp.islabel)||(h=(h=n.replace(/\[/g,"\\[")).replace(/\]/g,"\\]"),a=new RegExp("\\(([\\w\\[\\]'_ ]+,)*("+h+")(,[\\w\\[\\]'_ ]+)*\\)","g"),e.search(a)>=0&&s[n].addChild(t)))},gxt2jc:function(t,e){var i;return i=t=(t=(t=t.replace(/&lt;/g,"<")).replace(/&gt;/g,">")).replace(/&amp;/g,"&"),i=(i=(i=(i=this.replaceNameById(i,e,!0)).replace(/True/g,"true")).replace(/False/g,"false")).replace(/fasle/g,"false")}};const n=s.Z.GeonextParser},254:(__unused_webpack_module,__webpack_exports__,__webpack_require__)=>{__webpack_require__.d(__webpack_exports__,{Z:()=>__WEBPACK_DEFAULT_EXPORT__});var _jxg__WEBPACK_IMPORTED_MODULE_0__=__webpack_require__(765),_base_constants__WEBPACK_IMPORTED_MODULE_1__=__webpack_require__(351),_base_text__WEBPACK_IMPORTED_MODULE_2__=__webpack_require__(573),_math_math__WEBPACK_IMPORTED_MODULE_3__=__webpack_require__(275),_math_ia__WEBPACK_IMPORTED_MODULE_4__=__webpack_require__(785),_math_geometry__WEBPACK_IMPORTED_MODULE_5__=__webpack_require__(922),_math_statistics__WEBPACK_IMPORTED_MODULE_6__=__webpack_require__(309),_utils_type__WEBPACK_IMPORTED_MODULE_7__=__webpack_require__(109),_utils_env__WEBPACK_IMPORTED_MODULE_8__=__webpack_require__(503);Object.create||(Object.create=function(t,e){if("object"!=typeof t&&"function"!=typeof t)throw new TypeError("Object prototype may only be an Object: "+t);if(null===t)throw new Error("This browser's implementation of Object.create is a shim and doesn't support 'null' as the first argument.");if(void 0!==e)throw new Error("This browser's implementation of Object.create is a shim and doesn't support a second argument.");function i(){}return i.prototype=t,new i});var priv={modules:{math:_math_math__WEBPACK_IMPORTED_MODULE_3__.Z,"math/geometry":_math_geometry__WEBPACK_IMPORTED_MODULE_5__.Z,"math/statistics":_math_statistics__WEBPACK_IMPORTED_MODULE_6__.Z,"math/numerics":_math_math__WEBPACK_IMPORTED_MODULE_3__.Z.Numerics}},r,_ccache;_jxg__WEBPACK_IMPORTED_MODULE_0__.Z.JessieCode=function(t,e){this.scope={id:0,hasChild:!0,args:[],locals:{},context:null,previous:null},this.scopes=[],this.scopes.push(this.scope),this.dpstack=[[]],this.pscope=0,this.propstack=[{}],this.propscope=0,this.lhs=[],this.isLHS=!1,this.warnLog="jcwarn",this.$log=[],this.builtIn=this.defineBuiltIn(),this.operands=this.getPossibleOperands(),this.board=null,this.lineToElement={},this.parCurLine=1,this.parCurColumn=0,this.line=1,this.col=1,_jxg__WEBPACK_IMPORTED_MODULE_0__.Z.CA&&(this.CA=new _jxg__WEBPACK_IMPORTED_MODULE_0__.Z.CA(this.node,this.createNode,this)),this.code="","string"==typeof t&&this.parse(t,e)},_jxg__WEBPACK_IMPORTED_MODULE_0__.Z.extend(_jxg__WEBPACK_IMPORTED_MODULE_0__.Z.JessieCode.prototype,{node:function(t,e,i){return{type:t,value:e,children:i}},createNode:function(t,e,i){var s,r=this.node(t,e,[]);for(s=2;s<arguments.length;s++)r.children.push(arguments[s]);return"node_const"==r.type&&_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.isNumber(r.value)&&(r.isMath=!0),r.line=this.parCurLine,r.col=this.parCurColumn,r},pushScope:function(t){var e={args:t,locals:{},context:null,previous:this.scope};return this.scope.hasChild=!0,this.scope=e,e.id=this.scopes.push(e)-1,e},popScope:function(){var t=this.scope.previous;return this.scope=null!==t?t:this.scope,this.scope},getElementById:function(t){return this.board.objects[t]},log:function(){this.$log.push(arguments),"object"==typeof console&&console.log&&console.log.apply(console,arguments)},creator:(_ccache={},(r=function(t){var e,i;return"function"==typeof _ccache[this.board.id+t]?e=_ccache[this.board.id+t]:(i=this,(e=function(e,s){var r;return void 0===(r=_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.exists(s)?s:{}).name&&void 0===r.id&&(r.name=0!==i.lhs[i.scope.id]?i.lhs[i.scope.id]:""),i.board.create(t,e,r)}).creator=!0,_ccache[this.board.id+t]=e),e}).clearCache=function(){_ccache={}},r),letvar:function(t,e){this.builtIn[t]&&this._warn('"'+t+'" is a predefined value.'),this.scope.locals[t]=e},isLocalVariable:function(t){for(var e=this.scope;null!==e;){if(_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.exists(e.locals[t]))return e;e=e.previous}return null},isParameter:function(t){for(var e=this.scope;null!==e;){if(_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.indexOf(e.args,t)>-1)return e;e=e.previous}return null},isCreator:function(t){return!!_jxg__WEBPACK_IMPORTED_MODULE_0__.Z.elements[t]},isMathMethod:function(t){return"E"!==t&&!!Math[t]},isBuiltIn:function(t){return!!this.builtIn[t]},getvar:function(t,e,i){var s;if(e=_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.def(e,!1),null!==(s=this.isLocalVariable(t)))return s.locals[t];if("$board"===t||"EULER"===t||"PI"===t)return this.builtIn[t];if(i){if(this.isBuiltIn(t))return this.builtIn[t];if(this.isMathMethod(t))return Math[t];if(this.isCreator(t))return this.creator(t)}return e||(s=this.board.select(t))===t?void 0:s},resolve:function(t){for(var e=this.scope;null!==e;){if(_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.exists(e.locals[t]))return e.locals[t];e=e.previous}},getvarJS:function(t,e,i){var s,r="";return e=_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.def(e,!1),i=_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.def(i,!1),null!==this.isParameter(t)?t:null===this.isLocalVariable(t)||i?this.isCreator(t)?"(function () { var a = Array.prototype.slice.call(arguments, 0), props = "+(i?"a.pop()":"{}")+"; return $jc$.board.create.apply($jc$.board, ['"+t+"'].concat([a, props])); })":(i&&this._error("Syntax error (attribute values are allowed with element creators only)"),this.isBuiltIn(t)?(r=this.builtIn[t].src||this.builtIn[t],_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.isNumber(r)||r.match(/board\.select/)?r:(t=r.split(".").pop(),_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.exists(this.board.mathLib)&&null!==(s=new RegExp("^Math."+t)).exec(r)?r.replace(s,"$jc$.board.mathLib."+t):_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.exists(this.board.mathLibJXG)&&null!==(s=new RegExp("^JXG.Math.")).exec(r)?r.replace(s,"$jc$.board.mathLibJXG."):r)):this.isMathMethod(t)?"$jc$.board.mathLib."+t:e?"":(_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.isId(this.board,t)?(r="$jc$.board.objects['"+t+"']","slider"===this.board.objects[t].elType&&(r+=".Value()")):_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.isName(this.board,t)?(r="$jc$.board.elementsByName['"+t+"']","slider"===this.board.elementsByName[t].elType&&(r+=".Value()")):_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.isGroup(this.board,t)&&(r="$jc$.board.groups['"+t+"']"),r)):"$jc$.resolve('"+t+"')"},makeMap:function(t){return t.isMap=!0,t},functionCodeJS:function(t){var e=t.children[0].join(", "),i="",s="";return"op_map"===t.value&&(i="{ return  ",s=" }"),"function ("+e+") {\nvar $oldscope$ = $jc$.scope;\n$jc$.scope = $jc$.scopes["+this.scope.id+"];\nvar r = (function () "+i+this.compile(t.children[1],!0)+s+")();\n$jc$.scope = $oldscope$;\nreturn r;\n}"},defineFunction:function(node){var fun,i,that=this,list=node.children[0],scope=this.pushScope(list),_that;if(this.board.options.jc.compile){for(this.isLHS=!1,i=0;i<list.length;i++)scope.locals[list[i]]=list[i];this.replaceNames(node.children[1]),fun=function(jc){var fun,str="var f = function($jc$) { return "+jc.functionCodeJS(node)+"}; f;";try{for(fun=eval(str)(jc),scope.argtypes=[],i=0;i<list.length;i++)scope.argtypes.push(that.resolveType(list[i],node));return fun}catch(t){return jc._warn("error compiling function\n\n"+str+"\n\n"+t.toString()),function(){}}}(this),this.popScope()}else fun=function(t,e,i){return function(){var s,r;for(r=e.scope,e.scope=e.scopes[i],s=0;s<t.length;s++)e.scope.locals[t[s]]=arguments[s];return s=e.execute(node.children[1]),e.scope=r,s}}(list,this,scope.id);return fun.node=node,fun.scope=scope,fun.toJS=fun.toString,fun.toString=(_that=this,function(){return _that.compile(_that.replaceIDs(_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.deepCopy(node)))}),fun.deps={},this.collectDependencies(node.children[1],fun.deps),fun},mergeAttributes:function(t){var e,i={};for(e=0;e<arguments.length;e++)i=_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.deepCopy(i,arguments[e],!0);return i},setProp:function(t,e,i){var s,r,o={};t.elementClass!==_base_constants__WEBPACK_IMPORTED_MODULE_1__.Z.OBJECT_CLASS_POINT||"X"!==e&&"Y"!==e?t.elementClass!==_base_constants__WEBPACK_IMPORTED_MODULE_1__.Z.OBJECT_CLASS_TEXT||"X"!==e&&"Y"!==e?t.type&&t.elementClass&&t.visProp?_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.exists(t[t.methodMap[e]])&&"function"!=typeof t[t.methodMap[e]]?t[t.methodMap[e]]=i:(o[e]=i,t.setAttribute(o)):t[e]=i:("number"==typeof i?t[e]=function(){return i}:"function"==typeof i?(t.isDraggable=!1,t[e]=i):"string"==typeof i&&(t.isDraggable=!1,t[e]=_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.createFunction(i,this.board,null,!0),t[e+"jc"]=i),t[e].origin=i,this.board.update()):(e=e.toLowerCase(),t.isDraggable&&"number"==typeof i?(s="x"===e?i:t.X(),r="y"===e?i:t.Y(),t.setPosition(_base_constants__WEBPACK_IMPORTED_MODULE_1__.Z.COORDS_BY_USER,[s,r])):!t.isDraggable||"function"!=typeof i&&"string"!=typeof i?t.isDraggable||(s="x"===e?i:t.XEval.origin,r="y"===e?i:t.YEval.origin,t.addConstraint([s,r])):(s="x"===e?i:t.coords.usrCoords[1],r="y"===e?i:t.coords.usrCoords[2],t.addConstraint([s,r])),this.board.update())},_genericParse:function(t,e,i,s){var r,o,n,a,h=t.replace(/\r\n/g,"\n").split("\n"),l=[];s||(this.code+=t+"\n"),_base_text__WEBPACK_IMPORTED_MODULE_2__.Z&&(o=_base_text__WEBPACK_IMPORTED_MODULE_2__.Z.prototype.setText,_base_text__WEBPACK_IMPORTED_MODULE_2__.Z.prototype.setText=_base_text__WEBPACK_IMPORTED_MODULE_2__.Z.prototype.setTextJessieCode);try{for(_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.exists(i)||(i=!1),r=0;r<h.length;r++)i&&(h[r]=_jxg__WEBPACK_IMPORTED_MODULE_0__.Z.GeonextParser.geonext2JS(h[r],this.board)),l.push(h[r]);switch(t=l.join("\n"),n=parser.parse(t),this.CA&&(n=this.CA.expandDerivatives(n,null,n),n=this.CA.removeTrivialNodes(n)),e){case"parse":a=this.execute(n);break;case"manipulate":a=this.compile(n);break;case"getAst":a=n;break;default:a=!1}}catch(t){throw t}finally{_base_text__WEBPACK_IMPORTED_MODULE_2__.Z&&(_base_text__WEBPACK_IMPORTED_MODULE_2__.Z.prototype.setText=o)}return a},parse:function(t,e,i){return this._genericParse(t,"parse",e,i)},manipulate:function(t,e,i){return this._genericParse(t,"manipulate",e,i)},getAST:function(t,e,i){return this._genericParse(t,"getAst",e,i)},snippet:function(t,e,i,s){var r;return e=_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.def(e,!0),i=_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.def(i,""),s=_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.def(s,!1),r=(e?" function ("+i+") { return ":"")+t+(e?"; }":"")+";",this.parse(r,s,!0)},replaceIDs:function(t){var e,i;if(t.replaced&&(i=this.board.objects[t.children[1][0].value],_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.exists(i)&&""!==i.name&&(t.type="node_var",t.value=i.name,t.children.length=0,delete t.replaced)),_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.isArray(t))for(e=0;e<t.length;e++)t[e]=this.replaceIDs(t[e]);if(t.children)for(e=t.children.length;e>0;e--)_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.exists(t.children[e-1])&&(t.children[e-1]=this.replaceIDs(t.children[e-1]));return t},replaceNames:function(t){var e,i;if(i=t.value,"node_op"===t.type&&"op_lhs"===i&&1===t.children.length?this.isLHS=!0:"node_var"===t.type&&(this.isLHS?this.letvar(i,!0):!_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.exists(this.getvar(i,!0))&&_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.exists(this.board.elementsByName[i])&&(t=this.createReplacementNode(t))),_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.isArray(t))for(e=0;e<t.length;e++)t[e]=this.replaceNames(t[e]);if(t.children)for(e=t.children.length;e>0;e--)_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.exists(t.children[e-1])&&(t.children[e-1]=this.replaceNames(t.children[e-1]));return"node_op"===t.type&&"op_lhs"===t.value&&1===t.children.length&&(this.isLHS=!1),t},createReplacementNode:function(t){var e=t.value,i=this.board.elementsByName[e];return(t=this.createNode("node_op","op_execfun",this.createNode("node_var","$"),[this.createNode("node_str",i.id)])).replaced=!0,t},collectDependencies:function(t,e){var i,s,r,o;if(_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.isArray(t))for(o=t.length,i=0;i<o;i++)this.collectDependencies(t[i],e);else if(s=t.value,"node_var"===t.type&&(r=this.getvar(s))&&r.visProp&&r.type&&r.elementClass&&r.id&&(e[r.id]=r),"node_op"===t.type&&"op_execfun"===t.value&&t.children.length>1&&"$"===t.children[0].value&&t.children[1].length>0&&(e[r=t.children[1][0].value]=this.board.objects[r]),t.children)for(i=t.children.length;i>0;i--)_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.exists(t.children[i-1])&&this.collectDependencies(t.children[i-1],e)},resolveProperty:function(t,e,i){return i=_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.def(i,!1),t&&t.methodMap&&(_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.exists(t.subs)&&_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.exists(t.subs[e])?t=t.subs:_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.exists(t.methodMap[e])?e=t.methodMap[e]:(t=t.visProp,e=e.toLowerCase())),_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.isFunction(t)&&this._error("Accessing function properties is not allowed."),_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.exists(t)||this._error(t+" is not an object"),_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.exists(t[e])||this._error("unknown property "+e),i&&"function"==typeof t[e]?function(){return t[e].apply(t,arguments)}:t[e]},resolveType:function(t,e){var i,s;if(_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.isArray(e))for(i=0;i<e.length;i++)if("any"!==(s=this.resolveType(t,e[i])))return s;if("node_op"===e.type&&"op_execfun"===e.value&&"node_var"===e.children[0].type&&e.children[0].value===t)return"function";if("node_op"===e.type){for(i=0;i<e.children.length;i++)if("node_var"===e.children[0].type&&e.children[0].value===t&&("op_add"===e.value||"op_sub"===e.value||"op_mul"===e.value||"op_div"===e.value||"op_mod"===e.value||"op_exp"===e.value||"op_neg"===e.value))return"any";for(i=0;i<e.children.length;i++)if("any"!==(s=this.resolveType(t,e.children[i])))return s}return"any"},getLHS:function(t){var e;if("node_var"===t.type)e={o:this.scope.locals,what:t.value};else if("node_op"===t.type&&"op_property"===t.value)e={o:this.execute(t.children[0]),what:t.children[1]};else{if("node_op"!==t.type||"op_extvalue"!==t.value)throw new Error("Syntax error: Invalid left-hand side of assignment.");e={o:this.execute(t.children[0]),what:this.execute(t.children[1])}}return e},getLHSCompiler:function(t,e){var i;if("node_var"===t.type)i=t.value;else if("node_op"===t.type&&"op_property"===t.value)i=[this.compile(t.children[0],e),"'"+t.children[1]+"'"];else{if("node_op"!==t.type||"op_extvalue"!==t.value)throw new Error("Syntax error: Invalid left-hand side of assignment.");i=[this.compile(t.children[0],e),"node_const"===t.children[1].type?t.children[1].value:this.compile(t.children[1],e)]}return i},execute:function(t){var e,i,s,r,o,n,a,h,l,c,d=[];if(e=0,!t)return e;switch(this.line=t.line,this.col=t.col,t.type){case"node_op":switch(t.value){case"op_none":t.children[0]&&this.execute(t.children[0]),t.children[1]&&(e=this.execute(t.children[1]));break;case"op_assign":i=this.getLHS(t.children[0]),this.lhs[this.scope.id]=i.what,i.o.type&&i.o.elementClass&&i.o.methodMap&&"label"===i.what&&this._error("Left-hand side of assignment is read-only."),e=this.execute(t.children[1]),i.o!==this.scope.locals||_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.isArray(i.o)&&"number"==typeof i.what?this.setProp(i.o,i.what,e):this.letvar(i.what,e),this.lhs[this.scope.id]=0;break;case"op_if":this.execute(t.children[0])&&(e=this.execute(t.children[1]));break;case"op_conditional":case"op_if_else":e=this.execute(t.children[0])?this.execute(t.children[1]):this.execute(t.children[2]);break;case"op_while":for(;this.execute(t.children[0]);)this.execute(t.children[1]);break;case"op_do":do{this.execute(t.children[0])}while(this.execute(t.children[1]));break;case"op_for":for(this.execute(t.children[0]);this.execute(t.children[1]);this.execute(t.children[2]))this.execute(t.children[3]);break;case"op_proplst":t.children[0]&&this.execute(t.children[0]),t.children[1]&&this.execute(t.children[1]);break;case"op_emptyobject":e={};break;case"op_proplst_val":this.propstack.push({}),this.propscope++,this.execute(t.children[0]),e=this.propstack[this.propscope],this.propstack.pop(),this.propscope--;break;case"op_prop":this.propstack[this.propscope][t.children[0]]=this.execute(t.children[1]);break;case"op_array":for(e=[],o=t.children[0].length,s=0;s<o;s++)e.push(this.execute(t.children[0][s]));break;case"op_extvalue":e=this.execute(t.children[0]),e="number"==typeof(s=this.execute(t.children[1]))&&Math.abs(Math.round(s)-s)<_math_math__WEBPACK_IMPORTED_MODULE_3__.Z.eps?e[s]:undefined;break;case"op_return":if(0!==this.scope)return this.execute(t.children[0]);this._error("Unexpected return.");break;case"op_map":t.children[1].isMath||"node_var"===t.children[1].type||this._error("execute: In a map only function calls and mathematical expressions are allowed."),(h=this.defineFunction(t)).isMap=!0,e=h;break;case"op_function":(h=this.defineFunction(t)).isMap=!1,e=h;break;case"op_execfun":if(this.dpstack.push([]),this.pscope++,n=t.children[1],_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.exists(t.children[2]))if(t.children[3])for(a=t.children[2],l={},s=0;s<a.length;s++)l=_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.deepCopy(l,this.execute(a[s]),!0);else l=this.execute(t.children[2]);for(t.children[0]._isFunctionName=!0,h=this.execute(t.children[0]),delete t.children[0]._isFunctionName,c=h&&h.sc?h.sc:this,!h.creator&&_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.exists(t.children[2])&&this._error("Unexpected value. Only element creators are allowed to have a value after the function call."),s=0;s<n.length;s++)_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.exists(h.scope)&&_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.exists(h.scope.argtypes)&&"function"===h.scope.argtypes[s]?(n[s]._isFunctionName=!0,d[s]=this.execute(n[s]),delete n[s]._isFunctionName):d[s]=this.execute(n[s]),this.dpstack[this.pscope].push({line:t.children[1][s].line,col:t.children[1][s].ecol});if("function"!=typeof h||h.creator)if("function"==typeof h&&h.creator){r=this.line;try{for((e=h(d,l)).jcLineStart=r,e.jcLineEnd=t.eline,s=r;s<=t.line;s++)this.lineToElement[s]=e;e.debugParents=this.dpstack[this.pscope]}catch(t){this._error(t.toString())}}else this._error("Function '"+h+"' is undefined.");else e=h.apply(c,d);this.dpstack.pop(),this.pscope--;break;case"op_property":r=this.execute(t.children[0]),i=t.children[1],e=this.resolveProperty(r,i,!1),_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.exists(e)&&(e.sc=r);break;case"op_use":this._warn("Use of the 'use' operator is deprecated."),this.use(t.children[0].toString());break;case"op_delete":this._warn("Use of the 'delete' operator is deprecated. Please use the remove() function."),i=this.getvar(t.children[0]),e=this.del(i);break;case"op_eq":e=this.execute(t.children[0])==this.execute(t.children[1]);break;case"op_neq":e=this.execute(t.children[0])!=this.execute(t.children[1]);break;case"op_approx":e=Math.abs(this.execute(t.children[0])-this.execute(t.children[1]))<_math_math__WEBPACK_IMPORTED_MODULE_3__.Z.eps;break;case"op_gt":e=this.execute(t.children[0])>this.execute(t.children[1]);break;case"op_lt":e=this.execute(t.children[0])<this.execute(t.children[1]);break;case"op_geq":e=this.execute(t.children[0])>=this.execute(t.children[1]);break;case"op_leq":e=this.execute(t.children[0])<=this.execute(t.children[1]);break;case"op_or":e=this.execute(t.children[0])||this.execute(t.children[1]);break;case"op_and":e=this.execute(t.children[0])&&this.execute(t.children[1]);break;case"op_not":e=!this.execute(t.children[0]);break;case"op_add":e=this.add(this.execute(t.children[0]),this.execute(t.children[1]));break;case"op_sub":e=this.sub(this.execute(t.children[0]),this.execute(t.children[1]));break;case"op_div":e=this.div(this.execute(t.children[0]),this.execute(t.children[1]));break;case"op_mod":e=this.mod(this.execute(t.children[0]),this.execute(t.children[1]),!0);break;case"op_mul":e=this.mul(this.execute(t.children[0]),this.execute(t.children[1]));break;case"op_exp":e=this.pow(this.execute(t.children[0]),this.execute(t.children[1]));break;case"op_neg":e=this.neg(this.execute(t.children[0]))}break;case"node_var":e=this.getvar(t.value,!1,t._isFunctionName);break;case"node_const":e=null===t.value?null:Number(t.value);break;case"node_const_bool":e=t.value;break;case"node_str":e=t.value.replace(/\\(.)/g,"$1")}return e},compile:function(t,e){var i,s,r,o="";if(_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.exists(e)||(e=!1),!t)return o;switch(t.type){case"node_op":switch(t.value){case"op_none":t.children[0]&&(o=this.compile(t.children[0],e)),t.children[1]&&(o+=this.compile(t.children[1],e));break;case"op_assign":e?(i=this.getLHSCompiler(t.children[0],e),_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.isArray(i)?o="$jc$.setProp("+i[0]+", "+i[1]+", "+this.compile(t.children[1],e)+");\n":(this.isLocalVariable(i)!==this.scope&&(this.scope.locals[i]=!0),o="$jc$.scopes["+this.scope.id+"].locals['"+i+"'] = "+this.compile(t.children[1],e)+";\n")):o=(i=this.compile(t.children[0]))+" = "+this.compile(t.children[1],e)+";\n";break;case"op_if":o=" if ("+this.compile(t.children[0],e)+") "+this.compile(t.children[1],e);break;case"op_if_else":o=" if ("+this.compile(t.children[0],e)+")"+this.compile(t.children[1],e),o+=" else "+this.compile(t.children[2],e);break;case"op_conditional":o="(("+this.compile(t.children[0],e)+")?("+this.compile(t.children[1],e),o+="):("+this.compile(t.children[2],e)+"))";break;case"op_while":o=" while ("+this.compile(t.children[0],e)+") {\n"+this.compile(t.children[1],e)+"}\n";break;case"op_do":o=" do {\n"+this.compile(t.children[0],e)+"} while ("+this.compile(t.children[1],e)+");\n";break;case"op_for":o=" for ("+this.compile(t.children[0],e)+this.compile(t.children[1],e)+"; "+this.compile(t.children[2],e).slice(0,-2)+") {\n"+this.compile(t.children[3],e)+"\n}\n";break;case"op_proplst":t.children[0]&&(o=this.compile(t.children[0],e)+", "),o+=this.compile(t.children[1],e);break;case"op_prop":o=t.children[0]+": "+this.compile(t.children[1],e);break;case"op_emptyobject":o=e?"{}":"<< >>";break;case"op_proplst_val":o=this.compile(t.children[0],e);break;case"op_array":for(r=[],s=0;s<t.children[0].length;s++)r.push(this.compile(t.children[0][s],e));o="["+r.join(", ")+"]";break;case"op_extvalue":o=this.compile(t.children[0],e)+"["+this.compile(t.children[1],e)+"]";break;case"op_return":o=" return "+this.compile(t.children[0],e)+";\n";break;case"op_map":t.children[1].isMath||"node_var"===t.children[1].type||this._error("compile: In a map only function calls and mathematical expressions are allowed."),r=t.children[0],o=e?" $jc$.makeMap(function ("+r.join(", ")+") { return "+this.compile(t.children[1],e)+"; })":"map ("+r.join(", ")+") -> "+this.compile(t.children[1],e);break;case"op_function":r=t.children[0],this.pushScope(r),o=e?this.functionCodeJS(t):" function ("+r.join(", ")+") "+this.compile(t.children[1],e),this.popScope();break;case"op_execfunmath":console.log("op_execfunmath: TODO"),o="-1";break;case"op_execfun":if(t.children[2]){for(r=[],s=0;s<t.children[2].length;s++)r.push(this.compile(t.children[2][s],e));i=e?"$jc$.mergeAttributes("+r.join(", ")+")":r.join(", ")}for(t.children[0].withProps=!!t.children[2],r=[],s=0;s<t.children[1].length;s++)r.push(this.compile(t.children[1][s],e));o=this.compile(t.children[0],e)+"("+r.join(", ")+(t.children[2]&&e?", "+i:"")+")"+(t.children[2]&&!e?" "+i:""),e&&(o+="\n"),e&&"$"===t.children[0].value&&(o="$jc$.board.objects["+this.compile(t.children[1][0],e)+"]");break;case"op_property":o=e&&"X"!==t.children[1]&&"Y"!==t.children[1]?"$jc$.resolveProperty("+this.compile(t.children[0],e)+", '"+t.children[1]+"', true)":this.compile(t.children[0],e)+"."+t.children[1];break;case"op_use":this._warn("Use of the 'use' operator is deprecated."),o=e?"$jc$.use('":"use('",o+=t.children[0].toString()+"');";break;case"op_delete":this._warn("Use of the 'delete' operator is deprecated. Please use the remove() function."),o=e?"$jc$.del(":"remove(",o+=this.compile(t.children[0],e)+")";break;case"op_eq":o="("+this.compile(t.children[0],e)+" === "+this.compile(t.children[1],e)+")";break;case"op_neq":o="("+this.compile(t.children[0],e)+" !== "+this.compile(t.children[1],e)+")";break;case"op_approx":o="("+this.compile(t.children[0],e)+" ~= "+this.compile(t.children[1],e)+")";break;case"op_gt":o=e?"$jc$.gt("+this.compile(t.children[0],e)+", "+this.compile(t.children[1],e)+")":"("+this.compile(t.children[0],e)+" > "+this.compile(t.children[1],e)+")";break;case"op_lt":o=e?"$jc$.lt("+this.compile(t.children[0],e)+", "+this.compile(t.children[1],e)+")":"("+this.compile(t.children[0],e)+" < "+this.compile(t.children[1],e)+")";break;case"op_geq":o=e?"$jc$.geq("+this.compile(t.children[0],e)+", "+this.compile(t.children[1],e)+")":"("+this.compile(t.children[0],e)+" >= "+this.compile(t.children[1],e)+")";break;case"op_leq":o=e?"$jc$.leq("+this.compile(t.children[0],e)+", "+this.compile(t.children[1],e)+")":"("+this.compile(t.children[0],e)+" <= "+this.compile(t.children[1],e)+")";break;case"op_or":o="("+this.compile(t.children[0],e)+" || "+this.compile(t.children[1],e)+")";break;case"op_and":o="("+this.compile(t.children[0],e)+" && "+this.compile(t.children[1],e)+")";break;case"op_not":o="!("+this.compile(t.children[0],e)+")";break;case"op_add":o=e?"$jc$.add("+this.compile(t.children[0],e)+", "+this.compile(t.children[1],e)+")":"("+this.compile(t.children[0],e)+" + "+this.compile(t.children[1],e)+")";break;case"op_sub":o=e?"$jc$.sub("+this.compile(t.children[0],e)+", "+this.compile(t.children[1],e)+")":"("+this.compile(t.children[0],e)+" - "+this.compile(t.children[1],e)+")";break;case"op_div":o=e?"$jc$.div("+this.compile(t.children[0],e)+", "+this.compile(t.children[1],e)+")":"("+this.compile(t.children[0],e)+" / "+this.compile(t.children[1],e)+")";break;case"op_mod":o=e?"$jc$.mod("+this.compile(t.children[0],e)+", "+this.compile(t.children[1],e)+", true)":"("+this.compile(t.children[0],e)+" % "+this.compile(t.children[1],e)+")";break;case"op_mul":o=e?"$jc$.mul("+this.compile(t.children[0],e)+", "+this.compile(t.children[1],e)+")":"("+this.compile(t.children[0],e)+" * "+this.compile(t.children[1],e)+")";break;case"op_exp":o=e?"$jc$.pow("+this.compile(t.children[0],e)+", "+this.compile(t.children[1],e)+")":"("+this.compile(t.children[0],e)+"^"+this.compile(t.children[1],e)+")";break;case"op_neg":o=e?"$jc$.neg("+this.compile(t.children[0],e)+")":"(-"+this.compile(t.children[0],e)+")"}break;case"node_var":o=e?this.getvarJS(t.value,!1,t.withProps):t.value;break;case"node_const":case"node_const_bool":o=t.value;break;case"node_str":o="'"+t.value+"'"}return t.needsBrackets&&(o=e?"{\n"+o+"\n}\n":"<< "+o+" >>"),o},getName:function(t,e){var i="";return _utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.exists(t)&&_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.exists(t.getName)?(i=t.getName(),_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.exists(i)&&""!==i||!e||(i=t.id)):e&&(i=t.id),i},X:function(t){return t.X()},Y:function(t){return t.Y()},V:function(t){return t.Value()},L:function(t){return t.L()},area:function(t){return _utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.exists(t)&&_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.exists(t.Area)||this._error("Error: Can't calculate area."),t.Area()},dist:function(t,e){return _utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.exists(t)&&_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.exists(t.Dist)||this._error("Error: Can't calculate distance."),t.Dist(e)},radius:function(t){return _utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.exists(t)&&_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.exists(t.Radius)||this._error("Error: Can't calculate radius."),t.Radius()},add:function(t,e){var i,s,r;if(t=_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.evalSlider(t),e=_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.evalSlider(e),_math_ia__WEBPACK_IMPORTED_MODULE_4__.Z.isInterval(t)||_math_ia__WEBPACK_IMPORTED_MODULE_4__.Z.isInterval(e))r=_math_ia__WEBPACK_IMPORTED_MODULE_4__.Z.add(t,e);else if(_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.isArray(t)&&_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.isArray(e))for(s=Math.min(t.length,e.length),r=[],i=0;i<s;i++)r[i]=t[i]+e[i];else _utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.isNumber(t)&&_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.isNumber(e)?r=t+e:_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.isString(t)||_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.isString(e)?r=t.toString()+e.toString():this._error("Operation + not defined on operands "+typeof t+" and "+typeof e);return r},sub:function(t,e){var i,s,r;if(t=_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.evalSlider(t),e=_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.evalSlider(e),_math_ia__WEBPACK_IMPORTED_MODULE_4__.Z.isInterval(t)||_math_ia__WEBPACK_IMPORTED_MODULE_4__.Z.isInterval(e))r=_math_ia__WEBPACK_IMPORTED_MODULE_4__.Z.sub(t,e);else if(_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.isArray(t)&&_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.isArray(e))for(s=Math.min(t.length,e.length),r=[],i=0;i<s;i++)r[i]=t[i]-e[i];else _utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.isNumber(t)&&_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.isNumber(e)?r=t-e:this._error("Operation - not defined on operands "+typeof t+" and "+typeof e);return r},neg:function(t){var e,i,s;if(t=_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.evalSlider(t),_math_ia__WEBPACK_IMPORTED_MODULE_4__.Z.isInterval(t))s=_math_ia__WEBPACK_IMPORTED_MODULE_4__.Z.negative(t);else if(_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.isArray(t))for(i=t.length,s=[],e=0;e<i;e++)s[e]=-t[e];else _utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.isNumber(t)?s=-t:this._error("Unary operation - not defined on operand "+typeof t);return s},mul:function(t,e){var i,s,r;if(t=_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.evalSlider(t),e=_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.evalSlider(e),_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.isArray(t)&&_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.isNumber(e)&&(i=t,e=t=e),_math_ia__WEBPACK_IMPORTED_MODULE_4__.Z.isInterval(t)||_math_ia__WEBPACK_IMPORTED_MODULE_4__.Z.isInterval(e))r=_math_ia__WEBPACK_IMPORTED_MODULE_4__.Z.mul(t,e);else if(_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.isArray(t)&&_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.isArray(e))s=Math.min(t.length,e.length),r=_math_math__WEBPACK_IMPORTED_MODULE_3__.Z.innerProduct(t,e,s);else if(_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.isNumber(t)&&_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.isArray(e))for(s=e.length,r=[],i=0;i<s;i++)r[i]=t*e[i];else _utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.isNumber(t)&&_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.isNumber(e)?r=t*e:this._error("Operation * not defined on operands "+typeof t+" and "+typeof e);return r},div:function(t,e){var i,s,r;if(t=_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.evalSlider(t),e=_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.evalSlider(e),_math_ia__WEBPACK_IMPORTED_MODULE_4__.Z.isInterval(t)||_math_ia__WEBPACK_IMPORTED_MODULE_4__.Z.isInterval(e))r=_math_ia__WEBPACK_IMPORTED_MODULE_4__.Z.div(t,e);else if(_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.isArray(t)&&_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.isNumber(e))for(s=t.length,r=[],i=0;i<s;i++)r[i]=t[i]/e;else _utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.isNumber(t)&&_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.isNumber(e)?r=t/e:this._error("Operation * not defined on operands "+typeof t+" and "+typeof e);return r},mod:function(t,e){var i,s,r;if(t=_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.evalSlider(t),e=_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.evalSlider(e),_math_ia__WEBPACK_IMPORTED_MODULE_4__.Z.isInterval(t)||_math_ia__WEBPACK_IMPORTED_MODULE_4__.Z.isInterval(e))return _math_ia__WEBPACK_IMPORTED_MODULE_4__.Z.fmod(t,e);if(_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.isArray(t)&&_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.isNumber(e))for(s=t.length,r=[],i=0;i<s;i++)r[i]=_math_math__WEBPACK_IMPORTED_MODULE_3__.Z.mod(t[i],e,!0);else _utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.isNumber(t)&&_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.isNumber(e)?r=_math_math__WEBPACK_IMPORTED_MODULE_3__.Z.mod(t,e,!0):this._error("Operation * not defined on operands "+typeof t+" and "+typeof e);return r},pow:function(t,e){return t=_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.evalSlider(t),e=_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.evalSlider(e),_math_ia__WEBPACK_IMPORTED_MODULE_4__.Z.isInterval(t)||_math_ia__WEBPACK_IMPORTED_MODULE_4__.Z.isInterval(e)?_math_ia__WEBPACK_IMPORTED_MODULE_4__.Z.pow(t,e):_math_math__WEBPACK_IMPORTED_MODULE_3__.Z.pow(t,e)},lt:function(t,e){return _math_ia__WEBPACK_IMPORTED_MODULE_4__.Z.isInterval(t)||_math_ia__WEBPACK_IMPORTED_MODULE_4__.Z.isInterval(e)?_math_ia__WEBPACK_IMPORTED_MODULE_4__.Z.lt(t,e):t<e},leq:function(t,e){return _math_ia__WEBPACK_IMPORTED_MODULE_4__.Z.isInterval(t)||_math_ia__WEBPACK_IMPORTED_MODULE_4__.Z.isInterval(e)?_math_ia__WEBPACK_IMPORTED_MODULE_4__.Z.leq(t,e):t<=e},gt:function(t,e){return _math_ia__WEBPACK_IMPORTED_MODULE_4__.Z.isInterval(t)||_math_ia__WEBPACK_IMPORTED_MODULE_4__.Z.isInterval(e)?_math_ia__WEBPACK_IMPORTED_MODULE_4__.Z.gt(t,e):t>e},geq:function(t,e){return _math_ia__WEBPACK_IMPORTED_MODULE_4__.Z.isInterval(t)||_math_ia__WEBPACK_IMPORTED_MODULE_4__.Z.isInterval(e)?Intervalt.geq(t,e):t>=e},randint:function(t,e,i){return _utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.exists(i)||(i=1),Math.round(Math.random()*(e-t)/i)*i+t},DDD:function(t){console.log("Dummy derivative function. This should never appear!")},ifthen:function(t,e,i){return t?e:i},del:function(t){"object"==typeof t&&_jxg__WEBPACK_IMPORTED_MODULE_0__.Z.exists(t.type)&&_jxg__WEBPACK_IMPORTED_MODULE_0__.Z.exists(t.elementClass)&&this.board.removeObject(t)},use:function(t){var e,i,s=!1;if("string"==typeof t){for(e in _jxg__WEBPACK_IMPORTED_MODULE_0__.Z.boards)if(_jxg__WEBPACK_IMPORTED_MODULE_0__.Z.boards.hasOwnProperty(e)&&_jxg__WEBPACK_IMPORTED_MODULE_0__.Z.boards[e].container===t){i=_jxg__WEBPACK_IMPORTED_MODULE_0__.Z.boards[e],s=!0;break}}else i=t,s=!0;s?(this.board=i,this.builtIn.$board=i,this.builtIn.$board.src="$jc$.board"):this._error("Board '"+t+"' not found!")},findSymbol:function(t,e){var i,s;for(s=-1===(e=_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.def(e,-1))?this.scope:this.scopes[e];null!==s;){for(i in s.locals)if(s.locals.hasOwnProperty(i)&&s.locals[i]===t)return[i,s];s=s.previous}return[]},importModule:function(t){return priv.modules[t.toLowerCase()]},defineBuiltIn:function(){var t=this,e={PI:Math.PI,EULER:Math.E,D:t.DDD,X:t.X,Y:t.Y,V:t.V,L:t.L,acosh:_math_math__WEBPACK_IMPORTED_MODULE_3__.Z.acosh,acot:_math_math__WEBPACK_IMPORTED_MODULE_3__.Z.acot,asinh:_math_math__WEBPACK_IMPORTED_MODULE_3__.Z.asinh,binomial:_math_math__WEBPACK_IMPORTED_MODULE_3__.Z.binomial,cbrt:_math_math__WEBPACK_IMPORTED_MODULE_3__.Z.cbrt,cosh:_math_math__WEBPACK_IMPORTED_MODULE_3__.Z.cosh,cot:_math_math__WEBPACK_IMPORTED_MODULE_3__.Z.cot,deg:_math_geometry__WEBPACK_IMPORTED_MODULE_5__.Z.trueAngle,A:t.area,area:t.area,dist:t.dist,R:t.radius,radius:t.radius,erf:_math_math__WEBPACK_IMPORTED_MODULE_3__.Z.erf,erfc:_math_math__WEBPACK_IMPORTED_MODULE_3__.Z.erfc,erfi:_math_math__WEBPACK_IMPORTED_MODULE_3__.Z.erfi,factorial:_math_math__WEBPACK_IMPORTED_MODULE_3__.Z.factorial,gcd:_math_math__WEBPACK_IMPORTED_MODULE_3__.Z.gcd,lb:_math_math__WEBPACK_IMPORTED_MODULE_3__.Z.log2,lcm:_math_math__WEBPACK_IMPORTED_MODULE_3__.Z.lcm,ld:_math_math__WEBPACK_IMPORTED_MODULE_3__.Z.log2,lg:_math_math__WEBPACK_IMPORTED_MODULE_3__.Z.log10,ln:Math.log,log:_math_math__WEBPACK_IMPORTED_MODULE_3__.Z.log,log10:_math_math__WEBPACK_IMPORTED_MODULE_3__.Z.log10,log2:_math_math__WEBPACK_IMPORTED_MODULE_3__.Z.log2,ndtr:_math_math__WEBPACK_IMPORTED_MODULE_3__.Z.ndtr,ndtri:_math_math__WEBPACK_IMPORTED_MODULE_3__.Z.ndtri,nthroot:_math_math__WEBPACK_IMPORTED_MODULE_3__.Z.nthroot,pow:_math_math__WEBPACK_IMPORTED_MODULE_3__.Z.pow,rad:_math_geometry__WEBPACK_IMPORTED_MODULE_5__.Z.rad,ratpow:_math_math__WEBPACK_IMPORTED_MODULE_3__.Z.ratpow,trunc:_utils_type__WEBPACK_IMPORTED_MODULE_7__.Z.trunc,sinh:_math_math__WEBPACK_IMPORTED_MODULE_3__.Z.sinh,randint:t.randint,IfThen:t.ifthen,import:t.importModule,use:t.use,remove:t.del,$:t.getElementById,getName:t.getName,name:t.getName,$board:t.board,$log:t.log};return e.rad.sc=_math_geometry__WEBPACK_IMPORTED_MODULE_5__.Z,e.deg.sc=_math_geometry__WEBPACK_IMPORTED_MODULE_5__.Z,e.factorial.sc=_math_math__WEBPACK_IMPORTED_MODULE_3__.Z,e.X.src="$jc$.X",e.Y.src="$jc$.Y",e.V.src="$jc$.V",e.L.src="$jc$.L",e.acosh.src="JXG.Math.acosh",e.acot.src="JXG.Math.acot",e.asinh.src="JXG.Math.asinh",e.binomial.src="JXG.Math.binomial",e.cbrt.src="JXG.Math.cbrt",e.cot.src="JXG.Math.cot",e.cosh.src="JXG.Math.cosh",e.deg.src="JXG.Math.Geometry.trueAngle",e.erf.src="JXG.Math.erf",e.erfc.src="JXG.Math.erfc",e.erfi.src="JXG.Math.erfi",e.A.src="$jc$.area",e.area.src="$jc$.area",e.dist.src="$jc$.dist",e.R.src="$jc$.radius",e.radius.src="$jc$.radius",e.factorial.src="JXG.Math.factorial",e.gcd.src="JXG.Math.gcd",e.lb.src="JXG.Math.log2",e.lcm.src="JXG.Math.lcm",e.ld.src="JXG.Math.log2",e.lg.src="JXG.Math.log10",e.ln.src="Math.log",e.log.src="JXG.Math.log",e.log10.src="JXG.Math.log10",e.log2.src="JXG.Math.log2",e.ndtr.src="JXG.Math.ndtr",e.ndtri.src="JXG.Math.ndtri",e.nthroot.src="JXG.Math.nthroot",e.pow.src="JXG.Math.pow",e.rad.src="JXG.Math.Geometry.rad",e.ratpow.src="JXG.Math.ratpow",e.trunc.src="JXG.trunc",e.sinh.src="JXG.Math.sinh",e.randint.src="$jc$.randint",e.import.src="$jc$.importModule",e.use.src="$jc$.use",e.remove.src="$jc$.del",e.IfThen.src="$jc$.ifthen",e.$.src="(function (n) { return $jc$.board.select(n); })",e.getName.src="$jc$.getName",e.name.src="$jc$.getName",e.$board&&(e.$board.src="$jc$.board"),e.$log.src="$jc$.log",e},getPossibleOperands:function(){var t,e,i,s,r,o,n,a,h,l,c,d,u,p,_=["E"],f=this.defineBuiltIn(),b=Math;for(u=function(t,e){return t.toLowerCase().localeCompare(e.toLowerCase())},p=function(t,e){var i=null;if("jc"===e)i=f[t];else{if("Math"!==e)return;i=b[t]}if(!(_.indexOf(t)>=0))return _jxg__WEBPACK_IMPORTED_MODULE_0__.Z.isFunction(i)?{name:t,type:"function",numParams:i.length,origin:e}:_jxg__WEBPACK_IMPORTED_MODULE_0__.Z.isNumber(i)?{name:t,type:"constant",value:i,origin:e}:void(void 0!==i&&console.error("undefined type",i))},t=Object.getOwnPropertyNames(f).sort(u),e=Object.getOwnPropertyNames(b).sort(u),i=[],s=0,r=0;s<t.length||r<e.length;)t[s]===e[r]?(o=p(e[r],"Math"),_jxg__WEBPACK_IMPORTED_MODULE_0__.Z.exists(o)&&i.push(o),s++,r++):!_jxg__WEBPACK_IMPORTED_MODULE_0__.Z.exists(e[r])||t[s].toLowerCase().localeCompare(e[r].toLowerCase())<0?(o=p(t[s],"jc"),_jxg__WEBPACK_IMPORTED_MODULE_0__.Z.exists(o)&&i.push(o),s++):(o=p(e[r],"Math"),_jxg__WEBPACK_IMPORTED_MODULE_0__.Z.exists(o)&&i.push(o),r++);for(h=[],l=[],c=[],d={},n=i.length,s=0;s<n;s++){switch((a=i[s]).type){case"function":h.push(a.name),"jc"===a.origin&&l.push(a.name);break;case"constant":c.push(a.name)}d[a.name]=a}return{all:d,list:i,functions:h,functions_jessiecode:l,constants:c}},_debug:function(t){"object"==typeof console?console.log(t):_utils_env__WEBPACK_IMPORTED_MODULE_8__.Z.isBrowser&&document&&null!==document.getElementById("debug")&&(document.getElementById("debug").innerHTML+=t+"<br />")},_error:function(t){var e=new Error("Error("+this.line+"): "+t);throw e.line=this.line,e},_warn:function(t){"object"==typeof console?console.log("Warning("+this.line+"): "+t):_utils_env__WEBPACK_IMPORTED_MODULE_8__.Z.isBrowser&&document&&null!==document.getElementById(this.warnLog)&&(document.getElementById(this.warnLog).innerHTML+="Warning("+this.line+"): "+t+"<br />")},_log:function(t){"object"!=typeof window&&"object"==typeof self&&self.postMessage?self.postMessage({type:"log",msg:"Log: "+t.toString()}):console.log("Log: ",arguments)}});var parser=function(){var t=function(t,e,i,s){for(i=i||{},s=t.length;s--;i[t[s]]=e);return i},e=[2,14],i=[1,13],s=[1,37],r=[1,14],o=[1,15],n=[1,21],a=[1,16],h=[1,17],l=[1,33],c=[1,18],d=[1,19],u=[1,12],p=[1,59],_=[1,60],f=[1,58],b=[1,46],g=[1,48],m=[1,49],v=[1,50],Z=[1,51],C=[1,52],y=[1,53],P=[1,54],E=[1,45],O=[1,38],x=[1,39],w=[5,7,8,14,15,16,17,19,20,21,23,26,27,50,51,58,65,74,75,76,77,78,79,80,82,91,93],S=[5,7,8,12,14,15,16,17,19,20,21,23,26,27,50,51,58,65,74,75,76,77,78,79,80,82,91,93],T=[8,10,16,32,34,35,37,39,41,42,43,45,46,47,48,50,51,53,54,55,57,64,65,66,83,86],M=[2,48],N=[1,72],A=[10,16,32,34,35,37,39,41,42,43,45,46,47,48,50,51,53,54,55,57,66,83,86],k=[1,78],R=[8,10,16,32,34,35,37,41,42,43,45,46,47,48,50,51,53,54,55,57,64,65,66,83,86],D=[1,82],L=[8,10,16,32,34,35,37,39,45,46,47,48,50,51,53,54,55,57,64,65,66,83,86],B=[1,83],I=[1,84],Y=[1,85],j=[8,10,16,32,34,35,37,39,41,42,43,50,51,53,54,55,57,64,65,66,83,86],X=[1,89],U=[1,90],F=[1,91],J=[1,92],G=[1,97],z=[8,10,16,32,34,35,37,39,41,42,43,45,46,47,48,53,54,55,57,64,65,66,83,86],H=[1,103],W=[1,104],V=[8,10,16,32,34,35,37,39,41,42,43,45,46,47,48,50,51,57,64,65,66,83,86],$=[1,105],K=[1,106],q=[1,107],Q=[1,126],tt=[1,139],et=[83,86],it=[1,150],st=[10,66,86],rt=[8,10,16,20,32,34,35,37,39,41,42,43,45,46,47,48,50,51,53,54,55,57,64,65,66,82,83,86],ot=[1,167],nt=[10,86],at={trace:function(){},yy:{},symbols_:{error:2,Program:3,StatementList:4,EOF:5,IfStatement:6,IF:7,"(":8,Expression:9,")":10,Statement:11,ELSE:12,LoopStatement:13,WHILE:14,FOR:15,";":16,DO:17,UnaryStatement:18,USE:19,IDENTIFIER:20,DELETE:21,ReturnStatement:22,RETURN:23,EmptyStatement:24,StatementBlock:25,"{":26,"}":27,ExpressionStatement:28,AssignmentExpression:29,ConditionalExpression:30,LeftHandSideExpression:31,"=":32,LogicalORExpression:33,"?":34,":":35,LogicalANDExpression:36,"||":37,EqualityExpression:38,"&&":39,RelationalExpression:40,"==":41,"!=":42,"~=":43,AdditiveExpression:44,"<":45,">":46,"<=":47,">=":48,MultiplicativeExpression:49,"+":50,"-":51,UnaryExpression:52,"*":53,"/":54,"%":55,ExponentExpression:56,"^":57,"!":58,MemberExpression:59,CallExpression:60,PrimaryExpression:61,FunctionExpression:62,MapExpression:63,".":64,"[":65,"]":66,BasicLiteral:67,ObjectLiteral:68,ArrayLiteral:69,NullLiteral:70,BooleanLiteral:71,StringLiteral:72,NumberLiteral:73,NULL:74,TRUE:75,FALSE:76,STRING:77,NUMBER:78,NAN:79,INFINITY:80,ElementList:81,"<<":82,">>":83,PropertyList:84,Property:85,",":86,PropertyName:87,Arguments:88,AttributeList:89,Attribute:90,FUNCTION:91,ParameterDefinitionList:92,MAP:93,"->":94,$accept:0,$end:1},terminals_:{2:"error",5:"EOF",7:"IF",8:"(",10:")",12:"ELSE",14:"WHILE",15:"FOR",16:";",17:"DO",19:"USE",20:"IDENTIFIER",21:"DELETE",23:"RETURN",26:"{",27:"}",32:"=",34:"?",35:":",37:"||",39:"&&",41:"==",42:"!=",43:"~=",45:"<",46:">",47:"<=",48:">=",50:"+",51:"-",53:"*",54:"/",55:"%",57:"^",58:"!",64:".",65:"[",66:"]",74:"NULL",75:"TRUE",76:"FALSE",77:"STRING",78:"NUMBER",79:"NAN",80:"INFINITY",82:"<<",83:">>",86:",",91:"FUNCTION",93:"MAP",94:"->"},productions_:[0,[3,2],[6,5],[6,7],[13,5],[13,9],[13,7],[18,2],[18,2],[22,2],[22,3],[24,1],[25,3],[4,2],[4,0],[11,1],[11,1],[11,1],[11,1],[11,1],[11,1],[11,1],[28,2],[9,1],[29,1],[29,3],[30,1],[30,5],[33,1],[33,3],[36,1],[36,3],[38,1],[38,3],[38,3],[38,3],[40,1],[40,3],[40,3],[40,3],[40,3],[44,1],[44,3],[44,3],[49,1],[49,3],[49,3],[49,3],[56,1],[56,3],[52,1],[52,2],[52,2],[52,2],[31,1],[31,1],[59,1],[59,1],[59,1],[59,3],[59,4],[61,1],[61,1],[61,1],[61,1],[61,3],[67,1],[67,1],[67,1],[67,1],[70,1],[71,1],[71,1],[72,1],[73,1],[73,1],[73,1],[69,2],[69,3],[68,2],[68,3],[84,1],[84,3],[85,3],[87,1],[87,1],[87,1],[60,2],[60,3],[60,2],[60,4],[60,3],[88,2],[88,3],[89,1],[89,3],[90,1],[90,1],[81,1],[81,3],[62,4],[62,5],[63,5],[63,6],[92,1],[92,3]],performAction:function(t,e,i,s,r,o,n){var a=o.length-1;switch(r){case 1:return o[a-1];case 2:this.$=ht.createNode(lt(n[a-4]),"node_op","op_if",o[a-2],o[a]);break;case 3:this.$=ht.createNode(lt(n[a-6]),"node_op","op_if_else",o[a-4],o[a-2],o[a]);break;case 4:this.$=ht.createNode(lt(n[a-4]),"node_op","op_while",o[a-2],o[a]);break;case 5:this.$=ht.createNode(lt(n[a-8]),"node_op","op_for",o[a-6],o[a-4],o[a-2],o[a]);break;case 6:this.$=ht.createNode(lt(n[a-6]),"node_op","op_do",o[a-5],o[a-2]);break;case 7:this.$=ht.createNode(lt(n[a-1]),"node_op","op_use",o[a]);break;case 8:this.$=ht.createNode(lt(n[a-1]),"node_op","op_delete",o[a]);break;case 9:this.$=ht.createNode(lt(n[a-1]),"node_op","op_return",void 0);break;case 10:this.$=ht.createNode(lt(n[a-2]),"node_op","op_return",o[a-1]);break;case 11:case 14:this.$=ht.createNode(lt(n[a]),"node_op","op_none");break;case 12:this.$=o[a-1],this.$.needsBrackets=!0;break;case 13:this.$=ht.createNode(lt(n[a-1]),"node_op","op_none",o[a-1],o[a]);break;case 15:case 16:case 17:case 18:case 19:case 20:case 21:case 23:case 24:case 26:case 28:case 30:case 32:case 36:case 41:case 44:case 48:case 50:case 52:case 54:case 55:case 56:case 58:case 62:case 81:case 84:case 85:case 86:this.$=o[a];break;case 22:case 65:case 93:this.$=o[a-1];break;case 25:this.$=ht.createNode(lt(n[a-2]),"node_op","op_assign",o[a-2],o[a]),this.$.isMath=!1;break;case 27:this.$=ht.createNode(lt(n[a-4]),"node_op","op_conditional",o[a-4],o[a-2],o[a]),this.$.isMath=!1;break;case 29:this.$=ht.createNode(lt(n[a-2]),"node_op","op_or",o[a-2],o[a]),this.$.isMath=!1;break;case 31:this.$=ht.createNode(lt(n[a-2]),"node_op","op_and",o[a-2],o[a]),this.$.isMath=!1;break;case 33:this.$=ht.createNode(lt(n[a-2]),"node_op","op_eq",o[a-2],o[a]),this.$.isMath=!1;break;case 34:this.$=ht.createNode(lt(n[a-2]),"node_op","op_neq",o[a-2],o[a]),this.$.isMath=!1;break;case 35:this.$=ht.createNode(lt(n[a-2]),"node_op","op_approx",o[a-2],o[a]),this.$.isMath=!1;break;case 37:this.$=ht.createNode(lt(n[a-2]),"node_op","op_lt",o[a-2],o[a]),this.$.isMath=!1;break;case 38:this.$=ht.createNode(lt(n[a-2]),"node_op","op_gt",o[a-2],o[a]),this.$.isMath=!1;break;case 39:this.$=ht.createNode(lt(n[a-2]),"node_op","op_leq",o[a-2],o[a]),this.$.isMath=!1;break;case 40:this.$=ht.createNode(lt(n[a-2]),"node_op","op_geq",o[a-2],o[a]),this.$.isMath=!1;break;case 42:this.$=ht.createNode(lt(n[a-2]),"node_op","op_add",o[a-2],o[a]),this.$.isMath=!0;break;case 43:this.$=ht.createNode(lt(n[a-2]),"node_op","op_sub",o[a-2],o[a]),this.$.isMath=!0;break;case 45:this.$=ht.createNode(lt(n[a-2]),"node_op","op_mul",o[a-2],o[a]),this.$.isMath=!0;break;case 46:this.$=ht.createNode(lt(n[a-2]),"node_op","op_div",o[a-2],o[a]),this.$.isMath=!0;break;case 47:this.$=ht.createNode(lt(n[a-2]),"node_op","op_mod",o[a-2],o[a]),this.$.isMath=!0;break;case 49:this.$=ht.createNode(lt(n[a-2]),"node_op","op_exp",o[a-2],o[a]),this.$.isMath=!0;break;case 51:this.$=ht.createNode(lt(n[a-1]),"node_op","op_not",o[a]),this.$.isMath=!1;break;case 53:this.$=ht.createNode(lt(n[a-1]),"node_op","op_neg",o[a]),this.$.isMath=!0;break;case 57:case 63:case 64:case 66:case 67:case 68:case 97:this.$=o[a],this.$.isMath=!1;break;case 59:case 91:this.$=ht.createNode(lt(n[a-2]),"node_op","op_property",o[a-2],o[a]),this.$.isMath=!0;break;case 60:case 90:this.$=ht.createNode(lt(n[a-3]),"node_op","op_extvalue",o[a-3],o[a-1]),this.$.isMath=!0;break;case 61:this.$=ht.createNode(lt(n[a]),"node_var",o[a]);break;case 69:this.$=o[a],this.$.isMath=!0;break;case 70:this.$=ht.createNode(lt(n[a]),"node_const",null);break;case 71:this.$=ht.createNode(lt(n[a]),"node_const_bool",!0);break;case 72:this.$=ht.createNode(lt(n[a]),"node_const_bool",!1);break;case 73:this.$=ht.createNode(lt(n[a]),"node_str",o[a].substring(1,o[a].length-1));break;case 74:this.$=ht.createNode(lt(n[a]),"node_const",parseFloat(o[a]));break;case 75:this.$=ht.createNode(lt(n[a]),"node_const",NaN);break;case 76:this.$=ht.createNode(lt(n[a]),"node_const",1/0);break;case 77:this.$=ht.createNode(lt(n[a-1]),"node_op","op_array",[]);break;case 78:this.$=ht.createNode(lt(n[a-2]),"node_op","op_array",o[a-1]);break;case 79:this.$=ht.createNode(lt(n[a-1]),"node_op","op_emptyobject",{}),this.$.needsBrackets=!0;break;case 80:this.$=ht.createNode(lt(n[a-2]),"node_op","op_proplst_val",o[a-1]),this.$.needsBrackets=!0;break;case 82:this.$=ht.createNode(lt(n[a-2]),"node_op","op_proplst",o[a-2],o[a]);break;case 83:this.$=ht.createNode(lt(n[a-2]),"node_op","op_prop",o[a-2],o[a]);break;case 87:case 89:this.$=ht.createNode(lt(n[a-1]),"node_op","op_execfun",o[a-1],o[a]),this.$.isMath=!0;break;case 88:this.$=ht.createNode(lt(n[a-2]),"node_op","op_execfun",o[a-2],o[a-1],o[a],!0),this.$.isMath=!1;break;case 92:this.$=[];break;case 94:case 98:case 104:this.$=[o[a]];break;case 95:case 99:case 105:this.$=o[a-2].concat(o[a]);break;case 96:this.$=ht.createNode(lt(n[a]),"node_var",o[a]),this.$.isMath=!0;break;case 100:this.$=ht.createNode(lt(n[a-3]),"node_op","op_function",[],o[a]),this.$.isMath=!1;break;case 101:this.$=ht.createNode(lt(n[a-4]),"node_op","op_function",o[a-2],o[a]),this.$.isMath=!1;break;case 102:this.$=ht.createNode(lt(n[a-4]),"node_op","op_map",[],o[a]);break;case 103:this.$=ht.createNode(lt(n[a-5]),"node_op","op_map",o[a-3],o[a])}},table:[t([5,7,8,14,15,16,17,19,20,21,23,26,50,51,58,65,74,75,76,77,78,79,80,82,91,93],e,{3:1,4:2}),{1:[3]},{5:[1,3],6:6,7:i,8:s,9:20,11:4,13:7,14:r,15:o,16:n,17:a,18:8,19:h,20:l,21:c,22:9,23:d,24:11,25:5,26:u,28:10,29:22,30:23,31:24,33:25,36:28,38:32,40:40,44:47,49:55,50:p,51:_,52:56,56:57,58:f,59:26,60:27,61:29,62:30,63:31,65:b,67:34,68:35,69:36,70:41,71:42,72:43,73:44,74:g,75:m,76:v,77:Z,78:C,79:y,80:P,82:E,91:O,93:x},{1:[2,1]},t(w,[2,13]),t(S,[2,15]),t(S,[2,16]),t(S,[2,17]),t(S,[2,18]),t(S,[2,19]),t(S,[2,20]),t(S,[2,21]),t([7,8,14,15,16,17,19,20,21,23,26,27,50,51,58,65,74,75,76,77,78,79,80,82,91,93],e,{4:61}),{8:[1,62]},{8:[1,63]},{8:[1,64]},{6:6,7:i,8:s,9:20,11:65,13:7,14:r,15:o,16:n,17:a,18:8,19:h,20:l,21:c,22:9,23:d,24:11,25:5,26:u,28:10,29:22,30:23,31:24,33:25,36:28,38:32,40:40,44:47,49:55,50:p,51:_,52:56,56:57,58:f,59:26,60:27,61:29,62:30,63:31,65:b,67:34,68:35,69:36,70:41,71:42,72:43,73:44,74:g,75:m,76:v,77:Z,78:C,79:y,80:P,82:E,91:O,93:x},{20:[1,66]},{20:[1,67]},{8:s,9:69,16:[1,68],20:l,29:22,30:23,31:24,33:25,36:28,38:32,40:40,44:47,49:55,50:p,51:_,52:56,56:57,58:f,59:26,60:27,61:29,62:30,63:31,65:b,67:34,68:35,69:36,70:41,71:42,72:43,73:44,74:g,75:m,76:v,77:Z,78:C,79:y,80:P,82:E,91:O,93:x},{16:[1,70]},t(S,[2,11]),t(T,[2,23]),t(T,[2,24]),t([8,10,16,34,35,37,39,41,42,43,45,46,47,48,50,51,53,54,55,64,65,66,83,86],M,{32:[1,71],57:N}),t([8,10,16,32,35,39,41,42,43,45,46,47,48,50,51,53,54,55,57,64,65,66,83,86],[2,26],{34:[1,73],37:[1,74]}),t(A,[2,54],{88:77,8:k,64:[1,75],65:[1,76]}),t(A,[2,55],{88:79,8:k,64:[1,81],65:[1,80]}),t(R,[2,28],{39:D}),t(T,[2,56]),t(T,[2,57]),t(T,[2,58]),t(L,[2,30],{41:B,42:I,43:Y}),t(T,[2,61]),t(T,[2,62]),t(T,[2,63]),t(T,[2,64]),{8:s,9:86,20:l,29:22,30:23,31:24,33:25,36:28,38:32,40:40,44:47,49:55,50:p,51:_,52:56,56:57,58:f,59:26,60:27,61:29,62:30,63:31,65:b,67:34,68:35,69:36,70:41,71:42,72:43,73:44,74:g,75:m,76:v,77:Z,78:C,79:y,80:P,82:E,91:O,93:x},{8:[1,87]},{8:[1,88]},t(j,[2,32],{45:X,46:U,47:F,48:J}),t(T,[2,66]),t(T,[2,67]),t(T,[2,68]),t(T,[2,69]),{20:G,72:98,73:99,77:Z,78:C,79:y,80:P,83:[1,93],84:94,85:95,87:96},{8:s,20:l,29:102,30:23,31:24,33:25,36:28,38:32,40:40,44:47,49:55,50:p,51:_,52:56,56:57,58:f,59:26,60:27,61:29,62:30,63:31,65:b,66:[1,100],67:34,68:35,69:36,70:41,71:42,72:43,73:44,74:g,75:m,76:v,77:Z,78:C,79:y,80:P,81:101,82:E,91:O,93:x},t(z,[2,36],{50:H,51:W}),t(T,[2,70]),t(T,[2,71]),t(T,[2,72]),t(T,[2,73]),t(T,[2,74]),t(T,[2,75]),t(T,[2,76]),t(V,[2,41],{53:$,54:K,55:q}),t(T,[2,44]),t(T,[2,50]),{8:s,20:l,31:109,50:p,51:_,52:108,56:57,58:f,59:26,60:27,61:29,62:30,63:31,65:b,67:34,68:35,69:36,70:41,71:42,72:43,73:44,74:g,75:m,76:v,77:Z,78:C,79:y,80:P,82:E,91:O,93:x},{8:s,20:l,31:109,50:p,51:_,52:110,56:57,58:f,59:26,60:27,61:29,62:30,63:31,65:b,67:34,68:35,69:36,70:41,71:42,72:43,73:44,74:g,75:m,76:v,77:Z,78:C,79:y,80:P,82:E,91:O,93:x},{8:s,20:l,31:109,50:p,51:_,52:111,56:57,58:f,59:26,60:27,61:29,62:30,63:31,65:b,67:34,68:35,69:36,70:41,71:42,72:43,73:44,74:g,75:m,76:v,77:Z,78:C,79:y,80:P,82:E,91:O,93:x},{6:6,7:i,8:s,9:20,11:4,13:7,14:r,15:o,16:n,17:a,18:8,19:h,20:l,21:c,22:9,23:d,24:11,25:5,26:u,27:[1,112],28:10,29:22,30:23,31:24,33:25,36:28,38:32,40:40,44:47,49:55,50:p,51:_,52:56,56:57,58:f,59:26,60:27,61:29,62:30,63:31,65:b,67:34,68:35,69:36,70:41,71:42,72:43,73:44,74:g,75:m,76:v,77:Z,78:C,79:y,80:P,82:E,91:O,93:x},{8:s,9:113,20:l,29:22,30:23,31:24,33:25,36:28,38:32,40:40,44:47,49:55,50:p,51:_,52:56,56:57,58:f,59:26,60:27,61:29,62:30,63:31,65:b,67:34,68:35,69:36,70:41,71:42,72:43,73:44,74:g,75:m,76:v,77:Z,78:C,79:y,80:P,82:E,91:O,93:x},{8:s,9:114,20:l,29:22,30:23,31:24,33:25,36:28,38:32,40:40,44:47,49:55,50:p,51:_,52:56,56:57,58:f,59:26,60:27,61:29,62:30,63:31,65:b,67:34,68:35,69:36,70:41,71:42,72:43,73:44,74:g,75:m,76:v,77:Z,78:C,79:y,80:P,82:E,91:O,93:x},{8:s,9:115,20:l,29:22,30:23,31:24,33:25,36:28,38:32,40:40,44:47,49:55,50:p,51:_,52:56,56:57,58:f,59:26,60:27,61:29,62:30,63:31,65:b,67:34,68:35,69:36,70:41,71:42,72:43,73:44,74:g,75:m,76:v,77:Z,78:C,79:y,80:P,82:E,91:O,93:x},{14:[1,116]},t(S,[2,7]),t(S,[2,8]),t(S,[2,9]),{16:[1,117]},t(S,[2,22]),{8:s,20:l,29:118,30:23,31:24,33:25,36:28,38:32,40:40,44:47,49:55,50:p,51:_,52:56,56:57,58:f,59:26,60:27,61:29,62:30,63:31,65:b,67:34,68:35,69:36,70:41,71:42,72:43,73:44,74:g,75:m,76:v,77:Z,78:C,79:y,80:P,82:E,91:O,93:x},{8:s,20:l,31:109,50:p,51:_,52:119,56:57,58:f,59:26,60:27,61:29,62:30,63:31,65:b,67:34,68:35,69:36,70:41,71:42,72:43,73:44,74:g,75:m,76:v,77:Z,78:C,79:y,80:P,82:E,91:O,93:x},{8:s,20:l,29:120,30:23,31:24,33:25,36:28,38:32,40:40,44:47,49:55,50:p,51:_,52:56,56:57,58:f,59:26,60:27,61:29,62:30,63:31,65:b,67:34,68:35,69:36,70:41,71:42,72:43,73:44,74:g,75:m,76:v,77:Z,78:C,79:y,80:P,82:E,91:O,93:x},{8:s,20:l,31:109,36:121,38:32,40:40,44:47,49:55,50:p,51:_,52:56,56:57,58:f,59:26,60:27,61:29,62:30,63:31,65:b,67:34,68:35,69:36,70:41,71:42,72:43,73:44,74:g,75:m,76:v,77:Z,78:C,79:y,80:P,82:E,91:O,93:x},{20:[1,122]},{8:s,9:123,20:l,29:22,30:23,31:24,33:25,36:28,38:32,40:40,44:47,49:55,50:p,51:_,52:56,56:57,58:f,59:26,60:27,61:29,62:30,63:31,65:b,67:34,68:35,69:36,70:41,71:42,72:43,73:44,74:g,75:m,76:v,77:Z,78:C,79:y,80:P,82:E,91:O,93:x},t(T,[2,87],{89:124,90:125,68:127,20:Q,82:E}),{8:s,10:[1,128],20:l,29:102,30:23,31:24,33:25,36:28,38:32,40:40,44:47,49:55,50:p,51:_,52:56,56:57,58:f,59:26,60:27,61:29,62:30,63:31,65:b,67:34,68:35,69:36,70:41,71:42,72:43,73:44,74:g,75:m,76:v,77:Z,78:C,79:y,80:P,81:129,82:E,91:O,93:x},t(T,[2,89]),{8:s,9:130,20:l,29:22,30:23,31:24,33:25,36:28,38:32,40:40,44:47,49:55,50:p,51:_,52:56,56:57,58:f,59:26,60:27,61:29,62:30,63:31,65:b,67:34,68:35,69:36,70:41,71:42,72:43,73:44,74:g,75:m,76:v,77:Z,78:C,79:y,80:P,82:E,91:O,93:x},{20:[1,131]},{8:s,20:l,31:109,38:132,40:40,44:47,49:55,50:p,51:_,52:56,56:57,58:f,59:26,60:27,61:29,62:30,63:31,65:b,67:34,68:35,69:36,70:41,71:42,72:43,73:44,74:g,75:m,76:v,77:Z,78:C,79:y,80:P,82:E,91:O,93:x},{8:s,20:l,31:109,40:133,44:47,49:55,50:p,51:_,52:56,56:57,58:f,59:26,60:27,61:29,62:30,63:31,65:b,67:34,68:35,69:36,70:41,71:42,72:43,73:44,74:g,75:m,76:v,77:Z,78:C,79:y,80:P,82:E,91:O,93:x},{8:s,20:l,31:109,40:134,44:47,49:55,50:p,51:_,52:56,56:57,58:f,59:26,60:27,61:29,62:30,63:31,65:b,67:34,68:35,69:36,70:41,71:42,72:43,73:44,74:g,75:m,76:v,77:Z,78:C,79:y,80:P,82:E,91:O,93:x},{8:s,20:l,31:109,40:135,44:47,49:55,50:p,51:_,52:56,56:57,58:f,59:26,60:27,61:29,62:30,63:31,65:b,67:34,68:35,69:36,70:41,71:42,72:43,73:44,74:g,75:m,76:v,77:Z,78:C,79:y,80:P,82:E,91:O,93:x},{10:[1,136]},{10:[1,137],20:tt,92:138},{10:[1,140],20:tt,92:141},{8:s,20:l,31:109,44:142,49:55,50:p,51:_,52:56,56:57,58:f,59:26,60:27,61:29,62:30,63:31,65:b,67:34,68:35,69:36,70:41,71:42,72:43,73:44,74:g,75:m,76:v,77:Z,78:C,79:y,80:P,82:E,91:O,93:x},{8:s,20:l,31:109,44:143,49:55,50:p,51:_,52:56,56:57,58:f,59:26,60:27,61:29,62:30,63:31,65:b,67:34,68:35,69:36,70:41,71:42,72:43,73:44,74:g,75:m,76:v,77:Z,78:C,79:y,80:P,82:E,91:O,93:x},{8:s,20:l,31:109,44:144,49:55,50:p,51:_,52:56,56:57,58:f,59:26,60:27,61:29,62:30,63:31,65:b,67:34,68:35,69:36,70:41,71:42,72:43,73:44,74:g,75:m,76:v,77:Z,78:C,79:y,80:P,82:E,91:O,93:x},{8:s,20:l,31:109,44:145,49:55,50:p,51:_,52:56,56:57,58:f,59:26,60:27,61:29,62:30,63:31,65:b,67:34,68:35,69:36,70:41,71:42,72:43,73:44,74:g,75:m,76:v,77:Z,78:C,79:y,80:P,82:E,91:O,93:x},t(T,[2,79]),{83:[1,146],86:[1,147]},t(et,[2,81]),{35:[1,148]},{35:[2,84]},{35:[2,85]},{35:[2,86]},t(T,[2,77]),{66:[1,149],86:it},t(st,[2,98]),{8:s,20:l,31:109,49:151,50:p,51:_,52:56,56:57,58:f,59:26,60:27,61:29,62:30,63:31,65:b,67:34,68:35,69:36,70:41,71:42,72:43,73:44,74:g,75:m,76:v,77:Z,78:C,79:y,80:P,82:E,91:O,93:x},{8:s,20:l,31:109,49:152,50:p,51:_,52:56,56:57,58:f,59:26,60:27,61:29,62:30,63:31,65:b,67:34,68:35,69:36,70:41,71:42,72:43,73:44,74:g,75:m,76:v,77:Z,78:C,79:y,80:P,82:E,91:O,93:x},{8:s,20:l,31:109,50:p,51:_,52:153,56:57,58:f,59:26,60:27,61:29,62:30,63:31,65:b,67:34,68:35,69:36,70:41,71:42,72:43,73:44,74:g,75:m,76:v,77:Z,78:C,79:y,80:P,82:E,91:O,93:x},{8:s,20:l,31:109,50:p,51:_,52:154,56:57,58:f,59:26,60:27,61:29,62:30,63:31,65:b,67:34,68:35,69:36,70:41,71:42,72:43,73:44,74:g,75:m,76:v,77:Z,78:C,79:y,80:P,82:E,91:O,93:x},{8:s,20:l,31:109,50:p,51:_,52:155,56:57,58:f,59:26,60:27,61:29,62:30,63:31,65:b,67:34,68:35,69:36,70:41,71:42,72:43,73:44,74:g,75:m,76:v,77:Z,78:C,79:y,80:P,82:E,91:O,93:x},t(T,[2,51]),t([8,10,16,32,34,35,37,39,41,42,43,45,46,47,48,50,51,53,54,55,64,65,66,83,86],M,{57:N}),t(T,[2,52]),t(T,[2,53]),t([5,7,8,10,12,14,15,16,17,19,20,21,23,26,27,32,34,35,37,39,41,42,43,45,46,47,48,50,51,53,54,55,57,58,64,65,66,74,75,76,77,78,79,80,82,83,86,91,93],[2,12]),{10:[1,156]},{10:[1,157]},{16:[1,158]},{8:[1,159]},t(S,[2,10]),t(T,[2,25]),t(T,[2,49]),{35:[1,160]},t(R,[2,29],{39:D}),t(T,[2,59]),{66:[1,161]},t([8,10,16,32,34,35,37,39,41,42,43,45,46,47,48,50,51,53,54,55,57,64,65,66,83],[2,88],{86:[1,162]}),t(T,[2,94]),t(T,[2,96]),t(T,[2,97]),t(rt,[2,92]),{10:[1,163],86:it},{66:[1,164]},t(T,[2,91]),t(L,[2,31],{41:B,42:I,43:Y}),t(j,[2,33],{45:X,46:U,47:F,48:J}),t(j,[2,34],{45:X,46:U,47:F,48:J}),t(j,[2,35],{45:X,46:U,47:F,48:J}),t(T,[2,65]),{25:165,26:u},{10:[1,166],86:ot},t(nt,[2,104]),{94:[1,168]},{10:[1,169],86:ot},t(z,[2,37],{50:H,51:W}),t(z,[2,38],{50:H,51:W}),t(z,[2,39],{50:H,51:W}),t(z,[2,40],{50:H,51:W}),t(T,[2,80]),{20:G,72:98,73:99,77:Z,78:C,79:y,80:P,85:170,87:96},{8:s,20:l,29:171,30:23,31:24,33:25,36:28,38:32,40:40,44:47,49:55,50:p,51:_,52:56,56:57,58:f,59:26,60:27,61:29,62:30,63:31,65:b,67:34,68:35,69:36,70:41,71:42,72:43,73:44,74:g,75:m,76:v,77:Z,78:C,79:y,80:P,82:E,91:O,93:x},t(T,[2,78]),{8:s,20:l,29:172,30:23,31:24,33:25,36:28,38:32,40:40,44:47,49:55,50:p,51:_,52:56,56:57,58:f,59:26,60:27,61:29,62:30,63:31,65:b,67:34,68:35,69:36,70:41,71:42,72:43,73:44,74:g,75:m,76:v,77:Z,78:C,79:y,80:P,82:E,91:O,93:x},t(V,[2,42],{53:$,54:K,55:q}),t(V,[2,43],{53:$,54:K,55:q}),t(T,[2,45]),t(T,[2,46]),t(T,[2,47]),{6:6,7:i,8:s,9:20,11:173,13:7,14:r,15:o,16:n,17:a,18:8,19:h,20:l,21:c,22:9,23:d,24:11,25:5,26:u,28:10,29:22,30:23,31:24,33:25,36:28,38:32,40:40,44:47,49:55,50:p,51:_,52:56,56:57,58:f,59:26,60:27,61:29,62:30,63:31,65:b,67:34,68:35,69:36,70:41,71:42,72:43,73:44,74:g,75:m,76:v,77:Z,78:C,79:y,80:P,82:E,91:O,93:x},{6:6,7:i,8:s,9:20,11:174,13:7,14:r,15:o,16:n,17:a,18:8,19:h,20:l,21:c,22:9,23:d,24:11,25:5,26:u,28:10,29:22,30:23,31:24,33:25,36:28,38:32,40:40,44:47,49:55,50:p,51:_,52:56,56:57,58:f,59:26,60:27,61:29,62:30,63:31,65:b,67:34,68:35,69:36,70:41,71:42,72:43,73:44,74:g,75:m,76:v,77:Z,78:C,79:y,80:P,82:E,91:O,93:x},{8:s,9:175,20:l,29:22,30:23,31:24,33:25,36:28,38:32,40:40,44:47,49:55,50:p,51:_,52:56,56:57,58:f,59:26,60:27,61:29,62:30,63:31,65:b,67:34,68:35,69:36,70:41,71:42,72:43,73:44,74:g,75:m,76:v,77:Z,78:C,79:y,80:P,82:E,91:O,93:x},{8:s,9:176,20:l,29:22,30:23,31:24,33:25,36:28,38:32,40:40,44:47,49:55,50:p,51:_,52:56,56:57,58:f,59:26,60:27,61:29,62:30,63:31,65:b,67:34,68:35,69:36,70:41,71:42,72:43,73:44,74:g,75:m,76:v,77:Z,78:C,79:y,80:P,82:E,91:O,93:x},{8:s,20:l,29:177,30:23,31:24,33:25,36:28,38:32,40:40,44:47,49:55,50:p,51:_,52:56,56:57,58:f,59:26,60:27,61:29,62:30,63:31,65:b,67:34,68:35,69:36,70:41,71:42,72:43,73:44,74:g,75:m,76:v,77:Z,78:C,79:y,80:P,82:E,91:O,93:x},t(T,[2,60]),{20:Q,68:127,82:E,90:178},t(rt,[2,93]),t(T,[2,90]),t(T,[2,100]),{25:179,26:u},{20:[1,180]},{8:s,9:181,20:l,29:22,30:23,31:24,33:25,36:28,38:32,40:40,44:47,49:55,50:p,51:_,52:56,56:57,58:f,59:26,60:27,61:29,62:30,63:31,65:b,67:34,68:35,69:36,70:41,71:42,72:43,73:44,74:g,75:m,76:v,77:Z,78:C,79:y,80:P,82:E,91:O,93:x},{94:[1,182]},t(et,[2,82]),t(et,[2,83]),t(st,[2,99]),t(w,[2,2],{12:[1,183]}),t(S,[2,4]),{16:[1,184]},{10:[1,185]},t(T,[2,27]),t(T,[2,95]),t(T,[2,101]),t(nt,[2,105]),t(T,[2,102]),{8:s,9:186,20:l,29:22,30:23,31:24,33:25,36:28,38:32,40:40,44:47,49:55,50:p,51:_,52:56,56:57,58:f,59:26,60:27,61:29,62:30,63:31,65:b,67:34,68:35,69:36,70:41,71:42,72:43,73:44,74:g,75:m,76:v,77:Z,78:C,79:y,80:P,82:E,91:O,93:x},{6:6,7:i,8:s,9:20,11:187,13:7,14:r,15:o,16:n,17:a,18:8,19:h,20:l,21:c,22:9,23:d,24:11,25:5,26:u,28:10,29:22,30:23,31:24,33:25,36:28,38:32,40:40,44:47,49:55,50:p,51:_,52:56,56:57,58:f,59:26,60:27,61:29,62:30,63:31,65:b,67:34,68:35,69:36,70:41,71:42,72:43,73:44,74:g,75:m,76:v,77:Z,78:C,79:y,80:P,82:E,91:O,93:x},{8:s,9:188,20:l,29:22,30:23,31:24,33:25,36:28,38:32,40:40,44:47,49:55,50:p,51:_,52:56,56:57,58:f,59:26,60:27,61:29,62:30,63:31,65:b,67:34,68:35,69:36,70:41,71:42,72:43,73:44,74:g,75:m,76:v,77:Z,78:C,79:y,80:P,82:E,91:O,93:x},{16:[1,189]},t(T,[2,103]),t(S,[2,3]),{10:[1,190]},t(S,[2,6]),{6:6,7:i,8:s,9:20,11:191,13:7,14:r,15:o,16:n,17:a,18:8,19:h,20:l,21:c,22:9,23:d,24:11,25:5,26:u,28:10,29:22,30:23,31:24,33:25,36:28,38:32,40:40,44:47,49:55,50:p,51:_,52:56,56:57,58:f,59:26,60:27,61:29,62:30,63:31,65:b,67:34,68:35,69:36,70:41,71:42,72:43,73:44,74:g,75:m,76:v,77:Z,78:C,79:y,80:P,82:E,91:O,93:x},t(S,[2,5])],defaultActions:{3:[2,1],97:[2,84],98:[2,85],99:[2,86]},parseError:function(t,e){if(!e.recoverable){var i=new Error(t);throw i.hash=e,i}this.trace(t)},parse:function(t){var e=this,i=[0],s=[null],r=[],o=this.table,n="",a=0,h=0,l=0,c=r.slice.call(arguments,1),d=Object.create(this.lexer),u={yy:{}};for(var p in this.yy)Object.prototype.hasOwnProperty.call(this.yy,p)&&(u.yy[p]=this.yy[p]);d.setInput(t,u.yy),u.yy.lexer=d,u.yy.parser=this,void 0===d.yylloc&&(d.yylloc={});var _=d.yylloc;r.push(_);var f=d.options&&d.options.ranges;"function"==typeof u.yy.parseError?this.parseError=u.yy.parseError:this.parseError=Object.getPrototypeOf(this).parseError;for(var b,g,m,v,Z,C,y,P,E,O=function(){var t;return"number"!=typeof(t=d.lex()||1)&&(t=e.symbols_[t]||t),t},x={};;){if(m=i[i.length-1],this.defaultActions[m]?v=this.defaultActions[m]:(null==b&&(b=O()),v=o[m]&&o[m][b]),void 0===v||!v.length||!v[0]){var w="";for(C in E=[],o[m])this.terminals_[C]&&C>2&&E.push("'"+this.terminals_[C]+"'");w=d.showPosition?"Parse error on line "+(a+1)+":\n"+d.showPosition()+"\nExpecting "+E.join(", ")+", got '"+(this.terminals_[b]||b)+"'":"Parse error on line "+(a+1)+": Unexpected "+(1==b?"end of input":"'"+(this.terminals_[b]||b)+"'"),this.parseError(w,{text:d.match,token:this.terminals_[b]||b,line:d.yylineno,loc:_,expected:E})}if(v[0]instanceof Array&&v.length>1)throw new Error("Parse Error: multiple actions possible at state: "+m+", token: "+b);switch(v[0]){case 1:i.push(b),s.push(d.yytext),r.push(d.yylloc),i.push(v[1]),b=null,g?(b=g,g=null):(h=d.yyleng,n=d.yytext,a=d.yylineno,_=d.yylloc,l>0&&l--);break;case 2:if(y=this.productions_[v[1]][1],x.$=s[s.length-y],x._$={first_line:r[r.length-(y||1)].first_line,last_line:r[r.length-1].last_line,first_column:r[r.length-(y||1)].first_column,last_column:r[r.length-1].last_column},f&&(x._$.range=[r[r.length-(y||1)].range[0],r[r.length-1].range[1]]),void 0!==(Z=this.performAction.apply(x,[n,h,a,u.yy,v[1],s,r].concat(c))))return Z;y&&(i=i.slice(0,-1*y*2),s=s.slice(0,-1*y),r=r.slice(0,-1*y)),i.push(this.productions_[v[1]][0]),s.push(x.$),r.push(x._$),P=o[i[i.length-2]][i[i.length-1]],i.push(P);break;case 3:return!0}}return!0}},ht={node:function(t,e,i){return{type:t,value:e,children:i}},createNode:function(t,e,i,s){var r,o=this.node(e,i,[]);for(r=3;r<arguments.length;r++)o.children.push(arguments[r]);return o.line=t[0],o.col=t[1],o.eline=t[2],o.ecol=t[3],o}},lt=function(t){return[t.first_line,t.first_column,t.last_line,t.last_column]},ct=function(){var t={EOF:1,parseError:function(t,e){if(!this.yy.parser)throw new Error(t);this.yy.parser.parseError(t,e)},setInput:function(t,e){return this.yy=e||this.yy||{},this._input=t,this._more=this._backtrack=this.done=!1,this.yylineno=this.yyleng=0,this.yytext=this.matched=this.match="",this.conditionStack=["INITIAL"],this.yylloc={first_line:1,first_column:0,last_line:1,last_column:0},this.options.ranges&&(this.yylloc.range=[0,0]),this.offset=0,this},input:function(){var t=this._input[0];return this.yytext+=t,this.yyleng++,this.offset++,this.match+=t,this.matched+=t,t.match(/(?:\r\n?|\n).*/g)?(this.yylineno++,this.yylloc.last_line++):this.yylloc.last_column++,this.options.ranges&&this.yylloc.range[1]++,this._input=this._input.slice(1),t},unput:function(t){var e=t.length,i=t.split(/(?:\r\n?|\n)/g);this._input=t+this._input,this.yytext=this.yytext.substr(0,this.yytext.length-e),this.offset-=e;var s=this.match.split(/(?:\r\n?|\n)/g);this.match=this.match.substr(0,this.match.length-1),this.matched=this.matched.substr(0,this.matched.length-1),i.length-1&&(this.yylineno-=i.length-1);var r=this.yylloc.range;return this.yylloc={first_line:this.yylloc.first_line,last_line:this.yylineno+1,first_column:this.yylloc.first_column,last_column:i?(i.length===s.length?this.yylloc.first_column:0)+s[s.length-i.length].length-i[0].length:this.yylloc.first_column-e},this.options.ranges&&(this.yylloc.range=[r[0],r[0]+this.yyleng-e]),this.yyleng=this.yytext.length,this},more:function(){return this._more=!0,this},reject:function(){return this.options.backtrack_lexer?(this._backtrack=!0,this):this.parseError("Lexical error on line "+(this.yylineno+1)+". You can only invoke reject() in the lexer when the lexer is of the backtracking persuasion (options.backtrack_lexer = true).\n"+this.showPosition(),{text:"",token:null,line:this.yylineno})},less:function(t){this.unput(this.match.slice(t))},pastInput:function(){var t=this.matched.substr(0,this.matched.length-this.match.length);return(t.length>20?"...":"")+t.substr(-20).replace(/\n/g,"")},upcomingInput:function(){var t=this.match;return t.length<20&&(t+=this._input.substr(0,20-t.length)),(t.substr(0,20)+(t.length>20?"...":"")).replace(/\n/g,"")},showPosition:function(){var t=this.pastInput(),e=new Array(t.length+1).join("-");return t+this.upcomingInput()+"\n"+e+"^"},test_match:function(t,e){var i,s,r;if(this.options.backtrack_lexer&&(r={yylineno:this.yylineno,yylloc:{first_line:this.yylloc.first_line,last_line:this.last_line,first_column:this.yylloc.first_column,last_column:this.yylloc.last_column},yytext:this.yytext,match:this.match,matches:this.matches,matched:this.matched,yyleng:this.yyleng,offset:this.offset,_more:this._more,_input:this._input,yy:this.yy,conditionStack:this.conditionStack.slice(0),done:this.done},this.options.ranges&&(r.yylloc.range=this.yylloc.range.slice(0))),(s=t[0].match(/(?:\r\n?|\n).*/g))&&(this.yylineno+=s.length),this.yylloc={first_line:this.yylloc.last_line,last_line:this.yylineno+1,first_column:this.yylloc.last_column,last_column:s?s[s.length-1].length-s[s.length-1].match(/\r?\n?/)[0].length:this.yylloc.last_column+t[0].length},this.yytext+=t[0],this.match+=t[0],this.matches=t,this.yyleng=this.yytext.length,this.options.ranges&&(this.yylloc.range=[this.offset,this.offset+=this.yyleng]),this._more=!1,this._backtrack=!1,this._input=this._input.slice(t[0].length),this.matched+=t[0],i=this.performAction.call(this,this.yy,this,e,this.conditionStack[this.conditionStack.length-1]),this.done&&this._input&&(this.done=!1),i)return i;if(this._backtrack){for(var o in r)this[o]=r[o];return!1}return!1},next:function(){if(this.done)return this.EOF;var t,e,i,s;this._input||(this.done=!0),this._more||(this.yytext="",this.match="");for(var r=this._currentRules(),o=0;o<r.length;o++)if((i=this._input.match(this.rules[r[o]]))&&(!e||i[0].length>e[0].length)){if(e=i,s=o,this.options.backtrack_lexer){if(!1!==(t=this.test_match(i,r[o])))return t;if(this._backtrack){e=!1;continue}return!1}if(!this.options.flex)break}return e?!1!==(t=this.test_match(e,r[s]))&&t:""===this._input?this.EOF:this.parseError("Lexical error on line "+(this.yylineno+1)+". Unrecognized text.\n"+this.showPosition(),{text:"",token:null,line:this.yylineno})},lex:function(){var t=this.next();return t||this.lex()},begin:function(t){this.conditionStack.push(t)},popState:function(){return this.conditionStack.length-1>0?this.conditionStack.pop():this.conditionStack[0]},_currentRules:function(){return this.conditionStack.length&&this.conditionStack[this.conditionStack.length-1]?this.conditions[this.conditionStack[this.conditionStack.length-1]].rules:this.conditions.INITIAL.rules},topState:function(t){return(t=this.conditionStack.length-1-Math.abs(t||0))>=0?this.conditionStack[t]:"INITIAL"},pushState:function(t){this.begin(t)},stateStackSize:function(){return this.conditionStack.length},options:{},performAction:function(t,e,i,s){switch(i){case 0:case 5:case 6:break;case 1:case 2:return 78;case 3:case 4:return 77;case 7:return 7;case 8:return 12;case 9:return 14;case 10:return 17;case 11:return 15;case 12:return 91;case 13:return 93;case 14:return 19;case 15:return 23;case 16:return 21;case 17:return 75;case 18:return 76;case 19:return 74;case 20:return 80;case 21:case 22:return 94;case 23:return 82;case 24:return 83;case 25:return 26;case 26:return 27;case 27:return 16;case 28:return"#";case 29:return 34;case 30:return 35;case 31:return 79;case 32:return 64;case 33:return 65;case 34:return 66;case 35:return 8;case 36:return 10;case 37:return 58;case 38:return 57;case 39:return 53;case 40:return 54;case 41:return 55;case 42:return 50;case 43:return 51;case 44:return 47;case 45:return 45;case 46:return 48;case 47:return 46;case 48:return 41;case 49:return 43;case 50:return 42;case 51:return 39;case 52:return 37;case 53:return 32;case 54:return 86;case 55:return 5;case 56:return 20;case 57:return"INVALID"}},rules:[/^(?:\s+)/,/^(?:[0-9]+\.[0-9]*|[0-9]*\.[0-9]+\b)/,/^(?:[0-9]+)/,/^(?:"(\\["]|[^"])*")/,/^(?:'(\\[']|[^'])*')/,/^(?:\/\/.*)/,/^(?:\/\*(.|\n|\r)*?\*\/)/,/^(?:if\b)/,/^(?:else\b)/,/^(?:while\b)/,/^(?:do\b)/,/^(?:for\b)/,/^(?:function\b)/,/^(?:map\b)/,/^(?:use\b)/,/^(?:return\b)/,/^(?:delete\b)/,/^(?:true\b)/,/^(?:false\b)/,/^(?:null\b)/,/^(?:Infinity\b)/,/^(?:->)/,/^(?:=>)/,/^(?:<<)/,/^(?:>>)/,/^(?:\{)/,/^(?:\})/,/^(?:;)/,/^(?:#)/,/^(?:\?)/,/^(?::)/,/^(?:NaN\b)/,/^(?:\.)/,/^(?:\[)/,/^(?:\])/,/^(?:\()/,/^(?:\))/,/^(?:!)/,/^(?:\^)/,/^(?:\*)/,/^(?:\/)/,/^(?:%)/,/^(?:\+)/,/^(?:-)/,/^(?:<=)/,/^(?:<)/,/^(?:>=)/,/^(?:>)/,/^(?:==)/,/^(?:~=)/,/^(?:!=)/,/^(?:&&)/,/^(?:\|\|)/,/^(?:=)/,/^(?:,)/,/^(?:$)/,/^(?:[A-Za-z_\$][A-Za-z0-9_]*)/,/^(?:.)/],conditions:{INITIAL:{rules:[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57],inclusive:!0}}};return t}();function dt(){this.yy={}}return at.lexer=ct,dt.prototype=at,at.Parser=dt,new dt}();parser.yy.parseError=parser.parseError;const __WEBPACK_DEFAULT_EXPORT__=_jxg__WEBPACK_IMPORTED_MODULE_0__.Z.JessieCode},327:(t,e,i)=>{i.d(e,{Z:()=>h});var s=i(765),r=i(109),o=i(275),n={aliceblue:"f0f8ff",antiquewhite:"faebd7",aqua:"00ffff",aquamarine:"7fffd4",azure:"f0ffff",beige:"f5f5dc",bisque:"ffe4c4",black:"000000",blanchedalmond:"ffebcd",blue:"0000ff",blueviolet:"8a2be2",brown:"a52a2a",burlywood:"deb887",cadetblue:"5f9ea0",chartreuse:"7fff00",chocolate:"d2691e",coral:"ff7f50",cornflowerblue:"6495ed",cornsilk:"fff8dc",crimson:"dc143c",cyan:"00ffff",darkblue:"00008b",darkcyan:"008b8b",darkgoldenrod:"b8860b",darkgray:"a9a9a9",darkgreen:"006400",darkkhaki:"bdb76b",darkmagenta:"8b008b",darkolivegreen:"556b2f",darkorange:"ff8c00",darkorchid:"9932cc",darkred:"8b0000",darksalmon:"e9967a",darkseagreen:"8fbc8f",darkslateblue:"483d8b",darkslategray:"2f4f4f",darkturquoise:"00ced1",darkviolet:"9400d3",deeppink:"ff1493",deepskyblue:"00bfff",dimgray:"696969",dodgerblue:"1e90ff",feldspar:"d19275",firebrick:"b22222",floralwhite:"fffaf0",forestgreen:"228b22",fuchsia:"ff00ff",gainsboro:"dcdcdc",ghostwhite:"f8f8ff",gold:"ffd700",goldenrod:"daa520",gray:"808080",green:"008000",greenyellow:"adff2f",honeydew:"f0fff0",hotpink:"ff69b4",indianred:"cd5c5c",indigo:"4b0082",ivory:"fffff0",khaki:"f0e68c",lavender:"e6e6fa",lavenderblush:"fff0f5",lawngreen:"7cfc00",lemonchiffon:"fffacd",lightblue:"add8e6",lightcoral:"f08080",lightcyan:"e0ffff",lightgoldenrodyellow:"fafad2",lightgrey:"d3d3d3",lightgreen:"90ee90",lightpink:"ffb6c1",lightsalmon:"ffa07a",lightseagreen:"20b2aa",lightskyblue:"87cefa",lightslateblue:"8470ff",lightslategray:"778899",lightsteelblue:"b0c4de",lightyellow:"ffffe0",lime:"00ff00",limegreen:"32cd32",linen:"faf0e6",magenta:"ff00ff",maroon:"800000",mediumaquamarine:"66cdaa",mediumblue:"0000cd",mediumorchid:"ba55d3",mediumpurple:"9370d8",mediumseagreen:"3cb371",mediumslateblue:"7b68ee",mediumspringgreen:"00fa9a",mediumturquoise:"48d1cc",mediumvioletred:"c71585",midnightblue:"191970",mintcream:"f5fffa",mistyrose:"ffe4e1",moccasin:"ffe4b5",navajowhite:"ffdead",navy:"000080",oldlace:"fdf5e6",olive:"808000",olivedrab:"6b8e23",orange:"ffa500",orangered:"ff4500",orchid:"da70d6",palegoldenrod:"eee8aa",palegreen:"98fb98",paleturquoise:"afeeee",palevioletred:"d87093",papayawhip:"ffefd5",peachpuff:"ffdab9",peru:"cd853f",pink:"ffc0cb",plum:"dda0dd",powderblue:"b0e0e6",purple:"800080",red:"ff0000",rosybrown:"bc8f8f",royalblue:"4169e1",saddlebrown:"8b4513",salmon:"fa8072",sandybrown:"f4a460",seagreen:"2e8b57",seashell:"fff5ee",sienna:"a0522d",silver:"c0c0c0",skyblue:"87ceeb",slateblue:"6a5acd",slategray:"708090",snow:"fffafa",springgreen:"00ff7f",steelblue:"4682b4",tan:"d2b48c",teal:"008080",thistle:"d8bfd8",tomato:"ff6347",turquoise:"40e0d0",violet:"ee82ee",violetred:"d02090",wheat:"f5deb3",white:"ffffff",whitesmoke:"f5f5f5",yellow:"ffff00",yellowgreen:"9acd32"},a=[{re:/^\s*rgba\(\s*(\d{1,3})\s*,\s*(\d{1,3})\s*,\s*(\d{1,3})\s*,\s*([\d.]{1,3})\s*\)\s*$/,example:["rgba(123, 234, 45, 0.5)","rgba(255,234,245,1.0)"],process:function(t){return[parseInt(t[1],10),parseInt(t[2],10),parseInt(t[3],10)]}},{re:/^\s*rgb\(\s*(\d{1,3})\s*,\s*(\d{1,3})\s*,\s*(\d{1,3})\s*\)\s*$/,example:["rgb(123, 234, 45)","rgb(255,234,245)"],process:function(t){return[parseInt(t[1],10),parseInt(t[2],10),parseInt(t[3],10)]}},{re:/^(\w{2})(\w{2})(\w{2})$/,example:["#00ff00","336699"],process:function(t){return[parseInt(t[1],16),parseInt(t[2],16),parseInt(t[3],16)]}},{re:/^(\w{1})(\w{1})(\w{1})$/,example:["#fb0","f0f"],process:function(t){return[parseInt(t[1]+t[1],16),parseInt(t[2]+t[2],16),parseInt(t[3]+t[3],16)]}}];s.Z.rgbParser=function(t,e,i){var s,o,h,l,c,d,u,p,_,f,b=t;if(!r.Z.exists(t))return[];if(r.Z.exists(e)&&r.Z.exists(i)&&(b=[t,e,i]),s=b,f=!1,r.Z.isArray(s)){for(d=0;d<3;d++)f=f||/\./.test(b[d].toString());for(d=0;d<3;d++)f=f&&b[d]>=0&&b[d]<=1;return f?[Math.ceil(255*b[0]),Math.ceil(255*b[1]),Math.ceil(255*b[2])]:b}for("string"==typeof b&&(s=b),"#"===s.charAt(0)&&(s=s.substr(1,6)),s=s.replace(/ /g,"").toLowerCase(),s=n[s]||s,d=0;d<a.length;d++)h=a[d].re,l=a[d].process,(c=h.exec(s))&&(u=(o=l(c))[0],p=o[1],_=o[2]);return isNaN(u)||isNaN(p)||isNaN(_)?[]:[u=u<0||isNaN(u)?0:u>255?255:u,p=p<0||isNaN(p)?0:p>255?255:p,_=_<0||isNaN(_)?0:_>255?255:_]},s.Z.rgb2css=function(t,e,i){var r;return"rgb("+(r=s.Z.rgbParser(t,e,i))[0]+", "+r[1]+", "+r[2]+")"},s.Z.rgb2hex=function(t,e,i){var r,o,n;return o=(r=s.Z.rgbParser(t,e,i))[1],n=r[2],r=(r=r[0]).toString(16),o=o.toString(16),n=n.toString(16),1===r.length&&(r="0"+r),1===o.length&&(o="0"+o),1===n.length&&(n="0"+n),"#"+r+o+n},s.Z.hex2rgb=function(t){return s.Z.deprecated("JXG.hex2rgb()","JXG.rgb2css()"),s.Z.rgb2css(t)},s.Z.hsv2rgb=function(t,e,i){var s,r,n,a,h,l,c,d,u;if(t=(t%360+360)%360,0===e){if(!(isNaN(t)||t<o.Z.eps))return"#ffffff";s=i,r=i,n=i}else switch(l=t>=360?0:t,c=i*(1-e),d=i*(1-e*(a=(l/=60)-(h=Math.floor(l)))),u=i*(1-e*(1-a)),h){case 0:s=i,r=u,n=c;break;case 1:s=d,r=i,n=c;break;case 2:s=c,r=i,n=u;break;case 3:s=c,r=d,n=i;break;case 4:s=u,r=c,n=i;break;case 5:s=i,r=c,n=d}return["#",s=2===(s=Math.round(255*s).toString(16)).length?s:1===s.length?"0"+s:"00",r=2===(r=Math.round(255*r).toString(16)).length?r:1===r.length?"0"+r:"00",n=2===(n=Math.round(255*n).toString(16)).length?n:1===n.length?"0"+n:"00"].join("")},s.Z.rgb2hsv=function(t,e,i){var r,o,n,a,h,l,c,d,u,p,_,f,b;return o=(r=s.Z.rgbParser(t,e,i))[1],n=r[2],a=(r=r[0])/255,h=o/255,l=n/255,f=Math.max(r,o,n),d=(b=Math.min(r,o,n))/255,p=0,(_=c=f/255)>0&&(p=(_-d)/_),u=1/(c-d),p>0&&(f===r?u*=h-l:u=f===o?2+(l-a)*u:4+(a-h)*u),(u*=60)<0&&(u+=360),f===b&&(u=0),[u,p,_]},s.Z.rgb2LMS=function(t,e,i){var r,o,n,a,h,l,c,d=[[.05059983,.08585369,.0095242],[.01893033,.08925308,.01370054],[.00292202,.00975732,.07145979]];return o=(r=s.Z.rgbParser(t,e,i))[1],n=r[2],r=r[0],r=Math.pow(r,.476190476),o=Math.pow(o,.476190476),n=Math.pow(n,.476190476),(c=[a=r*d[0][0]+o*d[0][1]+n*d[0][2],h=r*d[1][0]+o*d[1][1]+n*d[1][2],l=r*d[2][0]+o*d[2][1]+n*d[2][2]]).l=a,c.m=h,c.s=l,c},s.Z.LMS2rgb=function(t,e,i){var s,r,o,n,a=[[30.830854,-29.832659,1.610474],[-6.481468,17.715578,-2.532642],[-.37569,-1.199062,14.273846]],h=function(t){for(var e=127,i=64;i>0;){if(Math.pow(e,.476190476)>t)e-=i;else{if(Math.pow(e+1,.476190476)>t)return e;e+=i}i/=2}return 254===e&&13.994955247<t?255:e};return s=t*a[0][0]+e*a[0][1]+i*a[0][2],r=t*a[1][0]+e*a[1][1]+i*a[1][2],o=t*a[2][0]+e*a[2][1]+i*a[2][2],(n=[s=h(s),r=h(r),o=h(o)]).r=s,n.g=r,n.b=o,n},s.Z.rgba2rgbo=function(t){var e;return 9===t.length&&"#"===t.charAt(0)?(e=parseInt(t.substr(7,2).toUpperCase(),16)/255,t=t.substr(0,7)):e=1,[t,e]},s.Z.rgbo2rgba=function(t,e){var i;return"none"===t?t:(1===(i=Math.round(255*e).toString(16)).length&&(i="0"+i),t+i)},s.Z.rgb2bw=function(t){var e,i,r,o="0123456789ABCDEF";return"none"===t?t:(r=s.Z.rgbParser(t),e=Math.floor(.3*r[0]+.59*r[1]+.11*r[2]),t="#"+(i=o.charAt(e>>4&15)+o.charAt(15&e))+i+i)},s.Z.rgb2cb=function(t,e){var i,r,o,n,a,h,l,c,d,u,p,_="0123456789ABCDEF";if("none"===t)return t;switch(r=(a=s.Z.rgb2LMS(t))[0],o=a[1],n=a[2],e=e.toLowerCase()){case"protanopia":h=-.06150039994295001,l=.08277001656812001,c=-.013200141220000003,d=.05858939668799999,u=-.07934519995360001,p=.013289415272000003,r=n/o<.6903216543277437?-(l*o+c*n)/h:-(u*o+p*n)/d;break;case"tritanopia":h=-.00058973116217,l=.007690316482,c=-.01011703519052,d=.025495080838999994,u=-.0422740347,p=.017005316784,n=o/r<.8349489908460004?-(h*r+l*o)/c:-(d*r+u*o)/p;break;default:h=-.06150039994295001,l=.08277001656812001,c=-.013200141220000003,d=.05858939668799999,u=-.07934519995360001,p=.013289415272000003,o=n/r<.5763833686400911?-(h*r+c*n)/l:-(d*r+p*n)/u}return i=s.Z.LMS2rgb(r,o,n),t="#"+(_.charAt(i[0]>>4&15)+_.charAt(15&i[0])),t+=_.charAt(i[1]>>4&15)+_.charAt(15&i[1]),t+=_.charAt(i[2]>>4&15)+_.charAt(15&i[2])},s.Z.autoHighlight=function(t){var e=s.Z.rgba2rgbo(t),i=e[0],r=e[1];return"#"===t.charAt(0)?(r*=r<.3?1.8:.4,s.Z.rgbo2rgba(i,r)):t},s.Z.contrast=function(t,e,i,r){var o,n,a,h,l;return e=e||"#000000",i=i||"#ffffff",r=r||7,o=s.Z.rgbParser(t),n=s.Z.rgbParser("#000000"),l=(a=.2126*Math.pow(o[0]/255,2.2)+.7152*Math.pow(o[1]/255,2.2)+.0722*Math.pow(o[2]/255,2.2))>(h=.2126*Math.pow(n[0]/255,2.2)+.7152*Math.pow(n[1]/255,2.2)+.0722*Math.pow(n[2]/255,2.2))?Math.floor((a+.05)/(h+.05)):Math.floor((h+.05)/(a+.05)),(l-=1)>r?e:i},s.Z.setClassicColors=function(){s.Z.Options.elements.strokeColor="blue",s.Z.Options.elements.fillColor="red",s.Z.Options.hatch.strokeColor="blue",s.Z.Options.angle.fillColor="#ff7f00",s.Z.Options.angle.highlightFillColor="#ff7f00",s.Z.Options.angle.strokeColor="#ff7f00",s.Z.Options.angle.label.strokeColor="blue",s.Z.Options.arc.strokeColor="blue",s.Z.Options.circle.center.fillColor="red",s.Z.Options.circle.center.strokeColor="blue",s.Z.Options.circumcircle.strokeColor="blue",s.Z.Options.circumcircle.center.fillColor="red",s.Z.Options.circumcircle.center.strokeColor="blue",s.Z.Options.circumcirclearc.strokeColor="blue",s.Z.Options.circumcirclesector.strokeColor="blue",s.Z.Options.circumcirclesector.fillColor="green",s.Z.Options.circumcirclesector.highlightFillColor="green",s.Z.Options.conic.strokeColor="blue",s.Z.Options.curve.strokeColor="blue",s.Z.Options.incircle.strokeColor="blue",s.Z.Options.incircle.center.fillColor="red",s.Z.Options.incircle.center.strokeColor="blue",s.Z.Options.inequality.fillColor="red",s.Z.Options.integral.fillColor="red",s.Z.Options.integral.curveLeft.color="red",s.Z.Options.integral.curveRight.color="red",s.Z.Options.line.strokeColor="blue",s.Z.Options.point.fillColor="red",s.Z.Options.point.strokeColor="red",s.Z.Options.polygon.fillColor="green",s.Z.Options.polygon.highlightFillColor="green",s.Z.Options.polygon.vertices.strokeColor="red",s.Z.Options.polygon.vertices.fillColor="red",s.Z.Options.regularpolygon.fillColor="green",s.Z.Options.regularpolygon.highlightFillColor="green",s.Z.Options.regularpolygon.vertices.strokeColor="red",s.Z.Options.regularpolygon.vertices.fillColor="red",s.Z.Options.riemannsum.fillColor="yellow",s.Z.Options.sector.fillColor="green",s.Z.Options.sector.highlightFillColor="green",s.Z.Options.semicircle.center.fillColor="red",s.Z.Options.semicircle.center.strokeColor="blue",s.Z.Options.slopetriangle.fillColor="red",s.Z.Options.slopetriangle.highlightFillColor="red",s.Z.Options.turtle.arrow.strokeColor="blue"},s.Z.extend(s.Z,{paletteWong:{black:"#000000",orange:"#E69F00",skyblue:"#56B4E9",bluishgreen:"#009E73",yellow:"#F0E442",darkblue:"#0072B2",vermillion:"#D55E00",reddishpurple:"#CC79A7",blue:"#0072B2",red:"#D55E00",green:"#009E73",purple:"#CC79A7",white:"#ffffff"}}),s.Z.palette=s.Z.paletteWong;const h=s.Z},503:(t,e,i)=>{i.d(e,{Z:()=>o});var s=i(765),r=i(109);s.Z.extendConstants(s.Z,{touchProperty:"touches"}),s.Z.extend(s.Z,{isTouchEvent:function(t){return s.Z.exists(t[s.Z.touchProperty])},isPointerEvent:function(t){return s.Z.exists(t.pointerId)},isMouseEvent:function(t){return!s.Z.isTouchEvent(t)&&!s.Z.isPointerEvent(t)},getNumberOfTouchPoints:function(t){var e=-1;return s.Z.isTouchEvent(t)&&(e=t[s.Z.touchProperty].length),e},isFirstTouch:function(t){var e=s.Z.getNumberOfTouchPoints(t);return s.Z.isPointerEvent(t)?t.isPrimary:1===e},isBrowser:"object"==typeof window&&"object"==typeof document,supportsES6:function(){try{return new Function("(a = 0) => a"),!0}catch(t){return!1}},supportsVML:function(){return this.isBrowser&&!!document.namespaces},supportsSVG:function(){return!!this.isBrowser&&(!!document.createElementNS&&!!document.createElementNS("http://www.w3.org/2000/svg","svg").createSVGRect)},supportsCanvas:function(){var t=!1;return this.isNode()&&(t=!0),t||this.isBrowser&&!!document.createElement("canvas").getContext},isNode:function(){return!this.isBrowser&&"undefined"!=typeof process&&-1!==process.release.name.search(/node|io.js/)},isWebWorker:function(){return!this.isBrowser&&"object"==typeof self&&"function"==typeof self.postMessage},supportsPointerEvents:function(){return!!(this.isBrowser&&window.navigator&&(window.PointerEvent||window.navigator.pointerEnabled||window.navigator.msPointerEnabled))},isTouchDevice:function(){return this.isBrowser&&void 0!==window.ontouchstart},isAndroid:function(){return r.Z.exists(navigator)&&navigator.userAgent.toLowerCase().indexOf("android")>-1},isWebkitAndroid:function(){return this.isAndroid()&&navigator.userAgent.indexOf(" AppleWebKit/")>-1},isApple:function(){return r.Z.exists(navigator)&&(navigator.userAgent.indexOf("iPad")>-1||navigator.userAgent.indexOf("iPhone")>-1)},isWebkitApple:function(){return this.isApple()&&navigator.userAgent.search(/Mobile\/[0-9A-Za-z.]*Safari/)>-1},isMetroApp:function(){return"object"==typeof window&&window.clientInformation&&window.clientInformation.appVersion&&window.clientInformation.appVersion.indexOf("MSAppHost")>-1},isMozilla:function(){return r.Z.exists(navigator)&&navigator.userAgent.toLowerCase().indexOf("mozilla")>-1&&-1===navigator.userAgent.toLowerCase().indexOf("apple")},isFirefoxOS:function(){return r.Z.exists(navigator)&&-1===navigator.userAgent.toLowerCase().indexOf("android")&&-1===navigator.userAgent.toLowerCase().indexOf("apple")&&navigator.userAgent.toLowerCase().indexOf("mobile")>-1&&navigator.userAgent.toLowerCase().indexOf("mozilla")>-1},ieVersion:function(){var t,e,i=3;if("object"!=typeof document)return 0;e=(t=document.createElement("div")).getElementsByTagName("i");do{t.innerHTML="\x3c!--[if gt IE "+ ++i+"]><i></i><![endif]--\x3e"}while(e[0]);return i>4?i:void 0}(),getDimensions:function(t,e){var i,s,o,n,a,h,l,c,d,u=/\d+(\.\d*)?px/;if(!this.isBrowser||null===t)return{width:500,height:500};if(i=(e=e||document).getElementById(t),!r.Z.exists(i))throw new Error("\nJSXGraph: HTML container element '"+t+"' not found.");return"none"!==(s=i.style.display)&&null!==s?i.clientWidth>0&&i.clientHeight>0?{width:i.clientWidth,height:i.clientHeight}:(d=window.getComputedStyle?window.getComputedStyle(i):i.style,{width:u.test(d.width)?parseFloat(d.width):0,height:u.test(d.height)?parseFloat(d.height):0}):(n=(o=i.style).visibility,a=o.position,h=o.display,o.visibility="hidden",o.position="absolute",o.display="block",l=i.clientWidth,c=i.clientHeight,o.display=h,o.position=a,o.visibility=n,{width:l,height:c})},addEvent:function(t,e,i,s,o){var n=function(){return i.apply(s,arguments)};n.origin=i,"object"==typeof s&&r.Z.exists(s.BOARD_MODE_NONE)&&(s["x_internal"+e]=s["x_internal"+e]||[],s["x_internal"+e].push(n)),r.Z.exists(t)&&r.Z.exists(t.addEventListener)&&(o=o||!1,t.addEventListener(e,n,o)),r.Z.exists(t)&&r.Z.exists(t.attachEvent)&&t.attachEvent("on"+e,n)},removeEvent:function(t,e,i,o){var n;if(r.Z.exists(o))if(r.Z.exists(o["x_internal"+e]))if(r.Z.isArray(o["x_internal"+e]))if(-1!==(n=r.Z.indexOf(o["x_internal"+e],i,"origin"))){try{r.Z.exists(t)&&r.Z.exists(t.removeEventListener)&&t.removeEventListener(e,o["x_internal"+e][n],!1),r.Z.exists(t)&&r.Z.exists(t.detachEvent)&&t.detachEvent("on"+e,o["x_internal"+e][n])}catch(t){s.Z.debug("event not registered in browser: ("+e+" -- "+i+")")}o["x_internal"+e].splice(n,1)}else s.Z.debug("removeEvent: no such event function in internal list: "+i);else s.Z.debug("owner[x_internal + "+e+"] is not an array");else s.Z.debug("no such type: "+e);else s.Z.debug("no such owner")},removeAllEvents:function(t,e,i){var r;if(i["x_internal"+e]){for(r=i["x_internal"+e].length-1;r>=0;r--)s.Z.removeEvent(t,e,i["x_internal"+e][r].origin,i);i["x_internal"+e].length>0&&s.Z.debug("removeAllEvents: Not all events could be removed.")}},getPosition:function(t,e,i){var o,n,a,h=0,l=0;if(t||(t=window.event),i=i||document,a=t[s.Z.touchProperty],r.Z.exists(a)&&0===a.length&&(a=t.changedTouches),r.Z.exists(e)&&r.Z.exists(a))if(-1===e){for(n=a.length,o=0;o<n;o++)if(a[o]){t=a[o];break}}else t=a[e];return t.clientX&&(h=t.clientX,l=t.clientY),[h,l]},getOffset:function(t){var e,i=t,s=t,r=i.offsetLeft-i.scrollLeft,o=i.offsetTop-i.scrollTop;for(r=(e=this.getCSSTransform([r,o],i))[0],o=e[1],i=i.offsetParent;i;){for(r+=i.offsetLeft,o+=i.offsetTop,i.offsetParent&&(r+=i.clientLeft-i.scrollLeft,o+=i.clientTop-i.scrollTop),r=(e=this.getCSSTransform([r,o],i))[0],o=e[1],s=s.parentNode;s!==i;)r+=s.clientLeft-s.scrollLeft,o+=s.clientTop-s.scrollTop,r=(e=this.getCSSTransform([r,o],s))[0],o=e[1],s=s.parentNode;i=i.offsetParent}return[r,o]},getStyle:function(t,e){var i,r=t.ownerDocument;return r.defaultView&&r.defaultView.getComputedStyle?i=r.defaultView.getComputedStyle(t,null).getPropertyValue(e):t.currentStyle&&s.Z.ieVersion>=9?i=t.currentStyle[e]:t.style&&(e=e.replace(/-([a-z]|[0-9])/gi,(function(t,e){return e.toUpperCase()})),i=t.style[e]),i},getProp:function(t,e){var i=parseInt(this.getStyle(t,e),10);return isNaN(i)?0:i},getCSSTransform:function(t,e){var i,s,o,n,a,h,l,c=["transform","webkitTransform","MozTransform","msTransform","oTransform"];for(a=c.length,i=0,o="";i<a;i++)if(r.Z.exists(e.style[c[i]])){o=e.style[c[i]];break}if(""!==o&&(n=o.indexOf("("))>0){for(a=o.length,s=0,h=(l=o.substring(n+1,a-1).split(",")).length;s<h;s++)l[s]=parseFloat(l[s]);0===o.indexOf("matrix")?(t[0]+=l[4],t[1]+=l[5]):0===o.indexOf("translateX")?t[0]+=l[0]:0===o.indexOf("translateY")?t[1]+=l[0]:0===o.indexOf("translate")&&(t[0]+=l[0],t[1]+=l[1])}return r.Z.exists(e.style.zoom)&&""!==(o=e.style.zoom)&&(t[0]*=parseFloat(o),t[1]*=parseFloat(o)),t},getCSSTransformMatrix:function(t){var e,i,s,o,n,a,h,l,c=t.ownerDocument,d=["transform","webkitTransform","MozTransform","msTransform","oTransform"],u=[[1,0,0],[0,1,0],[0,0,1]];if(c.defaultView&&c.defaultView.getComputedStyle)s=(l=c.defaultView.getComputedStyle(t,null)).getPropertyValue("-webkit-transform")||l.getPropertyValue("-moz-transform")||l.getPropertyValue("-ms-transform")||l.getPropertyValue("-o-transform")||l.getPropertyValue("transform");else for(n=d.length,e=0,s="";e<n;e++)if(r.Z.exists(t.style[d[e]])){s=t.style[d[e]];break}if(""!==s&&(o=s.indexOf("("))>0){for(n=s.length,i=0,a=(h=s.substring(o+1,n-1).split(",")).length;i<a;i++)h[i]=parseFloat(h[i]);0===s.indexOf("matrix")?u=[[1,0,0],[0,h[0],h[1]],[0,h[2],h[3]]]:0===s.indexOf("scaleX")?u[1][1]=h[0]:0===s.indexOf("scaleY")?u[2][2]=h[0]:0===s.indexOf("scale")&&(u[1][1]=h[0],u[2][2]=h[1])}return r.Z.exists(t.style.zoom)&&""!==(s=t.style.zoom)&&(u[1][1]*=parseFloat(s),u[2][2]*=parseFloat(s)),u},timedChunk:function(t,e,i,s){var r=t.concat(),o=function(){var n=+new Date;do{e.call(i,r.shift())}while(r.length>0&&+new Date-n<300);r.length>0?window.setTimeout(o,1):s(t)};window.setTimeout(o,1)},scaleJSXGraphDiv:function(t,e,i,s){var r,o,n,a,h,l,c,d,u,p,_,f=i.styleSheets.length,b=s,g=[":fullscreen",":-webkit-full-screen",":-moz-full-screen",":-ms-fullscreen"],m=g.length,v=new RegExp(".*#"+t+":.*full.*screen.*#"+e+".*auto;.*transform:.*matrix");for(a=(h=i.getElementById(t).getBoundingClientRect()).height,n=h.width,c=(d=i.getElementById(e).getBoundingClientRect()).height,p="{margin:0 auto;transform:matrix("+(u=(l=d.width)/c>=n/a?b*n/l:b*a/c)+",0,0,"+u+",0,"+.5*(a-c)+");}",0===f&&((r=document.createElement("style")).appendChild(document.createTextNode("")),i.appendChild(r),f=i.styleSheets.length),i.styleSheets[f-1].cssRules.length>0&&v.test(i.styleSheets[f-1].cssRules[0].cssText)&&i.styleSheets[f-1].deleteRule&&i.styleSheets[f-1].deleteRule(0),_=0;_<m;_++)try{o="#"+t+g[_]+" #"+e+p,i.styleSheets[f-1].insertRule(o,0);break}catch(t){}_===m&&(console.log("JXG.scaleJSXGraphDiv: Could not add any CSS rule."),console.log("One possible reason could be that the id of the JSXGraph container does not start with a letter."))}});const o=s.Z},88:(t,e,i)=>{i.d(e,{Z:()=>o});var s=i(765),r=i(109);s.Z.EventEmitter={eventHandlers:{},suspended:{},trigger:function(t,e){var i,s,r,o,n,a;for(n=t.length,s=0;s<n;s++)if(o=this.eventHandlers[t[s]],!this.suspended[t[s]]){if(this.suspended[t[s]]=!0,o)for(a=o.length,i=0;i<a;i++)(r=o[i]).handler.apply(r.context,e);this.suspended[t[s]]=!1}return this},on:function(t,e,i){return r.Z.isArray(this.eventHandlers[t])||(this.eventHandlers[t]=[]),i=r.Z.def(i,this),this.eventHandlers[t].push({handler:e,context:i}),this},off:function(t,e){var i;return t&&r.Z.isArray(this.eventHandlers[t])?(e?((i=r.Z.indexOf(this.eventHandlers[t],e,"handler"))>-1&&this.eventHandlers[t].splice(i,1),0===this.eventHandlers[t].length&&delete this.eventHandlers[t]):delete this.eventHandlers[t],this):this},eventify:function(t){t.eventHandlers={},t.on=this.on,t.off=this.off,t.triggerEventHandlers=this.trigger,t.trigger=this.trigger,t.suspended={}}};const o=s.Z.EventEmitter},421:(t,e,i)=>{i.d(e,{Z:()=>h});var s=i(765),r=i(109),o=i(351),n=i(705),a={each:function(t,e,i){var s,o,n=[];if(r.Z.exists(t.length))for(o=t.length,s=0;s<o;s++)n.push(e.call(this,t[s],i));return n},coords:function(t,e){var i=t;return t&&t.elementClass===o.Z.OBJECT_CLASS_POINT?i=t.coords:t.usrCoords&&t.scrCoords&&t.usr2screen&&(i=t),e&&(i=new n.Z(o.Z.COORDS_BY_USER,i.usrCoords,i.board)),i},coordsArray:function(t,e){var i;return(i=r.Z.isArray(t)?t:this.coords(t).usrCoords).length<3&&i.unshift(1),e&&(i=[i[0],i[1],i[2]]),i}};s.Z.Expect=a;const h=a},109:(t,e,i)=>{i.d(e,{Z:()=>o});var s=i(765),r=i(351);s.Z.extend(s.Z,{isId:function(t,e){return"string"==typeof e&&!!t.objects[e]},isName:function(t,e){return"string"==typeof e&&!!t.elementsByName[e]},isGroup:function(t,e){return"string"==typeof e&&!!t.groups[e]},isString:function(t){return"string"==typeof t},isNumber:function(t){return"number"==typeof t||"[Object Number]"===Object.prototype.toString.call(t)},isFunction:function(t){return"function"==typeof t},isArray:function(t){return Array.isArray?Array.isArray(t):null!==t&&"object"==typeof t&&"function"==typeof t.splice&&"function"==typeof t.join},isObject:function(t){return"object"==typeof t&&!this.isArray(t)},isDocumentOrFragment:function(t){return this.isObject(t)&&(9===t.nodeType||11===t.nodeType)},isPoint:function(t){return!(null===t||"object"!=typeof t||!this.exists(t.elementClass))&&t.elementClass===r.Z.OBJECT_CLASS_POINT},isPoint3D:function(t){return!(null===t||"object"!=typeof t||!this.exists(t.elType))&&"point3d"===t.elType},isPointType:function(t,e){var i,s;return!!this.isArray(e)||(!!(this.isFunction(e)&&(i=e(),this.isArray(i)&&i.length>1))||(s=t.select(e),this.isPoint(s)))},isTransformationOrArray:function(t){if(null!==t){if(this.isArray(t)&&t.length>0)return this.isTransformationOrArray(t[0]);if("object"==typeof t)return t.type===r.Z.OBJECT_TYPE_TRANSFORMATION}return!1},exists:function(t,e){var i=!(null==t||null===t);return(e=e||!1)?i&&""!==t:i},isEmpty:function(t){return 0===Object.keys(t).length},def:function(t,e){return this.exists(t)?t:e},str2Bool:function(t){return!this.exists(t)||("boolean"==typeof t?t:!!this.isString(t)&&"true"===t.toLowerCase())},createEvalFunction:function(t,e,i){var r,o,n,a=[],h={};for(o=0;o<i;o++)for(n in a[o]=s.Z.createFunction(e[o],t,"",!0),a[o].deps)h[n]=a[o].deps;return(r=function(t){return a[t]()}).deps=h,r},createFunction:function(t,e,i,s){var r=null;return this.exists(s)&&!s||!this.isString(t)?this.isFunction(t)?(r=t).deps={}:(this.isNumber(t)||this.isString(t))&&((r=function(){return t}).deps={}):r=e.jc.snippet(t,!0,i,!0),null!==r&&(r.origin=t),r},providePoints:function(t,e,i,s,r){var o,n,a,h,l,c=0,d=[];for(this.isArray(e)||(e=[e]),a=e.length,this.exists(r)&&(c=r.length),0===c&&(h=this.copyAttributes(i,t.options,s)),o=0;o<a;++o)if(c>0&&(n=Math.min(o,c-1),h=this.copyAttributes(i,t.options,s,r[n])),this.isArray(e[o])&&e[o].length>1?(d.push(t.create("point",e[o],h)),d[d.length-1]._is_new=!0):this.isFunction(e[o])?(l=e[o](),this.isArray(l)&&l.length>1&&(d.push(t.create("point",[e[o]],h)),d[d.length-1]._is_new=!0)):d.push(t.select(e[o])),!this.isPoint(d[o]))return!1;return d},providePoints3D:function(t,e,i,s,r){var o,n,a,h,l,c=0,d=[];for(this.isArray(e)||(e=[e]),a=e.length,this.exists(r)&&(c=r.length),0===c&&(h=this.copyAttributes(i,t.board.options,s)),o=0;o<a;++o)if(c>0&&(n=Math.min(o,c-1),h=this.copyAttributes(i,t.board.options,s,r[n])),this.isArray(e[o])&&e[o].length>1?(d.push(t.create("point3d",e[o],h)),d[d.length-1]._is_new=!0):this.isFunction(e[o])?(l=e[o](),this.isArray(l)&&l.length>1&&(d.push(t.create("point3d",[e[o]],h)),d[d.length-1]._is_new=!0)):d.push(t.select(e[o])),!this.isPoint3D(d[o]))return!1;return d},bind:function(t,e){return function(){return t.apply(e,arguments)}},evaluate:function(t){return this.isFunction(t)?t():t},indexOf:function(t,e,i){var s,r=this.exists(i);if(Array.indexOf&&!r)return t.indexOf(e);for(s=0;s<t.length;s++)if(r&&t[s][i]===e||!r&&t[s]===e)return s;return-1},eliminateDuplicates:function(t){var e,i=t.length,s=[],r={};for(e=0;e<i;e++)r[t[e]]=0;for(e in r)r.hasOwnProperty(e)&&s.push(e);return s},swap:function(t,e,i){var s;return s=t[e],t[e]=t[i],t[i]=s,t},uniqueArray:function(t){var e,i,r,o=[];if(0===t.length)return[];for(e=0;e<t.length;e++)if(r=this.isArray(t[e]),this.exists(t[e]))for(i=e+1;i<t.length;i++)r&&s.Z.cmpArrays(t[e],t[i])?t[e]=[]:r||t[e]!==t[i]||(t[e]="");else t[e]="";for(i=0,e=0;e<t.length;e++)(r=this.isArray(t[e]))||""===t[e]?r&&0!==t[e].length&&(o[i]=t[e].slice(0),i++):(o[i]=t[e],i++);return t=o,o},isInArray:function(t,e){return s.Z.indexOf(t,e)>-1},coordsArrayToMatrix:function(t,e){var i,s=[],r=[];for(i=0;i<t.length;i++)e?(s.push(t[i].usrCoords[1]),r.push(t[i].usrCoords[2])):r.push([t[i].usrCoords[1],t[i].usrCoords[2]]);return e&&(r=[s,r]),r},cmpArrays:function(t,e){var i;if(t===e)return!0;if(t.length!==e.length)return!1;for(i=0;i<t.length;i++)if(this.isArray(t[i])&&this.isArray(e[i])){if(!this.cmpArrays(t[i],e[i]))return!1}else if(t[i]!==e[i])return!1;return!0},removeElementFromArray:function(t,e){var i;for(i=0;i<t.length;i++)if(t[i]===e)return t.splice(i,1),t;return t},trunc:function(t,e){return e=s.Z.def(e,0),this.toFixed(t,e)},_decimalAdjust:function(t,e,i){return void 0===i||0==+i?Math[t](e):(e=+e,i=+i,isNaN(e)||"number"!=typeof i||i%1!=0?NaN:(e=e.toString().split("e"),+((e=(e=Math[t](+(e[0]+"e"+(e[1]?+e[1]-i:-i)))).toString().split("e"))[0]+"e"+(e[1]?+e[1]+i:i))))},_round10:function(t,e){return this._decimalAdjust("round",t,e)},_floor10:function(t,e){return this._decimalAdjust("floor",t,e)},_ceil10:function(t,e){return this._decimalAdjust("ceil",t,e)},toFixed:function(t,e){return this._round10(t,-e).toFixed(e)},autoDigits:function(t){var e=Math.abs(t);return e>=.1?this.toFixed(t,2):e>=.01?this.toFixed(t,4):e>=1e-4?this.toFixed(t,6):t},keys:function(t,e){var i,s=[];for(i in t)e?t.hasOwnProperty(i)&&s.push(i):s.push(i);return s},clone:function(t){var e={};return e.prototype=t,e},cloneAndCopy:function(t,e){var i,s=function(){};for(i in s.prototype=t,e)s[i]=e[i];return s},merge:function(t,e){var i,s;for(i in e)if(e.hasOwnProperty(i))if(this.isArray(e[i]))for(t[i]||(t[i]=[]),s=0;s<e[i].length;s++)"object"==typeof e[i][s]?t[i][s]=this.merge(t[i][s],e[i][s]):t[i][s]=e[i][s];else"object"==typeof e[i]?(t[i]||(t[i]={}),t[i]=this.merge(t[i],e[i])):t[i]=e[i];return t},deepCopy:function(t,e,i){var s,r,o,n;if(i=i||!1,"object"!=typeof t||null===t)return t;if(this.isArray(t))for(s=[],r=0;r<t.length;r++)"object"==typeof(o=t[r])?this.exists(o.board)?s[r]=o.id:s[r]=this.deepCopy(o):s[r]=o;else{for(r in s={},t)t.hasOwnProperty(r)&&(n=i?r.toLowerCase():r,null!==(o=t[r])&&"object"==typeof o?this.exists(o.board)?s[n]=o.id:s[n]=this.deepCopy(o):s[n]=o);for(r in e)e.hasOwnProperty(r)&&(n=i?r.toLowerCase():r,"object"==typeof(o=e[r])?this.isArray(o)||!this.exists(s[n])?s[n]=this.deepCopy(o):s[n]=this.deepCopy(s[n],o,i):s[n]=o)}return s},mergeAttr:function(t,e,i){var s,r,o;for(s in i=i||!0,e)e.hasOwnProperty(s)&&(r=i?s.toLowerCase():s,o=e[s],!this.isObject(o)||null===o||this.isDocumentOrFragment(o)||this.exists(o.board)||"string"==typeof o.valueOf()?t[r]=o:(void 0!==t[r]&&null!==t[r]&&this.isObject(t[r])||(t[r]={}),this.mergeAttr(t[r],o,i)))},copyAttributes:function(t,e,i){var r,o,n,a,h;for(r=(n=arguments.length)<3||{circle:1,curve:1,image:1,line:1,point:1,polygon:1,text:1,ticks:1,integral:1}[i]?s.Z.deepCopy(e.elements,null,!0):{},n<4&&this.exists(i)&&this.exists(e.layer[i])&&(r.layer=e.layer[i]),a=e,h=!0,o=2;o<n;o++){if(!this.exists(a[arguments[o]])){h=!1;break}a=a[arguments[o]]}for(h&&(r=s.Z.deepCopy(r,a,!0)),a="object"==typeof t?t:{},h=!0,o=3;o<n;o++){if(!this.exists(a[arguments[o]])){h=!1;break}a=a[arguments[o]]}if(h&&this.mergeAttr(r,a,!0),"board"===arguments[2])return r;for(a=e,h=!0,o=2;o<n;o++){if(!this.exists(a[arguments[o]])){h=!1;break}a=a[arguments[o]]}return h&&this.exists(a.label)&&(r.label=s.Z.deepCopy(a.label,r.label)),r.label=s.Z.deepCopy(e.label,r.label),r},copyPrototypeMethods:function(t,e,i){var s;for(s in t.prototype[i]=e.prototype.constructor,e.prototype)e.prototype.hasOwnProperty(s)&&(t.prototype[s]=e.prototype[s])},toJSON:function(t,e){var i,r,o,n;if(e=s.Z.def(e,!1),JSON.stringify&&!e)try{return JSON.stringify(t)}catch(t){}switch(typeof t){case"object":if(t){if(i=[],this.isArray(t)){for(o=0;o<t.length;o++)i.push(s.Z.toJSON(t[o],e));return"["+i.join(",")+"]"}for(r in t)if(t.hasOwnProperty(r)){try{n=s.Z.toJSON(t[r],e)}catch(t){n=""}e?i.push(r+":"+n):i.push('"'+r+'":'+n)}return"{"+i.join(",")+"} "}return"null";case"string":return"'"+t.replace(/(["'])/g,"\\$1")+"'";case"number":case"boolean":return t.toString()}return"0"},clearVisPropOld:function(t){return t.visPropOld={cssclass:"",cssdefaultstyle:"",cssstyle:"",fillcolor:"",fillopacity:"",firstarrow:!1,fontsize:-1,lastarrow:!1,left:-1e5,linecap:"",shadow:!1,strokecolor:"",strokeopacity:"",strokewidth:"",tabindex:-1e5,transitionduration:0,top:-1e5,visible:null},t},isInObject:function(t,e){var i;for(i in t)if(t.hasOwnProperty(i)&&t[i]===e)return!0;return!1},escapeHTML:function(t){return t.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;")},unescapeHTML:function(t){return t.replace(/<\/?[^>]+>/gi,"").replace(/&amp;/g,"&").replace(/&lt;/g,"<").replace(/&gt;/g,">")},capitalize:function(t){return t.charAt(0).toUpperCase()+t.substring(1).toLowerCase()},trimNumber:function(t){return"."!==(t=(t=t.replace(/^0+/,"")).replace(/0+$/,""))[t.length-1]&&","!==t[t.length-1]||(t=t.slice(0,-1)),"."!==t[0]&&","!==t[0]||(t="0"+t),t},filterElements:function(t,e){var i,s,r,o,n,a,h,l=t.length,c=[];if("function"!=typeof e&&"object"!=typeof e)return c;for(i=0;i<l;i++){if(h=!0,r=t[i],"object"==typeof e){for(s in e)if(e.hasOwnProperty(s)&&(o=s.toLowerCase(),n="function"==typeof r[s]?r[s]():r[s],a=r.visProp&&"function"==typeof r.visProp[o]?r.visProp[o]():r.visProp&&r.visProp[o],!(h="function"==typeof e[s]?e[s](n)||e[s](a):n===e[s]||a===e[s])))break}else"function"==typeof e&&(h=e(r));h&&c.push(r)}return c},trim:function(t){return t.replace(/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g,"")},sanitizeHTML:function(t,e){return"function"==typeof html_sanitize&&e?html_sanitize(t,(function(){}),(function(t){return t})):(t&&"string"==typeof t&&(t=t.replace(/</g,"&lt;").replace(/>/g,"&gt;")),t)},evalSlider:function(t){return t&&t.type===r.Z.OBJECT_TYPE_GLIDER&&"function"==typeof t.Value?t.Value():t}});const o=s.Z}},__webpack_module_cache__={};function __webpack_require__(t){var e=__webpack_module_cache__[t];if(void 0!==e)return e.exports;var i=__webpack_module_cache__[t]={exports:{}};return __webpack_modules__[t](i,i.exports,__webpack_require__),i.exports}__webpack_require__.d=(t,e)=>{for(var i in e)__webpack_require__.o(e,i)&&!__webpack_require__.o(t,i)&&Object.defineProperty(t,i,{enumerable:!0,get:e[i]})},__webpack_require__.o=(t,e)=>Object.prototype.hasOwnProperty.call(t,e);var __webpack_exports__={};(()=>{__webpack_require__.d(__webpack_exports__,{$l:()=>ut,fy:()=>it,JU:()=>st,kL:()=>pt,Cd:()=>_t,Zz:()=>ft,fS:()=>bt,mZ:()=>gt,L6:()=>mt,Hy:()=>vt,iG:()=>rt,QK:()=>Zt,ZA:()=>Ct,Ee:()=>yt,Nn:()=>ot,n1:()=>Pt,IY:()=>At,x1:()=>Et,ZX:()=>nt,Ei:()=>at,E9:()=>Ot,mg:()=>xt,xv:()=>wt,vb:()=>St,zA:()=>Tt,l8:()=>Mt,nY:()=>Nt,vP:()=>kt,lZ:()=>Rt,I0:()=>Dt,ak:()=>Lt,tj:()=>ht,kC:()=>Bt,HM:()=>It,d9:()=>Yt,V$:()=>jt,DV:()=>Xt,fG:()=>Ut,DM:()=>Ft,OD:()=>Jt,o5:()=>Gt,JI:()=>zt,fF:()=>Ht,Ql:()=>Wt,yl:()=>Vt,lU:()=>$t,p$:()=>Kt,Nj:()=>qt,ZP:()=>bi,x9:()=>Qt,Rm:()=>lt,XH:()=>te,r:()=>ee,Lw:()=>ie,ku:()=>se,a2:()=>re,vn:()=>oe,wx:()=>ae,zL:()=>ne,t_:()=>he,os:()=>le,bt:()=>ce,WJ:()=>de,wK:()=>ue,XG:()=>pe,Dt:()=>_e,mL:()=>fe,kJ:()=>be,dB:()=>ge,oG:()=>me,EE:()=>ve,oP:()=>Ze,K9:()=>Ce,UG:()=>ye,hj:()=>Pe,Kn:()=>Ee,EJ:()=>Oe,HD:()=>xe,b1:()=>we,iI:()=>Se,n2:()=>Te,E:()=>Me,Ju:()=>Ne,XP:()=>Ae,TS:()=>ke,ZL:()=>Re,DG:()=>ct,od:()=>dt,bU:()=>De,ui:()=>Le,yt:()=>Be,aC:()=>Ie,sL:()=>Ye,xC:()=>je,OK:()=>Xe,OW:()=>Ue,KJ:()=>Fe,dq:()=>Je,CO:()=>Ge,tu:()=>ze,KW:()=>Ve,uh:()=>We,cE:()=>He,jW:()=>$e,Xl:()=>Ke,uw:()=>qe,Fm:()=>Qe,kK:()=>ti,n:()=>ei,SJ:()=>ii,LF:()=>si,J6:()=>ri,FH:()=>oi,Ls:()=>ni,au:()=>ai,A8:()=>hi,_V:()=>li,$G:()=>ci,Uo:()=>di,Nb:()=>ui,zz:()=>pi,W6:()=>_i,ZK:()=>fi});var t=__webpack_require__(765),e=__webpack_require__(503),i=__webpack_require__(351),s=__webpack_require__(109);t.Z.XML={cleanWhitespace:function(t){for(var e=t.firstChild;s.Z.exists(e);)3!==e.nodeType||/\S/.test(e.nodeValue)?1===e.nodeType&&this.cleanWhitespace(e):t.removeChild(e),e=e.nextSibling},parse:function(t){var e,i;return i="function"==typeof DOMParser||"object"==typeof DOMParser?DOMParser:function(){this.parseFromString=function(t){var e;return"function"==typeof ActiveXObject&&(e=new ActiveXObject("MSXML.DomDocument")).loadXML(t),e}},e=(new i).parseFromString(t,"text/xml"),this.cleanWhitespace(e),e}};t.Z.XML;var r=__webpack_require__(88),o=(__webpack_require__(421),__webpack_require__(275));o.Z.ProbFuncs={MAXNUM:17014118346046923e22,SQRTH:.7071067811865476,SQRT2:1.4142135623730951,MAXLOG:708.3964185322641,P:[2.461969814735305e-10,.5641895648310689,7.463210564422699,48.63719709856814,196.5208329560771,526.4451949954773,934.5285271719576,1027.5518868951572,557.5353353693994],Q:[13.228195115474499,86.70721408859897,354.9377788878199,975.7085017432055,1823.9091668790973,2246.3376081871097,1656.6630919416134,557.5353408177277],R:[.5641895835477551,1.275366707599781,5.019050422511805,6.160210979930536,7.4097426995044895,2.9788666537210022],S:[2.2605286322011726,9.396035249380015,12.048953980809666,17.08144507475659,9.608968090632859,3.369076451000815],T:[9.604973739870516,90.02601972038427,2232.005345946843,7003.325141128051,55592.30130103949],U:[33.56171416475031,521.3579497801527,4594.323829709801,22629.000061389095,49267.39426086359],M:128,MINV:.0078125,expx2:function(t,e){var i,s,r,o;return t=Math.abs(t),e<0&&(t=-t),i=(r=this.MINV*Math.floor(this.M*t+.5))*r,s=2*r*(o=t-r)+o*o,e<0&&(i=-i,s=-s),i+s>this.MAXLOG?1/0:i=Math.exp(i)*Math.exp(s)},polevl:function(t,e,i){var r,o;if(s.Z.exists(e.reduce))return e.reduce((function(e,i){return e*t+i}),0);for(o=0,r=0;o<=i;o++)r=r*t+e[o];return r},p1evl:function(t,e,i){var r,o;if(s.Z.exists(e.reduce))return e.reduce((function(e,i){return e*t+i}),1);for(o=0,r=1;o<i;o++)r=r*t+e[o];return r},ndtr:function(t){var e,i,s;return e=t*this.SQRTH,(s=Math.abs(e))<1?i=.5+.5*this.erf(e):(i=.5*this.erfce(s),s=this.expx2(t,-1),i*=Math.sqrt(s),e>0&&(i=1-i)),i},_underflow:function(t){return console.log("erfc","UNDERFLOW"),t<0?2:0},erfc:function(t){var e,i,s,r,o;return(s=t<0?-t:t)<1?1-this.erf(t):(o=-t*t)<-this.MAXLOG?this._underflow(t):(o=this.expx2(t,-1),s<8?(e=this.polevl(s,this.P,8),i=this.p1evl(s,this.Q,8)):(e=this.polevl(s,this.R,5),i=this.p1evl(s,this.S,6)),r=o*e/i,t<0&&(r=2-r),0===r?this._underflow(t):r)},erfce:function(t){var e,i;return t<8?(e=this.polevl(t,this.P,8),i=this.p1evl(t,this.Q,8)):(e=this.polevl(t,this.R,5),i=this.p1evl(t,this.S,6)),e/i},erf:function(t){var e;return Math.abs(t)>1?1-this.erfc(t):(e=t*t,t*this.polevl(e,this.T,4)/this.p1evl(e,this.U,5))},s2pi:2.5066282746310007,P0:[-59.96335010141079,98.00107541859997,-56.67628574690703,13.931260938727968,-1.2391658386738125],Q0:[1.9544885833814176,4.676279128988815,86.36024213908905,-225.46268785411937,200.26021238006066,-82.03722561683334,15.90562251262117,-1.1833162112133],P1:[4.0554489230596245,31.525109459989388,57.16281922464213,44.08050738932008,14.684956192885803,2.1866330685079025,-.1402560791713545,-.03504246268278482,-.0008574567851546854],Q1:[15.779988325646675,45.39076351288792,41.3172038254672,15.04253856929075,2.504649462083094,-.14218292285478779,-.03808064076915783,-.0009332594808954574],P2:[3.2377489177694603,6.915228890689842,3.9388102529247444,1.3330346081580755,.20148538954917908,.012371663481782003,.00030158155350823543,26580697468673755e-22,6.239745391849833e-9],Q2:[6.02427039364742,3.6798356385616087,1.3770209948908132,.21623699359449663,.013420400608854318,.00032801446468212774,28924786474538068e-22,6.790194080099813e-9],ndtri:function(t){var e,i,s,r,o;return t<=0?-1/0:t>=1?1/0:(o=1,(i=t)>.8646647167633873&&(i=1-i,o=0),i>.1353352832366127?(e=(i-=.5)+i*((r=i*i)*this.polevl(r,this.P0,4)/this.p1evl(r,this.Q0,8)),e*=this.s2pi):(s=1/(e=Math.sqrt(-2*Math.log(i))),e=e-Math.log(e)/e-(e<8?s*this.polevl(s,this.P1,8)/this.p1evl(s,this.Q1,8):s*this.polevl(s,this.P2,8)/this.p1evl(s,this.Q2,8)),0!==o&&(e=-e),e))},erfi:function(t){return this.ndtri(.5*(t+1))*this.SQRTH}};o.Z.ProbFuncs;var n=__webpack_require__(785);o.Z.Extrapolate={upper:15,infty:1e4,wynnEps:function(t,e,i){var s,r,o,n,a;if(i[e]=t,0===e)a=t;else{for(o=0,s=e;s>0;s--)r=o,o=i[s-1],n=i[s]-o,Math.abs(n)<=1e-15?i[s-1]=1e20:(1,i[s-1]=1*r+1/n);a=i[e%2]}return a},aitken:function(t,e,i){var s,r,o,n,a,h;if(i[e]=t,e<2)s=t;else{for(n=e/2,a=1;a<=n;a++)r=i[(h=e-2*a)+2]-2*i[h+1]+i[h],Math.abs(r)<1e-15?i[h]=1e20:(o=i[h]-i[h+1],i[h]-=o*o/r);s=i[e%2]}return s},brezinski:function(t,e,i){var s,r,o,n,a,h,l,c;if(i[e]=t,e<3)s=t;else{for(h=e/3,c=e,l=1;l<=h;l++)o=i[(c-=3)+1]-i[c],n=i[c+2]-i[c+1],r=(a=i[c+3]-i[c+2])*(n-o)-o*(a-n),Math.abs(r)<1e-15?i[c]=1e20:i[c]=i[c+1]-o*n*(a-n)/r;s=i[e%3]}return s},iteration:function(t,e,i,s,r){var o,n,a,h,l=NaN,c=[],d="finite",u=e;for(r=r||0,o=1;o<=this.upper;o++){if(n=i(t+(u=0===r?e/(o+1):.5*u),!0),a=this[s](n,o-1,c),isNaN(a)){d="NaN";break}if(0!==n&&a/n>this.infty){l=a,d="infinite";break}if(h=a-l,Math.abs(h)<1e-7)break;l=a}return[l,d,1-(o-1)/this.upper]},levin:function(t,e,i,s,r,o){var n,a,h,l;if(l=1/(s+e),r[e]=t/i,o[e]=1/i,e>0&&(r[e-1]=r[e]-r[e-1],o[e-1]=o[e]-o[e-1],e>1))for(h=(s+e-1)*l,n=2;n<=e;n++)a=(s+e-n)*Math.pow(h,n-2)*l,r[e-n]=r[e-n+1]-a*r[e-n],o[e-n]=o[e-n+1]-a*o[e-n],l*=h;return Math.abs(o[0])<1e-15?1e20:r[0]/o[0]},iteration_levin:function(t,e,i,s){var r,o,n,a,h,l,c,d=NaN,u=[],p=[],_="finite",f=e;for(s=s||0,a=i(t+e,!0),r=1;r<=this.upper;r++){if(h=(o=i(t+(f=0===s?e/(r+1):.5*f),!0))-a,c="u"===(Math.abs(h)<1?"u":"t")?(1+r)*h:h,a=o,l=(n=this.levin(o,r-1,c,1,u,p))-d,isNaN(n)){_="NaN";break}if(0!==o&&n/o>this.infty){d=n,_="infinite";break}if(Math.abs(l)<1e-7)break;d=n}return[d,_,1-(r-1)/this.upper]},limit:function(t,e,i){return this.iteration_levin(t,e,i,0)}};const a=o.Z.Extrapolate;o.Z.Quadtree=function(t){this.capacity=10,this.points=[],this.xlb=t[0],this.xub=t[2],this.ylb=t[3],this.yub=t[1],this.northWest=null,this.northEast=null,this.southEast=null,this.southWest=null},s.Z.extend(o.Z.Quadtree.prototype,{contains:function(t,e){return this.xlb<t&&t<=this.xub&&this.ylb<e&&e<=this.yub},insert:function(t){return!!this.contains(t.usrCoords[1],t.usrCoords[2])&&(this.points.length<this.capacity?(this.points.push(t),!0):(null===this.northWest&&this.subdivide(),!!this.northWest.insert(t)||(!!this.northEast.insert(t)||(!!this.southEast.insert(t)||!!this.southWest.insert(t)))))},subdivide:function(){var t,e=this.points.length,i=this.xlb+(this.xub-this.xlb)/2,s=this.ylb+(this.yub-this.ylb)/2;for(this.northWest=new o.Z.Quadtree([this.xlb,this.yub,i,s]),this.northEast=new o.Z.Quadtree([i,this.yub,this.xub,s]),this.southEast=new o.Z.Quadtree([this.xlb,s,i,this.ylb]),this.southWest=new o.Z.Quadtree([i,s,this.xub,this.ylb]),t=0;t<e;t+=1)this.northWest.insert(this.points[t]),this.northEast.insert(this.points[t]),this.southEast.insert(this.points[t]),this.southWest.insert(this.points[t])},_query:function(t,e){var i;if(this.contains(t,e)){if(null===this.northWest)return this;if(i=this.northWest._query(t,e))return i;if(i=this.northEast._query(t,e))return i;if(i=this.southEast._query(t,e))return i;if(i=this.southWest._query(t,e))return i}return!1},query:function(t,e){var i,r;return s.Z.exists(e)?(i=t,r=e):(i=t.usrCoords[1],r=t.usrCoords[2]),this._query(i,r)}});const h=o.Z.Quadtree;var l=__webpack_require__(336);t.Z.Math.Nlp={arr:function(t){return new Float64Array(t)},arr2:function(t,e){for(var i=0,s=new Array(t);i<t;)s[i]=this.arr(e),i++;return s},arraycopy:function(t,e,i,s,r){for(var o=0;o<r;)i[o+s]=t[o+e],o++},lastNumberOfEvaluations:0,GetLastNumberOfEvaluations:function(){return this.lastNumberOfEvaluations},Normal:0,MaxIterationsReached:1,DivergingRoundingErrors:2,FindMinimum:function(t,e,i,s,r,o,n,a,h){var l,c,d=i+2,u=this.arr(e+1),p=this;return this.lastNumberOfEvaluations=0,h&&console.log("Experimental feature 'testForRoundingErrors' is activated."),u[0]=0,this.arraycopy(s,0,u,1,e),c=function(e,i,s,r){var o,n,a=p.arr(e);return p.lastNumberOfEvaluations=p.lastNumberOfEvaluations+1,p.arraycopy(s,1,a,0,e),o=p.arr(i),n=t(e,i,a,o),p.arraycopy(o,0,r,1,i),n},l=this.cobylb(c,e,i,d,u,r,o,n,a,h),this.arraycopy(u,1,s,0,e),l},cobylb:function(t,e,i,s,r,o,n,a,h,l){var c,d,u,p,_,f,b,g,m,v,Z,C,y,P,E,O,x,w,S,T,M,N,A,k,R,D,L,B,I,Y=-1,j=0,X=0,U=e+1,F=i+1,J=o,G=0,z=!1,H=!1,W=0,V=0,$=0,K=this.arr(1+s),q=this.arr2(1+e,1+U),Q=this.arr2(1+e,1+e),tt=this.arr2(1+s,1+U),et=this.arr2(1+e,1+F),it=this.arr(1+e),st=this.arr(1+e),rt=this.arr(1+e),ot=this.arr(1+e),nt=this.arr(1+e);for(a>=2&&console.log("The initial value of RHO is "+J+" and PARMU is set to zero."),g=0,f=1/J,d=1;d<=e;++d)q[d][U]=r[d],q[d][d]=J,Q[d][d]=f;m=U,v=!1;t:for(;;){if(g>=h&&g>0){Y=this.MaxIterationsReached;break t}for(++g,j=t(e,i,r,K),X=0,p=1;p<=i;++p)X=Math.max(X,-K[p]);if(g!==a-1&&3!==a||this.PrintIterationResult(g,j,X,r,e,a),K[F]=j,K[s]=X,Z=!0,!v){for(Z=!1,d=1;d<=s;++d)tt[d][m]=K[d];if(g<=U){if(m<=e)if(tt[F][U]<=j)r[m]=q[m][U];else{for(q[m][U]=r[m],p=1;p<=s;++p)tt[p][m]=tt[p][U],tt[p][U]=K[p];for(p=1;p<=m;++p){for(q[m][p]=-J,f=0,d=p;d<=m;++d)f-=Q[d][p];Q[m][p]=f}}if(g<=e){r[m=g]+=J;continue t}}v=!0}e:for(;;){i:do{if(!Z){for(C=tt[F][U]+G*tt[s][U],y=U,u=1;u<=e;++u)(f=tt[F][u]+G*tt[s][u])<C?(y=u,C=f):f===C&&0===G&&tt[s][u]<tt[s][y]&&(y=u);if(y<=e){for(d=1;d<=s;++d)f=tt[d][U],tt[d][U]=tt[d][y],tt[d][y]=f;for(d=1;d<=e;++d){for(f=q[d][y],q[d][y]=0,q[d][U]+=f,b=0,p=1;p<=e;++p)q[d][p]-=f,b-=Q[p][d];Q[y][d]=b}}if(P=0,l)for(d=1;d<=e;++d)for(u=1;u<=e;++u)f=this.DOT_PRODUCT_ROW_COL(Q,d,q,u,1,e)-(d===u?1:0),P=Math.max(P,Math.abs(f));if(P>.1){Y=this.DivergingRoundingErrors;break t}for(p=1;p<=F;++p){for(K[p]=-tt[p][U],u=1;u<=e;++u)nt[u]=tt[p][u]+K[p];for(d=1;d<=e;++d)et[d][p]=(p===F?-1:1)*this.DOT_PRODUCT_ROW_COL(nt,-1,Q,d,1,e)}for(z=!0,W=.25*J,E=2.1*J,u=1;u<=e;++u){for(O=0,x=0,p=1;p<=e;++p)O+=Q[u][p]*Q[u][p],x+=q[p][u]*q[p][u];it[u]=1/Math.sqrt(O),st[u]=Math.sqrt(x),(it[u]<W||st[u]>E)&&(z=!1)}if(!v&&!z){for(m=0,f=E,u=1;u<=e;++u)st[u]>f&&(m=u,f=st[u]);if(0===m)for(u=1;u<=e;++u)it[u]<f&&(m=u,f=it[u]);for(f=.5*J*it[m],p=1;p<=e;++p)ot[p]=f*Q[m][p];for(w=0,S=0,c=0,p=1;p<=F;++p)c=this.DOT_PRODUCT_ROW_COL(ot,-1,et,p,1,e),p<F&&(f=tt[p][U],w=Math.max(w,-c-f),S=Math.max(S,c-f));for(T=G*(w-S)>2*c?-1:1,f=0,d=1;d<=e;++d)ot[d]=T*ot[d],q[d][m]=ot[d],f+=Q[m][d]*ot[d];for(p=1;p<=e;++p)Q[m][p]/=f;for(u=1;u<=e;++u){if(u!==m)for(f=this.DOT_PRODUCT_ROW_COL(Q,u,ot,-1,1,e),p=1;p<=e;++p)Q[u][p]-=f*Q[m][p];r[u]=q[u][U]+ot[u]}continue t}if(!(H=this.trstlp(e,i,et,K,J,ot))){for(f=0,p=1;p<=e;++p)f+=ot[p]*ot[p];if(f<.25*J*J){v=!0;break i}}for(c=0,M=0,K[F]=0,p=1;p<=F;++p)c=K[p]-this.DOT_PRODUCT_ROW_COL(ot,-1,et,p,1,e),p<F&&(M=Math.max(M,c));if(G<1.5*(N=(V=tt[s][U]-M)>0?c/V:0))for(G=2*N,a>=2&&console.log("Increase in PARMU to "+G),A=tt[F][U]+G*tt[s][U],u=1;u<=e;++u)if((f=tt[F][u]+G*tt[s][u])<A||f===A&&0===G&&tt[s][u]<tt[s][U])continue e;for($=G*V-c,p=1;p<=e;++p)r[p]=q[p][U]+ot[p];v=!0;continue t}for(Z=!1,k=tt[F][U]+G*tt[s][U]-(j+G*X),0===G&&j===tt[F][U]&&($=V,k=tt[s][U]-X),R=k<=0?1:0,m=0,u=1;u<=e;++u)(f=Math.abs(this.DOT_PRODUCT_ROW_COL(Q,u,ot,-1,1,e)))>R&&(m=u,R=f),rt[u]=f*it[u];for(D=1.1*J,_=0,u=1;u<=e;++u)if(rt[u]>=W||rt[u]>=it[u]){if(f=st[u],k>0){for(f=0,p=1;p<=e;++p)f+=Math.pow(ot[p]-q[p][u],2);f=Math.sqrt(f)}f>D&&(_=u,D=f)}if(_>0&&(m=_),0!==m){for(f=0,d=1;d<=e;++d)q[d][m]=ot[d],f+=Q[m][d]*ot[d];for(p=1;p<=e;++p)Q[m][p]/=f;for(u=1;u<=e;++u)if(u!==m)for(f=this.DOT_PRODUCT_ROW_COL(Q,u,ot,-1,1,e),p=1;p<=e;++p)Q[u][p]-=f*Q[m][p];for(p=1;p<=s;++p)tt[p][m]=K[p];if(k>0&&k>=.1*$)continue e}}while(0);if(z){if(J<=n){Y=this.Normal;break t}if(L=0,B=0,(J*=.5)<=1.5*n&&(J=n),G>0){for(I=0,p=1;p<=F;++p){for(B=L=tt[p][U],d=1;d<=e;++d)L=Math.min(L,tt[p][d]),B=Math.max(B,tt[p][d]);p<=i&&L<.5*B&&(f=Math.max(B,0)-L,I=I<=0?f:Math.min(I,f))}0===I?G=0:B-L<G*I&&(G=(B-L)/I)}a>=2&&console.log("Reduction in RHO to "+J+"  and PARMU = "+G),2===a&&this.PrintIterationResult(g,tt[F][U],tt[s][U],this.COL(q,U),e,a)}else v=!1}}switch(Y){case this.Normal:if(a>=1&&console.log("%nNormal return from subroutine COBYLA%n"),H)return a>=1&&this.PrintIterationResult(g,j,X,r,e,a),Y;break;case this.MaxIterationsReached:a>=1&&console.log("%nReturn from subroutine COBYLA because the MAXFUN limit has been reached.%n");break;case this.DivergingRoundingErrors:a>=1&&console.log("%nReturn from subroutine COBYLA because rounding errors are becoming damaging.%n")}for(p=1;p<=e;++p)r[p]=q[p][U];return j=tt[F][U],X=tt[s][U],a>=1&&this.PrintIterationResult(g,j,X,r,e,a),Y},trstlp:function(t,e,i,s,r,o){var n,a,h,l,c,d,u,p,_,f,b,g,m,v,Z,C,y,P,E,O,x,w,S,T,M,N,A,k,R,D,L,B,I,Y=0,j=0,X=0,U=this.arr2(1+t,1+t),F=this.arr(2+e),J=this.arr(2+e),G=this.arr(1+t),z=this.arr(1+t),H=this.arr(2+e),W=this.arr(2+e),V=e,$=0;for(h=1;h<=t;++h)U[h][h]=1,o[h]=0;if(n=0,a=0,e>=1){for(l=1;l<=e;++l)s[l]>a&&(a=s[l],n=l);for(l=1;l<=e;++l)W[l]=l,J[l]=a-s[l]}c=!0;do{t:for(;;){(!c||c&&0===a)&&(n=V=e+1,W[V]=V,J[V]=0),c=!1,d=0,u=0,p=0,_=0;e:do{if(f=V===e?a:-this.DOT_PRODUCT_ROW_COL(o,-1,i,V,1,t),0===u||f<d?(d=f,j=$,u=3):$>j?(j=$,u=3):--u,0===u)break t;if(b=0,n<=$){if(n<$){g=W[n],m=J[n],l=n;do{for(C=W[Z=l+1],y=this.DOT_PRODUCT(this.PART(this.COL(U,l),1,t),this.PART(this.COL(i,C),1,t)),Y=Math.sqrt(y*y+F[Z]*F[Z]),P=F[Z]/Y,E=y/Y,F[Z]=P*F[l],F[l]=Y,h=1;h<=t;++h)Y=P*U[h][Z]+E*U[h][l],U[h][Z]=P*U[h][l]-E*U[h][Z],U[h][l]=Y;W[l]=C,J[l]=J[Z],l=Z}while(l<$);W[l]=g,J[l]=m}if(--$,V>e)for(Y=1/F[$],l=1;l<=t;++l)G[l]=Y*U[l][$];else for(Y=this.DOT_PRODUCT_ROW_COL(G,-1,U,$+1,1,t),l=1;l<=t;++l)G[l]-=Y*U[l][$+1]}else{for(C=W[n],l=1;l<=t;++l)z[l]=i[l][C];for(O=0,l=t;l>$;){for(y=0,x=0,h=1;h<=t;++h)y+=Y=U[h][l]*z[h],x+=Math.abs(Y);if(w=x+.1*Math.abs(y),S=x+.2*Math.abs(y),(x>=w||w>=S)&&(y=0),0===O)O=y;else for(Z=l+1,P=y/(Y=Math.sqrt(y*y+O*O)),E=O/Y,O=Y,h=1;h<=t;++h)Y=P*U[h][l]+E*U[h][Z],U[h][Z]=P*U[h][Z]-E*U[h][l],U[h][l]=Y;--l}if(0===O){b=-1,l=$;do{for(T=0,M=0,h=1;h<=t;++h)T+=Y=U[h][l]*z[h],M+=Math.abs(Y);if(w=M+.1*Math.abs(T),S=M+.2*Math.abs(T),M<w&&w<S){if((Y=T/F[l])>0&&W[l]<=e&&(I=J[l]/Y,(b<0||I<b)&&(b=I)),l>=2)for(N=W[l],h=1;h<=t;++h)z[h]-=Y*i[h][N];H[l]=Y}else H[l]=0}while(--l>0);if(b<0)break t;for(l=1;l<=$;++l)J[l]=Math.max(0,J[l]-b*H[l]);if(n<$){g=W[n],m=J[n],l=n;do{for(N=W[Z=l+1],y=this.DOT_PRODUCT(this.PART(this.COL(U,l),1,t),this.PART(this.COL(i,N),1,t)),Y=Math.sqrt(y*y+F[Z]*F[Z]),P=F[Z]/Y,E=y/Y,F[Z]=P*F[l],F[l]=Y,h=1;h<=t;++h)Y=P*U[h][Z]+E*U[h][l],U[h][Z]=P*U[h][l]-E*U[h][Z],U[h][l]=Y;W[l]=N,J[l]=J[Z],l=Z}while(l<$);W[l]=g,J[l]=m}if(0===(Y=this.DOT_PRODUCT(this.PART(this.COL(U,$),1,t),this.PART(this.COL(i,C),1,t))))break t;F[$]=Y,J[n]=0,J[$]=b}else F[++$]=O,J[n]=J[$],J[$]=0;if(W[n]=W[$],W[$]=C,V>e&&C!==V){for(l=$-1,y=this.DOT_PRODUCT(this.PART(this.COL(U,l),1,t),this.PART(this.COL(i,C),1,t)),Y=Math.sqrt(y*y+F[$]*F[$]),P=F[$]/Y,E=y/Y,F[$]=P*F[l],F[l]=Y,h=1;h<=t;++h)Y=P*U[h][$]+E*U[h][l],U[h][$]=P*U[h][l]-E*U[h][$],U[h][l]=Y;W[$]=W[l],W[l]=C,Y=J[l],J[l]=J[$],J[$]=Y}if(V>e)for(Y=1/F[$],l=1;l<=t;++l)G[l]=Y*U[l][$];else for(C=W[$],Y=(this.DOT_PRODUCT_ROW_COL(G,-1,i,C,1,t)-1)/F[$],l=1;l<=t;++l)G[l]-=Y*U[l][$]}for(A=r*r,R=0,k=0,h=1;h<=t;++h)Math.abs(o[h])>=1e-6*r&&(A-=o[h]*o[h]),R+=o[h]*G[h],k+=G[h]*G[h];if(A<=0)break t;if(Y=Math.sqrt(k*A),Math.abs(R)>=1e-6*Y&&(Y=Math.sqrt(k*A+R*R)),p=_=A/(Y+R),V===e){if(S=p+.2*a,p>=(w=p+.1*a)||w>=S)break e;p=Math.min(p,a)}for(l=1;l<=t;++l)z[l]=o[l]+p*G[l];if(V===e)for(X=a,a=0,l=1;l<=$;++l)Y=s[C=W[l]]-this.DOT_PRODUCT_ROW_COL(z,-1,i,C,1,t),a=Math.max(a,Y);l=$;do{for(D=0,L=0,h=1;h<=t;++h)D+=Y=U[h][l]*z[h],L+=Math.abs(Y);if(w=L+.1*Math.abs(D),S=L+.2*Math.abs(D),(L>=w||w>=S)&&(D=0),H[l]=D/F[l],l>=2)for(C=W[l],h=1;h<=t;++h)z[h]-=H[l]*i[h][C]}while(l-- >=2);for(V>e&&(H[$]=Math.max(0,H[$])),l=1;l<=t;++l)z[l]=o[l]+p*G[l];if(V>$)for(l=$+1;l<=V;++l){for(v=a-s[C=W[l]],B=a+Math.abs(s[C]),h=1;h<=t;++h)v+=Y=i[h][C]*z[h],B+=Math.abs(Y);w=B+.1*Math.abs(v),S=B+.2*Math.abs(v),(B>=w||w>=S)&&(v=0),H[l]=v}for(b=1,n=0,l=1;l<=V;++l)H[l]<0&&(Y=J[l]/(J[l]-H[l]))<b&&(b=Y,n=l);for(Y=1-b,l=1;l<=t;++l)o[l]=Y*o[l]+b*z[l];for(l=1;l<=V;++l)J[l]=Math.max(0,Y*J[l]+b*H[l]);V===e&&(a=X+b*(a-X))}while(n>0);if(p===_)return!0}}while(V===e);return!1},PrintIterationResult:function(t,e,i,s,r,o){o>1&&console.log("NFVALS = "+t+"  F = "+e+"  MAXCV = "+i),o>1&&console.log("X = "+this.PART(s,1,r))},ROW:function(t,e){return t[e].slice()},COL:function(t,e){var i,s=t.length,r=[];for(i=0;i<s;++i)r[i]=t[i][e];return r},PART:function(t,e,i){return t.slice(e,i+1)},FORMAT:function(t){return t.join(",")},DOT_PRODUCT:function(t,e){var i,s=0,r=t.length;for(i=0;i<r;++i)s+=t[i]*e[i];return s},DOT_PRODUCT_ROW_COL:function(t,e,i,s,r,o){var n,a=0;if(-1===e)for(n=r;n<=o;++n)a+=t[n]*i[n][s];else if(-1===s)for(n=r;n<=o;++n)a+=t[e][n]*i[n];else for(n=r;n<=o;++n)a+=t[e][n]*i[n][s];return a}};t.Z.Math.Nlp;var c=__webpack_require__(705),d=__webpack_require__(309),u=__webpack_require__(922);o.Z.Plot={checkReal:function(t){var e,i,s=!1,r=t.length;for(e=0;e<r;e++)if(i=t[e].usrCoords,!isNaN(i[1])&&!isNaN(i[2])&&Math.abs(i[0])>o.Z.eps){s=!0;break}return s},updateParametricCurveNaive:function(t,e,s,r){var o,n,a=!1,h=(s-e)/r;for(o=0;o<r;o++)n=e+o*h,t.points[o].setCoordinates(i.Z.COORDS_BY_USER,[t.X(n,a),t.Y(n,a)],!1),t.points[o]._t=n,a=!0;return t},isSegmentOutside:function(t,e,i,s,r){return e<0&&s<0||e>r.canvasHeight&&s>r.canvasHeight||t<0&&i<0||t>r.canvasWidth&&i>r.canvasWidth},isDistOK:function(t,e,i,s){return Math.abs(t)<i&&Math.abs(e)<s&&!isNaN(t+e)},isSegmentDefined:function(t,e,i,s){return!(isNaN(t+e)&&isNaN(i+s))},updateParametricCurveOld:function(e,s,r){var n,a,h,l,d,u,p,_,f,b,g,m=!1,v=new c.Z(i.Z.COORDS_BY_USER,[0,0],e.board,!1),Z=[],C=[],y=[],P=[],E=!1,O=0,x=function(t,e,i){var s,r,n=i[1]-t[1],a=i[2]-t[2],h=e[0]-t[1],l=e[1]-t[2],c=h*h+l*l;return c>=o.Z.eps&&(s=(n*h+a*l)/c)>0&&(s<=1?(n-=s*h,a-=s*l):(n-=h,a-=l)),r=n*n+a*a,Math.sqrt(r)};for(t.Z.deprecated("Curve.updateParametricCurveOld()"),e.board.updateQuality===e.board.BOARD_QUALITY_LOW?(f=15,b=10,g=10):(f=21,b=.7,g=.7),P[0]=r-s,n=1;n<f;n++)P[n]=.5*P[n-1];n=1,Z[0]=1,C[0]=0,a=s,v.setCoordinates(i.Z.COORDS_BY_USER,[e.X(a,m),e.Y(a,m)],!1),m=!0,d=v.scrCoords[1],u=v.scrCoords[2],a=r,v.setCoordinates(i.Z.COORDS_BY_USER,[e.X(a,m),e.Y(a,m)],!1),h=v.scrCoords[1],l=v.scrCoords[2],y[0]=[h,l],p=1,_=0,e.points=[],e.points[O++]=new c.Z(i.Z.COORDS_BY_SCREEN,[d,u],e.board,!1);do{for(E=this.isDistOK(h-d,l-u,b,g)||this.isSegmentOutside(d,u,h,l,e.board);_<f&&(!E||_<6)&&(_<=7||this.isSegmentDefined(d,u,h,l));)Z[p]=n,C[p]=_,y[p]=[h,l],p+=1,a=s+(n=2*n-1)*P[++_],v.setCoordinates(i.Z.COORDS_BY_USER,[e.X(a,m),e.Y(a,m)],!1,!0),h=v.scrCoords[1],l=v.scrCoords[2],E=this.isDistOK(h-d,l-u,b,g)||this.isSegmentOutside(d,u,h,l,e.board);O>1&&x(e.points[O-2].scrCoords,[h,l],e.points[O-1].scrCoords)<.015&&(O-=1),e.points[O]=new c.Z(i.Z.COORDS_BY_SCREEN,[h,l],e.board,!1),e.points[O]._t=a,O+=1,d=h,u=l,a,h=y[p-=1][0],l=y[p][1],_=C[p]+1,n=2*Z[p]}while(p>0&&O<5e5);return e.numberPoints=e.points.length,e},_insertPoint_v2:function(t,e,i){var s=!isNaN(this._lastCrds[1]+this._lastCrds[2]),r=!isNaN(e.scrCoords[1]+e.scrCoords[2]),o=t.board.canvasWidth,n=t.board.canvasHeight,a=500;(!(r=r&&e.scrCoords[1]>-500&&e.scrCoords[2]>-500&&e.scrCoords[1]<o+a&&e.scrCoords[2]<n+a)&&s||r&&(!s||Math.abs(e.scrCoords[1]-this._lastCrds[1])>.7||Math.abs(e.scrCoords[2]-this._lastCrds[2])>.7))&&(e._t=i,t.points.push(e),this._lastCrds=e.copy("scrCoords"))},neighborhood_isNaN_v2:function(t,e){var s,r,n=new c.Z(i.Z.COORDS_BY_USER,[0,0],t.board,!1);return s=e+o.Z.eps,n.setCoordinates(i.Z.COORDS_BY_USER,[t.X(s,!0),t.Y(s,!0)],!1),r=n.usrCoords,!!(isNaN(r[1]+r[2])||(s=e-o.Z.eps,n.setCoordinates(i.Z.COORDS_BY_USER,[t.X(s,!0),t.Y(s,!0)],!1),r=n.usrCoords,isNaN(r[1]+r[2])))},_borderCase:function(t,e,s,r,o,n,a,h){var l,d,u,p,_,f,b,g=null,m=!1;if(h<=1){if(d=new c.Z(i.Z.COORDS_BY_USER,[0,0],t.board,!1),isNaN(e[1]+e[2])&&!isNaN(r[1]+r[2])&&!this.neighborhood_isNaN_v2(t,o))return!1;if(isNaN(s[1]+s[2])&&!isNaN(r[1]+r[2])&&!this.neighborhood_isNaN_v2(t,n))return!1;if(isNaN(r[1]+r[2])&&(!isNaN(e[1]+e[2])||!isNaN(s[1]+s[2]))&&!this.neighborhood_isNaN_v2(t,a))return!1;p=0;do{if(isNaN(e[1]+e[2])&&!isNaN(r[1]+r[2]))_=o,f=a,b=n;else if(isNaN(s[1]+s[2])&&!isNaN(r[1]+r[2]))_=n,f=a,b=o;else if(isNaN(r[1]+r[2])&&!isNaN(s[1]+s[2]))_=a,f=n,b=n+(n-a);else{if(!isNaN(r[1]+r[2])||isNaN(e[1]+e[2]))return!1;_=a,f=o,b=o-(a-o)}l=.5*(_+f),d.setCoordinates(i.Z.COORDS_BY_USER,[t.X(l,!0),t.Y(l,!0)],!1),u=d.usrCoords,(m=isNaN(u[1]+u[2]))?_=l:(b=f,f=l),++p}while(m&&p<30);if(p<30&&(g=u.slice(),r=u.slice(),f=l),(t.X(f,!0)-t.X(b,!0))/(f-b),(t.Y(f,!0)-t.Y(b,!0))/(f-b),null!==g)return this._insertPoint_v2(t,new c.Z(i.Z.COORDS_BY_USER,g,t.board,!1)),!0}return!1},_plotRecursive_v2:function(t,e,s,r,o,n,a){var h,l,d,u,p,_=0,f=new c.Z(i.Z.COORDS_BY_USER,[0,0],t.board,!1);if(!(t.numberPoints>65536))return n<this.nanLevel&&this._isUndefined(t,e,s,r,o)||n<this.nanLevel&&this._isOutside(e,s,r,o,t.board)?this:(h=.5*(s+o),f.setCoordinates(i.Z.COORDS_BY_USER,[t.X(h,!0),t.Y(h,!0)],!1),l=f.scrCoords,this._borderCase(t,e,r,l,s,o,h,n)||(d=this._triangleDists(e,r,l),u=n<this.smoothLevel&&d[3]<a,p=n<this.jumpLevel&&(d[2]>.99*d[0]||d[1]>.99*d[0]||d[0]===1/0||d[1]===1/0||d[2]===1/0),n<this.smoothLevel+2&&d[0]<.5*(d[1]+d[2])&&(_=0,u=!1),--n,p?this._insertPoint_v2(t,new c.Z(i.Z.COORDS_BY_SCREEN,[NaN,NaN],t.board,!1),h):n<=_||u?this._insertPoint_v2(t,f,h):(this._plotRecursive_v2(t,e,s,l,h,n,a),isNaN(f.scrCoords[1]+f.scrCoords[2])||this._insertPoint_v2(t,f,h),this._plotRecursive_v2(t,l,h,r,o,n,a))),this)},updateParametricCurve_v2:function(t,e,r){var o,n,a,h,l,d,u,p,_,f=!1,b=new c.Z(i.Z.COORDS_BY_USER,[0,0],t.board,!1),g=new c.Z(i.Z.COORDS_BY_USER,[0,0],t.board,!1);return t.board.updateQuality===t.board.BOARD_QUALITY_LOW?(l=s.Z.evaluate(t.visProp.recursiondepthlow)||13,d=2,this.smoothLevel=l-6,this.jumpLevel=3):(l=s.Z.evaluate(t.visProp.recursiondepthhigh)||17,d=2,this.smoothLevel=l-9,this.jumpLevel=2),this.nanLevel=l-4,t.points=[],"x"===this.xterm?(u=.3*((p=t.board.getBoundingBox())[2]-p[0]),.3*(p[1]-p[3]),o=Math.max(e,p[0]-u),n=Math.min(r,p[2]+u)):(o=e,n=r),b.setCoordinates(i.Z.COORDS_BY_USER,[t.X(o,f),t.Y(o,f)],!1),f=!0,g.setCoordinates(i.Z.COORDS_BY_USER,[t.X(n,f),t.Y(n,f)],!1),_=this._findStartPoint(t,b.scrCoords,o,g.scrCoords,n),b.setCoordinates(i.Z.COORDS_BY_SCREEN,_[0],!1),o=_[1],_=this._findStartPoint(t,g.scrCoords,n,b.scrCoords,o),g.setCoordinates(i.Z.COORDS_BY_SCREEN,_[0],!1),n=_[1],this._visibleArea=[o,n],a=b.copy("scrCoords"),h=g.copy("scrCoords"),b._t=o,t.points.push(b),this._lastCrds=b.copy("scrCoords"),this._plotRecursive_v2(t,a,o,h,n,l,d),g._t=n,t.points.push(g),t.numberPoints=t.points.length,t},_insertLimesPoint:function(t,e,s,r,n){var a,h,l;Math.abs(this._lastUsrCrds[1])===1/0&&Math.abs(n.left_x)===1/0||Math.abs(this._lastUsrCrds[2])===1/0&&Math.abs(n.left_y)===1/0||((a=new c.Z(i.Z.COORDS_BY_USER,[n.left_x,n.left_y],t.board))._t=s,t.points.push(a),isNaN(n.left_x)||isNaN(n.left_y)||isNaN(n.right_x)||isNaN(n.right_y)||!(Math.abs(n.left_x-n.right_x)>o.Z.eps||Math.abs(n.left_y-n.right_y)>o.Z.eps)||((h=new c.Z(i.Z.COORDS_BY_SCREEN,e,t.board))._t=s,t.points.push(h)),(l=new c.Z(i.Z.COORDS_BY_USER,[n.right_x,n.right_y],t.board))._t=s,t.points.push(l),this._lastScrCrds=l.copy("scrCoords"),this._lastUsrCrds=l.copy("usrCoords"))},_insertPoint:function(t,e,r,o,n){var a,h=!isNaN(this._lastScrCrds[1]+this._lastScrCrds[2]),l=!isNaN(e[1]+e[2]),d=t.board.canvasWidth,u=t.board.canvasHeight,p=500;s.Z.exists(n)?this._insertLimesPoint(t,e,r,o,n):(l=l&&e[1]>-500&&e[2]>-500&&e[1]<d+p&&e[2]<u+p,(h||l)&&(l&&h&&Math.abs(e[1]-this._lastScrCrds[1])<.8&&Math.abs(e[2]-this._lastScrCrds[2])<.8||Math.abs(e[1])===1/0&&Math.abs(this._lastUsrCrds[1])===1/0||Math.abs(e[2])===1/0&&Math.abs(this._lastUsrCrds[2])===1/0||((a=new c.Z(i.Z.COORDS_BY_SCREEN,e,t.board))._t=r,t.points.push(a),this._lastScrCrds=a.copy("scrCoords"),this._lastUsrCrds=a.copy("usrCoords"))))},_triangleDists:function(t,e,i){var s;return s=[t[0]*e[0],.5*(t[1]+e[1]),.5*(t[2]+e[2])],[u.Z.distance(t,e,3),u.Z.distance(t,i,3),u.Z.distance(i,e,3),u.Z.distance(i,s,3)]},_isUndefined:function(t,e,s,r,o){var n,a,h;if(!isNaN(e[1]+e[2])||!isNaN(r[1]+r[2]))return!1;for(h=new c.Z(i.Z.COORDS_BY_USER,[0,0],t.board,!1),a=0;a<20;++a)if(n=s+Math.random()*(o-s),h.setCoordinates(i.Z.COORDS_BY_USER,[t.X(n,!0),t.Y(n,!0)],!1),!isNaN(h.scrCoords[0]+h.scrCoords[1]+h.scrCoords[2]))return!1;return!0},_isOutside:function(t,e,i,s,r){var o=500,n=r.canvasWidth,a=r.canvasHeight;return!!(t[1]<-500&&i[1]<-500||t[2]<-500&&i[2]<-500||t[1]>n+o&&i[1]>n+o||t[2]>a+o&&i[2]>a+o)},_isOutsidePoint:function(t,e){var i=500,s=e.canvasWidth,r=e.canvasHeight;return!!(t[1]<-500||t[2]<-500||t[1]>s+i||t[2]>r+i)},_findStartPoint:function(t,e,i,s,r){return[e,i]},_getBorderPos:function(t,e,s,r,n,a,h){var l,d,u,p,_,f;if(d=new c.Z(i.Z.COORDS_BY_USER,[0,0],t.board,!1),p=0,isNaN(s[1]+s[2])&&!isNaN(n[1]+n[2]))f=e,_=r,a;else if(isNaN(h[1]+h[2])&&!isNaN(n[1]+n[2]))f=a,_=r,e;else if(isNaN(n[1]+n[2])&&!isNaN(h[1]+h[2]))f=r,_=a,a+(a-r);else{if(!isNaN(n[1]+n[2])||isNaN(s[1]+s[2]))return!1;f=r,_=e,e-(r-e)}do{l=.5*(_+f),d.setCoordinates(i.Z.COORDS_BY_USER,[t.X(l,!0),t.Y(l,!0)],!1),u=d.usrCoords,isNaN(u[1]+u[2])?f=l:(_,_=l),++p}while(p<30&&Math.abs(_-f)>o.Z.eps);return l},_getCuspPos:function(t,e,i){var s=[t.X(e,!0),t.Y(e,!0)],r=[t.X(i,!0),t.Y(i,!0)];return l.Z.fminbr((function(e){var i=[t.X(e,!0),t.Y(e,!0)];return-(Math.sqrt((s[0]-i[0])*(s[0]-i[0])+(s[1]-i[1])*(s[1]-i[1]))+Math.sqrt((r[0]-i[0])*(r[0]-i[0])+(r[1]-i[1])*(r[1]-i[1])))}),[e,i],t)},_getJumpPos:function(t,e,i){return l.Z.fminbr((function(e){var i=o.Z.eps*o.Z.eps,s=[t.X(e,!0),t.Y(e,!0)],r=[t.X(e+i,!0),t.Y(e+i,!0)];return-Math.abs((r[1]-s[1])/(r[0]-s[0]))}),[e,i],t)},_getLimits:function(t,e){var i,s,r,o,n,h=2/(t.maxX()-t.minX());return s=(i=a.limit(e,-h,t.X))[0],"infinite"===i[1]&&(s=Math.sign(s)*(1/0)),o=(i=a.limit(e,-h,t.Y))[0],"infinite"===i[1]&&(o=Math.sign(o)*(1/0)),r=(i=a.limit(e,h,t.X))[0],"infinite"===i[1]&&(r=Math.sign(r)*(1/0)),n=(i=a.limit(e,h,t.Y))[0],"infinite"===i[1]&&(n=Math.sign(n)*(1/0)),{left_x:s,left_y:o,right_x:r,right_y:n,t:e}},_getLimes:function(t,e,i,s,r,o,n,a,h){var l;return"border"===a?l=this._getBorderPos(t,e,i,s,r,o,n):"cusp"===a?l=this._getCuspPos(t,e,o):"jump"===a&&(l=this._getJumpPos(t,e,o)),this._getLimits(t,l)},_plotNonRecursive:function(t,e,i,s,r,o){var n,a,h,l,c,d,u,p,_,f,b,g=null,m=!1,v="",Z=[],C=0;for(p=t.board.origin.scrCoords,Z[C++]=[e,i,s,r,o,1/0];C>0;){if(e=(b=Z[--C])[0],i=b[1],s=b[2],r=b[3],_=b[4],f=b[5],m=!1,v="",g=null,t.points.length>65536)return;if(_<this.nanLevel){if(this._isUndefined(t,e,i,s,r))continue;if(this._isOutside(e,i,s,r,t.board))continue}n=.5*(i+r),d=t.X(n,!0),u=t.Y(n,!0),a=[1,p[1]+d*t.board.unitX,p[2]-u*t.board.unitY],h=this._triangleDists(e,s,a),l=isNaN(e[1]+e[2]),c=isNaN(s[1]+s[2]),l&&!c||!l&&c?v="border":h[0]>.66*f||h[0]<this.cusp_threshold*(h[1]+h[2])||h[1]>5*h[2]||h[2]>5*h[1]?v="cusp":(h[2]>this.jump_threshold*h[0]||h[1]>this.jump_threshold*h[0]||h[0]===1/0||h[1]===1/0||h[2]===1/0)&&(v="jump"),m=""===v&&_<this.smoothLevel&&h[3]<this.smooth_threshold,_<this.testLevel&&!m&&(""===v?m=!0:g=this._getLimes(t,i,e,n,a,r,s,v,_)),null!==g?(a=[1,NaN,NaN],this._insertPoint(t,a,n,_,g)):_<=0||m?this._insertPoint(t,a,n,_,null):(Z[C++]=[a,n,s,r,_-1,h[0]],Z[C++]=[e,i,a,n,_-1,h[0]])}return this},updateParametricCurve_v3:function(t,e,r){var o,n,a,h,l,d,u,p,_=!1,f=new c.Z(i.Z.COORDS_BY_USER,[0,0],t.board,!1),b=new c.Z(i.Z.COORDS_BY_USER,[0,0],t.board,!1);return l=t.board.updateQuality===t.board.BOARD_QUALITY_LOW?s.Z.evaluate(t.visProp.recursiondepthlow)||14:s.Z.evaluate(t.visProp.recursiondepthhigh)||17,this.smoothLevel=7,this.nanLevel=l-4,this.testLevel=4,this.cusp_threshold=.5,this.jump_threshold=.99,this.smooth_threshold=2,t.points=[],"x"===t.xterm?(d=.3*((u=t.board.getBoundingBox())[2]-u[0]),o=Math.max(e,u[0]-d),n=Math.min(r,u[2]+d)):(o=e,n=r),f.setCoordinates(i.Z.COORDS_BY_USER,[t.X(o,_),t.Y(o,_)],!1),_=!0,b.setCoordinates(i.Z.COORDS_BY_USER,[t.X(n,_),t.Y(n,_)],!1),p=this._findStartPoint(t,f.scrCoords,o,b.scrCoords,n),f.setCoordinates(i.Z.COORDS_BY_SCREEN,p[0],!1),o=p[1],p=this._findStartPoint(t,b.scrCoords,n,f.scrCoords,o),b.setCoordinates(i.Z.COORDS_BY_SCREEN,p[0],!1),n=p[1],this._visibleArea=[o,n],a=f.copy("scrCoords"),h=b.copy("scrCoords"),f._t=o,t.points.push(f),this._lastScrCrds=f.copy("scrCoords"),this._lastUsrCrds=f.copy("usrCoords"),this._plotNonRecursive(t,a,o,h,n,l),b._t=n,t.points.push(b),t.numberPoints=t.points.length,t},_criticalInterval:function(t,e,i){var s,r,o,n,a,h,l,c=!1,u=-1/0,p=!1,_=!1,f=0,b=[],g=[],m=[];for(l=d.Z.abs(t),(n=d.Z.median(l))<1e-7?(n=1e-7,p=!0):n*=this.criticalThreshold,s=0;s<e;s++)l[s]>n?(m.push({i:s,v:t[s],group:f}),u=s,c||(c=!0)):c&&s>u+4&&(m.length>0&&b.push(m.slice(0)),m=[],c=!1,f++);for(c&&m.length>1&&b.push(m.slice(0)),p&&0===b.length&&(_=!0),r=0;r<b.length;r++)if(g[r]="point",!((o=b[r].length)<64)){for(h=0,a=Math.sign(b[r][0].v),s=1;s<o;s++)Math.sign(b[r][s].v)!==a&&(h++,a=Math.sign(b[r][s].v));6*h>o&&(g[r]="interval")}return{smooth:_,groups:b,types:g}},Component:function(){this.left_isNaN=!1,this.right_isNaN=!1,this.left_t=null,this.right_t=null,this.t_values=[],this.x_values=[],this.y_values=[],this.len=0},findComponents:function(t,e,i,s){var r,o,n,a,h,l,c=[],d=0,u=0,p=0,_=!1,f=!1;for(n=(i-e)/s,c[d]=new this.Component,l=c[d],r=0,o=e;r<=s;r++,o+=n)a=t.X(o,f),h=t.Y(o,f),isNaN(a)||isNaN(h)?++p>1&&_&&(l.right_isNaN=!0,l.right_t=o-n,l.len=u,_=!1,c[++d]=new this.Component,l=c[d],p=0):(_||(_=!0,u=0,p>0&&(l.left_t=o-n,l.left_isNaN=!0)),p=0,l.t_values[u]=o,l.x_values[u]=a,l.y_values[u]=h,u++),0===r&&(f=!0);return _?l.len=u:c.pop(),c},getPointType:function(t,e,i,s,r,o,n){var a=r[0],h=o[0],l=s.length,c={idx:e,t:i,x:a[e],y:h[e],type:"other"};return e<5?(c.type="borderleft",c.idx=0,c.t=s[0],c.x=a[0],c.y=h[0],c):e>n-6?(c.type="borderright",c.idx=l-1,c.t=s[l-1],c.x=a[l-1],c.y=h[l-1],c):c},newtonApprox:function(t,e,i,s,r){var o,n=0;for(o=s;o>0;o--)n=(n+r[o][t])*(e-(o-1)*i)/o;return n+r[0][t]},thiele:function(t,e,i,s,r){var o,n=0;for(o=r;o>1;o--)n=(t-i[s+o])/(e[o][s+1]-e[o-2][s+1]+n);return e[0][s+1]+(t-i[s+1])/(e[1][s+1]+n)},differenceMethodExperiments:function(t,e){var i,s,r,o,n,a,h,l,c,d,u,p=t.t_values,_=t.x_values,f=t.y_values,b=[],g=[],m=[],v=[],Z=[],C=[],y=[],P=[],E=0,O=[];for(n=p[1]-p[0],Z.push([]),C.push([]),y.push([]),P.push([]),r=f.length,i=0;i<r;i++)Z[0][i]=_[i],C[0][i]=f[i],y[0][i]=_[i],P[0][i]=f[i];for(Z.push([]),C.push([]),y.push([]),P.push([]),a=n,r=f.length-1,i=0;i<r;i++)b[i]=_[i+1]-_[i],g[i]=f[i+1]-f[i],m[i]=b[i],v[i]=g[i],Z[1][i]=b[i],C[1][i]=g[i],y[1][i]=a/b[i],P[1][i]=a/g[i];for(r--,o=Math.min(8,f.length-1),s=1;s<o;s++){for(Z.push([]),C.push([]),y.push([]),P.push([]),a*=n,i=0;i<r;i++)b[i]=b[i+1]-b[i],g[i]=g[i+1]-g[i],Z[s+1][i]=b[i],C[s+1][i]=g[i],y[s+1][i]=a/(y[s][i+1]-y[s][i])+y[s-1][i+1],P[s+1][i]=a/(P[s][i+1]-P[s][i])+P[s-1][i+1];if(!1===(u=this._criticalPoints(g,r,s))){console.log("Polynomial of degree",s),u=[];break}if(u.length>0&&++E>1&&s%2==0)break;r--}for(i=0;i<u.length;i++){for(l=-1/0,c=0;c<u[i].length;c++)(d=Math.abs(u[i][c].v))>l&&(l=d,h=c);h=Math.floor(u[i][h].i+s/2),O.push(this.getPointType(e,h,p,_,f,m,v,r+1))}return[O,Z,C,y,P]},getCenterOfCriticalInterval:function(t,e,i){var s,r,o,n,a,h=0,l=0,c=i[1]-i[0],d=[];for(s=-1/0,d=[],r=0;r<t.length;r++)(n=Math.abs(t[r].v))>s?(d=[r],s=n,o=r):s===n&&d.push(r);if(d.length>0&&(a=d.reduce((function(t,e){return t+e}),0)/d.length,o=Math.floor(a),a+=t[0].i),s<1/0){for(r=0;r<t.length;r++)h+=Math.abs(t[r].v)*t[r].i,l+=Math.abs(t[r].v);a=h/l}return a+=e/2,[t[o].i+e/2,a,i[Math.floor(a)]+c*(a-Math.floor(a))]},differenceMethod:function(t,e){var i,s,r,o,n,a,h,l,c,d,u=t.t_values,p=t.x_values,_=t.y_values,f=[],b=[],g=0,m=-1,v=-1,Z=[],C=[];for(r=_.length,f.push(new Float64Array(p)),b.push(new Float64Array(_)),r--,o=Math.min(12,r),s=0;s<o&&(f.push(new Float64Array(r)),b.push(new Float64Array(r)),f[s+1]=f[s].map((function(t,e,i){return i[e+1]-t})),b[s+1]=b[s].map((function(t,e,i){return i[e+1]-t})),!0===(l=this._criticalInterval(b[s+1],r,s)).smooth&&(v=s,Z=[]),h=this._criticalInterval(f[s+1],r,s),-1===m&&!0===h.smooth&&(m=s),!(v>=0));s++){if(l.groups.length>0&&++g>2&&(s+1)%2==0){Z=l.groups,d=l.types;break}r--}for(i=0;i<Z.length;i++)"interval"!==d[i]&&(a=this.getCenterOfCriticalInterval(Z[i],s+1,u),l[0],n=Math.floor(a[1]),c=a[2],C.push(this.getPointType(e,n,c,u,f,b,r+1)));return[C,f,b,m,v]},_insertPoint_v4:function(t,e,s,r){var o,n,a,h=null;t.points.length>0&&(h=t.points[t.points.length-1].scrCoords),o=new c.Z(i.Z.COORDS_BY_USER,e,t.board),null!==h&&(n=o.scrCoords[1]-h[1])*n+(a=o.scrCoords[2]-h[2])*a<.8*.8||(o._t=s,t.points.push(o))},getInterval:function(e,i,s){var r,o;return n.Z.disable(),r=n.Z.Interval(i,s),e.board.mathLib=n.Z,e.board.mathLibJXG=n.Z,e.X(r,!0),o=e.Y(r,!0),e.board.mathLib=Math,e.board.mathLibJXG=t.Z.Math,o},sign:function(t){return t<0?-1:t>0?1:0},handleBorder:function(t,e,i,r,o){var n,a,h,l,c,d,u,p,_,f,b,g,m=i.idx;if(g=e.t_values[1]-e.t_values[0],"borderleft"===i.type?h=(a=n=e.left_isNaN?e.left_t:i.t-g)+g:"borderright"===i.type?a=(h=n=e.right_isNaN?e.right_t:i.t+g)-g:console.log("No bordercase!!!"),0!==(f=this.findComponents(t,a,h,32)).length){for("borderleft"===i.type&&(a=f[0].left_t,h=f[0].t_values[0],g=f[0].t_values[1]-f[0].t_values[0],n=a=null===a?h-g:a,l=this.getInterval(t,a,h),s.Z.isObject(l)&&(u=l.lo,p=l.hi,c=t.X(n,!0),d=o[1][m]<0?p:u,this._insertPoint_v4(t,[1,c,d],n))),b=f[0].t_values.length,_=0;_<b;_++)n=f[0].t_values[_],c=f[0].x_values[_],d=f[0].y_values[_],this._insertPoint_v4(t,[1,c,d],n);"borderright"===i.type&&(a=f[0].t_values[b-1],h=f[0].right_t,g=f[0].t_values[1]-f[0].t_values[0],n=h=null===h?a+g:h,l=this.getInterval(t,a,h),s.Z.isObject(l)&&(u=l.lo,p=l.hi,c=t.X(n,!0),d=o[1][m]>0?p:u,this._insertPoint_v4(t,[1,c,d],n)))}},_seconditeration_v4:function(t,e,i,s,r){var o,n,a,h,l,c,d,u,p,_,f,b,g;for(n=e.t_values[i.idx-2],a=e.t_values[i.idx+2],l=this.findComponents(t,n,a,64),d=0;d<l.length;d++){for(c=l[d],u=(h=this.differenceMethod(c,t))[0],_=h[1],f=h[2],b=0,p=0;p<=u.length;p++){for(g=p===u.length?c.len:u[p].idx,o=b;o<g;o++)isNaN(c.x_values[o])||isNaN(c.y_values[o])||this._insertPoint_v4(t,[1,c.x_values[o],c.y_values[o]],c.t_values[o]);p<u.length&&(this.handleSingularity(t,c,u[p],_,f),b=u[p].idx+1)}g=c.len,d<l.length-1&&this._insertPoint_v4(t,[1,NaN,NaN],c.right_t)}return this},_recurse_v4:function(t,e,i,s,r,o,n,a){var h,l,c=.5*(e+i),d=t.X(c,!0),u=t.Y(c,!0);0!==a?(h=(d-s)*t.board.unitX,l=(u-r)*t.board.unitY,Math.sqrt(h*h+l*l)>2?this._recurse_v4(t,e,c,s,r,d,u,a-1):this._insertPoint_v4(t,[1,d,u],c),h=(d-o)*t.board.unitX,l=(u-n)*t.board.unitY,Math.sqrt(h*h+l*l)>2?this._recurse_v4(t,c,i,d,u,o,n,a-1):this._insertPoint_v4(t,[1,d,u],c)):this._insertPoint_v4(t,[1,NaN,NaN],c)},handleSingularity:function(t,e,i,r,o){var n,a,h,l,c,d,u,p,_,f,b,g=i.idx,m=100;n=i.t,console.log("HandleSingularity at t =",n),a=e.t_values[g-5],h=e.t_values[g+5],l=this.getInterval(t,a,h),s.Z.isObject(l)?(p=l.lo,_=l.hi):o[0][g-1]<o[0][g+1]?(p=o[0][g-1],_=o[0][g+1]):(p=o[0][g+1],_=o[0][g-1]),u=t.X(n,!0),f=(o[0][g-3]-o[0][g-5])/(e.t_values[g-3]-e.t_values[g-5]),b=(o[0][g+3]-o[0][g+5])/(e.t_values[g+3]-e.t_values[g+5]),console.log(":::",f,b),f<-100?(this._insertPoint_v4(t,[1,u,p],n,!0),b<=m&&this._insertPoint_v4(t,[1,NaN,NaN],n)):f>m?(this._insertPoint_v4(t,[1,u,_],n),b>=-100&&this._insertPoint_v4(t,[1,NaN,NaN],n)):(p===-1/0&&(this._insertPoint_v4(t,[1,u,p],n,!0),this._insertPoint_v4(t,[1,NaN,NaN],n)),_===1/0&&(this._insertPoint_v4(t,[1,NaN,NaN],n),this._insertPoint_v4(t,[1,u,_],n,!0)),i.t<e.t_values[g]?(c=g-1,d=g):(c=g,d=g+1),a=e.t_values[c],h=e.t_values[d],this._recurse_v4(t,a,h,r[0][c],o[0][c],r[0][d],o[0][d],10)),b<-100?this._insertPoint_v4(t,[1,u,_],n):b>m&&this._insertPoint_v4(t,[1,u,p],n)},steps:1021,criticalThreshold:1e3,plot_v4:function(t,e,i,r){var o,n,a,h,c,d,u,p,_,f,b,g,m,v,Z,C=(i-e)/r,y=function(e){return t.Y(e,!0)},P=function(e){return-t.Y(e,!0)},E=.5*C;for(a=this.findComponents(t,e,i,r),h=0;h<a.length;h++){for(c=a[h],d=(_=this.differenceMethod(c,t))[0],f=_[1],b=_[2],_[3],_[4],0!==d.length&&"borderleft"===d[0].type||d.unshift({idx:0,t:c.t_values[0],x:c.x_values[0],y:c.y_values[0],type:"borderleft"}),"borderright"!==d[d.length-1].type&&(n=c.t_values.length,d.push({idx:n-1,t:c.t_values[n-1],x:c.x_values[n-1],y:c.y_values[n-1],type:"borderright"})),p=0,u=0;u<=d.length;u++){for(n=u===d.length?c.len:d[u].idx-1,0,0,o=p;o<n-2;o++)this._insertPoint_v4(t,[1,c.x_values[o],c.y_values[o]],c.t_values[o]),Math.max(0,o-2),o>=p+3&&o<n-3&&b.length>3&&Math.abs(b[2][o])>.2*Math.abs(b[0][o])?(g=c.t_values[o],E=.25*C,Z=this.getInterval(t,g,g+C),s.Z.isObject(Z)?b[2][o]>0?this._insertPoint_v4(t,[1,g+E,Z.lo],g+E):this._insertPoint_v4(t,[1,g+C-E,Z.hi],g+C-E):(m=l.Z.fminbr(y,[g,g+C]))<(v=l.Z.fminbr(P,[g,g+C]))?(this._insertPoint_v4(t,[1,t.X(m,!0),t.Y(m,!0)],m),this._insertPoint_v4(t,[1,t.X(v,!0),t.Y(v,!0)],v)):(this._insertPoint_v4(t,[1,t.X(v,!0),t.Y(v,!0)],v),this._insertPoint_v4(t,[1,t.X(m,!0),t.Y(m,!0)],m))):0;u<d.length&&(o=d[u].idx,"borderleft"===d[u].type||"borderright"===d[u].type?this.handleBorder(t,c,d[u],f,b):this._seconditeration_v4(t,c,d[u],f,b),p=d[u].idx+1+1)}n=c.len,h<a.length-1&&this._insertPoint_v4(t,[1,NaN,NaN],c.right_t)}},updateParametricCurve_v4:function(t,e,i){var s,r,o,n;"x"===t.xterm?(o=.3*((n=t.board.getBoundingBox())[2]-n[0]),s=Math.max(e,n[0]-o),r=Math.min(i,n[2]+o)):(s=e,r=i),t.points=[],this.plot_v4(t,s,r,this.steps),t.numberPoints=t.points.length},updateParametricCurve:function(t,e,i){return this.updateParametricCurve_v2(t,e,i)}};const p=o.Z.Plot;o.Z.Metapost={MP_ENDPOINT:0,MP_EXPLICIT:1,MP_GIVEN:2,MP_CURL:3,MP_OPEN:4,MP_END_CYCLE:5,UNITY:1,FRACTION_ONE:1,FRACTION_THREE:3,ONE_EIGHTY_DEG:Math.PI,THREE_SIXTY_DEG:2*Math.PI,EPS_SQ:1e-5*1e-5,make_choices:function(t){var e,i,s,r,o,n,a,h,l,c,d,u,p,_,f;a=t[0];do{if(!a)break;n=a.next,a.rtype>this.MP_EXPLICIT&&(a.x-n.x)*(a.x-n.x)+(a.y-n.y)*(a.y-n.y)<this.EPS_SQ&&(a.rtype=this.MP_EXPLICIT,a.ltype===this.MP_OPEN&&(a.ltype=this.MP_CURL,a.set_left_curl(this.UNITY)),n.ltype=this.MP_EXPLICIT,n.rtype===this.MP_OPEN&&(n.rtype=this.MP_CURL,n.set_right_curl(this.UNITY)),a.rx=a.x,n.lx=a.x,a.ry=a.y,n.ly=a.y),a=n}while(a!==t[0]);for(i=t[0];i.ltype===this.MP_OPEN&&i.rtype===this.MP_OPEN;)if((i=i.next)===t[0]){i.ltype=this.MP_END_CYCLE;break}for(a=i;a;){if(n=a.next,a.rtype>=this.MP_GIVEN){for(;n.ltype===this.MP_OPEN&&n.rtype===this.MP_OPEN;)n=n.next;for(s=0,h=a,o=t.length,u=[],p=[],_=[],f=[null];c=h.next,u.push(c.x-h.x),p.push(c.y-h.y),_.push(this.mp_pyth_add(u[s],p[s])),s>0&&(d=p[s-1]/_[s-1],l=u[s-1]/_[s-1],f.push(Math.atan2(p[s]*l-u[s]*d,u[s]*l+p[s]*d))),s++,(h=c)===n&&(o=s),!(s>=o&&h.ltype!==this.MP_END_CYCLE););s===o?f.push(0):f.push(f[1]),n.ltype===this.MP_OPEN&&((r=n.rx-n.x)*r+(e=n.ry-n.y)*e<this.EPS_SQ?(n.ltype=this.MP_CURL,n.set_left_curl(this.UNITY)):(n.ltype=this.MP_GIVEN,n.set_left_given(Math.atan2(e,r)))),a.rtype===this.MP_OPEN&&a.ltype===this.MP_EXPLICIT&&((r=a.x-a.lx)*r+(e=a.y-a.ly)*e<this.EPS_SQ?(a.rtype=this.MP_CURL,a.set_right_curl(this.UNITY)):(a.rtype=this.MP_GIVEN,a.set_right_given(Math.atan2(e,r)))),this.mp_solve_choices(a,n,o,u,p,_,f)}else a.rtype===this.MP_ENDPOINT&&(a.rx=a.x,a.ry=a.y,n.lx=n.x,n.ly=n.y);if((a=n)===i)break}},mp_solve_choices:function(t,e,i,s,r,o,n){var a,h,l,c,d,u,p,_,f,b,g,m,v,Z,C,y,P,E,O,x,w,S,T,M,N,A;for(d=o.length+1,b=new Array(d),f=new Array(d),l=new Array(d),C=new Array(d),N=0;N<d;N++)C[N]=l[N]=f[N]=b[N]=0;for(p=0,_=t,m=0;;){if(v=_.next,0===p)if(_.rtype===this.MP_GIVEN){if(v.ltype===this.MP_GIVEN)return a=Math.atan2(r[0],s[0]),x=(O=this.mp_n_sin_cos(t.right_given()-a))[0],w=O[1],T=(S=this.mp_n_sin_cos(e.left_given()-a))[0],M=S[1],void this.mp_set_controls(t,e,s[0],r[0],w,x,-M,T);l[0]=_.right_given()-Math.atan2(r[0],s[0]),l[0]=this.reduce_angle(l[0]),b[0]=0,f[0]=0}else if(_.rtype===this.MP_CURL){if(v.ltype===this.MP_CURL)return t.rtype=this.MP_EXPLICIT,e.ltype=this.MP_EXPLICIT,g=Math.abs(e.left_tension()),y=Math.abs(t.right_tension()),Z=this.UNITY/(3*y),t.rx=t.x+s[0]*Z,t.ry=t.y+r[0]*Z,Z=this.UNITY/(3*g),e.lx=e.x-s[0]*Z,void(e.ly=e.y-r[0]*Z);E=_.right_curl(),g=Math.abs(v.left_tension()),y=Math.abs(_.right_tension()),b[0]=this.mp_curl_ratio(E,y,g),l[0]=-n[1]*b[0],f[0]=0}else _.rtype===this.MP_OPEN&&(b[0]=0,l[0]=0,f[0]=this.FRACTION_ONE);else if(_.ltype===this.MP_END_CYCLE||_.ltype===this.MP_OPEN){if(a=this.UNITY/(3*Math.abs(m.right_tension())-this.UNITY),P=o[p]*(this.FRACTION_THREE-this.UNITY/Math.abs(m.right_tension())),c=this.UNITY/(3*Math.abs(v.left_tension())-this.UNITY),u=o[p-1]*(this.FRACTION_THREE-this.UNITY/Math.abs(v.left_tension())),P*=E=this.FRACTION_ONE-b[p-1]*a,(g=Math.abs(_.left_tension()))<(y=Math.abs(_.right_tension()))?P*=Math.pow(g/y,2):g>y&&(u*=Math.pow(y/g,2)),Z=u/(u+P),b[p]=Z*c,h=-n[p+1]*b[p],m.rtype===this.MP_CURL?(f[p]=0,l[p]=h-n[1]*(this.FRACTION_ONE-Z)):(Z=(this.FRACTION_ONE-Z)/E,h-=n[p]*Z,Z*=a,l[p]=h-l[p-1]*Z,f[p]=-f[p-1]*Z),_.ltype===this.MP_END_CYCLE){for(a=0,c=this.FRACTION_ONE;0===(p-=1)&&(p=i),a=l[p]-a*b[p],c=f[p]-c*b[p],p!==i;);for(a/=this.FRACTION_ONE-c,C[i]=a,l[0]=a,A=1;A<i;A++)l[A]=l[A]+a*f[A];break}}else{if(_.ltype===this.MP_CURL){E=_.left_curl(),g=Math.abs(_.left_tension()),y=Math.abs(m.right_tension()),Z=this.mp_curl_ratio(E,g,y),C[i]=-l[i-1]*Z/(this.FRACTION_ONE-Z*b[i-1]);break}if(_.ltype===this.MP_GIVEN){C[i]=_.left_given()-Math.atan2(r[i-1],s[i-1]),C[i]=this.reduce_angle(C[i]);break}}m=_,_=v,p+=1}for(p=i-1;p>-1;p--)C[p]=l[p]-C[p+1]*b[p];for(_=t,p=0;v=_.next,x=(O=this.mp_n_sin_cos(C[p]))[0],w=O[1],T=(S=this.mp_n_sin_cos(-n[p+1]-C[p+1]))[0],M=S[1],this.mp_set_controls(_,v,s[p],r[p],w,x,M,T),_=v,++p!==i;);},mp_n_sin_cos:function(t){return[Math.cos(t),Math.sin(t)]},mp_set_controls:function(t,e,i,s,r,o,n,a){var h,l,c,d,u;c=Math.abs(e.left_tension()),h=Math.abs(t.right_tension()),u=this.mp_velocity(r,o,n,a,h),l=this.mp_velocity(n,a,r,o,c),(t.right_tension()<0||e.left_tension()<0)&&(r>=0&&n>=0||r<=0&&n<=0)&&(d=Math.abs(r)*a+Math.abs(n)*o)>0&&(d*=1.00024414062,t.right_tension()<0&&this.mp_ab_vs_cd(Math.abs(n),this.FRACTION_ONE,u,d)<0&&(u=Math.abs(n)/d),e.left_tension()<0&&this.mp_ab_vs_cd(Math.abs(r),this.FRACTION_ONE,l,d)<0&&(l=Math.abs(r)/d)),t.rx=t.x+(i*o-s*r)*u,t.ry=t.y+(s*o+i*r)*u,e.lx=e.x-(i*a+s*n)*l,e.ly=e.y-(s*a-i*n)*l,t.rtype=this.MP_EXPLICIT,e.ltype=this.MP_EXPLICIT},mp_pyth_add:function(t,e){return Math.sqrt(t*t+e*e)},mp_curl_ratio:function(t,e,i){var s=1/e,r=1/i;return Math.min(4,((3-s)*s*s*t+r*r*r)/(s*s*s*t+(3-r)*r*r))},mp_ab_vs_cd:function(t,e,i,s){return t*e==i*s?0:t*e>i*s?1:-1},mp_velocity:function(t,e,i,s,r){return Math.min(4,(2+Math.sqrt(2)*(t-i/16)*(i-t/16)*(e-s))/(1.5*r*(2+(Math.sqrt(5)-1)*e+(3-Math.sqrt(5))*s)))},reduce_angle:function(t){return Math.abs(t)>this.ONE_EIGHTY_DEG&&(t>0?t-=this.THREE_SIXTY_DEG:t+=this.THREE_SIXTY_DEG),t},makeknots:function(t,e,i){var s,r,o=[];for(e=e||1,r=t.length,s=0;s<r;s++)o.push({x:t[s][0],y:t[s][1],ltype:this.MP_OPEN,rtype:this.MP_OPEN,ly:e,ry:e,lx:e,rx:e,left_curl:function(){return this.lx||0},right_curl:function(){return this.rx||0},left_tension:function(){return this.ly||(this.ly=1),this.ly},right_tension:function(){return this.ry||(this.ry=1),this.ry},set_right_curl:function(t){this.rx=t||0},set_left_curl:function(t){this.lx=t||0}});for(r=o.length,s=0;s<r;s++)o[s].next=o[s+1]||o[s],o[s].set_right_given=o[s].set_right_curl,o[s].set_left_given=o[s].set_left_curl,o[s].right_given=o[s].right_curl,o[s].left_given=o[s].left_curl;return o[r-1].next=o[0],i||(o[r-1].rtype=this.MP_ENDPOINT,o[r-1].ltype=this.MP_CURL,o[0].rtype=this.MP_CURL),o},curve:function(t,e){var i,r,o,n,a=[],h=[];for(o in e=e||{tension:1,direction:{},curl:{},isClosed:!1},r=(i=this.makeknots(t,s.Z.evaluate(e.tension),e.isClosed)).length,e.direction)e.direction.hasOwnProperty(o)&&(n=s.Z.evaluate(e.direction[o]),s.Z.isArray(n)?(!1!==n[0]&&(i[o].lx=n[0]*Math.PI/180,i[o].ltype=this.MP_GIVEN),!1!==n[1]&&(i[o].rx=n[1]*Math.PI/180,i[o].rtype=this.MP_GIVEN)):(i[o].lx=n*Math.PI/180,i[o].rx=n*Math.PI/180,i[o].ltype=i[o].rtype=this.MP_GIVEN));for(o in e.curl)e.curl.hasOwnProperty(o)&&(n=s.Z.evaluate(e.curl[o]),0===parseInt(o,10)?(i[o].rtype=this.MP_CURL,i[o].set_right_curl(n)):parseInt(o,10)===r-1&&(i[o].ltype=this.MP_CURL,i[o].set_left_curl(n)));for(this.make_choices(i),o=0;o<r-1;o++)a.push(i[o].x),a.push(i[o].rx),a.push(i[o+1].lx),h.push(i[o].y),h.push(i[o].ry),h.push(i[o+1].ly);return a.push(i[r-1].x),h.push(i[r-1].y),e.isClosed&&(a.push(i[r-1].rx),h.push(i[r-1].ry),a.push(i[0].lx),h.push(i[0].ly),a.push(i[0].x),h.push(i[0].y)),[a,h]}};o.Z.Metapost;var _=[0,128,64,192,32,160,96,224,16,144,80,208,48,176,112,240,8,136,72,200,40,168,104,232,24,152,88,216,56,184,120,248,4,132,68,196,36,164,100,228,20,148,84,212,52,180,116,244,12,140,76,204,44,172,108,236,28,156,92,220,60,188,124,252,2,130,66,194,34,162,98,226,18,146,82,210,50,178,114,242,10,138,74,202,42,170,106,234,26,154,90,218,58,186,122,250,6,134,70,198,38,166,102,230,22,150,86,214,54,182,118,246,14,142,78,206,46,174,110,238,30,158,94,222,62,190,126,254,1,129,65,193,33,161,97,225,17,145,81,209,49,177,113,241,9,137,73,201,41,169,105,233,25,153,89,217,57,185,121,249,5,133,69,197,37,165,101,229,21,149,85,213,53,181,117,245,13,141,77,205,45,173,109,237,29,157,93,221,61,189,125,253,3,131,67,195,35,163,99,227,19,147,83,211,51,179,115,243,11,139,75,203,43,171,107,235,27,155,91,219,59,187,123,251,7,135,71,199,39,167,103,231,23,151,87,215,55,183,119,247,15,143,79,207,47,175,111,239,31,159,95,223,63,191,127,255],f=[3,4,5,6,7,8,9,10,11,13,15,17,19,23,27,31,35,43,51,59,67,83,99,115,131,163,195,227,258,0,0],b=[0,0,0,0,0,0,0,0,1,1,1,1,2,2,2,2,3,3,3,3,4,4,4,4,5,5,5,5,0,99,99],g=[1,2,3,4,5,7,9,13,17,25,33,49,65,97,129,193,257,385,513,769,1025,1537,2049,3073,4097,6145,8193,12289,16385,24577],m=[0,0,0,0,1,1,2,2,3,3,4,4,5,5,6,6,7,7,8,8,9,9,10,10,11,11,12,12,13,13],v=[16,17,18,0,8,7,9,6,10,5,11,4,12,3,13,2,14,1,15],Z=256;t.Z.Util=t.Z.Util||{},t.Z.Util.Unzip=function(e){var i,s,r,o,n=[],a=0,h=[],l=new Array(32768),c=0,d=!1,u=e.length,p=0,C=1,y=new Array(288),P=new Array(32),E=0,O=null,x=(new Array(64),new Array(64),0),w=new Array(17),S=[];function T(){return 8,p<u?e[p++]:-1}function M(){C=1}function N(){var t;try{t=1&C,0===(C>>=1)&&(t=1&(C=T()),C=C>>1|128)}catch(t){throw console.log("Probably problems on iOS7 with >>"),t}return t}function A(t){var e=0,i=t;try{for(;i--;)e=e<<1|N();t&&(e=_[e]>>8-t)}catch(t){throw console.log("Probably problems on iOS7 with >>"),t}return e}function k(){c=0}function R(t){l[c++]=t,n.push(String.fromCharCode(t)),32768===c&&(c=0)}function D(){this.b0=0,this.b1=0,this.jump=null,this.jumppos=-1}function L(){for(;;){if(w[x]>=o)return-1;if(r[w[x]]===x)return w[x]++;w[x]++}}function B(){var t,e=O[E];if(17===x)return-1;if(E++,x++,(t=L())>=0)e.b0=t;else if(e.b0=32768,B())return-1;if((t=L())>=0)e.b1=t,e.jump=null;else if(e.b1=32768,e.jump=O[E],e.jumppos=E,B())return-1;return x--,0}function I(t,e,i,s){var n;for(O=t,E=0,r=i,o=e,n=0;n<17;n++)w[n]=0;return x=0,B()?-1:0}function Y(t){for(var e,i,s=0,r=t[s];;)if(N()){if(!(32768&r.b1))return r.b1;for(r=r.jump,e=t.length,i=0;i<e;i++)if(t[i]===r){s=i;break}}else{if(!(32768&r.b0))return r.b0;r=t[++s]}}function j(){var e,i,s,r,o,n,a,h,d,u,p,Z,C,E,O;do{if(e=N(),0===(i=A(2)))for(M(),d=T(),d|=T()<<8,p=T(),65535&(d^~(p|=T()<<8))&&t.Z.debug("BlockLen checksum mismatch\n");d--;)R(T());else if(1===i)for(;;)if((r=_[A(7)]>>1)>23?(r=r<<1|N())>199?r=(r-=128)<<1|N():(r-=48)>143&&(r+=136):r+=256,r<256)R(r);else{if(256===r)break;for(h=A(b[r-=257])+f[r],r=_[A(5)]>>3,m[r]>8?(u=A(8),u|=A(m[r]-8)<<8):u=A(m[r]),u+=g[r],r=0;r<h;r++)R(l[c-u&32767])}else if(2===i){for(n=new Array(320),C=257+A(5),E=1+A(5),O=4+A(4),r=0;r<19;r++)n[r]=0;for(r=0;r<O;r++)n[v[r]]=A(3);for(h=P.length,s=0;s<h;s++)P[s]=new D;if(I(P,19,n))return k(),1;for(Z=C+E,s=0,-1;s<Z;)if((r=Y(P))<16)n[s++]=r;else if(16===r){if(s+(r=3+A(2))>Z)return k(),1;for(o=s?n[s-1]:0;r--;)n[s++]=o}else{if(s+(r=17===r?3+A(3):11+A(7))>Z)return k(),1;for(;r--;)n[s++]=0}for(h=y.length,s=0;s<h;s++)y[s]=new D;if(I(y,C,n))return k(),1;for(h=y.length,s=0;s<h;s++)P[s]=new D;for(a=[],s=C;s<n.length;s++)a[s-C]=n[s];if(I(P,E,a))return k(),1;for(;;)if((r=Y(y))>=256){if(0===(r-=256))break;for(h=A(b[r-=1])+f[r],r=Y(P),m[r]>8?(u=A(8),u|=A(m[r]-8)<<8):u=A(m[r]),u+=g[r];h--;)R(l[c-u&32767])}else R(r)}}while(!e);return k(),M(),0}function X(){var t,e,r,o,l,c=[];try{if(n=[],d=!1,c[0]=T(),c[1]=T(),120===c[0]&&218===c[1]&&(j(),h[a]=[n.join(""),"geonext.gxt"],a++),31===c[0]&&139===c[1]&&(U(),h[a]=[n.join(""),"file"],a++),80===c[0]&&75===c[1]){if(d=!0,c[2]=T(),c[3]=T(),3===c[2]&&4===c[3]){for(c[0]=T(),c[1]=T(),i=T(),i|=T()<<8,l=T(),l|=T()<<8,T(),T(),T(),T(),T(),T()<<8,T()<<16,T()<<24,T(),T()<<8,T()<<16,T()<<24,T(),T()<<8,T()<<16,T()<<24,o=T(),o|=T()<<8,r=T(),r|=T()<<8,t=0,S=[];o--;)"/"===(e=T())|":"===e?t=0:t<Z-1&&(S[t++]=String.fromCharCode(e));for(s||(s=S),t=0;t<r;)e=T(),t++;if(0,8===l&&(j(),h[a]=new Array(2),h[a][0]=n.join(""),h[a][1]=S.join(""),a++),U())return!1}return!0}}catch(t){throw console.log("Probably problems on iOS7 with >>"),t}return!1}function U(){var t,e,s=[];if(8&i&&(s[0]=T(),s[1]=T(),s[2]=T(),s[3]=T(),80===s[0]&&75===s[1]&&7===s[2]&&8===s[3]?(T(),T()<<8,T()<<16,T()<<24):s[0]|s[1]<<8|s[2]<<16|s[3]<<24,T(),T()<<8,T()<<16,T()<<24,T(),T()<<8,T()<<16,T()<<24),d&&X())return!1;if(s[0]=T(),8!==s[0])return!0;if(i=T(),T(),T(),T(),T(),T(),T(),4&i)for(s[0]=T(),s[2]=T(),x=s[0]+256*s[1],t=0;t<x;t++)T();if(8&i)for(t=0,S=[],e=T();e;)"7"!==e&&":"!==e||(t=0),t<Z-1&&(S[t++]=e),e=T();if(16&i)for(e=T();e;)e=T();return 2&i&&(T(),T()),j(),T(),T()<<8,T()<<16,T()<<24,T(),T()<<8,T()<<16,T()<<24,d&&X(),!1}w[0]=0,t.Z.Util.Unzip.prototype.unzipFile=function(t){var e;for(this.unzip(),e=0;e<h.length;e++)if(h[e][1]===t)return h[e][0];return""},t.Z.Util.Unzip.prototype.unzip=function(){return X(),h}};const C=t.Z.Util;var y=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,8,8,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,10,3,3,3,3,3,3,3,3,3,3,3,3,4,3,3,11,6,6,6,5,8,8,8,8,8,8,8,8,8,8,8,0,12,24,36,60,96,84,12,12,12,48,72,12,12,12,12,12,12,12,12,12,12,12,12,12,0,12,12,12,12,12,0,12,0,12,12,12,24,12,12,12,12,12,24,12,24,12,12,12,12,12,12,12,12,12,24,12,12,12,12,12,24,12,12,12,12,12,12,12,24,12,12,12,12,12,12,12,12,12,36,12,36,12,12,12,36,12,12,12,12,12,36,12,36,12,12,12,36,12,12,12,12,12,12,12,12,12,12];t.Z.Util=t.Z.Util||{},t.Z.Util.UTF8={encode:function(t){var e,i,s="",r=t.length;if(t=t.replace(/\r\n/g,"\n"),"function"==typeof unescape&&"function"==typeof encodeURIComponent)return unescape(encodeURIComponent(t));for(e=0;e<r;e++)(i=t.charCodeAt(e))<128?s+=String.fromCharCode(i):i>127&&i<2048?(s+=String.fromCharCode(i>>6|192),s+=String.fromCharCode(63&i|128)):(s+=String.fromCharCode(i>>12|224),s+=String.fromCharCode(i>>6&63|128),s+=String.fromCharCode(63&i|128));return s},decode:function(t){var e,i,s,r=0,o=0,n=0,a=[],h=t.length,l=[];for(e=0;e<h;e++)i=t.charCodeAt(e),s=y[i],o=0!==n?63&i|o<<6:255>>s&i,0===(n=y[256+n+s])&&(o>65535?a.push(55232+(o>>10),56320+(1023&o)):a.push(o),++r%1e4==0&&(l.push(String.fromCharCode.apply(null,a)),a=[]));return l.push(String.fromCharCode.apply(null,a)),l.join("")},asciiCharCodeAt:function(t,e){var i=t.charCodeAt(e);if(i>255)switch(i){case 8364:i=128;break;case 8218:i=130;break;case 402:i=131;break;case 8222:i=132;break;case 8230:i=133;break;case 8224:i=134;break;case 8225:i=135;break;case 710:i=136;break;case 8240:i=137;break;case 352:i=138;break;case 8249:i=139;break;case 338:i=140;break;case 381:i=142;break;case 8216:i=145;break;case 8217:i=146;break;case 8220:i=147;break;case 8221:i=148;break;case 8226:i=149;break;case 8211:i=150;break;case 8212:i=151;break;case 732:i=152;break;case 8482:i=153;break;case 353:i=154;break;case 8250:i=155;break;case 339:i=156;break;case 382:i=158;break;case 376:i=159}return i}};const P=t.Z.Util.UTF8;var E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",O="=";t.Z.Util=t.Z.Util||{},t.Z.Util.Base64={_getByte:function(t,e){return 255&t.charCodeAt(e)},_getIndex:function(t,e){return E.indexOf(t.charAt(e))},encode:function(t){var e,i,s,r,o,n=[];for(r=(s=(o=P.encode(t)).length)%3,e=0;e<s-r;e+=3)i=this._getByte(o,e)<<16|this._getByte(o,e+1)<<8|this._getByte(o,e+2),n.push(E.charAt(i>>18),E.charAt(i>>12&63),E.charAt(i>>6&63),E.charAt(63&i));switch(r){case 1:i=this._getByte(o,s-1),n.push(E.charAt(i>>2),E.charAt(i<<4&63),O,O);break;case 2:i=this._getByte(o,s-2)<<8|this._getByte(o,s-1),n.push(E.charAt(i>>10),E.charAt(i>>4&63),E.charAt(i<<2&63),O)}return n.join("")},decode:function(t,e){var i,s,r,o,n,a,h=[],l=[];if((r=(i=t.replace(/[^A-Za-z0-9+/=]/g,"")).length)%4!=0)throw new Error("JSXGraph/utils/base64: Can't decode string (invalid input length).");for(i.charAt(r-1)===O&&(o=1,i.charAt(r-2)===O&&(o=2),r-=4),s=0;s<r;s+=4)n=this._getIndex(i,s)<<18|this._getIndex(i,s+1)<<12|this._getIndex(i,s+2)<<6|this._getIndex(i,s+3),l.push(n>>16,n>>8&255,255&n),s%1e4==0&&(h.push(String.fromCharCode.apply(null,l)),l=[]);switch(o){case 1:n=this._getIndex(i,r)<<12|this._getIndex(i,r+1)<<6|this._getIndex(i,r+2),l.push(n>>10,n>>2&255);break;case 2:n=this._getIndex(i,s)<<6|this._getIndex(i,s+1),l.push(n>>4)}return h.push(String.fromCharCode.apply(null,l)),a=h.join(""),e&&(a=P.decode(a)),a},decodeAsArray:function(t){var e,i=this.decode(t),s=[],r=i.length;for(e=0;e<r;e++)s[e]=i.charCodeAt(e);return s}};const x=t.Z.Util.Base64;t.Z.Server={modules:{},runningCalls:{},handleError:function(e){t.Z.debug("error occured, server says: "+e.message)},callServer:function(e,i,r,o){var n,a,h,l,c,d,u;for(d in o=o||!1,"",r)r.hasOwnProperty(d)&&"&"+escape(d)+"="+escape(r[d]);c=s.Z.toJSON(r);do{l=e+Math.floor(4096*Math.random())}while(s.Z.exists(this.runningCalls[l]));return this.runningCalls[l]={action:e},s.Z.exists(r.module)&&(this.runningCalls[l].module=r.module),n=t.Z.serverBase+"JXGServer.py",a="action="+escape(e)+"&id="+l+"&dataJSON="+escape(x.encode(c)),this.cbp=function(t){var e,r,o,n,a,h,l,c;if(e=new C.Unzip(x.decodeAsArray(t)).unzip(),s.Z.isArray(e)&&e.length>0&&(e=e[0][0]),s.Z.exists(e))if("error"===(r=window.JSON&&window.JSON.parse?window.JSON.parse(e):new Function("return "+e)()).type)this.handleError(r);else if("response"===r.type){for(h=r.id,l=0;l<r.fields.length;l++)n=(o=r.fields[l]).namespace+("object"==typeof new Function("return "+o.namespace)()?".":".prototype.")+o.name+" = "+o.value,new Function(n)();for(l=0;l<r.handler.length;l++){for(o=r.handler[l],a=[],c=0;c<o.parameters.length;c++)a[c]='"'+o.parameters[c]+'": '+o.parameters[c];n="if(typeof JXG.Server.modules."+this.runningCalls[h].module+' == "undefined")JXG.Server.modules.'+this.runningCalls[h].module+" = {};",n+="JXG.Server.modules."+this.runningCalls[h].module+"."+o.name+"_cb = "+o.callback+";",n+="JXG.Server.modules."+this.runningCalls[h].module+"."+o.name+" = function ("+o.parameters.join(",")+', __JXGSERVER_CB__, __JXGSERVER_SYNC) {if(typeof __JXGSERVER_CB__ == "undefined") __JXGSERVER_CB__ = JXG.Server.modules.'+this.runningCalls[h].module+"."+o.name+"_cb;var __JXGSERVER_PAR__ = {"+a.join(",")+', "module": "'+this.runningCalls[h].module+'", "handler": "'+o.name+'" };JXG.Server.callServer("exec", __JXGSERVER_CB__, __JXGSERVER_PAR__, __JXGSERVER_SYNC);};',new Function(n)()}delete this.runningCalls[h],i(r.data)}},this.cb=t.Z.bind(this.cbp,this),window.XMLHttpRequest?(h=new XMLHttpRequest).overrideMimeType("text/plain; charset=iso-8859-1"):h=new ActiveXObject("Microsoft.XMLHTTP"),!(!h||(h.open("POST",n,!o),h.setRequestHeader("Content-type","application/x-www-form-urlencoded"),o||(h.onreadystatechange=(u=this.cb,function(){return 4===h.readyState&&200===h.status&&(u(h.responseText),!0)})),h.send(a),!o))&&(this.cb(h.responseText),!0)},loadModule_cb:function(e){var i;for(i=0;i<e.length;i++)t.Z.debug(e[i].name+": "+e[i].value)},loadModule:function(e){return t.Z.Server.callServer("load",t.Z.Server.loadModule_cb,{module:e},!0)}},t.Z.Server.load=t.Z.Server.loadModule;const w=t.Z.Server;var S;o.Z.Symbolic={generateSymbolicCoordinatesPartial:function(t,e,i,r){var o,n,a,h=e.ancestors,l=0,c=function(t){return"underscore"===r?i+"_{"+t+"}":"brace"===r?i+"["+t+"]":i+t};for(n in t.listOfFreePoints=[],t.listOfDependantPoints=[],h)if(h.hasOwnProperty(n)&&(o=0,s.Z.isPoint(h[n]))){for(a in h[n].ancestors)h[n].ancestors.hasOwnProperty(a)&&o++;0===o?(h[n].symbolic.x=h[n].coords.usrCoords[1],h[n].symbolic.y=h[n].coords.usrCoords[2],t.listOfFreePoints.push(h[n])):(l+=1,h[n].symbolic.x=c(l),l+=1,h[n].symbolic.y=c(l),t.listOfDependantPoints.push(h[n]))}return s.Z.isPoint(e)&&(e.symbolic.x="x",e.symbolic.y="y"),l},clearSymbolicCoordinates:function(t){var e=function(t){var e,i=t&&t.length||0;for(e=0;e<i;e++)s.Z.isPoint(t[e])&&(t[e].symbolic.x="",t[e].symbolic.y="")};e(t.listOfFreePoints),e(t.listOfDependantPoints),delete t.listOfFreePoints,delete t.listOfDependantPoints},generatePolynomials:function(t,e,i){var r,o,n,a,h=e.ancestors,l=[],c=[];for(r in i&&this.generateSymbolicCoordinatesPartial(t,e,"u","brace"),h[e.id]=e,h)if(h.hasOwnProperty(r)&&(a=0,l=[],s.Z.isPoint(h[r]))){for(o in h[r].ancestors)h[r].ancestors.hasOwnProperty(o)&&a++;if(a>0)for(l=h[r].generatePolynomial(),n=0;n<l.length;n++)c.push(l[n])}return i&&this.clearSymbolicCoordinates(t),c},geometricLocusByGroebnerBase:function(t,e){var r,n,a,h,l,d,p,_,f,b,g,m,v=t.options.locus,Z={},C=this.generateSymbolicCoordinatesPartial(t,e,"u","brace"),y=new c.Z(i.Z.COORDS_BY_USR,[0,0],t),P=new c.Z(i.Z.COORDS_BY_USR,[t.canvasWidth,t.canvasHeight],t),E=1,O=0,x=0,T=0;if(w.modules.geoloci===S&&w.loadModule("geoloci"),w.modules.geoloci===S)throw new Error("JSXGraph: Unable to load JXG.Server module 'geoloci.py'.");if(d=y.usrCoords[1],p=P.usrCoords[1],_=P.usrCoords[2],f=y.usrCoords[2],v.translateToOrigin&&t.listOfFreePoints.length>0){for(O=(a=v.toOrigin!==S&&null!==v.toOrigin&&s.Z.isInArray(t.listOfFreePoints,v.toOrigin.id)?v.toOrigin:t.listOfFreePoints[0]).symbolic.x,x=a.symbolic.y,l=0;l<t.listOfFreePoints.length;l++)t.listOfFreePoints[l].symbolic.x-=O,t.listOfFreePoints[l].symbolic.y-=x;if(d-=O,p-=O,_-=x,f-=x,v.translateTo10&&t.listOfFreePoints.length>1){for(h=v.to10!==S&&null!==v.to10&&v.to10.id!==v.toOrigin.id&&s.Z.isInArray(t.listOfFreePoints,v.to10.id)?v.to10:t.listOfFreePoints[0].id===a.id?t.listOfFreePoints[1]:t.listOfFreePoints[0],T=u.Z.rad([1,0],[0,0],[h.symbolic.x,h.symbolic.y]),b=Math.cos(-T),g=Math.sin(-T),l=0;l<t.listOfFreePoints.length;l++)m=t.listOfFreePoints[l].symbolic.x,t.listOfFreePoints[l].symbolic.x=b*t.listOfFreePoints[l].symbolic.x-g*t.listOfFreePoints[l].symbolic.y,t.listOfFreePoints[l].symbolic.y=g*m+b*t.listOfFreePoints[l].symbolic.y;if(h.symbolic.y=0,m=d,d=b*d-g*_,_=g*m+b*_,m=p,p=b*p-g*f,f=g*m+b*f,v.stretch&&Math.abs(h.symbolic.x)>o.Z.eps){for(E=h.symbolic.x,l=0;l<t.listOfFreePoints.length;l++)t.listOfFreePoints[l].symbolic.x/=E,t.listOfFreePoints[l].symbolic.y/=E;for(l=0;l<t.objectsList.length;l++)t.objectsList[l].elementClass===i.Z.OBJECT_CLASS_CIRCLE&&"pointRadius"===t.objectsList[l].method&&(Z[l]=t.objectsList[l].radius,t.objectsList[l].radius/=E);d/=E,p/=E,_/=E,f/=E,h.symbolic.x=1}}for(l=0;l<t.listOfFreePoints.length;l++)m=t.listOfFreePoints[l].symbolic.x,Math.abs(m)<o.Z.eps&&(t.listOfFreePoints[l].symbolic.x=0),Math.abs(m-Math.round(m))<o.Z.eps&&(t.listOfFreePoints[l].symbolic.x=Math.round(m)),m=t.listOfFreePoints[l].symbolic.y,Math.abs(m)<o.Z.eps&&(t.listOfFreePoints[l].symbolic.y=0),Math.abs(m-Math.round(m))<o.Z.eps&&(t.listOfFreePoints[l].symbolic.y=Math.round(m))}for(l in r=this.generatePolynomials(t,e).join(","),this.cbp=function(t){n=t},this.cb=s.Z.bind(this.cbp,this),w.modules.geoloci.lociCoCoA(d,p,_,f,C,r,E,T,O,x,this.cb,!0),this.clearSymbolicCoordinates(t),Z)Z.hasOwnProperty(l)&&(t.objects[l].radius=Z[l]);return n}};const T=o.Z.Symbolic;o.Z.Clip={_isSeparator:function(t){return isNaN(t.coords.usrCoords[1])&&isNaN(t.coords.usrCoords[2])},makeDoublyLinkedList:function(t){var e,i=null,s=[],r=t.length;if(r>0)for(e=0;e<r;e++)this._isSeparator(t[e])?(t[e]._next=t[(e+1)%r],t[e]._prev=t[(r+e-1)%r]):(null===i&&(i=e,s.push(i)),this._isSeparator(t[(e+1)%r])||e===r-1?(t[e]._next=t[i],t[i]._prev=t[e],t[e]._end=!0,i=null):(t[e]._next=t[(e+1)%r],t[i]._prev=t[e]),this._isSeparator(t[(r+e-1)%r])||(t[e]._prev=t[(r+e-1)%r]));return s},Vertex:function(t,e,s,r,o,n){this.pos=e,this.intersection=!0,this.coords=t,this.elementClass=i.Z.OBJECT_CLASS_POINT,this.data={alpha:s,path:r,pathname:o,done:!1,type:n,idx:0},this.neighbour=null,this.entry_exit=!1},_addToList:function(t,e,s){var r=t.length,n=o.Z.eps*o.Z.eps;r>0&&Math.abs(t[r-1].coords.usrCoords[0]-e.usrCoords[0])<n&&Math.abs(t[r-1].coords.usrCoords[1]-e.usrCoords[1])<n&&Math.abs(t[r-1].coords.usrCoords[2]-e.usrCoords[2])<n||t.push({pos:s,intersection:!1,coords:e,elementClass:i.Z.OBJECT_CLASS_POINT})},sortIntersections:function(t){var e,i,s,r,o,n,a=[],h=t.length;for(e=0;e<h;e++)if(t[e].sort((function(t,e){return t.data.alpha>e.data.alpha?1:-1})),t[e].length>0){for(o=t[e].length-1,n=(r=(s=t[e][0]).data.path[s.pos])._next,e===h-1&&(r._end=!1),0===s.data.alpha&&"T"===s.data.type?(r.intersection=!0,r.data=s.data,r.neighbour=s.neighbour,r.neighbour.neighbour=r,r.entry_exit=!1,t[e][0]=r):(s._prev=r,s._prev._next=s),i=1;i<=o;i++)(s=t[e][i])._prev=t[e][i-1],s._prev._next=s;(s=t[e][o])._next=n,s._next._prev=s,e===h-1&&(s._end=!0),a=a.concat(t[e])}return a},_inbetween:function(t,e,i){var s,r=o.Z.eps*o.Z.eps,n=i[1]-e[1],a=i[2]-e[2],h=t[1]-e[1],l=t[2]-e[2];return 0===n&&0===a&&0===h&&0===l||(s=Math.abs(h)<r&&Math.abs(n)<r?l/a:h/n,Math.abs(s)<r&&(s=0),s)},_print_array:function(t){var e,i;for(e=0;e<t.length;e++)try{i="",t[e]._end&&(i=" end"),console.log(e,t[e].coords.usrCoords,t[e].data.type,"\t","prev",t[e]._prev.coords.usrCoords,"next",t[e]._next.coords.usrCoords+i)}catch(i){console.log(e,t[e].coords.usrCoords)}},_print_list:function(t){for(var e,i=0;i<100&&(e=t.data?t.data.alpha:"-",console.log("\t",t.coords.usrCoords,"\n\t\tis:",t.intersection,"end:",t._end,e,"\n\t\t-:",t._prev.coords.usrCoords,"\n\t\t+:",t._next.coords.usrCoords,"\n\t\tn:",t.intersection?t.neighbour.coords.usrCoords:"-"),!t._end);)t=t._next,i++},_noOverlap:function(t,e,i,s){var r,n,a,h,l,c=Math.sqrt(o.Z.eps),d=!1;for(r=0;r<3;r++)if(n=Math.min(t[r],e[r]),a=Math.max(t[r],e[r]),h=Math.min(i[r],s[r]),l=Math.max(i[r],s[r]),a<h-c||n>l+c){d=!0;break}return d},findIntersections:function(t,e,s){var r,n,a,h,l,d,p,_,f,b,g,m,v,Z=[],C=o.Z.eps,y=t.length,P=e.length,E=[],O=[],x=[],w=!1,S=!1,T=!1;for(n=0;n<P;n++)x.push([]);for(r=0;r<y;r++)if(O.push([]),this._isSeparator(t[r])||this._isSeparator(t[(r+1)%y]))w=!0;else{if(w&&r===y-1)break;for(h=t[r].coords.usrCoords,l=t[(r+1)%y].coords.usrCoords,n=0;n<P;n++)if(this._isSeparator(e[n])||this._isSeparator(e[(n+1)%P]))S=!0;else{if(S&&n===P-1)break;if(d=e[n].coords.usrCoords,p=e[(n+1)%P].coords.usrCoords,!this._noOverlap(h,l,d,p)&&(Z=u.Z.meetSegmentSegment(h,l,d,p),_=u.Z.distance(h,l,3),f=u.Z.distance(d,p,3),Z[1]*_>-C&&Z[1]<1-C/_&&Z[2]*f>-C&&Z[2]<1-C/f||Z[1]===1/0&&Z[2]===1/0&&o.Z.norm(Z[0],3)<C)){if(a=new c.Z(i.Z.COORDS_BY_USER,Z[0],s),g="X",Math.abs(Z[1])*_<C||Math.abs(Z[2])*f<C)g="T",Math.abs(Z[1])*_<C&&(Z[1]=0),Math.abs(Z[2])*f<C&&(Z[2]=0),a=0===Z[1]?new c.Z(i.Z.COORDS_BY_USER,h,s):new c.Z(i.Z.COORDS_BY_USER,d,s);else if(Z[1]===1/0&&Z[2]===1/0&&o.Z.norm(Z[0],3)<C){(b=this._inbetween(h,d,p))>=0&&b<1&&(g="T",a=new c.Z(i.Z.COORDS_BY_USER,h,s),Z[1]=0,Z[2]=b,m=new this.Vertex(a,r,Z[1],t,"S",g),v=new this.Vertex(a,n,Z[2],e,"C",g),m.neighbour=v,v.neighbour=m,O[r].push(m),x[n].push(v)),b=this._inbetween(d,h,l),u.Z.distance(h,d,3)>C&&b>=0&&b<1&&(g="T",a=new c.Z(i.Z.COORDS_BY_USER,d,s),Z[1]=b,Z[2]=0,m=new this.Vertex(a,r,Z[1],t,"S",g),v=new this.Vertex(a,n,Z[2],e,"C",g),m.neighbour=v,v.neighbour=m,O[r].push(m),x[n].push(v));continue}T,m=new this.Vertex(a,r,Z[1],t,"S",g),v=new this.Vertex(a,n,Z[2],e,"C",g),m.neighbour=v,v.neighbour=m,O[r].push(m),x[n].push(v)}}}for(E=this.sortIntersections(O),r=0;r<E.length;r++)E[r].data.idx=r,E[r].neighbour.data.idx=r;return[E,this.sortIntersections(x)]},_getPosition:function(t,e,i,s){var r=u.Z.det3p(t,e,i),o=u.Z.det3p(t,i,s);return u.Z.det3p(e,i,s)>=0?r>=0&&o>=0?"left":"right":r>=0||o>=0?"left":"right"},_classifyDegenerateIntersections:function(t){var e,i,r,n,a,h,l,c,d,p,_,f,b,g,m=!1;for(m,d=u.Z.det3p,l=0,t._tours=0;;){if(t.intersection&&"T"===t.data.type&&(e=t._next.coords.usrCoords,i=t._prev.coords.usrCoords,u.Z.distance(t.coords.usrCoords,e,3)<o.Z.eps&&(e=t._next._next.coords.usrCoords),u.Z.distance(t.coords.usrCoords,i,3)<o.Z.eps&&(i=t._prev._prev.coords.usrCoords),n=(a=t.neighbour)._prev.coords.usrCoords,r=a._next.coords.usrCoords,u.Z.distance(a.coords.usrCoords,r,3)<o.Z.eps&&(r=a._next._next.coords.usrCoords),u.Z.distance(a.coords.usrCoords,n,3)<o.Z.eps&&(n=a._prev._prev.coords.usrCoords),_=d(t.coords.usrCoords,i,n),f=d(t.coords.usrCoords,e,r),b=d(t.coords.usrCoords,i,r),g=d(t.coords.usrCoords,e,n),0===_&&0===f&&0===b&&0===g&&(t.coords.usrCoords[1]*=1+Math.random()*o.Z.eps,t.coords.usrCoords[2]*=1+Math.random()*o.Z.eps,a.coords.usrCoords[1]=t.coords.usrCoords[1],a.coords.usrCoords[2]=t.coords.usrCoords[2],_=d(t.coords.usrCoords,i,n),f=d(t.coords.usrCoords,e,r),b=d(t.coords.usrCoords,i,r),g=d(t.coords.usrCoords,e,n)),p=!1,0===_?u.Z.affineRatio(t.coords.usrCoords,i,n)<0&&(p=!0):0===f?u.Z.affineRatio(t.coords.usrCoords,e,r)<0&&(p=!0):0===b?u.Z.affineRatio(t.coords.usrCoords,i,r)>0&&(p=!0):0===g&&u.Z.affineRatio(t.coords.usrCoords,e,n)>0&&(p=!0),p&&(c=n,n=r,r=c,c=_,_=b,b=c,c=f,f=g,g=c),s.Z.exists(t.delayedStatus)||(t.delayedStatus=[]),0===_&&0===f?t.delayedStatus=["on","on"]:0===_?(h=this._getPosition(e,n,a.coords.usrCoords,r),t.delayedStatus=["on",h]):0===f?(h=this._getPosition(i,n,a.coords.usrCoords,r),t.delayedStatus=[h,"on"]):0===t.delayedStatus.length&&(this._getPosition(i,n,a.coords.usrCoords,r)!==this._getPosition(e,n,a.coords.usrCoords,r)?t.data.type="X":t.data.type="B")),s.Z.exists(t._tours)&&t._tours++,t._tours>3||t._end||l>1e3){l>1e3&&console.log("Clipping: _classifyDegenerateIntersections exit"),s.Z.exists(t._tours)&&delete t._tours;break}t.intersection&&l++,t=t._next}},_handleIntersectionChains:function(t){var e,i=0,s="Null",r=!1,o=!1,n=!1;for(n;!0===t.intersection&&("T"===t.data.type&&("on"!==t.delayedStatus[0]&&"on"===t.delayedStatus[1]?(r=!0,e=t,s=t.delayedStatus[0]):r&&"on"===t.delayedStatus[0]&&"on"===t.delayedStatus[1]?t.data.type="B":r&&"on"===t.delayedStatus[0]&&"on"!==t.delayedStatus[1]&&(r=!1,s===t.delayedStatus[1]?(e.data.type="DB",t.data.type="DB"):(e.data.type="DX",t.data.type="DX"))),i++),t._end&&(o=!0),!o||r;){if(i>1e3){console.log("Warning: _handleIntersectionChains: intersection chain reached maximum numbers of iterations");break}t=t._next}},_handleFullyDegenerateCase:function(t,e,s){var r,n,a,h,l,d,p,_,f,b,g,m,v,Z,C=[t,e];for(a=0;a<2;a++){for(b=(r=C[a]).length,_=0,Z=!0;_<b;_++)if(!r[_].intersection){Z=!1;break}if(Z)for(g=(n=C[(a+1)%2]).length,_=0;_<b;_++){for(l=r[_].coords.usrCoords,d=r[_]._next.coords.usrCoords,h=[.5*(l[0]+d[0]),.5*(l[1]+d[1]),.5*(l[2]+d[2])],f=0,m=!1;f<g;f++)if(Math.abs(u.Z.det3p(n[f].coords.usrCoords,n[(f+1)%g].coords.usrCoords,h))<o.Z.eps){m=!0;break}if(!m){p={pos:_,intersection:!1,coords:new c.Z(i.Z.COORDS_BY_USER,h,s),elementClass:i.Z.OBJECT_CLASS_POINT},v=r[_]._next,r[_]._next=p,p._prev=r[_],p._next=v,v._prev=p,r[_]._end&&(r[_]._end=!1,p._end=!0);break}}}},_getStatus:function(t,e){for(;t.intersection&&!t._end;)t=t._next;return[t,0===u.Z.windingNumber(t.coords.usrCoords,e)?"entry":"exit"]},markEntryExit:function(t,e,i){var r,o,n,a,h,l,c,d=null,u=0;for(l=i.length,h=0;h<l;h++)for(c=i[h],this._classifyDegenerateIntersections(t[c]),this._handleIntersectionChains(t[c]),o=(a=this._getStatus(t[c],e))[0],r=a[1],o._starter=!0,n=0,d=null,u=0;!0===o.intersection&&("X"===o.data.type&&1===u&&(d.entry_exit=r,"exit"===r&&(d.data.type="X"),u=2),"X"!==o.data.type&&"DB"!==o.data.type||(o.entry_exit=r,r="entry"===r?"exit":"entry"),"DX"===o.data.type&&(0===u?(d=o,u=1):1===u?(o.entry_exit=r,d.entry_exit=r,"exit"===r?d.data.type="X":o.data.type="X",r="entry"===r?"exit":"entry",d=null,u=0):2===u&&(o.entry_exit=r,o.data.type="X",r="entry"===r?"exit":"entry",d=null,u=0))),o=o._next,!(s.Z.exists(o._starter)||n>1e4);)n++},_stayOnPath:function(t,e){var i=!0;return t.intersection&&"B"!==t.data.type&&(i=e===t.entry_exit),i},_addVertex:function(t,e,i){return isNaN(e.coords.usrCoords[1])||isNaN(e.coords.usrCoords[2])||t.push(e),e.intersection&&e.data.done?(i&&console.log("Add last intersection point",e.coords.usrCoords,"on",e.data.pathname,e.entry_exit,e.data.type),!0):(e.intersection&&(e.data.done=!0,i&&console.log("Add intersection point",e.coords.usrCoords,"on",e.data.pathname,e.entry_exit,e.data.type)),!1)},tracing:function(t,e,i){var s,r,o,n,a=0,h=1e4,l=0,c=[],d=!1,u=!1;for(u;l<e.length&&a<h;)if((r=e[l]).data.done||"X"!==r.data.type)l++;else{u,c.length>0&&c.push([NaN,NaN]),o=r.data.idx,s=t,d=this._addVertex(c,r,u),n=r.entry_exit;do{if(d)break;if("intersection"===i&&"entry"===r.entry_exit||"union"===i&&"exit"===r.entry_exit||"difference"===i&&s===t==("exit"===r.entry_exit)){u;do{if(r=r._next,d=this._addVertex(c,r,u))break}while(this._stayOnPath(r,n));a++}else{u;do{if(r=r._prev,d=this._addVertex(c,r,u))break}while(this._stayOnPath(r,n));a++}if(d)break;if(!r.neighbour)return console.log("Tracing: emergency break - no neighbour!!!!!!!!!!!!!!!!!",a),[[0],[0]];if((r=r.neighbour).data.done)break;r.data.done=!0,n=r.entry_exit,s=r.data.path}while(r.data.idx!==o&&a<h);a>=h&&console.log("Tracing: stopping an infinite loop!",a),l++}return this._getCoordsArrays(c,!1)},isEmptyCase:function(t,e,i){return"intersection"===i&&(0===t.length||0===e.length)||("union"===i&&0===t.length&&0===e.length||"difference"===i&&0===t.length)},_getCoordsArrays:function(t,e){var i,s=[],r=[],o=t.length;for(i=0;i<o;i++)t[i].coords?(s.push(t[i].coords.usrCoords[1]),r.push(t[i].coords.usrCoords[2])):(s.push(t[i][0]),r.push(t[i][1]));return e&&o>0&&(t[0].coords?(s.push(t[0].coords.usrCoords[1]),r.push(t[0].coords.usrCoords[2])):(s.push(t[0][0]),r.push(t[0][1]))),[s,r]},handleEmptyIntersection:function(t,e,i){var s,r,o=!1,n=[];if(0===t.length)return n="union"===i?e:[],this._getCoordsArrays(n,!0);if(0===e.length)return n="intersection"===i?[]:t,this._getCoordsArrays(n,!0);if(t.length>0)for(s=t[0];s.intersection&&!(s=s._next)._end;);if(e.length>0)for(r=e[0];r.intersection&&!(r=r._next)._end;);return 0===u.Z.windingNumber(s.coords.usrCoords,e)?0!==u.Z.windingNumber(r.coords.usrCoords,t)?("union"===i?(n=n.concat(t)).push(t[0]):"difference"===i&&((n=n.concat(t)).push(t[0]),u.Z.signedPolygon(t)*u.Z.signedPolygon(e)>0&&n.reverse(),n.push([NaN,NaN])),"difference"!==i&&"intersection"!==i||((n=n.concat(e)).push(e[0]),o=!1)):"difference"===i?(n=n.concat(t),o=!0):"union"===i&&((n=n.concat(t)).push(t[0]),n.push([NaN,NaN]),(n=n.concat(e)).push(e[0])):"intersection"===i?(n=n.concat(t),o=!0):"union"===i&&(n=n.concat(e)).push(e[0]),this._getCoordsArrays(n,o)},_countCrossingIntersections:function(t){var e,i=t.length,s=0;for(e=0;e<i;e++)"X"===t[e].data.type&&s++;return s},_getPath:function(t,e){var r,o,n,a,h,l,d,p=[];if(t.elementClass!==i.Z.OBJECT_CLASS_CURVE||t.type!==i.Z.OBJECT_TYPE_ARC&&t.type!==i.Z.OBJECT_TYPE_SECTOR){if(t.elementClass===i.Z.OBJECT_CLASS_CURVE&&s.Z.exists(t.points))for(o=t.numberPoints,r=0;r<o;r++)this._addToList(p,t.points[r],r);else if(t.type===i.Z.OBJECT_TYPE_POLYGON)for(r=0;r<t.vertices.length;r++)this._addToList(p,t.vertices[r].coords,r);else if(t.elementClass===i.Z.OBJECT_CLASS_CIRCLE)for(d=359,n=t.Radius(),a=2*Math.PI/d,r=0;r<=d;r++)this._addToList(p,new c.Z(i.Z.COORDS_BY_USER,[t.center.coords.usrCoords[0],t.center.coords.usrCoords[1]+Math.cos(r*a)*n,t.center.coords.usrCoords[2]+Math.sin(r*a)*n],e),r);else if(s.Z.isArray(t))for(o=t.length,r=0;r<o;r++)s.Z.exists(t[r].coords)?this._addToList(p,t[r].coords,r):s.Z.isArray(t[r])?this._addToList(p,new c.Z(i.Z.COORDS_BY_USER,t[r],e),r):s.Z.exists(t[r].usrCoords)&&this._addToList(p,t[r],r)}else{for(h=u.Z.rad(t.radiuspoint,t.center,t.anglepoint),d=Math.floor(180*h/Math.PI),n=t.Radius(),a=h/d,l=Math.atan2(t.radiuspoint.coords.usrCoords[2]-t.center.coords.usrCoords[2],t.radiuspoint.coords.usrCoords[1]-t.center.coords.usrCoords[1]),t.type===i.Z.OBJECT_TYPE_SECTOR&&this._addToList(p,t.center.coords,0),r=0;r<=d;r++)this._addToList(p,new c.Z(i.Z.COORDS_BY_USER,[t.center.coords.usrCoords[0],t.center.coords.usrCoords[1]+Math.cos(r*a+l)*n,t.center.coords.usrCoords[2]+Math.sin(r*a+l)*n],e),r+1);t.type===i.Z.OBJECT_TYPE_SECTOR&&this._addToList(p,t.center.coords,d+2)}return p},greinerHormann:function(t,e,i,s){var r,n,a,h,l=[],c=[];return(r=(l=this._getPath(t,s)).length)>0&&u.Z.distance(l[0].coords.usrCoords,l[r-1].coords.usrCoords,3)<o.Z.eps&&l.pop(),(r=(c=this._getPath(e,s)).length)>0&&u.Z.distance(c[0].coords.usrCoords,c[r-1].coords.usrCoords,3)<o.Z.eps*o.Z.eps&&c.pop(),this.isEmptyCase(l,c,i)?[[],[]]:(a=this.makeDoublyLinkedList(l),h=this.makeDoublyLinkedList(c),n=this.findIntersections(l,c,s)[0],this._handleFullyDegenerateCase(l,c,s),this.markEntryExit(l,c,a),this.markEntryExit(c,l,h),0===this._countCrossingIntersections(n)?this.handleEmptyIntersection(l,c,i):this.tracing(l,n,i))},union:function(t,e,i){return this.greinerHormann(t,e,"union",i)},intersection:function(t,e,i){return this.greinerHormann(t,e,"intersection",i)},difference:function(t,e,i){return this.greinerHormann(t,e,"difference",i)}},t.Z.extend(o.Z.Clip,{});o.Z.Clip;o.Z.Poly={},o.Z.Poly.Ring=function(t){this.vars=t},t.Z.extend(o.Z.Poly.Ring.prototype,{}),o.Z.Poly.Monomial=function(t,e,i){var r;if(!s.Z.exists(t))throw new Error("JSXGraph error: In JXG.Math.Poly.monomial missing parameter 'ring'.");for(s.Z.isArray(i)||(i=[]),r=(i=i.slice(0,t.vars.length)).length;r<t.vars.length;r++)i.push(0);this.ring=t,this.coefficient=e||0,this.exponents=s.Z.deepCopy(i)},t.Z.extend(o.Z.Poly.Monomial.prototype,{copy:function(){return new o.Z.Poly.Monomial(this.ring,this.coefficient,this.exponents)},print:function(){var t,e=[];for(t=0;t<this.ring.vars.length;t++)e.push(this.ring.vars[t]+"^"+this.exponents[t]);return this.coefficient+"*"+e.join("*")}}),o.Z.Poly.Polynomial=function(t,e){var i;if(!s.Z.exists(t))throw new Error("JSXGraph error: In JXG.Math.Poly.polynomial missing parameter 'ring'.");i=s.Z.exists(e)&&s.Z.isString(e)?void 0:[],this.ring=t,this.monomials=i},t.Z.extend(o.Z.Poly.Polynomial.prototype,{findSignature:function(t){var e;for(e=0;e<this.monomials.length;e++)if(s.Z.cmpArrays(this.monomials[e].exponents,t))return e;return-1},addSubMonomial:function(t,e){var i;(i=this.findSignature(t.exponents))>-1?this.monomials[i].coefficient+=e*t.coefficient:(t.coefficient*=e,this.monomials.push(t))},add:function(t){var e;if(!s.Z.exists(t)||t.ring!==this.ring)throw new Error("JSXGraph error: In JXG.Math.Poly.polynomial.add either summand is undefined or rings don't match.");if(s.Z.isArray(t.exponents))this.addSubMonomial(t,1);else for(e=0;e<t.monomials.length;e++)this.addSubMonomial(t.monomials[e],1)},sub:function(t){var e;if(!s.Z.exists(t)||t.ring!==this.ring)throw new Error("JSXGraph error: In JXG.Math.Poly.polynomial.sub either summand is undefined or rings don't match.");if(s.Z.isArray(t.exponents))this.addSubMonomial(t,-1);else for(e=0;e<t.monomials.length;e++)this.addSubMonomial(t.monomials[e],-1)},copy:function(){var t,e;for(e=new o.Z.Poly.Polynomial(this.ring),t=0;t<this.monomials.length;t++)e.monomials.push(this.monomials[t].copy());return e},print:function(){var t,e=[];for(t=0;t<this.monomials.length;t++)e.push("("+this.monomials[t].print()+")");return e.join("+")}});o.Z.Poly;t.Z.Complex=function(t,e){this.isComplex=!0,t&&t.isComplex&&(e=t.imaginary,t=t.real),this.real=t||0,this.imaginary=e||0,this.absval=0,this.angle=0},t.Z.extend(t.Z.Complex.prototype,{toString:function(){return this.real+" + "+this.imaginary+"i"},add:function(t){return s.Z.isNumber(t)?this.real+=t:(this.real+=t.real,this.imaginary+=t.imaginary),this},sub:function(t){return s.Z.isNumber(t)?this.real-=t:(this.real-=t.real,this.imaginary-=t.imaginary),this},mult:function(t){var e,i;return s.Z.isNumber(t)?(this.real*=t,this.imaginary*=t):(e=this.real,i=this.imaginary,this.real=e*t.real-i*t.imaginary,this.imaginary=e*t.imaginary+i*t.real),this},div:function(t){var e,i,r;if(s.Z.isNumber(t)){if(Math.abs(t)<Math.eps)return this.real=1/0,this.imaginary=1/0,this;this.real/=t,this.imaginary/=t}else{if(Math.abs(t.real)<Math.eps&&Math.abs(t.imaginary)<Math.eps)return this.real=1/0,this.imaginary=1/0,this;e=t.real*t.real+t.imaginary*t.imaginary,r=this.real,i=this.imaginary,this.real=(r*t.real+i*t.imaginary)/e,this.imaginary=(i*t.real-r*t.imaginary)/e}return this},conj:function(){return this.imaginary*=-1,this}}),t.Z.C={},t.Z.C.add=function(e,i){var s=new t.Z.Complex(e);return s.add(i),s},t.Z.C.sub=function(e,i){var s=new t.Z.Complex(e);return s.sub(i),s},t.Z.C.mult=function(e,i){var s=new t.Z.Complex(e);return s.mult(i),s},t.Z.C.div=function(e,i){var s=new t.Z.Complex(e);return s.div(i),s},t.Z.C.conj=function(e){var i=new t.Z.Complex(e);return i.conj(),i},t.Z.C.abs=function(e){var i=new t.Z.Complex(e);return i.conj(),i.mult(e),Math.sqrt(i.real)},t.Z.Complex.C=t.Z.C;const M=t.Z.Complex;var N=__webpack_require__(766);t.Z.AbstractRenderer=function(){this.vOffsetText=0,this.enhancedRendering=!0,this.container=null,this.type="",this.supportsForeignObject=!1},t.Z.extend(t.Z.AbstractRenderer.prototype,{_updateVisual:function(t,e,i){(i||this.enhancedRendering)&&(e=e||{},this.setObjectTransition(t),s.Z.evaluate(t.visProp.draft)?this.setDraft(t):(e.stroke||(t.highlighted?(this.setObjectStrokeColor(t,t.visProp.highlightstrokecolor,t.visProp.highlightstrokeopacity),this.setObjectStrokeWidth(t,t.visProp.highlightstrokewidth)):(this.setObjectStrokeColor(t,t.visProp.strokecolor,t.visProp.strokeopacity),this.setObjectStrokeWidth(t,t.visProp.strokewidth))),e.fill||(t.highlighted?this.setObjectFillColor(t,t.visProp.highlightfillcolor,t.visProp.highlightfillopacity):this.setObjectFillColor(t,t.visProp.fillcolor,t.visProp.fillopacity)),e.dash||this.setDashStyle(t,t.visProp),e.shadow||this.setShadow(t),e.gradient||this.setShadow(t),e.tabindex||this.setTabindex(t)))},_getHighlighted:function(t){var e=!1;return s.Z.exists(t.board)&&s.Z.exists(t.board.highlightedObjects)||(e=!0),!e&&s.Z.exists(t.board.highlightedObjects[t.id])?"highlight":""},drawPoint:function(t){var e,i=N.Z.normalizePointFace(s.Z.evaluate(t.visProp.face));e="o"===i?"ellipse":"[]"===i?"rect":"path",t.rendNode=this.appendChildPrim(this.createPrim(e,t.id),s.Z.evaluate(t.visProp.layer)),this.appendNodesToElement(t,e),this._updateVisual(t,{dash:!0,shadow:!0},!0),this.updatePoint(t)},updatePoint:function(t){var e,i=s.Z.evaluate(t.visProp.size),r=N.Z.normalizePointFace(s.Z.evaluate(t.visProp.face)),o=s.Z.evaluate(t.visProp.sizeunit),n=s.Z.evaluate(t.visProp.zoom);isNaN(t.coords.scrCoords[2]+t.coords.scrCoords[1])||("user"===o&&(i*=Math.sqrt(t.board.unitX*t.board.unitY)),e=0===(i*=t.board&&n?Math.sqrt(t.board.zoomX*t.board.zoomY):1)?0:i+1,"o"===r?this.updateEllipsePrim(t.rendNode,t.coords.scrCoords[1],t.coords.scrCoords[2],e,e):"[]"===r?this.updateRectPrim(t.rendNode,t.coords.scrCoords[1]-i,t.coords.scrCoords[2]-i,2*i,2*i):this.updatePathPrim(t.rendNode,this.updatePathStringPoint(t,i,r),t.board),this._updateVisual(t,{dash:!1,shadow:!1}),this.setShadow(t))},changePointStyle:function(t){var e=this.getElementById(t.id);s.Z.exists(e)&&this.remove(e),this.drawPoint(t),s.Z.clearVisPropOld(t),t.visPropCalc.visible||this.display(t,!1),s.Z.evaluate(t.visProp.draft)&&this.setDraft(t)},drawLine:function(t){t.rendNode=this.appendChildPrim(this.createPrim("line",t.id),s.Z.evaluate(t.visProp.layer)),this.appendNodesToElement(t,"lines"),this.updateLine(t)},updateLine:function(t){this._updateVisual(t),this.updatePathWithArrowHeads(t),this.setLineCap(t)},drawCurve:function(t){t.rendNode=this.appendChildPrim(this.createPrim("path",t.id),s.Z.evaluate(t.visProp.layer)),this.appendNodesToElement(t,"path"),this.updateCurve(t)},updateCurve:function(t){this._updateVisual(t),this.updatePathWithArrowHeads(t),this.setLineCap(t)},updatePathWithArrowHeads:function(t,e){var r,o,n=t.visProp,a=e?"highlight":"";r=e&&n.highlightstrokewidth?Math.max(s.Z.evaluate(n.highlightstrokewidth),s.Z.evaluate(n.strokewidth)):s.Z.evaluate(n.strokewidth),o=this.getArrowHeadData(t,r,a),this.makeArrows(t,o),t.elementClass===i.Z.OBJECT_CLASS_LINE?this.updateLineWithEndings(t,o):t.elementClass===i.Z.OBJECT_CLASS_CURVE&&this.updatePath(t),this.setArrowSize(t,o)},getArrowHeadData:function(t,e,r){var n,a,h,l,c=o.Z.eps,d=0,u=0,p=0,_=0,f=s.Z.evaluate(t.visProp.firstarrow),b=s.Z.evaluate(t.visProp.lastarrow);return(f||b)&&(n=s.Z.exists(f.type)?s.Z.evaluate(f.type):t.elementClass===i.Z.OBJECT_CLASS_LINE?1:7,a=s.Z.exists(b.type)?s.Z.evaluate(b.type):t.elementClass===i.Z.OBJECT_CLASS_LINE?1:7,f&&(l=6,s.Z.exists(f.size)&&(l=s.Z.evaluate(f.size)),""!==r&&s.Z.exists(f[r+"size"])&&(l=s.Z.evaluate(f[r+"size"])),h=e*l,2===n?(h*=.5,c+=e*l):3===n?(h=e*l/3,c+=e):4===n||5===n||6===n?(h=e*l/1.5,c+=e*l):7===n?(h=0,l=10,c+=e):c+=e*l,d+=h,p=l),b&&(l=6,s.Z.exists(b.size)&&(l=s.Z.evaluate(b.size)),""!==r&&s.Z.exists(b[r+"size"])&&(l=s.Z.evaluate(b[r+"size"])),h=e*l,2===a?(h*=.5,c+=e*l):3===a?(h=e*l/3,c+=e):4===a||5===a||6===a?(h=e*l/1.5,c+=e*l):7===a?(h=0,l=10,c+=e):c+=e*l,u+=h,_=l)),t.visPropCalc.typeFirst=n,t.visPropCalc.typeLast=a,{evFirst:f,evLast:b,typeFirst:n,typeLast:a,offFirst:d,offLast:u,sizeFirst:p,sizeLast:_,showFirst:1,showLast:1,minLen:c,strokeWidth:e}},updateLineWithEndings:function(t,e){var r,o,n;return r=new c.Z(i.Z.COORDS_BY_USER,t.point1.coords.usrCoords,t.board),o=new c.Z(i.Z.COORDS_BY_USER,t.point2.coords.usrCoords,t.board),n=s.Z.evaluate(t.visProp.margin),u.Z.calcStraight(t,r,o,n),this.handleTouchpoints(t,r,o,e),this.getPositionArrowHead(t,r,o,e),this.updateLinePrim(t.rendNode,r.scrCoords[1],r.scrCoords[2],o.scrCoords[1],o.scrCoords[2],t.board),this},updatePath:function(t){return s.Z.evaluate(t.visProp.handdrawing)?this.updatePathPrim(t.rendNode,this.updatePathStringBezierPrim(t),t.board):this.updatePathPrim(t.rendNode,this.updatePathStringPrim(t),t.board),this},getPositionArrowHead:function(t,e,s,r){var o,n,a,h,l;return(r.evFirst||r.evLast)&&(n=a=h=l=0,o=e.distance(i.Z.COORDS_BY_SCREEN,s),r.evFirst&&"vml"!==t.board.renderer.type&&(o>=r.minLen?(n=(s.scrCoords[1]-e.scrCoords[1])*r.offFirst/o,a=(s.scrCoords[2]-e.scrCoords[2])*r.offFirst/o):r.showFirst=0),r.evLast&&"vml"!==t.board.renderer.type&&(o>=r.minLen?(h=(s.scrCoords[1]-e.scrCoords[1])*r.offLast/o,l=(s.scrCoords[2]-e.scrCoords[2])*r.offLast/o):r.showLast=0),e.setCoordinates(i.Z.COORDS_BY_SCREEN,[e.scrCoords[1]+n,e.scrCoords[2]+a],!1,!0),s.setCoordinates(i.Z.COORDS_BY_SCREEN,[s.scrCoords[1]-h,s.scrCoords[2]-l],!1,!0)),this},handleTouchpoints:function(t,e,r,o){var n,a,h,l,c,d,u;return(o.evFirst||o.evLast)&&(h=l=c=d=u=0,n=s.Z.evaluate(t.point1.visProp.size)+s.Z.evaluate(t.point1.visProp.strokewidth),a=s.Z.evaluate(t.point2.visProp.size)+s.Z.evaluate(t.point2.visProp.strokewidth),o.evFirst&&s.Z.evaluate(t.visProp.touchfirstpoint)&&(h=e.distance(i.Z.COORDS_BY_SCREEN,r),l=(r.scrCoords[1]-e.scrCoords[1])*n/h,c=(r.scrCoords[2]-e.scrCoords[2])*n/h),o.evLast&&s.Z.evaluate(t.visProp.touchlastpoint)&&(h=e.distance(i.Z.COORDS_BY_SCREEN,r),d=(r.scrCoords[1]-e.scrCoords[1])*a/h,u=(r.scrCoords[2]-e.scrCoords[2])*a/h),e.setCoordinates(i.Z.COORDS_BY_SCREEN,[e.scrCoords[1]+l,e.scrCoords[2]+c],!1,!0),r.setCoordinates(i.Z.COORDS_BY_SCREEN,[r.scrCoords[1]-d,r.scrCoords[2]-u],!1,!0)),this},setArrowSize:function(t,e){return e.evFirst&&this._setArrowWidth(t.rendNodeTriangleStart,e.showFirst*e.strokeWidth,t.rendNode,e.sizeFirst),e.evLast&&this._setArrowWidth(t.rendNodeTriangleEnd,e.showLast*e.strokeWidth,t.rendNode,e.sizeLast),this},setLineCap:function(t){},drawTicks:function(t){t.rendNode=this.appendChildPrim(this.createPrim("path",t.id),s.Z.evaluate(t.visProp.layer)),this.appendNodesToElement(t,"path")},updateTicks:function(t){},drawEllipse:function(t){t.rendNode=this.appendChildPrim(this.createPrim("ellipse",t.id),s.Z.evaluate(t.visProp.layer)),this.appendNodesToElement(t,"ellipse"),this.updateEllipse(t)},updateEllipse:function(t){this._updateVisual(t);var e=t.Radius();e>0&&Math.abs(t.center.coords.usrCoords[0])>o.Z.eps&&!isNaN(e+t.center.coords.scrCoords[1]+t.center.coords.scrCoords[2])&&e*t.board.unitX<2e6&&this.updateEllipsePrim(t.rendNode,t.center.coords.scrCoords[1],t.center.coords.scrCoords[2],e*t.board.unitX,e*t.board.unitY)},drawPolygon:function(t){t.rendNode=this.appendChildPrim(this.createPrim("polygon",t.id),s.Z.evaluate(t.visProp.layer)),this.appendNodesToElement(t,"polygon"),this.updatePolygon(t)},updatePolygon:function(t){this._updateVisual(t,{stroke:!0,dash:!0}),this.updatePolygonPrim(t.rendNode,t)},displayCopyright:function(t,e){},drawInternalText:function(t){},updateInternalText:function(t){},drawText:function(t){var i,r,o,n;"html"===s.Z.evaluate(t.visProp.display)&&e.Z.isBrowser&&"no"!==this.type?((i=this.container.ownerDocument.createElement("div")).style.position="absolute",i.className=s.Z.evaluate(t.visProp.cssclass),o=s.Z.evaluate(t.visProp.layer),s.Z.exists(o)||(o=0),r=""===this.container.style.zIndex?0:parseInt(this.container.style.zIndex,10),i.style.zIndex=r+o,this.container.appendChild(i),i.setAttribute("id",this.container.id+"_"+t.id)):i=this.drawInternalText(t),t.rendNode=i,t.htmlStr="",t.visProp.islabel&&s.Z.exists(t.visProp.anchor)?(n=s.Z.evaluate(t.visProp.anchor.visProp.visible),t.prepareUpdate().updateVisibility(n)):t.prepareUpdate().updateVisibility(),this.updateText(t)},updateText:function(i){var r,o,n,a,h,l,c,d,u,p=i.plaintext;if(i.visPropCalc.visible)if(this.updateTextStyle(i,!1),"html"===s.Z.evaluate(i.visProp.display)&&"no"!==this.type){if(isNaN(i.coords.scrCoords[1]+i.coords.scrCoords[2])||(o=i.coords.scrCoords[1],o=Math.abs(o)<1e6?o:1e6,r="right"===(d=i.getAnchorX())?i.board.canvasWidth-o:"middle"===d?o-.5*i.size[0]:o,i.visPropOld.left!==d+r&&("right"===d?(i.rendNode.style.right=r+"px",i.rendNode.style.left="auto"):(i.rendNode.style.left=r+"px",i.rendNode.style.right="auto"),i.visPropOld.left=d+r),o=i.coords.scrCoords[2]+this.vOffsetText,o=Math.abs(o)<1e6?o:1e6,r="bottom"===(u=i.getAnchorY())?i.board.canvasHeight-o:"middle"===u?o-.5*i.size[1]:o,i.visPropOld.top!==u+r&&("bottom"===u?(i.rendNode.style.top="auto",i.rendNode.style.bottom=r+"px"):(i.rendNode.style.bottom="auto",i.rendNode.style.top=r+"px"),i.visPropOld.top=u+r)),i.htmlStr!==p){try{i.type===s.Z.OBJECT_TYPE_BUTTON?i.rendNodeButton.innerHTML=p:i.type===s.Z.OBJECT_TYPE_CHECKBOX||i.type===s.Z.OBJECT_TYPE_INPUT?i.rendNodeLabel.innerHTML=p:i.rendNode.innerHTML=p}catch(t){n=i.rendNode.parentNode,i.rendNode.parentNode.removeChild(i.rendNode),i.rendNode.innerHTML=p,n.appendChild(i.rendNode)}if(i.htmlStr=p,s.Z.evaluate(i.visProp.usemathjax))try{MathJax.typeset?MathJax.typeset([i.rendNode]):MathJax.Hub.Queue(["Typeset",MathJax.Hub,i.rendNode]),c="fullscreenwrap_"+(l=i.board.container),document.getElementById(c)&&(a=i.board.containerObj._cssFullscreenStore.scale,h=i.board.containerObj._cssFullscreenStore.vshift,e.Z.scaleJSXGraphDiv("#"+c,"#"+l,a,h))}catch(e){t.Z.debug("MathJax (not yet) loaded")}else if(s.Z.evaluate(i.visProp.usekatex))try{katex.render(p,i.rendNode,{throwOnError:!1})}catch(e){t.Z.debug("KaTeX not loaded (yet)")}else if(s.Z.evaluate(i.visProp.useasciimathml))try{AMprocessNode(i.rendNode,!1)}catch(e){t.Z.debug("AsciiMathML not loaded (yet)")}}this.transformImage(i,i.transformations)}else this.updateInternalText(i)},_css2js:function(t){var e,i,r,o,n,a=[],h=s.Z.trim(t).replace(/;$/,"").split(";");for(i=h.length,e=0;e<i;++e)""!==s.Z.trim(h[e])&&(n=h[e].split(":"),r=s.Z.trim(n[0].replace(/-([a-z])/gi,(function(t,e){return e.toUpperCase()}))),o=s.Z.trim(n[1]),a.push({key:r,val:o}));return a},updateTextStyle:function(t,i){var r,o,n,a,h,l,c,d,u,p=t.visProp,_=e.Z.isBrowser?p.display:"internal",f=["rendNode","rendNodeTag","rendNodeLabel"],b=f.length,g=s.Z.evaluate(p.fontunit),m=["cssdefaultstyle","cssstyle"],v=m.length;if(i?(n=p.highlightstrokecolor,o=p.highlightstrokeopacity,a=p.highlightcssclass):(n=p.strokecolor,o=p.strokeopacity,a=p.cssclass),"no"!==this.type&&("html"===_||"canvas"!==this.type)){for(d=0;d<v;d++)if(""!==(u=s.Z.evaluate(p[(i?"highlight":"")+m[d]]))&&t.visPropOld[m[d]]!==u){for(l=this._css2js(u),h=0;h<b;h++)if(s.Z.exists(t[f[h]]))for(c in l)l.hasOwnProperty(c)&&(t[f[h]].style[l[c].key]=l[c].val);t.visPropOld[m[d]]=u}if(r=s.Z.evaluate(p.fontsize),t.visPropOld.fontsize!==r){t.needsSizeUpdate=!0;try{for(h=0;h<b;h++)s.Z.exists(t[f[h]])&&(t[f[h]].style.fontSize=r+g)}catch(e){for(h=0;h<b;h++)s.Z.exists(t[f[h]])&&(t[f[h]].style.fontSize=r)}t.visPropOld.fontsize=r}}return this.setObjectTransition(t),"html"===_&&"no"!==this.type?(t.visPropOld.cssclass!==a&&(t.rendNode.className=a,t.visPropOld.cssclass=a,t.needsSizeUpdate=!0),this.setObjectStrokeColor(t,n,o)):this.updateInternalTextStyle(t,n,o),this},updateInternalTextStyle:function(t,e,i){this.setObjectStrokeColor(t,e,i)},drawImage:function(t){},updateImage:function(t){this.updateRectPrim(t.rendNode,t.coords.scrCoords[1],t.coords.scrCoords[2]-t.size[1],t.size[0],t.size[1]),this.updateImageURL(t),this.transformImage(t,t.transformations),this._updateVisual(t,{stroke:!0,dash:!0},!0)},joinTransforms:function(t,e){var i,s=t.board.origin.scrCoords[1],r=t.board.origin.scrCoords[2],n=t.board.unitX,a=t.board.unitY,h=e.length,l=[[1,0,0],[-s/n,1/n,0],[r/a,0,-1/a]];for(i=0;i<h;i++)l=o.Z.matMatMult(e[i].matrix,l);return l=o.Z.matMatMult([[1,0,0],[s,n,0],[r,0,-a]],l)},transformImage:function(t,e){},updateImageURL:function(t){},updateImageStyle:function(t,e){t.rendNode.className=s.Z.evaluate(e?t.visProp.highlightcssclass:t.visProp.cssclass)},drawForeignObject:function(t){},updateForeignObject:function(t){},appendChildPrim:function(t,e){},appendNodesToElement:function(t,e){},createPrim:function(t,e){return null},remove:function(t){},makeArrows:function(t,e){},_setArrowWidth:function(t,e,i){},updateEllipsePrim:function(t,e,i,s,r){},updateLinePrim:function(t,e,i,s,r,o){},updatePathPrim:function(t,e,i){},updatePathStringPoint:function(t,e,i){},updatePathStringPrim:function(t){},updatePathStringBezierPrim:function(t){},updatePolygonPrim:function(t,e){},updateRectPrim:function(t,e,i,s,r){},setPropertyPrim:function(t,e,i){},setTabindex:function(t){var e;t.board.attr.keyboard.enabled&&s.Z.exists(t.rendNode)&&(e=s.Z.evaluate(t.visProp.tabindex),t.visPropCalc.visible&&!s.Z.evaluate(t.visProp.fixed)||(e=null),e!==t.visPropOld.tabindex&&(t.rendNode.setAttribute("tabindex",e),t.visPropOld.tabindex=e))},display:function(t,e){t&&(t.visPropOld.visible=e)},show:function(t){},hide:function(t){},setBuffering:function(t,e){},setDashStyle:function(t){},setDraft:function(t){if(s.Z.evaluate(t.visProp.draft)){var e=t.board.options.elements.draft.color,r=t.board.options.elements.draft.opacity;this.setObjectTransition(t),t.type===i.Z.OBJECT_TYPE_POLYGON?this.setObjectFillColor(t,e,r):(t.elementClass===i.Z.OBJECT_CLASS_POINT?this.setObjectFillColor(t,e,r):this.setObjectFillColor(t,"none",0),this.setObjectStrokeColor(t,e,r),this.setObjectStrokeWidth(t,t.board.options.elements.draft.strokeWidth))}},removeDraft:function(t){this.setObjectTransition(t),t.type===i.Z.OBJECT_TYPE_POLYGON?this.setObjectFillColor(t,t.visProp.fillcolor,t.visProp.fillopacity):(t.type===i.Z.OBJECT_CLASS_POINT&&this.setObjectFillColor(t,t.visProp.fillcolor,t.visProp.fillopacity),this.setObjectStrokeColor(t,t.visProp.strokecolor,t.visProp.strokeopacity),this.setObjectStrokeWidth(t,t.visProp.strokewidth))},setGradient:function(t){},updateGradient:function(t){},setObjectTransition:function(t,e){},setObjectFillColor:function(t,e,i){},setObjectStrokeColor:function(t,e,i){},setObjectStrokeWidth:function(t,e){},setShadow:function(t){},highlight:function(t){var e,r,o=t.visProp;if(this.setObjectTransition(t),!o.draft){if(t.type===i.Z.OBJECT_TYPE_POLYGON)for(this.setObjectFillColor(t,o.highlightfillcolor,o.highlightfillopacity),e=0;e<t.borders.length;e++)this.setObjectStrokeColor(t.borders[e],t.borders[e].visProp.highlightstrokecolor,t.borders[e].visProp.highlightstrokeopacity);else t.elementClass===i.Z.OBJECT_CLASS_TEXT?this.updateTextStyle(t,!0):t.type===i.Z.OBJECT_TYPE_IMAGE?(this.updateImageStyle(t,!0),this.setObjectFillColor(t,o.highlightfillcolor,o.highlightfillopacity)):(this.setObjectStrokeColor(t,o.highlightstrokecolor,o.highlightstrokeopacity),this.setObjectFillColor(t,o.highlightfillcolor,o.highlightfillopacity));o.highlightstrokewidth&&(r=Math.max(s.Z.evaluate(o.highlightstrokewidth),s.Z.evaluate(o.strokewidth)),this.setObjectStrokeWidth(t,r),t.elementClass!==i.Z.OBJECT_CLASS_LINE&&t.elementClass!==i.Z.OBJECT_CLASS_CURVE||this.updatePathWithArrowHeads(t,!0))}return this},noHighlight:function(t){var e,r,o=t.visProp;if(this.setObjectTransition(t),!s.Z.evaluate(t.visProp.draft)){if(t.type===i.Z.OBJECT_TYPE_POLYGON)for(this.setObjectFillColor(t,o.fillcolor,o.fillopacity),e=0;e<t.borders.length;e++)this.setObjectStrokeColor(t.borders[e],t.borders[e].visProp.strokecolor,t.borders[e].visProp.strokeopacity);else t.elementClass===i.Z.OBJECT_CLASS_TEXT?this.updateTextStyle(t,!1):t.type===i.Z.OBJECT_TYPE_IMAGE?(this.updateImageStyle(t,!1),this.setObjectFillColor(t,o.fillcolor,o.fillopacity)):(this.setObjectStrokeColor(t,o.strokecolor,o.strokeopacity),this.setObjectFillColor(t,o.fillcolor,o.fillopacity));r=s.Z.evaluate(o.strokewidth),this.setObjectStrokeWidth(t,r),t.elementClass!==i.Z.OBJECT_CLASS_LINE&&t.elementClass!==i.Z.OBJECT_CLASS_CURVE||this.updatePathWithArrowHeads(t,!1)}return this},suspendRedraw:function(){},unsuspendRedraw:function(){},drawZoomBar:function(t,i){var r,o,n=function(t){t||(t=window.event),t.stopPropagation?t.stopPropagation():t.cancelBubble=!0},a=function(i,a,h){var l;h=h||"",(l=r.createElement("span")).innerHTML=i,l.style.paddingLeft="7px",l.style.paddingRight="7px",void 0!==l.classList&&l.classList.add("JXG_navigation_button"),l.setAttribute("id",h),o.appendChild(l),e.Z.addEvent(l,"click",(function(e){return s.Z.bind(a,t)(),!1}),t),e.Z.addEvent(l,"mouseup",n,t),e.Z.addEvent(l,"mousedown",n,t),e.Z.addEvent(l,"touchend",n,t),e.Z.addEvent(l,"touchstart",n,t)};e.Z.isBrowser&&"no"!==this.type&&(r=t.containerObj.ownerDocument,(o=r.createElement("div")).setAttribute("id",t.container+"_navigationbar"),o.style.color=i.strokecolor,o.style.backgroundColor=i.fillcolor,o.style.padding=i.padding,o.style.position=i.position,o.style.fontSize=i.fontsize,o.style.cursor=i.cursor,o.style.zIndex=i.zindex,t.containerObj.appendChild(o),o.style.right=i.right,o.style.bottom=i.bottom,void 0!==o.classList&&o.classList.add("JXG_navigation"),t.attr.showfullscreen&&a(t.attr.fullscreen.symbol,(function(){t.toFullscreen(t.attr.fullscreen.id)}),t.container+"_navigation_fullscreen"),t.attr.showscreenshot&&a(t.attr.screenshot.symbol,(function(){window.setTimeout((function(){t.renderer.screenshot(t,"",!1)}),330)}),t.container+"_navigation_screenshot"),t.attr.showreload&&a("↻",(function(){t.reload()}),t.container+"_navigation_reload"),t.attr.showcleartraces&&a("⊗",(function(){t.clearTraces()}),t.container+"_navigation_cleartraces"),t.attr.shownavigation&&(t.attr.showzoom&&(a("–",t.zoomOut,t.container+"_navigation_out"),a("o",t.zoom100,t.container+"_navigation_100"),a("+",t.zoomIn,t.container+"_navigation_in")),a("←",t.clickLeftArrow,t.container+"_navigation_left"),a("↓",t.clickUpArrow,t.container+"_navigation_down"),a("↑",t.clickDownArrow,t.container+"_navigation_up"),a("→",t.clickRightArrow,t.container+"_navigation_right")))},getElementById:function(t){return s.Z.exists(this.container)?this.container.querySelector("#"+this.container.id+"_"+t):""},removeToInsertLater:function(t){var e=t.parentNode,i=t.nextSibling;if(null!==e)return e.removeChild(t),function(){i?e.insertBefore(t,i):e.appendChild(t)}},resize:function(t,e){},createTouchpoints:function(t){},showTouchpoint:function(t){},hideTouchpoint:function(t){},updateTouchpoint:function(t,e){},dumpToDataURI:function(t){},dumpToCanvas:function(t,e,i,s){},screenshot:function(t){},setLayer:function(t,e){}});const A=t.Z.AbstractRenderer;t.Z.FileReader={handleRemoteFile:function(e,i,r,o,n,a){var h=!1;try{h=new XMLHttpRequest,"raw"===r.toLowerCase()?h.overrideMimeType("text/plain; charset="+n):h.overrideMimeType("text/xml; charset="+n)}catch(t){try{h=new ActiveXObject("Msxml2.XMLHTTP")}catch(t){try{h=new ActiveXObject("Microsoft.XMLHTTP")}catch(t){h=!1}}}if(h){h.open("GET",e,o),"raw"===r.toLowerCase()?this.cbp=function(){var t=h;4===t.readyState&&i(t.responseText)}:this.cbp=function(){var t=h,e="";4===t.readyState&&(e=!s.Z.exists(t.responseStream)||"PK"!==t.responseText.slice(0,2)&&31!==P.asciiCharCodeAt(t.responseText.slice(0,1),0)?t.responseText:x.decode(jxgBinFileReader(t)),this.parseString(e,i,r,a))},this.cb=s.Z.bind(this.cbp,this),h.onreadystatechange=this.cb;try{h.send(null)}catch(t){throw new Error("JSXGraph: A problem occurred while trying to read remote file '"+e+"'.")}}else t.Z.debug("AJAX not activated!")},handleLocalFile:function(t,e,i,r,o,n){s.Z.exists(r)||(r=!0),"raw"===i.toLowerCase()?this.cbp=function(t){e(t.target.result)}:this.cbp=function(t){var s=t.target.result;this.parseString(s,e,i,n)},this.cb=s.Z.bind(this.cbp,this);var a=new FileReader;a.onload=this.cb,"raw"===i.toLowerCase()?a.readAsText(t):a.readAsText(t,o)},parseFileContent:function(t,e,i,r,o,n){s.Z.isString(t)||void 0===FileReader?this.handleRemoteFile(t,e,i,r,o,n):this.handleLocalFile(t,e,i,r,o,n)},parseString:function(e,i,r,o){var n;if(r=r.toLowerCase(),n=t.Z.readers[r],s.Z.exists(n))new n(i,e).read();else if("jessiecode"!==r)throw new Error("JSXGraph: There is no reader available for '"+r+"'.");s.Z.isFunction(o)&&o(i)}},!e.Z.isMetroApp()&&e.Z.isBrowser&&"object"==typeof navigator&&/msie/i.test(navigator.userAgent)&&!/opera/i.test(navigator.userAgent)&&document&&document.write&&document.write('<script type="text/vbscript">\nFunction Base64Encode(inData)\n  Const Base64 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/"\n  Dim cOut, sOut, I\n  For I = 1 To LenB(inData) Step 3\n    Dim nGroup, pOut, sGroup\n    nGroup = &H10000 * AscB(MidB(inData, I, 1)) + _\n      &H100 * MyASC(MidB(inData, I + 1, 1)) + MyASC(MidB(inData, I + 2, 1))\n    nGroup = Oct(nGroup)\n    nGroup = String(8 - Len(nGroup), "0") & nGroup\n    pOut = Mid(Base64, CLng("&o" & Mid(nGroup, 1, 2)) + 1, 1) + _\n      Mid(Base64, CLng("&o" & Mid(nGroup, 3, 2)) + 1, 1) + _\n      Mid(Base64, CLng("&o" & Mid(nGroup, 5, 2)) + 1, 1) + _\n      Mid(Base64, CLng("&o" & Mid(nGroup, 7, 2)) + 1, 1)\n    sOut = sOut + pOut\n  Next\n  Select Case LenB(inData) Mod 3\n    Case 1: \'8 bit final\n      sOut = Left(sOut, Len(sOut) - 2) + "=="\n    Case 2: \'16 bit final\n      sOut = Left(sOut, Len(sOut) - 1) + "="\n  End Select\n  Base64Encode = sOut\nEnd Function\n\nFunction MyASC(OneChar)\n  If OneChar = "" Then MyASC = 0 Else MyASC = AscB(OneChar)\nEnd Function\n\nFunction jxgBinFileReader(xhr)\n    Dim byteString\n    Dim b64String\n    Dim i\n    byteString = xhr.responseBody\n    ReDim byteArray(LenB(byteString))\n    For i = 1 To LenB(byteString)\n        byteArray(i-1) = AscB(MidB(byteString, i, 1))\n    Next\n    b64String = Base64Encode(byteString)\n    jxgBinFileReader = b64String\nEnd Function\n<\/script>\n');const k=t.Z.FileReader;var R=__webpack_require__(632),D=__webpack_require__(254),L=__webpack_require__(327);t.Z.Composition=function(t){var e,i=this,r=["setAttribute","setParents","prepareUpdate","updateRenderer","update","fullUpdate","highlight","noHighlight"],o=function(t){return function(){var e;for(e in i.elements)i.elements.hasOwnProperty(e)&&s.Z.exists(i.elements[e][t])&&i.elements[e][t].apply(i.elements[e],arguments);return i}};for(e=0;e<r.length;e++)this[r[e]]=o(r[e]);for(e in this.elements={},this.objects=this.elements,this.elementsByName={},this.objectsList=[],this.groups={},this.methodMap={setAttribute:"setAttribute",setProperty:"setAttribute",setParents:"setParents",add:"add",remove:"remove",select:"select"},t)t.hasOwnProperty(e)&&this.add(e,t[e]);this.dump=!0,this.subs={}},t.Z.extend(t.Z.Composition.prototype,{add:function(t,e){return!(s.Z.exists(this[t])||!s.Z.exists(e))&&(s.Z.exists(e.id)?this.elements[e.id]=e:this.elements[t]=e,s.Z.exists(e.name)&&(this.elementsByName[e.name]=e),e.on("attribute:name",this.nameListener,this),this.objectsList.push(e),this[t]=e,this.methodMap[t]=e,!0)},remove:function(t){var e,i=!1;for(e in this.elements)if(this.elements.hasOwnProperty(e)&&this.elements[e].id===this[t].id){i=!0;break}return i&&(delete this.elements[this[t].id],delete this[t]),i},nameListener:function(t,e,i){delete this.elementsByName[t],this.elementsByName[e]=i},select:function(e){return s.Z.exists(t.Z.Board)?t.Z.Board.prototype.select.call(this,e):new t.Z.Composition},getParents:function(){return this.parents},getType:function(){return this.elType},getAttributes:function(){var t,e={};for(t in this.subs)this.subs.hasOwnProperty(t)&&(e[t]=this.subs[t].visProp);return this.attr}});const B=t.Z.Composition;t.Z.Board=function(o,n,a,h,l,c,d,u,p,_,f){if(this.BOARD_MODE_NONE=0,this.BOARD_MODE_DRAG=1,this.BOARD_MODE_MOVE_ORIGIN=2,this.BOARD_MODE_ZOOM=17,this.BOARD_QUALITY_LOW=1,this.BOARD_QUALITY_HIGH=2,s.Z.exists(f.document)&&!1!==f.document?this.document=f.document:e.Z.isBrowser&&(this.document=document),this.container=o,this.containerObj=e.Z.isBrowser?this.document.getElementById(this.container):null,e.Z.isBrowser&&"no"!==n.type&&null===this.containerObj)throw new Error("\nJSXGraph: HTML container element '"+o+"' not found.");this.renderer=n,this.grids=[],this.options=s.Z.deepCopy(N.Z),this.attr=f,this.dimension=2,this.jc=new D.Z,this.jc.use(this),this.origin={},this.origin.usrCoords=[1,0,0],this.origin.scrCoords=[1,h[0],h[1]],this.zoomX=l,this.zoomY=c,this.unitX=d*this.zoomX,this.unitY=u*this.zoomY,this.keepaspectratio=!1,this.canvasWidth=p,this.canvasHeight=_,s.Z.exists(a)&&""!==a&&e.Z.isBrowser&&!s.Z.exists(this.document.getElementById(a))?this.id=a:this.id=this.generateId(),r.Z.eventify(this),this.hooks=[],this.dependentBoards=[],this.inUpdate=!1,this.objects={},this.objectsList=[],this.groups={},this.animationObjects={},this.highlightedObjects={},this.numObjects=0,this.elementsByName={},this.mode=this.BOARD_MODE_NONE,this.updateQuality=this.BOARD_QUALITY_HIGH,this.isSuspendedRedraw=!1,this.calculateSnapSizes(),this.drag_dx=0,this.drag_dy=0,this.drag_position=[0,0],this.mouse={},this.touches=[],this.xmlString="",this.cPos=[],this.touchMoveLast=0,this.touchMoveLastId=1/0,this.positionAccessLast=0,this.downObjects=[],this.attr.showcopyright&&this.renderer.displayCopyright(i.Z.licenseText,parseInt(this.options.text.fontSize,10)),this.needsFullUpdate=!1,this.reducedUpdate=!1,this.currentCBDef="none",this.geonextCompatibilityMode=!1,this.options.text.useASCIIMathML&&translateASCIIMath?init():this.options.text.useASCIIMathML=!1,this.hasMouseHandlers=!1,this.hasTouchHandlers=!1,this.hasPointerHandlers=!1,this.hasMouseUp=!1,this.hasTouchEnd=!1,this.hasPointerUp=!1,this._drag_offset=[0,0],this._inputDevice="mouse",this._board_touches=[],this.selectingMode=!1,this.isSelecting=!1,this._isScrolling=!1,this._isResizing=!1,this.selectingBox=[[0,0],[0,0]],this.userLog=[],this.mathLib=Math,this.mathLibJXG=t.Z.Math,this.attr.registerevents&&this.addEventHandlers(),this.methodMap={update:"update",fullUpdate:"fullUpdate",on:"on",off:"off",trigger:"trigger",setView:"setBoundingBox",setBoundingBox:"setBoundingBox",migratePoint:"migratePoint",colorblind:"emulateColorblindness",suspendUpdate:"suspendUpdate",unsuspendUpdate:"unsuspendUpdate",clearTraces:"clearTraces",left:"clickLeftArrow",right:"clickRightArrow",up:"clickUpArrow",down:"clickDownArrow",zoomIn:"zoomIn",zoomOut:"zoomOut",zoom100:"zoom100",zoomElements:"zoomElements",remove:"removeObject",removeObject:"removeObject"}},t.Z.extend(t.Z.Board.prototype,{generateName:function(t){var e,r,o=this.attr.maxnamelength,n="",a="",h=[],l="";if(t.type===i.Z.OBJECT_TYPE_TICKS)return"";for(e=s.Z.isPoint(t)||s.Z.isPoint3D(t)?["","A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z"]:t.type===i.Z.OBJECT_TYPE_ANGLE?["","&alpha;","&beta;","&gamma;","&delta;","&epsilon;","&zeta;","&eta;","&theta;","&iota;","&kappa;","&lambda;","&mu;","&nu;","&xi;","&omicron;","&pi;","&rho;","&sigma;","&tau;","&upsilon;","&phi;","&chi;","&psi;","&omega;"]:["","a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z"],s.Z.isPoint(t)||t.elementClass===i.Z.OBJECT_CLASS_LINE||t.type===i.Z.OBJECT_TYPE_ANGLE||(n=t.type===i.Z.OBJECT_TYPE_POLYGON?"P_{":t.elementClass===i.Z.OBJECT_CLASS_CIRCLE?"k_{":t.elementClass===i.Z.OBJECT_CLASS_TEXT?"t_{":"s_{",a="}"),r=0;r<o;r++)h[r]=0;for(;h[o-1]<e.length;){for(h[0]=1;h[0]<e.length;h[0]++){for(l=n,r=o;r>0;r--)l+=e[h[r-1]];if(!s.Z.exists(this.elementsByName[l+a]))return l+a}for(h[0]=e.length,r=1;r<o;r++)h[r-1]===e.length&&(h[r-1]=1,h[r]+=1)}return""},generateId:function(){for(var e=1;s.Z.exists(t.Z.boards["jxgBoard"+e]);)e=Math.round(65535*Math.random());return"jxgBoard"+e},setId:function(t,e){var i,r=this.numObjects,o=t.id;if(this.numObjects+=1,""===o||!s.Z.exists(o))for(o=this.id+e+r;s.Z.exists(this.objects[o]);)i=Math.round(65535*Math.random()),o=this.id+e+r+"-"+i;return t.id=o,this.objects[o]=t,t._pos=this.objectsList.length,this.objectsList[this.objectsList.length]=t,o},finalizeAdding:function(t){!1===s.Z.evaluate(t.visProp.visible)&&this.renderer.display(t,!1)},finalizeLabel:function(t){t.hasLabel&&!s.Z.evaluate(t.label.visProp.islabel)&&!1===s.Z.evaluate(t.label.visProp.visible)&&this.renderer.display(t.label,!1)},checkFrameRate:function(t){var e=!1,i=(new Date).getTime();return s.Z.exists(t.pointerId)&&this.touchMoveLastId!==t.pointerId&&(e=!0,this.touchMoveLastId=t.pointerId),!e&&(i-this.touchMoveLast)*this.attr.maxframerate>=1e3&&(e=!0),e&&(this.touchMoveLast=i),e},getCoordsTopLeftCorner:function(){var t,i,r,o,n,a=this.document.ownerDocument||this.document,h=a.documentElement||this.document.body.parentNode,l=a.body,c=this.containerObj;if(this.cPos.length>0&&(this.mode===this.BOARD_MODE_DRAG||this.mode===this.BOARD_MODE_MOVE_ORIGIN||(new Date).getTime()-this.positionAccessLast<1e3))return this.cPos;if(this.positionAccessLast=(new Date).getTime(),c.getBoundingClientRect){for(r=c.getBoundingClientRect(),o=1,n=c;n&&s.Z.exists(n.parentNode);)s.Z.exists(n.style)&&s.Z.exists(n.style.zoom)&&""!==n.style.zoom&&(o*=parseFloat(n.style.zoom)),n=n.parentNode;return(t=[r.left*o,r.top*o])[0]+=e.Z.getProp(c,"border-left-width"),t[1]+=e.Z.getProp(c,"border-top-width"),"vml"!==this.renderer.type&&(t[0]+=e.Z.getProp(c,"padding-left"),t[1]+=e.Z.getProp(c,"padding-top")),this.cPos=t.slice(),this.cPos}return t=e.Z.getOffset(c),i=this.document.documentElement.ownerDocument,!this.containerObj.currentStyle&&i.defaultView&&(t[0]+=e.Z.getProp(h,"margin-left"),t[1]+=e.Z.getProp(h,"margin-top"),t[0]+=e.Z.getProp(h,"border-left-width"),t[1]+=e.Z.getProp(h,"border-top-width"),t[0]+=e.Z.getProp(h,"padding-left"),t[1]+=e.Z.getProp(h,"padding-top")),l&&(t[0]+=e.Z.getProp(l,"left"),t[1]+=e.Z.getProp(l,"top")),"object"==typeof google&&google.translate&&(t[0]+=10,t[1]+=25),t[0]+=e.Z.getProp(c,"border-left-width"),t[1]+=e.Z.getProp(c,"border-top-width"),"vml"!==this.renderer.type&&(t[0]+=e.Z.getProp(c,"padding-left"),t[1]+=e.Z.getProp(c,"padding-top")),t[0]+=this.attr.offsetx,t[1]+=this.attr.offsety,this.cPos=t.slice(),this.cPos},getMousePosition:function(t,i){var r,n,a=this.getCoordsTopLeftCorner();return r=e.Z.getPosition(t,i,this.document),s.Z.exists(this.cssTransMat)||this.updateCSSTransforms(),n=[1,r[0]-a[0],r[1]-a[1]],(n=o.Z.matVecMult(this.cssTransMat,n))[1]/=n[0],n[2]/=n[0],[n[1],n[2]]},initMoveOrigin:function(t,e){this.drag_dx=t-this.origin.scrCoords[1],this.drag_dy=e-this.origin.scrCoords[2],this.mode=this.BOARD_MODE_MOVE_ORIGIN,this.updateQuality=this.BOARD_QUALITY_LOW},initMoveObject:function(t,e,r,o){var n,a,h,l=[],c=[],u=this.objectsList.length,p={visProp:{layer:-1e4}};for(a=0;a<u;a++)h=(n=this.objectsList[a]).hasPoint&&n.hasPoint(t,e),n.visPropCalc.visible&&h&&(n.triggerEventHandlers([o+"down","down"],[r]),this.downObjects.push(n)),h&&n.isDraggable&&n.visPropCalc.visible&&(this.geonextCompatibilityMode&&(s.Z.isPoint(n)||n.elementClass===i.Z.OBJECT_CLASS_TEXT)||!this.geonextCompatibilityMode)&&!s.Z.evaluate(n.visProp.fixed)&&(n.visProp.layer>p.visProp.layer||n.visProp.layer===p.visProp.layer&&n.lastDragTime.getTime()>=p.lastDragTime.getTime())&&(this.attr.ignorelabels&&s.Z.exists(p.label)&&n===p.label||(p=n,l.push(p),s.Z.exists(p.coords)?c.push(d.Z.subtract(p.coords.scrCoords.slice(1),[t,e])):c.push([0,0])));return this.attr.drag.enabled&&l.length>0&&(this.mode=this.BOARD_MODE_DRAG),this.attr.takefirst?(l.length=1,this._drag_offset=c[0]):(l=l.slice(-1),this._drag_offset=c[c.length-1]),this._drag_offset||(this._drag_offset=[0,0]),"svg"===this.renderer.type&&s.Z.exists(l[0])&&s.Z.evaluate(l[0].visProp.dragtotopoflayer)&&1===l.length&&s.Z.exists(l[0].rendNode)&&l[0].rendNode.parentNode.appendChild(l[0].rendNode),this.previousRotation=0,this.previousScale=1,l.length>=1&&(l[0].highlight(!0),this.triggerEventHandlers(["mousehit","hit"],[r,l[0]])),l},moveObject:function(t,e,r,o,n){var a,h,l,u=new c.Z(i.Z.COORDS_BY_SCREEN,this.getScrCoordsOfMouse(t,e),this);r&&r.obj&&((a=r.obj).coords&&(h=a.coords.scrCoords.slice()),this.addLogEntry("drag",a),this.drag_position=[u.scrCoords[1],u.scrCoords[2]],this.drag_position=d.Z.add(this.drag_position,this._drag_offset),s.Z.exists(a.coords)?a.setPositionDirectly(i.Z.COORDS_BY_SCREEN,this.drag_position):(this.displayInfobox(!1),isNaN(r.targets[0].Xprev+r.targets[0].Yprev)||a.setPositionDirectly(i.Z.COORDS_BY_SCREEN,[u.scrCoords[1],u.scrCoords[2]],[r.targets[0].Xprev,r.targets[0].Yprev]),r.targets[0].Xprev=u.scrCoords[1],r.targets[0].Yprev=u.scrCoords[2]),s.Z.exists(a.coords)&&(a.prepareUpdate().update(!1).updateRenderer(),this.updateInfobox(a),a.prepareUpdate().update(!0).updateRenderer()),a.coords&&(l=a.coords.scrCoords),a.coords&&h[1]===l[1]&&h[2]===l[2]||(a.triggerEventHandlers([n+"drag","drag"],[o]),this.update()),a.highlight(!0),this.triggerEventHandlers(["mousehit","hit"],[o,a]),a.lastDragTime=new Date)},twoFingerMove:function(t,e,r){var o;s.Z.exists(t)&&s.Z.exists(t.obj)&&((o=t.obj).elementClass===i.Z.OBJECT_CLASS_LINE||o.type===i.Z.OBJECT_TYPE_POLYGON?this.twoFingerTouchObject(t.targets,o,e):o.elementClass===i.Z.OBJECT_CLASS_CIRCLE&&this.twoFingerTouchCircle(t.targets,o,e),r&&o.triggerEventHandlers(["touchdrag","drag"],[r]))},twoFingerTouchObject:function(t,e,r){var n,a,h,l,d,p,_,f,b,g,m,v,Z,C,y,P,E=0;if(s.Z.exists(t[0])&&s.Z.exists(t[1])&&!isNaN(t[0].Xprev+t[0].Yprev+t[1].Xprev+t[1].Yprev)){if(r===t[0].num?(C=t[1],y=t[0]):(C=t[0],y=t[1]),P=new c.Z(i.Z.COORDS_BY_SCREEN,[C.Xprev,C.Yprev],this).usrCoords,a=new c.Z(i.Z.COORDS_BY_SCREEN,[y.Xprev,y.Yprev],this).usrCoords,n=new c.Z(i.Z.COORDS_BY_SCREEN,[y.X,y.Y],this).usrCoords,l=o.Z.crossProduct(P,a),h=o.Z.crossProduct(P,n),p=o.Z.crossProduct(l,h),Math.abs(p[0])<o.Z.eps)return;if(s.Z.evaluate(e.visProp.rotatable)&&(E=u.Z.rad(a.slice(1),P.slice(1),n.slice(1))),(_=this.create("transform",[E,[P[1],P[2]]],{type:"rotate"})).update(),s.Z.evaluate(e.visProp.scalable)&&(d=u.Z.distance(n,P)/u.Z.distance(a,P),f=this.create("transform",[-P[1],-P[2]],{type:"translate"}),b=this.create("transform",[d,d],{type:"scale"}),g=this.create("transform",[P[1],P[2]],{type:"translate"}),_.melt(f).melt(b).melt(g)),e.elementClass===i.Z.OBJECT_CLASS_LINE)m=[],e.point1.draggable()&&m.push(e.point1),e.point2.draggable()&&m.push(e.point2),_.applyOnce(m);else if(e.type===i.Z.OBJECT_TYPE_POLYGON){for(m=[],Z=e.vertices.length-1,v=0;v<Z;++v)e.vertices[v].draggable()&&m.push(e.vertices[v]);_.applyOnce(m)}this.update(),e.highlight(!0)}},twoFingerTouchCircle:function(t,e,r){var o,n,a,h,l,d,p,_,f,b,g;"pointCircle"!==e.method&&"pointLine"!==e.method&&s.Z.exists(t[0])&&s.Z.exists(t[1])&&!isNaN(t[0].Xprev+t[0].Yprev+t[1].Xprev+t[1].Yprev)&&(r===t[0].num?(o=t[1],n=t[0]):(o=t[0],n=t[1]),l=new c.Z(i.Z.COORDS_BY_SCREEN,[o.Xprev,o.Yprev],this).usrCoords,h=new c.Z(i.Z.COORDS_BY_SCREEN,[n.Xprev,n.Yprev],this).usrCoords,a=new c.Z(i.Z.COORDS_BY_SCREEN,[n.X,n.Y],this).usrCoords,p=u.Z.rad(h.slice(1),l.slice(1),a.slice(1)),_=this.create("transform",[-l[1],-l[2]],{type:"translate"}),f=this.create("transform",[p],{type:"rotate"}),_.melt(f),s.Z.evaluate(e.visProp.scalable)&&(d=u.Z.distance(l,a)/u.Z.distance(l,h),b=this.create("transform",[d,d],{type:"scale"}),_.melt(b)),g=this.create("transform",[l[1],l[2]],{type:"translate"}),_.melt(g),e.center.draggable()&&_.applyOnce([e.center]),"twoPoints"===e.method?e.point2.draggable()&&_.applyOnce([e.point2]):"pointRadius"===e.method&&s.Z.isNumber(e.updateRadius.origin)&&e.setRadius(e.radius*d),this.update(e.center),e.highlight(!0))},highlightElements:function(t,e,i,r){var o,n,a,h={},l=this.objectsList.length;for(o=0;o<l;o++)a=(n=this.objectsList[o]).id,s.Z.exists(n.hasPoint)&&n.visPropCalc.visible&&n.hasPoint(t,e)&&(this.updateInfobox(n),s.Z.exists(this.highlightedObjects[a])||(h[a]=n,n.highlight(),this.triggerEventHandlers(["mousehit","hit"],[i,n,r])),n.mouseover?n.triggerEventHandlers(["mousemove","move"],[i]):(n.triggerEventHandlers(["mouseover","over"],[i]),n.mouseover=!0));for(o=0;o<l;o++)a=(n=this.objectsList[o]).id,n.mouseover&&(h[a]||(n.triggerEventHandlers(["mouseout","out"],[i]),n.mouseover=!1))},saveStartPos:function(e,r){var o,n,a=[];if(e.type===i.Z.OBJECT_TYPE_TICKS)a.push([1,NaN,NaN]);else if(e.elementClass===i.Z.OBJECT_CLASS_LINE)a.push(e.point1.coords.usrCoords),a.push(e.point2.coords.usrCoords);else if(e.elementClass===i.Z.OBJECT_CLASS_CIRCLE)a.push(e.center.coords.usrCoords),"twoPoints"===e.method&&a.push(e.point2.coords.usrCoords);else if(e.type===i.Z.OBJECT_TYPE_POLYGON)for(n=e.vertices.length-1,o=0;o<n;o++)a.push(e.vertices[o].coords.usrCoords);else if(e.type===i.Z.OBJECT_TYPE_SECTOR)a.push(e.point1.coords.usrCoords),a.push(e.point2.coords.usrCoords),a.push(e.point3.coords.usrCoords);else if(s.Z.isPoint(e)||e.type===i.Z.OBJECT_TYPE_GLIDER)a.push(e.coords.usrCoords);else if(e.elementClass===i.Z.OBJECT_CLASS_CURVE)e.points.length>0&&a.push(e.points[0].usrCoords);else try{a.push(e.coords.usrCoords)}catch(e){t.Z.debug("JSXGraph+ saveStartPos: obj.coords.usrCoords not available: "+e)}for(n=a.length,o=0;o<n;o++)r.Zstart.push(a[o][0]),r.Xstart.push(a[o][1]),r.Ystart.push(a[o][2])},mouseOriginMoveStart:function(t){var e,i;return(e=this._isRequiredKeyPressed(t,"pan"))&&(i=this.getMousePosition(t),this.initMoveOrigin(i[0],i[1])),e},mouseOriginMove:function(t){var e,i=this.mode===this.BOARD_MODE_MOVE_ORIGIN;return i&&(e=this.getMousePosition(t),this.moveOrigin(e[0],e[1],!0)),i},touchStartMoveOriginOneFinger:function(e){var i,s,r=e[t.Z.touchProperty];return(i=this.attr.pan.enabled&&!this.attr.pan.needtwofingers&&1===r.length)&&(s=this.getMousePosition(e,0),this.initMoveOrigin(s[0],s[1])),i},touchOriginMove:function(t){var e,i=this.mode===this.BOARD_MODE_MOVE_ORIGIN;return i&&(e=this.getMousePosition(t,0),this.moveOrigin(e[0],e[1],!0)),i},originMoveEnd:function(){this.updateQuality=this.BOARD_QUALITY_HIGH,this.mode=this.BOARD_MODE_NONE},addEventHandlers:function(){if(e.Z.supportsPointerEvents()?this.addPointerEventHandlers():(this.addMouseEventHandlers(),this.addTouchEventHandlers()),null!==this.containerObj&&(this.containerObj.oncontextmenu=function(t){return s.Z.exists(t)&&t.preventDefault(),!1}),this.addFullscreenEventHandlers(),this.addKeyboardEventHandlers(),e.Z.isBrowser){try{this.startResizeObserver()}catch(t){e.Z.addEvent(window,"resize",this.resizeListener,this),this.startIntersectionObserver()}e.Z.addEvent(window,"scroll",this.scrollListener,this)}},removeEventHandlers:function(){this.removeMouseEventHandlers(),this.removeTouchEventHandlers(),this.removePointerEventHandlers(),this.removeFullscreenEventHandlers(),this.removeKeyboardEventHandlers(),e.Z.isBrowser&&(s.Z.exists(this.resizeObserver)?this.stopResizeObserver():(e.Z.removeEvent(window,"resize",this.resizeListener,this),this.stopIntersectionObserver()),e.Z.removeEvent(window,"scroll",this.scrollListener,this))},addPointerEventHandlers:function(){if(!this.hasPointerHandlers&&e.Z.isBrowser){var t=this.attr.movetarget||this.containerObj;window.navigator.msPointerEnabled?(e.Z.addEvent(this.containerObj,"MSPointerDown",this.pointerDownListener,this),e.Z.addEvent(t,"MSPointerMove",this.pointerMoveListener,this)):(e.Z.addEvent(this.containerObj,"pointerdown",this.pointerDownListener,this),e.Z.addEvent(t,"pointermove",this.pointerMoveListener,this)),e.Z.addEvent(this.containerObj,"mousewheel",this.mouseWheelListener,this),e.Z.addEvent(this.containerObj,"DOMMouseScroll",this.mouseWheelListener,this),null!==this.containerObj&&(this.containerObj.style.touchAction="none"),this.hasPointerHandlers=!0}},addMouseEventHandlers:function(){if(!this.hasMouseHandlers&&e.Z.isBrowser){var t=this.attr.movetarget||this.containerObj;e.Z.addEvent(this.containerObj,"mousedown",this.mouseDownListener,this),e.Z.addEvent(t,"mousemove",this.mouseMoveListener,this),e.Z.addEvent(this.containerObj,"mousewheel",this.mouseWheelListener,this),e.Z.addEvent(this.containerObj,"DOMMouseScroll",this.mouseWheelListener,this),this.hasMouseHandlers=!0}},addTouchEventHandlers:function(t){if(!this.hasTouchHandlers&&e.Z.isBrowser){var i=this.attr.movetarget||this.containerObj;e.Z.addEvent(this.containerObj,"touchstart",this.touchStartListener,this),e.Z.addEvent(i,"touchmove",this.touchMoveListener,this),this.hasTouchHandlers=!0}},addFullscreenEventHandlers:function(){var t,i=["fullscreenchange","mozfullscreenchange","webkitfullscreenchange","msfullscreenchange"],s=i.length;if(!this.hasFullsceenEventHandlers&&e.Z.isBrowser){for(t=0;t<s;t++)e.Z.addEvent(this.document,i[t],this.fullscreenListener,this);this.hasFullsceenEventHandlers=!0}},addKeyboardEventHandlers:function(){this.attr.keyboard.enabled&&!this.hasKeyboardHandlers&&e.Z.isBrowser&&(e.Z.addEvent(this.containerObj,"keydown",this.keyDownListener,this),e.Z.addEvent(this.containerObj,"focusin",this.keyFocusInListener,this),e.Z.addEvent(this.containerObj,"focusout",this.keyFocusOutListener,this),this.hasKeyboardHandlers=!0)},removeKeyboardEventHandlers:function(){this.hasKeyboardHandlers&&e.Z.isBrowser&&(e.Z.removeEvent(this.containerObj,"keydown",this.keyDownListener,this),e.Z.removeEvent(this.containerObj,"focusin",this.keyFocusInListener,this),e.Z.removeEvent(this.containerObj,"focusout",this.keyFocusOutListener,this),this.hasKeyboardHandlers=!1)},removeFullscreenEventHandlers:function(){var t,i=["fullscreenchange","mozfullscreenchange","webkitfullscreenchange","msfullscreenchange"],s=i.length;if(this.hasFullsceenEventHandlers&&e.Z.isBrowser){for(t=0;t<s;t++)e.Z.removeEvent(this.document,i[t],this.fullscreenListener,this);this.hasFullsceenEventHandlers=!1}},removePointerEventHandlers:function(){if(this.hasPointerHandlers&&e.Z.isBrowser){var t=this.attr.movetarget||this.containerObj;window.navigator.msPointerEnabled?(e.Z.removeEvent(this.containerObj,"MSPointerDown",this.pointerDownListener,this),e.Z.removeEvent(t,"MSPointerMove",this.pointerMoveListener,this)):(e.Z.removeEvent(this.containerObj,"pointerdown",this.pointerDownListener,this),e.Z.removeEvent(t,"pointermove",this.pointerMoveListener,this)),e.Z.removeEvent(this.containerObj,"mousewheel",this.mouseWheelListener,this),e.Z.removeEvent(this.containerObj,"DOMMouseScroll",this.mouseWheelListener,this),this.hasPointerUp&&(window.navigator.msPointerEnabled?e.Z.removeEvent(this.document,"MSPointerUp",this.pointerUpListener,this):(e.Z.removeEvent(this.document,"pointerup",this.pointerUpListener,this),e.Z.removeEvent(this.document,"pointercancel",this.pointerUpListener,this)),this.hasPointerUp=!1),this.hasPointerHandlers=!1}},removeMouseEventHandlers:function(){if(this.hasMouseHandlers&&e.Z.isBrowser){var t=this.attr.movetarget||this.containerObj;e.Z.removeEvent(this.containerObj,"mousedown",this.mouseDownListener,this),e.Z.removeEvent(t,"mousemove",this.mouseMoveListener,this),this.hasMouseUp&&(e.Z.removeEvent(this.document,"mouseup",this.mouseUpListener,this),this.hasMouseUp=!1),e.Z.removeEvent(this.containerObj,"mousewheel",this.mouseWheelListener,this),e.Z.removeEvent(this.containerObj,"DOMMouseScroll",this.mouseWheelListener,this),this.hasMouseHandlers=!1}},removeTouchEventHandlers:function(){if(this.hasTouchHandlers&&e.Z.isBrowser){var t=this.attr.movetarget||this.containerObj;e.Z.removeEvent(this.containerObj,"touchstart",this.touchStartListener,this),e.Z.removeEvent(t,"touchmove",this.touchMoveListener,this),this.hasTouchEnd&&(e.Z.removeEvent(this.document,"touchend",this.touchEndListener,this),this.hasTouchEnd=!1),this.hasTouchHandlers=!1}},clickLeftArrow:function(){return this.moveOrigin(this.origin.scrCoords[1]+.1*this.canvasWidth,this.origin.scrCoords[2]),this},clickRightArrow:function(){return this.moveOrigin(this.origin.scrCoords[1]-.1*this.canvasWidth,this.origin.scrCoords[2]),this},clickUpArrow:function(){return this.moveOrigin(this.origin.scrCoords[1],this.origin.scrCoords[2]-.1*this.canvasHeight),this},clickDownArrow:function(){return this.moveOrigin(this.origin.scrCoords[1],this.origin.scrCoords[2]+.1*this.canvasHeight),this},gestureChangeListener:function(t){var e,r,o,n,a,h,l,d,p,_,f,b,g=!1,m=this.attr.zoom.factorx,v=this.attr.zoom.factory;return this.mode!==this.BOARD_MODE_ZOOM||(t.preventDefault(),h=u.Z.distance([t.touches[0].clientX,t.touches[0].clientY],[t.touches[1].clientX,t.touches[1].clientY],2),void 0===t.scale&&(t.scale=h/this.prevDist),!!s.Z.exists(this.prevCoords)&&(r=[t.touches[0].clientX-this.prevCoords[0][0],t.touches[0].clientY-this.prevCoords[0][1]],o=[t.touches[1].clientX-this.prevCoords[1][0],t.touches[1].clientY-this.prevCoords[1][1]],r[0]*r[0]+r[1]*r[1]<100&&o[0]*o[0]+o[1]*o[1]<100||(n=u.Z.rad(r,[0,0],o),"pan"!==this.isPreviousGesture&&Math.abs(n)>.2*Math.PI&&Math.abs(n)<1.8*Math.PI&&(g=!0),"pan"===this.isPreviousGesture||g||(Math.abs(t.scale)<.77||Math.abs(t.scale)>1.3)&&(g=!0),a=t.scale/this.prevScale,this.prevScale=t.scale,this.prevCoords=[[t.touches[0].clientX,t.touches[0].clientY],[t.touches[1].clientX,t.touches[1].clientY]],e=new c.Z(i.Z.COORDS_BY_SCREEN,this.getMousePosition(t,0),this),this.attr.pan.enabled&&this.attr.pan.needtwofingers&&!g?(this.isPreviousGesture="pan",this.moveOrigin(e.scrCoords[1],e.scrCoords[2],!0)):this.attr.zoom.enabled&&Math.abs(a-1)<.5&&((this.attr.zoom.pinchhorizontal||this.attr.zoom.pinchvertical)&&(l=Math.abs(t.touches[0].clientX-t.touches[1].clientX),d=Math.abs(t.touches[0].clientY-t.touches[1].clientY),p=Math.abs(Math.atan2(d,l)),b=Math.PI*this.attr.zoom.pinchsensitivity/90),this.attr.zoom.pinchhorizontal&&p<b?(this.attr.zoom.factorx=a,this.attr.zoom.factory=1,_=0,f=0):this.attr.zoom.pinchvertical&&Math.abs(p-.5*Math.PI)<b?(this.attr.zoom.factorx=1,this.attr.zoom.factory=a,_=0,f=0):(this.attr.zoom.factorx=a,this.attr.zoom.factory=a,_=e.usrCoords[1],f=e.usrCoords[2]),this.zoomIn(_,f),this.attr.zoom.factorx=m,this.attr.zoom.factory=v)),!1))},gestureStartListener:function(t){var e;return t.preventDefault(),this.prevScale=1,this.prevDist=u.Z.distance([t.touches[0].clientX,t.touches[0].clientY],[t.touches[1].clientX,t.touches[1].clientY],2),this.prevCoords=[[t.touches[0].clientX,t.touches[0].clientY],[t.touches[1].clientX,t.touches[1].clientY]],this.isPreviousGesture="none",e=this.getMousePosition(t,0),this.initMoveOrigin(e[0],e[1]),this.mode=this.BOARD_MODE_ZOOM,!1},_isRequiredKeyPressed:function(t,e){var i=this.attr[e];return!!i.enabled&&!(!(i.needshift&&t.shiftKey||!i.needshift&&!t.shiftKey)||!(i.needctrl&&t.ctrlKey||!i.needctrl&&!t.ctrlKey))},_isPointerRegistered:function(t){var e,i=this._board_touches.length;for(e=0;e<i;e++)if(this._board_touches[e].pointerId===t.pointerId)return!0;return!1},_pointerStorePosition:function(t){var e,i;for(e=0,i=!1;e<this._board_touches.length;e++)if(this._board_touches[e].pointerId===t.pointerId){this._board_touches[e].clientX=t.clientX,this._board_touches[e].clientY=t.clientY,i=!0;break}return!i&&this._board_touches.length<2&&this._board_touches.push({pointerId:t.pointerId,clientX:t.clientX,clientY:t.clientY}),this},_pointerRemoveTouches:function(t){var e;for(e=0;e<this._board_touches.length;e++)if(this._board_touches[e].pointerId===t.pointerId){this._board_touches.splice(e,1);break}return this},_pointerClearTouches:function(){this._board_touches.length>0&&this.dehighlightAll(),this.updateQuality=this.BOARD_QUALITY_HIGH,this.mode=this.BOARD_MODE_NONE,this._board_touches=[],this.touches=[]},_getPointerInputDevice:function(t){if(e.Z.isBrowser){if("touch"===t.pointerType||window.navigator.msMaxTouchPoints&&window.navigator.msMaxTouchPoints>1)return"touch";if("mouse"===t.pointerType)return"mouse";if("pen"===t.pointerType)return"pen"}return"mouse"},pointerDownListener:function(t,i){var r,o,n,a,h,l,c,d,u,p,_;if(!i&&this._isPointerRegistered(t))return!1;if(!i&&t.isPrimary&&this._pointerClearTouches(),this.hasPointerUp||(window.navigator.msPointerEnabled?e.Z.addEvent(this.document,"MSPointerUp",this.pointerUpListener,this):(e.Z.addEvent(this.document,"pointerup",this.pointerUpListener,this),e.Z.addEvent(this.document,"pointercancel",this.pointerUpListener,this)),this.hasPointerUp=!0),this.hasMouseHandlers&&this.removeMouseEventHandlers(),this.hasTouchHandlers&&this.removeTouchEventHandlers(),this.document.selection&&s.Z.isFunction(this.document.selection.empty))this.document.selection.empty();else if(window.getSelection&&(l=window.getSelection()).removeAllRanges)try{l.removeAllRanges()}catch(t){}if(this._inputDevice=this._getPointerInputDevice(t),d=this._inputDevice,this.options.precision.hasPoint=this.options.precision[d],a=this.getMousePosition(t),this._testForSelection(t),this.selectingMode)return this._startSelecting(a),void this.triggerEventHandlers(["touchstartselecting","pointerstartselecting","startselecting"],[t]);if(this.attr.drag.enabled&&i?(h=[i],this.mode=this.BOARD_MODE_DRAG):h=this.initMoveObject(a[0],a[1],t,d),c={num:t.pointerId,X:a[0],Y:a[1],Xprev:NaN,Yprev:NaN,Xstart:[],Ystart:[],Zstart:[]},h.length>0){for(p=h[h.length-1],u=!1,r=0;r<this.touches.length;r++)if(this.touches[r].obj===p){o=r,n=this.touches[r].targets.push(c)-1,u=!0;break}u||(n=0,o=this.touches.push({obj:p,targets:[c]})-1),this.dehighlightAll(),p.highlight(!0),this.saveStartPos(p,this.touches[o].targets[n]),t&&t.preventDefault?t.preventDefault():window.event&&(window.event.returnValue=!1)}return this.touches.length>0&&(t.preventDefault(),t.stopPropagation()),!!e.Z.isBrowser&&("touch"!==this._getPointerInputDevice(t)?this.mode===this.BOARD_MODE_NONE&&this.mouseOriginMoveStart(t):(this._pointerStorePosition(t),t.touches=this._board_touches,1===t.touches.length&&this.mode===this.BOARD_MODE_NONE&&this.touchStartMoveOriginOneFinger(t)||2!==t.touches.length||this.mode!==this.BOARD_MODE_NONE&&this.mode!==this.BOARD_MODE_MOVE_ORIGIN||(this.mode===this.BOARD_MODE_MOVE_ORIGIN&&this.originMoveEnd(),this.gestureStartListener(t))),_="none",this.mode!==this.BOARD_MODE_NONE||!s.Z.evaluate(this.attr.browserpan)||s.Z.evaluate(this.attr.pan.enabled)&&!s.Z.evaluate(this.attr.pan.needtwofingers)||(_="pan-x pan-y"),this.containerObj.style.touchAction=_,this.triggerEventHandlers(["touchstart","down","pointerdown","MSPointerDown"],[t]),!0)},pointerMoveListener:function(t){var e,i,s,r,o;if("touch"===this._getPointerInputDevice(t)&&!this._isPointerRegistered(t))return this.BOARD_MODE_NONE;if(!this.checkFrameRate(t))return!1;if(this.mode!==this.BOARD_MODE_DRAG&&(this.dehighlightAll(),this.displayInfobox(!1)),this.mode!==this.BOARD_MODE_NONE&&(t.preventDefault(),t.stopPropagation()),this.updateQuality=this.BOARD_QUALITY_LOW,this._inputDevice=this._getPointerInputDevice(t),o=this._inputDevice,this.options.precision.hasPoint=this.options.precision[o],this.selectingMode)s=this.getMousePosition(t),this._moveSelecting(s),this.triggerEventHandlers(["touchmoveselecting","moveselecting","pointermoveselecting"],[t,this.mode]);else if(!this.mouseOriginMove(t))if(this.mode===this.BOARD_MODE_DRAG){for(e=0;e<this.touches.length;e++)for(r=this.touches[e].targets,i=0;i<r.length;i++)if(r[i].num===t.pointerId){s=this.getMousePosition(t),r[i].X=s[0],r[i].Y=s[1],1===r.length?this.moveObject(s[0],s[1],this.touches[e],t,o):2===r.length&&(this.twoFingerMove(this.touches[e],t.pointerId,t),r[i].Xprev=s[0],r[i].Yprev=s[1]);break}}else"touch"===this._getPointerInputDevice(t)&&(this._pointerStorePosition(t),2===this._board_touches.length&&(t.touches=this._board_touches,this.gestureChangeListener(t))),s=this.getMousePosition(t),this.highlightElements(s[0],s[1],t,-1);return this.triggerEventHandlers(["pointermove","MSPointerMove","move"],[t,this.mode]),this.updateQuality=this.BOARD_QUALITY_HIGH,this.mode===this.BOARD_MODE_NONE},pointerUpListener:function(t){var i,r,o,n,a=!1;if(this.triggerEventHandlers(["touchend","up","pointerup","MSPointerUp"],[t]),this.displayInfobox(!1),t)for(i=0;i<this.touches.length;i++)for(n=this.touches[i].targets,r=0;r<n.length;r++)if(n[r].num===t.pointerId){n.splice(r,1),0===n.length&&this.touches.splice(i,1);break}if(this.originMoveEnd(),this.update(),this.selectingMode)this._stopSelecting(t),this.triggerEventHandlers(["touchstopselecting","pointerstopselecting","stopselecting"],[t]),this.stopSelectionMode();else for(i=this.downObjects.length-1;i>-1;i--){for(o=!1,r=0;r<this.touches.length;r++)this.touches[r].obj.id===this.downObjects[i].id&&(o=!0);o||(this.downObjects[i].triggerEventHandlers(["touchend","up","pointerup","MSPointerUp"],[t]),s.Z.exists(this.downObjects[i].coords)||(this.downObjects[i].snapToGrid(),this.downObjects[i].snapToPoints(),a=!0),this.downObjects.splice(i,1))}return this.hasPointerUp&&(window.navigator.msPointerEnabled?e.Z.removeEvent(this.document,"MSPointerUp",this.pointerUpListener,this):(e.Z.removeEvent(this.document,"pointerup",this.pointerUpListener,this),e.Z.removeEvent(this.document,"pointercancel",this.pointerUpListener,this)),this.hasPointerUp=!1),a&&this.update(),this._pointerClearTouches(),!0},touchStartListener:function(r){var o,n,a,h,l,c,d,u,p,_,f=this.options.precision.touch,b=r[t.Z.touchProperty];for(this.hasTouchEnd||(e.Z.addEvent(this.document,"touchend",this.touchEndListener,this),this.hasTouchEnd=!0),this.document.selection&&s.Z.isFunction(this.document.selection.empty)?this.document.selection.empty():window.getSelection&&window.getSelection().removeAllRanges(),this._inputDevice="touch",this.options.precision.hasPoint=this.options.precision.touch,o=0;o<b.length;o++)b[o].jxg_isused=!1;for(o=0;o<this.touches.length;o++)for(_=this.touches[o].targets,h=0;h<_.length;h++){_[h].num=-1,f=this.options.precision.touch;do{for(l=0;l<b.length;l++)if(Math.abs(Math.pow(b[l].screenX-_[h].X,2)+Math.pow(b[l].screenY-_[h].Y,2))<f*f){_[h].num=l,_[h].X=b[l].screenX,_[h].Y=b[l].screenY,b[l].jxg_isused=!0;break}f*=2}while(-1===_[h].num&&f<this.options.precision.touchMax);-1===_[h].num&&(t.Z.debug("i couldn't find a targettouches for target no "+h+" on "+this.touches[o].obj.name+" ("+this.touches[o].obj.id+"). Removed the target."),t.Z.debug("eps = "+f+", touchMax = "+N.Z.precision.touchMax),_.splice(o,1))}for(o=0;o<b.length;o++)if(!b[o].jxg_isused){if(n=this.getMousePosition(r,o),this.selectingMode)return this._startSelecting(n),this.triggerEventHandlers(["touchstartselecting","startselecting"],[r]),r.preventDefault(),r.stopPropagation(),this.options.precision.hasPoint=this.options.precision.mouse,this.touches.length>0;if(0!==(a=this.initMoveObject(n[0],n[1],r,"touch")).length)if(c=a[a.length-1],p={num:o,X:b[o].screenX,Y:b[o].screenY,Xprev:NaN,Yprev:NaN,Xstart:[],Ystart:[],Zstart:[]},s.Z.isPoint(c)||c.elementClass===i.Z.OBJECT_CLASS_TEXT||c.type===i.Z.OBJECT_TYPE_TICKS||c.type===i.Z.OBJECT_TYPE_IMAGE)u=[p],this.saveStartPos(c,u[0]),this.touches.push({obj:c,targets:u}),c.highlight(!0);else if(c.elementClass===i.Z.OBJECT_CLASS_LINE||c.elementClass===i.Z.OBJECT_CLASS_CIRCLE||c.elementClass===i.Z.OBJECT_CLASS_CURVE||c.type===i.Z.OBJECT_TYPE_POLYGON){for(d=!1,h=0;h<this.touches.length;h++)c.id===this.touches[h].obj.id&&(d=!0,1===this.touches[h].targets.length&&(this.saveStartPos(c,p),this.touches[h].targets.push(p)),b[o].jxg_isused=!0);d||(u=[p],this.saveStartPos(c,u[0]),this.touches.push({obj:c,targets:u}),c.highlight(!0))}b[o].jxg_isused=!0}return this.touches.length>0&&(r.preventDefault(),r.stopPropagation()),1===b.length&&this.mode===this.BOARD_MODE_NONE&&this.touchStartMoveOriginOneFinger(r)||2!==b.length||this.mode!==this.BOARD_MODE_NONE&&this.mode!==this.BOARD_MODE_MOVE_ORIGIN||(this.mode===this.BOARD_MODE_MOVE_ORIGIN&&this.originMoveEnd(),this.gestureStartListener(r)),this.options.precision.hasPoint=this.options.precision.mouse,this.triggerEventHandlers(["touchstart","down"],[r]),!1},touchMoveListener:function(e){var i,s,r,o,n=e[t.Z.touchProperty];if(!this.checkFrameRate(e))return!1;if(this.mode!==this.BOARD_MODE_NONE&&(e.preventDefault(),e.stopPropagation()),this.mode!==this.BOARD_MODE_DRAG&&(this.dehighlightAll(),this.displayInfobox(!1)),this._inputDevice="touch",this.options.precision.hasPoint=this.options.precision.touch,this.updateQuality=this.BOARD_QUALITY_LOW,this.selectingMode){for(i=0;i<n.length;i++)if(!n[i].jxg_isused){s=this.getMousePosition(e,i),this._moveSelecting(s),this.triggerEventHandlers(["touchmoves","moveselecting"],[e,this.mode]);break}}else if(!this.touchOriginMove(e))if(this.mode===this.BOARD_MODE_DRAG){for(i=0;i<this.touches.length;i++)if(1===(o=this.touches[i].targets).length){if(n[o[0].num]){if((s=this.getMousePosition(e,o[0].num))[0]<0||s[0]>this.canvasWidth||s[1]<0||s[1]>this.canvasHeight)return;o[0].X=s[0],o[0].Y=s[1],this.moveObject(s[0],s[1],this.touches[i],e,"touch")}}else if(2===o.length&&o[0].num>-1&&o[1].num>-1&&n[o[0].num]&&n[o[1].num]){if(s=this.getMousePosition(e,o[0].num),r=this.getMousePosition(e,o[1].num),s[0]<0||s[0]>this.canvasWidth||s[1]<0||s[1]>this.canvasHeight||r[0]<0||r[0]>this.canvasWidth||r[1]<0||r[1]>this.canvasHeight)return;o[0].X=s[0],o[0].Y=s[1],o[1].X=r[0],o[1].Y=r[1],this.twoFingerMove(this.touches[i],o[0].num,e),this.twoFingerMove(this.touches[i],o[1].num),o[0].Xprev=s[0],o[0].Yprev=s[1],o[1].Xprev=r[0],o[1].Yprev=r[1]}}else 2===n.length&&this.gestureChangeListener(e),s=this.getMousePosition(e,0),this.highlightElements(s[0],s[1],e,-1);return this.mode!==this.BOARD_MODE_DRAG&&this.displayInfobox(!1),this.triggerEventHandlers(["touchmove","move"],[e,this.mode]),this.options.precision.hasPoint=this.options.precision.mouse,this.updateQuality=this.BOARD_QUALITY_HIGH,this.mode===this.BOARD_MODE_NONE},touchEndListener:function(r){var o,n,a,h,l,c,d=this.options.precision.touch,u=[],p=r&&r[t.Z.touchProperty],_=!1;if(this.triggerEventHandlers(["touchend","up"],[r]),this.displayInfobox(!1),this.selectingMode)this._stopSelecting(r),this.triggerEventHandlers(["touchstopselecting","stopselecting"],[r]),this.stopSelectionMode();else if(p&&p.length>0){for(o=0;o<this.touches.length;o++)u[o]=this.touches[o];for(this.touches.length=0,o=0;o<p.length;o++)p[o].jxg_isused=!1;for(o=0;o<u.length;o++){for(h=!1,l=0,c=u[o].targets,n=0;n<c.length;n++)for(c[n].found=!1,a=0;a<p.length;a++)if(Math.abs(Math.pow(p[a].screenX-c[n].X,2)+Math.pow(p[a].screenY-c[n].Y,2))<d*d){c[n].found=!0,c[n].num=a,c[n].X=p[a].screenX,c[n].Y=p[a].screenY,l+=1;break}if(s.Z.isPoint(u[o].obj)?h=c[0]&&c[0].found:u[o].obj.elementClass===i.Z.OBJECT_CLASS_LINE?h=c[0]&&c[0].found||c[1]&&c[1].found:u[o].obj.elementClass===i.Z.OBJECT_CLASS_CIRCLE&&(h=1===l||3===l),h)for(this.touches.push({obj:u[o].obj,targets:[]}),n=0;n<c.length;n++)c[n].found&&this.touches[this.touches.length-1].targets.push({num:c[n].num,X:c[n].screenX,Y:c[n].screenY,Xprev:NaN,Yprev:NaN,Xstart:c[n].Xstart,Ystart:c[n].Ystart,Zstart:c[n].Zstart});else u[o].obj.noHighlight()}}else this.touches.length=0;for(o=this.downObjects.length-1;o>-1;o--){for(h=!1,n=0;n<this.touches.length;n++)this.touches[n].obj.id===this.downObjects[o].id&&(h=!0);h||(this.downObjects[o].triggerEventHandlers(["touchup","up"],[r]),s.Z.exists(this.downObjects[o].coords)||(this.downObjects[o].snapToGrid(),this.downObjects[o].snapToPoints(),_=!0),this.downObjects.splice(o,1))}return p&&0!==p.length||(this.hasTouchEnd&&(e.Z.removeEvent(this.document,"touchend",this.touchEndListener,this),this.hasTouchEnd=!1),this.dehighlightAll(),this.updateQuality=this.BOARD_QUALITY_HIGH,this.originMoveEnd(),_&&this.update()),!0},mouseDownListener:function(t){var i,r,o;if(this.document.selection&&s.Z.isFunction(this.document.selection.empty)?this.document.selection.empty():window.getSelection&&window.getSelection().removeAllRanges(),!this.hasMouseUp)return e.Z.addEvent(this.document,"mouseup",this.mouseUpListener,this),this.hasMouseUp=!0,this._inputDevice="mouse",this.options.precision.hasPoint=this.options.precision.mouse,i=this.getMousePosition(t),this._testForSelection(t),this.selectingMode?(this._startSelecting(i),void this.triggerEventHandlers(["mousestartselecting","startselecting"],[t])):(0===(r=this.initMoveObject(i[0],i[1],t,"mouse")).length?(this.mode=this.BOARD_MODE_NONE,o=!0):(this.mouse={obj:null,targets:[{X:i[0],Y:i[1],Xprev:NaN,Yprev:NaN}]},this.mouse.obj=r[r.length-1],this.dehighlightAll(),this.mouse.obj.highlight(!0),this.mouse.targets[0].Xstart=[],this.mouse.targets[0].Ystart=[],this.mouse.targets[0].Zstart=[],this.saveStartPos(this.mouse.obj,this.mouse.targets[0]),t&&t.preventDefault?t.preventDefault():window.event&&(window.event.returnValue=!1)),this.mode===this.BOARD_MODE_NONE&&(o=this.mouseOriginMoveStart(t)),this.triggerEventHandlers(["mousedown","down"],[t]),o)},mouseMoveListener:function(t){var e;if(!this.checkFrameRate(t))return!1;e=this.getMousePosition(t),this.updateQuality=this.BOARD_QUALITY_LOW,this.mode!==this.BOARD_MODE_DRAG&&(this.dehighlightAll(),this.displayInfobox(!1)),this.selectingMode?(this._moveSelecting(e),this.triggerEventHandlers(["mousemoveselecting","moveselecting"],[t,this.mode])):this.mouseOriginMove(t)||(this.mode===this.BOARD_MODE_DRAG?this.moveObject(e[0],e[1],this.mouse,t,"mouse"):this.highlightElements(e[0],e[1],t,-1),this.triggerEventHandlers(["mousemove","move"],[t,this.mode])),this.updateQuality=this.BOARD_QUALITY_HIGH},mouseUpListener:function(t){var i;if(!1===this.selectingMode&&this.triggerEventHandlers(["mouseup","up"],[t]),this.updateQuality=this.BOARD_QUALITY_HIGH,this.mouse&&this.mouse.obj&&(s.Z.exists(this.mouse.obj.coords)||(this.mouse.obj.snapToGrid(this.mouse.targets[0]),this.mouse.obj.snapToPoints())),this.originMoveEnd(),this.dehighlightAll(),this.update(),this.selectingMode)this._stopSelecting(t),this.triggerEventHandlers(["mousestopselecting","stopselecting"],[t]),this.stopSelectionMode();else for(i=0;i<this.downObjects.length;i++)this.downObjects[i].triggerEventHandlers(["mouseup","up"],[t]);this.downObjects.length=0,this.hasMouseUp&&(e.Z.removeEvent(this.document,"mouseup",this.mouseUpListener,this),this.hasMouseUp=!1),this.mouse=null},mouseWheelListener:function(t){if(!this.attr.zoom.wheel||!this._isRequiredKeyPressed(t,"zoom"))return!0;var e=(t=t||window.event).detail?-t.detail:t.wheelDelta/40,s=new c.Z(i.Z.COORDS_BY_SCREEN,this.getMousePosition(t),this);return e>0?this.zoomIn(s.usrCoords[1],s.usrCoords[2]):this.zoomOut(s.usrCoords[1],s.usrCoords[2]),this.triggerEventHandlers(["mousewheel"],[t]),t.preventDefault(),!1},keyDownListener:function(e){var r,o,n,a,h,l,c=e.target.id,d=0,u=0,p=s.Z.evaluate(this.attr.keyboard.dx)/this.unitX,_=s.Z.evaluate(this.attr.keyboard.dy)/this.unitY,f=!1,b=!0;return!(!this.attr.keyboard.enabled||""===c)&&((!(a=this.containerObj.shadowRoot||document).activeElement||"INPUT"!==(o=a.activeElement).tagName&&"textarea"!==o.tagName)&&(r=c.replace(this.containerObj.id+"_",""),o=this.select(r),s.Z.exists(o.coords)&&(l=o.coords.usrCoords.slice(1)),s.Z.evaluate(this.attr.keyboard.panshift)&&e.shiftKey||s.Z.evaluate(this.attr.keyboard.panctrl)&&e.ctrlKey?(!0===s.Z.evaluate(this.attr.zoom.enabled)&&(f=!0),38===e.keyCode?this.clickUpArrow():40===e.keyCode?this.clickDownArrow():37===e.keyCode?this.clickLeftArrow():39===e.keyCode?this.clickRightArrow():f&&171===e.keyCode?this.zoomIn():f&&173===e.keyCode?this.zoomOut():f&&79===e.keyCode?this.zoom100():b=!1):(s.Z.exists(o.visProp)&&(s.Z.exists(o.visProp.snaptogrid)&&o.visProp.snaptogrid&&s.Z.evaluate(o.visProp.snapsizex)&&s.Z.evaluate(o.visProp.snapsizey)?(d=(n=o.getSnapSizes())[0],u=n[1],p=Math.max(d,p),_=Math.max(u,_)):s.Z.exists(o.visProp.attracttogrid)&&o.visProp.attracttogrid&&s.Z.evaluate(o.visProp.attractordistance)&&s.Z.evaluate(o.visProp.attractorunit)&&(u=d=1.1*s.Z.evaluate(o.visProp.attractordistance),"screen"===s.Z.evaluate(o.visProp.attractorunit)&&(d/=this.unitX,u/=this.unitX),p=Math.max(d,p),_=Math.max(u,_))),38===e.keyCode?h=[0,_]:40===e.keyCode?h=[0,-_]:37===e.keyCode?h=[-p,0]:39===e.keyCode?h=[p,0]:b=!1,h&&o.isDraggable&&o.visPropCalc.visible&&(this.geonextCompatibilityMode&&(s.Z.isPoint(o)||o.elementClass===i.Z.OBJECT_CLASS_TEXT)||!this.geonextCompatibilityMode)&&!s.Z.evaluate(o.visProp.fixed)&&(this.mode=this.BOARD_MODE_DRAG,s.Z.exists(o.coords)&&(h[0]+=l[0],h[1]+=l[1]),o.setPosition(t.Z.COORDS_BY_USER,h),s.Z.exists(o.coords)&&this.updateInfobox(o),this.triggerEventHandlers(["keymove","move"],[e,this.mode]),o.triggerEventHandlers(["keydrag","drag"],[e]),this.mode=this.BOARD_MODE_NONE)),this.update(),b&&s.Z.exists(e.preventDefault)&&e.preventDefault(),b))},keyFocusInListener:function(t){var e,i,r=t.target.id;if(!this.attr.keyboard.enabled||""===r)return!1;e=r.replace(this.containerObj.id+"_",""),i=this.select(e),s.Z.exists(i.highlight)&&(i.highlight(!0),i.triggerEventHandlers(["hit"],[t])),s.Z.exists(i.coords)&&this.updateInfobox(i)},keyFocusOutListener:function(t){if(!this.attr.keyboard.enabled)return!1;this.dehighlightAll(),this.displayInfobox(!1)},updateContainerDims:function(){var t,e,i,r,o,n;t=(i=this.containerObj.getBoundingClientRect()).width,e=i.height,window&&window.getComputedStyle&&(r=window.getComputedStyle(this.containerObj,null),o=parseFloat(r.getPropertyValue("border-left-width"))+parseFloat(r.getPropertyValue("border-right-width")),isNaN(o)||(t-=o),n=parseFloat(r.getPropertyValue("border-top-width"))+parseFloat(r.getPropertyValue("border-bottom-width")),isNaN(n)||(e-=n)),t<=0||e<=0||isNaN(t)||isNaN(e)||(isNaN(this.getBoundingBox()[0])&&this.setBoundingBox(this.attr.boundingbox,this.keepaspectratio,"keep"),s.Z.exists(this._prevDim)&&this._prevDim.w===t&&this._prevDim.h===e||(this.resizeContainer(t,e,!0),this._prevDim={w:t,h:e}))},startResizeObserver:function(){var t=this;e.Z.isBrowser&&this.attr.resize&&this.attr.resize.enabled&&(this.resizeObserver=new ResizeObserver((function(e){t._isResizing||(t._isResizing=!0,window.setTimeout((function(){try{t.updateContainerDims()}catch(e){t.stopResizeObserver()}finally{t._isResizing=!1}}),t.attr.resize.throttle))})),this.resizeObserver.observe(this.containerObj))},stopResizeObserver:function(){e.Z.isBrowser&&this.attr.resize&&this.attr.resize.enabled&&s.Z.exists(this.resizeObserver)&&this.resizeObserver.unobserve(this.containerObj)},resizeListener:function(){var t=this;e.Z.isBrowser&&this.attr.resize&&this.attr.resize.enabled&&(this._isScrolling||this._isResizing||(this._isResizing=!0,window.setTimeout((function(){t.updateContainerDims(),t._isResizing=!1}),this.attr.resize.throttle)))},scrollListener:function(t){var i=this;e.Z.isBrowser&&(this._isScrolling||(this._isScrolling=!0,window.setTimeout((function(){i._isScrolling=!1}),66)))},startIntersectionObserver:function(){var t=this;try{this.intersectionObserver=new IntersectionObserver((function(e){isNaN(t.getBoundingBox()[0])&&t.updateContainerDims()}),{root:null,rootMargin:"0px",threshold:.8}),this.intersectionObserver.observe(t.containerObj)}catch(t){console.log("JSXGraph: IntersectionObserver not available in this browser.")}},stopIntersectionObserver:function(){s.Z.exists(this.intersectionObserver)&&this.intersectionObserver.unobserve(this.containerObj)},initInfobox:function(){var t=s.Z.copyAttributes({},this.options,"infobox");return t.id=this.id+"_infobox",this.infobox=this.create("text",[0,0,"0,0"],t),this.infobox.dump=!1,this.displayInfobox(!1),this},updateInfobox:function(t){var e,i,r,o,n,a,h,l=s.Z.evaluate(t.visProp.showinfobox);return!s.Z.evaluate(this.attr.showinfobox)&&"inherit"===l||!l||s.Z.isPoint(t)&&(r=t.coords.usrCoords[1],o=t.coords.usrCoords[2],a=s.Z.evaluate(this.infobox.visProp.distancex),h=s.Z.evaluate(this.infobox.visProp.distancey),n=s.Z.evaluate(t.visProp.infoboxdigits),this.infobox.setCoords(r+a/this.unitX,o+h/this.unitY),"string"!=typeof t.infoboxText?("auto"===n?(e=s.Z.autoDigits(r),i=s.Z.autoDigits(o)):s.Z.isNumber(n)?(e=s.Z.toFixed(r,n),i=s.Z.toFixed(o,n)):(e=r,i=o),this.highlightInfobox(e,i,t)):this.highlightCustomInfobox(t.infoboxText,t),this.displayInfobox(!0)),this},displayInfobox:function(t){return this.infobox.hiddenByParent===t&&(this.infobox.hiddenByParent=!t,this.infobox.prepareUpdate().updateVisibility(t).updateRenderer()),this},showInfobox:function(t){return this.displayInfobox(t)},highlightInfobox:function(t,e,i){return this.highlightCustomInfobox("("+t+", "+e+")",i),this},highlightCustomInfobox:function(t,e){return this.infobox.setText(t),this},dehighlightAll:function(){var t,e,i=!1;for(t in this.highlightedObjects)this.highlightedObjects.hasOwnProperty(t)&&(e=this.highlightedObjects[t],(this.hasMouseHandlers||this.hasPointerHandlers)&&e.noHighlight(),i=!0);return this.highlightedObjects={},"canvas"===this.renderer.type&&i&&(this.prepareUpdate(),this.renderer.suspendRedraw(this),this.updateRenderer(),this.renderer.unsuspendRedraw()),this},getScrCoordsOfMouse:function(t,e){return[t,e]},getUsrCoordsOfMouse:function(t){var s=this.getCoordsTopLeftCorner(),r=e.Z.getPosition(t,null,this.document),o=r[0]-s[0],n=r[1]-s[1];return new c.Z(i.Z.COORDS_BY_SCREEN,[o,n],this).usrCoords.slice(1)},getAllUnderMouse:function(t){var e=this.getAllObjectsUnderMouse(t);return e.push(this.getUsrCoordsOfMouse(t)),e},getAllObjectsUnderMouse:function(t){var i,s,r=this.getCoordsTopLeftCorner(),o=e.Z.getPosition(t,null,this.document),n=o[0]-r[0],a=o[1]-r[1],h=[],l=this.objectsList.length;for(i=0;i<l;i++)(s=this.objectsList[i]).visPropCalc.visible&&s.hasPoint&&s.hasPoint(n,a)&&(h[h.length]=s);return h},updateCoords:function(){var t,e,i=this.objectsList.length;for(e=0;e<i;e++)t=this.objectsList[e],s.Z.exists(t.coords)&&(s.Z.evaluate(t.visProp.frozen)?t.coords.screen2usr():t.coords.usr2screen());return this},moveOrigin:function(t,e,r){var o,n,a,h;return s.Z.exists(t)&&s.Z.exists(e)&&(o=this.origin.scrCoords[1],n=this.origin.scrCoords[2],this.origin.scrCoords[1]=t,this.origin.scrCoords[2]=e,r&&(this.origin.scrCoords[1]-=this.drag_dx,this.origin.scrCoords[2]-=this.drag_dy),a=new c.Z(i.Z.COORDS_BY_SCREEN,[0,0],this).usrCoords,h=new c.Z(i.Z.COORDS_BY_SCREEN,[this.canvasWidth,this.canvasHeight],this).usrCoords,(a[1]<this.maxboundingbox[0]||a[2]>this.maxboundingbox[1]||h[1]>this.maxboundingbox[2]||h[2]<this.maxboundingbox[3])&&(this.origin.scrCoords[1]=o,this.origin.scrCoords[2]=n)),this.updateCoords().clearTraces().fullUpdate(),this.triggerEventHandlers(["boundingbox"]),this},addConditions:function(e){var r,o,n,a,h,l,c,d=[],u=e.indexOf("<data>"),p=e.indexOf("</data>"),_=function(t,e,s,r){return function(){var o,n;n=(o=t.select(e.id)).coords.usrCoords[r],2===r?o.setPositionDirectly(i.Z.COORDS_BY_USER,[s(),n]):o.setPositionDirectly(i.Z.COORDS_BY_USER,[n,s()]),o.prepareUpdate().update()}},f=function(t,e,i){return function(){var s,r;s=t.select(e.id),r=i(),s.setAttribute({visible:r})}},b=function(t,e,i,s){return function(){var r,o;r=t.select(e.id),o=i(),"strokewidth"===s?r.visProp.strokewidth=o:(o=L.Z.rgba2rgbo(o),r.visProp[s+"color"]=o[0],r.visProp[s+"opacity"]=o[1])}},g=function(t,e,i){return function(){t.select(e.id).position=i()}},m=function(t,e,i){return function(){t.select(e.id).setStyle(i())}};if(!(u<0)){for(;u>=0;){if(o=(r=e.slice(u+6,p)).indexOf("="),n=r.slice(0,o),a=r.slice(o+1),o=n.indexOf("."),h=n.slice(0,o),l=this.elementsByName[s.Z.unescapeHTML(h)],c=n.slice(o+1).replace(/\s+/g,"").toLowerCase(),a=s.Z.createFunction(a,this,"",!0),s.Z.exists(this.elementsByName[h]))switch(c){case"x":d.push(_(this,l,a,2));break;case"y":d.push(_(this,l,a,1));break;case"visible":d.push(f(this,l,a));break;case"position":d.push(g(this,l,a));break;case"stroke":d.push(b(this,l,a,"stroke"));break;case"style":d.push(m(this,l,a));break;case"strokewidth":d.push(b(this,l,a,"strokewidth"));break;case"fill":d.push(b(this,l,a,"fill"));break;case"label":break;default:t.Z.debug("property '"+c+"' in conditions not yet implemented:"+a)}else t.Z.debug("debug conditions: |"+h+"| undefined");u=(e=e.slice(p+7)).indexOf("<data>"),p=e.indexOf("</data>")}this.updateConditions=function(){var t;for(t=0;t<d.length;t++)d[t]();return this.prepareUpdate().updateElements(),!0},this.updateConditions()}},updateConditions:function(){return!1},calculateSnapSizes:function(){var t=new c.Z(i.Z.COORDS_BY_USER,[0,0],this),e=new c.Z(i.Z.COORDS_BY_USER,[this.options.grid.gridX,this.options.grid.gridY],this),s=t.scrCoords[1]-e.scrCoords[1],r=t.scrCoords[2]-e.scrCoords[2];for(this.options.grid.snapSizeX=this.options.grid.gridX;Math.abs(s)>25;)this.options.grid.snapSizeX*=2,s/=2;for(this.options.grid.snapSizeY=this.options.grid.gridY;Math.abs(r)>25;)this.options.grid.snapSizeY*=2,r/=2;return this},applyZoom:function(){return this.updateCoords().calculateSnapSizes().clearTraces().fullUpdate(),this},zoomIn:function(t,e){var i=this.getBoundingBox(),r=this.attr.zoom.factorx,o=this.attr.zoom.factory,n=(i[2]-i[0])*(1-1/r),a=(i[1]-i[3])*(1-1/o),h=.5,l=.5,c=this.attr.zoom.eps||this.attr.zoom.min||.001;return this.zoomX>this.attr.zoom.max&&r>1||this.zoomY>this.attr.zoom.max&&o>1||this.zoomX<c&&r<1||this.zoomY<c&&o<1?this:(s.Z.isNumber(t)&&s.Z.isNumber(e)&&(h=(t-i[0])/(i[2]-i[0]),l=(i[1]-e)/(i[1]-i[3])),this.setBoundingBox([i[0]+n*h,i[1]-a*l,i[2]-n*(1-h),i[3]+a*(1-l)],this.keepaspectratio,"update"),this.applyZoom())},zoomOut:function(t,e){var i=this.getBoundingBox(),r=this.attr.zoom.factorx,o=this.attr.zoom.factory,n=(i[2]-i[0])*(1-r),a=(i[1]-i[3])*(1-o),h=.5,l=.5,c=this.attr.zoom.eps||this.attr.zoom.min||.001;return this.zoomX<c||this.zoomY<c?this:(s.Z.isNumber(t)&&s.Z.isNumber(e)&&(h=(t-i[0])/(i[2]-i[0]),l=(i[1]-e)/(i[1]-i[3])),this.setBoundingBox([i[0]+n*h,i[1]-a*l,i[2]-n*(1-h),i[3]+a*(1-l)],this.keepaspectratio,"update"),this.applyZoom())},zoom100:function(){var t,e,i;return s.Z.exists(this.attr.boundingbox)?this.setBoundingBox(this.attr.boundingbox,this.keepaspectratio,"reset"):(e=((t=this.getBoundingBox())[2]-t[0])*(1-this.zoomX)*.5,i=(t[1]-t[3])*(1-this.zoomY)*.5,this.setBoundingBox([t[0]+e,t[1]-i,t[2]-e,t[3]+i],this.keepaspectratio,"reset")),this.applyZoom()},zoomAllPoints:function(){var t,e,i,r,o=0,n=0,a=0,h=0,l=this.objectsList.length;for(t=0;t<l;t++)r=this.objectsList[t],s.Z.isPoint(r)&&r.visPropCalc.visible&&(r.coords.usrCoords[1]<o?o=r.coords.usrCoords[1]:r.coords.usrCoords[1]>n&&(n=r.coords.usrCoords[1]),r.coords.usrCoords[2]>h?h=r.coords.usrCoords[2]:r.coords.usrCoords[2]<a&&(a=r.coords.usrCoords[2]));return 50,e=50/this.unitX,i=50/this.unitY,this.setBoundingBox([o-e,h+i,n+e,a-i],this.keepaspectratio,"update"),this.applyZoom()},zoomElements:function(t){var e,i,r,o,n,a,h,l=[1/0,-1/0,-1/0,1/0];if(!s.Z.isArray(t)||0===t.length)return this;for(e=0;e<t.length;e++)i=this.select(t[e]).bounds(),s.Z.isArray(i)&&(i[0]<l[0]&&(l[0]=i[0]),i[1]>l[1]&&(l[1]=i[1]),i[2]>l[2]&&(l[2]=i[2]),i[3]<l[3]&&(l[3]=i[3]));return s.Z.isArray(l)&&(r=.5*(l[0]+l[2]),o=.5*(l[1]+l[3]),n=1.5*(l[2]-l[0])*.5,a=1.5*(l[1]-l[3])*.5,h=Math.max(n,a),this.setBoundingBox([r-h,o+h,r+h,o-h],this.keepaspectratio,"update")),this},setZoom:function(t,e){var i=this.attr.zoom.factorx,s=this.attr.zoom.factory;return this.attr.zoom.factorx=t/this.zoomX,this.attr.zoom.factory=e/this.zoomY,this.zoomIn(),this.attr.zoom.factorx=i,this.attr.zoom.factory=s,this},removeObject:function(e,r){var o,n;if(s.Z.isArray(e)){for(n=0;n<e.length;n++)this.removeObject(e[n]);return this}if(e=this.select(e),!s.Z.exists(e)||s.Z.isString(e))return this;try{for(o in e.childElements)e.childElements.hasOwnProperty(o)&&e.childElements[o].board.removeObject(e.childElements[o]);for(o in e.objects)e.objects.hasOwnProperty(o)&&e.objects[o].board.removeObject(e.objects[o]);if(r)for(o in this.objects)this.objects.hasOwnProperty(o)&&s.Z.exists(this.objects[o].childElements)&&s.Z.exists(this.objects[o].childElements.hasOwnProperty(e.id))&&(delete this.objects[o].childElements[e.id],delete this.objects[o].descendants[e.id]);else if(s.Z.exists(e.ancestors))for(o in e.ancestors)e.ancestors.hasOwnProperty(o)&&s.Z.exists(e.ancestors[o].childElements)&&s.Z.exists(e.ancestors[o].childElements.hasOwnProperty(e.id))&&(delete e.ancestors[o].childElements[e.id],delete e.ancestors[o].descendants[e.id]);if(e._pos>-1)for(this.objectsList.splice(e._pos,1),o=e._pos;o<this.objectsList.length;o++)this.objectsList[o]._pos--;else e.type!==i.Z.OBJECT_TYPE_TURTLE&&t.Z.debug("Board.removeObject: object "+e.id+" not found in list.");delete this.objects[e.id],delete this.elementsByName[e.name],e.visProp&&s.Z.evaluate(e.visProp.trace)&&e.clearTrace(),s.Z.exists(e.remove)&&e.remove()}catch(i){t.Z.debug(e.id+": Could not be removed: "+i)}return this.update(),this},removeAncestors:function(t){var e;for(e in t.ancestors)t.ancestors.hasOwnProperty(e)&&this.removeAncestors(t.ancestors[e]);return this.removeObject(t),this},initGeonextBoard:function(){var t,e,i;return t=this.create("point",[0,0],{id:this.id+"g00e0",name:"Ursprung",withLabel:!1,visible:!1,fixed:!0}),e=this.create("point",[1,0],{id:this.id+"gX0e0",name:"Punkt_1_0",withLabel:!1,visible:!1,fixed:!0}),i=this.create("point",[0,1],{id:this.id+"gY0e0",name:"Punkt_0_1",withLabel:!1,visible:!1,fixed:!0}),this.create("line",[t,e],{id:this.id+"gXLe0",name:"X-Achse",withLabel:!1,visible:!1}),this.create("line",[t,i],{id:this.id+"gYLe0",name:"Y-Achse",withLabel:!1,visible:!1}),this},resizeContainer:function(t,e,i,s){var r,o,n,a,h;return o=this.canvasWidth,n=this.canvasHeight,s||(r=this.getBoundingBox()),this.canvasWidth=parseFloat(t),this.canvasHeight=parseFloat(e),i||(this.containerObj.style.width=this.canvasWidth+"px",this.containerObj.style.height=this.canvasHeight+"px"),this.renderer.resize(this.canvasWidth,this.canvasHeight),s?(a=(this.canvasWidth-o)/2,h=(this.canvasHeight-n)/2,this.moveOrigin(this.origin.scrCoords[1]+a,this.origin.scrCoords[2]+h)):this.setBoundingBox(r,this.keepaspectratio,"keep"),this},showDependencies:function(){var t,e,i,s,r;for(t in e="<p>\n",this.objects)if(this.objects.hasOwnProperty(t)){for(i in r=0,this.objects[t].childElements)this.objects[t].childElements.hasOwnProperty(i)&&(r+=1);for(i in r>=0&&(e+="<strong>"+this.objects[t].id+":</strong> "),this.objects[t].childElements)this.objects[t].childElements.hasOwnProperty(i)&&(e+=this.objects[t].childElements[i].id+"("+this.objects[t].childElements[i].name+"), ");e+="<p>\n"}return e+="</p>\n",(s=window.open()).document.open(),s.document.write(e),s.document.close(),this},showXML:function(){var t=window.open("");return t.document.open(),t.document.write("<pre>"+s.Z.escapeHTML(this.xmlString)+"</pre>"),t.document.close(),this},prepareUpdate:function(){var t,e,i=this.objectsList.length;for(t=0;t<i;t++)(e=this.objectsList[t]).needsUpdate=e.needsRegularUpdate||this.needsFullUpdate;for(t in this.groups)this.groups.hasOwnProperty(t)&&((e=this.groups[t]).needsUpdate=e.needsRegularUpdate||this.needsFullUpdate);return this},updateElements:function(t){var e,r;for(t=this.select(t),e=0;e<this.objectsList.length;e++)r=this.objectsList[e],this.needsFullUpdate&&r.elementClass===i.Z.OBJECT_CLASS_TEXT&&r.updateSize(),r.update(!s.Z.exists(t)||r.id!==t.id).updateVisibility();for(e in this.groups)this.groups.hasOwnProperty(e)&&this.groups[e].update(t);return this},updateRenderer:function(){var t,e=this.objectsList.length;if(this.renderer){if("canvas"===this.renderer.type)this.updateRendererCanvas();else for(t=0;t<e;t++)this.objectsList[t].updateRenderer();return this}},updateRendererCanvas:function(){var t,e,i,s,r,o=this.objectsList.length,n=this.options.layer,a=this.options.layer.numlayers,h=Number.NEGATIVE_INFINITY;for(i=0;i<a;i++){for(r in s=Number.POSITIVE_INFINITY,n)n.hasOwnProperty(r)&&n[r]>h&&n[r]<s&&(s=n[r]);for(h=s,t=0;t<o;t++)(e=this.objectsList[t]).visProp.layer===s&&e.prepareUpdate().updateRenderer()}return this},addHook:function(e,i,r){return t.Z.deprecated("Board.addHook()","Board.on()"),i=s.Z.def(i,"update"),r=s.Z.def(r,this),this.hooks.push([i,e]),this.on(i,e,r),this.hooks.length-1},addEvent:t.Z.shortcut(t.Z.Board.prototype,"on"),removeHook:function(e){return t.Z.deprecated("Board.removeHook()","Board.off()"),this.hooks[e]&&(this.off(this.hooks[e][0],this.hooks[e][1]),this.hooks[e]=null),this},removeEvent:t.Z.shortcut(t.Z.Board.prototype,"off"),updateHooks:function(e){var i=Array.prototype.slice.call(arguments,0);return t.Z.deprecated("Board.updateHooks()","Board.triggerEventHandlers()"),i[0]=s.Z.def(i[0],"update"),this.triggerEventHandlers([i[0]],arguments),this},addChild:function(t){return s.Z.exists(t)&&s.Z.exists(t.containerObj)&&(this.dependentBoards.push(t),this.update()),this},removeChild:function(t){var e;for(e=this.dependentBoards.length-1;e>=0;e--)this.dependentBoards[e]===t&&this.dependentBoards.splice(e,1);return this},update:function(t){var e,i,r,o,n;if(this.inUpdate||this.isSuspendedUpdate)return this;for(this.inUpdate=!0,"all"===this.attr.minimizereflow&&this.containerObj&&"vml"!==this.renderer.type&&(n=this.document.activeElement,o=this.renderer.removeToInsertLater(this.containerObj)),"svg"===this.attr.minimizereflow&&"svg"===this.renderer.type&&(n=this.document.activeElement,o=this.renderer.removeToInsertLater(this.renderer.svgRoot)),this.prepareUpdate().updateElements(t).updateConditions(),this.renderer.suspendRedraw(this),this.updateRenderer(),this.renderer.unsuspendRedraw(),this.triggerEventHandlers(["update"],[]),o&&(o(),n.focus()),i=this.dependentBoards.length,e=0;e<i;e++)r=this.dependentBoards[e],s.Z.exists(r)&&r!==this&&(r.updateQuality=this.updateQuality,r.prepareUpdate().updateElements().updateConditions(),r.renderer.suspendRedraw(),r.updateRenderer(),r.renderer.unsuspendRedraw(),r.triggerEventHandlers(["update"],[]));return this.inUpdate=!1,this},fullUpdate:function(){return this.needsFullUpdate=!0,this.update(),this.needsFullUpdate=!1,this},addGrid:function(){return this.create("grid",[]),this},removeGrids:function(){var t;for(t=0;t<this.grids.length;t++)this.removeObject(this.grids[t]);return this.grids.length=0,this.update(),this},create:function(e,i,r){var o,n;for(e=e.toLowerCase(),s.Z.exists(i)||(i=[]),s.Z.exists(r)||(r={}),n=0;n<i.length;n++)!s.Z.isString(i[n])||"text"===e&&2===n||"solidofrevolution3d"===e&&2===n||!("input"!==e&&"checkbox"!==e&&"button"!==e||2!==n&&3!==n)||"curve"===e&&n>0||(i[n]=this.select(i[n]));if(!s.Z.isFunction(t.Z.elements[e]))throw new Error("JSXGraph: create: Unknown element type given: "+e);return o=t.Z.elements[e](this,i,r),s.Z.exists(o)?(o.prepareUpdate&&o.update&&o.updateRenderer&&o.fullUpdate(),o):(t.Z.debug("JSXGraph: create: failure creating "+e),o)},createElement:function(){return t.Z.deprecated("Board.createElement()","Board.create()"),this.create.apply(this,arguments)},clearTraces:function(){var t;for(t=0;t<this.objectsList.length;t++)this.objectsList[t].clearTrace();return this.numTraces=0,this},suspendUpdate:function(){return this.inUpdate||(this.isSuspendedUpdate=!0),this},unsuspendUpdate:function(){return this.isSuspendedUpdate&&(this.isSuspendedUpdate=!1,this.fullUpdate()),this},setBoundingBox:function(t,i,r){var n,a,h,l,c,d,u,p,_,f=0,b=0,g=1,m=e.Z.getDimensions(this.container,this.document);return s.Z.isArray(t)?(t[0]<this.maxboundingbox[0]||t[1]>this.maxboundingbox[1]||t[2]>this.maxboundingbox[2]||t[3]<this.maxboundingbox[3]||(s.Z.exists(r)||(r="reset"),h=this.unitX,l=this.unitY,this.canvasWidth=parseFloat(m.width),this.canvasHeight=parseFloat(m.height),a=this.canvasWidth,n=this.canvasHeight,i?(c=h/l,"keep"===r&&(g=this.zoomX/this.zoomY),p=h*(d=t[2]-t[0]),_=l*(u=t[1]-t[3]),a>=n?p>=_?(this.unitY=n/u,this.unitX=this.unitY*c):(this.unitY=n/Math.abs(d)*o.Z.sign(u)/g,this.unitX=this.unitY*c):_>p?(this.unitX=a/d,this.unitY=this.unitX/c):(this.unitX=a/Math.abs(u)*o.Z.sign(d)*g,this.unitY=this.unitX/c),f=.5*(a/this.unitX-d),b=.5*(n/this.unitY-u),this.keepaspectratio=!0):(this.unitX=a/(t[2]-t[0]),this.unitY=n/(t[1]-t[3]),this.keepaspectratio=!1),this.moveOrigin(-this.unitX*(t[0]-f),this.unitY*(t[1]+b)),"update"===r?(this.zoomX*=this.unitX/h,this.zoomY*=this.unitY/l):"reset"===r&&(this.zoomX=s.Z.exists(this.attr.zoomx)?this.attr.zoomx:1,this.zoomY=s.Z.exists(this.attr.zoomy)?this.attr.zoomy:1)),this):this},getBoundingBox:function(){var t=new c.Z(i.Z.COORDS_BY_SCREEN,[0,0],this).usrCoords,e=new c.Z(i.Z.COORDS_BY_SCREEN,[this.canvasWidth,this.canvasHeight],this).usrCoords;return[t[1],t[2],e[1],e[2]]},addAnimation:function(t){var e=this;return this.animationObjects[t.id]=t,this.animationIntervalCode||(this.animationIntervalCode=window.setInterval((function(){e.animate()}),t.board.attr.animationdelay)),this},stopAllAnimation:function(){var t;for(t in this.animationObjects)this.animationObjects.hasOwnProperty(t)&&s.Z.exists(this.animationObjects[t])&&(this.animationObjects[t]=null,delete this.animationObjects[t]);return window.clearInterval(this.animationIntervalCode),delete this.animationIntervalCode,this},animate:function(){var t,e,r,o,n,a,h,l,c=0,d=null;for(e in this.animationObjects)if(this.animationObjects.hasOwnProperty(e)&&s.Z.exists(this.animationObjects[e])){if(c+=1,(r=this.animationObjects[e]).animationPath&&(o=s.Z.isFunction(r.animationPath)?r.animationPath((new Date).getTime()-r.animationStart):r.animationPath.pop(),!s.Z.exists(o)||!s.Z.isArray(o)&&isNaN(o)?delete r.animationPath:(r.setPositionDirectly(i.Z.COORDS_BY_USER,o),r.fullUpdate(),d=r)),r.animationData){for(n in h=0,r.animationData)r.animationData.hasOwnProperty(n)&&(a=r.animationData[n].pop(),s.Z.exists(a)?(h+=1,(t={})[n]=a,r.setAttribute(t)):delete r.animationData[a]);0===h&&delete r.animationData}s.Z.exists(r.animationData)||s.Z.exists(r.animationPath)||(this.animationObjects[e]=null,delete this.animationObjects[e],s.Z.exists(r.animationCallback)&&(l=r.animationCallback,r.animationCallback=null,l()))}return 0===c?(window.clearInterval(this.animationIntervalCode),delete this.animationIntervalCode):this.update(d),this},migratePoint:function(t,e,i){var r,o,n,a,h,l,c=!1;for(o in t=this.select(t),e=this.select(e),s.Z.exists(t.label)&&(l=t.label.id,c=!0,this.removeObject(t.label)),t.childElements)if(t.childElements.hasOwnProperty(o)){for(n in a=!1,r=t.childElements[o])r.hasOwnProperty(n)&&r[n]===t&&(r[n]=e,a=!0);for(a&&delete t.childElements[o],h=0;h<r.parents.length;h++)r.parents[h]===t.id&&(r.parents[h]=e.id);e.addChild(r)}return i&&(c&&(delete e.childElements[l],delete e.descendants[l]),e.label&&this.removeObject(e.label),delete this.elementsByName[e.name],e.name=t.name,c&&e.createLabel()),this.removeObject(t),s.Z.exists(e.name)&&""!==e.name&&(this.elementsByName[e.name]=e),this.fullUpdate(),this},emulateColorblindness:function(e){var i,r;if(s.Z.exists(e)||(e="none"),this.currentCBDef===e)return this;for(i in this.objects)this.objects.hasOwnProperty(i)&&(r=this.objects[i],"none"!==e?("none"===this.currentCBDef&&(r.visPropOriginal={strokecolor:r.visProp.strokecolor,fillcolor:r.visProp.fillcolor,highlightstrokecolor:r.visProp.highlightstrokecolor,highlightfillcolor:r.visProp.highlightfillcolor}),r.setAttribute({strokecolor:L.Z.rgb2cb(s.Z.evaluate(r.visPropOriginal.strokecolor),e),fillcolor:L.Z.rgb2cb(s.Z.evaluate(r.visPropOriginal.fillcolor),e),highlightstrokecolor:L.Z.rgb2cb(s.Z.evaluate(r.visPropOriginal.highlightstrokecolor),e),highlightfillcolor:L.Z.rgb2cb(s.Z.evaluate(r.visPropOriginal.highlightfillcolor),e)})):s.Z.exists(r.visPropOriginal)&&t.Z.extend(r.visProp,r.visPropOriginal));return this.currentCBDef=e,this.update(),this},select:function(t,e){var i,r,o,n,a=t;if(null===a)return a;if(s.Z.isString(a)&&""!==a)s.Z.exists(this.objects[a])?a=this.objects[a]:s.Z.exists(this.elementsByName[a])?a=this.elementsByName[a]:s.Z.exists(this.groups[a])&&(a=this.groups[a]);else if(!e&&(s.Z.isFunction(a)||s.Z.isObject(a)&&!s.Z.isFunction(a.setAttribute))){for(r={},n=(i=s.Z.filterElements(this.objectsList,a)).length,o=0;o<n;o++)r[i[o].id]=i[o];a=new B(r)}else s.Z.isObject(a)&&s.Z.exists(a.id)&&!s.Z.exists(this.objects[a.id])&&(a=null);return a},hasPoint:function(t,e){var i=t,r=e,o=this.getBoundingBox();return s.Z.exists(t)&&s.Z.isArray(t.usrCoords)&&(i=t.usrCoords[1],r=t.usrCoords[2]),!!(s.Z.isNumber(i)&&s.Z.isNumber(r)&&o[0]<i&&i<o[2]&&o[1]>r&&r>o[3])},updateCSSTransforms:function(){var t=this.containerObj,i=t,r=t;if(this.cssTransMat=e.Z.getCSSTransformMatrix(i),s.Z.exists(i.getRootNode)){for(i=i.parentNode===i.getRootNode()?i.parentNode.host:i.parentNode;i;)this.cssTransMat=o.Z.matMatMult(e.Z.getCSSTransformMatrix(i),this.cssTransMat),i=i.parentNode===i.getRootNode()?i.parentNode.host:i.parentNode;this.cssTransMat=o.Z.inverse(this.cssTransMat)}else{for(i=i.offsetParent;i;){for(this.cssTransMat=o.Z.matMatMult(e.Z.getCSSTransformMatrix(i),this.cssTransMat),r=r.parentNode;r!==i;)this.cssTransMat=o.Z.matMatMult(e.Z.getCSSTransformMatrix(i),this.cssTransMat),r=r.parentNode;i=i.offsetParent}this.cssTransMat=o.Z.inverse(this.cssTransMat)}return this},startSelectionMode:function(){this.selectingMode=!0,this.selectionPolygon.setAttribute({visible:!0}),this.selectingBox=[[0,0],[0,0]],this._setSelectionPolygonFromBox(),this.selectionPolygon.fullUpdate()},stopSelectionMode:function(){return this.selectingMode=!1,this.selectionPolygon.setAttribute({visible:!1}),[this.selectionPolygon.vertices[0].coords,this.selectionPolygon.vertices[2].coords]},_startSelecting:function(t){this.isSelecting=!0,this.selectingBox=[[t[0],t[1]],[t[0],t[1]]],this._setSelectionPolygonFromBox()},_moveSelecting:function(t){this.isSelecting&&(this.selectingBox[1]=[t[0],t[1]],this._setSelectionPolygonFromBox(),this.selectionPolygon.fullUpdate())},_stopSelecting:function(t){var e=this.getMousePosition(t);this.isSelecting=!1,this.selectingBox[1]=[e[0],e[1]],this._setSelectionPolygonFromBox()},_setSelectionPolygonFromBox:function(){var e=this.selectingBox[0],i=this.selectingBox[1];this.selectionPolygon.vertices[0].setPositionDirectly(t.Z.COORDS_BY_SCREEN,[e[0],e[1]]),this.selectionPolygon.vertices[1].setPositionDirectly(t.Z.COORDS_BY_SCREEN,[e[0],i[1]]),this.selectionPolygon.vertices[2].setPositionDirectly(t.Z.COORDS_BY_SCREEN,[i[0],i[1]]),this.selectionPolygon.vertices[3].setPositionDirectly(t.Z.COORDS_BY_SCREEN,[i[0],e[1]])},_testForSelection:function(t){this._isRequiredKeyPressed(t,"selection")&&(s.Z.exists(this.selectionPolygon)||this._createSelectionPolygon(this.attr),this.startSelectionMode())},_createSelectionPolygon:function(t){var e;return s.Z.exists(this.selectionPolygon)||!0===(e=s.Z.copyAttributes(t,N.Z,"board","selection")).enabled&&(this.selectionPolygon=this.create("polygon",[[0,0],[0,0],[0,0],[0,0]],e)),this},__evt__down:function(t){},__evt__mousedown:function(t){},__evt__pendown:function(t){},__evt__pointerdown:function(t){},__evt__touchstart:function(t){},__evt__up:function(t){},__evt__mouseup:function(t){},__evt__pointerup:function(t){},__evt__touchend:function(t){},__evt__move:function(t,e){},__evt__mousemove:function(t,e){},__evt__penmove:function(t,e){},__evt__pointermove:function(t,e){},__evt__touchmove:function(t,e){},__evt__keymove:function(t,e){},__evt__hit:function(t,e,i){},__evt__mousehit:function(t,e,i){},__evt__update:function(){},__evt__boundingbox:function(){},__evt__startselecting:function(){},__evt__mousestartselecting:function(){},__evt__pointerstartselecting:function(){},__evt__touchstartselecting:function(){},__evt__stopselecting:function(){},__evt__mousestopselecting:function(){},__evt__pointerstopselecting:function(){},__evt__touchstopselecting:function(){},__evt__moveselecting:function(){},__evt__mousemoveselecting:function(){},__evt__pointermoveselecting:function(){},__evt__touchmoveselecting:function(){},__evt:function(){},toFullscreen:function(t){var e,i,r,o=this.document;return t=t||this.container,this._fullscreen_inner_id=t,r=o.getElementById(t),e="fullscreenwrap_"+t,o.getElementById(e)?i=o.getElementById(e):((i=document.createElement("div")).classList.add("JXG_wrap_private"),i.setAttribute("id",e),r.parentNode.insertBefore(i,r),i.appendChild(r)),i.requestFullscreen=i.requestFullscreen||i.webkitRequestFullscreen||i.mozRequestFullScreen||i.msRequestFullscreen,null===(void 0!==o.fullscreenElement?o.fullscreenElement:void 0!==o.webkitFullscreenElement?o.webkitFullscreenElement:o.msFullscreenElement)?i.requestFullscreen&&i.requestFullscreen():s.Z.exists(document.exitFullscreen)?document.exitFullscreen():s.Z.exists(document.webkitExitFullscreen)&&document.webkitExitFullscreen(),this},fullscreenListener:function(t){var i,r,o,n=this.document;if(i=this._fullscreen_inner_id,s.Z.exists(i)){if(o=void 0!==n.fullscreenElement?n.fullscreenElement:void 0!==n.webkitFullscreenElement?n.webkitFullscreenElement:n.msFullscreenElement,r=n.getElementById(i),o)r._cssFullscreenStore={id:o.id,isFullscreen:!0,margin:r.style.margin},r.style.margin="",e.Z.scaleJSXGraphDiv(o.id,i,n,s.Z.evaluate(this.attr.fullscreen.scale)),o=null;else if(s.Z.exists(r._cssFullscreenStore)){try{n.styleSheets[n.styleSheets.length-1].deleteRule(0)}catch(t){console.log("JSXGraph: Could not remove CSS rules for full screen mode")}r._cssFullscreenStore.isFullscreen=!1,r.style.margin=r._cssFullscreenStore.margin}this.updateCSSTransforms()}},addLogEntry:function(t,e){var i,r=e.id,o=this.userLog.length-1;return s.Z.evaluate(this.attr.logging.enabled)&&(i=(new Date).getTime(),o>=0&&this.userLog[o].type===t&&this.userLog[o].id===r&&i-this.userLog[o].end<500?this.userLog[o].end=i:this.userLog.push({type:t,id:r,start:i,end:i})),this},createRoulette:function(t,e,i,s,r,o,n){var a=this;return new function(){var h,c=0,d=0,u=0,p=i,_=l.Z.root((function(i){var s=t.X(p),r=t.Y(p),o=e.X(i),n=e.Y(i);return(s-o)*(s-o)+(r-n)*(r-n)}),[0,2*Math.PI]),f=0,b=0,g=a.create("transform",[function(){return c}],{type:"rotate"}),m=a.create("transform",[function(){return c},function(){return t.X(p)},function(){return t.Y(p)}],{type:"rotate"}),v=a.create("transform",[function(){return d},function(){return u}],{type:"translate"}),Z=function(t,e,i){var s=l.Z.D(t.X)(e),r=l.Z.D(t.Y)(e),o=l.Z.D(t.X)(i),n=l.Z.D(t.Y)(i),a=l.Z.D(t.X)(.5*(e+i)),h=l.Z.D(t.Y)(.5*(e+i)),c=Math.sqrt(s*s+r*r),d=Math.sqrt(o*o+n*n);return(c+4*Math.sqrt(a*a+h*h)+d)*(i-e)/6},C=function(t){return h-Z(e,_,t)},y=Math.PI/18,P=9*y,E=null;return this.rolling=function(){var i,o,E,O,x;h=Z(t,p,f=p+r*s),b=l.Z.root(C,_),i=new M(t.X(f),t.Y(f)),o=new M(e.X(b),e.Y(b)),E=new M(l.Z.D(t.X)(f),l.Z.D(t.Y)(f)),O=new M(l.Z.D(e.X)(b),l.Z.D(e.Y)(b)),x=M.C.div(E,O),c=Math.atan2(x.imaginary,x.real),x.div(M.C.abs(x)),x.mult(o),d=i.real-x.real,u=i.imaginary-x.imaginary,c<-y&&c>-P?(c=-y,m.applyOnce(n)):c>y&&c<P?(c=y,m.applyOnce(n)):(g.applyOnce(n),v.applyOnce(n),p=f,_=b),a.update()},this.start=function(){return o>0&&(E=window.setInterval(this.rolling,o)),this},this.stop=function(){return window.clearInterval(E),this},this}}});const I=t.Z.Board;t.Z.SVGRenderer=function(t,e){var i;for(this.type="svg",this.isIE=-1!==navigator.appVersion.indexOf("MSIE")||navigator.userAgent.match(/Trident\//),this.svgRoot=null,this.svgNamespace="http://www.w3.org/2000/svg",this.xlinkNamespace="http://www.w3.org/1999/xlink",this.container=t,this.container.style.MozUserSelect="none",this.container.style.userSelect="none",this.container.style.overflow="hidden",""===this.container.style.position&&(this.container.style.position="relative"),this.svgRoot=this.container.ownerDocument.createElementNS(this.svgNamespace,"svg"),this.svgRoot.style.overflow="hidden",this.svgRoot.style.display="block",this.resize(e.width,e.height),this.container.appendChild(this.svgRoot),this.defs=this.container.ownerDocument.createElementNS(this.svgNamespace,"defs"),this.svgRoot.appendChild(this.defs),this.createShadowFilter=function(t,e,i,r,o,n){var a,h,l,c,d,u=this.container.ownerDocument.createElementNS(this.svgNamespace,"filter");return u.setAttributeNS(null,"id",t),u.setAttributeNS(null,"width","300%"),u.setAttributeNS(null,"height","300%"),u.setAttributeNS(null,"filterUnits","userSpaceOnUse"),(a=this.container.ownerDocument.createElementNS(this.svgNamespace,"feOffset")).setAttributeNS(null,"in","SourceGraphic"),a.setAttributeNS(null,"result","offOut"),a.setAttributeNS(null,"dx",n[0]),a.setAttributeNS(null,"dy",n[1]),u.appendChild(a),(h=this.container.ownerDocument.createElementNS(this.svgNamespace,"feColorMatrix")).setAttributeNS(null,"in","offOut"),h.setAttributeNS(null,"result","colorOut"),h.setAttributeNS(null,"type","matrix"),"none"===e||!s.Z.isArray(e)||e.length<3?h.setAttributeNS(null,"values","0.1 0 0 0 0  0 0.1 0 0 0  0 0 0.1 0 0  0 0 0 "+i+" 0"):(e[0]/=255,e[1]/=255,e[2]/=255,d=r+" 0 0 0 "+e[0]+"  0 "+r+" 0 0 "+e[1]+"  0 0 "+r+" 0 "+e[2]+"  0 0 0 "+i+" 0",h.setAttributeNS(null,"values",d)),u.appendChild(h),(l=this.container.ownerDocument.createElementNS(this.svgNamespace,"feGaussianBlur")).setAttributeNS(null,"in","colorOut"),l.setAttributeNS(null,"result","blurOut"),l.setAttributeNS(null,"stdDeviation",o),u.appendChild(l),(c=this.container.ownerDocument.createElementNS(this.svgNamespace,"feBlend")).setAttributeNS(null,"in","SourceGraphic"),c.setAttributeNS(null,"in2","blurOut"),c.setAttributeNS(null,"mode","normal"),u.appendChild(c),u},this.defs.appendChild(this.createShadowFilter(this.container.id+"_f1","none",1,.1,3,[5,5])),this.layer=[],i=0;i<N.Z.layer.numlayers;i++)this.layer[i]=this.container.ownerDocument.createElementNS(this.svgNamespace,"g"),this.svgRoot.appendChild(this.layer[i]);try{this.foreignObjLayer=this.container.ownerDocument.createElementNS(this.svgNamespace,"foreignObject"),this.foreignObjLayer.setAttribute("display","none"),this.foreignObjLayer.setAttribute("x",0),this.foreignObjLayer.setAttribute("y",0),this.foreignObjLayer.setAttribute("width","100%"),this.foreignObjLayer.setAttribute("height","100%"),this.foreignObjLayer.setAttribute("id",this.container.id+"_foreignObj"),this.svgRoot.appendChild(this.foreignObjLayer),this.supportsForeignObject=!0}catch(t){this.supportsForeignObject=!1}this.dashArray=["2, 2","5, 5","10, 10","20, 20","20, 10, 10, 10","20, 5, 10, 5"]},t.Z.SVGRenderer.prototype=new A,t.Z.extend(t.Z.SVGRenderer.prototype,{_createArrowHead:function(t,e,r){var o,n,a,h,l=t.id+"Triangle";return s.Z.exists(e)&&(l+=e),(o=this.createPrim("marker",l)).setAttributeNS(null,"stroke",s.Z.evaluate(t.visProp.strokecolor)),o.setAttributeNS(null,"stroke-opacity",s.Z.evaluate(t.visProp.strokeopacity)),o.setAttributeNS(null,"fill",s.Z.evaluate(t.visProp.strokecolor)),o.setAttributeNS(null,"fill-opacity",s.Z.evaluate(t.visProp.strokeopacity)),o.setAttributeNS(null,"stroke-width",0),o.setAttributeNS(null,"orient","auto"),o.setAttributeNS(null,"markerUnits","strokeWidth"),n=this.container.ownerDocument.createElementNS(this.svgNamespace,"path"),h=5,"End"===e?(a=0,2===r?n.setAttributeNS(null,"d","M 10,0 L 0,5 L 10,10 L 5,5 z"):3===r?n.setAttributeNS(null,"d","M 0,0 L 3.33,0 L 3.33,10 L 0,10 z"):4===r?(h=3.31,n.setAttributeNS(null,"d","M 0.00,3.31 C 3.53,3.84 7.13,4.50 10.00,6.63 C 9.33,5.52 8.67,4.42 8.00,3.31 C 8.67,2.21 9.33,1.10 10.00,0.00 C 7.13,2.13 3.53,2.79 0.00,3.31")):5===r?(h=3.28,n.setAttributeNS(null,"d","M 0.00,3.28 C 3.39,4.19 6.81,5.07 10.00,6.55 C 9.38,5.56 9.00,4.44 9.00,3.28 C 9.00,2.11 9.38,0.99 10.00,0.00 C 6.81,1.49 3.39,2.37 0.00,3.28")):6===r?(h=2.84,n.setAttributeNS(null,"d","M 0.00,2.84 C 3.39,3.59 6.79,4.35 10.00,5.68 C 9.67,4.73 9.33,3.78 9.00,2.84 C 9.33,1.89 9.67,0.95 10.00,0.00 C 6.79,1.33 3.39,2.09 0.00,2.84")):7===r?(h=5.2,n.setAttributeNS(null,"d","M 0.00,5.20 C 4.04,5.20 7.99,6.92 10.00,10.39 M 10.00,0.00 C 7.99,3.47 4.04,5.20 0.00,5.20")):n.setAttributeNS(null,"d","M 10,0 L 0,5 L 10,10 z"),t.elementClass===i.Z.OBJECT_CLASS_LINE&&(a=2===r?4.9:3===r?3.3:4===r||5===r||6===r?6.66:7===r?0:10)):(a=10,2===r?n.setAttributeNS(null,"d","M 0,0 L 10,5 L 0,10 L 5,5 z"):3===r?(a=3.3,n.setAttributeNS(null,"d","M 0,0 L 3.33,0 L 3.33,10 L 0,10 z")):4===r?(h=3.31,n.setAttributeNS(null,"d","M 10.00,3.31 C 6.47,3.84 2.87,4.50 0.00,6.63 C 0.67,5.52 1.33,4.42 2.00,3.31 C 1.33,2.21 0.67,1.10 0.00,0.00 C 2.87,2.13 6.47,2.79 10.00,3.31")):5===r?(h=3.28,n.setAttributeNS(null,"d","M 10.00,3.28 C 6.61,4.19 3.19,5.07 0.00,6.55 C 0.62,5.56 1.00,4.44 1.00,3.28 C 1.00,2.11 0.62,0.99 0.00,0.00 C 3.19,1.49 6.61,2.37 10.00,3.28")):6===r?(h=2.84,n.setAttributeNS(null,"d","M 10.00,2.84 C 6.61,3.59 3.21,4.35 0.00,5.68 C 0.33,4.73 0.67,3.78 1.00,2.84 C 0.67,1.89 0.33,0.95 0.00,0.00 C 3.21,1.33 6.61,2.09 10.00,2.84")):7===r?(h=5.2,n.setAttributeNS(null,"d","M 10.00,5.20 C 5.96,5.20 2.01,6.92 0.00,10.39 M 0.00,0.00 C 2.01,3.47 5.96,5.20 10.00,5.20")):n.setAttributeNS(null,"d","M 0,0 L 10,5 L 0,10 z"),t.elementClass===i.Z.OBJECT_CLASS_LINE&&(a=2===r?5.1:3===r?.02:4===r||5===r||6===r?3.33:7===r?10:.05)),7===r&&(o.setAttributeNS(null,"fill","none"),o.setAttributeNS(null,"stroke-width",1)),o.setAttributeNS(null,"refY",h),o.setAttributeNS(null,"refX",a),o.appendChild(n),o},_setArrowColor:function(t,e,i,r,o){t&&(s.Z.isString(e)&&(7!==o?this._setAttribute((function(){t.setAttributeNS(null,"stroke",e),t.setAttributeNS(null,"fill",e),t.setAttributeNS(null,"stroke-opacity",i),t.setAttributeNS(null,"fill-opacity",i)}),r.visPropOld.fillcolor):this._setAttribute((function(){t.setAttributeNS(null,"fill","none"),t.setAttributeNS(null,"stroke",e),t.setAttributeNS(null,"stroke-opacity",i)}),r.visPropOld.fillcolor)),this.isIE&&r.rendNode.parentNode.insertBefore(r.rendNode,r.rendNode))},_setArrowWidth:function(t,e,i,s){var r,o;t&&(o=(r=e)*s,t.setAttributeNS(null,"viewBox","0 0 "+10*r+" "+10*r),t.setAttributeNS(null,"markerHeight",o),t.setAttributeNS(null,"markerWidth",o),t.setAttributeNS(null,"display","inherit"),this.isIE&&i.parentNode.insertBefore(i,i))},updateTicks:function(t){var e,i,r,o,n,a,h,l,c="",d=t.ticks.length,u=!0;for(e=0;e<d;e++){for(n=(r=t.ticks[e])[0],a=r[1],h=n.length,l=" M "+n[0]+" "+a[0],s.Z.isNumber(n[0])||(u=!1),i=1;u&&i<h;++i)s.Z.isNumber(n[i])?l+=" L "+n[i]+" "+a[i]:u=!1;u&&(c+=l)}o=t.rendNode,s.Z.exists(o)||(o=this.createPrim("path",t.id),this.appendChildPrim(o,s.Z.evaluate(t.visProp.layer)),t.rendNode=o),o.setAttributeNS(null,"stroke",s.Z.evaluate(t.visProp.strokecolor)),o.setAttributeNS(null,"fill","none"),o.setAttributeNS(null,"stroke-opacity",s.Z.evaluate(t.visProp.strokeopacity)),o.setAttributeNS(null,"stroke-width",s.Z.evaluate(t.visProp.strokewidth)),this.updatePathPrim(o,c,t.board)},displayCopyright:function(t,e){var i,s=this.createPrim("text","licenseText");s.setAttributeNS(null,"x","20px"),s.setAttributeNS(null,"y",2+e+"px"),s.setAttributeNS(null,"style","font-family:Arial,Helvetica,sans-serif; font-size:"+e+"px; fill:#356AA0;  opacity:0.3;"),i=this.container.ownerDocument.createTextNode(t),s.appendChild(i),this.appendChildPrim(s,0)},drawInternalText:function(t){var e=this.createPrim("text",t.id);return e.style.whiteSpace="nowrap",t.rendNodeText=this.container.ownerDocument.createTextNode(""),e.appendChild(t.rendNodeText),this.appendChildPrim(e,s.Z.evaluate(t.visProp.layer)),e},updateInternalText:function(t){var e,i=t.plaintext,r=t.getAnchorX(),o=t.getAnchorY();t.rendNode.getAttributeNS(null,"class")!==t.visProp.cssclass&&(t.rendNode.setAttributeNS(null,"class",s.Z.evaluate(t.visProp.cssclass)),t.needsSizeUpdate=!0),isNaN(t.coords.scrCoords[1]+t.coords.scrCoords[2])||(e=t.coords.scrCoords[1],t.visPropOld.left!==r+e&&(t.rendNode.setAttributeNS(null,"x",e+"px"),"left"===r?t.rendNode.setAttributeNS(null,"text-anchor","start"):"right"===r?t.rendNode.setAttributeNS(null,"text-anchor","end"):"middle"===r&&t.rendNode.setAttributeNS(null,"text-anchor","middle"),t.visPropOld.left=r+e),e=t.coords.scrCoords[2],t.visPropOld.top!==o+e&&(t.rendNode.setAttributeNS(null,"y",e+.5*this.vOffsetText+"px"),"bottom"===o?t.rendNode.setAttributeNS(null,"dominant-baseline","text-after-edge"):"top"===o?t.rendNode.setAttributeNS(null,"dy","1.6ex"):"middle"===o&&t.rendNode.setAttributeNS(null,"dy","0.6ex"),t.visPropOld.top=o+e)),t.htmlStr!==i&&(t.rendNodeText.data=i,t.htmlStr=i),this.transformImage(t,t.transformations)},updateInternalTextStyle:function(t,e,i,s){this.setObjectFillColor(t,e,i)},drawImage:function(t){var e=this.createPrim("image",t.id);e.setAttributeNS(null,"preserveAspectRatio","none"),this.appendChildPrim(e,s.Z.evaluate(t.visProp.layer)),t.rendNode=e,this.updateImage(t)},transformImage:function(t,e){var i,s=t.rendNode,r="";e.length>0&&(r+=" matrix("+[(i=this.joinTransforms(t,e))[1][1],i[2][1],i[1][2],i[2][2],i[1][0],i[2][0]].join(",")+") ",s.setAttributeNS(null,"transform",r))},updateImageURL:function(t){var e=s.Z.evaluate(t.url);return t._src!==e&&(t.imgIsLoaded=!1,t.rendNode.setAttributeNS(this.xlinkNamespace,"xlink:href",e),t._src=e,!0)},updateImageStyle:function(t,e){var i=s.Z.evaluate(e?t.visProp.highlightcssclass:t.visProp.cssclass);t.rendNode.setAttributeNS(null,"class",i)},drawForeignObject:function(t){t.rendNode=this.appendChildPrim(this.createPrim("foreignObject",t.id),s.Z.evaluate(t.visProp.layer)),this.appendNodesToElement(t,"foreignObject"),this.updateForeignObject(t)},updateForeignObject:function(t){t._useUserSize?t.rendNode.style.overflow="hidden":t.rendNode.style.overflow="visible",this.updateRectPrim(t.rendNode,t.coords.scrCoords[1],t.coords.scrCoords[2]-t.size[1],t.size[0],t.size[1]),t.rendNode.innerHTML=t.content,this._updateVisual(t,{stroke:!0,dash:!0},!0)},appendChildPrim:function(t,e){return s.Z.exists(e)?e>=N.Z.layer.numlayers&&(e=N.Z.layer.numlayers-1):e=0,this.layer[e].appendChild(t),t},createPrim:function(t,e){var i=this.container.ownerDocument.createElementNS(this.svgNamespace,t);return i.setAttributeNS(null,"id",this.container.id+"_"+e),i.style.position="absolute","path"===t&&(i.setAttributeNS(null,"stroke-linecap","round"),i.setAttributeNS(null,"stroke-linejoin","round"),i.setAttributeNS(null,"fill-rule","evenodd")),i},remove:function(t){s.Z.exists(t)&&s.Z.exists(t.parentNode)&&t.parentNode.removeChild(t)},setLayer:function(t,e){s.Z.exists(e)?e>=N.Z.layer.numlayers&&(e=N.Z.layer.numlayers-1):e=0,this.layer[e].appendChild(t.rendNode)},makeArrows:function(t,e){var i,r=e.evFirst,o=e.evLast;t.visPropOld.firstarrow!==r||t.visPropOld.lastarrow!==o?(r?(i=t.rendNodeTriangleStart,s.Z.exists(i)?this.defs.appendChild(i):(i=this._createArrowHead(t,"End",e.typeFirst),this.defs.appendChild(i),t.rendNodeTriangleStart=i,t.rendNode.setAttributeNS(null,"marker-start","url(#"+this.container.id+"_"+t.id+"TriangleEnd)"))):(i=t.rendNodeTriangleStart,s.Z.exists(i)&&this.remove(i)),o?(i=t.rendNodeTriangleEnd,s.Z.exists(i)?this.defs.appendChild(i):(i=this._createArrowHead(t,"Start",e.typeLast),this.defs.appendChild(i),t.rendNodeTriangleEnd=i,t.rendNode.setAttributeNS(null,"marker-end","url(#"+this.container.id+"_"+t.id+"TriangleStart)"))):(i=t.rendNodeTriangleEnd,s.Z.exists(i)&&this.remove(i)),t.visPropOld.firstarrow=r,t.visPropOld.lastarrow=o):this.isIE&&t.visPropCalc.visible&&(r||o)&&t.rendNode.parentNode.insertBefore(t.rendNode,t.rendNode)},updateEllipsePrim:function(t,e,i,s,r){var o;o=2e5,e=Math.abs(e)<o?e:o*e/Math.abs(e),i=Math.abs(i)<o?i:o*i/Math.abs(i),s=Math.abs(s)<o?s:o*s/Math.abs(s),r=Math.abs(r)<o?r:o*r/Math.abs(r),t.setAttributeNS(null,"cx",e),t.setAttributeNS(null,"cy",i),t.setAttributeNS(null,"rx",Math.abs(s)),t.setAttributeNS(null,"ry",Math.abs(r))},updateLinePrim:function(t,e,i,s,r){var o;o=2e5,isNaN(e+i+s+r)||(e=Math.abs(e)<o?e:o*e/Math.abs(e),i=Math.abs(i)<o?i:o*i/Math.abs(i),s=Math.abs(s)<o?s:o*s/Math.abs(s),r=Math.abs(r)<o?r:o*r/Math.abs(r),t.setAttributeNS(null,"x1",e),t.setAttributeNS(null,"y1",i),t.setAttributeNS(null,"x2",s),t.setAttributeNS(null,"y2",r))},updatePathPrim:function(t,e){""===e&&(e="M 0 0"),t.setAttributeNS(null,"d",e)},updatePathStringPoint:function(t,e,i){var s="",r=t.coords.scrCoords,o=e*Math.sqrt(3)*.5,n=.5*e;return"x"===i?s=" M "+(r[1]-e)+" "+(r[2]-e)+" L "+(r[1]+e)+" "+(r[2]+e)+" M "+(r[1]+e)+" "+(r[2]-e)+" L "+(r[1]-e)+" "+(r[2]+e):"+"===i?s=" M "+(r[1]-e)+" "+r[2]+" L "+(r[1]+e)+" "+r[2]+" M "+r[1]+" "+(r[2]-e)+" L "+r[1]+" "+(r[2]+e):"|"===i?s=" M "+r[1]+" "+(r[2]-e)+" L "+r[1]+" "+(r[2]+e):"-"===i?s=" M "+(r[1]-e)+" "+r[2]+" L "+(r[1]+e)+" "+r[2]:"<>"===i?s=" M "+(r[1]-e)+" "+r[2]+" L "+r[1]+" "+(r[2]+e)+" L "+(r[1]+e)+" "+r[2]+" L "+r[1]+" "+(r[2]-e)+" Z ":"^"===i?s=" M "+r[1]+" "+(r[2]-e)+" L "+(r[1]-o)+" "+(r[2]+n)+" L "+(r[1]+o)+" "+(r[2]+n)+" Z ":"v"===i?s=" M "+r[1]+" "+(r[2]+e)+" L "+(r[1]-o)+" "+(r[2]-n)+" L "+(r[1]+o)+" "+(r[2]-n)+" Z ":">"===i?s=" M "+(r[1]+e)+" "+r[2]+" L "+(r[1]-n)+" "+(r[2]-o)+" L "+(r[1]-n)+" "+(r[2]+o)+" Z ":"<"===i&&(s=" M "+(r[1]-e)+" "+r[2]+" L "+(r[1]+n)+" "+(r[2]-o)+" L "+(r[1]+n)+" "+(r[2]+o)+" Z "),s},updatePathStringPrim:function(t){var e,i,s,r=" M ",o=r,n=5e3,a="";if(t.numberPoints<=0)return"";if(s=Math.min(t.points.length,t.numberPoints),1===t.bezierDegree)for(e=0;e<s;e++)i=t.points[e].scrCoords,isNaN(i[1])||isNaN(i[2])?o=r:(i[1]=Math.max(Math.min(i[1],n),-5e3),i[2]=Math.max(Math.min(i[2],n),-5e3),a+=o+i[1]+" "+i[2],o=" L ");else if(3===t.bezierDegree)for(e=0;e<s;)i=t.points[e].scrCoords,isNaN(i[1])||isNaN(i[2])?o=r:(a+=o+i[1]+" "+i[2]," C "===o&&(e+=1,a+=" "+(i=t.points[e].scrCoords)[1]+" "+i[2],e+=1,a+=" "+(i=t.points[e].scrCoords)[1]+" "+i[2]),o=" C "),e+=1;return a},updatePathStringBezierPrim:function(t){var e,i,r,o,n,a,h,c=" M ",d=c,u=5e3,p="",_=s.Z.evaluate(t.visProp.strokewidth),f="plot"!==s.Z.evaluate(t.visProp.curvetype);if(t.numberPoints<=0)return"";for(f&&t.board.options.curve.RDPsmoothing&&(t.points=l.Z.RamerDouglasPeucker(t.points,.5)),h=Math.min(t.points.length,t.numberPoints),i=1;i<3;i++)for(d=c,e=0;e<h;e++)o=t.points[e].scrCoords,isNaN(o[1])||isNaN(o[2])?d=c:(o[1]=Math.max(Math.min(o[1],u),-5e3),o[2]=Math.max(Math.min(o[2],u),-5e3),d===c?p+=d+o[1]+" "+o[2]:(r=2*i,p+=[d,n+.333*(o[1]-n)+_*(r*Math.random()-i)," ",a+.333*(o[2]-a)+_*(r*Math.random()-i)," ",n+.666*(o[1]-n)+_*(r*Math.random()-i)," ",a+.666*(o[2]-a)+_*(r*Math.random()-i)," ",o[1]," ",o[2]].join("")),d=" C ",n=o[1],a=o[2]);return p},updatePolygonPrim:function(t,e){var i,s,r="",o=e.vertices.length;for(t.setAttributeNS(null,"stroke","none"),t.setAttributeNS(null,"fill-rule","evenodd"),"polygonalchain"===e.elType&&o++,i=0;i<o-1;i++){if(!e.vertices[i].isReal)return void t.setAttributeNS(null,"points","");r=r+(s=e.vertices[i].coords.scrCoords)[1]+","+s[2],i<o-2&&(r+=" ")}-1===r.indexOf("NaN")&&t.setAttributeNS(null,"points",r)},updateRectPrim:function(t,e,i,s,r){t.setAttributeNS(null,"x",e),t.setAttributeNS(null,"y",i),t.setAttributeNS(null,"width",s),t.setAttributeNS(null,"height",r)},setPropertyPrim:function(t,e,i){"stroked"!==e&&t.setAttributeNS(null,e,i)},display:function(t,e){var i;t&&t.rendNode&&(t.visPropOld.visible=e,i=t.rendNode,e?(i.setAttributeNS(null,"display","inline"),i.style.visibility="inherit"):(i.setAttributeNS(null,"display","none"),i.style.visibility="hidden"))},show:function(e){t.Z.deprecated("Board.renderer.show()","Board.renderer.display()"),this.display(e,!0)},hide:function(e){t.Z.deprecated("Board.renderer.hide()","Board.renderer.display()"),this.display(e,!1)},setBuffering:function(t,e){t.rendNode.setAttribute("buffered-rendering",e)},setDashStyle:function(t){var e=s.Z.evaluate(t.visProp.dash),i=t.rendNode;e>0?i.setAttributeNS(null,"stroke-dasharray",this.dashArray[e-1]):i.hasAttributeNS(null,"stroke-dasharray")&&i.removeAttributeNS(null,"stroke-dasharray")},setGradient:function(t){var e,i,r,o=t.rendNode,n=s.Z.evaluate(t.visProp.gradient);"linear"===n||"radial"===n?(e=this.createPrim(n+"Gradient",t.id+"_gradient"),i=this.createPrim("stop",t.id+"_gradient1"),r=this.createPrim("stop",t.id+"_gradient2"),e.appendChild(i),e.appendChild(r),this.defs.appendChild(e),o.setAttributeNS(null,"style","fill:url(#"+this.container.id+"_"+t.id+"_gradient)"),t.gradNode1=i,t.gradNode2=r,t.gradNode=e):o.removeAttributeNS(null,"style")},updateGradientAngle:function(t,e){var i=1,s=Math.cos(e),r=Math.sin(e);Math.abs(s)>Math.abs(r)?i/=Math.abs(s):i/=Math.abs(r),s>=0?(t.setAttributeNS(null,"x1",0),t.setAttributeNS(null,"x2",s*i)):(t.setAttributeNS(null,"x1",-s*i),t.setAttributeNS(null,"x2",0)),r>=0?(t.setAttributeNS(null,"y1",0),t.setAttributeNS(null,"y2",r*i)):(t.setAttributeNS(null,"y1",-r*i),t.setAttributeNS(null,"y2",0))},updateGradientCircle:function(t,e,i,s,r,o,n){t.setAttributeNS(null,"cx",100*e+"%"),t.setAttributeNS(null,"cy",100*i+"%"),t.setAttributeNS(null,"r",100*s+"%"),t.setAttributeNS(null,"fx",100*r+"%"),t.setAttributeNS(null,"fy",100*o+"%"),t.setAttributeNS(null,"fr",100*n+"%")},updateGradient:function(t){var e,i,r=t.gradNode1,o=t.gradNode2,n=s.Z.evaluate(t.visProp.gradient);s.Z.exists(r)&&s.Z.exists(o)&&(i=(i=s.Z.evaluate(t.visProp.fillopacity))>0?i:0,e=s.Z.evaluate(t.visProp.fillcolor),r.setAttributeNS(null,"style","stop-color:"+e+";stop-opacity:"+i),o.setAttributeNS(null,"style","stop-color:"+s.Z.evaluate(t.visProp.gradientsecondcolor)+";stop-opacity:"+s.Z.evaluate(t.visProp.gradientsecondopacity)),r.setAttributeNS(null,"offset",100*s.Z.evaluate(t.visProp.gradientstartoffset)+"%"),o.setAttributeNS(null,"offset",100*s.Z.evaluate(t.visProp.gradientendoffset)+"%"),"linear"===n?this.updateGradientAngle(t.gradNode,s.Z.evaluate(t.visProp.gradientangle)):"radial"===n&&this.updateGradientCircle(t.gradNode,s.Z.evaluate(t.visProp.gradientcx),s.Z.evaluate(t.visProp.gradientcy),s.Z.evaluate(t.visProp.gradientr),s.Z.evaluate(t.visProp.gradientfx),s.Z.evaluate(t.visProp.gradientfy),s.Z.evaluate(t.visProp.gradientfr)))},setObjectTransition:function(t,e){var i,r,o,n,a=[],h=["rendNode","rendNodeTriangleStart","rendNodeTriangleEnd"];if(void 0===e&&(e=s.Z.evaluate(t.visProp.transitionduration)),i=s.Z.evaluate(t.visProp.transitionproperties),e!==t.visPropOld.transitionduration||i!==t.visPropOld.transitionproperties){for(n=i.length,o=0;o<n;o++)a.push(i[o]+" "+e+"ms");for(r=a.join(", "),n=h.length,o=0;o<n;++o)t[h[o]]&&(t[h[o]].style.transition=r);t.visPropOld.transitionduration=e,t.visPropOld.transitionproperties=i}},_setAttribute:function(t,e){""===e?t():window.setTimeout(t,1)},setObjectFillColor:function(e,i,r,o){var n,a,h,l,c=s.Z.evaluate(i),d=s.Z.evaluate(r),u=s.Z.evaluate(e.visProp.gradient);d=d>0?d:0,e.visPropOld.fillcolor===c&&e.visPropOld.fillopacity===d&&null===u||(s.Z.exists(c)&&!1!==c&&(9!==c.length?(a=c,l=d):(h=L.Z.rgba2rgbo(c),a=h[0],l=d*h[1]),n=void 0===o?e.rendNode:o,"none"!==a&&this._setAttribute((function(){n.setAttributeNS(null,"fill",a)}),e.visPropOld.fillcolor),e.type===t.Z.OBJECT_TYPE_IMAGE?this._setAttribute((function(){n.setAttributeNS(null,"opacity",l)}),e.visPropOld.fillopacity):("none"===a?(l=0,n.setAttributeNS(null,"pointer-events","visibleStroke")):n.setAttributeNS(null,"pointer-events","visiblePainted"),this._setAttribute((function(){n.setAttributeNS(null,"fill-opacity",l)}),e.visPropOld.fillopacity)),"linear"!==u&&"radial"!==u||this.updateGradient(e)),e.visPropOld.fillcolor=c,e.visPropOld.fillopacity=d)},setObjectStrokeColor:function(t,e,r){var o,n,a,h,l=s.Z.evaluate(e),c=s.Z.evaluate(r);c=c>0?c:0,t.visPropOld.strokecolor===l&&t.visPropOld.strokeopacity===c||(s.Z.exists(l)&&!1!==l&&(9!==l.length?(o=l,a=c):(n=L.Z.rgba2rgbo(l),o=n[0],a=c*n[1]),h=t.rendNode,t.elementClass===i.Z.OBJECT_CLASS_TEXT?"html"===s.Z.evaluate(t.visProp.display)?this._setAttribute((function(){h.style.color=o,h.style.opacity=a}),t.visPropOld.strokecolor):this._setAttribute((function(){h.setAttributeNS(null,"style","fill:"+o),h.setAttributeNS(null,"style","fill-opacity:"+a)}),t.visPropOld.strokecolor):this._setAttribute((function(){h.setAttributeNS(null,"stroke",o),h.setAttributeNS(null,"stroke-opacity",a)}),t.visPropOld.strokecolor),t.elementClass!==i.Z.OBJECT_CLASS_CURVE&&t.elementClass!==i.Z.OBJECT_CLASS_LINE||(s.Z.evaluate(t.visProp.firstarrow)&&this._setArrowColor(t.rendNodeTriangleStart,o,a,t,t.visPropCalc.typeFirst),s.Z.evaluate(t.visProp.lastarrow)&&this._setArrowColor(t.rendNodeTriangleEnd,o,a,t,t.visPropCalc.typeLast))),t.visPropOld.strokecolor=l,t.visPropOld.strokeopacity=c)},setObjectStrokeWidth:function(t,e){var i,r=s.Z.evaluate(e);isNaN(r)||t.visPropOld.strokewidth===r||(i=t.rendNode,this.setPropertyPrim(i,"stroked","true"),s.Z.exists(r)&&this.setPropertyPrim(i,"stroke-width",r+"px"),t.visPropOld.strokewidth=r)},setLineCap:function(t){var e=s.Z.evaluate(t.visProp.linecap);void 0!==e&&""!==e&&t.visPropOld.linecap!==e&&s.Z.exists(t.rendNode)&&(this.setPropertyPrim(t.rendNode,"stroke-linecap",e),t.visPropOld.linecap=e)},setShadow:function(e){var i,r,o,n,a,h,l,c,d=s.Z.evaluate(e.visProp.shadow),u=!0,p=!1;(i=JSON.stringify(d))!==e.visPropOld.shadow&&("boolean"==typeof d?(u=!0,p=d,r="none",o=3,n=.1,a=[5,5],h=1):s.Z.evaluate(d.enabled)?(u=!1,p=!0,r=t.Z.rgbParser(s.Z.evaluate(d.color)),o=s.Z.evaluate(d.blur),n=s.Z.evaluate(d.blend),a=s.Z.evaluate(d.offset),h=s.Z.evaluate(d.opacity)):p=!1,s.Z.exists(e.rendNode)&&(p?u?e.rendNode.setAttributeNS(null,"filter","url(#"+this.container.id+"_f1)"):((c=this.container.ownerDocument.getElementById(l))&&this.defs.removeChild(c),l=e.rendNode.id+"_f1",this.defs.appendChild(this.createShadowFilter(l,r,h,n,o,a)),e.rendNode.setAttributeNS(null,"filter","url(#"+l+")")):e.rendNode.removeAttributeNS(null,"filter")),e.visPropOld.shadow=i)},suspendRedraw:function(){},unsuspendRedraw:function(){},resize:function(t,e){this.svgRoot.setAttribute("width",parseFloat(t)),this.svgRoot.setAttribute("height",parseFloat(e))},createTouchpoints:function(t){var e,i,s,r;for(this.touchpoints=[],e=0;e<t;e++)i="touchpoint1_"+e,r=this.createPrim("path",i),this.appendChildPrim(r,19),r.setAttributeNS(null,"d","M 0 0"),this.touchpoints.push(r),this.setPropertyPrim(r,"stroked","true"),this.setPropertyPrim(r,"stroke-width","1px"),r.setAttributeNS(null,"stroke","#000000"),r.setAttributeNS(null,"stroke-opacity",1),r.setAttributeNS(null,"display","none"),s="touchpoint2_"+e,r=this.createPrim("ellipse",s),this.appendChildPrim(r,19),this.updateEllipsePrim(r,0,0,0,0),this.touchpoints.push(r),this.setPropertyPrim(r,"stroked","true"),this.setPropertyPrim(r,"stroke-width","1px"),r.setAttributeNS(null,"stroke","#000000"),r.setAttributeNS(null,"stroke-opacity",1),r.setAttributeNS(null,"fill","#ffffff"),r.setAttributeNS(null,"fill-opacity",0),r.setAttributeNS(null,"display","none")},showTouchpoint:function(t){this.touchpoints&&t>=0&&2*t<this.touchpoints.length&&(this.touchpoints[2*t].setAttributeNS(null,"display","inline"),this.touchpoints[2*t+1].setAttributeNS(null,"display","inline"))},hideTouchpoint:function(t){this.touchpoints&&t>=0&&2*t<this.touchpoints.length&&(this.touchpoints[2*t].setAttributeNS(null,"display","none"),this.touchpoints[2*t+1].setAttributeNS(null,"display","none"))},updateTouchpoint:function(t,e){var i,s;this.touchpoints&&t>=0&&2*t<this.touchpoints.length&&(i=e[0],s=e[1],this.touchpoints[2*t].setAttributeNS(null,"d","M "+(i-37)+" "+s+" L "+(i+37)+" "+s+" M "+i+" "+(s-37)+" L "+i+" "+(s+37)),this.updateEllipsePrim(this.touchpoints[2*t+1],e[0],e[1],25,25))},_getValuesOfDOMElements:function(t){var e=[];if(1===t.nodeType)for(t=t.firstChild;t;)void 0!==t.id&&void 0!==t.value&&e.push([t.id,t.value]),e=e.concat(this._getValuesOfDOMElements(t)),t=t.nextSibling;return e},_getDataUri:function(t,e){var i=new Image;i.onload=function(){var t=document.createElement("canvas");t.width=this.naturalWidth,t.height=this.naturalHeight,t.getContext("2d").drawImage(this,0,0),e(t.toDataURL("image/png")),t.remove()},i.src=t},_getImgDataURL:function(t){var e,i,s,r,o,n;if((i=(e=t.getElementsByTagName("image")).length)>0)for(s=document.createElement("canvas"),n=0;n<i;n++){e[n].setAttribute("crossorigin","anonymous"),r=s.getContext("2d"),s.width=e[n].getAttribute("width"),s.height=e[n].getAttribute("height");try{r.drawImage(e[n],0,0,s.width,s.height),o=s.toDataURL(),e[n].setAttribute("xlink:href",o)}catch(t){console.log("CORS problem! Image can not be used",t)}}return!0},dumpToDataURI:function(t){var e,i,r,o=this.svgRoot,n=window.btoa||x.encode,a=[];if(this.container.hasChildNodes()&&s.Z.exists(this.foreignObjLayer))for(t||this.foreignObjLayer.setAttribute("display","inline");o.nextSibling;)a=a.concat(this._getValuesOfDOMElements(o.nextSibling)),this.foreignObjLayer.appendChild(o.nextSibling);if(this._getImgDataURL(o),o.setAttribute("xmlns","http://www.w3.org/2000/svg"),e=(new XMLSerializer).serializeToString(o),!0!==t)for(r=a.length,i=0;i<r;i++)e=e.replace('id="'+a[i][0]+'"','id="'+a[i][0]+'" value="'+a[i][1]+'"');if((e.match(/xmlns="http:\/\/www.w3.org\/2000\/svg"/g)||[]).length>1&&(e=e.replace(/xmlns="http:\/\/www.w3.org\/2000\/svg"/g,"")),e=e.replace(/&nbsp;/g," "),s.Z.exists(this.foreignObjLayer)&&this.foreignObjLayer.hasChildNodes()){for(;this.foreignObjLayer.firstChild;)this.container.appendChild(this.foreignObjLayer.firstChild);this.foreignObjLayer.setAttribute("display","none")}return"data:image/svg+xml;base64,"+n(unescape(encodeURIComponent(e)))},dumpToCanvas:function(t,e,i,s){var r,o,n,a;return(n=this.container.ownerDocument.getElementById(t)).width=n.width,a=n.getContext("2d"),void 0!==e&&void 0!==i&&(n.style.width=parseFloat(e)+"px",n.style.height=parseFloat(i)+"px",n.setAttribute("width",parseFloat(e)),n.setAttribute("height",parseFloat(i))),o=new Image,r=this.dumpToDataURI(s),o.src=r,"Promise"in window?new Promise((function(t,s){try{o.onload=function(){a.drawImage(o,0,0,e,i),t()}}catch(t){s(t)}})):(o.onload=function(){window.setTimeout((function(){try{a.drawImage(o,0,0,e,i)}catch(t){console.log("screenshots not longer supported on IE")}}),200)},this)},screenshot:function(t,e,i){var r,o,n,a,h,l,c,d,u,p,_,f=this.container.ownerDocument,b=this.container.parentNode,g=t.attr.screenshot,m=!1;return"no"===this.type||(c=g.scale*this.container.getBoundingClientRect().width,d=g.scale*this.container.getBoundingClientRect().height,void 0===e||""===e?(m=!0,(a=new Image).style.width=c+"px",a.style.height=d+"px"):(m=!1,a=f.getElementById(e)),m&&((r=f.createElement("div")).style.cssText=g.css,r.style.width=c+"px",r.style.height=d+"px",r.style.zIndex=this.container.style.zIndex+120,r.style.position="absolute",r.style.top=this.container.offsetTop+"px",r.style.left=this.container.offsetLeft+"px"),o=f.createElement("canvas"),n=Math.random().toString(36).substr(2,5),o.setAttribute("id",n),o.setAttribute("width",c),o.setAttribute("height",d),o.style.width=c+"px",o.style.height=c+"px",o.style.display="none",b.appendChild(o),m&&(h=f.createElement("span"),l=f.createTextNode("✖"),h.style.cssText=g.cssButton,h.appendChild(l),h.onclick=function(){r.parentNode.removeChild(r)},r.appendChild(a),r.appendChild(h),b.insertBefore(r,this.container.nextSibling)),u=f.getElementById(this.container.id+"_navigationbar"),s.Z.exists(u)&&(p=u.style.display,u.style.display="none"),_=function(){a.src=o.toDataURL("image/png"),b.removeChild(o)},"Promise"in window?this.dumpToCanvas(n,c,d,i).then(_):(this.dumpToCanvas(n,c,d,i),window.setTimeout(_,200)),s.Z.exists(u)&&(u.style.display=p)),this}});const Y=t.Z.SVGRenderer;t.Z.VMLRenderer=function(e){this.type="vml",this.container=e,this.container.style.overflow="hidden",""===this.container.style.position&&(this.container.style.position="relative"),this.container.onselectstart=function(){return!1},this.resolution=10,s.Z.exists(t.Z.vmlStylesheet)||(e.ownerDocument.namespaces.add("jxgvml","urn:schemas-microsoft-com:vml"),t.Z.vmlStylesheet=this.container.ownerDocument.createStyleSheet(),t.Z.vmlStylesheet.addRule(".jxgvml","behavior:url(#default#VML)"));try{e.ownerDocument.namespaces.jxgvml||e.ownerDocument.namespaces.add("jxgvml","urn:schemas-microsoft-com:vml"),this.createNode=function(t){return e.ownerDocument.createElement("<jxgvml:"+t+' class="jxgvml">')}}catch(t){this.createNode=function(t){return e.ownerDocument.createElement("<"+t+' xmlns="urn:schemas-microsoft.com:vml" class="jxgvml">')}}this.dashArray=["Solid","1 1","ShortDash","Dash","LongDash","ShortDashDot","LongDashDot"]},t.Z.VMLRenderer.prototype=new A,t.Z.extend(t.Z.VMLRenderer.prototype,{_setAttr:function(e,i,s,r){try{8===this.container.ownerDocument.documentMode?e[i]=s:e.setAttribute(i,s,r)}catch(e){t.Z.debug("_setAttr: "+i+" "+s+"<br>\n")}},updateTicks:function(t){var e,i,r,o,n,a=this.resolution,h=[];for(i=t.ticks.length,e=0;e<i;e++)o=(r=t.ticks[e])[0],n=r[1],s.Z.isNumber(o[0])&&s.Z.isNumber(o[1])&&h.push(" m "+Math.round(a*o[0])+", "+Math.round(a*n[0])+" l "+Math.round(a*o[1])+", "+Math.round(a*n[1])+" ");s.Z.exists(t.rendNode)||(t.rendNode=this.createPrim("path",t.id),this.appendChildPrim(t.rendNode,s.Z.evaluate(t.visProp.layer))),this._setAttr(t.rendNode,"stroked","true"),this._setAttr(t.rendNode,"strokecolor",s.Z.evaluate(t.visProp.strokecolor),1),this._setAttr(t.rendNode,"strokeweight",s.Z.evaluate(t.visProp.strokewidth)),this._setAttr(t.rendNodeStroke,"opacity",100*s.Z.evaluate(t.visProp.strokeopacity)+"%"),this.updatePathPrim(t.rendNode,h,t.board)},displayCopyright:function(t,e){var i,s;(i=this.createNode("textbox")).style.position="absolute",this._setAttr(i,"id",this.container.id+"_licenseText"),i.style.left=20,i.style.top=2,i.style.fontSize=e,i.style.color="#356AA0",i.style.fontFamily="Arial,Helvetica,sans-serif",this._setAttr(i,"opacity","30%"),i.style.filter="progid:DXImageTransform.Microsoft.Matrix(M11='1.0', sizingMethod='auto expand', enabled = false) progid:DXImageTransform.Microsoft.Alpha(opacity = 30, enabled = true)",s=this.container.ownerDocument.createTextNode(t),i.appendChild(s),this.appendChildPrim(i,0)},drawInternalText:function(t){var e;return(e=this.createNode("textbox")).style.position="absolute",t.rendNodeText=this.container.ownerDocument.createTextNode(""),e.appendChild(t.rendNodeText),this.appendChildPrim(e,9),e.style.filter="progid:DXImageTransform.Microsoft.Matrix(M11='1.0', sizingMethod='auto expand', enabled = false) progid:DXImageTransform.Microsoft.Alpha(opacity = 100, enabled = false)",e},updateInternalText:function(t){var e,i,s,r,n,a,h=t.plaintext,l=this.joinTransforms(t,t.transformations),c=[0,0],d=t.rendNode,u=[],p=t.getAnchorX(),_=t.getAnchorY();if(!isNaN(t.coords.scrCoords[1]+t.coords.scrCoords[2])){for("right"===p?c[0]=1:"middle"===p&&(c[0]=.5),"bottom"===_?c[1]=1:"middle"===_&&(c[1]=.5),u[0]=o.Z.matVecMult(l,[1,t.coords.scrCoords[1]-c[0]*t.size[0],t.coords.scrCoords[2]+(1-c[1])*t.size[1]+this.vOffsetText]),u[0][1]/=u[0][0],u[0][2]/=u[0][0],u[1]=o.Z.matVecMult(l,[1,t.coords.scrCoords[1]+(1-c[0])*t.size[0],t.coords.scrCoords[2]+(1-c[1])*t.size[1]+this.vOffsetText]),u[1][1]/=u[1][0],u[1][2]/=u[1][0],u[2]=o.Z.matVecMult(l,[1,t.coords.scrCoords[1]+(1-c[0])*t.size[0],t.coords.scrCoords[2]-c[1]*t.size[1]+this.vOffsetText]),u[2][1]/=u[2][0],u[2][2]/=u[2][0],u[3]=o.Z.matVecMult(l,[1,t.coords.scrCoords[1]-c[0]*t.size[0],t.coords.scrCoords[2]-c[1]*t.size[1]+this.vOffsetText]),u[3][1]/=u[3][0],u[3][2]/=u[3][0],i=u[0][1],r=u[0][1],s=u[0][2],n=u[0][2],a=1;a<4;a++)i=Math.max(i,u[a][1]),r=Math.min(r,u[a][1]),s=Math.max(s,u[a][2]),n=Math.min(n,u[a][2]);e=1===c[0]?Math.floor(t.board.canvasWidth-i):Math.floor(r),t.visPropOld.left!==p+e&&(1===c[0]?(t.rendNode.style.right=e+"px",t.rendNode.style.left="auto"):(t.rendNode.style.left=e+"px",t.rendNode.style.right="auto"),t.visPropOld.left=p+e),e=1===c[1]?Math.floor(t.board.canvasHeight-s):Math.floor(n),t.visPropOld.top!==_+e&&(1===c[1]?(t.rendNode.style.bottom=e+"px",t.rendNode.style.top="auto"):(t.rendNode.style.top=e+"px",t.rendNode.style.bottom="auto"),t.visPropOld.top=_+e)}t.htmlStr!==h&&(t.rendNodeText.data=h,t.htmlStr=h),d.filters.item(0).M11=l[1][1],d.filters.item(0).M12=l[1][2],d.filters.item(0).M21=l[2][1],d.filters.item(0).M22=l[2][2],d.filters.item(0).enabled=!0},drawImage:function(t){var e;(e=this.container.ownerDocument.createElement("img")).style.position="absolute",this._setAttr(e,"id",this.container.id+"_"+t.id),this.container.appendChild(e),this.appendChildPrim(e,s.Z.evaluate(t.visProp.layer)),e.style.filter="progid:DXImageTransform.Microsoft.Matrix(M11='1.0', sizingMethod='auto expand') progid:DXImageTransform.Microsoft.Alpha(opacity = 100, enabled = false)",t.rendNode=e,this.updateImage(t)},transformImage:function(t,e){var i,s,r,n,a,h,l=t.rendNode,c=[];if(e.length>0){for(i=this.joinTransforms(t,e),c[0]=o.Z.matVecMult(i,t.coords.scrCoords),c[0][1]/=c[0][0],c[0][2]/=c[0][0],c[1]=o.Z.matVecMult(i,[1,t.coords.scrCoords[1]+t.size[0],t.coords.scrCoords[2]]),c[1][1]/=c[1][0],c[1][2]/=c[1][0],c[2]=o.Z.matVecMult(i,[1,t.coords.scrCoords[1]+t.size[0],t.coords.scrCoords[2]-t.size[1]]),c[2][1]/=c[2][0],c[2][2]/=c[2][0],c[3]=o.Z.matVecMult(i,[1,t.coords.scrCoords[1],t.coords.scrCoords[2]-t.size[1]]),c[3][1]/=c[3][0],c[3][2]/=c[3][0],s=c[0][1],n=c[0][1],r=c[0][2],a=c[0][2],h=1;h<4;h++)s=Math.max(s,c[h][1]),n=Math.min(n,c[h][1]),r=Math.max(r,c[h][2]),a=Math.min(a,c[h][2]);l.style.left=Math.floor(n)+"px",l.style.top=Math.floor(a)+"px",l.filters.item(0).M11=i[1][1],l.filters.item(0).M12=i[1][2],l.filters.item(0).M21=i[2][1],l.filters.item(0).M22=i[2][2],l.filters.item(0).enabled=!0}},updateImageURL:function(t){var e=s.Z.evaluate(t.url);this._setAttr(t.rendNode,"src",e)},appendChildPrim:function(t,e){return s.Z.exists(e)||(e=0),t.style.zIndex=e,this.container.appendChild(t),t},appendNodesToElement:function(t,e){"shape"!==e&&"path"!==e&&"polygon"!==e||(t.rendNodePath=this.getElementById(t.id+"_path")),t.rendNodeFill=this.getElementById(t.id+"_fill"),t.rendNodeStroke=this.getElementById(t.id+"_stroke"),t.rendNodeShadow=this.getElementById(t.id+"_shadow"),t.rendNode=this.getElementById(t.id)},createPrim:function(t,e){var i,s,r=this.createNode("fill"),o=this.createNode("stroke"),n=this.createNode("shadow");return this._setAttr(r,"id",this.container.id+"_"+e+"_fill"),this._setAttr(o,"id",this.container.id+"_"+e+"_stroke"),this._setAttr(n,"id",this.container.id+"_"+e+"_shadow"),"circle"===t||"ellipse"===t?((i=this.createNode("oval")).appendChild(r),i.appendChild(o),i.appendChild(n)):"polygon"===t||"path"===t||"shape"===t||"line"===t?((i=this.createNode("shape")).appendChild(r),i.appendChild(o),i.appendChild(n),s=this.createNode("path"),this._setAttr(s,"id",this.container.id+"_"+e+"_path"),i.appendChild(s)):((i=this.createNode(t)).appendChild(r),i.appendChild(o),i.appendChild(n)),i.style.position="absolute",i.style.left="0px",i.style.top="0px",this._setAttr(i,"id",this.container.id+"_"+e),i},remove:function(t){s.Z.exists(t)&&t.removeNode(!0)},makeArrows:function(t){var e,i=s.Z.evaluate(t.visProp.firstarrow),r=s.Z.evaluate(t.visProp.lastarrow);t.visPropOld.firstarrow===i&&t.visPropOld.lastarrow===r||(i?(e=t.rendNodeStroke,this._setAttr(e,"startarrow","block"),this._setAttr(e,"startarrowlength","long")):(e=t.rendNodeStroke,s.Z.exists(e)&&this._setAttr(e,"startarrow","none")),r?(e=t.rendNodeStroke,this._setAttr(e,"id",this.container.id+"_"+t.id+"stroke"),this._setAttr(e,"endarrow","block"),this._setAttr(e,"endarrowlength","long")):(e=t.rendNodeStroke,s.Z.exists(e)&&this._setAttr(e,"endarrow","none")),t.visPropOld.firstarrow=i,t.visPropOld.lastarrow=r)},updateEllipsePrim:function(t,e,i,s,r){t.style.left=Math.floor(e-s)+"px",t.style.top=Math.floor(i-r)+"px",t.style.width=Math.floor(2*Math.abs(s))+"px",t.style.height=Math.floor(2*Math.abs(r))+"px"},updateLinePrim:function(t,e,i,s,r,o){var n,a=this.resolution;isNaN(e+i+s+r)||(n=["m ",Math.floor(a*e),", ",Math.floor(a*i)," l ",Math.floor(a*s),", ",Math.floor(a*r)],this.updatePathPrim(t,n,o))},updatePathPrim:function(t,e,i){var s=i.canvasWidth,r=i.canvasHeight;e.length<=0&&(e=["m 0,0"]),t.style.width=s,t.style.height=r,this._setAttr(t,"coordsize",[Math.floor(this.resolution*s),Math.floor(this.resolution*r)].join(",")),this._setAttr(t,"path",e.join(""))},updatePathStringPoint:function(t,e,i){var s=[],r=Math.round,o=t.coords.scrCoords,n=e*Math.sqrt(3)*.5,a=.5*e,h=this.resolution;return"x"===i?s.push([" m ",r(h*(o[1]-e)),", ",r(h*(o[2]-e))," l ",r(h*(o[1]+e)),", ",r(h*(o[2]+e))," m ",r(h*(o[1]+e)),", ",r(h*(o[2]-e))," l ",r(h*(o[1]-e)),", ",r(h*(o[2]+e))].join("")):"+"===i?s.push([" m ",r(h*(o[1]-e)),", ",r(h*o[2])," l ",r(h*(o[1]+e)),", ",r(h*o[2])," m ",r(h*o[1]),", ",r(h*(o[2]-e))," l ",r(h*o[1]),", ",r(h*(o[2]+e))].join("")):"<>"===i?s.push([" m ",r(h*(o[1]-e)),", ",r(h*o[2])," l ",r(h*o[1]),", ",r(h*(o[2]+e))," l ",r(h*(o[1]+e)),", ",r(h*o[2])," l ",r(h*o[1]),", ",r(h*(o[2]-e))," x e "].join("")):"^"===i?s.push([" m ",r(h*o[1]),", ",r(h*(o[2]-e))," l ",r(h*(o[1]-n)),", ",r(h*(o[2]+a))," l ",r(h*(o[1]+n)),", ",r(h*(o[2]+a))," x e "].join("")):"v"===i?s.push([" m ",r(h*o[1]),", ",r(h*(o[2]+e))," l ",r(h*(o[1]-n)),", ",r(h*(o[2]-a))," l ",r(h*(o[1]+n)),", ",r(h*(o[2]-a))," x e "].join("")):">"===i?s.push([" m ",r(h*(o[1]+e)),", ",r(h*o[2])," l ",r(h*(o[1]-a)),", ",r(h*(o[2]-n))," l ",r(h*(o[1]-a)),", ",r(h*(o[2]+n))," l ",r(h*(o[1]+e)),", ",r(h*o[2])].join("")):"<"===i&&s.push([" m ",r(h*(o[1]-e)),", ",r(h*o[2])," l ",r(h*(o[1]+a)),", ",r(h*(o[2]-n))," l ",r(h*(o[1]+a)),", ",r(h*(o[2]+n))," x e "].join("")),s},updatePathStringPrim:function(t){var e,i,s=[],r=this.resolution,o=Math.round,n=" m ",a=n,h=Math.min(t.numberPoints,8192);if(t.numberPoints<=0)return"";if(h=Math.min(h,t.points.length),1===t.bezierDegree)for(e=0;e<h;e++)i=t.points[e].scrCoords,isNaN(i[1])||isNaN(i[2])?a=n:(i[1]>2e4?i[1]=2e4:i[1]<-2e4&&(i[1]=-2e4),i[2]>2e4?i[2]=2e4:i[2]<-2e4&&(i[2]=-2e4),s.push([a,o(r*i[1]),", ",o(r*i[2])].join("")),a=" l ");else if(3===t.bezierDegree)for(e=0;e<h;)i=t.points[e].scrCoords,isNaN(i[1])||isNaN(i[2])?a=n:(s.push([a,o(r*i[1]),", ",o(r*i[2])].join(""))," c "===a&&(e+=1,i=t.points[e].scrCoords,s.push([" ",o(r*i[1]),", ",o(r*i[2])].join("")),e+=1,i=t.points[e].scrCoords,s.push([" ",o(r*i[1]),", ",o(r*i[2])].join(""))),a=" c "),e+=1;return s.push(" e"),s},updatePathStringBezierPrim:function(t){var e,i,r,o,n,a,h=[],c=s.Z.evaluate(t.visProp.strokewidth),d=this.resolution,u=Math.round,p=" m ",_=p,f="plot"!==s.Z.evaluate(t.visProp.curvetype),b=Math.min(t.numberPoints,8192);if(t.numberPoints<=0)return"";for(f&&t.board.options.curve.RDPsmoothing&&(t.points=l.Z.RamerDouglasPeucker(t.points,1)),b=Math.min(b,t.points.length),i=1;i<3;i++)for(_=p,e=0;e<b;e++)o=t.points[e].scrCoords,isNaN(o[1])||isNaN(o[2])?_=p:(o[1]>2e4?o[1]=2e4:o[1]<-2e4&&(o[1]=-2e4),o[2]>2e4?o[2]=2e4:o[2]<-2e4&&(o[2]=-2e4),_===p?h.push([_,u(d*o[1])," ",u(d*o[2])].join("")):(r=2*i,h.push([_,u(d*(n+.333*(o[1]-n)+c*(r*Math.random()-i)))," ",u(d*(a+.333*(o[2]-a)+c*(r*Math.random()-i)))," ",u(d*(n+.666*(o[1]-n)+c*(r*Math.random()-i)))," ",u(d*(a+.666*(o[2]-a)+c*(r*Math.random()-i)))," ",u(d*o[1])," ",u(d*o[2])].join(""))),_=" c ",n=o[1],a=o[2]);return h.push(" e"),h},updatePolygonPrim:function(t,e){var i,s,r=e.vertices.length,o=this.resolution,n=[];if(this._setAttr(t,"stroked","false"),s=e.vertices[0].coords.scrCoords,!isNaN(s[1]+s[2])){for(n.push(["m ",Math.floor(o*s[1]),",",Math.floor(o*s[2])," l "].join("")),i=1;i<r-1;i++){if(!e.vertices[i].isReal)return void this.updatePathPrim(t,"",e.board);if(s=e.vertices[i].coords.scrCoords,isNaN(s[1]+s[2]))return;n.push(Math.floor(o*s[1])+","+Math.floor(o*s[2])),i<r-2&&n.push(", ")}n.push(" x e"),this.updatePathPrim(t,n,e.board)}},updateRectPrim:function(t,e,i,s,r){t.style.left=Math.floor(e)+"px",t.style.top=Math.floor(i)+"px",s>=0&&(t.style.width=s+"px"),r>=0&&(t.style.height=r+"px")},setPropertyPrim:function(t,e,i){var r,o="";switch(e){case"stroke":o="strokecolor";break;case"stroke-width":o="strokeweight";break;case"stroke-dasharray":o="dashstyle"}""!==o&&(r=s.Z.evaluate(i),this._setAttr(t,o,r))},display:function(t,e){t&&t.rendNode&&(t.visPropOld.visible=e,t.rendNode.style.visibility=e?"inherit":"hidden")},show:function(e){t.Z.deprecated("Board.renderer.show()","Board.renderer.display()"),e&&e.rendNode&&(e.rendNode.style.visibility="inherit")},hide:function(e){t.Z.deprecated("Board.renderer.hide()","Board.renderer.display()"),e&&e.rendNode&&(e.rendNode.style.visibility="hidden")},setDashStyle:function(t,e){var i;e.dash>=0&&(i=t.rendNodeStroke,this._setAttr(i,"dashstyle",this.dashArray[e.dash]))},setGradient:function(t){var e=t.rendNodeFill,i=s.Z.evaluate(t.visProp.gradient);"linear"===i?(this._setAttr(e,"type","gradient"),this._setAttr(e,"color2",s.Z.evaluate(t.visProp.gradientsecondcolor)),this._setAttr(e,"opacity2",s.Z.evaluate(t.visProp.gradientsecondopacity)),this._setAttr(e,"angle",s.Z.evaluate(t.visProp.gradientangle))):"radial"===i?(this._setAttr(e,"type","gradientradial"),this._setAttr(e,"color2",s.Z.evaluate(t.visProp.gradientsecondcolor)),this._setAttr(e,"opacity2",s.Z.evaluate(t.visProp.gradientsecondopacity)),this._setAttr(e,"focusposition",100*s.Z.evaluate(t.visProp.gradientpositionx)+"%,"+100*s.Z.evaluate(t.visProp.gradientpositiony)+"%"),this._setAttr(e,"focussize","0,0")):this._setAttr(e,"type","solid")},setObjectFillColor:function(t,e,r){var o,n,a,h=s.Z.evaluate(e),l=s.Z.evaluate(r),c=t.rendNode;l=l>0?l:0,t.visPropOld.fillcolor===h&&t.visPropOld.fillopacity===l||(s.Z.exists(h)&&!1!==h&&(9!==h.length?(o=h,a=l):(o=(n=L.Z.rgba2rgbo(h))[0],a=l*n[1]),"none"===o||!1===o?this._setAttr(t.rendNode,"filled","false"):(this._setAttr(t.rendNode,"filled","true"),this._setAttr(t.rendNode,"fillcolor",o),s.Z.exists(a)&&t.rendNodeFill&&this._setAttr(t.rendNodeFill,"opacity",100*a+"%")),t.type===i.Z.OBJECT_TYPE_IMAGE&&c.filters.length>1&&(c.filters.item(1).opacity=Math.round(100*a),c.filters.item(1).enabled=!0)),t.visPropOld.fillcolor=h,t.visPropOld.fillopacity=l)},setObjectStrokeColor:function(t,e,r){var o,n,a,h,l=s.Z.evaluate(e),c=s.Z.evaluate(r),d=t.rendNode;c=c>0?c:0,t.visPropOld.strokecolor===l&&t.visPropOld.strokeopacity===c||(s.Z.exists(l)&&!1!==l&&(9!==l.length?(o=l,a=c):(o=(n=e.rgba2rgbo(l))[0],a=c*n[1]),t.elementClass===i.Z.OBJECT_CLASS_TEXT?(d.filters.length>1&&(d.filters.item(1).opacity=Math.round(100*a),d.filters.item(1).enabled=!0),d.style.color=o):(!1!==o&&(this._setAttr(d,"stroked","true"),this._setAttr(d,"strokecolor",o)),h=t.rendNodeStroke,s.Z.exists(a)&&t.type!==i.Z.OBJECT_TYPE_IMAGE&&this._setAttr(h,"opacity",100*a+"%"))),t.visPropOld.strokecolor=l,t.visPropOld.strokeopacity=c)},setObjectStrokeWidth:function(t,e){var i,r=s.Z.evaluate(e);isNaN(r)||t.visPropOld.strokewidth===r||(i=t.rendNode,this.setPropertyPrim(i,"stroked","true"),s.Z.exists(r)&&(this.setPropertyPrim(i,"stroke-width",r),0===r&&s.Z.exists(t.rendNodeStroke)&&this._setAttr(i,"stroked","false")),t.visPropOld.strokewidth=r)},setShadow:function(t){var e=t.rendNodeShadow,i=s.Z.evaluate(t.visProp.shadow);e&&t.visPropOld.shadow!==i&&(i?(this._setAttr(e,"On","True"),this._setAttr(e,"Offset","3pt,3pt"),this._setAttr(e,"Opacity","60%"),this._setAttr(e,"Color","#aaaaaa")):this._setAttr(e,"On","False"),t.visPropOld.shadow=i)},suspendRedraw:function(){this.container.style.display="none"},unsuspendRedraw:function(){this.container.style.display=""}});const j=t.Z.VMLRenderer;var X="0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz".split("");t.Z.Util=t.Z.Util||{},t.Z.Util.genUUID=function(t){var e,i,s=[],r=0;for(""!==(t=t||"")&&"-"!==t.substr(t.length-1)&&(t+="-"),i=0;i<36;i++)8===i||13===i||18===i||23===i?s[i]="-":14===i?s[i]="4":(r<=2&&(r=33554432+16777216*Math.random()|0),e=15&r,r>>=4,s[i]=X[19===i?3&e|8:e]);return t+s.join("")};const U=t.Z.Util;t.Z.CanvasRenderer=function(i,s){if(this.type="canvas",this.canvasRoot=null,this.suspendHandle=null,this.canvasId=U.genUUID(),this.canvasNamespace=null,e.Z.isBrowser)this.container=i,this.container.style.MozUserSelect="none",this.container.style.userSelect="none",this.container.style.overflow="hidden",""===this.container.style.position&&(this.container.style.position="relative"),this.container.innerHTML=['<canvas id="',this.canvasId,'" width="',s.width,'px" height="',s.height,'px"><',"/canvas>"].join(""),this.canvasRoot=this.container.ownerDocument.getElementById(this.canvasId),this.canvasRoot.style.display="block",this.context=this.canvasRoot.getContext("2d");else if(e.Z.isNode())try{this.canvasRoot=t.Z.createCanvas(500,500),this.context=this.canvasRoot.getContext("2d")}catch(t){throw new Error('JXG.createCanvas not available.\nInstall the npm package `canvas`\nand call:\n    import { createCanvas } from "canvas";\n    JXG.createCanvas = createCanvas;\n')}this.dashArray=[[2,2],[5,5],[10,10],[20,20],[20,10,10,10],[20,5,10,5]]},t.Z.CanvasRenderer.prototype=new A,t.Z.extend(t.Z.CanvasRenderer.prototype,{_drawPolygon:function(t,e,i){var s,r=t.length,o=this.context;if(r>0){if(i&&(o.lineWidth=0),o.beginPath(),o.moveTo(t[0][0],t[0][1]),1===e)for(s=1;s<r;s++)o.lineTo(t[s][0],t[s][1]);else for(s=1;s<r;s+=3)o.bezierCurveTo(t[s][0],t[s][1],t[s+1][0],t[s+1][1],t[s+2][0],t[s+2][1]);i?(o.lineTo(t[0][0],t[0][1]),o.closePath(),o.fill("evenodd")):o.stroke()}},_fill:function(t){var e=this.context;e.save(),this._setColor(t,"fill")&&e.fill("evenodd"),e.restore()},_rotatePoint:function(t,e,i){return[e*Math.cos(t)-i*Math.sin(t),e*Math.sin(t)+i*Math.cos(t)]},_rotateShape:function(t,e){var i,s=[],r=t.length;if(r<=0)return t;for(i=0;i<r;i++)s.push(this._rotatePoint(e,t[i][0],t[i][1]));return s},updateGradientAngle:function(t,e){var s,r,o,n,a,h,l,d,u,p,_,f,b=1,g=Math.cos(-e),m=Math.sin(-e),v=t.getBoundingBox();return Math.abs(g)>Math.abs(m)?b/=Math.abs(g):b/=Math.abs(m),g>=0?(o=0,n=g*b):(o=-g*b,n=0),m>=0?(a=0,h=m*b):(a=-m*b,h=0),s=new c.Z(i.Z.COORDS_BY_USER,[v[0],v[1]],t.board),_=(r=new c.Z(i.Z.COORDS_BY_USER,[v[2],v[3]],t.board)).scrCoords[1]-s.scrCoords[1],f=r.scrCoords[2]-s.scrCoords[2],l=s.scrCoords[1]+_*o,u=s.scrCoords[2]+f*a,d=s.scrCoords[1]+_*n,p=s.scrCoords[2]+f*h,this.context.createLinearGradient(l,u,d,p)},updateGradientCircle:function(t,e,s,r,o,n,a){var h,l,d,u,p,_,f,b,g,m,v=t.getBoundingBox();return h=new c.Z(i.Z.COORDS_BY_USER,[v[0],v[1]],t.board),g=(l=new c.Z(i.Z.COORDS_BY_USER,[v[2],v[3]],t.board)).scrCoords[1]-h.scrCoords[1],m=h.scrCoords[2]-l.scrCoords[2],d=h.scrCoords[1]+g*e,u=l.scrCoords[2]+m*s,_=h.scrCoords[1]+g*o,f=l.scrCoords[2]+m*n,p=r*(g+m)*.5,b=a*(g+m)*.5,this.context.createRadialGradient(_,f,b,d,u,p)},updateGradient:function(t){var e,i,r,o=s.Z.evaluate(t.visProp.gradient);return i=(i=s.Z.evaluate(t.visProp.fillopacity))>0?i:0,e=s.Z.evaluate(t.visProp.fillcolor),"linear"===o?r=this.updateGradientAngle(t,s.Z.evaluate(t.visProp.gradientangle)):"radial"===o&&(r=this.updateGradientCircle(t,s.Z.evaluate(t.visProp.gradientcx),s.Z.evaluate(t.visProp.gradientcy),s.Z.evaluate(t.visProp.gradientr),s.Z.evaluate(t.visProp.gradientfx),s.Z.evaluate(t.visProp.gradientfy),s.Z.evaluate(t.visProp.gradientfr))),r.addColorStop(s.Z.evaluate(t.visProp.gradientstartoffset),e),r.addColorStop(s.Z.evaluate(t.visProp.gradientendoffset),s.Z.evaluate(t.visProp.gradientsecondcolor)),r},_setColor:function(t,e,i){var r,o,n,a,h,l,c,d,u=!0,p=t.visProp;return e=e||"stroke",i=i||e,r=this._getHighlighted(t),"linear"===(d=s.Z.evaluate(t.visProp.gradient))||"radial"===d?(this.context[i+"Style"]=this.updateGradient(t),u):("none"!==(n=s.Z.evaluate(p[r+e+"color"]))&&!1!==n?(l=(l=s.Z.evaluate(p[r+e+"opacity"]))>0?l:0,9!==n.length?(h=n,c=l):(h=(a=L.Z.rgba2rgbo(n))[0],c=l*a[1]),this.context.globalAlpha=c,this.context[i+"Style"]=h):u=!1,o=parseFloat(s.Z.evaluate(p[r+"strokewidth"])),"stroke"!==e||isNaN(o)||(0===o?this.context.globalAlpha=0:this.context.lineWidth=o),"stroke"===e&&void 0!==p.linecap&&""!==p.linecap&&(this.context.lineCap=p.linecap),u)},_stroke:function(t){var e=this.context,i=s.Z.evaluate(t.visProp.dash);e.save(),i>0?e.setLineDash&&e.setLineDash(this.dashArray[i]):this.context.lineDashArray=[],this._setColor(t,"stroke")&&e.stroke(),e.restore()},_translateShape:function(t,e,i){var s,r=[],o=t.length;if(o<=0)return t;for(s=0;s<o;s++)r.push([t[s][0]+e,t[s][1]+i]);return r},drawPoint:function(t){var e=s.Z.evaluate(t.visProp.face),i=s.Z.evaluate(t.visProp.size),r=t.coords.scrCoords,o=i*Math.sqrt(3)*.5,n=.5*i,a=parseFloat(s.Z.evaluate(t.visProp.strokewidth))/2,h=this.context;if(t.visPropCalc.visible)switch(e){case"cross":case"x":h.beginPath(),h.moveTo(r[1]-i,r[2]-i),h.lineTo(r[1]+i,r[2]+i),h.moveTo(r[1]+i,r[2]-i),h.lineTo(r[1]-i,r[2]+i),h.lineCap="round",h.lineJoin="round",h.closePath(),this._stroke(t);break;case"circle":case"o":h.beginPath(),h.arc(r[1],r[2],i+1+a,0,2*Math.PI,!1),h.closePath(),this._fill(t),this._stroke(t);break;case"square":case"[]":if(i<=0)break;h.save(),this._setColor(t,"stroke","fill")&&h.fillRect(r[1]-i-a,r[2]-i-a,2*i+3*a,2*i+3*a),h.restore(),h.save(),this._setColor(t,"fill"),h.fillRect(r[1]-i+a,r[2]-i+a,2*i-a,2*i-a),h.restore();break;case"plus":case"+":h.beginPath(),h.moveTo(r[1]-i,r[2]),h.lineTo(r[1]+i,r[2]),h.moveTo(r[1],r[2]-i),h.lineTo(r[1],r[2]+i),h.lineCap="round",h.lineJoin="round",h.closePath(),this._stroke(t);break;case"divide":case"|":h.beginPath(),h.moveTo(r[1],r[2]-i),h.lineTo(r[1],r[2]+i),h.lineCap="round",h.lineJoin="round",h.closePath(),this._stroke(t);break;case"minus":case"-":h.beginPath(),h.moveTo(r[1]-i,r[2]),h.lineTo(r[1]+i,r[2]),h.lineCap="round",h.lineJoin="round",h.closePath(),this._stroke(t);break;case"diamond":case"<>":h.beginPath(),h.moveTo(r[1]-i,r[2]),h.lineTo(r[1],r[2]+i),h.lineTo(r[1]+i,r[2]),h.lineTo(r[1],r[2]-i),h.closePath(),this._fill(t),this._stroke(t);break;case"triangleup":case"a":case"^":h.beginPath(),h.moveTo(r[1],r[2]-i),h.lineTo(r[1]-o,r[2]+n),h.lineTo(r[1]+o,r[2]+n),h.closePath(),this._fill(t),this._stroke(t);break;case"triangledown":case"v":h.beginPath(),h.moveTo(r[1],r[2]+i),h.lineTo(r[1]-o,r[2]-n),h.lineTo(r[1]+o,r[2]-n),h.closePath(),this._fill(t),this._stroke(t);break;case"triangleleft":case"<":h.beginPath(),h.moveTo(r[1]-i,r[2]),h.lineTo(r[1]+n,r[2]-o),h.lineTo(r[1]+n,r[2]+o),h.closePath(),this._fill(t),this._stroke(t);break;case"triangleright":case">":h.beginPath(),h.moveTo(r[1]+i,r[2]),h.lineTo(r[1]-n,r[2]-o),h.lineTo(r[1]-n,r[2]+o),h.closePath(),this._fill(t),this._stroke(t)}},updatePoint:function(t){this.drawPoint(t)},drawArrows:function(t,e,r,o,n){var a,h,l,c,d,u,p,_,f,b,g,m,v,Z,C,y,P,E,O,x,w=this.context,S=1,T=1,M=1,N=n.evFirst,A=n.evLast;if("none"!==s.Z.evaluate(t.visProp.strokecolor)&&(N||A)){if(t.elementClass===i.Z.OBJECT_CLASS_LINE)a=e.scrCoords[1],h=e.scrCoords[2],l=r.scrCoords[1],c=r.scrCoords[2],O=x=Math.atan2(c-h,l-a);else{if(a=t.points[0].scrCoords[1],h=t.points[0].scrCoords[2],(E=t.points.length-1)<1)return;l=t.points[t.points.length-1].scrCoords[1],c=t.points[t.points.length-1].scrCoords[2],Z=t.points[1].scrCoords[1]-t.points[0].scrCoords[1],C=t.points[1].scrCoords[2]-t.points[0].scrCoords[2],y=t.points[E].scrCoords[1]-t.points[E-1].scrCoords[1],P=t.points[E].scrCoords[2]-t.points[E-1].scrCoords[2],N&&(O=Math.atan2(C,Z)),A&&(x=Math.atan2(P,y))}if(d=s.Z.evaluate(t.visProp[o+"strokewidth"]),N)if(u=d*n.sizeFirst,f=S=n.typeFirst,2===S)_=[[u,.5*-u],[0,0],[u,.5*u],[.5*u,0]];else if(3===S)_=[[u/3,.5*-u],[0,.5*-u],[0,.5*u],[u/3,.5*u]];else if(4===S)for(u/=10,T=3,v=(_=[[10,3.31],[6.47,3.84],[2.87,4.5],[0,6.63],[.67,5.52],[1.33,4.42],[2,3.31],[1.33,2.21],[.67,1.1],[0,0],[2.87,2.13],[6.47,2.79],[10,3.31]]).length,m=0;m<v;m++)_[m][0]*=-u,_[m][1]*=u,_[m][0]+=10*u,_[m][1]-=3.31*u;else if(5===S)for(u/=10,T=3,v=(_=[[10,3.28],[6.61,4.19],[3.19,5.07],[0,6.55],[.62,5.56],[1,4.44],[1,3.28],[1,2.11],[.62,.99],[0,0],[3.19,1.49],[6.61,2.37],[10,3.28]]).length,m=0;m<v;m++)_[m][0]*=-u,_[m][1]*=u,_[m][0]+=10*u,_[m][1]-=3.28*u;else if(6===S)for(u/=10,T=3,v=(_=[[10,2.84],[6.61,3.59],[3.21,4.35],[0,5.68],[.33,4.73],[.67,3.78],[1,2.84],[.67,1.89],[.33,.95],[0,0],[3.21,1.33],[6.61,2.09],[10,2.84]]).length,m=0;m<v;m++)_[m][0]*=-u,_[m][1]*=u,_[m][0]+=10*u,_[m][1]-=2.84*u;else if(7===S)for(u=d,T=3,v=(_=[[0,10.39],[2.01,6.92],[5.96,5.2],[10,5.2],[5.96,5.2],[2.01,3.47],[0,0]]).length,m=0;m<v;m++)_[m][0]*=-u,_[m][1]*=u,_[m][0]+=10*u,_[m][1]-=5.2*u;else _=[[u,.5*-u],[0,0],[u,.5*u]];if(A)if(u=d*n.sizeLast,b=S=n.typeLast,2===S)p=[[-u,.5*-u],[0,0],[-u,.5*u],[.5*-u,0]];else if(3===S)p=[[-u/3,.5*-u],[0,.5*-u],[0,.5*u],[-u/3,.5*u]];else if(4===S)for(u/=10,M=3,v=(p=[[10,3.31],[6.47,3.84],[2.87,4.5],[0,6.63],[.67,5.52],[1.33,4.42],[2,3.31],[1.33,2.21],[.67,1.1],[0,0],[2.87,2.13],[6.47,2.79],[10,3.31]]).length,m=0;m<v;m++)p[m][0]*=u,p[m][1]*=u,p[m][0]-=10*u,p[m][1]-=3.31*u;else if(5===S)for(u/=10,M=3,v=(p=[[10,3.28],[6.61,4.19],[3.19,5.07],[0,6.55],[.62,5.56],[1,4.44],[1,3.28],[1,2.11],[.62,.99],[0,0],[3.19,1.49],[6.61,2.37],[10,3.28]]).length,m=0;m<v;m++)p[m][0]*=u,p[m][1]*=u,p[m][0]-=10*u,p[m][1]-=3.28*u;else if(6===S)for(u/=10,M=3,v=(p=[[10,2.84],[6.61,3.59],[3.21,4.35],[0,5.68],[.33,4.73],[.67,3.78],[1,2.84],[.67,1.89],[.33,.95],[0,0],[3.21,1.33],[6.61,2.09],[10,2.84]]).length,m=0;m<v;m++)p[m][0]*=u,p[m][1]*=u,p[m][0]-=10*u,p[m][1]-=2.84*u;else if(7===S)for(u=d,M=3,v=(p=[[0,10.39],[2.01,6.92],[5.96,5.2],[10,5.2],[5.96,5.2],[2.01,3.47],[0,0]]).length,m=0;m<v;m++)p[m][0]*=u,p[m][1]*=u,p[m][0]-=10*u,p[m][1]-=5.2*u;else p=[[-u,.5*-u],[0,0],[-u,.5*u]];w.save(),this._setColor(t,"stroke","fill")&&(this._setColor(t,"stroke"),N&&(g=7!==f,this._drawPolygon(this._translateShape(this._rotateShape(_,O),a,h),T,g)),A&&(g=7!==b,this._drawPolygon(this._translateShape(this._rotateShape(p,x),l,c),M,g))),w.restore()}},drawLine:function(t){var e,r,o,n,a,h=new c.Z(i.Z.COORDS_BY_USER,t.point1.coords.usrCoords,t.board),l=new c.Z(i.Z.COORDS_BY_USER,t.point2.coords.usrCoords,t.board),d=null;t.visPropCalc.visible&&(o=this._getHighlighted(t),n=s.Z.evaluate(t.visProp[o+"strokewidth"]),((a=this.getArrowHeadData(t,n,o)).evFirst||a.evLast)&&(d=-4),u.Z.calcStraight(t,h,l,d),this.handleTouchpoints(t,h,l,a),e=new c.Z(i.Z.COORDS_BY_USER,h.usrCoords,t.board),r=new c.Z(i.Z.COORDS_BY_USER,l.usrCoords,t.board),this.getPositionArrowHead(t,h,l,a),this.context.beginPath(),this.context.moveTo(h.scrCoords[1],h.scrCoords[2]),this.context.lineTo(l.scrCoords[1],l.scrCoords[2]),this._stroke(t),(a.evFirst||a.evLast)&&this.drawArrows(t,e,r,o,a))},updateLine:function(t){this.drawLine(t)},drawTicks:function(){},updateTicks:function(t){var e,i,s,r,o,n,a=t.ticks.length,h=this.context;for(h.beginPath(),e=0;e<a;e++)for(s=(i=t.ticks[e])[0],r=i[1],o=s.length,h.moveTo(s[0],r[0]),n=1;n<o;++n)h.lineTo(s[n],r[n]);h.lineCap="round",this._stroke(t)},drawCurve:function(t){var e,i,r;s.Z.evaluate(t.visProp.handdrawing)?this.updatePathStringBezierPrim(t):this.updatePathStringPrim(t),t.numberPoints>1&&(e=this._getHighlighted(t),i=s.Z.evaluate(t.visProp[e+"strokewidth"]),((r=this.getArrowHeadData(t,i,e)).evFirst||r.evLast)&&this.drawArrows(t,null,null,e,r))},updateCurve:function(t){this.drawCurve(t)},drawEllipse:function(t){var e=t.center.coords.scrCoords[1],i=t.center.coords.scrCoords[2],s=t.board.unitX,r=t.board.unitY,o=2*t.Radius(),n=2*t.Radius(),a=o*s,h=n*r,l=e-a/2,c=i-h/2,d=a/2*.5522848,u=h/2*.5522848,p=l+a,_=c+h,f=l+a/2,b=c+h/2,g=this.context;o>0&&n>0&&!isNaN(e+i)&&(g.beginPath(),g.moveTo(l,b),g.bezierCurveTo(l,b-u,f-d,c,f,c),g.bezierCurveTo(f+d,c,p,b-u,p,b),g.bezierCurveTo(p,b+u,f+d,_,f,_),g.bezierCurveTo(f-d,_,l,b+u,l,b),g.closePath(),this._fill(t),this._stroke(t))},updateEllipse:function(t){return this.drawEllipse(t)},displayCopyright:function(t,e){var i=this.context;i.save(),i.font=e+"px Arial",i.fillStyle="#aaa",i.lineWidth=.5,i.fillText(t,10,2+e),i.restore()},drawInternalText:function(t){var e=s.Z.evaluate(t.visProp.fontsize),i=s.Z.evaluate(t.visProp.fontunit),r=t.getAnchorX(),o=t.getAnchorY(),n=this.context;return n.save(),this._setColor(t,"stroke","fill")&&!isNaN(t.coords.scrCoords[1]+t.coords.scrCoords[2])&&(n.font=(e>0?e:0)+i+" Arial",this.transformImage(t,t.transformations),"left"===r?n.textAlign="left":"right"===r?n.textAlign="right":"middle"===r&&(n.textAlign="center"),"bottom"===o?n.textBaseline="bottom":"top"===o?n.textBaseline="top":"middle"===o&&(n.textBaseline="middle"),n.fillText(t.plaintext,t.coords.scrCoords[1],t.coords.scrCoords[2])),n.restore(),null},updateInternalText:function(t){this.drawInternalText(t)},setObjectStrokeColor:function(t,e,r){var o,n,a,h,l=s.Z.evaluate(e),c=s.Z.evaluate(r);c=c>0?c:0,t.visPropOld.strokecolor===l&&t.visPropOld.strokeopacity===c||(s.Z.exists(l)&&!1!==l&&(9!==l.length?(o=l,a=c):(o=(n=L.Z.rgba2rgbo(l))[0],a=c*n[1]),h=t.rendNode,t.elementClass===i.Z.OBJECT_CLASS_TEXT&&"html"===s.Z.evaluate(t.visProp.display)&&(h.style.color=o,h.style.opacity=a)),t.visPropOld.strokecolor=l,t.visPropOld.strokeopacity=c)},drawImage:function(t){t.rendNode=new Image,t._src="",this.updateImage(t)},updateImage:function(t){var e=this.context,i=s.Z.evaluate(t.visProp.fillopacity),r=s.Z.bind((function(){t.imgIsLoaded=!0,t.size[0]<=0||t.size[1]<=0||(e.save(),e.globalAlpha=i,this.transformImage(t,t.transformations),e.drawImage(t.rendNode,t.coords.scrCoords[1],t.coords.scrCoords[2]-t.size[1],t.size[0],t.size[1]),e.restore())}),this);this.updateImageURL(t)?t.rendNode.onload=r:t.imgIsLoaded&&r()},transformImage:function(t,e){var i,s=e.length,r=this.context;s>0&&(i=this.joinTransforms(t,e),Math.abs(l.Z.det(i))>=o.Z.eps&&r.transform(i[1][1],i[2][1],i[1][2],i[2][2],i[1][0],i[2][0]))},updateImageURL:function(t){var e;return e=s.Z.evaluate(t.url),t._src!==e&&(t.imgIsLoaded=!1,t.rendNode.src=e,t._src=e,!0)},remove:function(t){s.Z.exists(t)&&s.Z.exists(t.parentNode)&&t.parentNode.removeChild(t)},updatePathStringPrim:function(t){var e,i,s,r,o,n="M",a=n,h=5e3,l=this.context;if(!(t.numberPoints<=0)){if(o=Math.min(t.points.length,t.numberPoints),l.beginPath(),1===t.bezierDegree)for(e=0;e<o;e++)i=t.points[e].scrCoords,isNaN(i[1])||isNaN(i[2])?a=n:(i[1]>h?i[1]=h:i[1]<-5e3&&(i[1]=-5e3),i[2]>h?i[2]=h:i[2]<-5e3&&(i[2]=-5e3),a===n?l.moveTo(i[1],i[2]):l.lineTo(i[1],i[2]),a="L");else if(3===t.bezierDegree)for(e=0;e<o;)i=t.points[e].scrCoords,isNaN(i[1])||isNaN(i[2])?a=n:(a===n?l.moveTo(i[1],i[2]):(e+=1,s=t.points[e].scrCoords,e+=1,r=t.points[e].scrCoords,l.bezierCurveTo(i[1],i[2],s[1],s[2],r[1],r[2])),a="C"),e+=1;l.lineCap="round",this._fill(t),this._stroke(t)}},updatePathStringBezierPrim:function(t){var e,i,r,o,n,a,h,c="M",d=c,u=5e3,p=s.Z.evaluate(t.visProp.strokewidth),_="plot"!==s.Z.evaluate(t.visProp.curvetype),f=this.context;if(!(t.numberPoints<=0)){for(_&&t.board.options.curve.RDPsmoothing&&(t.points=l.Z.RamerDouglasPeucker(t.points,.5)),h=Math.min(t.points.length,t.numberPoints),f.beginPath(),i=1;i<3;i++)for(d=c,e=0;e<h;e++)o=t.points[e].scrCoords,isNaN(o[1])||isNaN(o[2])?d=c:(o[1]>u?o[1]=u:o[1]<-5e3&&(o[1]=-5e3),o[2]>u?o[2]=u:o[2]<-5e3&&(o[2]=-5e3),d===c?f.moveTo(o[1],o[2]):(r=2*i,f.bezierCurveTo(n+.333*(o[1]-n)+p*(r*Math.random()-i),a+.333*(o[2]-a)+p*(r*Math.random()-i),n+.666*(o[1]-n)+p*(r*Math.random()-i),a+.666*(o[2]-a)+p*(r*Math.random()-i),o[1],o[2])),d="C",n=o[1],a=o[2]);f.lineCap="round",this._fill(t),this._stroke(t)}},updatePolygonPrim:function(t,e){var i,s,r,o=e.vertices.length,n=this.context,a=!0;if(!(o<=0)&&e.visPropCalc.visible){for("polygonalchain"===e.elType&&o++,n.beginPath(),s=0;!e.vertices[s].isReal&&s<o-1;)s++,a=!1;for(i=e.vertices[s].coords.scrCoords,n.moveTo(i[1],i[2]),r=s;r<o-1;r++)e.vertices[r].isReal||(a=!1),i=e.vertices[r].coords.scrCoords,n.lineTo(i[1],i[2]);n.closePath(),a&&this._fill(e)}},display:function(t,e){t&&t.rendNode&&(t.visPropOld.visible=e,t.rendNode.style.visibility=e?"inherit":"hidden")},show:function(e){t.Z.deprecated("Board.renderer.show()","Board.renderer.display()"),s.Z.exists(e.rendNode)&&(e.rendNode.style.visibility="inherit")},hide:function(e){t.Z.deprecated("Board.renderer.hide()","Board.renderer.display()"),s.Z.exists(e.rendNode)&&(e.rendNode.style.visibility="hidden")},setGradient:function(t){var e;e=(e=s.Z.evaluate(t.visProp.fillopacity))>0?e:0},setShadow:function(t){t.visPropOld.shadow!==t.visProp.shadow&&(t.visPropOld.shadow=t.visProp.shadow)},highlight:function(t){return t.elementClass===i.Z.OBJECT_CLASS_TEXT&&"html"===s.Z.evaluate(t.visProp.display)?this.updateTextStyle(t,!0):(t.board.prepareUpdate(),t.board.renderer.suspendRedraw(t.board),t.board.updateRenderer(),t.board.renderer.unsuspendRedraw()),this},noHighlight:function(t){return t.elementClass===i.Z.OBJECT_CLASS_TEXT&&"html"===s.Z.evaluate(t.visProp.display)?this.updateTextStyle(t,!1):(t.board.prepareUpdate(),t.board.renderer.suspendRedraw(t.board),t.board.updateRenderer(),t.board.renderer.unsuspendRedraw()),this},suspendRedraw:function(e){this.context.save(),this.context.clearRect(0,0,this.canvasRoot.width,this.canvasRoot.height),e&&e.attr.showcopyright&&this.displayCopyright(t.Z.licenseText,12)},unsuspendRedraw:function(){this.context.restore()},resize:function(t,e){this.container?(this.canvasRoot.style.width=parseFloat(t)+"px",this.canvasRoot.style.height=parseFloat(e)+"px",this.canvasRoot.setAttribute("width",2*parseFloat(t)+"px"),this.canvasRoot.setAttribute("height",2*parseFloat(e)+"px")):(this.canvasRoot.width=2*parseFloat(t),this.canvasRoot.height=2*parseFloat(e)),this.context=this.canvasRoot.getContext("2d"),this.context.scale(2,2)},removeToInsertLater:function(){return function(){}}});const F=t.Z.CanvasRenderer;t.Z.NoRenderer=function(){this.enhancedRendering=!1,this.type="no"},t.Z.extend(t.Z.NoRenderer.prototype,{drawPoint:function(t){},updatePoint:function(t){},changePointStyle:function(t){},drawLine:function(t){},updateLine:function(t){},drawTicks:function(t){},updateTicks:function(t){},drawCurve:function(t){},updateCurve:function(t){},drawEllipse:function(t){},updateEllipse:function(t){},drawPolygon:function(t){},updatePolygon:function(t){},displayCopyright:function(t,e){},drawInternalText:function(t){},updateInternalText:function(t){},drawText:function(t){},updateText:function(t){},updateTextStyle:function(t,e){},updateInternalTextStyle:function(t,e,i){},drawImage:function(t){},updateImage:function(t){},transformImage:function(t,e){},updateImageURL:function(t){},appendChildPrim:function(t,e){},appendNodesToElement:function(t,e){},createPrim:function(t,e){return null},remove:function(t){},makeArrows:function(t){},updateEllipsePrim:function(t,e,i,s,r){},updateLinePrim:function(t,e,i,s,r,o){},updatePathPrim:function(t,e,i){},updatePathStringPoint:function(t,e,i){},updatePathStringPrim:function(t){},updatePathStringBezierPrim:function(t){},updatePolygonPrim:function(t,e){},updateRectPrim:function(t,e,i,s,r){},setPropertyPrim:function(t,e,i){},display:function(t,e){t&&(t.visPropOld.visible=e)},show:function(t){},hide:function(t){},setBuffering:function(t,e){},setDashStyle:function(t){},setDraft:function(t){},removeDraft:function(t){},setGradient:function(t){},updateGradient:function(t){},setObjectTransition:function(t,e){},setObjectFillColor:function(t,e,i){},setObjectStrokeColor:function(t,e,i){},setObjectStrokeWidth:function(t,e){},setShadow:function(t){},highlight:function(t){},noHighlight:function(t){},suspendRedraw:function(){},unsuspendRedraw:function(){},drawZoomBar:function(t){},getElementById:function(t){return null},resize:function(t,e){},removeToInsertLater:function(){return function(){}}}),t.Z.NoRenderer.prototype=new A;const J=t.Z.NoRenderer;t.Z.JSXGraph={rendererType:(N.Z.board.renderer="no",e.Z.supportsVML()&&(N.Z.board.renderer="vml",document.onmousemove=function(){var t;return document.body&&(t=document.body.scrollLeft,t+=document.body.scrollTop),t}),e.Z.supportsCanvas()&&(N.Z.board.renderer="canvas"),e.Z.supportsSVG()&&(N.Z.board.renderer="svg"),e.Z.isNode()&&e.Z.supportsCanvas()&&(N.Z.board.renderer="canvas"),(e.Z.isNode()||"no"===N.Z.renderer)&&(N.Z.text.display="internal",N.Z.infobox.display="internal"),N.Z.board.renderer),initRenderer:function(t,e,i,r){var o;if(s.Z.exists(i)&&!1!==i||"object"!=typeof document||(i=document),"object"==typeof i&&null!==t)for(o=i.getElementById(t);o.firstChild;)o.removeChild(o.firstChild);else o=t;return void 0!==r&&"auto"!==r||(r=this.rendererType),"svg"===r?new Y(o,e):"vml"===r?new j(o):"canvas"===r?new F(o,e):new J},_setAttributes:function(t){var e=s.Z.copyAttributes(t,N.Z,"board");return e.zoom=s.Z.copyAttributes(e,N.Z,"board","zoom"),e.pan=s.Z.copyAttributes(e,N.Z,"board","pan"),e.drag=s.Z.copyAttributes(e,N.Z,"board","drag"),e.keyboard=s.Z.copyAttributes(e,N.Z,"board","keyboard"),e.selection=s.Z.copyAttributes(e,N.Z,"board","selection"),e.navbar=s.Z.copyAttributes(e.navbar,N.Z,"navbar"),e.screenshot=s.Z.copyAttributes(e,N.Z,"board","screenshot"),e.resize=s.Z.copyAttributes(e,N.Z,"board","resize"),e.fullscreen=s.Z.copyAttributes(e,N.Z,"board","fullscreen"),e.logging=s.Z.copyAttributes(e,N.Z,"board","logging"),e.movetarget=t.moveTarget||t.movetarget||N.Z.board.moveTarget,e},_fillBoard:function(e,i,s){e.initInfobox(),e.maxboundingbox=i.maxboundingbox,e.resizeContainer(s.width,s.height,!0,!0),e._createSelectionPolygon(i),e.renderer.drawZoomBar(e,i.navbar),t.Z.boards[e.id]=e},_setARIA:function(t,i){var s,r,o,n,a,h,l=i.document;if("object"!=typeof l){if(!e.Z.isBrowser)return;l=document}s=(r=l.getElementById(t)).ownerDocument,n=r.parentNode,a=t+"_ARIAlabel",h=t+"_ARIAdescription",(o=s.createElement("div")).innerHTML=i.title,o.setAttribute("id",a),o.style.display="none",n.insertBefore(o,r),(o=s.createElement("div")).innerHTML=i.description,o.setAttribute("id",h),o.style.display="none",n.insertBefore(o,r),r.setAttribute("aria-labelledby",a),r.setAttribute("aria-describedby",h)},_removeARIANodes:function(t){var e,i,s;"object"==typeof(s=t.document||document)&&(i=t.containerObj.getAttribute("aria-labelledby"),(e=s.getElementById(i))&&e.parentNode&&e.parentNode.removeChild(e),i=t.containerObj.getAttribute("aria-describedby"),(e=s.getElementById(i))&&e.parentNode&&e.parentNode.removeChild(e))},initBoard:function(t,i){var r,o,n,a,h,l,c,d,u,p,_,f,b,g,m=0,v=0;return i=i||{},p=this._setAttributes(i),d=e.Z.getDimensions(t,p.document),p.unitx||p.unity?(r=s.Z.def(p.originx,150),o=s.Z.def(p.originy,150),n=s.Z.def(p.unitx,50),a=s.Z.def(p.unity,50)):((u=p.boundingbox)[0]<p.maxboundingbox[0]&&(u[0]=p.maxboundingbox[0]),u[1]>p.maxboundingbox[1]&&(u[1]=p.maxboundingbox[1]),u[2]>p.maxboundingbox[2]&&(u[2]=p.maxboundingbox[2]),u[3]<p.maxboundingbox[3]&&(u[3]=p.maxboundingbox[3]),l=parseInt(d.width,10),c=parseInt(d.height,10),s.Z.exists(u)&&p.keepaspectratio?(n=l/(u[2]-u[0]),a=c/(u[1]-u[3]),Math.abs(n)<Math.abs(a)?v=.5*(c/(a=Math.abs(n)*a/Math.abs(a))-(u[1]-u[3])):m=.5*(l/(n=Math.abs(a)*n/Math.abs(n))-(u[2]-u[0]))):(n=l/(u[2]-u[0]),a=c/(u[1]-u[3])),r=-n*(u[0]-m),o=a*(u[1]+v)),h=this.initRenderer(t,d,p.document,p.renderer),this._setARIA(t,p),(g=new I(t,h,p.id,[r,o],p.zoomfactor*p.zoomx,p.zoomfactor*p.zoomy,n,a,d.width,d.height,p)).keepaspectratio=p.keepaspectratio,this._fillBoard(g,p,d),g.suspendUpdate(),p.axis&&(_="object"==typeof p.axis?p.axis:{},f=s.Z.deepCopy(N.Z.board.defaultAxes.x,_),b=s.Z.deepCopy(N.Z.board.defaultAxes.y,_),p.defaultaxes.x&&(f=s.Z.deepCopy(f,p.defaultaxes.x)),p.defaultaxes.y&&(b=s.Z.deepCopy(b,p.defaultaxes.y)),g.defaultAxes={},g.defaultAxes.x=g.create("axis",[[0,0],[1,0]],f),g.defaultAxes.y=g.create("axis",[[0,0],[0,1]],b)),p.grid&&g.create("grid",[],"object"==typeof p.grid?p.grid:{}),g.unsuspendUpdate(),g},loadBoardFromFile:function(t,i,s,r,o){var n,a,h,l,c;return r=r||{},n=this._setAttributes(r),l=e.Z.getDimensions(t,n.document),a=this.initRenderer(t,l,n.document,n.renderer),this._setARIA(t,n),h=new I(t,a,"",[150,150],1,1,50,50,l.width,l.height,n),this._fillBoard(h,n,l),c=n.encoding||"iso-8859-1",k.parseFileContent(i,h,s,!0,c,o),h},loadBoardFromString:function(t,i,s,r,o){var n,a,h,l;return r=r||{},n=this._setAttributes(r),l=e.Z.getDimensions(t,n.document),a=this.initRenderer(t,l,n.document,n.renderer),this._setARIA(t,n),h=new I(t,a,"",[150,150],1,1,50,50,l.width,l.height,n),this._fillBoard(h,n,l),k.parseString(i,h,s,!0,o),h},freeBoard:function(e){var i;for(i in"string"==typeof e&&(e=t.Z.boards[e]),this._removeARIANodes(e),e.removeEventHandlers(),e.suspendUpdate(),e.objects)e.objects.hasOwnProperty(i)&&e.objects[i].remove();for(;e.containerObj.firstChild;)e.containerObj.removeChild(e.containerObj.firstChild);for(i in e.objects)e.objects.hasOwnProperty(i)&&delete e.objects[i];delete e.renderer,e.jc.creator.clearCache(),delete e.jc,delete t.Z.boards[e.id]},registerElement:function(e,i){t.Z.deprecated("JXG.JSXGraph.registerElement()","JXG.registerElement()"),t.Z.registerElement(e,i)}},e.Z.isBrowser&&"object"==typeof window&&"object"==typeof document&&e.Z.addEvent(window,"load",(function(){var e,i,r,o,n,a,h,l,c,d,u,p,_,f,b,g,m,v,Z=!1,C=document.getElementsByTagName("script"),y=function(e,i,s){var r=t.Z.JSXGraph.initBoard(n,{boundingbox:s,keepaspectratio:!0,grid:b,axis:f,showReload:!0});if(i.toLowerCase().indexOf("script")>-1)r.construct(e);else try{r.jc.parse(e)}catch(e){t.Z.debug(e)}return r},P=function(e,i,s,r){return function(){var o;t.Z.JSXGraph.freeBoard(e),(o=y(i,s,r)).reload=P(o,i,s,r)}};for(i=0;i<C.length;i++)if(e=C[i].getAttribute("type",!1),s.Z.exists(e)&&("text/jessiescript"===e.toLowerCase()||"jessiescript"===e.toLowerCase()||"text/jessiecode"===e.toLowerCase()||"jessiecode"===e.toLowerCase())){if(p=C[i].getAttribute("class",!1)||"",l=C[i].getAttribute("width",!1)||"",c=C[i].getAttribute("height",!1)||"",d=C[i].getAttribute("maxwidth",!1)||"100%",u=C[i].getAttribute("aspectratio",!1)||"1/1",_=C[i].getAttribute("boundingbox",!1)||"-5, 5, 5, -5",n=C[i].getAttribute("container",!1),m=C[i].getAttribute("src",!1),4!==(_=_.split(",")).length)_=[-5,5,5,-5];else for(r=0;r<_.length;r++)_[r]=parseFloat(_[r]);if(f=s.Z.str2Bool(C[i].getAttribute("axis",!1)||"false"),b=s.Z.str2Bool(C[i].getAttribute("grid",!1)||"false"),s.Z.exists(n))o=document.getElementById(n);else{n="jessiescript_autgen_jxg_"+i,(o=document.createElement("div")).setAttribute("id",n),h=""!==l?"width:"+l+";":"",h+=""!==c?"height:"+c+";":"",h+=""!==d?"max-width:"+d+";":"",h+=""!==u?"aspect-ratio:"+u+";":"",o.setAttribute("style",h),o.setAttribute("class","jxgbox "+p);try{document.body.insertBefore(o,C[i])}catch(t){"object"==typeof jQuery&&jQuery(o).insertBefore(C[i])}}g="",s.Z.exists(m)?(Z=!0,(v=new XMLHttpRequest).open("GET",m),v.overrideMimeType("text/plain; charset=x-user-defined"),v.addEventListener("load",(function(){if(!(this.status<400))throw new Error("\nJSXGraph: failed to load file",m,":",this.responseText);g=this.responseText+"\n"+g,(a=y(g,e,_)).reload=P(a,g,e,_)})),v.addEventListener("error",(function(t){throw new Error("\nJSXGraph: failed to load file",m,":",t)})),v.send()):Z=!1,document.getElementById(n)?(g=(g=C[i].innerHTML).replace(/<!\[CDATA\[/g,"").replace(/\]\]>/g,""),C[i].innerHTML=g,Z||((a=y(g,e,_)).reload=P(a,g,e,_))):t.Z.debug("JSXGraph: Apparently the div injection failed. Can't create a board, sorry.")}}),window);t.Z.JSXGraph;var G=__webpack_require__(958),z=__webpack_require__(218);t.Z.Point=function(t,e,s){this.constructor(t,s,i.Z.OBJECT_TYPE_POINT,i.Z.OBJECT_CLASS_POINT),this.element=this.board.select(s.anchor),this.coordsConstructor(e),this.elType="point",this.id=this.board.setId(this,"P"),this.board.renderer.drawPoint(this),this.board.finalizeAdding(this),this.createGradient(),this.createLabel()},t.Z.Point.prototype=new G.Z,s.Z.copyPrototypeMethods(t.Z.Point,z.Z,"coordsConstructor"),t.Z.extend(t.Z.Point.prototype,{hasPoint:function(t,e){var i,r,o,n=this.coords.scrCoords,a=s.Z.evaluate(this.visProp.sizeunit);return s.Z.isObject(s.Z.evaluate(this.visProp.precision))?(o=this.board._inputDevice,r=s.Z.evaluate(this.visProp.precision[o])):r=this.board.options.precision.hasPoint,i=parseFloat(s.Z.evaluate(this.visProp.size)),"user"===a&&(i*=Math.sqrt(this.board.unitX*this.board.unitY)),(i+=.5*parseFloat(s.Z.evaluate(this.visProp.strokewidth)))<r&&(i=r),Math.abs(n[1]-t)<i+2&&Math.abs(n[2]-e)<i+2},update:function(t){return this.needsUpdate?(this.updateCoords(t),s.Z.evaluate(this.visProp.trace)&&this.cloneToBackground(!0),this):this},updateTransform:function(t){var e,s;if(0===this.transformations.length||null===this.baseElement)return this;for(this===this.baseElement?(e=this.transformations[0].apply(this.baseElement,"self"),this.coords.setCoordinates(i.Z.COORDS_BY_USER,e)):e=this.transformations[0].apply(this.baseElement),this.coords.setCoordinates(i.Z.COORDS_BY_USER,e),s=1;s<this.transformations.length;s++)this.coords.setCoordinates(i.Z.COORDS_BY_USER,this.transformations[s].apply(this));return this},updateRenderer:function(){return this.updateRendererGeneric("updatePoint"),this},bounds:function(){return this.coords.usrCoords.slice(1).concat(this.coords.usrCoords.slice(1))},makeIntersection:function(t,e,r,o){var n;t=this.board.select(t),e=this.board.select(e),n=u.Z.intersectionFunction(this.board,t,e,r,o,s.Z.evaluate(this.visProp.alwaysintersect)),this.addConstraint([n]);try{t.addChild(this),e.addChild(this)}catch(i){throw new Error("JSXGraph: Can't create 'intersection' with parent types '"+typeof t+"' and '"+typeof e+"'.")}this.type=i.Z.OBJECT_TYPE_INTERSECTION,this.elType="intersection",this.parents=[t.id,e.id,r,o],this.generatePolynomial=function(){var i=t.generatePolynomial(this),s=e.generatePolynomial(this);return 0===i.length||0===s.length?[]:[i[0],s[0]]},this.prepareUpdate().update()},setStyle:function(t){return this.visProp.face=["cross","cross","cross","circle","circle","circle","circle","square","square","square","plus","plus","plus"][t],this.visProp.size=[2,3,4,1,2,3,4,2,3,4,2,3,4][t],this.board.renderer.changePointStyle(this),this},normalizeFace:function(e){return t.Z.deprecated("Point.normalizeFace()","JXG.normalizePointFace()"),N.Z.normalizePointFace(e)},face:function(e){t.Z.deprecated("Point.face()","Point.setAttribute()"),this.setAttribute({face:e})},size:function(e){t.Z.deprecated("Point.size()","Point.setAttribute()"),this.setAttribute({size:e})},isOn:function(e,r){var n,a;return r=r||o.Z.eps,s.Z.isPoint(e)?this.Dist(e)<r:e.elementClass===i.Z.OBJECT_CLASS_LINE?("segment"!==e.elType||s.Z.evaluate(this.visProp.alwaysintersect)||(n=t.Z.Math.Geometry.projectCoordsToSegment(this.coords.usrCoords,e.point1.coords.usrCoords,e.point2.coords.usrCoords))[1]>=0&&n[1]<=1)&&u.Z.distPointLine(this.coords.usrCoords,e.stdform)<r:e.elementClass===i.Z.OBJECT_CLASS_CIRCLE?s.Z.evaluate(e.visProp.hasinnerpoints)?this.Dist(e.center)<e.Radius()+r:Math.abs(this.Dist(e.center)-e.Radius())<r:e.elementClass===i.Z.OBJECT_CLASS_CURVE?(a=u.Z.projectPointToCurve(this,e,this.board)[0],u.Z.distance(this.coords.usrCoords,a.usrCoords,3)<r):e.type===i.Z.OBJECT_TYPE_POLYGON?!(!s.Z.evaluate(e.visProp.hasinnerpoints)||!e.pnpoly(this.coords.usrCoords[1],this.coords.usrCoords[2],t.Z.COORDS_BY_USER))||(n=u.Z.projectCoordsToPolygon(this.coords.usrCoords,e),u.Z.distance(this.coords.usrCoords,n,3)<r):e.type===i.Z.OBJECT_TYPE_TURTLE&&(a=u.Z.projectPointToTurtle(this,e,this.board),u.Z.distance(this.coords.usrCoords,a.usrCoords,3)<r)},cloneToBackground:function(){var t={};return t.id=this.id+"T"+this.numTraces,this.numTraces+=1,t.coords=this.coords,t.visProp=s.Z.deepCopy(this.visProp,this.visProp.traceattributes,!0),t.visProp.layer=this.board.options.layer.trace,t.elementClass=i.Z.OBJECT_CLASS_POINT,t.board=this.board,s.Z.clearVisPropOld(t),t.visPropCalc={visible:s.Z.evaluate(t.visProp.visible)},this.board.renderer.drawPoint(t),this.traces[t.id]=t.rendNode,this}}),t.Z.createPoint=function(e,i,r){var o,n;if(n=s.Z.copyAttributes(r,e.options,"point"),!(o=z.Z.create(t.Z.Point,e,i,n)))throw new Error("JSXGraph: Can't create point with parent types '"+typeof i[0]+"' and '"+typeof i[1]+"'.\nPossible parent types: [x,y], [z,x,y], [element,transformation]");return o},t.Z.createGlider=function(t,e,i){var r,o,n=s.Z.copyAttributes(i,t.options,"glider");return o=1===e.length?[0,0]:e.slice(0,2),(r=t.create("point",o,n)).makeGlider(e[e.length-1]),r},t.Z.createIntersectionPoint=function(t,e,r){var o,n,a,h,l,c,d=s.Z.copyAttributes(r,t.options,"intersection");e.push(0,0),n=t.select(e[0]),a=t.select(e[1]),l=e[2]||0,c=e[3]||0,o=t.create("point",[0,0,0],d),h=u.Z.intersectionFunction(t,n,a,l,c,o.visProp.alwaysintersect),o.addConstraint([h]);try{n.addChild(o),a.addChild(o)}catch(t){throw new Error("JSXGraph: Can't create 'intersection' with parent types '"+typeof e[0]+"' and '"+typeof e[1]+"'.")}return o.type=i.Z.OBJECT_TYPE_INTERSECTION,o.elType="intersection",o.setParents([n.id,a.id]),o.intersectionNumbers=[l,c],o.getParents=function(){return this.parents.concat(this.intersectionNumbers)},o.generatePolynomial=function(){var t=n.generatePolynomial(o),e=a.generatePolynomial(o);return 0===t.length||0===e.length?[]:[t[0],e[0]]},o},t.Z.createOtherIntersectionPoint=function(t,e,r){var n,a,h,l;if(3!==e.length||!s.Z.isPoint(e[2])||e[0].elementClass!==i.Z.OBJECT_CLASS_LINE&&e[0].elementClass!==i.Z.OBJECT_CLASS_CIRCLE||e[1].elementClass!==i.Z.OBJECT_CLASS_LINE&&e[1].elementClass!==i.Z.OBJECT_CLASS_CIRCLE)throw new Error("JSXGraph: Can't create 'other intersection point' with parent types '"+typeof e[0]+"',  '"+typeof e[1]+"'and  '"+typeof e[2]+"'.\nPossible parent types: [circle|line,circle|line,point]");return a=t.select(e[0]),h=t.select(e[1]),l=t.select(e[2]),(n=t.create("point",[function(){var t=u.Z.meet(a.stdform,h.stdform,0,a.board);return Math.abs(l.X()-t.usrCoords[1])>o.Z.eps||Math.abs(l.Y()-t.usrCoords[2])>o.Z.eps||Math.abs(l.Z()-t.usrCoords[0])>o.Z.eps?t:u.Z.meet(a.stdform,h.stdform,1,a.board)}],r)).type=i.Z.OBJECT_TYPE_INTERSECTION,n.elType="otherintersection",n.setParents([a.id,h.id,l]),a.addChild(n),h.addChild(n),n.generatePolynomial=function(){var t=a.generatePolynomial(n),e=h.generatePolynomial(n);return 0===t.length||0===e.length?[]:[t[0],e[0]]},n},t.Z.createPolePoint=function(e,s,r){var o,n,a,h,l,c,d;if(s.length>1&&(h=s[0].type===i.Z.OBJECT_TYPE_CONIC||s[0].elementClass===i.Z.OBJECT_CLASS_CIRCLE,l=s[1].type===i.Z.OBJECT_TYPE_CONIC||s[1].elementClass===i.Z.OBJECT_CLASS_CIRCLE,c=s[0].elementClass===i.Z.OBJECT_CLASS_LINE,d=s[1].elementClass===i.Z.OBJECT_CLASS_LINE),2!==s.length||!(h&&d||c&&l))throw new Error("JSXGraph: Can't create 'pole point' with parent types '"+typeof s[0]+"' and '"+typeof s[1]+"'.\nPossible parent type: [conic|circle,line], [line,conic|circle]");return d?(n=e.select(s[0]),a=e.select(s[1])):(n=e.select(s[1]),a=e.select(s[0])),(o=e.create("point",[function(){var e=n.quadraticform,i=a.stdform.slice(0,3);return[t.Z.Math.Numerics.det([i,e[1],e[2]]),t.Z.Math.Numerics.det([e[0],i,e[2]]),t.Z.Math.Numerics.det([e[0],e[1],i])]}],r)).elType="polepoint",o.setParents([n.id,a.id]),n.addChild(o),a.addChild(o),o},t.Z.registerElement("point",t.Z.createPoint),t.Z.registerElement("glider",t.Z.createGlider),t.Z.registerElement("intersection",t.Z.createIntersectionPoint),t.Z.registerElement("otherintersection",t.Z.createOtherIntersectionPoint),t.Z.registerElement("polepoint",t.Z.createPolePoint);const H=t.Z.Point;t.Z.Line=function(e,s,r,o){this.constructor(e,o,i.Z.OBJECT_TYPE_LINE,i.Z.OBJECT_CLASS_LINE),this.point1=this.board.select(s),this.point2=this.board.select(r),this.ticks=[],this.defaultTicks=null,this.parentPolygon=null,this.id=this.board.setId(this,"L"),this.board.renderer.drawLine(this),this.board.finalizeAdding(this),this.elType="line",this.point1._is_new?(this.addChild(this.point1),delete this.point1._is_new):this.point1.addChild(this),this.point2._is_new?(this.addChild(this.point2),delete this.point2._is_new):this.point2.addChild(this),this.inherits.push(this.point1,this.point2),this.updateStdform(),this.createLabel(),this.methodMap=t.Z.deepCopy(this.methodMap,{point1:"point1",point2:"point2",getSlope:"getSlope",getRise:"getRise",getYIntersect:"getRise",getAngle:"getAngle",L:"L",length:"L"})},t.Z.Line.prototype=new G.Z,t.Z.extend(t.Z.Line.prototype,{hasPoint:function(t,e){var r,n,a,h,l,d,p,_,f,b=[],g=[1,t,e],m=s.Z.evaluate(this.visProp.strokewidth);return s.Z.isObject(s.Z.evaluate(this.visProp.precision))?(f=this.board._inputDevice,_=s.Z.evaluate(this.visProp.precision[f])):_=this.board.options.precision.hasPoint,_+=.5*m,b[0]=this.stdform[0]-this.stdform[1]*this.board.origin.scrCoords[1]/this.board.unitX+this.stdform[2]*this.board.origin.scrCoords[2]/this.board.unitY,b[1]=this.stdform[1]/this.board.unitX,b[2]=this.stdform[2]/-this.board.unitY,r=u.Z.distPointLine(g,b),!(isNaN(r)||r>_)&&(!(!s.Z.evaluate(this.visProp.straightfirst)||!s.Z.evaluate(this.visProp.straightlast))||(a=this.point1.coords,h=this.point2.coords,n=[0,b[1],b[2]],n=o.Z.crossProduct(n,g),(n=o.Z.crossProduct(n,b))[1]/=n[0],n[2]/=n[0],n[0]=1,n=new c.Z(i.Z.COORDS_BY_SCREEN,n.slice(1),this.board).usrCoords,l=a.distance(i.Z.COORDS_BY_USER,h),a=a.usrCoords.slice(0),h=h.usrCoords.slice(0),l<o.Z.eps?d=0:(l===Number.POSITIVE_INFINITY&&(l=1/o.Z.eps,Math.abs(h[0])<o.Z.eps?(l/=u.Z.distance([0,0,0],h),h=[1,a[1]+h[1]*l,a[2]+h[2]*l]):(l/=u.Z.distance([0,0,0],a),a=[1,h[1]+a[1]*l,h[2]+a[2]*l])),l=h[p=1]-a[p],Math.abs(l)<o.Z.eps&&(l=h[p=2]-a[p]),d=(n[p]-a[p])/l),!(!s.Z.evaluate(this.visProp.straightfirst)&&d<0)&&!(!s.Z.evaluate(this.visProp.straightlast)&&d>1)))},update:function(){var t;return this.needsUpdate?(this.constrained&&(s.Z.isFunction(this.funps)?(t=this.funps())&&t.length&&2===t.length&&(this.point1=t[0],this.point2=t[1]):(s.Z.isFunction(this.funp1)&&(t=this.funp1(),s.Z.isPoint(t)?this.point1=t:t&&t.length&&2===t.length&&this.point1.setPositionDirectly(i.Z.COORDS_BY_USER,t)),s.Z.isFunction(this.funp2)&&(t=this.funp2(),s.Z.isPoint(t)?this.point2=t:t&&t.length&&2===t.length&&this.point2.setPositionDirectly(i.Z.COORDS_BY_USER,t)))),this.updateSegmentFixedLength(),this.updateStdform(),s.Z.evaluate(this.visProp.trace)&&this.cloneToBackground(!0),this):this},updateSegmentFixedLength:function(){var t,e,r,n,a,h,l,c;return this.hasFixedLength?(t=this.point1.Dist(this.point2),e=this.fixedLength(),r=this.fixedLengthOldCoords[0].distance(i.Z.COORDS_BY_USER,this.point1.coords),n=this.fixedLengthOldCoords[1].distance(i.Z.COORDS_BY_USER,this.point2.coords),(r>o.Z.eps||n>o.Z.eps||t!==e)&&(a=this.point1.isDraggable&&this.point1.type!==i.Z.OBJECT_TYPE_GLIDER&&!s.Z.evaluate(this.point1.visProp.fixed),h=this.point2.isDraggable&&this.point2.type!==i.Z.OBJECT_TYPE_GLIDER&&!s.Z.evaluate(this.point2.visProp.fixed),t>o.Z.eps?r>n&&h||r<=n&&h&&!a?(this.point2.setPositionDirectly(i.Z.COORDS_BY_USER,[this.point1.X()+(this.point2.X()-this.point1.X())*e/t,this.point1.Y()+(this.point2.Y()-this.point1.Y())*e/t]),this.point2.fullUpdate()):(r<=n&&a||r>n&&a&&!h)&&(this.point1.setPositionDirectly(i.Z.COORDS_BY_USER,[this.point2.X()+(this.point1.X()-this.point2.X())*e/t,this.point2.Y()+(this.point1.Y()-this.point2.Y())*e/t]),this.point1.fullUpdate()):(l=Math.random()-.5,c=Math.random()-.5,t=Math.sqrt(l*l+c*c),h?(this.point2.setPositionDirectly(i.Z.COORDS_BY_USER,[this.point1.X()+l*e/t,this.point1.Y()+c*e/t]),this.point2.fullUpdate()):a&&(this.point1.setPositionDirectly(i.Z.COORDS_BY_USER,[this.point2.X()+l*e/t,this.point2.Y()+c*e/t]),this.point1.fullUpdate())),this.fixedLengthOldCoords[0].setCoordinates(i.Z.COORDS_BY_USER,this.point1.coords.usrCoords),this.fixedLengthOldCoords[1].setCoordinates(i.Z.COORDS_BY_USER,this.point2.coords.usrCoords)),this):this},updateStdform:function(){var t=o.Z.crossProduct(this.point1.coords.usrCoords,this.point2.coords.usrCoords);this.stdform[0]=t[0],this.stdform[1]=t[1],this.stdform[2]=t[2],this.stdform[3]=0,this.normalize()},updateRenderer:function(){return this.needsUpdate?(this.visPropCalc.visible&&(this.isReal=!isNaN(this.point1.coords.usrCoords[1]+this.point1.coords.usrCoords[2]+this.point2.coords.usrCoords[1]+this.point2.coords.usrCoords[2])&&o.Z.innerProduct(this.stdform,this.stdform,3)>=o.Z.eps*o.Z.eps,this.isReal||this.updateVisibility(!1)),this.visPropCalc.visible&&this.board.renderer.updateLine(this),this.hasLabel&&this.visPropCalc.visible&&this.label&&this.label.visPropCalc.visible&&this.isReal&&(this.label.update(),this.board.renderer.updateText(this.label)),this.setDisplayRendNode(),this.needsUpdate=!1,this):this},generatePolynomial:function(t){var e=this.point1.symbolic.x,i=this.point1.symbolic.y,s=this.point2.symbolic.x,r=this.point2.symbolic.y,o=t.symbolic.x,n=t.symbolic.y;return[["(",i,")*(",o,")-(",i,")*(",s,")+(",n,")*(",s,")-(",e,")*(",n,")+(",e,")*(",r,")-(",o,")*(",r,")"].join("")]},getRise:function(){return Math.abs(this.stdform[2])>=o.Z.eps?-this.stdform[0]/this.stdform[2]:1/0},getSlope:function(){return Math.abs(this.stdform[2])>=o.Z.eps?-this.stdform[1]/this.stdform[2]:1/0},getAngle:function(){return Math.atan2(-this.stdform[1],this.stdform[2])},setStraight:function(t,e){return this.visProp.straightfirst=t,this.visProp.straightlast=e,this.board.renderer.updateLine(this),this},getTextAnchor:function(){return new c.Z(i.Z.COORDS_BY_USER,[.5*(this.point2.X()+this.point1.X()),.5*(this.point2.Y()+this.point1.Y())],this.board)},setLabelRelativeCoords:function(t){s.Z.exists(this.label)&&(this.label.relativeCoords=new c.Z(i.Z.COORDS_BY_SCREEN,[t[0],-t[1]],this.board))},getLabelAnchor:function(){var t,e,r=0,n=new c.Z(i.Z.COORDS_BY_USER,this.point1.coords.usrCoords,this.board),a=new c.Z(i.Z.COORDS_BY_USER,this.point2.coords.usrCoords,this.board),h=s.Z.evaluate(this.visProp.straightfirst),l=s.Z.evaluate(this.visProp.straightlast);if((h||l)&&u.Z.calcStraight(this,n,a,0),n=n.scrCoords,a=a.scrCoords,!s.Z.exists(this.label))return new c.Z(i.Z.COORDS_BY_SCREEN,[NaN,NaN],this.board);switch(s.Z.evaluate(this.label.visProp.position)){case"lft":case"llft":case"ulft":n[1]<=a[1]?(t=n[1],e=n[2]):(t=a[1],e=a[2]);break;case"rt":case"lrt":case"urt":n[1]>a[1]?(t=n[1],e=n[2]):(t=a[1],e=a[2]);break;default:t=.5*(n[1]+a[1]),e=.5*(n[2]+a[2])}return(h||l)&&(s.Z.exists(this.label)&&(r=s.Z.evaluate(this.label.visProp.fontsize)),Math.abs(t)<o.Z.eps?t=r:this.board.canvasWidth+o.Z.eps>t&&t>this.board.canvasWidth-r-o.Z.eps&&(t=this.board.canvasWidth-r),o.Z.eps+r>e&&e>-o.Z.eps?e=r:this.board.canvasHeight+o.Z.eps>e&&e>this.board.canvasHeight-r-o.Z.eps&&(e=this.board.canvasHeight-r)),new c.Z(i.Z.COORDS_BY_SCREEN,[t,e],this.board)},cloneToBackground:function(){var t,e,r,o={};return o.id=this.id+"T"+this.numTraces,o.elementClass=i.Z.OBJECT_CLASS_LINE,this.numTraces++,o.point1=this.point1,o.point2=this.point2,o.stdform=this.stdform,o.board=this.board,o.visProp=s.Z.deepCopy(this.visProp,this.visProp.traceattributes,!0),o.visProp.layer=this.board.options.layer.trace,s.Z.clearVisPropOld(o),o.visPropCalc={visible:s.Z.evaluate(o.visProp.visible)},e=this.getSlope(),t=this.getRise(),o.getSlope=function(){return e},o.getRise=function(){return t},r=this.board.renderer.enhancedRendering,this.board.renderer.enhancedRendering=!0,this.board.renderer.drawLine(o),this.board.renderer.enhancedRendering=r,this.traces[o.id]=o.rendNode,this},addTransform:function(t){var e,i=s.Z.isArray(t)?t:[t],r=i.length;for(e=0;e<r;e++)this.point1.transformations.push(i[e]),this.point2.transformations.push(i[e]);return this},snapToGrid:function(t){var e,r,o,n,a,h,l,p;return s.Z.evaluate(this.visProp.snaptogrid)?this.parents.length<3?(this.point1.handleSnapToGrid(!0,!0),this.point2.handleSnapToGrid(!0,!0)):s.Z.exists(t)&&(l=s.Z.evaluate(this.visProp.snapsizex),p=s.Z.evaluate(this.visProp.snapsizey),a=(e=new c.Z(i.Z.COORDS_BY_SCREEN,[t.Xprev,t.Yprev],this.board)).usrCoords[1],h=e.usrCoords[2],l<=0&&this.board.defaultAxes&&this.board.defaultAxes.x.defaultTicks&&(l=(n=this.board.defaultAxes.x.defaultTicks).ticksDelta*(s.Z.evaluate(n.visProp.minorticks)+1)),p<=0&&this.board.defaultAxes&&this.board.defaultAxes.y.defaultTicks&&(p=(n=this.board.defaultAxes.y.defaultTicks).ticksDelta*(s.Z.evaluate(n.visProp.minorticks)+1)),l>0&&p>0&&(r=u.Z.projectPointToLine({coords:e},this,this.board),o=d.Z.subtract([1,Math.round(a/l)*l,Math.round(h/p)*p],r.usrCoords),this.board.create("transform",o.slice(1),{type:"translate"}).applyOnce([this.point1,this.point2]))):(this.point1.handleSnapToGrid(!1,!0),this.point2.handleSnapToGrid(!1,!0)),this},snapToPoints:function(){var t=s.Z.evaluate(this.visProp.snaptopoints);return this.parents.length<3&&(this.point1.handleSnapToPoints(t),this.point2.handleSnapToPoints(t)),this},X:function(t){var e,i=this.stdform[2];return e=Math.abs(this.point1.coords.usrCoords[0])>o.Z.eps?this.point1.coords.usrCoords[1]:this.point2.coords.usrCoords[1],t=2*(t-.5),(1-Math.abs(t))*e-t*i},Y:function(t){var e,i=this.stdform[1];return e=Math.abs(this.point1.coords.usrCoords[0])>o.Z.eps?this.point1.coords.usrCoords[2]:this.point2.coords.usrCoords[2],t=2*(t-.5),(1-Math.abs(t))*e+t*i},Z:function(t){var e=Math.abs(this.point1.coords.usrCoords[0])>o.Z.eps?this.point1.coords.usrCoords[0]:this.point2.coords.usrCoords[0];return t=2*(t-.5),(1-Math.abs(t))*e},L:function(){return this.point1.Dist(this.point2)},minX:function(){return 0},maxX:function(){return 1},bounds:function(){var t=this.point1.coords.usrCoords,e=this.point2.coords.usrCoords;return[Math.min(t[1],e[1]),Math.max(t[2],e[2]),Math.max(t[1],e[1]),Math.min(t[2],e[2])]},remove:function(){this.removeAllTicks(),G.Z.prototype.remove.call(this)}}),t.Z.createLine=function(e,i,r){var o,n,a,h,l,c,d,u=[],p=!1,_=!1;if(2===i.length){if(s.Z.isArray(i[0])&&i[0].length>1)c=s.Z.copyAttributes(r,e.options,"line","point1"),a=e.create("point",i[0],c);else if(s.Z.isString(i[0])||s.Z.isPoint(i[0]))a=e.select(i[0]);else if(s.Z.isFunction(i[0])&&s.Z.isPoint(i[0]()))a=i[0](),_=!0;else if(s.Z.isFunction(i[0])&&i[0]().length&&i[0]().length>=2)c=s.Z.copyAttributes(r,e.options,"line","point1"),a=t.Z.createPoint(e,i[0](),c),_=!0;else{if(!s.Z.isObject(i[0])||!s.Z.isTransformationOrArray(i[1]))throw new Error("JSXGraph: Can't create line with parent types '"+typeof i[0]+"' and '"+typeof i[1]+"'.\nPossible parent types: [point,point], [[x1,y1],[x2,y2]], [a,b,c]");p=!0,c=s.Z.copyAttributes(r,e.options,"line","point1"),a=e.create("point",[i[0].point1,i[1]],c)}if(p)c=s.Z.copyAttributes(r,e.options,"line","point2"),h=e.create("point",[i[0].point2,i[1]],c);else if(s.Z.isArray(i[1])&&i[1].length>1)c=s.Z.copyAttributes(r,e.options,"line","point2"),h=e.create("point",i[1],c);else if(s.Z.isString(i[1])||s.Z.isPoint(i[1]))h=e.select(i[1]);else if(s.Z.isFunction(i[1])&&s.Z.isPoint(i[1]()))h=i[1](),_=!0;else{if(!(s.Z.isFunction(i[1])&&i[1]().length&&i[1]().length>=2))throw new Error("JSXGraph: Can't create line with parent types '"+typeof i[0]+"' and '"+typeof i[1]+"'.\nPossible parent types: [point,point], [[x1,y1],[x2,y2]], [a,b,c]");c=s.Z.copyAttributes(r,e.options,"line","point2"),h=t.Z.createPoint(e,i[1](),c),_=!0}c=s.Z.copyAttributes(r,e.options,"line"),n=new t.Z.Line(e,a,h,c),_?(n.constrained=!0,n.funp1=i[0],n.funp2=i[1]):p||(n.isDraggable=!0),n.setParents([a.id,h.id])}else if(3===i.length){for(d=!0,l=0;l<3;l++)if(s.Z.isNumber(i[l]))u[l]=s.Z.createFunction(i[l]);else{if(!s.Z.isFunction(i[l]))throw new Error("JSXGraph: Can't create line with parent types '"+typeof i[0]+"' and '"+typeof i[1]+"' and '"+typeof i[2]+"'.\nPossible parent types: [point,point], [[x1,y1],[x2,y2]], [a,b,c]");u[l]=i[l],d=!1}c=s.Z.copyAttributes(r,e.options,"line","point1"),a=d?e.create("point",[u[2]()*u[2]()+u[1]()*u[1](),u[2]()-u[1]()*u[0]()+u[2](),-u[1]()-u[2]()*u[0]()-u[1]()],c):e.create("point",[function(){return.5*(u[2]()*u[2]()+u[1]()*u[1]())},function(){return.5*(u[2]()-u[1]()*u[0]()+u[2]())},function(){return.5*(-u[1]()-u[2]()*u[0]()-u[1]())}],c),c=s.Z.copyAttributes(r,e.options,"line","point2"),h=d?e.create("point",[u[2]()*u[2]()+u[1]()*u[1](),-u[1]()*u[0]()+u[2](),-u[2]()*u[0]()-u[1]()],c):e.create("point",[function(){return u[2]()*u[2]()+u[1]()*u[1]()},function(){return-u[1]()*u[0]()+u[2]()},function(){return-u[2]()*u[0]()-u[1]()}],c),a.prepareUpdate().update(),h.prepareUpdate().update(),c=s.Z.copyAttributes(r,e.options,"line"),(n=new t.Z.Line(e,a,h,c)).isDraggable=d,n.setParents([a,h])}else if(1===i.length&&s.Z.isFunction(i[0])&&2===i[0]().length&&s.Z.isPoint(i[0]()[0])&&s.Z.isPoint(i[0]()[1]))o=i[0](),c=s.Z.copyAttributes(r,e.options,"line"),(n=new t.Z.Line(e,o[0],o[1],c)).constrained=!0,n.funps=i[0],n.setParents(o);else{if(!(1===i.length&&s.Z.isFunction(i[0])&&3===i[0]().length&&s.Z.isNumber(i[0]()[0])&&s.Z.isNumber(i[0]()[1])&&s.Z.isNumber(i[0]()[2])))throw new Error("JSXGraph: Can't create line with parent types '"+typeof i[0]+"' and '"+typeof i[1]+"'.\nPossible parent types: [point,point], [[x1,y1],[x2,y2]], [a,b,c]");o=i[0],c=s.Z.copyAttributes(r,e.options,"line","point1"),a=e.create("point",[function(){var t=o();return[.5*(t[2]*t[2]+t[1]*t[1]),.5*(t[2]-t[1]*t[0]+t[2]),.5*(-t[1]-t[2]*t[0]-t[1])]}],c),c=s.Z.copyAttributes(r,e.options,"line","point2"),h=e.create("point",[function(){var t=o();return[t[2]*t[2]+t[1]*t[1],-t[1]*t[0]+t[2],-t[2]*t[0]-t[1]]}],c),c=s.Z.copyAttributes(r,e.options,"line"),(n=new t.Z.Line(e,a,h,c)).constrained=!0,n.funps=i[0],n.setParents([a,h])}return n},t.Z.registerElement("line",t.Z.createLine),t.Z.createSegment=function(t,e,r){var o,n;if(r.straightFirst=!1,r.straightLast=!1,n=s.Z.copyAttributes(r,t.options,"segment"),o=t.create("line",e.slice(0,2),n),3===e.length){if(o.hasFixedLength=!0,s.Z.isNumber(e[2]))o.fixedLength=function(){return e[2]};else{if(!s.Z.isFunction(e[2]))throw new Error("JSXGraph: Can't create segment with third parent type '"+typeof e[2]+"'.\nPossible third parent types: number or function");o.fixedLength=e[2]}o.getParents=function(){return this.parents.concat(this.fixedLength())},o.fixedLengthOldCoords=[],o.fixedLengthOldCoords[0]=new c.Z(i.Z.COORDS_BY_USER,o.point1.coords.usrCoords.slice(1,3),t),o.fixedLengthOldCoords[1]=new c.Z(i.Z.COORDS_BY_USER,o.point2.coords.usrCoords.slice(1,3),t)}return o.elType="segment",o},t.Z.registerElement("segment",t.Z.createSegment),t.Z.createArrow=function(t,e,r){var o,n;return r.straightFirst=!1,r.straightLast=!1,n=s.Z.copyAttributes(r,t.options,"arrow"),(o=t.create("line",e,n)).type=i.Z.OBJECT_TYPE_VECTOR,o.elType="arrow",o},t.Z.registerElement("arrow",t.Z.createArrow),t.Z.createAxis=function(t,e,r){var o,n,a,h,l;if(!s.Z.isArray(e[0])&&!s.Z.isPoint(e[0])||!s.Z.isArray(e[1])&&!s.Z.isPoint(e[1]))throw new Error("JSXGraph: Can't create axis with parent types '"+typeof e[0]+"' and '"+typeof e[1]+"'.\nPossible parent types: [point,point], [[x1,y1],[x2,y2]]");for(h in o=s.Z.copyAttributes(r,t.options,"axis"),(a=t.create("line",e,o)).type=i.Z.OBJECT_TYPE_AXIS,a.isDraggable=!1,a.point1.isDraggable=!1,a.point2.isDraggable=!1,a.ancestors)a.ancestors.hasOwnProperty(h)&&(a.ancestors[h].type=i.Z.OBJECT_TYPE_AXISPOINT);return n=s.Z.copyAttributes(r,t.options,"axis","ticks"),l=s.Z.exists(n.ticksdistance)?n.ticksdistance:s.Z.isArray(n.ticks)?n.ticks:1,a.defaultTicks=t.create("ticks",[a,l],n),a.defaultTicks.dump=!1,a.elType="axis",a.subs={ticks:a.defaultTicks},a.inherits.push(a.defaultTicks),a},t.Z.registerElement("axis",t.Z.createAxis),t.Z.createTangent=function(t,e,r){var n,a,h,c,d;if(1===e.length)n=e[0],a=n.slideObject;else{if(2!==e.length)throw new Error("JSXGraph: Can't create tangent with parent types '"+typeof e[0]+"' and '"+typeof e[1]+"'.\nPossible parent types: [glider], [point,line|curve|circle|conic]");if(s.Z.isPoint(e[0]))n=e[0],a=e[1];else{if(!s.Z.isPoint(e[1]))throw new Error("JSXGraph: Can't create tangent with parent types '"+typeof e[0]+"' and '"+typeof e[1]+"'.\nPossible parent types: [glider], [point,line|curve|circle|conic]");a=e[0],n=e[1]}}if(a.elementClass===i.Z.OBJECT_CLASS_LINE?(d=t.create("line",[a.point1,a.point2],r)).glider=n:a.elementClass===i.Z.OBJECT_CLASS_CURVE&&a.type!==i.Z.OBJECT_TYPE_CONIC?"plot"!==s.Z.evaluate(a.visProp.curvetype)?(d=t.create("line",[function(){var t=a.X,e=a.Y;return-n.X()*l.Z.D(e)(n.position)+n.Y()*l.Z.D(t)(n.position)},function(){return l.Z.D(a.Y)(n.position)},function(){return-l.Z.D(a.X)(n.position)}],r),n.addChild(d),d.glider=n):(d=t.create("line",[function(){var t,e,i,s,r,o,h,l,c,d,u=Math.floor(n.position);if(1===a.bezierDegree)u===a.numberPoints-1&&u--;else{if(3!==a.bezierDegree)return 0;u=3*Math.floor(n.position*(a.numberPoints-1)/3),i=(n.position*(a.numberPoints-1)-u)/3,u>=a.numberPoints-1&&(u=a.numberPoints-4,i=1)}return u<0?1:(1===a.bezierDegree?(t=a.points[u].usrCoords,e=a.points[u+1].usrCoords):(s=a.points[u].usrCoords,r=a.points[u+1].usrCoords,o=a.points[u+2].usrCoords,h=a.points[u+3].usrCoords,l=(1-i)*(1-i)*(r[1]-s[1])+2*(1-i)*i*(o[1]-r[1])+i*i*(h[1]-o[1]),c=(1-i)*(1-i)*(r[2]-s[2])+2*(1-i)*i*(o[2]-r[2])+i*i*(h[2]-o[2]),l/=d=Math.sqrt(l*l+c*c),c/=d,e=[1,(t=n.coords.usrCoords)[1]+l,t[2]+c]),t[2]*e[1]-t[1]*e[2])},function(){var t,e,i,s,r,o,h,l,c,d,u=Math.floor(n.position);if(1===a.bezierDegree)u===a.numberPoints-1&&u--;else{if(3!==a.bezierDegree)return 0;u=3*Math.floor(n.position*(a.numberPoints-1)/3),i=(n.position*(a.numberPoints-1)-u)/3,u>=a.numberPoints-1&&(u=a.numberPoints-4,i=1)}return u<0?0:(1===a.bezierDegree?(t=a.points[u].usrCoords,e=a.points[u+1].usrCoords):(s=a.points[u].usrCoords,r=a.points[u+1].usrCoords,o=a.points[u+2].usrCoords,h=a.points[u+3].usrCoords,l=(1-i)*(1-i)*(r[1]-s[1])+2*(1-i)*i*(o[1]-r[1])+i*i*(h[1]-o[1]),c=(1-i)*(1-i)*(r[2]-s[2])+2*(1-i)*i*(o[2]-r[2])+i*i*(h[2]-o[2]),l/=d=Math.sqrt(l*l+c*c),c/=d,e=[1,(t=n.coords.usrCoords)[1]+l,t[2]+c]),e[2]-t[2])},function(){var t,e,i,s,r,o,h,l,c,d,u=Math.floor(n.position);if(1===a.bezierDegree)u===a.numberPoints-1&&u--;else{if(3!==a.bezierDegree)return 0;u=3*Math.floor(n.position*(a.numberPoints-1)/3),i=(n.position*(a.numberPoints-1)-u)/3,u>=a.numberPoints-1&&(u=a.numberPoints-4,i=1)}return u<0?0:(1===a.bezierDegree?(t=a.points[u].usrCoords,e=a.points[u+1].usrCoords):(s=a.points[u].usrCoords,r=a.points[u+1].usrCoords,o=a.points[u+2].usrCoords,h=a.points[u+3].usrCoords,l=(1-i)*(1-i)*(r[1]-s[1])+2*(1-i)*i*(o[1]-r[1])+i*i*(h[1]-o[1]),c=(1-i)*(1-i)*(r[2]-s[2])+2*(1-i)*i*(o[2]-r[2])+i*i*(h[2]-o[2]),l/=d=Math.sqrt(l*l+c*c),c/=d,e=[1,(t=n.coords.usrCoords)[1]+l,t[2]+c]),t[1]-e[1])}],r),n.addChild(d),d.glider=n):a.type===i.Z.OBJECT_TYPE_TURTLE?(d=t.create("line",[function(){var t=Math.floor(n.position);for(h=0;h<a.objects.length;h++)if((c=a.objects[h]).type===i.Z.OBJECT_TYPE_CURVE){if(t<c.numberPoints)break;t-=c.numberPoints}return t===c.numberPoints-1&&t--,t<0?1:c.Y(t)*c.X(t+1)-c.X(t)*c.Y(t+1)},function(){var t=Math.floor(n.position);for(h=0;h<a.objects.length;h++)if((c=a.objects[h]).type===i.Z.OBJECT_TYPE_CURVE){if(t<c.numberPoints)break;t-=c.numberPoints}return t===c.numberPoints-1&&t--,t<0?0:c.Y(t+1)-c.Y(t)},function(){var t=Math.floor(n.position);for(h=0;h<a.objects.length;h++)if((c=a.objects[h]).type===i.Z.OBJECT_TYPE_CURVE){if(t<c.numberPoints)break;t-=c.numberPoints}return t===c.numberPoints-1&&t--,t<0?0:c.X(t)-c.X(t+1)}],r),n.addChild(d),d.glider=n):a.elementClass!==i.Z.OBJECT_CLASS_CIRCLE&&a.type!==i.Z.OBJECT_TYPE_CONIC||(d=t.create("line",[function(){return o.Z.matVecMult(a.quadraticform,n.coords.usrCoords)[0]},function(){return o.Z.matVecMult(a.quadraticform,n.coords.usrCoords)[1]},function(){return o.Z.matVecMult(a.quadraticform,n.coords.usrCoords)[2]}],r),n.addChild(d),d.glider=n),!s.Z.exists(d))throw new Error("JSXGraph: Couldn't create tangent with the given parents.");return d.elType="tangent",d.type=i.Z.OBJECT_TYPE_TANGENT,d.setParents(e),d},t.Z.createRadicalAxis=function(t,e,s){var r,n,a;if(2!==e.length||e[0].elementClass!==i.Z.OBJECT_CLASS_CIRCLE||e[1].elementClass!==i.Z.OBJECT_CLASS_CIRCLE)throw new Error("JSXGraph: Can't create 'radical axis' with parent types '"+typeof e[0]+"' and '"+typeof e[1]+"'.\nPossible parent type: [circle,circle]");return n=t.select(e[0]),a=t.select(e[1]),(r=t.create("line",[function(){var t=n.stdform,e=a.stdform;return o.Z.matVecMult(o.Z.transpose([t.slice(0,3),e.slice(0,3)]),[e[3],-t[3]])}],s)).elType="radicalaxis",r.setParents([n.id,a.id]),n.addChild(r),a.addChild(r),r},t.Z.createPolarLine=function(t,e,r){var o,n,a,h,l,c,d;if(e.length>1&&(h=e[0].type===i.Z.OBJECT_TYPE_CONIC||e[0].elementClass===i.Z.OBJECT_CLASS_CIRCLE,l=e[1].type===i.Z.OBJECT_TYPE_CONIC||e[1].elementClass===i.Z.OBJECT_CLASS_CIRCLE,c=s.Z.isPoint(e[0]),d=s.Z.isPoint(e[1])),2!==e.length||!(h&&d||c&&l))throw new Error("JSXGraph: Can't create 'polar line' with parent types '"+typeof e[0]+"' and '"+typeof e[1]+"'.\nPossible parent type: [conic|circle,point], [point,conic|circle]");return d?(n=t.select(e[0]),a=t.select(e[1])):(n=t.select(e[1]),a=t.select(e[0])),(o=t.create("tangent",[n,a],r)).elType="polarline",o},t.Z.registerElement("tangent",t.Z.createTangent),t.Z.registerElement("polar",t.Z.createTangent),t.Z.registerElement("radicalaxis",t.Z.createRadicalAxis),t.Z.registerElement("polarline",t.Z.createPolarLine);t.Z.Line;t.Z.Group=function(t,e,r,o,n){var a,h,l,c;for(this.board=t,this.objects={},a=this.board.numObjects,this.board.numObjects+=1,""!==e&&s.Z.exists(e)?this.id=e:this.id=this.board.id+"Group"+a,this.board.groups[this.id]=this,this.type=i.Z.OBJECT_TYPE_POINT,this.elementClass=i.Z.OBJECT_CLASS_POINT,""!==r&&s.Z.exists(r)?this.name=r:this.name="group_"+this.board.generateName(this),delete this.type,this.coords={},this.needsRegularUpdate=n.needsregularupdate,this.rotationCenter="centroid",this.scaleCenter=null,this.rotationPoints=[],this.translationPoints=[],this.scalePoints=[],this.scaleDirections={},this.parents=[],h=s.Z.isArray(o)?o:Array.prototype.slice.call(arguments,3),l=0;l<h.length;l++)c=this.board.select(h[l]),!s.Z.evaluate(c.visProp.fixed)&&s.Z.exists(c.coords)&&this.addPoint(c);this.methodMap={ungroup:"ungroup",add:"addPoint",addPoint:"addPoint",addPoints:"addPoints",addGroup:"addGroup",remove:"removePoint",removePoint:"removePoint",setAttribute:"setAttribute",setProperty:"setAttribute"}},t.Z.extend(t.Z.Group.prototype,{ungroup:function(){var t,e,i;for(t in this.objects)this.objects.hasOwnProperty(t)&&(e=this.objects[t].point,s.Z.isArray(e.groups)&&(i=s.Z.indexOf(e.groups,this.id))>=0&&delete e.groups[i]);return this.objects={},this},addParents:function(t){var e,i,r;for(i=(r=s.Z.isArray(t)?t:arguments).length,e=0;e<i;++e)s.Z.isId(this.board,r[e])?this.parents.push(r[e]):s.Z.exists(r[e].id)&&this.parents.push(r[e].id);this.parents=s.Z.uniqueArray(this.parents)},setParents:function(t){return this.parents=[],this.addParents(t),this},getParents:function(){return s.Z.isArray(this.parents)?this.parents:[]},_updateCoordsCache:function(t){var e;""!==t&&s.Z.exists(this.objects[t])&&(e=this.objects[t].point,this.coords[e.id]={usrCoords:e.coords.usrCoords.slice(0)})},update:function(){var t,e,i,r,n,a,h,l,c,d,p=null;if(!this.needsUpdate)return this;if("nothing"===(t=this._update_find_drag_type()).action)return this._updateCoordsCache(t.id),this;if(p=this.objects[t.id].point,"translation"===t.action)c=[p.coords.usrCoords[1]-this.coords[t.id].usrCoords[1],p.coords.usrCoords[2]-this.coords[t.id].usrCoords[2]];else if("rotation"===t.action||"scaling"===t.action){if(i="rotation"===t.action?"rotationCenter":"scaleCenter",s.Z.isPoint(this[i]))d=this[i].coords.usrCoords.slice(1);else if("centroid"===this[i])d=this._update_centroid_center();else if(s.Z.isArray(this[i]))d=this[i];else{if(!s.Z.isFunction(this[i]))return this;d=this[i]()}if("rotation"===t.action)l=u.Z.rad(this.coords[t.id].usrCoords.slice(1),d,this.objects[t.id].point),(c=this.board.create("transform",[l,d[0],d[1]],{type:"rotate"})).update();else{if("scaling"!==t.action)return this;if(n=u.Z.distance(this.coords[t.id].usrCoords.slice(1),d),Math.abs(n)<o.Z.eps)return this;n=u.Z.distance(p.coords.usrCoords.slice(1),d)/n,a=this.scaleDirections[t.id].indexOf("x")>=0?n:1,h=this.scaleDirections[t.id].indexOf("y")>=0?n:1,(c=this.board.create("transform",[1,0,0,d[0]*(1-a),a,0,d[1]*(1-h),0,h],{type:"generic"})).update()}}for(e in this._update_apply_transformation(t,c),this.needsUpdate=!1,this.objects)if(this.objects.hasOwnProperty(e))for(r in this.objects[e].descendants)this.objects[e].descendants.hasOwnProperty(r)&&(this.objects[e].descendants.needsUpdate=this.objects[e].descendants.needsRegularUpdate||this.board.needsFullUpdate);for(e in this.board.updateElements(t),this.objects)this.objects.hasOwnProperty(e)&&this._updateCoordsCache(e);return this},_update_find_drag_type:function(){var t,e,r,n="nothing",a=[];for(t in this.objects)this.objects.hasOwnProperty(t)&&(e=this.objects[t].point).coords.distance(i.Z.COORDS_BY_USER,this.coords[t])>o.Z.eps&&a.push(e.id);return 0===a.length?{action:n,id:"",changed:a}:(r=a[0],e=this.objects[r].point,a.length>1?n="translation":s.Z.isInArray(this.rotationPoints,e)&&s.Z.exists(this.rotationCenter)?n="rotation":s.Z.isInArray(this.scalePoints,e)&&s.Z.exists(this.scaleCenter)?n="scaling":s.Z.isInArray(this.translationPoints,e)&&(n="translation"),{action:n,id:r,changed:a})},_update_centroid_center:function(){var t,e,i;for(i in t=[0,0],e=0,this.coords)this.coords.hasOwnProperty(i)&&(t[0]+=this.coords[i].usrCoords[1],t[1]+=this.coords[i].usrCoords[2],++e);return e>0&&(t[0]/=e,t[1]/=e),t},_update_apply_transformation:function(t,e){var r,n;for(r in this.objects)this.objects.hasOwnProperty(r)&&(s.Z.exists(this.board.objects[r])?(n=this.objects[r].point).id!==t.id?"translation"===t.action?s.Z.isInArray(t.changed,n.id)||n.coords.setCoordinates(i.Z.COORDS_BY_USER,[this.coords[r].usrCoords[1]+e[0],this.coords[r].usrCoords[2]+e[1]]):"rotation"!==t.action&&"scaling"!==t.action||e.applyOnce([n]):"rotation"!==t.action&&"scaling"!==t.action||n.coords.setCoordinates(i.Z.COORDS_BY_USER,o.Z.matVecMult(e.matrix,this.coords[n.id].usrCoords)):delete this.objects[r])},addPoint:function(t){return this.objects[t.id]={point:this.board.select(t)},this._updateCoordsCache(t.id),this.translationPoints.push(t),t.groups.push(this.id),t.groups=s.Z.uniqueArray(t.groups),this},addPoints:function(t){var e;for(e=0;e<t.length;e++)this.addPoint(t[e]);return this},addGroup:function(t){var e;for(e in t.objects)t.objects.hasOwnProperty(e)&&this.addPoint(t.objects[e].point);return this},removePoint:function(t){return delete this.objects[t.id],this},setRotationCenter:function(t){return this.rotationCenter=t,this},setRotationPoints:function(t){return this._setActionPoints("rotation",t)},addRotationPoint:function(t){return this._addActionPoint("rotation",t)},removeRotationPoint:function(t){return this._removeActionPoint("rotation",t)},setTranslationPoints:function(t){return this._setActionPoints("translation",t)},addTranslationPoint:function(t){return this._addActionPoint("translation",t)},removeTranslationPoint:function(t){return this._removeActionPoint("translation",t)},setScaleCenter:function(t){return this.scaleCenter=t,this},setScalePoints:function(t,e){var i,r,o;for(o=(i=s.Z.isArray(t)?t:arguments).length,r=0;r<o;++r)this.scaleDirections[this.board.select(i[r]).id]=e||"xy";return this._setActionPoints("scale",t)},addScalePoint:function(t,e){return this._addActionPoint("scale",t),this.scaleDirections[this.board.select(t).id]=e||"xy",this},removeScalePoint:function(t){return this._removeActionPoint("scale",t)},_setActionPoints:function(t,e){var i,r,o;for(o=(i=s.Z.isArray(e)?e:arguments).length,this[t+"Points"]=[],r=0;r<o;++r)this._addActionPoint(t,i[r]);return this},_addActionPoint:function(t,e){return this[t+"Points"].push(this.board.select(e)),this},_removeActionPoint:function(t,e){var i=this[t+"Points"].indexOf(this.board.select(e));return i>-1&&this[t+"Points"].splice(i,1),this},setProperty:function(){t.Z.deprecated("Group.setProperty","Group.setAttribute()"),this.setAttribute.apply(this,arguments)},setAttribute:function(){var t;for(t in this.objects)this.objects.hasOwnProperty(t)&&this.objects[t].point.setAttribute.apply(this.objects[t].point,arguments);return this}}),t.Z.createGroup=function(e,i,r){var o=s.Z.copyAttributes(r,e.options,"group"),n=new t.Z.Group(e,o.id,o.name,i,o);return n.elType="group",n.setParents(i),n},t.Z.registerElement("group",t.Z.createGroup);t.Z.Group;t.Z.Circle=function(t,e,r,o,n){this.constructor(t,n,i.Z.OBJECT_TYPE_CIRCLE,i.Z.OBJECT_CLASS_CIRCLE),this.method=e,this.midpoint=this.board.select(r),this.center=this.board.select(r),this.point2=null,this.radius=0,this.line=null,this.circle=null,this.points=[],"twoPoints"===e?(this.point2=t.select(o),this.radius=this.Radius()):"pointRadius"===e?(this.gxtterm=o,this.updateRadius=s.Z.createFunction(o,this.board,null,!0),this.updateRadius(),this.addParentsFromJCFunctions([this.updateRadius])):"pointLine"===e?(this.line=t.select(o),this.radius=this.line.point1.coords.distance(i.Z.COORDS_BY_USER,this.line.point2.coords)):"pointCircle"===e&&(this.circle=t.select(o),this.radius=this.circle.Radius()),this.id=this.board.setId(this,"C"),this.board.renderer.drawEllipse(this),this.board.finalizeAdding(this),this.createGradient(),this.elType="circle",this.createLabel(),s.Z.exists(this.center._is_new)?(this.addChild(this.center),delete this.center._is_new):this.center.addChild(this),"pointRadius"===e?this.notifyParents(o):"pointLine"===e?this.line.addChild(this):"pointCircle"===e?this.circle.addChild(this):"twoPoints"===e&&(s.Z.exists(this.point2._is_new)?(this.addChild(this.point2),delete this.point2._is_new):this.point2.addChild(this)),this.methodMap=s.Z.deepCopy(this.methodMap,{setRadius:"setRadius",getRadius:"getRadius",Area:"Area",area:"Area",radius:"Radius",center:"center",line:"line",point2:"point2"})},t.Z.Circle.prototype=new G.Z,t.Z.extend(t.Z.Circle.prototype,{hasPoint:function(t,e){var r,o,n,a,h,l=this.center.coords.usrCoords,d=new c.Z(i.Z.COORDS_BY_SCREEN,[t,e],this.board),u=this.Radius();return s.Z.isObject(s.Z.evaluate(this.visProp.precision))?(o=this.board._inputDevice,r=s.Z.evaluate(this.visProp.precision[o])):r=this.board.options.precision.hasPoint,n=l[1]-d.usrCoords[1],a=l[2]-d.usrCoords[2],h=Math.sqrt(n*n+a*a),r+=.5*s.Z.evaluate(this.visProp.strokewidth),r/=Math.sqrt(this.board.unitX*this.board.unitY),s.Z.evaluate(this.visProp.hasinnerpoints)?h<u+r:Math.abs(h-u)<r},generatePolynomial:function(t){var e=this.center.symbolic.x,i=this.center.symbolic.y,s=t.symbolic.x,r=t.symbolic.y,o=this.generateRadiusSquared();return""===o?[]:["(("+s+")-("+e+"))^2 + (("+r+")-("+i+"))^2 - ("+o+")"]},generateRadiusSquared:function(){var t,e,i,r,o="";return"twoPoints"===this.method?(t=this.center.symbolic.x,e=this.center.symbolic.y,o="(("+(i=this.point2.symbolic.x)+")-("+t+"))^2 + (("+(r=this.point2.symbolic.y)+")-("+e+"))^2"):"pointRadius"===this.method?s.Z.isNumber(this.radius)&&(o=(this.radius*this.radius).toString()):"pointLine"===this.method?(i=this.line.point1.symbolic.x,r=this.line.point1.symbolic.y,o="(("+i+")-("+this.line.point2.symbolic.x+"))^2 + (("+r+")-("+this.line.point2.symbolic.y+"))^2"):"pointCircle"===this.method&&(o=this.circle.Radius()),o},update:function(){var t,e,r,o,n,a;if(this.needsUpdate)for(s.Z.evaluate(this.visProp.trace)&&this.cloneToBackground(!0),"pointLine"===this.method?this.radius=this.line.point1.coords.distance(i.Z.COORDS_BY_USER,this.line.point2.coords):"pointCircle"===this.method?this.radius=this.circle.Radius():"pointRadius"===this.method&&(this.radius=this.updateRadius()),this.updateStdform(),this.updateQuadraticform(),r=this.center.coords.usrCoords[0],t=this.center.coords.usrCoords[1]/r,e=this.center.coords.usrCoords[2]/r,r/=r,o=this.Radius(),n=.551915024494,this.numberPoints=13,this.dataX=[t+o,t+o,t+o*n,t,t-o*n,t-o,t-o,t-o,t-o*n,t,t+o*n,t+o,t+o],this.dataY=[e,e+o*n,e+o,e+o,e+o,e+o*n,e,e-o*n,e-o,e-o,e-o,e-o*n,e],this.bezierDegree=3,a=0;a<this.numberPoints;a++)this.points[a]=new c.Z(i.Z.COORDS_BY_USER,[this.dataX[a],this.dataY[a]],this.board);return this},updateQuadraticform:function(){var t=this.center,e=t.X(),i=t.Y(),s=this.Radius();this.quadraticform=[[e*e+i*i-s*s,-e,-i],[-e,1,0],[-i,0,1]]},updateStdform:function(){this.stdform[3]=.5,this.stdform[4]=this.Radius(),this.stdform[1]=-this.center.coords.usrCoords[1],this.stdform[2]=-this.center.coords.usrCoords[2],isFinite(this.stdform[4])||(this.stdform[0]=s.Z.exists(this.point2)?-(this.stdform[1]*this.point2.coords.usrCoords[1]+this.stdform[2]*this.point2.coords.usrCoords[2]):0),this.normalize()},updateRenderer:function(){return this.needsUpdate?(this.visPropCalc.visible&&(this.isReal=!isNaN(this.center.coords.usrCoords[1]+this.center.coords.usrCoords[2]+this.Radius())&&this.center.isReal,this.isReal||this.updateVisibility(!1)),this.visPropCalc.visible&&this.board.renderer.updateEllipse(this),this.hasLabel&&this.visPropCalc.visible&&this.label&&this.label.visPropCalc.visible&&this.isReal&&(this.label.update(),this.board.renderer.updateText(this.label)),this.setDisplayRendNode(),this.needsUpdate=!1,this):this},notifyParents:function(t){s.Z.isString(t)&&R.Z.findDependencies(this,t,this.board)},setRadius:function(t){return this.updateRadius=s.Z.createFunction(t,this.board,null,!0),this.addParentsFromJCFunctions([this.updateRadius]),this.board.update(),this},Radius:function(t){return s.Z.exists(t)?(this.setRadius(t),this.Radius()):"twoPoints"===this.method?s.Z.cmpArrays(this.point2.coords.usrCoords,[0,0,0])||s.Z.cmpArrays(this.center.coords.usrCoords,[0,0,0])?NaN:this.center.Dist(this.point2):"pointLine"===this.method||"pointCircle"===this.method?this.radius:"pointRadius"===this.method?this.updateRadius():NaN},getRadius:function(){return t.Z.deprecated("Circle.getRadius()","Circle.Radius()"),this.Radius()},getTextAnchor:function(){return this.center.coords},getLabelAnchor:function(){var t,e,r=this.Radius(),o=this.center.coords.usrCoords,n=.7071067811865;switch(s.Z.evaluate(this.visProp.label.position)){case"lft":t=o[1]-r,e=o[2];break;case"llft":t=o[1]-n*r,e=o[2]-n*r;break;case"rt":t=o[1]+r,e=o[2];break;case"lrt":t=o[1]+n*r,e=o[2]-n*r;break;case"urt":t=o[1]+n*r,e=o[2]+n*r;break;case"top":t=o[1],e=o[2]+r;break;case"bot":t=o[1],e=o[2]-r;break;default:t=o[1]-n*r,e=o[2]+n*r}return new c.Z(i.Z.COORDS_BY_USER,[t,e],this.board)},cloneToBackground:function(){var t,e=this.Radius(),r={id:this.id+"T"+this.numTraces,elementClass:i.Z.OBJECT_CLASS_CIRCLE,center:{coords:this.center.coords},Radius:function(){return e},getRadius:function(){return e},board:this.board,visProp:s.Z.deepCopy(this.visProp,this.visProp.traceattributes,!0)};return r.visProp.layer=this.board.options.layer.trace,this.numTraces++,s.Z.clearVisPropOld(r),r.visPropCalc={visible:s.Z.evaluate(r.visProp.visible)},t=this.board.renderer.enhancedRendering,this.board.renderer.enhancedRendering=!0,this.board.renderer.drawEllipse(r),this.board.renderer.enhancedRendering=t,this.traces[r.id]=r.rendNode,this},addTransform:function(t){var e,i=s.Z.isArray(t)?t:[t],r=i.length;for(e=0;e<r;e++)this.center.transformations.push(i[e]),"twoPoints"===this.method&&this.point2.transformations.push(i[e]);return this},snapToGrid:function(){var t=s.Z.evaluate(this.visProp.snaptogrid);return this.center.handleSnapToGrid(t,!0),"twoPoints"===this.method&&this.point2.handleSnapToGrid(t,!0),this},snapToPoints:function(){var t=s.Z.evaluate(this.visProp.snaptopoints);return this.center.handleSnapToPoints(t),"twoPoints"===this.method&&this.point2.handleSnapToPoints(t),this},X:function(t){return this.Radius()*Math.cos(2*t*Math.PI)+this.center.coords.usrCoords[1]},Y:function(t){return this.Radius()*Math.sin(2*t*Math.PI)+this.center.coords.usrCoords[2]},Z:function(t){return 1},minX:function(){return 0},maxX:function(){return 1},Area:function(){var t=this.Radius();return t*t*Math.PI},bounds:function(){var t=this.center.coords.usrCoords,e=this.Radius();return[t[1]-e,t[2]+e,t[1]+e,t[2]-e]},getParents:function(){return 1===this.parents.length?this.parents.concat(this.radius):this.parents}}),t.Z.createCircle=function(e,r,o){var n,a,h,l,c,d=["center","point2"];if(a=[],c=e.select(r[0]),s.Z.isObject(c)&&c.elementClass===i.Z.OBJECT_CLASS_CIRCLE&&s.Z.isTransformationOrArray(r[1]))return l=s.Z.copyAttributes(o,e.options,"circle"),(n=t.Z.createEllipse(e,[c.center,c.center,function(){return 2*c.Radius()}],l)).addTransform(r[1]),n;for(h=0;h<r.length;h++)if(s.Z.isPointType(e,r[h])){if(!1===(a=a.concat(s.Z.providePoints(e,[r[h]],o,"circle",[d[h]])))[a.length-1])throw new Error("JSXGraph: Can't create circle from this type. Please provide a point type.")}else a.push(r[h]);if(l=s.Z.copyAttributes(o,e.options,"circle"),2===a.length&&s.Z.isPoint(a[0])&&s.Z.isPoint(a[1]))n=new t.Z.Circle(e,"twoPoints",a[0],a[1],l);else if((s.Z.isNumber(a[0])||s.Z.isFunction(a[0])||s.Z.isString(a[0]))&&s.Z.isPoint(a[1]))n=new t.Z.Circle(e,"pointRadius",a[1],a[0],l);else if((s.Z.isNumber(a[1])||s.Z.isFunction(a[1])||s.Z.isString(a[1]))&&s.Z.isPoint(a[0]))n=new t.Z.Circle(e,"pointRadius",a[0],a[1],l);else if(a[0].elementClass===i.Z.OBJECT_CLASS_CIRCLE&&s.Z.isPoint(a[1]))n=new t.Z.Circle(e,"pointCircle",a[1],a[0],l);else if(a[1].elementClass===i.Z.OBJECT_CLASS_CIRCLE&&s.Z.isPoint(a[0]))n=new t.Z.Circle(e,"pointCircle",a[0],a[1],l);else if(a[0].elementClass===i.Z.OBJECT_CLASS_LINE&&s.Z.isPoint(a[1]))n=new t.Z.Circle(e,"pointLine",a[1],a[0],l);else if(a[1].elementClass===i.Z.OBJECT_CLASS_LINE&&s.Z.isPoint(a[0]))n=new t.Z.Circle(e,"pointLine",a[0],a[1],l);else{if(!(3===r.length&&s.Z.isPoint(a[0])&&s.Z.isPoint(a[1])&&s.Z.isPoint(a[2])))throw new Error("JSXGraph: Can't create circle with parent types '"+typeof r[0]+"' and '"+typeof r[1]+"'.\nPossible parent types: [point,point], [point,number], [point,function], [point,circle], [point,point,point], [circle,transformation]");if(!t.Z.elements.circumcircle)throw new Error("JSXGraph: Can't create circle with three points. Please include the circumcircle element (element/composition).");n=t.Z.elements.circumcircle(e,a,l)}for(n.isDraggable=!0,n.setParents(a),n.elType="circle",h=0;h<a.length;h++)s.Z.isPoint(a[h])&&n.inherits.push(a[h]);return n},t.Z.registerElement("circle",t.Z.createCircle);const W=t.Z.Circle;t.Z.createEllipse=function(t,e,r){var o,n,a,h,l,d,u,p=[],_=s.Z.copyAttributes(r,t.options,"conic","foci"),f=s.Z.copyAttributes(r,t.options,"conic","center"),b=s.Z.copyAttributes(r,t.options,"conic");for(d=0;d<2;d++)if(e[d].length>1)p[d]=t.create("point",e[d],_);else if(s.Z.isPoint(e[d]))p[d]=t.select(e[d]);else if(s.Z.isFunction(e[d])&&s.Z.isPoint(e[d]()))p[d]=e[d]();else{if(!s.Z.isString(e[d]))throw new Error("JSXGraph: Can't create Ellipse with parent types '"+typeof e[0]+"' and '"+typeof e[1]+"'.\nPossible parent types: [point,point,point], [point,point,number|function]");p[d]=t.select(e[d])}if(s.Z.isNumber(e[2]))l=s.Z.createFunction(e[2],t);else if(s.Z.isFunction(e[2])&&s.Z.isNumber(e[2]()))l=e[2];else{if(s.Z.isPoint(e[2]))h=t.select(e[2]);else if(e[2].length>1)h=t.create("point",e[2],_);else if(s.Z.isFunction(e[2])&&s.Z.isPoint(e[2]()))h=e[2]();else{if(!s.Z.isString(e[2]))throw new Error("JSXGraph: Can't create Ellipse with parent types '"+typeof e[0]+"' and '"+typeof e[1]+"' and '"+typeof e[2]+"'.\nPossible parent types: [point,point,point], [point,point,number|function]");h=t.select(e[2])}l=function(){return h.Dist(p[0])+h.Dist(p[1])}}for(s.Z.exists(e[4])||(e[4]=2*Math.PI),s.Z.exists(e[3])||(e[3]=0),a=t.create("point",[function(){return.5*(p[0].X()+p[1].X())},function(){return.5*(p[0].Y()+p[1].Y())}],f),(n=t.create("curve",[function(t){return 0},function(t){return 0},e[3],e[4]],b)).majorAxis=l,u=n.hasPoint,o=function(t,e){var i,s,r,o,a,h,c,d,u;e||(s=(i=l())*i,r=p[0].X(),o=p[0].Y(),c=r-(a=p[1].X()),d=o-(h=p[1].Y()),u=(s-r*r-o*o+a*a+h*h)/(2*i),n.quadraticform=[[u*u-a*a-h*h,u*c/i+a,u*d/i+h],[u*c/i+a,c*c/s-1,c*d/s],[u*d/i+h,c*d/s,d*d/s-1]])},n.X=function(t,e){var i=l(),s=p[1].Dist(p[0]),r=.5*(s*s-i*i)/(s*Math.cos(t)-i),n=Math.atan2(p[1].Y()-p[0].Y(),p[1].X()-p[0].X());return e||o(0,e),p[0].X()+Math.cos(n+t)*r},n.Y=function(t,e){var i=l(),s=p[1].Dist(p[0]),r=.5*(s*s-i*i)/(s*Math.cos(t)-i),o=Math.atan2(p[1].Y()-p[0].Y(),p[1].X()-p[0].X());return p[0].Y()+Math.sin(o+t)*r},n.midpoint=n.center=a,n.type=i.Z.OBJECT_TYPE_CONIC,n.subs={center:n.center},n.inherits.push(n.center,p[0],p[1]),s.Z.isPoint(h)&&n.inherits.push(h),n.hasPoint=function(t,e){var r,o,n,a;return s.Z.evaluate(this.visProp.hasinnerpoints)?(r=p[0].coords,o=p[1].coords,n=this.majorAxis(),(a=new c.Z(i.Z.COORDS_BY_SCREEN,[t,e],this.board)).distance(i.Z.COORDS_BY_USER,r)+a.distance(i.Z.COORDS_BY_USER,o)<=n):u.apply(this,arguments)},a.addChild(n),d=0;d<2;d++)s.Z.isPoint(p[d])&&p[d].addChild(n);return s.Z.isPoint(h)&&h.addChild(n),n.setParents(e),n},t.Z.createHyperbola=function(t,e,r){var o,n,a,h,l,c,d=[],u=s.Z.copyAttributes(r,t.options,"conic","foci"),p=s.Z.copyAttributes(r,t.options,"conic","center"),_=s.Z.copyAttributes(r,t.options,"conic");for(c=0;c<2;c++)if(e[c].length>1)d[c]=t.create("point",e[c],u);else if(s.Z.isPoint(e[c]))d[c]=t.select(e[c]);else if(s.Z.isFunction(e[c])&&s.Z.isPoint(e[c]()))d[c]=e[c]();else{if(!s.Z.isString(e[c]))throw new Error("JSXGraph: Can't create Hyperbola with parent types '"+typeof e[0]+"' and '"+typeof e[1]+"'.\nPossible parent types: [point,point,point], [point,point,number|function]");d[c]=t.select(e[c])}if(s.Z.isNumber(e[2]))l=s.Z.createFunction(e[2],t);else if(s.Z.isFunction(e[2])&&s.Z.isNumber(e[2]()))l=e[2];else{if(s.Z.isPoint(e[2]))h=t.select(e[2]);else if(e[2].length>1)h=t.create("point",e[2],u);else if(s.Z.isFunction(e[2])&&s.Z.isPoint(e[2]()))h=e[2]();else{if(!s.Z.isString(e[2]))throw new Error("JSXGraph: Can't create Hyperbola with parent types '"+typeof e[0]+"' and '"+typeof e[1]+"' and '"+typeof e[2]+"'.\nPossible parent types: [point,point,point], [point,point,number|function]");h=t.select(e[2])}l=function(){return h.Dist(d[0])-h.Dist(d[1])}}for(s.Z.exists(e[4])||(e[4]=1.0001*Math.PI),s.Z.exists(e[3])||(e[3]=-1.0001*Math.PI),a=t.create("point",[function(){return.5*(d[0].X()+d[1].X())},function(){return.5*(d[0].Y()+d[1].Y())}],p),(n=t.create("curve",[function(t){return 0},function(t){return 0},e[3],e[4]],_)).majorAxis=l,o=function(t,e){var i,s,r,o,a,h,c,u,p;e||(s=(i=l())*i,r=d[0].X(),o=d[0].Y(),c=r-(a=d[1].X()),u=o-(h=d[1].Y()),p=(s-r*r-o*o+a*a+h*h)/(2*i),n.quadraticform=[[p*p-a*a-h*h,p*c/i+a,p*u/i+h],[p*c/i+a,c*c/s-1,c*u/s],[p*u/i+h,c*u/s,u*u/s-1]])},n.X=function(t,e){var i=l(),s=d[1].Dist(d[0]),r=.5*(s*s-i*i)/(s*Math.cos(t)+i),n=Math.atan2(d[1].Y()-d[0].Y(),d[1].X()-d[0].X());return e||o(0,e),d[0].X()+Math.cos(n+t)*r},n.Y=function(t,e){var i=l(),s=d[1].Dist(d[0]),r=.5*(s*s-i*i)/(s*Math.cos(t)+i),o=Math.atan2(d[1].Y()-d[0].Y(),d[1].X()-d[0].X());return d[0].Y()+Math.sin(o+t)*r},n.midpoint=n.center=a,n.subs={center:n.center},n.inherits.push(n.center,d[0],d[1]),s.Z.isPoint(h)&&n.inherits.push(h),n.type=i.Z.OBJECT_TYPE_CONIC,a.addChild(n),c=0;c<2;c++)s.Z.isPoint(d[c])&&d[c].addChild(n);return s.Z.isPoint(h)&&h.addChild(n),n.setParents(e),n},t.Z.createParabola=function(t,e,r){var o,n,a,h,l=e[0],c=e[1],d=s.Z.copyAttributes(r,t.options,"conic","foci"),p=s.Z.copyAttributes(r,t.options,"conic","center"),_=s.Z.copyAttributes(r,t.options,"conic");if(e[0].length>1)l=t.create("point",e[0],d);else if(s.Z.isPoint(e[0]))l=t.select(e[0]);else if(s.Z.isFunction(e[0])&&s.Z.isPoint(e[0]()))l=e[0]();else{if(!s.Z.isString(e[0]))throw new Error("JSXGraph: Can't create Parabola with parent types '"+typeof e[0]+"' and '"+typeof e[1]+"'.\nPossible parent types: [point,line]");l=t.select(e[0])}return s.Z.isArray(c)&&2===c.length&&(h=s.Z.copyAttributes(r,t.options,"conic","line"),c=t.create("line",c,h)),s.Z.exists(e[3])||(e[3]=2*Math.PI),s.Z.exists(e[2])||(e[2]=0),a=t.create("point",[function(){return u.Z.projectPointToLine(l,c,t).usrCoords}],p),(n=t.create("curve",[function(t){return 0},function(t){return 0},e[2],e[3]],_)).midpoint=n.center=a,n.subs={center:n.center},n.inherits.push(n.center),o=function(t,e){var i,s,r,o,a,h;e||(i=c.stdform[1],s=c.stdform[2],r=c.stdform[0],o=i*i+s*s,a=l.X(),h=l.Y(),n.quadraticform=[[r*r-o*(a*a+h*h),r*i+o*a,r*s+o*h],[r*i+o*a,-s*s,i*s],[r*s+o*h,i*s,-i*i]])},n.X=function(t,e){var i,s=c.getAngle(),r=u.Z.distPointLine(l.coords.usrCoords,c.stdform),n=c.point1.coords.usrCoords,a=c.point2.coords.usrCoords,h=l.coords.usrCoords;return 0===n[0]?n=[1,a[1]+c.stdform[2],a[2]-c.stdform[1]]:0===a[0]&&(a=[1,n[1]+c.stdform[2],n[2]-c.stdform[1]]),i=((a[1]-n[1])*(h[2]-n[2])-(a[2]-n[2])*(h[1]-n[1])>=0?1:-1)*r/(1-Math.sin(t)),e||o(0,e),l.X()+Math.cos(t+s)*i},n.Y=function(t,e){var i,s=c.getAngle(),r=u.Z.distPointLine(l.coords.usrCoords,c.stdform),o=c.point1.coords.usrCoords,n=c.point2.coords.usrCoords,a=l.coords.usrCoords;return 0===o[0]?o=[1,n[1]+c.stdform[2],n[2]-c.stdform[1]]:0===n[0]&&(n=[1,o[1]+c.stdform[2],o[2]-c.stdform[1]]),i=((n[1]-o[1])*(a[2]-o[2])-(n[2]-o[2])*(a[1]-o[1])>=0?1:-1)*r/(1-Math.sin(t)),l.Y()+Math.sin(t+s)*i},n.type=i.Z.OBJECT_TYPE_CONIC,a.addChild(n),s.Z.isPoint(l)&&(l.addChild(n),n.inherits.push(l)),c.addChild(n),n.setParents(e),n},t.Z.createConic=function(t,e,r){var n,a,h,c,d,u,p,_,f,b,g,m,v,Z,C=[[1,0,0],[0,1,0],[0,0,1]],y=[[1,0,0],[0,1,0],[0,0,1]],P=[],E=[],O=s.Z.copyAttributes(r,t.options,"conic","point"),x=s.Z.copyAttributes(r,t.options,"conic","center"),w=s.Z.copyAttributes(r,t.options,"conic");if(5===e.length)Z=!0;else{if(6!==e.length)throw new Error("JSXGraph: Can't create generic Conic with "+e.length+" parameters.");Z=!1}if(Z)for(m=0;m<5;m++)if(e[m].length>1)P[m]=t.create("point",e[m],O);else if(s.Z.isPoint(e[m]))P[m]=t.select(e[m]);else if(s.Z.isFunction(e[m])&&s.Z.isPoint(e[m]()))P[m]=e[m]();else{if(!s.Z.isString(e[m]))throw new Error("JSXGraph: Can't create Conic section with parent types '"+typeof e[m]+"'.\nPossible parent types: [point,point,point,point,point], [a00,a11,a22,a01,a02,a12]");P[m]=t.select(e[m])}else(v=[[0,0,0],[0,0,0],[0,0,0]])[0][0]=s.Z.isFunction(e[2])?function(){return e[2]()}:function(){return e[2]},v[0][1]=s.Z.isFunction(e[4])?function(){return e[4]()}:function(){return e[4]},v[0][2]=s.Z.isFunction(e[5])?function(){return e[5]()}:function(){return e[5]},v[1][1]=s.Z.isFunction(e[0])?function(){return e[0]()}:function(){return e[0]},v[1][2]=s.Z.isFunction(e[3])?function(){return e[3]()}:function(){return e[3]},v[2][2]=s.Z.isFunction(e[1])?function(){return e[1]()}:function(){return e[1]};if(d=function(t){var e,i;for(e=0;e<3;e++)for(i=e;i<3;i++)t[e][i]+=t[i][e];for(e=0;e<3;e++)for(i=0;i<e;i++)t[e][i]=t[i][e];return t},c=function(t,e){var i,s,r=[[0,0,0],[0,0,0],[0,0,0]];for(i=0;i<3;i++)for(s=0;s<3;s++)r[i][s]=t[i]*e[s];return d(r)},h=function(t,e,i){var s,r,n,a,h,l=[[0,0,0],[0,0,0],[0,0,0]];for(h=o.Z.matVecMult(e,i),n=o.Z.innerProduct(i,h),h=o.Z.matVecMult(t,i),a=o.Z.innerProduct(i,h),s=0;s<3;s++)for(r=0;r<3;r++)l[s][r]=n*t[s][r]-a*e[s][r];return l},a=t.create("curve",[function(t){return 0},function(t){return 0},0,2*Math.PI],w),n=function(t,e){var i,r,n,d;if(!e){if(Z){for(i=0;i<5;i++)E[i]=P[i].coords.usrCoords;b=c(o.Z.crossProduct(E[0],E[1]),o.Z.crossProduct(E[2],E[3])),g=c(o.Z.crossProduct(E[0],E[2]),o.Z.crossProduct(E[1],E[3])),y=h(b,g,E[4])}else for(i=0;i<3;i++)for(r=i;r<3;r++)y[i][r]=v[i][r](),r>i&&(y[r][i]=y[i][r]);for(a.quadraticform=y,(u=l.Z.Jacobi(y))[0][0][0]<0&&(u[0][0][0]*=-1,u[0][1][1]*=-1,u[0][2][2]*=-1),i=0;i<3;i++){for(n=0,r=0;r<3;r++)n+=u[1][r][i]*u[1][r][i];n=Math.sqrt(n)}C=u[1],f=Math.sqrt(Math.abs(u[0][0][0])),p=Math.sqrt(Math.abs(u[0][1][1])),_=Math.sqrt(Math.abs(u[0][2][2]))}return u[0][1][1]<=0&&u[0][2][2]<=0?d=o.Z.matVecMult(C,[1/f,Math.cos(t)/p,Math.sin(t)/_]):u[0][1][1]<=0&&u[0][2][2]>0?d=o.Z.matVecMult(C,[Math.cos(t)/f,1/p,Math.sin(t)/_]):u[0][2][2]<0&&(d=o.Z.matVecMult(C,[Math.sin(t)/f,Math.cos(t)/p,1/_])),s.Z.exists(d)?(d[1]/=d[0],d[2]/=d[0],d[0]=1):d=[1,NaN,NaN],d},a.X=function(t,e){return n(t,e)[1]},a.Y=function(t,e){return n(t,e)[2]},a.midpoint=t.create("point",[function(){var t=a.quadraticform;return[t[1][1]*t[2][2]-t[1][2]*t[1][2],t[1][2]*t[0][2]-t[2][2]*t[0][1],t[0][1]*t[1][2]-t[1][1]*t[0][2]]}],x),a.type=i.Z.OBJECT_TYPE_CONIC,a.center=a.midpoint,a.subs={center:a.center},a.inherits.push(a.center),a.inherits=a.inherits.concat(P),Z){for(m=0;m<5;m++)s.Z.isPoint(P[m])&&P[m].addChild(a);a.setParents(e)}return a.addChild(a.center),a},t.Z.registerElement("ellipse",t.Z.createEllipse),t.Z.registerElement("hyperbola",t.Z.createHyperbola),t.Z.registerElement("parabola",t.Z.createParabola),t.Z.registerElement("conic",t.Z.createConic),t.Z.Polygon=function(e,r,o){this.constructor(e,o,i.Z.OBJECT_TYPE_POLYGON,i.Z.OBJECT_CLASS_AREA);var n,a,h,l,c,d=s.Z.copyAttributes(o,e.options,"polygon","borders");for(this.withLines=o.withlines,this.attr_line=d,this.vertices=[],n=0;n<r.length;n++)this.vertices[n]=this.board.select(r[n]),this.vertices[n]._is_new&&(delete this.vertices[n]._is_new,this.vertices[n]._is_new_pol=!0);if(this.vertices.length>0&&this.vertices[this.vertices.length-1].id!==this.vertices[0].id&&this.vertices.push(this.vertices[0]),this.borders=[],this.withLines)for(h=this.vertices.length-1,l=0;l<h;l++)n=(l+1)%h,d.id=d.ids&&d.ids[n],d.name=d.names&&d.names[n],d.strokecolor=s.Z.isArray(d.colors)&&d.colors[n%d.colors.length]||d.strokecolor,d.visible=s.Z.exists(o.borders.visible)?o.borders.visible:o.visible,!1===d.strokecolor&&(d.strokecolor="none"),(a=e.create("segment",[this.vertices[n],this.vertices[n+1]],d)).dump=!1,this.borders[n]=a,a.parentPolygon=this;for(this.inherits.push(this.vertices,this.borders),this.id=this.board.setId(this,"Py"),n=0;n<this.vertices.length-1;n++)c=this.board.select(this.vertices[n]),s.Z.exists(c._is_new_pol)?(this.addChild(c),delete c._is_new_pol):c.addChild(this);this.board.renderer.drawPolygon(this),this.board.finalizeAdding(this),this.createGradient(),this.elType="polygon",this.createLabel(),this.methodMap=t.Z.deepCopy(this.methodMap,{borders:"borders",vertices:"vertices",A:"Area",Area:"Area",Perimeter:"Perimeter",L:"Perimeter",Length:"Perimeter",boundingBox:"boundingBox",bounds:"bounds",addPoints:"addPoints",insertPoints:"insertPoints",removePoints:"removePoints"})},t.Z.Polygon.prototype=new G.Z,t.Z.extend(t.Z.Polygon.prototype,{pnpoly:function(t,e,i){return u.Z.pnpoly(t,e,this.vertices,i)},hasPoint:function(t,e){var i,r;if(s.Z.evaluate(this.visProp.hasinnerpoints)&&this.pnpoly(t,e))return!0;for(r=this.borders.length,i=0;i<r;i++)if(this.borders[i].hasPoint(t,e))return!0;return!1},updateRenderer:function(){var t,e;if(!this.needsUpdate)return this;if(this.visPropCalc.visible){for(e=this.vertices.length,this.isReal=!0,t=0;t<e;++t)if(!this.vertices[t].isReal){this.isReal=!1;break}this.isReal||this.updateVisibility(!1)}return this.visPropCalc.visible&&this.board.renderer.updatePolygon(this),this.hasLabel&&this.visPropCalc.visible&&this.label&&this.label.visPropCalc.visible&&this.isReal&&(this.label.update(),this.board.renderer.updateText(this.label)),this.setDisplayRendNode(),this.needsUpdate=!1,this},getTextAnchor:function(){var t,e,s,r,o;if(0===this.vertices.length)return new c.Z(i.Z.COORDS_BY_USER,[1,0,0],this.board);for(s=t=this.vertices[0].X(),r=e=this.vertices[0].Y(),o=0;o<this.vertices.length;o++)this.vertices[o].X()<t&&(t=this.vertices[o].X()),this.vertices[o].X()>s&&(s=this.vertices[o].X()),this.vertices[o].Y()>e&&(e=this.vertices[o].Y()),this.vertices[o].Y()<r&&(r=this.vertices[o].Y());return new c.Z(i.Z.COORDS_BY_USER,[.5*(t+s),.5*(e+r)],this.board)},getLabelAnchor:t.Z.shortcut(t.Z.Polygon.prototype,"getTextAnchor"),cloneToBackground:function(){var t,e={};return e.id=this.id+"T"+this.numTraces,this.numTraces++,e.vertices=this.vertices,e.visProp=s.Z.deepCopy(this.visProp,this.visProp.traceattributes,!0),e.visProp.layer=this.board.options.layer.trace,e.board=this.board,s.Z.clearVisPropOld(e),e.visPropCalc={visible:s.Z.evaluate(e.visProp.visible)},t=this.board.renderer.enhancedRendering,this.board.renderer.enhancedRendering=!0,this.board.renderer.drawPolygon(e),this.board.renderer.enhancedRendering=t,this.traces[e.id]=e.rendNode,this},hideElement:function(e){var i;if(t.Z.deprecated("Element.hideElement()","Element.setDisplayRendNode()"),this.visPropCalc.visible=!1,this.board.renderer.display(this,!1),!e)for(i=0;i<this.borders.length;i++)this.borders[i].hideElement();this.hasLabel&&s.Z.exists(this.label)&&(this.label.hiddenByParent=!0,this.label.visPropCalc.visible&&this.label.hideElement())},showElement:function(e){var i;if(t.Z.deprecated("Element.showElement()","Element.setDisplayRendNode()"),this.visPropCalc.visible=!0,this.board.renderer.display(this,!0),!e)for(i=0;i<this.borders.length;i++)this.borders[i].showElement().updateRenderer();return s.Z.exists(this.label)&&this.hasLabel&&this.label.hiddenByParent&&(this.label.hiddenByParent=!1,this.label.visPropCalc.visible||this.label.showElement().updateRenderer()),this},Area:function(){return Math.abs(u.Z.signedPolygon(this.vertices,!0))},Perimeter:function(){var t,e=this.vertices.length,i=0;for(t=1;t<e;++t)i+=this.vertices[t].Dist(this.vertices[t-1]);return i},boundingBox:function(){var t,e,i=[0,0,0,0],s=this.vertices.length-1;if(0===s)return i;for(i[0]=this.vertices[0].X(),i[2]=i[0],i[1]=this.vertices[0].Y(),i[3]=i[1],t=1;t<s;++t)(e=this.vertices[t].X())<i[0]?i[0]=e:e>i[2]&&(i[2]=e),(e=this.vertices[t].Y())>i[1]?i[1]=e:e<i[3]&&(i[3]=e);return i},bounds:function(){return this.boundingBox()},remove:function(){var t;for(t=0;t<this.borders.length;t++)this.board.removeObject(this.borders[t]);G.Z.prototype.remove.call(this)},findPoint:function(t){var e;if(!s.Z.isPoint(t))return-1;for(e=0;e<this.vertices.length;e++)if(this.vertices[e].id===t.id)return e;return-1},addPoints:function(t){var e,i=Array.prototype.slice.call(arguments);return e="polygonalchain"===this.elType?this.vertices.length-1:this.vertices.length-2,this.insertPoints.apply(this,[e].concat(i))},insertPoints:function(t,e){var i,r,o,n,a;if(0===arguments.length)return this;if(o=this.vertices.length-1,"polygon"===this.elType&&o--,t<-1||t>o)return this;for(r=arguments.length-1,i=1;i<r+1;i++)(a=s.Z.providePoints(this.board,[arguments[i]],{},"polygon",["vertices"])[0])._is_new&&(this.addChild(a),delete a._is_new),this.vertices.splice(t+i,0,a);if(this.withLines)for(n=t+1,"polygon"===this.elType?t<0?(this.vertices[this.vertices.length-1]=this.vertices[0],this.borders[this.borders.length-1].point2=this.vertices[this.vertices.length-1]):this.borders[t].point2=this.vertices[n]:t>=0&&(t<this.borders.length?this.borders[t].point2=this.vertices[n]:n=t),i=n;i<n+r;i++)this.borders.splice(i,0,this.board.create("segment",[this.vertices[i],this.vertices[i+1]],this.attr_line));return this.inherits=[],this.inherits.push(this.vertices,this.borders),this.board.update(),this},removePoints:function(t){var e,i,r,o,n=[],a=[],h=[],l=[];for("polygon"===this.elType&&(o=this.vertices.pop()),e=0;e<arguments.length;e++)r=arguments[e],s.Z.isPoint(r)&&(r=this.findPoint(r)),s.Z.isNumber(r)&&r>-1&&r<this.vertices.length&&-1===s.Z.indexOf(h,r)&&h.push(r);if(0===h.length)return"polygon"===this.elType&&this.vertices.push(o),this;for(e=0;e<h.length;e++)this.vertices[h[e]].removeChild(this);for(h=h.sort(),n=this.vertices.slice(),a=this.borders.slice(),this.withLines&&l.push([h[h.length-1]]),e=h.length-1;e>-1;e--)n[h[e]]=-1,this.withLines&&h.length>1&&h[e]-1>h[e-1]&&(l[l.length-1][1]=h[e],l.push([h[e-1]]));for(this.withLines&&(l[l.length-1][1]=h[0]),this.vertices=[],e=0;e<n.length;e++)s.Z.isPoint(n[e])&&this.vertices.push(n[e]);if("polygon"===this.elType&&this.vertices.length>1&&this.vertices[this.vertices.length-1].id!==this.vertices[0].id&&this.vertices.push(this.vertices[0]),this.withLines){for(e=0;e<l.length;e++){for(i=l[e][1]-1;i<l[e][0]+1;i++)i<0?"polygon"===this.elType&&(this.board.removeObject(this.borders[a.length-1]),a[a.length-1]=-1):i<a.length&&(this.board.removeObject(this.borders[i]),a[i]=-1);0!==l[e][1]&&l[e][0]!==n.length-1&&(a[l[e][0]-1]=this.board.create("segment",[n[l[e][1]-1],n[l[e][0]+1]],this.attr_line))}for(this.borders=[],e=0;e<a.length;e++)-1!==a[e]&&this.borders.push(a[e]);"polygon"===this.elType&&this.vertices.length>2&&(l[0][1]===this.vertices.length-1||0===l[l.length-1][1])&&this.borders.push(this.board.create("segment",[this.vertices[0],this.vertices[this.vertices.length-2]],this.attr_line))}return this.inherits=[],this.inherits.push(this.vertices,this.borders),this.board.update(),this},getParents:function(){return this.setParents(this.vertices),this.parents},getAttributes:function(){var t,e=G.Z.prototype.getAttributes.call(this);if(this.withLines)for(e.lines=e.lines||{},e.lines.ids=[],e.lines.colors=[],t=0;t<this.borders.length;t++)e.lines.ids.push(this.borders[t].id),e.lines.colors.push(this.borders[t].visProp.strokecolor);return e},snapToGrid:function(){var t,e;for(e=!!s.Z.evaluate(this.visProp.snaptogrid),t=0;t<this.vertices.length;t++)this.vertices[t].handleSnapToGrid(e,!0)},setPositionDirectly:function(t,e,i){var s,r,o,n=new c.Z(t,e,this.board),a=new c.Z(t,i,this.board);for(o=this.vertices.length-1,r=0;r<o;r++)if(!this.vertices[r].draggable())return this;return s=d.Z.subtract(n.usrCoords,a.usrCoords),this.board.create("transform",s.slice(1),{type:"translate"}).applyOnce(this.vertices.slice(0,-1)),this},sutherlandHodgman:function(e){var i,s,r,o,n,a,h,l=t.Z.Math.Geometry.sortVertices(this.vertices),c=t.Z.Math.Geometry.sortVertices(e.vertices),d=l.length-1,u=c.length-1,p=[],_=function(t,e,i){return(e[1]-t[1])*(i[2]-t[2])-(e[2]-t[2])*(i[1]-t[1])>=0};for(r=0;r<u;r++)p.push(c[r]);for(r=0;r<d;r++)for(s=p.slice(0),p=[],n=s[(i=s.length)-1],o=0;o<i;o++)a=s[o],_(l[r],l[r+1],a)?(_(l[r],l[r+1],n)||((h=t.Z.Math.Geometry.meetSegmentSegment(n,a,l[r],l[r+1]))[0][1]/=h[0][0],h[0][2]/=h[0][0],h[0][0]=1,p.push(h[0])),p.push(a)):_(l[r],l[r+1],n)&&((h=t.Z.Math.Geometry.meetSegmentSegment(n,a,l[r],l[r+1]))[0][1]/=h[0][0],h[0][2]/=h[0][0],h[0][0]=1,p.push(h[0])),n=a;return p},intersect:function(t){return this.sutherlandHodgman(t)}}),t.Z.createPolygon=function(e,r,o){var n,a,h,l,c,d,u=[],p=!1;if(s.Z.copyAttributes(o,e.options,"polygon"),null===(l=e.select(r[0]))&&(l=r[0]),s.Z.isObject(l)&&l.type===i.Z.OBJECT_TYPE_POLYGON&&s.Z.isTransformationOrArray(r[1]))for(p=!0,h=l.vertices.length-1,d=s.Z.copyAttributes(o,e.options,"polygon","vertices"),a=0;a<h;a++)d.withlabel&&(d.name=""===l.vertices[a].name?"":l.vertices[a].name+"'"),u.push(e.create("point",[l.vertices[a],r[1]],d));else if(!1===(u=s.Z.providePoints(e,r,o,"polygon",["vertices"])))throw new Error("JSXGraph: Can't create polygon / polygonalchain with parent types other than 'point' and 'coordinate arrays' or a function returning an array of coordinates. Alternatively, a polygon and a transformation can be supplied");if(c=s.Z.copyAttributes(o,e.options,"polygon"),(n=new t.Z.Polygon(e,u,c)).isDraggable=!0,p)for(n.prepareUpdate().update().updateVisibility().updateRenderer(),h=l.vertices.length-1,a=0;a<h;a++)u[a].prepareUpdate().update().updateVisibility().updateRenderer();return n},t.Z.createRegularPolygon=function(t,e,r){var o,n,a,h,l,c,d,u=[];if(a=e[(l=e.length)-1],s.Z.isNumber(a)&&(3!==e.length||a<3))throw new Error("JSXGraph: A regular polygon needs two point types and a number > 2 as input.");if(s.Z.isNumber(t.select(a))?(l--,c=!1):(a=l,c=!0),!1===(u=s.Z.providePoints(t,e.slice(0,l),r,"regularpolygon",["vertices"])))throw new Error("JSXGraph: Can't create regular polygon with parent types other than 'point' and 'coordinate arrays' or a function returning an array of coordinates");for(d=s.Z.copyAttributes(r,t.options,"regularpolygon","vertices"),n=2;n<a;n++)h=t.create("transform",[Math.PI*(2-(a-2)/a),u[n-1]],{type:"rotate"}),c?(u[n].addTransform(u[n-2],h),u[n].fullUpdate()):(s.Z.isArray(d.ids)&&d.ids.length>=a-2&&(d.id=d.ids[n-2]),u[n]=t.create("point",[u[n-2],h],d),u[n].type=i.Z.OBJECT_TYPE_CAS,u[n].isDraggable=!0,u[n].visProp.fixed=!1);return d=s.Z.copyAttributes(r,t.options,"regularpolygon"),(o=t.create("polygon",u,d)).elType="regularpolygon",o},t.Z.createPolygonalChain=function(t,e,i){var r,o;return r=s.Z.copyAttributes(i,t.options,"polygonalchain"),(o=t.create("polygon",e,r)).elType="polygonalchain",o.vertices.pop(),t.removeObject(o.borders[o.borders.length-1]),o.borders.pop(),o},t.Z.registerElement("polygon",t.Z.createPolygon),t.Z.registerElement("regularpolygon",t.Z.createRegularPolygon),t.Z.registerElement("polygonalchain",t.Z.createPolygonalChain);const V=t.Z.Polygon;t.Z.Curve=function(t,e,r){this.constructor(t,r,i.Z.OBJECT_TYPE_CURVE,i.Z.OBJECT_CLASS_CURVE),this.points=[],this.numberPoints=s.Z.evaluate(this.visProp.numberpointshigh),this.bezierDegree=1,this.dataX=null,this.dataY=null,this.ticks=[],this.qdt=null,s.Z.exists(e[0])?this.varname=e[0]:this.varname="x",this.xterm=e[1],this.yterm=e[2],this.generateTerm(this.varname,this.xterm,this.yterm,e[3],e[4]),this.updateCurve(),this.id=this.board.setId(this,"G"),this.board.renderer.drawCurve(this),this.board.finalizeAdding(this),this.createGradient(),this.elType="curve",this.createLabel(),s.Z.isString(this.xterm)&&this.notifyParents(this.xterm),s.Z.isString(this.yterm)&&this.notifyParents(this.yterm),this.methodMap=s.Z.deepCopy(this.methodMap,{generateTerm:"generateTerm",setTerm:"generateTerm",move:"moveTo",moveTo:"moveTo"})},t.Z.Curve.prototype=new G.Z,t.Z.extend(t.Z.Curve.prototype,{minX:function(){return"polar"===s.Z.evaluate(this.visProp.curvetype)?0:new c.Z(i.Z.COORDS_BY_SCREEN,[.1*-this.board.canvasWidth,0],this.board,!1).usrCoords[1]},maxX:function(){return"polar"===s.Z.evaluate(this.visProp.curvetype)?2*Math.PI:new c.Z(i.Z.COORDS_BY_SCREEN,[1.1*this.board.canvasWidth,0],this.board,!1).usrCoords[1]},X:function(t){return NaN},Y:function(t){return NaN},Z:function(t){return 1},hasPoint:function(t,e,r){var n,a,h,l,d,p,_,f,b,g,m,v,Z,C,y,P,E=[],O=s.Z.evaluate(this.visProp.numberpointslow),x=(this.maxX()-this.minX())/O,w=1/0;if(s.Z.isObject(s.Z.evaluate(this.visProp.precision))?(v=this.board._inputDevice,m=s.Z.evaluate(this.visProp.precision[v])):m=this.board.options.precision.hasPoint,t=(a=new c.Z(i.Z.COORDS_BY_SCREEN,[t,e],this.board,!1)).usrCoords[1],e=a.usrCoords[2],1===this.bezierDegree&&s.Z.evaluate(this.visProp.hasinnerpoints)&&0!==u.Z.windingNumber([1,t,e],this.points,!0))return!0;if(m+=.5*s.Z.evaluate(this.visProp.strokewidth),m*=m,Z=this.board.unitX*this.board.unitX,C=this.board.unitY*this.board.unitY,P=this.minX(),this.maxX(),s.Z.exists(this._visibleArea)&&(P=this._visibleArea[0],x=(this._visibleArea[1]-P)/O),"parameter"===(y=s.Z.evaluate(this.visProp.curvetype))||"polar"===y)for(this.transformations.length>0&&(this.updateTransformMatrix(),l=o.Z.inverse(this.transformMat),t=(d=o.Z.matVecMult(l,[1,t,e]))[1],e=d[2]),p=0,n=P;p<O;p++){if((w=(t-(_=this.X(n,true)))*(t-_)*Z+(e-(f=this.Y(n,true)))*(e-f)*C)<=m)return!0;n+=x}else if("plot"===y||"functiongraph"===y){for((!s.Z.exists(r)||r<0)&&(r=0),s.Z.exists(this.qdt)&&s.Z.evaluate(this.visProp.useqdt)&&3!==this.bezierDegree?h=(b=(g=this.qdt.query(new c.Z(i.Z.COORDS_BY_USER,[t,e],this.board))).points).length:(b=this.points,h=this.numberPoints-1),p=r;p<h;p++)if(3===this.bezierDegree?E.push(u.Z.projectCoordsToBeziersegment([1,t,e],this,p)):g?(b[p].prev&&(E=u.Z.projectCoordsToSegment([1,t,e],b[p].prev.usrCoords,b[p].usrCoords)),b[p].next&&b[p+1]!==b[p].next&&(E=u.Z.projectCoordsToSegment([1,t,e],b[p].usrCoords,b[p].next.usrCoords))):E=u.Z.projectCoordsToSegment([1,t,e],b[p].usrCoords,b[p+1].usrCoords),E[1]>=0&&E[1]<=1&&(t-E[0][1])*(t-E[0][1])*Z+(e-E[0][2])*(e-E[0][2])*C<=m)return!0;return!1}return w<m},allocatePoints:function(){var t,e;if(e=this.numberPoints,this.points.length<this.numberPoints)for(t=this.points.length;t<e;t++)this.points[t]=new c.Z(i.Z.COORDS_BY_USER,[0,0],this.board,!1)},update:function(){return this.needsUpdate&&(s.Z.evaluate(this.visProp.trace)&&this.cloneToBackground(!0),this.updateCurve()),this},updateRenderer:function(){return this.needsUpdate?(this.visPropCalc.visible&&(this.isReal=p.checkReal(this.points),this.isReal||this.updateVisibility(!1)),this.visPropCalc.visible&&this.board.renderer.updateCurve(this),this.hasLabel&&this.visPropCalc.visible&&this.label&&this.label.visPropCalc.visible&&this.isReal&&(this.label.update(),this.board.renderer.updateText(this.label)),this.setDisplayRendNode(),this.needsUpdate=!1,this):this},updateDataArray:function(){},updateCurve:function(){var t,e,r,o,n,a,c=this.visProp.plotversion,d=!1;if(this.updateTransformMatrix(),this.updateDataArray(),e=this.minX(),r=this.maxX(),s.Z.exists(this.dataX))for(this.numberPoints=this.dataX.length,t=this.numberPoints,this.allocatePoints(),a=0;a<t;a++)o=a,s.Z.exists(this.dataY)?(n=a,this.points[a].setCoordinates(i.Z.COORDS_BY_USER,[this.dataX[a],this.dataY[a]],!1)):(n=this.X(o),this.points[a].setCoordinates(i.Z.COORDS_BY_USER,[this.dataX[a],this.Y(n,d)],!1)),this.points[a]._t=a,d=!0;else if(s.Z.evaluate(this.visProp.doadvancedplot)?1===c||s.Z.evaluate(this.visProp.doadvancedplotold)?p.updateParametricCurveOld(this,e,r):2===c?p.updateParametricCurve_v2(this,e,r):3===c?p.updateParametricCurve_v3(this,e,r):4===c?p.updateParametricCurve_v4(this,e,r):p.updateParametricCurve_v2(this,e,r):(this.board.updateQuality===this.board.BOARD_QUALITY_HIGH?this.numberPoints=s.Z.evaluate(this.visProp.numberpointshigh):this.numberPoints=s.Z.evaluate(this.visProp.numberpointslow),this.allocatePoints(),p.updateParametricCurveNaive(this,e,r,this.numberPoints)),t=this.numberPoints,s.Z.evaluate(this.visProp.useqdt)&&this.board.updateQuality===this.board.BOARD_QUALITY_HIGH)for(this.qdt=new h(this.board.getBoundingBox()),a=0;a<this.points.length;a++)this.qdt.insert(this.points[a]),a>0&&(this.points[a].prev=this.points[a-1]),a<t-1&&(this.points[a].next=this.points[a+1]);for("plot"!==s.Z.evaluate(this.visProp.curvetype)&&s.Z.evaluate(this.visProp.rdpsmoothing)&&(this.points=l.Z.RamerDouglasPeucker(this.points,.2),this.numberPoints=this.points.length),t=this.numberPoints,a=0;a<t;a++)this.updateTransform(this.points[a]);return this},updateTransformMatrix:function(){var t,e,i=this.transformations.length;for(this.transformMat=[[1,0,0],[0,1,0],[0,0,1]],e=0;e<i;e++)(t=this.transformations[e]).update(),this.transformMat=o.Z.matMatMult(t.matrix,this.transformMat);return this},updateTransform:function(t){var e;return this.transformations.length>0&&(e=o.Z.matVecMult(this.transformMat,t.usrCoords),t.setCoordinates(i.Z.COORDS_BY_USER,e,!1,!0)),t},addTransform:function(t){var e,i=s.Z.isArray(t)?t:[t],r=i.length;for(e=0;e<r;e++)this.transformations.push(i[e]);return this},interpolationFunctionFromArray:function(t){var e="data"+t,i=this;return function(t,r){var o,n,a,h,l=i[e],c=l.length,d=[];if(isNaN(t))return NaN;if(t<0)return s.Z.isFunction(l[0])?l[0]():l[0];if(3===i.bezierDegree){if(t>=(c-1)/3)return s.Z.isFunction(l[l.length-1])?l[l.length-1]():l[l.length-1];for(o=3*Math.floor(t),h=1-(a=t%1),n=0;n<4;n++)s.Z.isFunction(l[o+n])?d[n]=l[o+n]():d[n]=l[o+n];return h*h*(h*d[0]+3*a*d[1])+(3*h*d[2]+a*d[3])*a*a}if((o=t>c-2?c-2:parseInt(Math.floor(t),10))===t)return s.Z.isFunction(l[o])?l[o]():l[o];for(n=0;n<2;n++)s.Z.isFunction(l[o+n])?d[n]=l[o+n]():d[n]=l[o+n];return d[0]+(d[1]-d[0])*(t-o)}},generateTerm:function(t,e,i,r,o){var n,a;s.Z.isArray(e)?(this.dataX=e,this.numberPoints=this.dataX.length,this.X=this.interpolationFunctionFromArray.apply(this,["X"]),this.visProp.curvetype="plot",this.isDraggable=!0):(this.X=s.Z.createFunction(e,this.board,t),s.Z.isString(e)?this.visProp.curvetype="functiongraph":(s.Z.isFunction(e)||s.Z.isNumber(e))&&(this.visProp.curvetype="parameter"),this.isDraggable=!0),s.Z.isArray(i)?(this.dataY=i,this.Y=this.interpolationFunctionFromArray.apply(this,["Y"])):this.Y=s.Z.createFunction(i,this.board,t),s.Z.isFunction(e)&&s.Z.isArray(i)&&(n=s.Z.createFunction(i[0],this.board,""),a=s.Z.createFunction(i[1],this.board,""),this.X=function(t){return e(t)*Math.cos(t)+n()},this.X.deps=n.deps,this.Y=function(t){return e(t)*Math.sin(t)+a()},this.Y.deps=a.deps,this.visProp.curvetype="polar"),s.Z.exists(r)&&(this.minX=s.Z.createFunction(r,this.board,"")),s.Z.exists(o)&&(this.maxX=s.Z.createFunction(o,this.board,"")),this.addParentsFromJCFunctions([this.X,this.Y,this.minX,this.maxX])},notifyParents:function(t){var e,i,s,r=!1;for(e in s={xterm:1,yterm:1})if(s.hasOwnProperty(e)&&this.hasOwnProperty(e)&&this[e].origin)for(i in r=!0,this[e].origin.deps)this[e].origin.deps.hasOwnProperty(i)&&this[e].origin.deps[i].addChild(this);r||R.Z.findDependencies(this,t,this.board)},getLabelAnchor:function(){var t,e,r,o=.05*this.board.canvasWidth,n=.05*this.board.canvasHeight,a=.95*this.board.canvasWidth,h=.95*this.board.canvasHeight;switch(s.Z.evaluate(this.visProp.label.position)){case"ulft":e=o,r=n;break;case"llft":e=o,r=h;break;case"rt":e=a,r=.5*h;break;case"lrt":e=a,r=h;break;case"urt":e=a,r=n;break;case"top":e=.5*a,r=n;break;case"bot":e=.5*a,r=h;break;default:e=o,r=.5*h}return t=new c.Z(i.Z.COORDS_BY_SCREEN,[e,r],this.board,!1),u.Z.projectCoordsToCurve(t.usrCoords[1],t.usrCoords[2],0,this,this.board)[0]},cloneToBackground:function(){var t,e={id:this.id+"T"+this.numTraces,elementClass:i.Z.OBJECT_CLASS_CURVE,points:this.points.slice(0),bezierDegree:this.bezierDegree,numberPoints:this.numberPoints,board:this.board,visProp:s.Z.deepCopy(this.visProp,this.visProp.traceattributes,!0)};return e.visProp.layer=this.board.options.layer.trace,e.visProp.curvetype=this.visProp.curvetype,this.numTraces++,s.Z.clearVisPropOld(e),e.visPropCalc={visible:s.Z.evaluate(e.visProp.visible)},t=this.board.renderer.enhancedRendering,this.board.renderer.enhancedRendering=!0,this.board.renderer.drawCurve(e),this.board.renderer.enhancedRendering=t,this.traces[e.id]=e.rendNode,this},bounds:function(){var t,e,i,r=1/0,o=-1/0,n=1/0,a=-1/0,h=this.points.length;if(3===this.bezierDegree){for(t=0;t<h;t++)this.points[t].X=s.Z.bind((function(){return this.usrCoords[1]}),this.points[t]),this.points[t].Y=s.Z.bind((function(){return this.usrCoords[2]}),this.points[t]);return i=(e=l.Z.bezier(this.points))[3](),r=l.Z.fminbr((function(t){return e[0](t)}),[0,i]),o=l.Z.fminbr((function(t){return-e[0](t)}),[0,i]),n=l.Z.fminbr((function(t){return e[1](t)}),[0,i]),a=l.Z.fminbr((function(t){return-e[1](t)}),[0,i]),r=e[0](r),o=e[0](o),n=e[1](n),[r,a=e[1](a),o,n]}for(t=0;t<h;t++)r>this.points[t].usrCoords[1]&&(r=this.points[t].usrCoords[1]),o<this.points[t].usrCoords[1]&&(o=this.points[t].usrCoords[1]),n>this.points[t].usrCoords[2]&&(n=this.points[t].usrCoords[2]),a<this.points[t].usrCoords[2]&&(a=this.points[t].usrCoords[2]);return[r,a,o,n]},getParents:function(){var t=[this.xterm,this.yterm,this.minX(),this.maxX()];return 0!==this.parents.length&&(t=this.parents),t},moveTo:function(t){var e,r=[];return this.points.length>0&&!s.Z.evaluate(this.visProp.fixed)&&(e=this.points[0],r=3===t.length?[t[0]-e.usrCoords[0],t[1]-e.usrCoords[1],t[2]-e.usrCoords[2]]:[t[0]-e.usrCoords[1],t[1]-e.usrCoords[2]],this.setPosition(i.Z.COORDS_BY_USER,r)),this},getTransformationSource:function(){var t,e;return s.Z.exists(this._transformationSource)&&(e=this._transformationSource).elementClass===i.Z.OBJECT_CLASS_CURVE&&(t=!0),[t,e]},pnpoly:function(t,e,s){var r,o,n,a,h,l,d=this.points,u=!1;for(s===i.Z.COORDS_BY_USER?(a=(l=new c.Z(i.Z.COORDS_BY_USER,[t,e],this.board)).scrCoords[1],h=l.scrCoords[2]):(a=t,h=e),r=0,o=(n=this.points.length)-2;r<n-1;o=r++)d[r].scrCoords[2]>h!=d[o].scrCoords[2]>h&&a<(d[o].scrCoords[1]-d[r].scrCoords[1])*(h-d[r].scrCoords[2])/(d[o].scrCoords[2]-d[r].scrCoords[2])+d[r].scrCoords[1]&&(u=!u);return u}}),t.Z.createCurve=function(e,r,o){var n,a,h=s.Z.copyAttributes(o,e.options,"curve");return n=e.select(r[0],!0),s.Z.isTransformationOrArray(r[1])&&s.Z.isObject(n)&&(n.type===i.Z.OBJECT_TYPE_CURVE||n.type===i.Z.OBJECT_TYPE_ANGLE||n.type===i.Z.OBJECT_TYPE_ARC||n.type===i.Z.OBJECT_TYPE_CONIC||n.type===i.Z.OBJECT_TYPE_SECTOR)?(n.type===i.Z.OBJECT_TYPE_SECTOR?h=s.Z.copyAttributes(o,e.options,"sector"):n.type===i.Z.OBJECT_TYPE_ARC?h=s.Z.copyAttributes(o,e.options,"arc"):n.type===i.Z.OBJECT_TYPE_ANGLE?(s.Z.exists(o.withLabel)||(o.withLabel=!1),h=s.Z.copyAttributes(o,e.options,"angle")):h=s.Z.copyAttributes(o,e.options,"curve"),h=s.Z.copyAttributes(h,e.options,"curve"),(a=new t.Z.Curve(e,["x",[],[]],h)).updateDataArray=function(){var t,e=n.numberPoints;for(this.bezierDegree=n.bezierDegree,this.dataX=[],this.dataY=[],t=0;t<e;t++)this.dataX.push(n.points[t].usrCoords[1]),this.dataY.push(n.points[t].usrCoords[2]);return this},a.addTransform(r[1]),n.addChild(a),a.setParents([n]),a._transformationSource=n,a):(h=s.Z.copyAttributes(o,e.options,"curve"),new t.Z.Curve(e,["x"].concat(r),h))},t.Z.registerElement("curve",t.Z.createCurve),t.Z.createFunctiongraph=function(e,i,r){var o,n=["x","x"].concat(i);return(o=s.Z.copyAttributes(r,e.options,"curve")).curvetype="functiongraph",new t.Z.Curve(e,n,o)},t.Z.registerElement("functiongraph",t.Z.createFunctiongraph),t.Z.registerElement("plot",t.Z.createFunctiongraph),t.Z.createSpline=function(e,i,r){var o,n,a;return n=function(){var t,e=[],r=[];return[function(o,n){var a,h,c;if(!n){if(e=[],r=[],2===i.length&&s.Z.isArray(i[0])&&s.Z.isArray(i[1])&&i[0].length===i[1].length)for(a=0;a<i[0].length;a++)s.Z.isFunction(i[0][a])?e.push(i[0][a]()):e.push(i[0][a]),s.Z.isFunction(i[1][a])?r.push(i[1][a]()):r.push(i[1][a]);else for(a=0;a<i.length;a++)if(s.Z.isPoint(i[a]))e.push(i[a].X()),r.push(i[a].Y());else if(s.Z.isArray(i[a])&&2===i[a].length)for(h=0;h<i.length;h++)s.Z.isFunction(i[h][0])?e.push(i[h][0]()):e.push(i[h][0]),s.Z.isFunction(i[h][1])?r.push(i[h][1]()):r.push(i[h][1]);else s.Z.isFunction(i[a])&&2===i[a]().length&&(c=i[a](),e.push(c[0]),r.push(c[1]));t=l.Z.splineDef(e,r)}return l.Z.splineEval(o,e,r,t)},function(){return e[0]},function(){return e[e.length-1]}]},(r=s.Z.copyAttributes(r,e.options,"curve")).curvetype="functiongraph",a=n(),(o=new t.Z.Curve(e,["x","x",a[0],a[1],a[2]],r)).setParents(i),o.elType="spline",o},t.Z.registerElement("spline",t.Z.createSpline),t.Z.createCardinalSpline=function(e,i,r){var o,n,a,h,c,d,u,p,_,f,b="\nPossible parent types: [points:array, tau:number|function, type:string]";if(!s.Z.exists(i[0])||!s.Z.isArray(i[0]))throw new Error("JSXGraph: JXG.createCardinalSpline: argument 1 'points' has to be array of points or coordinate pairs"+b);if(!s.Z.exists(i[1])||!s.Z.isNumber(i[1])&&!s.Z.isFunction(i[1]))throw new Error("JSXGraph: JXG.createCardinalSpline: argument 2 'tau' has to be number between [0,1] or function'"+b);if(!s.Z.exists(i[2])||!s.Z.isString(i[2]))throw new Error("JSXGraph: JXG.createCardinalSpline: argument 3 'type' has to be string 'uniform' or 'centripetal'"+b);if(r=s.Z.copyAttributes(r,e.options,"curve"),(r=s.Z.copyAttributes(r,e.options,"cardinalspline")).curvetype="parameter",d=i[0],u=[],!r.isarrayofcoordinates&&2===d.length&&s.Z.isArray(d[0])&&s.Z.isArray(d[1])&&d[0].length===d[1].length)for(p=0;p<d[0].length;p++)u[p]=[],s.Z.isFunction(d[0][p])?u[p].push(d[0][p]()):u[p].push(d[0][p]),s.Z.isFunction(d[1][p])?u[p].push(d[1][p]()):u[p].push(d[1][p]);else for(p=0;p<d.length;p++)s.Z.isString(d[p])?u.push(e.select(d[p])):s.Z.isPoint(d[p])?u.push(d[p]):s.Z.isArray(d[p])&&2===d[p].length?(u[p]=[],s.Z.isFunction(d[p][0])?u[p].push(d[p][0]()):u[p].push(d[p][0]),s.Z.isFunction(d[p][1])?u[p].push(d[p][1]()):u[p].push(d[p][1])):s.Z.isFunction(d[p])&&2===d[p]().length&&u.push(i[p]());if(!0===r.createpoints)a=s.Z.providePoints(e,u,r,"cardinalspline",["points"]);else for(a=[],n=function(t){return{X:function(){return u[t][0]},Y:function(){return u[t][1]},Dist:function(t){var e=this.X()-t.X(),i=this.Y()-t.Y();return Math.sqrt(e*e+i*i)}}},p=0;p<u.length;p++)s.Z.isPoint(u[p])?a.push(u[p]):a.push(n(p));for(h=i[1],c=i[2],f=["x"].concat(l.Z.CardinalSpline(a,h,c)),o=new t.Z.Curve(e,f,r),_=a.length,o.setParents(a),p=0;p<_;p++)d=a[p],s.Z.isPoint(d)&&(s.Z.exists(d._is_new)?(o.addChild(d),delete d._is_new):d.addChild(o));return o.elType="cardinalspline",o},t.Z.registerElement("cardinalspline",t.Z.createCardinalSpline),t.Z.createMetapostSpline=function(e,i,r){var o,n,a,h,l,c,d,u,p="\nPossible parent types: [points:array, controls:object";if(!s.Z.exists(i[0])||!s.Z.isArray(i[0]))throw new Error("JSXGraph: JXG.createMetapostSpline: argument 1 'points' has to be array of points or coordinate pairs"+p);if(!s.Z.exists(i[1])||!s.Z.isObject(i[1]))throw new Error("JSXGraph: JXG.createMetapostSpline: argument 2 'controls' has to be a JavaScript object'"+p);if(r=s.Z.copyAttributes(r,e.options,"curve"),(r=s.Z.copyAttributes(r,e.options,"metapostspline")).curvetype="parameter",l=i[0],c=[],!r.isarrayofcoordinates&&2===l.length&&s.Z.isArray(l[0])&&s.Z.isArray(l[1])&&l[0].length===l[1].length)for(d=0;d<l[0].length;d++)c[d]=[],s.Z.isFunction(l[0][d])?c[d].push(l[0][d]()):c[d].push(l[0][d]),s.Z.isFunction(l[1][d])?c[d].push(l[1][d]()):c[d].push(l[1][d]);else for(d=0;d<l.length;d++)s.Z.isString(l[d])?c.push(e.select(l[d])):s.Z.isPoint(l[d])?c.push(l[d]):s.Z.isArray(l[d])&&2===l[d].length?(c[d]=[],s.Z.isFunction(l[d][0])?c[d].push(l[d][0]()):c[d].push(l[d][0]),s.Z.isFunction(l[d][1])?c[d].push(l[d][1]()):c[d].push(l[d][1])):s.Z.isFunction(l[d])&&2===l[d]().length&&c.push(i[d]());if(!0===r.createpoints)a=s.Z.providePoints(e,c,r,"metapostspline",["points"]);else for(a=[],n=function(t){return{X:function(){return c[t][0]},Y:function(){return c[t][1]}}},d=0;d<c.length;d++)s.Z.isPoint(c[d])?a.push(c[d]):a.push(n);for(h=i[1],(o=new t.Z.Curve(e,["t",[],[],0,l.length-1],r)).updateDataArray=function(){var e,i,s=a.length,r=[];for(i=0;i<s;i++)r.push([a[i].X(),a[i].Y()]);e=t.Z.Math.Metapost.curve(r,h),this.dataX=e[0],this.dataY=e[1]},o.bezierDegree=3,u=a.length,o.setParents(a),d=0;d<u;d++)s.Z.isPoint(a[d])&&a[d].addChild(o);return o.elType="metapostspline",o},t.Z.registerElement("metapostspline",t.Z.createMetapostSpline),t.Z.createRiemannsum=function(t,e,i){var r,o,n,a,h,c;if((c=s.Z.copyAttributes(i,t.options,"riemannsum")).curvetype="plot",n=e[0],r=s.Z.createFunction(e[1],t,""),!s.Z.exists(r))throw new Error("JSXGraph: JXG.createRiemannsum: argument '2' n has to be number or function.\nPossible parent types: [function,n:number|function,type,start:number|function,end:number|function]");if(o=s.Z.createFunction(e[2],t,"",!1),!s.Z.exists(o))throw new Error("JSXGraph: JXG.createRiemannsum: argument 3 'type' has to be string or function.\nPossible parent types: [function,n:number|function,type,start:number|function,end:number|function]");return a=[[0],[0]].concat(e.slice(3)),(h=t.create("curve",a,c)).sum=0,h.Value=function(){return this.sum},h.updateDataArray=function(){var t=l.Z.riemann(n,r(),o(),this.minX(),this.maxX());this.dataX=t[0],this.dataY=t[1],this.sum=t[2]},h.addParentsFromJCFunctions([r,o]),h},t.Z.registerElement("riemannsum",t.Z.createRiemannsum),t.Z.createTracecurve=function(t,e,r){var o,n,a,h;if(2!==e.length)throw new Error("JSXGraph: Can't create trace curve with given parent'\nPossible parent types: [glider, point]");if(n=t.select(e[0]),a=t.select(e[1]),n.type!==i.Z.OBJECT_TYPE_GLIDER||!s.Z.isPoint(a))throw new Error("JSXGraph: Can't create trace curve with parent types '"+typeof e[0]+"' and '"+typeof e[1]+"'.\nPossible parent types: [glider, point]");return(h=s.Z.copyAttributes(r,t.options,"tracecurve")).curvetype="plot",(o=t.create("curve",[[0],[0]],h)).updateDataArray=function(){var t,e,s,r,o,l,c,d,u,p=h.numberpoints,_=n.position,f=n.slideObject,b=f.minX();for(e=(f.maxX()-b)/p,this.dataX=[],this.dataY=[],f.elementClass!==i.Z.OBJECT_CLASS_CURVE&&p++,t=0;t<p;t++){for(r in s=b+t*e,l=f.X(s)/f.Z(s),c=f.Y(s)/f.Z(s),n.setPositionDirectly(i.Z.COORDS_BY_USER,[l,c]),d=!1,this.board.objects)if(this.board.objects.hasOwnProperty(r)&&((o=this.board.objects[r])===n&&(d=!0),d&&o.needsRegularUpdate&&(u=o.visProp.trace,o.visProp.trace=!1,o.needsUpdate=!0,o.update(!0),o.visProp.trace=u,o===a)))break;this.dataX[t]=a.X(),this.dataY[t]=a.Y()}for(r in n.position=_,d=!1,this.board.objects)if(this.board.objects.hasOwnProperty(r)&&((o=this.board.objects[r])===n&&(d=!0),d&&o.needsRegularUpdate&&(u=o.visProp.trace,o.visProp.trace=!1,o.needsUpdate=!0,o.update(!0),o.visProp.trace=u,o===a)))break},o},t.Z.registerElement("tracecurve",t.Z.createTracecurve),t.Z.createStepfunction=function(t,e,i){var r,o;if(2!==e.length)throw new Error("JSXGraph: Can't create step function with given parent'\nPossible parent types: [array, array|function]");return o=s.Z.copyAttributes(i,t.options,"stepfunction"),(r=t.create("curve",e,o)).updateDataArray=function(){var t,e=0,i=this.xterm.length;if(this.dataX=[],this.dataY=[],0!==i)for(this.dataX[e]=this.xterm[0],this.dataY[e]=this.yterm[0],++e,t=1;t<i;++t)this.dataX[e]=this.xterm[t],this.dataY[e]=this.dataY[e-1],++e,this.dataX[e]=this.xterm[t],this.dataY[e]=this.yterm[t],++e},r},t.Z.registerElement("stepfunction",t.Z.createStepfunction),t.Z.createDerivative=function(t,e,r){var o,n,a,h,c;if(1!==e.length&&e[0].class!==i.Z.OBJECT_CLASS_CURVE)throw new Error("JSXGraph: Can't create derivative curve with given parent'\nPossible parent types: [curve]");return c=s.Z.copyAttributes(r,t.options,"curve"),n=e[0],a=l.Z.D(n.X),h=l.Z.D(n.Y),(o=t.create("curve",[function(t){return n.X(t)},function(t){return h(t)/a(t)},n.minX(),n.maxX()],c)).setParents(n),o},t.Z.registerElement("derivative",t.Z.createDerivative),t.Z.createCurveIntersection=function(e,i,s){var r;if(2!==i.length)throw new Error("JSXGraph: Can't create curve intersection with given parent'\nPossible parent types: [array, array|function]");return(r=e.create("curve",[[],[]],s)).updateDataArray=function(){var e=t.Z.Math.Clip.intersection(i[0],i[1],this.board);this.dataX=e[0],this.dataY=e[1]},r},t.Z.createCurveUnion=function(e,i,s){var r;if(2!==i.length)throw new Error("JSXGraph: Can't create curve union with given parent'\nPossible parent types: [array, array|function]");return(r=e.create("curve",[[],[]],s)).updateDataArray=function(){var e=t.Z.Math.Clip.union(i[0],i[1],this.board);this.dataX=e[0],this.dataY=e[1]},r},t.Z.createCurveDifference=function(e,i,s){var r;if(2!==i.length)throw new Error("JSXGraph: Can't create curve difference with given parent'\nPossible parent types: [array, array|function]");return(r=e.create("curve",[[],[]],s)).updateDataArray=function(){var e=t.Z.Math.Clip.difference(i[0],i[1],this.board);this.dataX=e[0],this.dataY=e[1]},r},t.Z.registerElement("curvedifference",t.Z.createCurveDifference),t.Z.registerElement("curveintersection",t.Z.createCurveIntersection),t.Z.registerElement("curveunion",t.Z.createCurveUnion),t.Z.createBoxPlot=function(t,e,i){var r,o,n,a=s.Z.copyAttributes(i,t.options,"boxplot");if(3!==e.length)throw new Error("JSXGraph: Can't create box plot with given parent'\nPossible parent types: [array, number|function, number|function] containing quantiles, axis, width");if(e[0].length<5)throw new Error("JSXGraph: Can't create box plot with given parent[0]'\nparent[0] has to conatin at least 5 quantiles.");for(r=t.create("curve",[[],[]],a),n=e[0].length,r.Q=[],o=0;o<n;o++)r.Q[o]=s.Z.createFunction(e[0][o],t,null,!0);return r.x=s.Z.createFunction(e[1],t,null,!0),r.w=s.Z.createFunction(e[2],t,null,!0),r.updateDataArray=function(){var t,e,i,r,o,n,a,h,l;a=s.Z.evaluate(this.visProp.smallwidth),h=s.Z.evaluate(this.visProp.dir),i=(l=this.x())-.5*this.w(),r=l-.5*this.w()*a,o=l+.5*this.w(),t=[l,r,n=l+.5*this.w()*a,l,l,i,i,o,o,l,NaN,i,o,NaN,l,l,r,n,l],e=[this.Q[0](),this.Q[0](),this.Q[0](),this.Q[0](),this.Q[1](),this.Q[1](),this.Q[3](),this.Q[3](),this.Q[1](),this.Q[1](),NaN,this.Q[2](),this.Q[2](),NaN,this.Q[3](),this.Q[4](),this.Q[4](),this.Q[4](),this.Q[4]()],"vertical"===h?(this.dataX=t,this.dataY=e):(this.dataX=e,this.dataY=t)},r.addParentsFromJCFunctions([r.Q,r.x,r.w]),r},t.Z.registerElement("boxplot",t.Z.createBoxPlot);t.Z.Curve;t.Z.createArc=function(e,r,n){var a,h,l;if(!1===(l=s.Z.providePoints(e,r,n,"arc",["center","radiusPoint","anglePoint"]))||l.length<3)throw new Error("JSXGraph: Can't create Arc with parent types '"+typeof r[0]+"' and '"+typeof r[1]+"' and '"+typeof r[2]+"'.\nPossible parent types: [point,point,point], [arc, transformation]");return h=s.Z.copyAttributes(n,e.options,"arc"),(a=e.create("curve",[[0],[0]],h)).elType="arc",a.setParents(l),a.type=i.Z.OBJECT_TYPE_ARC,a.center=l[0],a.radiuspoint=l[1],a.point2=a.radiuspoint,a.anglepoint=l[2],a.point3=a.anglepoint,s.Z.exists(a.center._is_new)?(a.addChild(a.center),delete a.center._is_new):a.center.addChild(a),s.Z.exists(a.radiuspoint._is_new)?(a.addChild(a.radiuspoint),delete a.radiuspoint._is_new):a.radiuspoint.addChild(a),s.Z.exists(a.anglepoint._is_new)?(a.addChild(a.anglepoint),delete a.anglepoint._is_new):a.anglepoint.addChild(a),a.useDirection=h.usedirection,a.updateDataArray=function(){var t,e,i,r,o,n=1,a=this.radiuspoint,h=this.center,c=this.anglepoint,d=s.Z.evaluate(this.visProp.selection);e=u.Z.rad(a,h,c),("minor"===d&&e>Math.PI||"major"===d&&e<Math.PI)&&(n=-1),this.useDirection&&(i=l[1].coords.usrCoords,r=l[3].coords.usrCoords,o=l[2].coords.usrCoords,(i[1]-o[1])*(i[2]-r[2])-(i[2]-o[2])*(i[1]-r[1])<0?(this.radiuspoint=l[1],this.anglepoint=l[2]):(this.radiuspoint=l[2],this.anglepoint=l[1])),a=a.coords.usrCoords,h=h.coords.usrCoords,c=c.coords.usrCoords,t=u.Z.bezierArc(a,h,c,!1,n),this.dataX=t[0],this.dataY=t[1],this.bezierDegree=3,this.updateStdform(),this.updateQuadraticform()},a.Radius=function(){return this.radiuspoint.Dist(this.center)},a.getRadius=function(){return t.Z.deprecated("Arc.getRadius()","Arc.Radius()"),this.Radius()},a.Value=function(){return this.Radius()*u.Z.rad(this.radiuspoint,this.center,this.anglepoint)},a.hasPoint=function(t,e){var r,n,a,h,l,d,p,_=this.Radius();return s.Z.evaluate(this.visProp.hasinnerpoints)?this.hasPointSector(t,e):(s.Z.isObject(s.Z.evaluate(this.visProp.precision))?(p=this.board._inputDevice,d=s.Z.evaluate(this.visProp.precision[p])):d=this.board.options.precision.hasPoint,d/=Math.min(this.board.unitX,this.board.unitY),n=new c.Z(i.Z.COORDS_BY_SCREEN,[t,e],this.board),this.transformations.length>0&&(this.updateTransformMatrix(),h=o.Z.inverse(this.transformMat),l=o.Z.matVecMult(h,n.usrCoords),n=new c.Z(i.Z.COORDS_BY_USER,l,this.board)),r=this.center.coords.distance(i.Z.COORDS_BY_USER,n),(a=Math.abs(r-_)<d)&&(a=u.Z.coordsOnArc(this,n)),a)},a.hasPointSector=function(t,e){var s=new c.Z(i.Z.COORDS_BY_SCREEN,[t,e],this.board),r=this.Radius(),o=this.center.coords.distance(i.Z.COORDS_BY_USER,s)<r;return o&&(o=u.Z.coordsOnArc(this,s)),o},a.getTextAnchor=function(){return this.center.coords},a.getLabelAnchor=function(){var t,e,r,o,n,a=u.Z.rad(this.radiuspoint,this.center,this.anglepoint),h=10/this.board.unitX,l=10/this.board.unitY,d=this.point2.coords.usrCoords,p=this.center.coords.usrCoords,_=d[1]-p[1],f=d[2]-p[2],b=s.Z.evaluate(this.visProp.selection),g=this.label?this.label.visProp:this.visProp.label;return("minor"===b&&a>Math.PI||"major"===b&&a<Math.PI)&&(a=-(2*Math.PI-a)),r=(t=new c.Z(i.Z.COORDS_BY_USER,[p[1]+Math.cos(.5*a)*_-Math.sin(.5*a)*f,p[2]+Math.sin(.5*a)*_+Math.cos(.5*a)*f],this.board)).usrCoords[1]-p[1],o=t.usrCoords[2]-p[2],r=r*((n=Math.sqrt(r*r+o*o))+h)/n,o=o*(n+l)/n,e=[p[1]+r,p[2]+o],g.position=u.Z.calcLabelQuadrant(u.Z.rad([1,0],[0,0],e)),new c.Z(i.Z.COORDS_BY_USER,e,this.board)},a.updateQuadraticform=W.prototype.updateQuadraticform,a.updateStdform=W.prototype.updateStdform,a.methodMap=t.Z.deepCopy(a.methodMap,{getRadius:"getRadius",radius:"Radius",center:"center",radiuspoint:"radiuspoint",anglepoint:"anglepoint",Value:"Value"}),a.prepareUpdate().update(),a},t.Z.registerElement("arc",t.Z.createArc),t.Z.createSemicircle=function(t,e,i){var r,o,n,a;if(!1===(a=s.Z.providePoints(t,e,i,"point"))||2!==a.length)throw new Error("JSXGraph: Can't create Semicircle with parent types '"+typeof e[0]+"' and '"+typeof e[1]+"'.\nPossible parent types: [point,point]");return n=s.Z.copyAttributes(i,t.options,"semicircle","center"),(o=t.create("midpoint",a,n)).dump=!1,n=s.Z.copyAttributes(i,t.options,"semicircle"),(r=t.create("arc",[o,a[1],a[0]],n)).elType="semicircle",r.setParents([a[0].id,a[1].id]),r.subs={midpoint:o},r.inherits.push(o),r.midpoint=r.center=o,r},t.Z.registerElement("semicircle",t.Z.createSemicircle),t.Z.createCircumcircleArc=function(t,e,i){var r,o,n,a;if(!1===(a=s.Z.providePoints(t,e,i,"point"))||3!==a.length)throw new Error("JSXGraph: create Circumcircle Arc with parent types '"+typeof e[0]+"' and '"+typeof e[1]+"' and '"+typeof e[2]+"'.\nPossible parent types: [point,point,point]");return n=s.Z.copyAttributes(i,t.options,"circumcirclearc","center"),(o=t.create("circumcenter",a,n)).dump=!1,(n=s.Z.copyAttributes(i,t.options,"circumcirclearc")).usedirection=!0,(r=t.create("arc",[o,a[0],a[2],a[1]],n)).elType="circumcirclearc",r.setParents([a[0].id,a[1].id,a[2].id]),r.subs={center:o},r.inherits.push(o),r.center=o,r},t.Z.registerElement("circumcirclearc",t.Z.createCircumcircleArc),t.Z.createMinorArc=function(e,i,s){return s.selection="minor",t.Z.createArc(e,i,s)},t.Z.registerElement("minorarc",t.Z.createMinorArc),t.Z.createMajorArc=function(e,i,s){return s.selection="major",t.Z.createArc(e,i,s)},t.Z.registerElement("majorarc",t.Z.createMajorArc),t.Z.createSector=function(e,r,n){var a,h,l,p,_,f,b="invalid";if(r[0].elementClass===i.Z.OBJECT_CLASS_LINE&&r[1].elementClass===i.Z.OBJECT_CLASS_LINE&&(s.Z.isArray(r[2])||s.Z.isNumber(r[2]))&&(s.Z.isArray(r[3])||s.Z.isNumber(r[3]))&&(s.Z.isNumber(r[4])||s.Z.isFunction(r[4])||s.Z.isString(r[4])))b="2lines";else{if(!1===(f=s.Z.providePoints(e,r,n,"sector",["center","radiusPoint","anglePoint"])))throw new Error("JSXGraph: Can't create Sector with parent types '"+typeof r[0]+"' and '"+typeof r[1]+"' and '"+typeof r[2]+"'.");b="3points"}if(h=s.Z.copyAttributes(n,e.options,"sector"),(a=e.create("curve",[[0],[0]],h)).type=i.Z.OBJECT_TYPE_SECTOR,a.elType="sector",a.autoRadius=function(){var t=20/a.board.unitX,e=1/0,i=50/a.board.unitX;return s.Z.isPoint(a.center)&&(e=.3333*a.center.Dist(a.point2)),Math.max(t,Math.min(e,i))},"2lines"===b)a.Radius=function(){var t=s.Z.evaluate(r[4]);return"auto"===t?this.autoRadius():t},a.line1=e.select(r[0]),a.line2=e.select(r[1]),a.line1.addChild(a),a.line2.addChild(a),a.setParents(r),a.point1={visProp:{}},a.point2={visProp:{}},a.point3={visProp:{}},p=u.Z.meetLineLine(a.line1.stdform,a.line2.stdform,0,e),s.Z.isArray(r[2])?(2===r[2].length&&(r[2]=[1].concat(r[2])),_=u.Z.projectPointToLine({coords:{usrCoords:r[2]}},a.line1,e),_=d.Z.subtract(_.usrCoords,p.usrCoords),a.direction1=o.Z.innerProduct(_,[0,a.line1.stdform[2],-a.line1.stdform[1]],3)>=0?1:-1):a.direction1=r[2]>=0?1:-1,s.Z.isArray(r[3])?(2===r[3].length&&(r[3]=[1].concat(r[3])),_=u.Z.projectPointToLine({coords:{usrCoords:r[3]}},a.line2,e),_=d.Z.subtract(_.usrCoords,p.usrCoords),a.direction2=o.Z.innerProduct(_,[0,a.line2.stdform[2],-a.line2.stdform[1]],3)>=0?1:-1):a.direction2=r[3]>=0?1:-1,a.updateDataArray=function(){var t,e,s,r,n,h,l=[0,0,0];if(e=this.line1,s=this.line2,l=o.Z.crossProduct(e.stdform,s.stdform),Math.abs(l[0])>o.Z.eps*o.Z.eps&&(l[1]/=l[0],l[2]/=l[0],l[0]/=l[0]),t=this.direction1*this.Radius(),r=d.Z.add(l,[0,t*e.stdform[2],-t*e.stdform[1]]),t=this.direction2*this.Radius(),n=d.Z.add(l,[0,t*s.stdform[2],-t*s.stdform[1]]),this.point2.coords=new c.Z(i.Z.COORDS_BY_USER,r,a.board),this.point1.coords=new c.Z(i.Z.COORDS_BY_USER,l,a.board),this.point3.coords=new c.Z(i.Z.COORDS_BY_USER,n,a.board),Math.abs(r[0])<o.Z.eps||Math.abs(l[0])<o.Z.eps||Math.abs(n[0])<o.Z.eps)return this.dataX=[NaN],void(this.dataY=[NaN]);h=u.Z.bezierArc(r,l,n,!0,1),this.dataX=h[0],this.dataY=h[1],this.bezierDegree=3},a.methodMap=t.Z.deepCopy(a.methodMap,{radius:"Radius",getRadius:"Radius",setRadius:"setRadius"});else if("3points"===b){for(a.point1=f[0],a.point2=f[1],a.point3=f[2],l=0;l<3;l++)s.Z.exists(f[l]._is_new)?(a.addChild(f[l]),delete f[l]._is_new):f[l].addChild(a);a.useDirection=n.usedirection,a.setParents(f),s.Z.exists(f[3])&&(a.point4=f[3],a.point4.addChild(a)),a.methodMap=t.Z.deepCopy(a.methodMap,{arc:"arc",center:"center",radiuspoint:"radiuspoint",anglepoint:"anglepoint",radius:"Radius",getRadius:"Radius",setRadius:"setRadius"}),a.updateDataArray=function(){var t,e,i,r,o,n=this.point2,a=this.point1,h=this.point3,l=1,c=s.Z.evaluate(this.visProp.selection);if(!n.isReal||!a.isReal||!h.isReal)return this.dataX=[NaN],void(this.dataY=[NaN]);o=u.Z.rad(n,a,h),("minor"===c&&o>Math.PI||"major"===c&&o<Math.PI)&&(l=-1),this.useDirection&&s.Z.exists(this.point4)&&(e=this.point2.coords.usrCoords,i=this.point4.coords.usrCoords,r=this.point3.coords.usrCoords,(e[1]-r[1])*(e[2]-i[2])-(e[2]-r[2])*(e[1]-i[1])>=0&&(h=this.point2,n=this.point3)),n=n.coords.usrCoords,a=a.coords.usrCoords,h=h.coords.usrCoords,t=u.Z.bezierArc(n,a,h,!0,l),this.dataX=t[0],this.dataY=t[1],this.bezierDegree=3},a.Radius=function(){return this.point2.Dist(this.point1)},(h=s.Z.copyAttributes(n,e.options,"sector","arc")).withLabel=!1,h.name+="_arc",a.arc=e.create("arc",[a.point1,a.point2,a.point3],h),a.addChild(a.arc)}return a.center=a.point1,a.radiuspoint=a.point2,a.anglepoint=a.point3,a.hasPointCurve=function(t,e){var r,o,n,a,h,l,d=new c.Z(i.Z.COORDS_BY_SCREEN,[t,e],this.board),p=this.Radius(),_=this.center.coords.distance(i.Z.COORDS_BY_USER,d),f=s.Z.evaluate(this.visProp.selection);return s.Z.isObject(s.Z.evaluate(this.visProp.precision))?(h=this.board._inputDevice,a=s.Z.evaluate(this.visProp.precision[h])):a=this.board.options.precision.hasPoint,a/=Math.min(this.board.unitX,this.board.unitY),(l=Math.abs(_-p)<a)&&(r=u.Z.rad(this.point2,this.center,d.usrCoords.slice(1)),o=0,n=u.Z.rad(this.point2,this.center,this.point3),("minor"===f&&n>Math.PI||"major"===f&&n<Math.PI)&&(o=n,n=2*Math.PI),(r<o||r>n)&&(l=!1)),l},a.hasPointSector=function(t,e){var r,o,n,a=new c.Z(i.Z.COORDS_BY_SCREEN,[t,e],this.board),h=this.Radius(),l=this.point1.coords.distance(i.Z.COORDS_BY_USER,a)<h,d=s.Z.evaluate(this.visProp.selection);return l&&(r=u.Z.rad(this.radiuspoint,this.center,a.usrCoords.slice(1)),o=0,n=u.Z.rad(this.radiuspoint,this.center,this.anglepoint),("minor"===d&&n>Math.PI||"major"===d&&n<Math.PI)&&(o=n,n=2*Math.PI),(r<o||r>n)&&(l=!1)),l},a.hasPoint=function(t,e){return s.Z.evaluate(this.visProp.highlightonsector)||s.Z.evaluate(this.visProp.hasinnerpoints)?this.hasPointSector(t,e):this.hasPointCurve(t,e)},a.getTextAnchor=function(){return this.point1.coords},a.getLabelAnchor=function(){var t,e,r,o,n,a=u.Z.rad(this.point2,this.point1,this.point3),h=13/this.board.unitX,l=13/this.board.unitY,d=this.point2.coords.usrCoords,p=this.point1.coords.usrCoords,_=d[1]-p[1],f=d[2]-p[2],b=s.Z.evaluate(this.visProp.selection),g=this.label?this.label.visProp:this.visProp.label;return("minor"===b&&a>Math.PI||"major"===b&&a<Math.PI)&&(a=-(2*Math.PI-a)),r=(t=new c.Z(i.Z.COORDS_BY_USER,[p[1]+Math.cos(.5*a)*_-Math.sin(.5*a)*f,p[2]+Math.sin(.5*a)*_+Math.cos(.5*a)*f],this.board)).usrCoords[1]-p[1],o=t.usrCoords[2]-p[2],r=r*((n=Math.sqrt(r*r+o*o))+h)/n,o=o*(n+l)/n,e=[p[1]+r,p[2]+o],g.position=u.Z.calcLabelQuadrant(u.Z.rad([1,0],[0,0],e)),new c.Z(i.Z.COORDS_BY_USER,e,this.board)},a.setRadius=function(t){a.Radius=function(){var e=s.Z.evaluate(t);return"auto"===e?this.autoRadius():e}},a.getRadius=function(){return t.Z.deprecated("Sector.getRadius()","Sector.Radius()"),this.Radius()},"3points"===b&&(a.setPositionDirectly=function(t,e,i){var s,r=new c.Z(t,e,this.board),o=new c.Z(t,i,this.board);return a.point1.draggable()&&a.point2.draggable()&&a.point3.draggable()?(s=d.Z.subtract(r.usrCoords,o.usrCoords),this.board.create("transform",s.slice(1),{type:"translate"}).applyOnce([a.point1,a.point2,a.point3]),this):this}),a.prepareUpdate().update(),a},t.Z.registerElement("sector",t.Z.createSector),t.Z.createCircumcircleSector=function(t,e,i){var r,o,n,a;if(!1===(a=s.Z.providePoints(t,e,i,"point")))throw new Error("JSXGraph: Can't create circumcircle sector with parent types '"+typeof e[0]+"' and '"+typeof e[1]+"' and '"+typeof e[2]+"'.");return(o=t.create("circumcenter",a.slice(0,3),n)).dump=!1,n=s.Z.copyAttributes(i,t.options,"circumcirclesector"),(r=t.create("sector",[o,a[0],a[2],a[1]],n)).elType="circumcirclesector",r.setParents(a),r.center=o,r.subs={center:o},r},t.Z.registerElement("circumcirclesector",t.Z.createCircumcircleSector),t.Z.createMinorSector=function(e,i,s){return s.selection="minor",t.Z.createSector(e,i,s)},t.Z.registerElement("minorsector",t.Z.createMinorSector),t.Z.createMajorSector=function(e,i,s){return s.selection="major",t.Z.createSector(e,i,s)},t.Z.registerElement("majorsector",t.Z.createMajorSector),t.Z.createAngle=function(t,e,r){var n,a,h,l,d,p,_="invalid";if(e[0].elementClass===i.Z.OBJECT_CLASS_LINE&&e[1].elementClass===i.Z.OBJECT_CLASS_LINE&&(s.Z.isArray(e[2])||s.Z.isNumber(e[2]))&&(s.Z.isArray(e[3])||s.Z.isNumber(e[3])))_="2lines";else{if(!1===(p=s.Z.providePoints(t,e,r,"point")))throw new Error("JSXGraph: Can't create angle with parent types '"+typeof e[0]+"' and '"+typeof e[1]+"' and '"+typeof e[2]+"'.");_="3points"}if(h=s.Z.copyAttributes(r,t.options,"angle"),s.Z.exists(h.name)&&""!==h.name||(h.name=t.generateName({type:i.Z.OBJECT_TYPE_ANGLE})),a=s.Z.exists(h.radius)?h.radius:0,"2lines"===_?(e.push(a),(n=t.create("sector",e,h)).updateDataArraySector=n.updateDataArray,n.setAngle=function(t){},n.free=function(t){}):((n=t.create("sector",[p[1],p[0],p[2]],h)).arc.visProp.priv=!0,n.point=n.point2=n.radiuspoint=p[0],n.pointsquare=n.point3=n.anglepoint=p[2],n.Radius=function(){var t=s.Z.evaluate(a);return"auto"===t?n.autoRadius():t},n.updateDataArraySector=function(){var t,e,i=this.point2,r=this.point1,o=this.point3,n=this.Radius(),a=r.Dist(i),h=1,l=s.Z.evaluate(this.visProp.selection);e=u.Z.rad(i,r,o),("minor"===l&&e>Math.PI||"major"===l&&e<Math.PI)&&(h=-1),i=i.coords.usrCoords,r=r.coords.usrCoords,o=o.coords.usrCoords,i=[1,r[1]+(i[1]-r[1])*n/a,r[2]+(i[2]-r[2])*n/a],o=[1,r[1]+(o[1]-r[1])*n/a,r[2]+(o[2]-r[2])*n/a],t=u.Z.bezierArc(i,r,o,!0,h),this.dataX=t[0],this.dataY=t[1],this.bezierDegree=3},n.setAngle=function(t){var e,i,r,n=this.anglepoint,a=this.radiuspoint;return n.draggable()&&(e=this.board.create("transform",[t,this.center],{type:"rotate"}),n.addTransform(a,e),e.update(),n.moveTo(o.Z.matVecMult(e.matrix,a.coords.usrCoords)),r=s.Z.isFunction(t)?function(){return 2*Math.PI-t()}:function(){return 2*Math.PI-t},i=this.board.create("transform",[r,this.center],{type:"rotate"}),n.coords.on("update",(function(){i.update(),a.moveTo(o.Z.matVecMult(i.matrix,n.coords.usrCoords))})),n.setParents(a)),this},n.free=function(){var t=this.anglepoint;return t.transformations.length>0&&(t.transformations.pop(),t.isDraggable=!0,t.parents=[],t.coords.off("update")),this},n.setParents(p)),s.Z.exists(n.visProp.text)&&n.label.setText(s.Z.evaluate(n.visProp.text)),n.elType="angle",n.type=i.Z.OBJECT_TYPE_ANGLE,n.subs={},n.updateDataArraySquare=function(){var t,e,i,s,r,n,a,h,l=this.Radius();"2lines"===_&&this.updateDataArraySector(),t=this.point2,e=this.point1,i=this.point3,t=t.coords.usrCoords,e=e.coords.usrCoords,i=i.coords.usrCoords,s=u.Z.distance(t,e,3),r=u.Z.distance(i,e,3),t=[1,e[1]+(t[1]-e[1])*l/s,e[2]+(t[2]-e[2])*l/s],i=[1,e[1]+(i[1]-e[1])*l/r,e[2]+(i[2]-e[2])*l/r],n=o.Z.crossProduct(i,e),a=[-t[1]*n[1]-t[2]*n[2],t[0]*n[1],t[0]*n[2]],n=o.Z.crossProduct(t,e),h=[-i[1]*n[1]-i[2]*n[2],i[0]*n[1],i[0]*n[2]],(n=o.Z.crossProduct(a,h))[1]/=n[0],n[2]/=n[0],this.dataX=[e[1],t[1],n[1],i[1],e[1]],this.dataY=[e[2],t[2],n[2],i[2],e[2]],this.bezierDegree=1},n.updateDataArrayNone=function(){this.dataX=[NaN],this.dataY=[NaN],this.bezierDegree=1},n.updateDataArray=function(){var t=s.Z.evaluate(this.visProp.type),e=u.Z.trueAngle(this.point2,this.point1,this.point3),i=s.Z.evaluate(this.visProp.selection);("minor"===i&&e>180||"major"===i&&e<180)&&(e=360-e),Math.abs(e-90)<s.Z.evaluate(this.visProp.orthosensitivity)+o.Z.eps&&(t=s.Z.evaluate(this.visProp.orthotype)),"none"===t?this.updateDataArrayNone():"square"===t?this.updateDataArraySquare():"sector"===t?this.updateDataArraySector():"sectordot"===t&&(this.updateDataArraySector(),this.dot.visProp.visible||this.dot.setAttribute({visible:!0})),(!this.visProp.visible||"sectordot"!==t&&this.dot.visProp.visible)&&this.dot.setAttribute({visible:!1})},l=s.Z.copyAttributes(r,t.options,"angle","dot"),n.dot=t.create("point",[function(){var t,e,i,r,a,h,l,c,d;return s.Z.exists(n.dot)&&!n.dot.visProp.visible?[0,0]:(t=n.point2.coords.usrCoords,e=n.point1.coords.usrCoords,i=n.Radius(),r=u.Z.distance(t,e,3),a=u.Z.rad(n.point2,n.point1,n.point3),("minor"===(d=s.Z.evaluate(n.visProp.selection))&&a>Math.PI||"major"===d&&a<Math.PI)&&(a=-(2*Math.PI-a)),a*=.5,h=Math.cos(a),l=Math.sin(a),t=[1,e[1]+(t[1]-e[1])*i/r,e[2]+(t[2]-e[2])*i/r],c=[[1,0,0],[e[1]-.5*e[1]*h+.5*e[2]*l,.5*h,.5*-l],[e[2]-.5*e[1]*l-.5*e[2]*h,.5*l,.5*h]],o.Z.matVecMult(c,t))}],l),n.dot.dump=!1,n.subs.dot=n.dot,"2lines"===_)for(d=0;d<2;d++)t.select(e[d]).addChild(n.dot);else for(d=0;d<3;d++)t.select(p[d]).addChild(n.dot);return n.getLabelAnchor=function(){var t,e,r,a,h,l,d,p,_,f=12,b=s.Z.evaluate(n.visProp.selection),g=this.label?this.label.visProp:this.visProp.label;return s.Z.exists(this.label.visProp.fontSize)&&(f=s.Z.evaluate(this.label.visProp.fontSize)),f/=this.board.unitX,e=n.point2.coords.usrCoords,r=n.point1.coords.usrCoords,a=n.Radius(),h=u.Z.distance(e,r,3),l=u.Z.rad(n.point2,n.point1,n.point3),("minor"===b&&l>Math.PI||"major"===b&&l<Math.PI)&&(l=-(2*Math.PI-l)),l*=.5,d=Math.cos(l),p=Math.sin(l),e=[1,r[1]+(e[1]-r[1])*a/h,r[2]+(e[2]-r[2])*a/h],_=[[1,0,0],[r[1]-.5*r[1]*d+.5*r[2]*p,.5*d,.5*-p],[r[2]-.5*r[1]*p-.5*r[2]*d,.5*p,.5*d]],(t=o.Z.matVecMult(_,e))[1]/=t[0],t[2]/=t[0],t[0]/=t[0],h=u.Z.distance(t,r,3),t=[t[0],r[1]+(t[1]-r[1])*(a+f)/h,r[2]+(t[2]-r[2])*(a+f)/h],g.position=u.Z.calcLabelQuadrant(u.Z.rad([1,0],[0,0],t)),new c.Z(i.Z.COORDS_BY_USER,t,this.board)},n.Value=function(){return u.Z.rad(this.point2,this.point1,this.point3)},n.methodMap=s.Z.deepCopy(n.methodMap,{Value:"Value",setAngle:"setAngle",free:"free"}),n},t.Z.registerElement("angle",t.Z.createAngle),t.Z.createNonreflexAngle=function(e,i,s){var r;return s.selection="minor",(r=t.Z.createAngle(e,i,s)).Value=function(){var t=u.Z.rad(this.point2,this.point1,this.point3);return t<Math.PI?t:2*Math.PI-t},r},t.Z.registerElement("nonreflexangle",t.Z.createNonreflexAngle),t.Z.createReflexAngle=function(e,i,s){var r;return s.selection="major",(r=t.Z.createAngle(e,i,s)).Value=function(){var t=u.Z.rad(this.point2,this.point1,this.point3);return t>=Math.PI?t:2*Math.PI-t},r},t.Z.registerElement("reflexangle",t.Z.createReflexAngle),t.Z.createOrthogonalProjection=function(t,e,r){var o,n,a,h;if(e[0]=t.select(e[0]),e[1]=t.select(e[1]),s.Z.isPointType(t,e[0])&&e[1].elementClass===i.Z.OBJECT_CLASS_LINE)n=s.Z.providePoints(t,[e[0]],r,"point")[0],o=e[1];else{if(!s.Z.isPointType(t,e[1])||e[0].elementClass!==i.Z.OBJECT_CLASS_LINE)throw new Error("JSXGraph: Can't create perpendicular point with parent types '"+typeof e[0]+"' and '"+typeof e[1]+"'.\nPossible parent types: [point,line]");n=s.Z.providePoints(t,[e[1]],r,"point")[0],o=e[0]}return h=s.Z.copyAttributes(r,t.options,"orthogonalprojection"),a=t.create("point",[function(){return u.Z.projectPointToLine(n,o,t)}],h),s.Z.exists(n._is_new)?(a.addChild(n),delete n._is_new):n.addChild(a),o.addChild(a),a.elType="orthogonalprojection",a.setParents([n.id,a.id]),a.update(),a.generatePolynomial=function(){var t=o.point1.symbolic.x,e=o.point1.symbolic.y,i=o.point2.symbolic.x,s=o.point2.symbolic.y,r=n.symbolic.x,h=n.symbolic.y,l=a.symbolic.x,c=a.symbolic.y;return["("+e+")*("+l+")-("+e+")*("+i+")+("+c+")*("+i+")-("+t+")*("+c+")+("+t+")*("+s+")-("+l+")*("+s+")","("+h+")*("+e+")-("+h+")*("+s+")-("+c+")*("+e+")+("+c+")*("+s+")+("+r+")*("+t+")-("+r+")*("+i+")-("+l+")*("+t+")+("+l+")*("+i+")"]},a},t.Z.createPerpendicular=function(e,r,o){var n,a,h,l;if(r[0]=e.select(r[0]),r[1]=e.select(r[1]),s.Z.isPointType(e,r[0])&&r[1].elementClass===i.Z.OBJECT_CLASS_LINE)a=r[1],n=s.Z.providePoints(e,[r[0]],o,"point")[0];else{if(!s.Z.isPointType(e,r[1])||r[0].elementClass!==i.Z.OBJECT_CLASS_LINE)throw new Error("JSXGraph: Can't create perpendicular with parent types '"+typeof r[0]+"' and '"+typeof r[1]+"'.\nPossible parent types: [line,point]");a=r[0],n=s.Z.providePoints(e,[r[1]],o,"point")[0]}return l=s.Z.copyAttributes(o,e.options,"perpendicular"),(h=t.Z.createLine(e,[function(){return a.stdform[2]*n.X()-a.stdform[1]*n.Y()},function(){return-a.stdform[2]*n.Z()},function(){return a.stdform[1]*n.Z()}],l)).elType="perpendicular",h.setParents([a.id,n.id]),s.Z.exists(n._is_new)?(h.addChild(n),delete n._is_new):n.addChild(h),a.addChild(h),h},t.Z.createPerpendicularPoint=function(t,e,r){var o,n,a;if(e[0]=t.select(e[0]),e[1]=t.select(e[1]),s.Z.isPointType(t,e[0])&&e[1].elementClass===i.Z.OBJECT_CLASS_LINE)n=s.Z.providePoints(t,[e[0]],r,"point")[0],o=e[1];else{if(!s.Z.isPointType(t,e[1])||e[0].elementClass!==i.Z.OBJECT_CLASS_LINE)throw new Error("JSXGraph: Can't create perpendicular point with parent types '"+typeof e[0]+"' and '"+typeof e[1]+"'.\nPossible parent types: [point,line]");n=s.Z.providePoints(t,[e[1]],r,"point")[0],o=e[0]}return a=t.create("point",[function(){return u.Z.perpendicular(o,n,t)[0]}],r),s.Z.exists(n._is_new)?(a.addChild(n),delete n._is_new):n.addChild(a),o.addChild(a),a.elType="perpendicularpoint",a.setParents([n.id,o.id]),a.update(),a.generatePolynomial=function(){var t=o.point1.symbolic.x,e=o.point1.symbolic.y,i=o.point2.symbolic.x,s=o.point2.symbolic.y,r=n.symbolic.x,h=n.symbolic.y,l=a.symbolic.x,c=a.symbolic.y;return["("+e+")*("+l+")-("+e+")*("+i+")+("+c+")*("+i+")-("+t+")*("+c+")+("+t+")*("+s+")-("+l+")*("+s+")","("+h+")*("+e+")-("+h+")*("+s+")-("+c+")*("+e+")+("+c+")*("+s+")+("+r+")*("+t+")-("+r+")*("+i+")-("+l+")*("+t+")+("+l+")*("+i+")"]},a},t.Z.createPerpendicularSegment=function(e,r,o){var n,a,h,l,c;if(r[0]=e.select(r[0]),r[1]=e.select(r[1]),s.Z.isPointType(e,r[0])&&r[1].elementClass===i.Z.OBJECT_CLASS_LINE)a=r[1],n=s.Z.providePoints(e,[r[0]],o,"point")[0];else{if(!s.Z.isPointType(e,r[1])||r[0].elementClass!==i.Z.OBJECT_CLASS_LINE)throw new Error("JSXGraph: Can't create perpendicular with parent types '"+typeof r[0]+"' and '"+typeof r[1]+"'.\nPossible parent types: [line,point]");a=r[0],n=s.Z.providePoints(e,[r[1]],o,"point")[0]}return c=s.Z.copyAttributes(o,e.options,"perpendicularsegment","point"),(l=t.Z.createPerpendicularPoint(e,[a,n],c)).dump=!1,s.Z.exists(o.layer)||(o.layer=e.options.layer.line),c=s.Z.copyAttributes(o,e.options,"perpendicularsegment"),(h=t.Z.createLine(e,[function(){return u.Z.perpendicular(a,n,e)[1]?[l,n]:[n,l]}],c)).point=l,s.Z.exists(n._is_new)?(h.addChild(n),delete n._is_new):n.addChild(h),a.addChild(h),h.elType="perpendicularsegment",h.setParents([n.id,a.id]),h.subs={point:l},h.inherits.push(l),h},t.Z.createMidpoint=function(t,e,r){var n,a,h,l,c;for(l=0;l<e.length;++l)e[l]=t.select(e[l]);if(2===e.length&&s.Z.isPointType(t,e[0])&&s.Z.isPointType(t,e[1]))e=s.Z.providePoints(t,e,r,"point"),n=e[0],a=e[1];else{if(1!==e.length||e[0].elementClass!==i.Z.OBJECT_CLASS_LINE)throw new Error("JSXGraph: Can't create midpoint.\nPossible parent types: [point,point], [line]");n=e[0].point1,a=e[0].point2}return c=s.Z.copyAttributes(r,t.options,"midpoint"),h=t.create("point",[function(){var t=n.coords.usrCoords[1]+a.coords.usrCoords[1];return isNaN(t)||Math.abs(n.coords.usrCoords[0])<o.Z.eps||Math.abs(a.coords.usrCoords[0])<o.Z.eps?NaN:.5*t},function(){var t=n.coords.usrCoords[2]+a.coords.usrCoords[2];return isNaN(t)||Math.abs(n.coords.usrCoords[0])<o.Z.eps||Math.abs(a.coords.usrCoords[0])<o.Z.eps?NaN:.5*t}],c),s.Z.exists(n._is_new)?(h.addChild(n),delete n._is_new):n.addChild(h),s.Z.exists(a._is_new)?(h.addChild(a),delete a._is_new):a.addChild(h),h.elType="midpoint",h.setParents([n.id,a.id]),h.prepareUpdate().update(),h.generatePolynomial=function(){var t=n.symbolic.x,e=n.symbolic.y,i=a.symbolic.x,s=a.symbolic.y,r=h.symbolic.x,o=h.symbolic.y;return["("+e+")*("+r+")-("+e+")*("+i+")+("+o+")*("+i+")-("+t+")*("+o+")+("+t+")*("+s+")-("+r+")*("+s+")","("+t+")^2 - 2*("+t+")*("+r+")+("+e+")^2-2*("+e+")*("+o+")-("+i+")^2+2*("+i+")*("+r+")-("+s+")^2+2*("+s+")*("+o+")"]},h},t.Z.createParallelPoint=function(t,e,r){var o,n,a,h,l;for(l=0;l<e.length;++l)e[l]=t.select(e[l]);if(3===e.length&&s.Z.isPointType(t,e[0])&&s.Z.isPointType(t,e[1])&&s.Z.isPointType(t,e[2]))e=s.Z.providePoints(t,e,r,"point"),o=e[0],n=e[1],a=e[2];else if(s.Z.isPointType(t,e[0])&&e[1].elementClass===i.Z.OBJECT_CLASS_LINE)a=s.Z.providePoints(t,[e[0]],r,"point")[0],o=e[1].point1,n=e[1].point2;else{if(!s.Z.isPointType(t,e[1])||e[0].elementClass!==i.Z.OBJECT_CLASS_LINE)throw new Error("JSXGraph: Can't create parallel point with parent types '"+typeof e[0]+"', '"+typeof e[1]+"' and '"+typeof e[2]+"'.\nPossible parent types: [line,point], [point,point,point]");a=s.Z.providePoints(t,[e[1]],r,"point")[0],o=e[0].point1,n=e[0].point2}return h=t.create("point",[function(){return a.coords.usrCoords[1]+n.coords.usrCoords[1]-o.coords.usrCoords[1]},function(){return a.coords.usrCoords[2]+n.coords.usrCoords[2]-o.coords.usrCoords[2]}],r),s.Z.exists(o._is_new)?(h.addChild(o),delete o._is_new):o.addChild(h),s.Z.exists(n._is_new)?(h.addChild(n),delete n._is_new):n.addChild(h),s.Z.exists(a._is_new)?(h.addChild(a),delete a._is_new):a.addChild(h),h.elType="parallelpoint",h.setParents([o.id,n.id,a.id]),h.prepareUpdate().update(),h.generatePolynomial=function(){var t=o.symbolic.x,e=o.symbolic.y,i=n.symbolic.x,s=n.symbolic.y,r=a.symbolic.x,l=a.symbolic.y,c=h.symbolic.x,d=h.symbolic.y;return["("+s+")*("+c+")-("+s+")*("+r+")-("+e+")*("+c+")+("+e+")*("+r+")-("+d+")*("+i+")+("+d+")*("+t+")+("+l+")*("+i+")-("+l+")*("+t+")","("+d+")*("+t+")-("+d+")*("+r+")-("+s+")*("+t+")+("+s+")*("+r+")-("+c+")*("+e+")+("+c+")*("+l+")+("+i+")*("+e+")-("+i+")*("+l+")"]},h},t.Z.createParallel=function(t,e,i){var r,n,a,h,l,c,d=1;for(l=0;l<e.length;++l)e[l]=t.select(e[l]);return r=null,3===e.length?(r=(e=s.Z.providePoints(t,e,i,"point"))[2],d=0):s.Z.isPointType(t,e[0])?(r=s.Z.providePoints(t,[e[0]],i,"point")[0],h=function(){return e[1].stdform}):s.Z.isPointType(t,e[1])&&(r=s.Z.providePoints(t,[e[1]],i,"point")[0],h=function(){return e[0].stdform}),s.Z.exists(i.layer)||(i.layer=t.options.layer.line),c=s.Z.copyAttributes(i,t.options,"parallel","point"),(n=1===d?t.create("point",[function(){return o.Z.crossProduct([1,0,0],h())}],c):t.create("parallelpoint",e,c)).isDraggable=!0,c=s.Z.copyAttributes(i,t.options,"parallel"),(a=t.create("line",[r,n],c)).elType="parallel",a.subs={point:n},a.inherits.push(n),a.setParents([e[0].id,e[1].id]),3===e.length&&a.addParents(e[2].id),a.point=n,a},t.Z.createArrowParallel=function(e,i,s){var r;try{return s.firstArrow=!1,s.lastArrow=!0,(r=t.Z.createParallel(e,i,s).setAttribute({straightFirst:!1,straightLast:!1})).elType="arrowparallel",r}catch(t){throw new Error("JSXGraph: Can't create arrowparallel with parent types '"+typeof i[0]+"' and '"+typeof i[1]+"'.\nPossible parent types: [line,point], [point,point,point]")}},t.Z.createNormal=function(t,e,r){var n,a,h,c,d,u,p,_,f;for(c=0;c<e.length;++c)e[c]=t.select(e[c]);if(1===e.length)n=e[0],a=n.slideObject;else{if(2!==e.length)throw new Error("JSXGraph: Can't create normal with parent types '"+typeof e[0]+"' and '"+typeof e[1]+"'.\nPossible parent types: [point,line], [point,circle], [glider]");if(s.Z.isPointType(t,e[0]))n=s.Z.providePoints(t,[e[0]],r,"point")[0],a=e[1];else{if(!s.Z.isPointType(t,e[1]))throw new Error("JSXGraph: Can't create normal with parent types '"+typeof e[0]+"' and '"+typeof e[1]+"'.\nPossible parent types: [point,line], [point,circle], [glider]");a=e[0],n=s.Z.providePoints(t,[e[1]],r,"point")[0]}}if(p=s.Z.copyAttributes(r,t.options,"normal"),a.elementClass===i.Z.OBJECT_CLASS_LINE)f=s.Z.copyAttributes(r,t.options,"normal","point"),_=t.create("point",[function(){var t=o.Z.crossProduct([1,0,0],a.stdform);return[t[0],-t[2],t[1]]}],f),_.isDraggable=!0,(h=t.create("line",[n,_],p)).point=_,h.subs={point:_},h.inherits.push(_);else if(a.elementClass===i.Z.OBJECT_CLASS_CIRCLE)h=t.create("line",[a.midpoint,n],p);else if(a.elementClass===i.Z.OBJECT_CLASS_CURVE)"plot"!==s.Z.evaluate(a.visProp.curvetype)?(d=a.X,u=a.Y,h=t.create("line",[function(){return-n.X()*l.Z.D(d)(n.position)-n.Y()*l.Z.D(u)(n.position)},function(){return l.Z.D(d)(n.position)},function(){return l.Z.D(u)(n.position)}],p)):h=t.create("line",[function(){var t,e,i,s,r,o,h,l,c,d,u=Math.floor(n.position),p=n.position-u;if(1===a.bezierdegree)u===a.numberPoints-1&&(u-=1,p=1);else{if(3!==a.bezierDegree)return 0;u=3*Math.floor(n.position*(a.numberPoints-1)/3),i=(n.position*(a.numberPoints-1)-u)/3,u>=a.numberPoints-1&&(u=a.numberPoints-4,i=1)}return u<0?1:1===a.bezierDegree?(a.Y(u)+p*(a.Y(u+1)-a.Y(u)))*(a.Y(u)-a.Y(u+1))-(a.X(u)+p*(a.X(u+1)-a.X(u)))*(a.X(u+1)-a.X(u)):(s=a.points[u].usrCoords,r=a.points[u+1].usrCoords,o=a.points[u+2].usrCoords,h=a.points[u+3].usrCoords,l=(1-i)*(1-i)*(r[1]-s[1])+2*(1-i)*i*(o[1]-r[1])+i*i*(h[1]-o[1]),c=(1-i)*(1-i)*(r[2]-s[2])+2*(1-i)*i*(o[2]-r[2])+i*i*(h[2]-o[2]),l/=d=Math.sqrt(l*l+c*c),c/=d,e=[1,(t=n.coords.usrCoords)[1]-c,t[2]+l],t[2]*e[1]-t[1]*e[2])},function(){var t,e,i,s,r,o,h,l,c,d=Math.floor(n.position);if(1===a.bezierdegree)d===a.numberPoints-1&&(d-=1);else{if(3!==a.bezierDegree)return 0;d=3*Math.floor(n.position*(a.numberPoints-1)/3),e=(n.position*(a.numberPoints-1)-d)/3,d>=a.numberPoints-1&&(d=a.numberPoints-4,e=1)}return d<0?0:1===a.bezierDegree?a.X(d+1)-a.X(d):(i=a.points[d].usrCoords,s=a.points[d+1].usrCoords,r=a.points[d+2].usrCoords,o=a.points[d+3].usrCoords,h=(1-e)*(1-e)*(s[1]-i[1])+2*(1-e)*e*(r[1]-s[1])+e*e*(o[1]-r[1]),l=(1-e)*(1-e)*(s[2]-i[2])+2*(1-e)*e*(r[2]-s[2])+e*e*(o[2]-r[2]),h/=c=Math.sqrt(h*h+l*l),l/=c,[1,(t=n.coords.usrCoords)[1]-l,t[2]+h][2]-t[2])},function(){var t,e,i,s,r,o,h,l,c,d,u=Math.floor(n.position);if(1===a.bezierdegree)u===a.numberPoints-1&&(u-=1);else{if(3!==a.bezierDegree)return 0;u=3*Math.floor(n.position*(a.numberPoints-1)/3),i=(n.position*(a.numberPoints-1)-u)/3,u>=a.numberPoints-1&&(u=a.numberPoints-4,i=1)}return u<0?0:1===a.bezierDegree?a.Y(u+1)-a.Y(u):(s=a.points[u].usrCoords,r=a.points[u+1].usrCoords,o=a.points[u+2].usrCoords,h=a.points[u+3].usrCoords,l=(1-i)*(1-i)*(r[1]-s[1])+2*(1-i)*i*(o[1]-r[1])+i*i*(h[1]-o[1]),c=(1-i)*(1-i)*(r[2]-s[2])+2*(1-i)*i*(o[2]-r[2])+i*i*(h[2]-o[2]),l/=d=Math.sqrt(l*l+c*c),c/=d,e=[1,(t=n.coords.usrCoords)[1]-c,t[2]+l],t[1]-e[1])}],p);else{if(a.type!==i.Z.OBJECT_TYPE_TURTLE)throw new Error("JSXGraph: Can't create normal with parent types '"+typeof e[0]+"' and '"+typeof e[1]+"'.\nPossible parent types: [point,line], [point,circle], [glider]");h=t.create("line",[function(){var t,e,s=Math.floor(n.position),r=n.position-s;for(e=0;e<a.objects.length;e++)if((t=a.objects[e]).type===i.Z.OBJECT_TYPE_CURVE){if(s<t.numberPoints)break;s-=t.numberPoints}return s===t.numberPoints-1&&(s-=1,r=1),s<0?1:(t.Y(s)+r*(t.Y(s+1)-t.Y(s)))*(t.Y(s)-t.Y(s+1))-(t.X(s)+r*(t.X(s+1)-t.X(s)))*(t.X(s+1)-t.X(s))},function(){var t,e,s=Math.floor(n.position);for(e=0;e<a.objects.length;e++)if((t=a.objects[e]).type===i.Z.OBJECT_TYPE_CURVE){if(s<t.numberPoints)break;s-=t.numberPoints}return s===t.numberPoints-1&&(s-=1),s<0?0:t.X(s+1)-t.X(s)},function(){var t,e,s=Math.floor(n.position);for(e=0;e<a.objects.length;e++)if((t=a.objects[e]).type===i.Z.OBJECT_TYPE_CURVE){if(s<t.numberPoints)break;s-=t.numberPoints}return s===t.numberPoints-1&&(s-=1),s<0?0:t.Y(s+1)-t.Y(s)}],p)}return h.elType="normal",h.setParents(e),s.Z.exists(n._is_new)?(h.addChild(n),delete n._is_new):n.addChild(h),a.addChild(h),h},t.Z.createBisector=function(e,i,r){var o,n,a,h;if(i=s.Z.providePoints(e,i,r,"point"),s.Z.isPoint(i[0])&&s.Z.isPoint(i[1])&&s.Z.isPoint(i[2])){for((h=s.Z.copyAttributes(r,e.options,"bisector","point")).snapToGrid=!1,(o=e.create("point",[function(){return u.Z.angleBisector(i[0],i[1],i[2],e)}],h)).dump=!1,a=0;a<3;a++)s.Z.exists(i[a]._is_new)?(o.addChild(i[a]),delete i[a]._is_new):i[a].addChild(o);return s.Z.exists(r.layer)||(r.layer=e.options.layer.line),h=s.Z.copyAttributes(r,e.options,"bisector"),(n=t.Z.createLine(e,[i[1],o],h)).point=o,n.elType="bisector",n.setParents(i),n.subs={point:o},n.inherits.push(o),n}throw new Error("JSXGraph: Can't create angle bisector with parent types '"+typeof i[0]+"' and '"+typeof i[1]+"'.\nPossible parent types: [point,point,point]")},t.Z.createAngularBisectorsOfTwoLines=function(t,e,r){var o,n,a,h,l=t.select(e[0]),c=t.select(e[1]);if(l.elementClass!==i.Z.OBJECT_CLASS_LINE||c.elementClass!==i.Z.OBJECT_CLASS_LINE)throw new Error("JSXGraph: Can't create angle bisectors of two lines with parent types '"+typeof e[0]+"' and '"+typeof e[1]+"'.\nPossible parent types: [line,line]");return s.Z.exists(r.layer)||(r.layer=t.options.layer.line),a=s.Z.copyAttributes(r,t.options,"bisectorlines","line1"),o=t.create("line",[function(){var t=Math.sqrt(l.stdform[1]*l.stdform[1]+l.stdform[2]*l.stdform[2]),e=Math.sqrt(c.stdform[1]*c.stdform[1]+c.stdform[2]*c.stdform[2]);return l.stdform[0]/t-c.stdform[0]/e},function(){var t=Math.sqrt(l.stdform[1]*l.stdform[1]+l.stdform[2]*l.stdform[2]),e=Math.sqrt(c.stdform[1]*c.stdform[1]+c.stdform[2]*c.stdform[2]);return l.stdform[1]/t-c.stdform[1]/e},function(){var t=Math.sqrt(l.stdform[1]*l.stdform[1]+l.stdform[2]*l.stdform[2]),e=Math.sqrt(c.stdform[1]*c.stdform[1]+c.stdform[2]*c.stdform[2]);return l.stdform[2]/t-c.stdform[2]/e}],a),s.Z.exists(r.layer)||(r.layer=t.options.layer.line),a=s.Z.copyAttributes(r,t.options,"bisectorlines","line2"),n=t.create("line",[function(){var t=Math.sqrt(l.stdform[1]*l.stdform[1]+l.stdform[2]*l.stdform[2]),e=Math.sqrt(c.stdform[1]*c.stdform[1]+c.stdform[2]*c.stdform[2]);return l.stdform[0]/t+c.stdform[0]/e},function(){var t=Math.sqrt(l.stdform[1]*l.stdform[1]+l.stdform[2]*l.stdform[2]),e=Math.sqrt(c.stdform[1]*c.stdform[1]+c.stdform[2]*c.stdform[2]);return l.stdform[1]/t+c.stdform[1]/e},function(){var t=Math.sqrt(l.stdform[1]*l.stdform[1]+l.stdform[2]*l.stdform[2]),e=Math.sqrt(c.stdform[1]*c.stdform[1]+c.stdform[2]*c.stdform[2]);return l.stdform[2]/t+c.stdform[2]/e}],a),h=new B({line1:o,line2:n}),o.dump=!1,n.dump=!1,h.elType="bisectorlines",h.setParents([l.id,c.id]),h.subs={line1:o,line2:n},h},t.Z.createCircumcenter=function(e,i,r){var o,n,a,h,l;if(i=s.Z.providePoints(e,i,r,"point"),s.Z.isPoint(i[0])&&s.Z.isPoint(i[1])&&s.Z.isPoint(i[2])){for(a=i[0],h=i[1],l=i[2],o=t.Z.createPoint(e,[function(){return u.Z.circumcenter(a,h,l,e)}],r),n=0;n<3;n++)s.Z.exists(i[n]._is_new)?(o.addChild(i[n]),delete i[n]._is_new):i[n].addChild(o);return o.elType="circumcenter",o.setParents(i),o.generatePolynomial=function(){var t=a.symbolic.x,e=a.symbolic.y,i=h.symbolic.x,s=h.symbolic.y,r=l.symbolic.x,n=l.symbolic.y,c=o.symbolic.x,d=o.symbolic.y;return[["((",c,")-(",t,"))^2+((",d,")-(",e,"))^2-((",c,")-(",i,"))^2-((",d,")-(",s,"))^2"].join(""),["((",c,")-(",t,"))^2+((",d,")-(",e,"))^2-((",c,")-(",r,"))^2-((",d,")-(",n,"))^2"].join("")]},o}throw new Error("JSXGraph: Can't create circumcircle midpoint with parent types '"+typeof i[0]+"', '"+typeof i[1]+"' and '"+typeof i[2]+"'.\nPossible parent types: [point,point,point]")},t.Z.createIncenter=function(t,e,r){var o,n,a,h,l;if(!((e=s.Z.providePoints(t,e,r,"point")).length>=3&&s.Z.isPoint(e[0])&&s.Z.isPoint(e[1])&&s.Z.isPoint(e[2])))throw new Error("JSXGraph: Can't create incenter with parent types '"+typeof e[0]+"', '"+typeof e[1]+"' and '"+typeof e[2]+"'.\nPossible parent types: [point,point,point]");for(n=e[0],a=e[1],h=e[2],o=t.create("point",[function(){var e,s,r;return e=Math.sqrt((a.X()-h.X())*(a.X()-h.X())+(a.Y()-h.Y())*(a.Y()-h.Y())),s=Math.sqrt((n.X()-h.X())*(n.X()-h.X())+(n.Y()-h.Y())*(n.Y()-h.Y())),r=Math.sqrt((a.X()-n.X())*(a.X()-n.X())+(a.Y()-n.Y())*(a.Y()-n.Y())),new c.Z(i.Z.COORDS_BY_USER,[(e*n.X()+s*a.X()+r*h.X())/(e+s+r),(e*n.Y()+s*a.Y()+r*h.Y())/(e+s+r)],t)}],r),l=0;l<3;l++)s.Z.exists(e[l]._is_new)?(o.addChild(e[l]),delete e[l]._is_new):e[l].addChild(o);return o.elType="incenter",o.setParents(e),o},t.Z.createCircumcircle=function(e,i,r){var o,n,a,h;if(!1===(i=s.Z.providePoints(e,i,r,"point")))throw new Error("JSXGraph: Can't create circumcircle with parent types '"+typeof i[0]+"', '"+typeof i[1]+"' and '"+typeof i[2]+"'.\nPossible parent types: [point,point,point]");try{for(a=s.Z.copyAttributes(r,e.options,"circumcircle","center"),(o=t.Z.createCircumcenter(e,i,a)).dump=!1,s.Z.exists(r.layer)||(r.layer=e.options.layer.circle),a=s.Z.copyAttributes(r,e.options,"circumcircle"),(n=t.Z.createCircle(e,[o,i[0]],a)).elType="circumcircle",n.setParents(i),n.subs={center:o},n.inherits.push(n),h=0;h<3;h++)s.Z.exists(i[h]._is_new)?(n.addChild(i[h]),delete i[h]._is_new):i[h].addChild(n)}catch(t){throw new Error("JSXGraph: Can't create circumcircle with parent types '"+typeof i[0]+"', '"+typeof i[1]+"' and '"+typeof i[2]+"'.\nPossible parent types: [point,point,point]")}return n},t.Z.createIncircle=function(e,i,r){var o,n,a,h;if(!1===(i=s.Z.providePoints(e,i,r,"point")))throw new Error("JSXGraph: Can't create circumcircle with parent types '"+typeof i[0]+"', '"+typeof i[1]+"' and '"+typeof i[2]+"'.\nPossible parent types: [point,point,point]");try{for(h=s.Z.copyAttributes(r,e.options,"incircle","center"),(n=t.Z.createIncenter(e,i,h)).dump=!1,s.Z.exists(r.layer)||(r.layer=e.options.layer.circle),h=s.Z.copyAttributes(r,e.options,"incircle"),(a=t.Z.createCircle(e,[n,function(){var t=Math.sqrt((i[1].X()-i[2].X())*(i[1].X()-i[2].X())+(i[1].Y()-i[2].Y())*(i[1].Y()-i[2].Y())),e=Math.sqrt((i[0].X()-i[2].X())*(i[0].X()-i[2].X())+(i[0].Y()-i[2].Y())*(i[0].Y()-i[2].Y())),s=Math.sqrt((i[1].X()-i[0].X())*(i[1].X()-i[0].X())+(i[1].Y()-i[0].Y())*(i[1].Y()-i[0].Y())),r=(t+e+s)/2;return Math.sqrt((r-t)*(r-e)*(r-s)/r)}],h)).elType="incircle",a.setParents(i),o=0;o<3;o++)s.Z.exists(i[o]._is_new)?(a.addChild(i[o]),delete i[o]._is_new):i[o].addChild(a);a.center=n,a.subs={center:a.center},a.inherits.push(n)}catch(t){throw new Error("JSXGraph: Can't create circumcircle with parent types '"+typeof i[0]+"', '"+typeof i[1]+"' and '"+typeof i[2]+"'.\nPossible parent types: [point,point,point]")}return a},t.Z.createReflection=function(e,r,o){var n,a,h,l,c,d,u,p,_="\nPossible parent types: [point|line|curve|polygon|circle|arc|sector, line]";for(d=0;d<r.length;++d)r[d]=e.select(r[d]);if(u=s.Z.copyAttributes(o,e.options,"reflection"),s.Z.isPoint(r[0]))a=s.Z.providePoints(e,[r[0]],p)[0];else{if(r[0].elementClass!==i.Z.OBJECT_CLASS_CURVE&&r[0].elementClass!==i.Z.OBJECT_CLASS_LINE&&r[0].type!==i.Z.OBJECT_TYPE_POLYGON&&r[0].elementClass!==i.Z.OBJECT_CLASS_CIRCLE)throw new Error("JSXGraph: Can't create reflection element with parent types '"+typeof r[0]+"' and '"+typeof r[1]+"'."+_);a=r[0]}if(r[1].elementClass!==i.Z.OBJECT_CLASS_LINE)throw new Error("JSXGraph: Can't create reflected element with parent types '"+typeof r[0]+"' and '"+typeof r[1]+"'."+_);if(n=r[1],c=t.Z.createTransform(e,[n],{type:"reflect"}),s.Z.isPoint(a))h=t.Z.createPoint(e,[a,c],u);else if(a.elementClass===i.Z.OBJECT_CLASS_CURVE)h=t.Z.createCurve(e,[a,c],u);else if(a.elementClass===i.Z.OBJECT_CLASS_LINE)h=t.Z.createLine(e,[a,c],u);else if(a.type===i.Z.OBJECT_TYPE_POLYGON)h=t.Z.createPolygon(e,[a,c],u);else{if(a.elementClass!==i.Z.OBJECT_CLASS_CIRCLE)throw new Error("JSXGraph: Can't create reflected element with parent types '"+typeof r[0]+"' and '"+typeof r[1]+"'."+_);"euclidean"===u.type.toLowerCase()?(p=s.Z.copyAttributes(o,e.options,"reflection","center"),(l=t.Z.createPoint(e,[a.center,c],p)).prepareUpdate().update().updateVisibility(s.Z.evaluate(l.visProp.visible)).updateRenderer(),h=t.Z.createCircle(e,[l,function(){return a.Radius()}],u)):h=t.Z.createCircle(e,[a,c],u)}return s.Z.exists(a._is_new)&&(h.addChild(a),delete a._is_new),n.addChild(h),h.elType="reflection",h.addParents(n),h.prepareUpdate().update(),s.Z.isPoint(h)&&(h.generatePolynomial=function(){var t=n.point1.symbolic.x,e=n.point1.symbolic.y,i=n.point2.symbolic.x,s=n.point2.symbolic.y,r=a.symbolic.x,o=a.symbolic.y,l=h.symbolic.x,c=h.symbolic.y;return[["((",c,")-(",o,"))*((",e,")-(",s,"))+((",t,")-(",i,"))*((",l,")-(",r,"))"].join(""),["((",l,")-(",t,"))^2+((",c,")-(",e,"))^2-((",r,")-(",t,"))^2-((",o,")-(",e,"))^2"].join("")]}),h},t.Z.createMirrorElement=function(e,r,o){var n,a,h,l,c,d,u,p,_="\nPossible parent types: [point|line|curve|polygon|circle|arc|sector, point]";for(a=0;a<r.length;++a)r[a]=e.select(r[a]);if(u=s.Z.copyAttributes(o,e.options,"mirrorelement"),s.Z.isPoint(r[0]))n=s.Z.providePoints(e,[r[0]],u)[0];else{if(r[0].elementClass!==i.Z.OBJECT_CLASS_CURVE&&r[0].elementClass!==i.Z.OBJECT_CLASS_LINE&&r[0].type!==i.Z.OBJECT_TYPE_POLYGON&&r[0].elementClass!==i.Z.OBJECT_CLASS_CIRCLE)throw new Error("JSXGraph: Can't create mirror element with parent types '"+typeof r[0]+"' and '"+typeof r[1]+"'."+_);n=r[0]}if(!s.Z.isPoint(r[1]))throw new Error("JSXGraph: Can't create mirror element with parent types '"+typeof r[0]+"' and '"+typeof r[1]+"'."+_);if(p=s.Z.copyAttributes(o,e.options,"mirrorelement","point"),h=s.Z.providePoints(e,[r[1]],p)[0],d=t.Z.createTransform(e,[Math.PI,h],{type:"rotate"}),s.Z.isPoint(n))l=t.Z.createPoint(e,[n,d],u);else if(n.elementClass===i.Z.OBJECT_CLASS_CURVE)l=t.Z.createCurve(e,[n,d],u);else if(n.elementClass===i.Z.OBJECT_CLASS_LINE)l=t.Z.createLine(e,[n,d],u);else if(n.type===i.Z.OBJECT_TYPE_POLYGON)l=t.Z.createPolygon(e,[n,d],u);else{if(n.elementClass!==i.Z.OBJECT_CLASS_CIRCLE)throw new Error("JSXGraph: Can't create mirror element with parent types '"+typeof r[0]+"' and '"+typeof r[1]+"'."+_);"euclidean"===u.type.toLowerCase()?(p=s.Z.copyAttributes(o,e.options,"mirrorelement","center"),(c=t.Z.createPoint(e,[n.center,d],p)).prepareUpdate().update().updateVisibility(s.Z.evaluate(c.visProp.visible)).updateRenderer(),l=t.Z.createCircle(e,[c,function(){return n.Radius()}],u)):l=t.Z.createCircle(e,[n,d],u)}return s.Z.exists(n._is_new)&&(l.addChild(n),delete n._is_new),h.addChild(l),l.elType="mirrorelement",l.addParents(h),l.prepareUpdate().update(),l},t.Z.createMirrorPoint=function(e,i,s){var r=t.Z.createMirrorElement(e,i,s);return r.elType="mirrorpoint",r},t.Z.createIntegral=function(e,r,o){var n,a,h,d,u,p,_,f,b,g,m,v,Z,C,y=null;if(s.Z.isArray(r[0])&&r[1].elementClass===i.Z.OBJECT_CLASS_CURVE)n=r[0],a=r[1];else{if(!s.Z.isArray(r[1])||r[0].elementClass!==i.Z.OBJECT_CLASS_CURVE)throw new Error("JSXGraph: Can't create integral with parent types '"+typeof r[0]+"' and '"+typeof r[1]+"'.\nPossible parent types: [[number|function,number|function],curve]");n=r[1],a=r[0]}return(h=s.Z.copyAttributes(o,e.options,"integral")).withLabel=!1,C=e.create("curve",[[0],[0]],h),d=n[0],u=n[1],s.Z.isFunction(d)?(_=function(){return a.Y(p())},d=(p=d)()):(p=d,_=a.Y(d)),s.Z.isFunction(u)?(b=function(){return a.Y(f())},u=(f=u)()):(f=u,b=a.Y(u)),h=s.Z.copyAttributes(o,e.options,"integral","curveLeft"),g=e.create("glider",[p,_,a],h),s.Z.isFunction(p)&&g.hideElement(),h=s.Z.copyAttributes(o,e.options,"integral","baseLeft"),m=e.create("point",[function(){return"y"===s.Z.evaluate(C.visProp.axis)?0:g.X()},function(){return"y"===s.Z.evaluate(C.visProp.axis)?g.Y():0}],h),h=s.Z.copyAttributes(o,e.options,"integral","curveRight"),v=e.create("glider",[f,b,a],h),s.Z.isFunction(f)&&v.hideElement(),h=s.Z.copyAttributes(o,e.options,"integral","baseRight"),Z=e.create("point",[function(){return"y"===s.Z.evaluate(C.visProp.axis)?0:v.X()},function(){return"y"===s.Z.evaluate(C.visProp.axis)?v.Y():0}],h),!1!==(h=s.Z.copyAttributes(o,e.options,"integral")).withlabel&&"y"!==h.axis&&(h=s.Z.copyAttributes(o,e.options,"integral","label"),h=s.Z.copyAttributes(h,e.options,"label"),(y=e.create("text",[function(){var t=new c.Z(i.Z.COORDS_BY_SCREEN,[s.Z.evaluate(this.visProp.offset[0])+this.board.origin.scrCoords[1],0],this.board,!1),e=this.board.getBoundingBox(),r=.1*(e[2]-e[0]),o=v.X();return o<e[0]?o=e[0]+r:o>e[2]&&(o=e[2]-r),o+t.usrCoords[1]},function(){var t=new c.Z(i.Z.COORDS_BY_SCREEN,[0,s.Z.evaluate(this.visProp.offset[1])+this.board.origin.scrCoords[2]],this.board,!1),e=this.board.getBoundingBox(),r=.1*(e[1]-e[3]),o=v.Y();return o>e[1]?o=e[1]-r:o<e[3]&&(o=e[3]+r),o+t.usrCoords[2]},function(){var t=l.Z.NewtonCotes([m.X(),Z.X()],a.Y);return"&int; = "+s.Z.toFixed(t,4)}],h)).dump=!1,g.addChild(y),v.addChild(y)),g.dump=!1,m.dump=!1,v.dump=!1,Z.dump=!1,C.elType="integral",C.setParents([a.id,n]),C.subs={curveLeft:g,baseLeft:m,curveRight:v,baseRight:Z},C.inherits.push(g,m,v,Z),h.withLabel&&(C.subs.label=y,C.inherits.push(y)),C.Value=function(){return l.Z.I([m.X(),Z.X()],a.Y)},C.updateDataArray=function(){var t,e,i,r,o,n,h,l,c;if("y"===s.Z.evaluate(this.visProp.axis)){for(g.Y()<v.Y()?(n=g.X(),l=g.Y(),h=v.X(),c=v.Y()):(n=v.X(),l=v.Y(),h=g.X(),c=g.Y()),r=Math.min(n,h),o=Math.max(n,h),t=[0,n],e=[l,l],i=0;i<a.numberPoints;i++)l<=a.points[i].usrCoords[2]&&r<=a.points[i].usrCoords[1]&&a.points[i].usrCoords[2]<=c&&a.points[i].usrCoords[1]<=o&&(t.push(a.points[i].usrCoords[1]),e.push(a.points[i].usrCoords[2]));t.push(h),e.push(c),t.push(0),e.push(c),t.push(0),e.push(l)}else{for(m.X()<Z.X()?(r=m.X(),o=Z.X()):(r=Z.X(),o=m.X()),t=[r,r],e=[0,a.Y(r)],i=0;i<a.numberPoints;i++)r<=a.points[i].usrCoords[1]&&a.points[i].usrCoords[1]<=o&&(t.push(a.points[i].usrCoords[1]),e.push(a.points[i].usrCoords[2]));t.push(o),e.push(a.Y(o)),t.push(o),e.push(0),t.push(r),e.push(0)}this.dataX=t,this.dataY=e},g.addChild(C),v.addChild(C),m.addChild(C),Z.addChild(C),C.baseLeft=m,C.baseRight=Z,C.curveLeft=g,C.curveRight=v,C.methodMap=t.Z.deepCopy(C.methodMap,{curveLeft:"curveLeft",baseLeft:"baseLeft",curveRight:"curveRight",baseRight:"baseRight",Value:"Value"}),C.label=y,C},t.Z.createGrid=function(t,e,r){var o,n;return n=s.Z.copyAttributes(r,t.options,"grid"),(o=t.create("curve",[[null],[null]],n)).elType="grid",o.type=i.Z.OBJECT_TYPE_GRID,o.updateDataArray=function(){var e,r,n,a,h,l=s.Z.evaluate(this.visProp.gridx),d=s.Z.evaluate(this.visProp.gridy);for(a=s.Z.isArray(this.visProp.topleft)?new c.Z(s.Z.evaluate(this.visProp.tltype)||i.Z.COORDS_BY_USER,this.visProp.topleft,t):new c.Z(i.Z.COORDS_BY_SCREEN,[0,0],t),h=s.Z.isArray(this.visProp.bottomright)?new c.Z(s.Z.evaluate(this.visProp.brtype)||i.Z.COORDS_BY_USER,this.visProp.bottomright,t):new c.Z(i.Z.COORDS_BY_SCREEN,[t.canvasWidth,t.canvasHeight],t),t.options.grid.hasGrid=!0,o.dataX=[],o.dataY=[],e=Math.floor(a.usrCoords[2]/d)*d,r=Math.ceil(h.usrCoords[2]/d)*d,a.usrCoords[2]<h.usrCoords[2]&&(e=Math.ceil(h.usrCoords[2]/d)*d,r=Math.floor(a.usrCoords[2]/d)*d),n=e;n>r-d;n-=d)o.dataX.push(a.usrCoords[1],h.usrCoords[1],NaN),o.dataY.push(n,n,NaN);for(e=Math.ceil(a.usrCoords[1]/l)*l,r=Math.floor(h.usrCoords[1]/l)*l,a.usrCoords[1]>h.usrCoords[1]&&(e=Math.floor(h.usrCoords[1]/l)*l,r=Math.ceil(a.usrCoords[1]/l)*l),n=e;n<r+l;n+=l)o.dataX.push(n,n,NaN),o.dataY.push(a.usrCoords[2],h.usrCoords[2],NaN)},o.hasPoint=function(){return!1},t.grids.push(o),o},t.Z.createInequality=function(t,e,r){var n,a,h;if(h=s.Z.copyAttributes(r,t.options,"inequality"),e[0].elementClass===i.Z.OBJECT_CLASS_LINE)(a=t.create("curve",[[],[]],h)).hasPoint=function(){return!1},a.updateDataArray=function(){var s,r,n,a=t.getBoundingBox(),l=h.inverse?-1:1,c=1.5*Math.max(a[2]-a[0],a[1]-a[3]),d={coords:{usrCoords:[1,(a[0]+a[2])/2,h.inverse?a[1]:a[3]]}},p=e[0].stdform.slice(1),_=p;n=1.5*Math.max(u.Z.perpendicular(e[0],d,t)[0].distance(i.Z.COORDS_BY_USER,d.coords),c),n*=l,d={coords:{usrCoords:[1,(a[0]+a[2])/2,(a[1]+a[3])/2]}},s=[1,(d=Math.abs(o.Z.innerProduct(d.coords.usrCoords,e[0].stdform,3))>=o.Z.eps?u.Z.perpendicular(e[0],d,t)[0].usrCoords:d.coords.usrCoords)[1]+p[1]*c,d[2]-p[0]*c],r=[1,d[1]-_[1]*c,d[2]+_[0]*c],this.dataX=[s[1],s[1]+p[0]*n,r[1]+_[0]*n,r[1],s[1]],this.dataY=[s[2],s[2]+p[1]*n,r[2]+_[1]*n,r[2],s[2]]};else if(e[0].elementClass===i.Z.OBJECT_CLASS_CURVE&&"functiongraph"===e[0].visProp.curvetype)(a=t.create("curve",[[],[]],h)).updateDataArray=function(){var t,i,r,o,n,a,h,l,c,d=this.board.getBoundingBox(),u=[],p=e[0].minX(),_=e[0].maxX(),f=.3*(d[1]-d[3]);if(t=s.Z.evaluate(this.visProp.inverse)?1:3,this.dataX=[],this.dataY=[],0!==(o=e[0].points.length))for(d[1]+=f,d[3]-=f,r=-1;r<o-1;){for(n=r+1,i=o;n<o;n++)if(e[0].points[n].isReal()){i=n;break}if(i>=o)break;for(n=i,r=o-1;n<o-1;n++)if(!e[0].points[n+1].isReal()){r=n;break}for(l=e[0].points[i].usrCoords[1],c=e[0].points[r].usrCoords[1],a=d[0]<p?p:d[0],h=d[2]>_?_:d[2],a=0===i?a:Math.max(a,l),h=r===o-1?h:Math.min(h,c),h=r===o-1?_:c,(u=[]).push([1,a=0===i?p:l,d[t]]),u.push([1,a,e[0].points[i].usrCoords[2]]),n=i;n<=r;n++)u.push(e[0].points[n].usrCoords);for(u.push([1,h,e[0].points[r].usrCoords[2]]),u.push([1,h,d[t]]),u.push(u[0]),n=0;n<u.length;n++)this.dataX.push(u[n][1]),this.dataY.push(u[n][2]);r<o-1&&(this.dataX.push(NaN),this.dataY.push(NaN))}},a.hasPoint=function(){return!1};else if(n=s.Z.createFunction(e[0]),a.addParentsFromJCFunctions([n]),!s.Z.exists(n))throw new Error("JSXGraph: Can't create area with the given parents.\nPossible parent types: [line], [function]");return a.addParents(e[0]),a},t.Z.registerElement("arrowparallel",t.Z.createArrowParallel),t.Z.registerElement("bisector",t.Z.createBisector),t.Z.registerElement("bisectorlines",t.Z.createAngularBisectorsOfTwoLines),t.Z.registerElement("msector",t.Z.createMsector),t.Z.registerElement("circumcircle",t.Z.createCircumcircle),t.Z.registerElement("circumcirclemidpoint",t.Z.createCircumcenter),t.Z.registerElement("circumcenter",t.Z.createCircumcenter),t.Z.registerElement("incenter",t.Z.createIncenter),t.Z.registerElement("incircle",t.Z.createIncircle),t.Z.registerElement("integral",t.Z.createIntegral),t.Z.registerElement("midpoint",t.Z.createMidpoint),t.Z.registerElement("mirrorelement",t.Z.createMirrorElement),t.Z.registerElement("mirrorpoint",t.Z.createMirrorPoint),t.Z.registerElement("normal",t.Z.createNormal),t.Z.registerElement("orthogonalprojection",t.Z.createOrthogonalProjection),t.Z.registerElement("parallel",t.Z.createParallel),t.Z.registerElement("parallelpoint",t.Z.createParallelPoint),t.Z.registerElement("perpendicular",t.Z.createPerpendicular),t.Z.registerElement("perpendicularpoint",t.Z.createPerpendicularPoint),t.Z.registerElement("perpendicularsegment",t.Z.createPerpendicularSegment),t.Z.registerElement("reflection",t.Z.createReflection),t.Z.registerElement("grid",t.Z.createGrid),t.Z.registerElement("inequality",t.Z.createInequality),t.Z.createLocus=function(t,e,i){var r,o;if(!s.Z.isArray(e)||1!==e.length||!s.Z.isPoint(e[0]))throw new Error("JSXGraph: Can't create locus with parent of type other than point.\nPossible parent types: [point]");return o=e[0],(r=t.create("curve",[[null],[null]],i)).dontCallServer=!1,r.elType="locus",r.setParents([o.id]),r.updateDataArray=function(){var e,i,s;r.board.mode>0||(e=T.generatePolynomials(t,o,!0).join("|"))!==r.spe&&(r.spe=e,i=function(t,e,i,s){var o;r.dataX=t,r.dataY=e,r.eq=i,r.ctime=s,r.generatePolynomial=(o=i,function(t){var e,i="("+t.symbolic.x+")",s="("+t.symbolic.y+")",r=[];for(e=0;e<o.length;e++)r[e]=o[e].replace(/\*\*/g,"^").replace(/x/g,i).replace(/y/g,s);return r})},i((s=T.geometricLocusByGroebnerBase(t,o,i)).datax,s.datay,s.polynomial,s.exectime))},r},t.Z.registerElement("locus",t.Z.createLocus);__webpack_require__(573);t.Z.Image=function(e,r,o,n,a){this.constructor(e,o,i.Z.OBJECT_TYPE_IMAGE,i.Z.OBJECT_CLASS_OTHER),this.element=this.board.select(o.anchor),this.coordsConstructor(r),this.W=s.Z.createFunction(a[0],this.board,""),this.H=s.Z.createFunction(a[1],this.board,""),this.addParentsFromJCFunctions([this.W,this.H]),this.usrSize=[this.W(),this.H()],this.size=[Math.abs(this.usrSize[0]*e.unitX),Math.abs(this.usrSize[1]*e.unitY)],this.url=n,this.elType="image",this.span=[this.coords.usrCoords.slice(0),[this.coords.usrCoords[0],this.W(),0],[this.coords.usrCoords[0],0,this.H()]],this.id=this.board.setId(this,"Im"),this.board.renderer.drawImage(this),this.board.finalizeAdding(this),this.methodMap=t.Z.deepCopy(this.methodMap,{addTransformation:"addTransform",trans:"addTransform"})},t.Z.Image.prototype=new G.Z,s.Z.copyPrototypeMethods(t.Z.Image,z.Z,"coordsConstructor"),t.Z.extend(t.Z.Image.prototype,{hasPoint:function(t,e){var r,n,a,h,l,d,u,p,_,f=this.transformations.length;return s.Z.isObject(s.Z.evaluate(this.visProp.precision))?(h=this.board._inputDevice,l=s.Z.evaluate(this.visProp.precision[h])):l=this.board.options.precision.hasPoint,0===f?(r=t-this.coords.scrCoords[1],n=this.coords.scrCoords[2]-e,r>=-(a=l)&&r-this.size[0]<=a&&n>=-a&&n-this.size[1]<=a):(u=[(d=(d=new c.Z(i.Z.COORDS_BY_SCREEN,[t,e],this.board)).usrCoords)[0]-this.span[0][0],d[1]-this.span[0][1],d[2]-this.span[0][2]],0<=(p=(_=o.Z.innerProduct)(u,this.span[1]))&&p<=_(this.span[1],this.span[1])&&0<=(p=_(u,this.span[2]))&&p<=_(this.span[2],this.span[2]))},update:function(t){return this.needsUpdate?(this.updateCoords(t),this.updateSize(),this.updateSpan(),this):this},updateRenderer:function(){return this.updateRendererGeneric("updateImage")},updateSize:function(){return this.usrSize=[this.W(),this.H()],this.size=[Math.abs(this.usrSize[0]*this.board.unitX),Math.abs(this.usrSize[1]*this.board.unitY)],this},updateSpan:function(){var t,e,i=this.transformations.length,s=[];if(0===i)this.span=[[this.Z(),this.X(),this.Y()],[this.Z(),this.W(),0],[this.Z(),0,this.H()]];else{for(s[0]=[this.Z(),this.X(),this.Y()],s[1]=[this.Z(),this.X()+this.W(),this.Y()],s[2]=[this.Z(),this.X(),this.Y()+this.H()],t=0;t<i;t++)for(e=0;e<3;e++)s[e]=o.Z.matVecMult(this.transformations[t].matrix,s[e]);for(e=0;e<3;e++)s[e][1]/=s[e][0],s[e][2]/=s[e][0],s[e][0]/=s[e][0];for(e=1;e<3;e++)s[e][0]-=s[0][0],s[e][1]-=s[0][1],s[e][2]-=s[0][2];this.span=s}return this},addTransform:function(t){var e;if(s.Z.isArray(t))for(e=0;e<t.length;e++)this.transformations.push(t[e]);else this.transformations.push(t);return this},getParents:function(){var t=[this.url,[this.Z(),this.X(),this.Y()],this.usrSize];return 0!==this.parents.length&&(t=this.parents),t},setSize:function(t,e){return this.W=s.Z.createFunction(t,this.board,""),this.H=s.Z.createFunction(e,this.board,""),this.addParentsFromJCFunctions([this.W,this.H]),this},W:function(){},H:function(){}}),t.Z.createImage=function(e,i,r){var o,n,a=i[0],h=i[1],l=i[2];if(o=s.Z.copyAttributes(r,e.options,"image"),!(n=z.Z.create(t.Z.Image,e,h,o,a,l)))throw new Error("JSXGraph: Can't create image with parent types '"+typeof i[0]+"' and '"+typeof i[1]+"'.\nPossible parent types: [x,y], [z,x,y], [element,transformation]");return 0!==o.rotate&&n.addRotation(o.rotate),n},t.Z.registerElement("image",t.Z.createImage);t.Z.Image;t.Z.createSlider=function(t,e,r){var n,a,h,l,d,u,p,_,f,b,g,m,v,Z,C,y,P,E,O,x,w;return P=(w=s.Z.copyAttributes(r,t.options,"slider")).withticks,y=w.withlabel,E=w.snapwidth,w=s.Z.copyAttributes(r,t.options,"slider","point1"),p=t.create("point",e[0],w),w=s.Z.copyAttributes(r,t.options,"slider","point2"),_=t.create("point",e[1],w),w=s.Z.copyAttributes(r,t.options,"slider","baseline"),(b=t.create("segment",[p,_],w)).updateStdform(),n=p.coords.usrCoords.slice(1),a=_.coords.usrCoords.slice(1),h=e[2][0],l=e[2][1],d=e[2][2],u=d-h,x=-1===(O=s.Z.evaluate(E))?l:Math.round(l/O)*O,Z=n[0]+(a[0]-n[0])*(x-h)/(d-h),C=n[1]+(a[1]-n[1])*(x-h)/(d-h),(w=s.Z.copyAttributes(r,t.options,"slider")).withLabel=!1,(f=t.create("glider",[Z,C,b],w)).setAttribute({snapwidth:E}),w=s.Z.copyAttributes(r,t.options,"slider","highline"),g=t.create("segment",[p,f],w),f.Value=function(){var t=this._smax-this._smin,e=s.Z.evaluate(this.visProp.snapwidth);return-1===e?this.position*t+this._smin:Math.round((this.position*t+this._smin)/e)*e},f.methodMap=s.Z.deepCopy(f.methodMap,{Value:"Value",setValue:"setValue",smax:"_smax",smin:"_smin",setMax:"setMax",setMin:"setMin"}),f._smax=d,f._smin=h,f.setMax=function(t){return this._smax=t,this},f.setValue=function(t){var e=this._smax-this._smin;return Math.abs(e)>o.Z.eps?this.position=(t-this._smin)/e:this.position=0,this.position=Math.max(0,Math.min(1,this.position)),this},f.setMin=function(t){return this._smin=t,this},y&&(w=s.Z.copyAttributes(r,t.options,"slider","label"),v=t.create("text",[function(){return.05*(_.X()-p.X())+_.X()},function(){return.05*(_.Y()-p.Y())+_.Y()},function(){var t,e=s.Z.evaluate(f.visProp.digits),i=s.Z.evaluate(f.visProp.suffixlabel),r=s.Z.evaluate(f.visProp.unitlabel),o=s.Z.evaluate(f.visProp.postlabel);return 2===e&&2!==s.Z.evaluate(f.visProp.precision)&&(e=s.Z.evaluate(f.visProp.precision)),t=null!==i?i:f.name&&""!==f.name?f.name+" = ":"",t+=s.Z.toFixed(f.Value(),e),null!==r&&(t+=r),null!==o&&(t+=o),t}],w),f.label=v,f.visProp.withlabel=!0,f.hasLabel=!0),f.point1=p,f.point2=_,f.baseline=b,f.highline=g,P&&(w=s.Z.copyAttributes(r,t.options,"slider","ticks"),s.Z.exists(w.generatelabeltext)||(w.generateLabelText=function(t,e,i){var s=f.point1.Dist(f.point2),r=f._smin,n=f._smax,a=this.getDistanceFromZero(e,t)*(n-r)/s+r;return s<o.Z.eps||Math.abs(a)<o.Z.eps?"0":this.formatLabelText(a)}),2,m=t.create("ticks",[f.baseline,f.point1.Dist(p)/2,function(t){var e=f.point1.Dist(f.point2),s=f.point1.coords.distance(i.Z.COORDS_BY_USER,t);return e<o.Z.eps?0:s/e*u+h}],w),f.ticks=m),f.remove=function(){y&&t.removeObject(v),t.removeObject(g),t.removeObject(b),t.removeObject(_),t.removeObject(p),H.prototype.remove.call(f)},p.dump=!1,_.dump=!1,b.dump=!1,g.dump=!1,y&&(v.dump=!1),f.elType="slider",f.parents=e,f.subs={point1:p,point2:_,baseLine:b,highLine:g},f.inherits.push(p,_,b,g),P&&(m.dump=!1,f.subs.ticks=m,f.inherits.push(m)),f.getParents=function(){return[this.point1.coords.usrCoords.slice(1),this.point2.coords.usrCoords.slice(1),[this._smin,this.position*(this._smax-this._smin)+this._smin,this._smax]]},f.baseline.on("up",(function(t){var e,r;s.Z.evaluate(f.visProp.moveonup)&&!s.Z.evaluate(f.visProp.fixed)&&(e=b.board.getMousePosition(t,0),r=new c.Z(i.Z.COORDS_BY_SCREEN,e,this.board),f.moveTo([r.usrCoords[1],r.usrCoords[2]]),f.triggerEventHandlers(["drag"],[t]))})),f.prepareUpdate().update(),t.isSuspendedUpdate||(f.updateVisibility().updateRenderer(),f.baseline.updateVisibility().updateRenderer(),f.highline.updateVisibility().updateRenderer(),P&&f.ticks.updateVisibility().updateRenderer()),f},t.Z.registerElement("slider",t.Z.createSlider),t.Z.createTapemeasure=function(e,i,r){var o,n,a,h,l,c,d,u,p,_,f;return o=i[0],n=i[1],a=s.Z.copyAttributes(r,e.options,"tapemeasure","point1"),u=e.create("point",o,a),a=s.Z.copyAttributes(r,e.options,"tapemeasure","point2"),p=e.create("point",n,a),u.setAttribute({ignoredSnapToPoints:[p]}),p.setAttribute({ignoredSnapToPoints:[u]}),a=s.Z.copyAttributes(r,e.options,"tapemeasure"),h=a.withticks,l=a.withlabel,2===(c=a.digits)&&2!==a.precision&&(c=a.precision),l&&(a.withlabel=!0),d=e.create("segment",[u,p],a),l&&(_=r.name&&""!==r.name?r.name+" = ":"",d.label.setText((function(){return _+s.Z.toFixed(u.Dist(p),c)}))),h&&(a=s.Z.copyAttributes(r,e.options,"tapemeasure","ticks"),f=e.create("ticks",[d,.1],a),d.inherits.push(f)),d.remove=function(){h&&d.removeTicks(f),e.removeObject(p),e.removeObject(u),G.Z.prototype.remove.call(this)},d.Value=function(){return u.Dist(p)},u.dump=!1,p.dump=!1,d.elType="tapemeasure",d.getParents=function(){return[[u.X(),u.Y()],[p.X(),p.Y()]]},d.subs={point1:u,point2:p},h&&(f.dump=!1),d.methodMap=t.Z.deepCopy(d.methodMap,{Value:"Value"}),d.prepareUpdate().update(),e.isSuspendedUpdate||(d.updateVisibility().updateRenderer(),d.point1.updateVisibility().updateRenderer(),d.point2.updateVisibility().updateRenderer()),d},t.Z.registerElement("tapemeasure",t.Z.createTapemeasure),t.Z.DataSource=function(){return this.data=[],this.columnHeaders=[],this.rowHeaders=[],this},t.Z.extend(t.Z.DataSource.prototype,{loadFromArray:function(t,e,i){var r,o,n;if(s.Z.isArray(e)&&(this.columnHeaders=e,e=!1),s.Z.isArray(i)&&(this.rowHeaders=i,i=!1),this.data=[],e&&(this.columnHeaders=[]),i&&(this.rowHeaders=[]),s.Z.exists(t)){for(this.data=[],r=0;r<t.length;r++)for(this.data[r]=[],o=0;o<t[r].length;o++)n=t[r][o],parseFloat(n).toString()===n?this.data[r][o]=parseFloat(n):this.data[r][o]="-"!==n?n:NaN;if(e&&(this.columnHeaders=this.data[0].slice(1),this.data=this.data.slice(1)),i)for(this.rowHeaders=[],r=0;r<this.data.length;r++)this.rowHeaders.push(this.data[r][0]),this.data[r]=this.data[r].slice(1)}return this},loadFromTable:function(t,e,i){var r,o,n,a,h;if(s.Z.isArray(e)&&(this.columnHeaders=e,e=!1),s.Z.isArray(i)&&(this.rowHeaders=i,i=!1),this.data=[],e&&(this.columnHeaders=[]),i&&(this.rowHeaders=[]),t=document.getElementById(t),s.Z.exists(t)){for(r=t.getElementsByTagName("tr"),this.data=[],o=0;o<r.length;o++)for(a=r[o].getElementsByTagName("td"),this.data[o]=[],n=0;n<a.length;n++)h=a[n].innerHTML,parseFloat(h).toString()===h?this.data[o][n]=parseFloat(h):this.data[o][n]="-"!==h?h:NaN;if(e&&(this.columnHeaders=this.data[0].slice(1),this.data=this.data.slice(1)),i)for(this.rowHeaders=[],o=0;o<this.data.length;o++)this.rowHeaders.push(this.data[o][0]),this.data[o]=this.data[o].slice(1)}return this},addColumn:function(t,e,i){throw new Error("not implemented")},addRow:function(t,e,i){throw new Error("not implemented")},getColumn:function(t){var e,i=[];if(s.Z.isString(t))for(e=0;e<this.columnHeaders.length;e++)if(t===this.columnHeaders[e]){t=e;break}for(e=0;e<this.data.length;e++)this.data[e].length>t&&(i[e]=parseFloat(this.data[e][t]));return i},getRow:function(t){var e,i;if(s.Z.isString(t))for(i=0;i<this.rowHeaders.length;i++)if(t===this.rowHeaders[i]){t=i;break}for(e=[],i=0;i<this.data[t].length;i++)e[i]=this.data[t][i];return e}});const $=t.Z.DataSource;t.Z.Chart=function(t,e,i){var r,o,n,a,h,l;if(this.constructor(t,i),!s.Z.isArray(e)||0===e.length)throw new Error("JSXGraph: Can't create a chart without data");if(this.elements=[],s.Z.isNumber(e[0]))for(o=e,r=[],n=0;n<o.length;n++)r[n]=n+1;else if(1===e.length&&s.Z.isArray(e[0]))for(o=e[0],r=[],l=s.Z.evaluate(o).length,n=0;n<l;n++)r[n]=n+1;else 2===e.length&&(l=Math.min(e[0].length,e[1].length),r=e[0].slice(0,l),o=e[1].slice(0,l));if(s.Z.isArray(o)&&0===o.length)throw new Error("JSXGraph: Can't create charts without data.");for(h=i.chartstyle.replace(/ /g,"").split(","),n=0;n<h.length;n++){switch(h[n]){case"bar":a=this.drawBar(t,r,o,i);break;case"line":a=this.drawLine(t,r,o,i);break;case"fit":a=this.drawFit(t,r,o,i);break;case"spline":a=this.drawSpline(t,r,o,i);break;case"pie":a=this.drawPie(t,o,i);break;case"point":a=this.drawPoints(t,r,o,i);break;case"radar":a=this.drawRadar(t,e,i)}this.elements.push(a)}return this.id=this.board.setId(this,"Chart"),this.elements},t.Z.Chart.prototype=new G.Z,t.Z.extend(t.Z.Chart.prototype,{drawLine:function(t,e,i,s){return s.fillcolor="none",s.highlightfillcolor="none",t.create("curve",[e,i],s)},drawSpline:function(t,e,i,s){return s.fillColor="none",s.highlightfillcolor="none",t.create("spline",[e,i],s)},drawFit:function(t,e,i,s){var r=s.degree;return r=Math.max(parseInt(r,10),1)||1,s.fillcolor="none",s.highlightfillcolor="none",t.create("functiongraph",[l.Z.regressionPolynomial(r,e,i)],s)},drawBar:function(t,e,i,r){var o,n,a,h,l,c,d,u,p,_,f=[],b=[],g=function(t,i){return function(){return e[t]()-i*a}},m={fixed:!0,withLabel:!1,visible:!1,name:""};if((p=s.Z.copyAttributes(r,t.options,"chart"))&&p.width)a=p.width;else{if(e.length<=1)a=1;else for(a=e[1]-e[0],o=1;o<e.length-1;o++)a=e[o+1]-e[o]<a?e[o+1]-e[o]:a;a*=.8}for(_=s.Z.copyAttributes(r,t.options,"chart","label"),o=0;o<e.length;o++)s.Z.isFunction(e[o])?(h=g(o,-.5),l=g(o,0),c=g(o,.5)):(h=e[o]-.5*a,l=e[o],c=e[o]+.5*a),d=s.Z.isFunction(i[o])?i[o]():i[o],d=i[o],"horizontal"===p.dir?(b[0]=t.create("point",[0,h],m),b[1]=t.create("point",[d,h],m),b[2]=t.create("point",[d,c],m),b[3]=t.create("point",[0,c],m),s.Z.exists(p.labels)&&s.Z.exists(p.labels[o])&&(_.anchorY="middle",(n=t.create("text",[d,l,p.labels[o]],_)).visProp.anchorx=function(t){return function(){return t.X()>=0?"left":"right"}}(n))):(b[0]=t.create("point",[h,0],m),b[1]=t.create("point",[h,d],m),b[2]=t.create("point",[c,d],m),b[3]=t.create("point",[c,0],m),s.Z.exists(p.labels)&&s.Z.exists(p.labels[o])&&(_.anchorX="middle",(n=t.create("text",[l,d,p.labels[o]],_)).visProp.anchory=function(t){return function(){return t.Y()>=0?"bottom":"top"}}(n))),s.Z.isArray(p.colors)&&(u=p.colors,p.fillcolor=u[o%u.length]),f[o]=t.create("polygon",b,p),s.Z.exists(p.labels)&&s.Z.exists(p.labels[o])&&(f[o].text=n);return f},drawPoints:function(t,e,i,s){var r,o=[],n=s.infoboxarray;for(s.fixed=!0,s.name="",r=0;r<e.length;r++)s.infoboxtext=!!n&&n[r%n.length],o[r]=t.create("point",[e[r],i[r]],s);return o},drawPie:function(t,e,r){var o,n,a=[],h=[],l=(d.Z.sum(e),r.colors),u=r.highlightcolors,p=r.labels,_=r.radius||4,f=_,b=r.center||[0,0],g=b[0],m=b[1],v=function(t,i,r){return function(){var o,n,a,h=0;for(n=0;n<=t;n++)h+=parseFloat(s.Z.evaluate(e[n]));for(o=h,n=t+1;n<e.length;n++)o+=parseFloat(s.Z.evaluate(e[n]));return a=0!==o?2*Math.PI*h/o:0,f()*Math[i](a)+r}},Z=function(t,e){var r=-this.point1.coords.usrCoords[1]+this.point2.coords.usrCoords[1],o=-this.point1.coords.usrCoords[2]+this.point2.coords.usrCoords[2];s.Z.exists(this.label)&&(this.label.rendNode.style.fontSize=e*s.Z.evaluate(this.label.visProp.fontsize)+"px",this.label.fullUpdate()),this.point2.coords=new c.Z(i.Z.COORDS_BY_USER,[this.point1.coords.usrCoords[1]+r*t,this.point1.coords.usrCoords[2]+o*t],this.board),this.fullUpdate()},C=function(){this.highlighted||(this.highlighted=!0,this.board.highlightedObjects[this.id]=this,this.board.renderer.highlight(this),Z.call(this,1.1,2))},y=function(){this.highlighted&&(this.highlighted=!1,this.board.renderer.noHighlight(this),Z.call(this,.9090909,1))},P={fixed:!0,withLabel:!1,visible:!1,name:""};if(!s.Z.isArray(p))for(p=[],o=0;o<e.length;o++)p[o]="";for(s.Z.isFunction(_)||(f=function(){return _}),r.highlightonsector=r.highlightonsector||!1,r.straightfirst=!1,r.straightlast=!1,n=t.create("point",[g,m],P),a[0]=t.create("point",[function(){return f()+g},function(){return m}],P),o=0;o<e.length;o++)a[o+1]=t.create("point",[v(o,"cos",g),v(o,"sin",m)],P),r.name=p[o],r.withlabel=""!==r.name,r.fillcolor=l&&l[o%l.length],r.labelcolor=l&&l[o%l.length],r.highlightfillcolor=u&&u[o%u.length],h[o]=t.create("sector",[n,a[o],a[o+1]],r),r.highlightonsector&&(h[o].hasPoint=h[o].hasPointSector),r.highlightbysize&&(h[o].highlight=C,h[o].noHighlight=y);return{sectors:h,points:a,midpoint:n}},drawRadar:function(e,r,o){var n,a,h,l,d,u,p,_,f,b,g,m,v,Z,C,y,P,E,O,x,w,S,T,M,N,A,k,R,D,L,B,I,Y,j,X,U,F,J,G,z,H,W,V=r.length,$=function(){var t,e,r,o,n=s.Z.evaluate(this.visProp.label.offset).slice(0);return t=this.point1.X(),e=this.point2.X(),r=this.point1.Y(),o=this.point2.Y(),e<t&&(n[0]=-n[0]),o<r&&(n[1]=-n[1]),this.setLabelRelativeCoords(n),new c.Z(i.Z.COORDS_BY_USER,[this.point2.X(),this.point2.Y()],this.board)},K=function(t,i){var s,r,o;return s=e.create("transform",[-(C[i]-v[i]),0],{type:"translate"}),r=e.create("transform",[O/(y[i]+Z[i]-(C[i]-v[i])),1],{type:"scale"}),s.melt(r),o=e.create("transform",[t],{type:"rotate"}),s.melt(o),s};if(V<=0)throw new Error("JSXGraph radar chart: no data");if(h=o.paramarray,!s.Z.exists(h))throw new Error("JSXGraph radar chart: need paramArray attribute");if((l=h.length)<=1)throw new Error("JSXGraph radar chart: need more than one param in paramArray");for(n=0;n<V;n++)if(l!==r[n].length)throw new Error("JSXGraph radar chart: use data length equal to number of params ("+r[n].length+" != "+l+")");for(d=[],u=[],a=0;a<l;a++)d[a]=r[0][a],u[a]=d[a];for(n=1;n<V;n++)for(a=0;a<l;a++)r[n][a]>d[a]&&(d[a]=r[n][a]),r[n][a]<u[a]&&(u[a]=r[n][a]);for(p=[],_=[],n=0;n<V;n++)p[n]="",_[n]=[];for(f=[],b=[],g=o.startshiftratio||0,m=o.endshiftratio||0,n=0;n<l;n++)f[n]=(d[n]-u[n])*g,b[n]=(d[n]-u[n])*m;if(v=o.startshiftarray||f,Z=o.endshiftarray||b,C=o.startarray||u,s.Z.exists(o.start))for(n=0;n<l;n++)C[n]=o.start;if(y=o.endarray||d,s.Z.exists(o.end))for(n=0;n<l;n++)y[n]=o.end;if(v.length!==l)throw new Error("JSXGraph radar chart: start shifts length is not equal to number of parameters");if(Z.length!==l)throw new Error("JSXGraph radar chart: end shifts length is not equal to number of parameters");if(C.length!==l)throw new Error("JSXGraph radar chart: starts length is not equal to number of parameters");if(y.length!==l)throw new Error("JSXGraph radar chart: snds length is not equal to number of parameters");for(P=o.labelarray||p,E=o.colors,o.highlightcolors,O=o.radius||10,H=o.strokewidth||1,s.Z.exists(o.highlightonsector)||(o.highlightonsector=!1),x={name:o.name,id:o.id,strokewidth:H,polystrokewidth:o.polystrokewidth||H,strokecolor:o.strokecolor||"black",straightfirst:!1,straightlast:!1,fillcolor:o.fillColor||"#FFFF88",fillopacity:o.fillOpacity||.4,highlightfillcolor:o.highlightFillColor||"#FF7400",highlightstrokecolor:o.highlightStrokeColor||"black",gradient:o.gradient||"none"},S=(w=o.center||[0,0])[0],T=w[1],M=e.create("point",[S,T],{name:"",fixed:!0,withlabel:!1,visible:!1}),Math.PI/2-Math.PI/l,A=N=o.startangle||0,k=[],R=[],n=0;n<l;n++)for(A+=2*Math.PI/l,L=O*Math.cos(A)+S,B=O*Math.sin(A)+T,k[n]=e.create("point",[L,B],{name:"",fixed:!0,withlabel:!1,visible:!1}),R[n]=e.create("line",[M,k[n]],{name:h[n],strokeColor:x.strokecolor,strokeWidth:x.strokewidth,strokeOpacity:1,straightFirst:!1,straightLast:!1,withLabel:!0,highlightStrokeColor:x.highlightstrokecolor}),R[n].getLabelAnchor=$,D=K(A,n),a=0;a<r.length;a++)W=r[a][n],_[a][n]=e.create("point",[W,0],{name:"",fixed:!0,withlabel:!1,visible:!1}),_[a][n].addTransform(_[a][n],D);for(I=[],n=0;n<V;n++)for(x.labelcolor=E&&E[n%E.length],x.strokecolor=E&&E[n%E.length],x.fillcolor=E&&E[n%E.length],I[n]=e.create("polygon",_[n],{withLines:!0,withLabel:!1,fillColor:x.fillcolor,fillOpacity:x.fillopacity,highlightFillColor:x.highlightfillcolor}),a=0;a<l;a++)I[n].borders[a].setAttribute("strokecolor:"+E[n%E.length]),I[n].borders[a].setAttribute("strokewidth:"+x.polystrokewidth);switch(o.legendposition||"none"){case"right":j=o.legendleftoffset||2,X=o.legendtopoffset||1,this.legend=e.create("legend",[S+O+j,T+O-X],{labels:P,colors:E});break;case"none":break;default:t.Z.debug("Unknown legend position")}if(Y=[],o.showcircles){for(U=[],n=0;n<6;n++)U[n]=20*n;if(U[0]="0",(J=(F=o.circlelabelarray||U).length)<2)throw new Error("JSXGraph radar chart: too less circles in circleLabelArray");for(G=[],D=K(N+Math.PI/l,0),x.fillcolor="none",x.highlightfillcolor="none",x.strokecolor=o.strokecolor||"black",x.strokewidth=o.circlestrokewidth||.5,x.layer=0,z=(y[0]-C[0])/(J-1),n=0;n<J;n++)G[n]=e.create("point",[C[0]+n*z,0],{name:F[n],size:0,fixed:!0,withLabel:!0,visible:!0}),G[n].addTransform(G[n],D),Y[n]=e.create("circle",[M,G[n]],x)}return this.rendNode=I[0].rendNode,{circles:Y,lines:R,points:_,midpoint:M,polygons:I}},updateRenderer:function(){return this},update:function(){return this.needsUpdate&&this.updateDataArray(),this},updateDataArray:function(){return this}}),t.Z.createChart=function(i,r,o){var n,a,h,l,c,d,u,p,_,f,b,g,m,v,Z,C,y=[],P=e.Z.isBrowser?i.document.getElementById(r[0]):null;if(1===r.length&&s.Z.isString(r[0])){if(s.Z.exists(P)){if(_=s.Z.copyAttributes(o,i.options,"chart"),n=(P=(new $).loadFromTable(r[0],_.withheaders,_.withheaders)).data,c=P.columnHeaders,a=P.rowHeaders,f=_.width,b=_.name,g=_.strokecolor,m=_.fillcolor,v=_.highlightstrokecolor,Z=_.highlightfillcolor,i.suspendUpdate(),C=n.length,p=[],_.rows&&s.Z.isArray(_.rows)){for(h=0;h<C;h++)for(l=0;l<_.rows.length;l++)if(_.rows[l]===h||_.withheaders&&_.rows[l]===a[h]){p.push(n[h]);break}}else p=n;for(C=p.length,h=0;h<C;h++){if(u=[],_.chartstyle&&-1!==_.chartstyle.indexOf("bar")){for(d=f||.8,u.push(1-d/2+(h+.5)*d/C),l=1;l<p[h].length;l++)u.push(u[l-1]+1);_.width=d/C}b&&b.length===C?_.name=b[h]:_.withheaders&&(_.name=c[h]),g&&g.length===C?_.strokecolor=g[h]:_.strokecolor=L.Z.hsv2rgb((h+1)/C*360,.9,.6),m&&m.length===C?_.fillcolor=m[h]:_.fillcolor=L.Z.hsv2rgb((h+1)/C*360,.9,1),v&&v.length===C?_.highlightstrokecolor=v[h]:_.highlightstrokecolor=L.Z.hsv2rgb((h+1)/C*360,.9,1),Z&&Z.length===C?_.highlightfillcolor=Z[h]:_.highlightfillcolor=L.Z.hsv2rgb((h+1)/C*360,.9,.6),_.chartstyle&&-1!==_.chartstyle.indexOf("bar")?y.push(new t.Z.Chart(i,[u,p[h]],_)):y.push(new t.Z.Chart(i,[p[h]],_))}i.unsuspendUpdate()}return y}return _=s.Z.copyAttributes(o,i.options,"chart"),new t.Z.Chart(i,r,_)},t.Z.registerElement("chart",t.Z.createChart),t.Z.Legend=function(t,e,r){var o;if(this.constructor(),o=s.Z.copyAttributes(r,t.options,"legend"),this.board=t,this.coords=new c.Z(i.Z.COORDS_BY_USER,e,this.board),this.myAtts={},this.label_array=o.labelarray||o.labels,this.color_array=o.colorarray||o.colors,this.lines=[],this.myAtts.strokewidth=o.strokewidth||5,this.myAtts.straightfirst=!1,this.myAtts.straightlast=!1,this.myAtts.withlabel=!0,this.myAtts.fixed=!0,this.style=o.legendstyle||o.style,"vertical"!==this.style)throw new Error("JSXGraph: Unknown legend style: "+this.style);this.drawVerticalLegend(t,o)},t.Z.Legend.prototype=new G.Z,t.Z.Legend.prototype.drawVerticalLegend=function(t,e){var r,o=e.linelength||1,n=(e.rowheight||20)/this.board.unitY,a=function(){return this.setLabelRelativeCoords(this.visProp.label.offset),new c.Z(i.Z.COORDS_BY_USER,[this.point2.X(),this.point2.Y()],this.board)};for(r=0;r<this.label_array.length;r++)this.myAtts.name=this.label_array[r],this.myAtts.strokecolor=this.color_array[r%this.color_array.length],this.myAtts.highlightstrokecolor=this.color_array[r%this.color_array.length],this.myAtts.label={offset:[10,0],strokeColor:this.color_array[r%this.color_array.length],strokeWidth:this.myAtts.strokewidth},this.lines[r]=t.create("line",[[this.coords.usrCoords[1],this.coords.usrCoords[2]-r*n],[this.coords.usrCoords[1]+o,this.coords.usrCoords[2]-r*n]],this.myAtts),this.lines[r].getLabelAnchor=a,this.lines[r].prepareUpdate().update().updateVisibility(s.Z.evaluate(this.lines[r].visProp.visible)).updateRenderer()},t.Z.createLegend=function(e,i,r){var o=[0,0];if(!s.Z.exists(i)||2!==i.length)throw new Error("JSXGraph: Legend element needs two numbers as parameters");return o=i,new t.Z.Legend(e,o,r)},t.Z.registerElement("legend",t.Z.createLegend);t.Z.Chart,t.Z.Legend;t.Z.Transformation=function(t,e,s){this.elementClass=i.Z.OBJECT_CLASS_OTHER,this.type=i.Z.OBJECT_TYPE_TRANSFORMATION,this.matrix=[[1,0,0],[0,1,0],[0,0,1]],this.board=t,this.isNumericMatrix=!1,this.setMatrix(t,e,s),this.methodMap={apply:"apply",applyOnce:"applyOnce",bindTo:"bindTo",bind:"bindTo",melt:"melt"}},t.Z.Transformation.prototype={},t.Z.extend(t.Z.Transformation.prototype,{update:function(){return this},setMatrix:function(t,e,i){var r,n,a;for(this.isNumericMatrix=!0,r=0;r<i.length;r++)if("number"!=typeof i[r]){this.isNumericMatrix=!1;break}if("translate"===e){if(2!==i.length)throw new Error("JSXGraph: translate transformation needs 2 parameters.");this.evalParam=s.Z.createEvalFunction(t,i,2),this.update=function(){this.matrix[1][0]=this.evalParam(0),this.matrix[2][0]=this.evalParam(1)}}else if("scale"===e){if(2!==i.length)throw new Error("JSXGraph: scale transformation needs 2 parameters.");this.evalParam=s.Z.createEvalFunction(t,i,2),this.update=function(){this.matrix[1][1]=this.evalParam(0),this.matrix[2][2]=this.evalParam(1)}}else if("reflect"===e)i.length<4&&(i[0]=t.select(i[0])),2===i.length&&(i[1]=t.select(i[1])),4===i.length&&(this.evalParam=s.Z.createEvalFunction(t,i,4)),this.update=function(){var t,e,s,r,n,a,h,l;1===i.length?h=i[0].stdform:2===i.length?h=o.Z.crossProduct(i[1].coords.usrCoords,i[0].coords.usrCoords):4===i.length&&(h=o.Z.crossProduct([1,this.evalParam(2),this.evalParam(3)],[1,this.evalParam(0),this.evalParam(1)])),t=h[1],e=h[2],a=(l=[-(s=h[0])*t,-s*e,t*t+e*e])[2],r=l[0]/l[2],n=l[1]/l[2],t=-h[2],e=h[1],this.matrix[1][1]=(t*t-e*e)/a,this.matrix[1][2]=2*t*e/a,this.matrix[2][1]=this.matrix[1][2],this.matrix[2][2]=-this.matrix[1][1],this.matrix[1][0]=r*(1-this.matrix[1][1])-n*this.matrix[1][2],this.matrix[2][0]=n*(1-this.matrix[2][2])-r*this.matrix[2][1]};else if("rotate"===e)3===i.length?this.evalParam=s.Z.createEvalFunction(t,i,3):i.length>0&&i.length<=2&&(this.evalParam=s.Z.createEvalFunction(t,i,1),2!==i.length||s.Z.isArray(i[1])||(i[1]=t.select(i[1]))),this.update=function(){var t,e,r=this.evalParam(0),o=Math.cos(r),n=Math.sin(r);this.matrix[1][1]=o,this.matrix[1][2]=-n,this.matrix[2][1]=n,this.matrix[2][2]=o,i.length>1&&(3===i.length?(t=this.evalParam(1),e=this.evalParam(2)):s.Z.isArray(i[1])?(t=i[1][0],e=i[1][1]):(t=i[1].X(),e=i[1].Y()),this.matrix[1][0]=t*(1-o)+e*n,this.matrix[2][0]=e*(1-o)-t*n)};else if("shear"===e){if(2!==i.length)throw new Error("JSXGraph: shear transformation needs 2 parameters.");this.evalParam=s.Z.createEvalFunction(t,i,2),this.update=function(){this.matrix[1][2]=this.evalParam(0),this.matrix[2][1]=this.evalParam(1)}}else if("generic"===e){if(9!==i.length)throw new Error("JSXGraph: generic transformation needs 9 parameters.");this.evalParam=s.Z.createEvalFunction(t,i,9),this.update=function(){this.matrix[0][0]=this.evalParam(0),this.matrix[0][1]=this.evalParam(1),this.matrix[0][2]=this.evalParam(2),this.matrix[1][0]=this.evalParam(3),this.matrix[1][1]=this.evalParam(4),this.matrix[1][2]=this.evalParam(5),this.matrix[2][0]=this.evalParam(6),this.matrix[2][1]=this.evalParam(7),this.matrix[2][2]=this.evalParam(8)}}for(n in this.evalParam.deps)a=this.evalParam.deps[n],this.addParents(a),a.addChild(this)},apply:function(t,e){return this.update(),s.Z.exists(e)?o.Z.matVecMult(this.matrix,t.initialCoords.usrCoords):o.Z.matVecMult(this.matrix,t.coords.usrCoords)},applyOnce:function(t){var e,r,n;for(s.Z.isArray(t)||(t=[t]),r=t.length,n=0;n<r;n++)this.update(),e=o.Z.matVecMult(this.matrix,t[n].coords.usrCoords),t[n].coords.setCoordinates(i.Z.COORDS_BY_USER,e)},bindTo:function(t){var e,i;if(s.Z.isArray(t))for(i=t.length,e=0;e<i;e++)t[e].transformations.push(this);else t.transformations.push(this)},setProperty:function(e){t.Z.deprecated("Transformation.setProperty()","Transformation.setAttribute()")},setAttribute:function(t){},melt:function(t){var e,i,s,r,o,n,a=[];for(i=t.matrix.length,s=this.matrix[0].length,e=0;e<i;e++)a[e]=[];for(this.update(),t.update(),e=0;e<i;e++)for(n=0;n<s;n++){for(o=0,r=0;r<i;r++)o+=t.matrix[e][r]*this.matrix[r][n];a[e][n]=o}return this.update=function(){var t=this.matrix.length,i=this.matrix[0].length;for(e=0;e<t;e++)for(n=0;n<i;n++)this.matrix[e][n]=a[e][n]},this},getParents:function(){var t=[[].concat.apply([],this.matrix)];return 0!==this.parents.length&&(t=this.parents),t}}),t.Z.createTransform=function(e,i,s){return new t.Z.Transformation(e,s.type,i)},t.Z.registerElement("transform",t.Z.createTransform);t.Z.Transformation;t.Z.Turtle=function(t,e,r){var o,n,a;return this.constructor(t,r,i.Z.OBJECT_TYPE_TURTLE,i.Z.OBJECT_CLASS_OTHER),this.turtleIsHidden=!1,this.board=t,this.visProp.curveType="plot",this._attributes=s.Z.copyAttributes(this.visProp,t.options,"turtle"),delete this._attributes.id,o=0,n=0,a=90,0!==e.length&&(3===e.length?(o=e[0],n=e[1],a=e[2]):2===e.length?s.Z.isArray(e[0])?(o=e[0][0],n=e[0][1],a=e[1]):(o=e[0],n=e[1]):(o=e[0][0],n=e[0][1])),this.init(o,n,a),this.methodMap=s.Z.deepCopy(this.methodMap,{forward:"forward",fd:"forward",back:"back",bk:"back",right:"right",rt:"right",left:"left",lt:"left",penUp:"penUp",pu:"penUp",penDown:"penDown",pd:"penDown",clearScreen:"clearScreen",cs:"clearScreen",clean:"clean",setPos:"setPos",home:"home",hideTurtle:"hideTurtle",ht:"hideTurtle",showTurtle:"showTurtle",st:"showTurtle",penSize:"setPenSize",penColor:"setPenColor",getPenColor:"getPenColor",getHighlightPenColor:"getHighlightPenColor",getPenSize:"getPenSize",pushTurtle:"pushTurtle",push:"pushTurtle",popTurtle:"popTurtle",pop:"popTurtle",lookTo:"lookTo",pos:"pos",moveTo:"moveTo",X:"X",Y:"Y"}),this},t.Z.Turtle.prototype=new G.Z,t.Z.extend(t.Z.Turtle.prototype,{init:function(t,e,i){var s={fixed:!0,name:"",visible:!1,withLabel:!1};this.arrowLen=20/Math.sqrt(this.board.unitX*this.board.unitX+this.board.unitY*this.board.unitY),this.pos=[t,e],this.isPenDown=!0,this.dir=90,this.stack=[],this.objects=[],this.curve=this.board.create("curve",[[this.pos[0]],[this.pos[1]]],this._attributes),this.objects.push(this.curve),this.turtle=this.board.create("point",this.pos,s),this.objects.push(this.turtle),this.turtle2=this.board.create("point",[this.pos[0],this.pos[1]+this.arrowLen],s),this.objects.push(this.turtle2),this.visProp.arrow.lastArrow=!0,this.visProp.arrow.straightFirst=!1,this.visProp.arrow.straightLast=!1,this.arrow=this.board.create("line",[this.turtle,this.turtle2],this.visProp.arrow),this.objects.push(this.arrow),this.subs={arrow:this.arrow},this.inherits.push(this.arrow),this.right(90-i),this.board.update()},forward:function(t){if(0===t)return this;var e,i=t*Math.cos(this.dir*Math.PI/180),s=t*Math.sin(this.dir*Math.PI/180);return this.turtleIsHidden||((e=this.board.create("transform",[i,s],{type:"translate"})).applyOnce(this.turtle),e.applyOnce(this.turtle2)),this.isPenDown&&this.curve.dataX.length>=8192&&(this.curve=this.board.create("curve",[[this.pos[0]],[this.pos[1]]],this._attributes),this.objects.push(this.curve)),this.pos[0]+=i,this.pos[1]+=s,this.isPenDown&&(this.curve.dataX.push(this.pos[0]),this.curve.dataY.push(this.pos[1])),this.board.update(),this},back:function(t){return this.forward(-t)},right:function(t){(this.dir-=t,this.dir%=360,this.turtleIsHidden)||this.board.create("transform",[-t*Math.PI/180,this.turtle],{type:"rotate"}).applyOnce(this.turtle2);return this.board.update(),this},left:function(t){return this.right(-t)},penUp:function(){return this.isPenDown=!1,this},penDown:function(){return this.isPenDown=!0,this.curve=this.board.create("curve",[[this.pos[0]],[this.pos[1]]],this._attributes),this.objects.push(this.curve),this},clean:function(){var t,e;for(t=0;t<this.objects.length;t++)(e=this.objects[t]).type===i.Z.OBJECT_TYPE_CURVE&&(this.board.removeObject(e),this.objects.splice(t,1));return this.curve=this.board.create("curve",[[this.pos[0]],[this.pos[1]]],this._attributes),this.objects.push(this.curve),this.board.update(),this},clearScreen:function(){var t,e,i=this.objects.length;for(t=0;t<i;t++)e=this.objects[t],this.board.removeObject(e);return this.init(0,0,90),this},setPos:function(t,e){return s.Z.isArray(t)?this.pos=t:this.pos=[t,e],this.turtleIsHidden||(this.turtle.setPositionDirectly(i.Z.COORDS_BY_USER,[t,e]),this.turtle2.setPositionDirectly(i.Z.COORDS_BY_USER,[t,e+this.arrowLen]),this.board.create("transform",[-(this.dir-90)*Math.PI/180,this.turtle],{type:"rotate"}).applyOnce(this.turtle2)),this.curve=this.board.create("curve",[[this.pos[0]],[this.pos[1]]],this._attributes),this.objects.push(this.curve),this.board.update(),this},setPenSize:function(t){return this.curve=this.board.create("curve",[[this.pos[0]],[this.pos[1]]],this.copyAttr("strokeWidth",t)),this.objects.push(this.curve),this},setPenColor:function(t){return this.curve=this.board.create("curve",[[this.pos[0]],[this.pos[1]]],this.copyAttr("strokeColor",t)),this.objects.push(this.curve),this},getPenAttribute:function(t){var e,i=this.objects.length;return e=4===i?0:i-1,s.Z.evaluate(this.objects[e].visProp[t])},getPenSize:function(){return this.getPenAttribute("strokewidth")},getPenColor:function(){return this.getPenAttribute("strokecolor")},getHighlightPenColor:function(){return this.getPenAttribute("highlightstrokecolor")},setHighlightPenColor:function(t){return this.curve=this.board.create("curve",[[this.pos[0]],[this.pos[1]]],this.copyAttr("highlightStrokeColor",t)),this.objects.push(this.curve),this},setAttribute:function(t){var e,r,o,n=this.objects.length;for(e=0;e<n;e++)(r=this.objects[e]).type===i.Z.OBJECT_TYPE_CURVE&&r.setAttribute(t);return o=this.visProp.id,this.visProp=s.Z.deepCopy(this.curve.visProp),this.visProp.id=o,this._attributes=s.Z.deepCopy(this.visProp),delete this._attributes.id,this},copyAttr:function(t,e){return this._attributes[t.toLowerCase()]=e,this._attributes},showTurtle:function(){return this.turtleIsHidden=!1,this.arrow.setAttribute({visible:!0}),this.visProp.arrow.visible=!1,this.setPos(this.pos[0],this.pos[1]),this.board.update(),this},hideTurtle:function(){return this.turtleIsHidden=!0,this.arrow.setAttribute({visible:!1}),this.visProp.arrow.visible=!1,this.board.update(),this},home:function(){return this.pos=[0,0],this.setPos(this.pos[0],this.pos[1]),this},pushTurtle:function(){return this.stack.push([this.pos[0],this.pos[1],this.dir]),this},popTurtle:function(){var t=this.stack.pop();return this.pos[0]=t[0],this.pos[1]=t[1],this.dir=t[2],this.setPos(this.pos[0],this.pos[1]),this},lookTo:function(t){var e,i,r,o,n;return s.Z.isArray(t)?(e=this.pos[0],i=this.pos[1],r=t[0],o=t[1],n=Math.atan2(o-i,r-e),this.right(this.dir-180*n/Math.PI)):s.Z.isNumber(t)&&this.right(this.dir-t),this},moveTo:function(t){var e,i,r;return s.Z.isArray(t)&&(e=t[0]-this.pos[0],i=t[1]-this.pos[1],this.turtleIsHidden||((r=this.board.create("transform",[e,i],{type:"translate"})).applyOnce(this.turtle),r.applyOnce(this.turtle2)),this.isPenDown&&this.curve.dataX.length>=8192&&(this.curve=this.board.create("curve",[[this.pos[0]],[this.pos[1]]],this._attributes),this.objects.push(this.curve)),this.pos[0]=t[0],this.pos[1]=t[1],this.isPenDown&&(this.curve.dataX.push(this.pos[0]),this.curve.dataY.push(this.pos[1])),this.board.update()),this},fd:function(t){return this.forward(t)},bk:function(t){return this.back(t)},lt:function(t){return this.left(t)},rt:function(t){return this.right(t)},pu:function(){return this.penUp()},pd:function(){return this.penDown()},ht:function(){return this.hideTurtle()},st:function(){return this.showTurtle()},cs:function(){return this.clearScreen()},push:function(){return this.pushTurtle()},pop:function(){return this.popTurtle()},evalAt:function(t,e){var s,r,o,n,a=this.objects.length;for(s=0,r=0;s<a;s++)if((o=this.objects[s]).elementClass===i.Z.OBJECT_CLASS_CURVE){if(r<=t&&t<r+o.numberPoints)return n=t-r,o[e](n);r+=o.numberPoints}return this[e]()},X:function(t){return s.Z.exists(t)?this.evalAt(t,"X"):this.pos[0]},Y:function(t){return s.Z.exists(t)?this.evalAt(t,"Y"):this.pos[1]},Z:function(t){return 1},minX:function(){return 0},maxX:function(){var t,e=this.objects.length,s=0;for(t=0;t<e;t++)this.objects[t].elementClass===i.Z.OBJECT_CLASS_CURVE&&(s+=this.objects[t].numberPoints);return s},hasPoint:function(t,e){var s,r;for(s=0;s<this.objects.length;s++)if((r=this.objects[s]).type===i.Z.OBJECT_TYPE_CURVE&&r.hasPoint(t,e))return!0;return!1}}),t.Z.createTurtle=function(e,i,r){var o;return i=i||[],o=s.Z.copyAttributes(r,e.options,"turtle"),new t.Z.Turtle(e,i,o)},t.Z.registerElement("turtle",t.Z.createTurtle);t.Z.Turtle;t.Z.Ticks=function(t,e,r){if(this.constructor(t.board,r,i.Z.OBJECT_TYPE_TICKS,i.Z.OBJECT_CLASS_OTHER),this.line=t,this.board=this.line.board,this.ticksFunction=null,this.fixedTicks=null,this.equidistant=!1,this.labelsData=[],s.Z.isFunction(e))throw this.ticksFunction=e,new Error("Function arguments are no longer supported.");s.Z.isArray(e)?this.fixedTicks=e:((Math.abs(e)<o.Z.eps||e<0)&&(e=r.defaultdistance),this.ticksFunction=this.makeTicksFunction(e),this.equidistant=!0),this.minTicksDistance=r.minticksdistance,this.ticks=[],this.ticksDelta=1,this.labels=[],this.labelData=[],this.labelCounter=0,this.id=this.line.addTicks(this),this.elType="ticks",this.inherits.push(this.labels),this.board.setId(this,"Ti")},t.Z.Ticks.prototype=new G.Z,t.Z.extend(t.Z.Ticks.prototype,{makeTicksFunction:function(t){return function(){var e,i,r;return s.Z.evaluate(this.visProp.insertticks)?((r=(i=this.getLowerAndUpperBounds(this.getZeroCoordinates(),"ticksdistance")).upper-i.lower)<=6*(e=Math.pow(10,Math.floor(Math.log(.6*r)/Math.LN10)))&&(e*=.5),e):t}},hasPoint:function(t,e){var r,n,a,h,l=this.ticks&&this.ticks.length||0;if(s.Z.isObject(s.Z.evaluate(this.visProp.precision))?(h=this.board._inputDevice,a=s.Z.evaluate(this.visProp.precision[h])):a=this.board.options.precision.hasPoint,a+=.5*s.Z.evaluate(this.visProp.strokewidth),!s.Z.evaluate(this.line.visProp.scalable)||this.line.elementClass===i.Z.OBJECT_CLASS_CURVE)return!1;if(0!==this.line.stdform[1]&&0!==this.line.stdform[2]&&this.line.type!==i.Z.OBJECT_TYPE_AXIS)return!1;for(r=0;r<l;r++)if((n=this.ticks[r])[2]&&!(0===this.line.stdform[1]&&Math.abs(n[0][0]-this.line.point1.coords.scrCoords[1])<o.Z.eps||0===this.line.stdform[2]&&Math.abs(n[1][0]-this.line.point1.coords.scrCoords[2])<o.Z.eps)&&(Math.abs(n[0][0]-n[0][1])>=1||Math.abs(n[1][0]-n[1][1])>=1))if(0===this.line.stdform[1]){if(Math.abs(e-.5*(n[1][0]+n[1][1]))<2*a&&n[0][0]-a<t&&t<n[0][1]+a)return!0}else if(0===this.line.stdform[2]&&Math.abs(t-.5*(n[0][0]+n[0][1]))<2*a&&n[1][0]-a<e&&e<n[1][1]+a)return!0;return!1},setPositionDirectly:function(t,e,r){var n,a,h=new c.Z(t,e,this.board),l=new c.Z(t,r,this.board),d=this.board.getBoundingBox();return this.line.type===i.Z.OBJECT_TYPE_AXIS&&s.Z.evaluate(this.line.visProp.scalable)?(Math.abs(this.line.stdform[1])<o.Z.eps&&Math.abs(h.usrCoords[1]*l.usrCoords[1])>o.Z.eps?(n=l.usrCoords[1]/h.usrCoords[1],d[0]*=n,d[2]*=n,this.board.setBoundingBox(d,this.board.keepaspectratio,"update")):Math.abs(this.line.stdform[2])<o.Z.eps&&Math.abs(h.usrCoords[2]*l.usrCoords[2])>o.Z.eps&&(a=l.usrCoords[2]/h.usrCoords[2],d[3]*=a,d[1]*=a,this.board.setBoundingBox(d,this.board.keepaspectratio,"update")),this):this},calculateTicksCoordinates:function(){var t,e,r,n;if(!(this.line.elementClass===i.Z.OBJECT_CLASS_LINE&&(this.setTicksSizeVariables(),Math.abs(this.dx)<o.Z.eps&&Math.abs(this.dy)<o.Z.eps)))return t=this.getZeroCoordinates(),e=this.line.elementClass===i.Z.OBJECT_CLASS_LINE?this.getLowerAndUpperBounds(t):{lower:this.line.minX(),upper:this.line.maxX()},"polar"===s.Z.evaluate(this.visProp.type)&&(n=this.board.getBoundingBox(),r=Math.max(Math.sqrt(n[0]*n[0]+n[1]*n[1]),Math.sqrt(n[2]*n[2]+n[3]*n[3])),e.upper=r),this.ticks=[],this.labelsData=[],this.equidistant?this.generateEquidistantTicks(t,e):this.generateFixedTicks(t,e),this},setTicksSizeVariables:function(t){var e,i,r,n,a=.5*s.Z.evaluate(this.visProp.majorheight),h=.5*s.Z.evaluate(this.visProp.minorheight);s.Z.exists(t)?(i=this.line.minX(),r=this.line.maxX(),(n=this.line.points.length)<2?(this.dxMaj=0,this.dyMaj=0):o.Z.relDif(t,i)<o.Z.eps?(this.dxMaj=this.line.points[0].usrCoords[2]-this.line.points[1].usrCoords[2],this.dyMaj=this.line.points[1].usrCoords[1]-this.line.points[0].usrCoords[1]):o.Z.relDif(t,r)<o.Z.eps?(this.dxMaj=this.line.points[n-2].usrCoords[2]-this.line.points[n-1].usrCoords[2],this.dyMaj=this.line.points[n-1].usrCoords[1]-this.line.points[n-2].usrCoords[1]):(this.dxMaj=-l.Z.D(this.line.Y)(t),this.dyMaj=l.Z.D(this.line.X)(t))):(this.dxMaj=this.line.stdform[1],this.dyMaj=this.line.stdform[2]),this.dxMin=this.dxMaj,this.dyMin=this.dyMaj,this.dx=this.dxMaj,this.dy=this.dyMaj,e=Math.sqrt(this.dxMaj*this.dxMaj*this.board.unitX*this.board.unitX+this.dyMaj*this.dyMaj*this.board.unitY*this.board.unitY),this.dxMaj*=a/e*this.board.unitX,this.dyMaj*=a/e*this.board.unitY,this.dxMin*=h/e*this.board.unitX,this.dyMin*=h/e*this.board.unitY,this.minStyle=s.Z.evaluate(this.visProp.minorheight)<0?"infinite":"finite",this.majStyle=s.Z.evaluate(this.visProp.majorheight)<0?"infinite":"finite"},getZeroCoordinates:function(){var t,e,r,o,n,a,h,l,d=s.Z.evaluate(this.visProp.anchor);return this.line.elementClass===i.Z.OBJECT_CLASS_LINE?this.line.type===i.Z.OBJECT_TYPE_AXIS?u.Z.projectPointToLine({coords:{usrCoords:[1,0,0]}},this.line,this.board):(r=this.line.point1.coords.usrCoords[0],t=this.line.point1.coords.usrCoords[1],e=this.line.point1.coords.usrCoords[2],a=this.line.point2.coords.usrCoords[0],o=this.line.point2.coords.usrCoords[1],n=this.line.point2.coords.usrCoords[2],"right"===d?this.line.point2.coords:"middle"===d?new c.Z(i.Z.COORDS_BY_USER,[.5*(r+a),.5*(t+o),.5*(e+n)],this.board):s.Z.isNumber(d)?new c.Z(i.Z.COORDS_BY_USER,[r+(a-r)*d,t+(o-t)*d,e+(n-e)*d],this.board):this.line.point1.coords):(h=this.line.minX(),l=this.line.maxX(),"right"===d?l:"middle"===d?.5*(h+l):s.Z.isNumber(d)?h*(1-d)+l*d:h)},getLowerAndUpperBounds:function(t,e){var r,n,a,h,l,d,p,_,f,b,g=s.Z.evaluate(this.line.visProp.straightfirst),m=s.Z.evaluate(this.line.visProp.straightlast),v=s.Z.evaluate(this.visProp.includeboundaries);return this.line.elementClass===i.Z.OBJECT_CLASS_CURVE?{lower:this.line.minX(),upper:this.line.maxX()}:(l=new c.Z(i.Z.COORDS_BY_USER,this.line.point1.coords.usrCoords,this.board),d=new c.Z(i.Z.COORDS_BY_USER,this.line.point2.coords.usrCoords,this.board),p=Math.abs(l.usrCoords[0])>=o.Z.eps&&l.scrCoords[1]>=0&&l.scrCoords[1]<=this.board.canvasWidth&&l.scrCoords[2]>=0&&l.scrCoords[2]<=this.board.canvasHeight,_=Math.abs(d.usrCoords[0])>=o.Z.eps&&d.scrCoords[1]>=0&&d.scrCoords[1]<=this.board.canvasWidth&&d.scrCoords[2]>=0&&d.scrCoords[2]<=this.board.canvasHeight,s.Z.exists(e)||"tickdistance"===e?u.Z.calcStraight(this.line,l,d,s.Z.evaluate(this.line.visProp.margin)):u.Z.calcLineDelimitingPoints(this.line,l,d),a=s.Z.evaluate(this.line.visProp.firstarrow),h=s.Z.evaluate(this.line.visProp.lastarrow),(a||h)&&(this.board.renderer.getPositionArrowHead(this.line,l,d,s.Z.evaluate(this.line.visProp.strokewidth)),a&&l.setCoordinates(i.Z.COORDS_BY_SCREEN,[l.scrCoords[1],l.scrCoords[2]]),h&&d.setCoordinates(i.Z.COORDS_BY_SCREEN,[d.scrCoords[1],d.scrCoords[2]])),(f=this.getDistanceFromZero(t,l))<(b=this.getDistanceFromZero(t,d))?(r=f,g||!p||v||(r+=o.Z.eps),n=b,m||!_||v||(n-=o.Z.eps)):b<f?(r=b,m||!_||v||(r+=o.Z.eps),n=f,g||!p||v||(n-=o.Z.eps)):(r=0,n=0),{lower:r,upper:n})},getDistanceFromZero:function(t,e){var s,r,n,a,h;return s=this.line.point1.coords,r=this.line.point2.coords,h=t.distance(i.Z.COORDS_BY_USER,e),n=[r.usrCoords[0]-s.usrCoords[0],r.usrCoords[1]-s.usrCoords[1],r.usrCoords[2]-s.usrCoords[2]],a=[e.usrCoords[0]-t.usrCoords[0],e.usrCoords[1]-t.usrCoords[1],e.usrCoords[2]-t.usrCoords[2]],o.Z.innerProduct(n,a,3)<0&&(h*=-1),h},generateEquidistantTicks:function(t,e){var r,n,a=o.Z.eps,h=this.equidistant?this.ticksFunction(1):this.ticksDelta,l=s.Z.evaluate(this.visProp.insertticks),c=s.Z.evaluate(this.visProp.minorticks);if(this.line.elementClass===i.Z.OBJECT_CLASS_LINE&&(n=this.getXandYdeltas()),h*=s.Z.evaluate(this.visProp.scale),l&&this.minTicksDistance>o.Z.eps?(h=this.adjustTickDistance(h,t,n),h/=c+1):l||(h/=c+1),this.ticksDelta=h,!(h<o.Z.eps)){for(r=0,s.Z.evaluate(this.visProp.drawzero)||(r=h);r<=e.upper+a&&(r>=e.lower-a&&this.processTickPosition(t,r,h,n),r+=h,!(e.upper-r>1e4*h)););for(r=-h;r>=e.lower-a&&(r<=e.upper+a&&this.processTickPosition(t,r,h,n),!((r-=h)-e.lower>1e4*h)););}},adjustTickDistance:function(t,e,r){var o,n,a,h=1,l=s.Z.evaluate(this.visProp.minorticks);if(this.line.elementClass===i.Z.OBJECT_CLASS_CURVE)return t;if(this.getLowerAndUpperBounds(e,"ticksdistance"),o=e.usrCoords[1]+r.x*t,n=e.usrCoords[2]+r.y*t,a=e.distance(i.Z.COORDS_BY_SCREEN,new c.Z(i.Z.COORDS_BY_USER,[o,n],this.board)),0===t)return 0;for(;a/(l+1)<this.minTicksDistance;)t*=1===h?2:5,h*=-1,o=e.usrCoords[1]+r.x*t,n=e.usrCoords[2]+r.y*t,a=e.distance(i.Z.COORDS_BY_SCREEN,new c.Z(i.Z.COORDS_BY_USER,[o,n],this.board));return t},processTickPosition:function(t,e,r,o){var n,a,h,l,d,u=s.Z.evaluate(this.visProp.ticksperlabel),p=null;this.line.elementClass===i.Z.OBJECT_CLASS_LINE?(n=t.usrCoords[1]+e*o.x,a=t.usrCoords[2]+e*o.y):(n=this.line.X(t+e),a=this.line.Y(t+e)),h=new c.Z(i.Z.COORDS_BY_USER,[n,a],this.board),this.line.elementClass===i.Z.OBJECT_CLASS_CURVE&&(p=t+e,this.setTicksSizeVariables(p)),h.major=Math.round(e/r)%(s.Z.evaluate(this.visProp.minorticks)+1)==0,u||(u=s.Z.evaluate(this.visProp.minorticks)+1),d=Math.round(e/r)%u==0,3===(l=this.createTickPath(h,h.major)).length&&(this.ticks.push(l),d&&s.Z.evaluate(this.visProp.drawlabels)?this.labelsData.push(this.generateLabelData(this.generateLabelText(h,t,p),h,this.ticks.length)):this.labelsData.push(null))},generateFixedTicks:function(t,e){var r,n,a,h,l,d,u,p,_=o.Z.eps,f=s.Z.isArray(this.visProp.labels),b=s.Z.evaluate(this.visProp.drawlabels);for(this.line.elementClass===i.Z.OBJECT_CLASS_LINE&&(p=this.getXandYdeltas()),a=0;a<this.fixedTicks.length;a++)this.line.elementClass===i.Z.OBJECT_CLASS_LINE?(u=this.fixedTicks[a],l=t.usrCoords[1]+u*p.x,d=t.usrCoords[2]+u*p.y):(u=t+this.fixedTicks[a],l=this.line.X(u),d=this.line.Y(u)),r=new c.Z(i.Z.COORDS_BY_USER,[l,d],this.board),this.line.elementClass===i.Z.OBJECT_CLASS_CURVE&&this.setTicksSizeVariables(u),3===(h=this.createTickPath(r,!0)).length&&u>=e.lower-_&&u<=e.upper+_&&(this.ticks.push(h),b&&(f||s.Z.exists(this.visProp.labels[a]))?(n=f?s.Z.evaluate(this.visProp.labels[a]):u,this.labelsData.push(this.generateLabelData(this.generateLabelText(r,t,n),r,a))):this.labelsData.push(null))},getXandYdeltas:function(){var t,e,s=this.line.point1.Dist(this.line.point2);return this.line.type===i.Z.OBJECT_TYPE_AXIS?(t=this.line.point1.coords.usrCoords,e=this.line.point2.coords.usrCoords,(t[1]>e[1]||Math.abs(t[1]-e[1])<o.Z.eps&&t[2]>e[2])&&(t=this.line.point2.coords.usrCoords,e=this.line.point1.coords.usrCoords)):(t=this.line.point1.coords.usrCoords,e=this.line.point2.coords.usrCoords),{x:(e[1]-t[1])/s,y:(e[2]-t[2])/s}},_isInsideCanvas:function(t,e,i){var s=this.board.canvasWidth,r=this.board.canvasHeight;return void 0===i&&(i=0),t[0]>=i&&t[0]<=s-i&&e[0]>=i&&e[0]<=r-i||t[1]>=i&&t[1]<=s-i&&e[1]>=i&&e[1]<=r-i},createTickPath:function(t,e){var i,r,n,a,h,l,c,d,p,_,f,b,g,m,v,Z,C,y=[-2e6,-2e6],P=[-2e6,-2e6];if(i=t.scrCoords,e?(a=this.dxMaj,h=this.dyMaj,p=this.majStyle,v=s.Z.evaluate(this.visProp.majortickendings[0])>0,Z=s.Z.evaluate(this.visProp.majortickendings[1])>0):(a=this.dxMin,h=this.dyMin,p=this.minStyle,v=s.Z.evaluate(this.visProp.tickendings[0])>0,Z=s.Z.evaluate(this.visProp.tickendings[1])>0),r=[-h*i[1]-a*i[2],h,a],e&&"polar"===s.Z.evaluate(this.visProp.type)){if(b=this.board.getBoundingBox(),m=(g=2*Math.PI)/180,i=t.usrCoords,(f=Math.sqrt(i[1]*i[1]+i[2]*i[2]))<Math.max(Math.sqrt(b[0]*b[0]+b[1]*b[1]),Math.sqrt(b[2]*b[2]+b[3]*b[3]))){for(y=[],P=[],_=0;_<=g;_+=m)y.push(this.board.origin.scrCoords[1]+f*Math.cos(_)*this.board.unitX),P.push(this.board.origin.scrCoords[2]+f*Math.sin(_)*this.board.unitY);return[y,P,e]}}else{if("infinite"===p){if(s.Z.evaluate(this.visProp.ignoreinfinitetickendings)&&(v=Z=!0),n=u.Z.meetLineBoard(r,this.board),v&&Z)y[0]=n[0].scrCoords[1],y[1]=n[1].scrCoords[1],P[0]=n[0].scrCoords[2],P[1]=n[1].scrCoords[2];else if((C=[o.Z.innerProduct(n[0].usrCoords.slice(1,3),this.line.stdform.slice(1,3))+this.line.stdform[0],o.Z.innerProduct(n[1].usrCoords.slice(1,3),this.line.stdform.slice(1,3))+this.line.stdform[0]])[0]<C[1]&&(n.reverse(),C.reverse()),v){if(C[0]<0)return[];C[1]<0?(y[0]=n[0].scrCoords[1],P[0]=n[0].scrCoords[2],y[1]=i[1],P[1]=i[2]):(y[0]=n[0].scrCoords[1],P[0]=n[0].scrCoords[2],y[1]=n[1].scrCoords[1],P[1]=n[1].scrCoords[2])}else if(Z){if(C[1]>0)return[];C[0]>0?(y[0]=i[1],P[0]=i[2],y[1]=n[1].scrCoords[1],P[1]=n[1].scrCoords[2]):(y[0]=n[0].scrCoords[1],P[0]=n[0].scrCoords[2],y[1]=n[1].scrCoords[1],P[1]=n[1].scrCoords[2])}}else d=">"===s.Z.evaluate(this.visProp.face)?Math.PI/4:"<"===s.Z.evaluate(this.visProp.face)?-Math.PI/4:0,l=Math.cos(d)*a-Math.sin(d)*h,c=Math.sin(d)*a+Math.cos(d)*h,y[0]=i[1]+l*v,P[0]=i[2]-c*v,y[1]=i[1],P[1]=i[2],d=-d,l=Math.cos(d)*a-Math.sin(d)*h,c=Math.sin(d)*a+Math.cos(d)*h,y[2]=i[1]-l*Z,P[2]=i[2]+c*Z;if(this._isInsideCanvas(y,P))return[y,P,e]}return[]},formatLabelText:function(t){var e,i,r=s.Z.evaluate(this.visProp.scalesymbol);return s.Z.isNumber(t)?(((e=(Math.round(1e11*t)/1e11).toString()).length>s.Z.evaluate(this.visProp.maxlabellength)||-1!==e.indexOf("e"))&&(i=s.Z.evaluate(this.visProp.digits),3!==s.Z.evaluate(this.visProp.precision)&&3===i&&(i=s.Z.evaluate(this.visProp.precision)),e=t.toExponential(i).toString()),s.Z.evaluate(this.visProp.beautifulscientificticklabels)&&(e=this.beautifyScientificNotationLabel(e)),e.indexOf(".")>-1&&-1===e.indexOf("e")&&(e=(e=e.replace(/0+$/,"")).replace(/\.$/,""))):e=t.toString(),r.length>0&&("1"===e?e=r:"-1"===e?e="-"+r:"0"!==e&&(e+=r)),s.Z.evaluate(this.visProp.useunicodeminus)&&(e=e.replace(/-/g,"−")),e},beautifyScientificNotationLabel:function(t){return-1===t.indexOf("e")?t:(parseFloat(t.substring(0,t.indexOf("e")))+t.substring(t.indexOf("e"))).replace(/e(.*)$/g,(function(t,e){var i="•10";return i+=e.replace(/-/g,"⁻").replace(/\+/g,"").replace(/0/g,"⁰").replace(/1/g,"¹").replace(/2/g,"²").replace(/3/g,"³").replace(/4/g,"⁴").replace(/5/g,"⁵").replace(/6/g,"⁶").replace(/7/g,"⁷").replace(/8/g,"⁸").replace(/9/g,"⁹")}))},generateLabelText:function(t,e,i){var r;if(!s.Z.exists(i)){if(r=this.getDistanceFromZero(e,t),Math.abs(r)<o.Z.eps)return"0";i=r/s.Z.evaluate(this.visProp.scale)}return this.formatLabelText(i)},generateLabelData:function(t,e,i){var r,o,n,a;return a=s.Z.evaluate(this.visProp.label.fontsize),r=[e.scrCoords[1],e.scrCoords[1]],o=[e.scrCoords[2],e.scrCoords[2]],n=void 0===a?12:a,n*=.5,this._isInsideCanvas(r,o,n)?(r=s.Z.evaluate(this.visProp.label.offset[0]),o=s.Z.evaluate(this.visProp.label.offset[1]),{x:e.usrCoords[1]+r/this.board.unitX,y:e.usrCoords[2]+o/this.board.unitY,t,i}):null},update:function(){return this.needsUpdate&&0!==this.board.canvasWidth&&0!==this.board.canvasHeight&&this.calculateTicksCoordinates(),this},updateRenderer:function(){return this.needsUpdate?(this.visPropCalc.visible&&this.board.renderer.updateTicks(this),this.updateRendererLabels(),this.setDisplayRendNode(),this.needsUpdate=!1,this):this},updateRendererLabels:function(){var e,i,r,o,n,a,h,l;for(r=this.labelsData.length,o=this.labels.length,e=0,i=0;e<r;e++)null!==this.labelsData[e]&&(h=this.labelsData[e],i<o?((a=this.labels[i]).setText(h.t),a.setCoords(h.x,h.y),i++):(this.labelCounter+=1,n={isLabel:!0,layer:this.board.options.layer.line,highlightStrokeColor:this.board.options.text.strokeColor,highlightStrokeWidth:this.board.options.text.strokeWidth,highlightStrokeOpacity:this.board.options.text.strokeOpacity,priv:this.visProp.priv},(n=s.Z.deepCopy(n,this.visProp.label)).id=this.id+h.i+"Label"+this.labelCounter,a=t.Z.createText(this.board,[h.x,h.y,h.t],n),this.addChild(a),a.setParents(this),a.isDraggable=!1,a.dump=!1,this.labels.push(a)),"inherit"===(l=s.Z.evaluate(this.visProp.label.visible))&&(l=this.visPropCalc.visible),a.prepareUpdate().updateVisibility(l).updateRenderer(),a.distanceX=s.Z.evaluate(this.visProp.label.offset[0]),a.distanceY=s.Z.evaluate(this.visProp.label.offset[1]));for(i=r=i;i<o;i++)this.board.renderer.display(this.labels[i],!1),this.labels[i].visProp.visible=this.labels[i].visPropCalc.visible=!1;return this},hideElement:function(){var e;for(t.Z.deprecated("Element.hideElement()","Element.setDisplayRendNode()"),this.visPropCalc.visible=!1,this.board.renderer.display(this,!1),e=0;e<this.labels.length;e++)s.Z.exists(this.labels[e])&&this.labels[e].hideElement();return this},showElement:function(){var e;for(t.Z.deprecated("Element.showElement()","Element.setDisplayRendNode()"),this.visPropCalc.visible=!0,this.board.renderer.display(this,!1),e=0;e<this.labels.length;e++)s.Z.exists(this.labels[e])&&this.labels[e].showElement();return this}}),t.Z.createTicks=function(e,r,o){var n,a,h=s.Z.copyAttributes(o,e.options,"ticks");if(a=r.length<2?h.ticksdistance:r[1],r[0].elementClass!==i.Z.OBJECT_CLASS_LINE&&r[0].elementClass!==i.Z.OBJECT_CLASS_CURVE)throw new Error("JSXGraph: Can't create Ticks with parent types '"+typeof r[0]+"'.");return n=new t.Z.Ticks(r[0],a,h),s.Z.isFunction(h.generatelabelvalue)&&(n.generateLabelText=h.generatelabelvalue),s.Z.isFunction(h.generatelabeltext)&&(n.generateLabelText=h.generatelabeltext),n.setParents(r[0]),n.isDraggable=!0,n.fullUpdate(r[0].visPropCalc.visible),n},t.Z.createHatchmark=function(t,e,r){var o,n,a,h,l,c=[],d=s.Z.copyAttributes(r,t.options,"hatch");if(e[0].elementClass!==i.Z.OBJECT_CLASS_LINE&&e[0].elementClass!==i.Z.OBJECT_CLASS_CURVE||"number"!=typeof e[1])throw new Error("JSXGraph: Can't create Hatch mark with parent types '"+typeof e[0]+"' and '"+typeof e[1]+" and ''"+typeof e[2]+"'.");for(a=.5*-(((o=e[1])-1)*(h=d.ticksdistance)),n=0;n<o;n++)c[n]=a+n*h;return(l=t.create("ticks",[e[0],c],d)).elType="hatch",e[0].inherits.push(l),l},t.Z.registerElement("ticks",t.Z.createTicks),t.Z.registerElement("hash",t.Z.createHatchmark),t.Z.registerElement("hatch",t.Z.createHatchmark);t.Z.Ticks;t.Z.CA=function(t,e,i){this.node=t,this.createNode=e,this.parser=i},t.Z.extend(t.Z.CA.prototype,{findMapNode:function(t,e){var i,s,r;if("op_assign"===e.value&&e.children[0].value===t)return e.children[1];if(e.children)for(s=e.children.length,i=0;i<s;++i)if(null!==(r=this.findMapNode(t,e.children[i])))return r;return null},setMath:function(t){var e,i;if(("node_op"!=t.type||"op_add"!=t.value&&"op_sub"!=t.value&&"op_mul"!=t.value&&"op_div"!=t.value&&"op_neg"!=t.value&&"op_execfun"!=t.value&&"op_exp"!=t.value)&&"node_var"!=t.type&&"node_const"!=t.type||(t.isMath=!0),t.children)for(i=t.children.length,e=0;e<i;++e)this.setMath(t.children[e])},deriveElementary:function(t,e){var i,r=t.children[0].value,o=t.children[1];switch(r){case"abs":i=this.createNode("node_op","op_div",o[0],this.createNode("node_op","op_execfun",this.createNode("node_var","sqrt"),[this.createNode("node_op","op_mul",s.Z.deepCopy(o[0]),s.Z.deepCopy(o[0]))]));break;case"sqrt":i=this.createNode("node_op","op_div",this.createNode("node_const",1),this.createNode("node_op","op_mul",this.createNode("node_const",2),this.createNode(t.type,t.value,s.Z.deepCopy(t.children[0]),s.Z.deepCopy(t.children[1]))));break;case"sin":i=this.createNode("node_op","op_execfun",this.createNode("node_var","cos"),s.Z.deepCopy(o));break;case"cos":i=this.createNode("node_op","op_neg",this.createNode("node_op","op_execfun",this.createNode("node_var","sin"),s.Z.deepCopy(o)));break;case"tan":i=this.createNode("node_op","op_div",this.createNode("node_const",1),this.createNode("node_op","op_exp",this.createNode("node_op","op_execfun",this.createNode("node_var","cos"),s.Z.deepCopy(o)),this.createNode("node_const",2)));break;case"cot":i=this.createNode("node_op","op_neg",this.createNode("node_op","op_div",this.createNode("node_const",1),this.createNode("node_op","op_exp",this.createNode("node_op","op_execfun",this.createNode("node_var","sin"),s.Z.deepCopy(o)),this.createNode("node_const",2))));break;case"exp":i=this.createNode(t.type,t.value,s.Z.deepCopy(t.children[0]),s.Z.deepCopy(t.children[1]));break;case"pow":i=this.createNode("node_op","op_mul",this.createNode("node_op","op_execfun",s.Z.deepCopy(t.children[0]),s.Z.deepCopy(t.children[1])),this.createNode("node_op","op_add",this.createNode("node_op","op_mul",this.derivative(t.children[1][0],e),this.createNode("node_op","op_div",s.Z.deepCopy(t.children[1][1]),s.Z.deepCopy(t.children[1][0]))),this.createNode("node_op","op_mul",this.derivative(t.children[1][1],e),this.createNode("node_op","op_execfun",this.createNode("node_var","log"),[s.Z.deepCopy(t.children[1][0])]))));break;case"log":case"ln":i=this.createNode("node_op","op_div",this.createNode("node_const",1),s.Z.deepCopy(o[0]));break;case"log2":case"lb":case"ld":i=this.createNode("node_op","op_mul",this.createNode("node_op","op_div",this.createNode("node_const",1),s.Z.deepCopy(o[0])),this.createNode("node_const",1.4426950408889634));break;case"log10":case"lg":i=this.createNode("node_op","op_mul",this.createNode("node_op","op_div",this.createNode("node_const",1),s.Z.deepCopy(o[0])),this.createNode("node_const",.43429448190325176));break;case"asin":i=this.createNode("node_op","op_div",this.createNode("node_const",1),this.createNode("node_op","op_execfun",this.createNode("node_var","sqrt"),[this.createNode("node_op","op_sub",this.createNode("node_const",1),this.createNode("node_op","op_mul",s.Z.deepCopy(o[0]),s.Z.deepCopy(o[0])))]));break;case"acos":i=this.createNode("node_op","op_neg",this.createNode("node_op","op_div",this.createNode("node_const",1),this.createNode("node_op","op_execfun",this.createNode("node_var","sqrt"),[this.createNode("node_op","op_sub",this.createNode("node_const",1),this.createNode("node_op","op_mul",s.Z.deepCopy(o[0]),s.Z.deepCopy(o[0])))])));break;case"atan":i=this.createNode("node_op","op_div",this.createNode("node_const",1),this.createNode("node_op","op_add",this.createNode("node_const",1),this.createNode("node_op","op_mul",s.Z.deepCopy(o[0]),s.Z.deepCopy(o[0]))));break;case"acot":i=this.createNode("node_op","op_neg",this.createNode("node_op","op_div",this.createNode("node_const",1),this.createNode("node_op","op_add",this.createNode("node_const",1),this.createNode("node_op","op_mul",s.Z.deepCopy(o[0]),s.Z.deepCopy(o[0])))));break;case"sinh":i=this.createNode("node_op","op_execfun",this.createNode("node_var","cosh"),[s.Z.deepCopy(o[0])]);break;case"cosh":i=this.createNode("node_op","op_execfun",this.createNode("node_var","sinh"),[s.Z.deepCopy(o[0])]);break;case"tanh":i=this.createNode("node_op","op_sub",this.createNode("node_const",1),this.createNode("node_op","op_exp",this.createNode("node_op","op_execfun",this.createNode("node_var","tanh"),[s.Z.deepCopy(o[0])]),this.createNode("node_const",2)));break;case"asinh":i=this.createNode("node_op","op_div",this.createNode("node_const",1),this.createNode("node_op","op_execfun",this.createNode("node_var","sqrt"),[this.createNode("node_op","op_add",this.createNode("node_op","op_mul",s.Z.deepCopy(o[0]),s.Z.deepCopy(o[0])),this.createNode("node_const",1))]));break;case"acosh":i=this.createNode("node_op","op_div",this.createNode("node_const",1),this.createNode("node_op","op_execfun",this.createNode("node_var","sqrt"),[this.createNode("node_op","op_sub",this.createNode("node_op","op_mul",s.Z.deepCopy(o[0]),s.Z.deepCopy(o[0])),this.createNode("node_const",1))]));break;case"atanh":i=this.createNode("node_op","op_div",this.createNode("node_const",1),this.createNode("node_op","op_sub",this.createNode("node_const",1),this.createNode("node_op","op_mul",s.Z.deepCopy(o[0]),s.Z.deepCopy(o[0]))));break;default:throw i=this.createNode("node_const",0),console.log('Derivative of "'+r+'" not yet implemented'),new Error("Error("+this.line+"): ")}return i},derivative:function(t,e){var i;switch(t.type){case"node_op":switch(t.value){case"op_execfun":i="pow"==t.children[0].value?this.deriveElementary(t,e):0===t.children[1].length?this.createNode("node_const",0):this.createNode("node_op","op_mul",this.deriveElementary(t,e),this.derivative(t.children[1][0],e));break;case"op_div":i=this.createNode("node_op","op_div",this.createNode("node_op","op_sub",this.createNode("node_op","op_mul",this.derivative(t.children[0],e),s.Z.deepCopy(t.children[1])),this.createNode("node_op","op_mul",s.Z.deepCopy(t.children[0]),this.derivative(t.children[1],e))),this.createNode("node_op","op_mul",s.Z.deepCopy(t.children[1]),s.Z.deepCopy(t.children[1])));break;case"op_mul":i=this.createNode("node_op","op_add",this.createNode("node_op","op_mul",s.Z.deepCopy(t.children[0]),this.derivative(t.children[1],e)),this.createNode("node_op","op_mul",this.derivative(t.children[0],e),s.Z.deepCopy(t.children[1])));break;case"op_neg":i=this.createNode("node_op","op_neg",this.derivative(t.children[0],e));break;case"op_add":case"op_sub":i=this.createNode("node_op",t.value,this.derivative(t.children[0],e),this.derivative(t.children[1],e));break;case"op_exp":i=this.createNode("node_op","op_mul",s.Z.deepCopy(t),this.createNode("node_op","op_add",this.createNode("node_op","op_mul",this.derivative(t.children[0],e),this.createNode("node_op","op_div",s.Z.deepCopy(t.children[1]),s.Z.deepCopy(t.children[0]))),this.createNode("node_op","op_mul",this.derivative(t.children[1],e),this.createNode("node_op","op_execfun",this.createNode("node_var","log"),[s.Z.deepCopy(t.children[0])]))))}break;case"node_var":i=t.value===e?this.createNode("node_const",1):this.createNode("node_const",0);break;case"node_const":i=this.createNode("node_const",0)}return i},expandDerivatives:function(t,e,i){var r,o,n,a,h,l,c,d,u,p,_;if(0,!t)return 0;for(this.line=t.line,this.col=t.col,r=t.children.length,o=0;o<r;++o)if(t.children[o]&&t.children[o].type)t.children[o]=this.expandDerivatives(t.children[o],t,i);else if(s.Z.isArray(t.children[o]))for(n=0;n<t.children[o].length;++n)t.children[o][n]&&t.children[o][n].type&&(t.children[o][n]=this.expandDerivatives(t.children[o][n],t,i));if("node_op"===t.type)if("op_execfun"===t.value)if(t.children[0]&&"D"===t.children[0].value){if("node_var"==t.children[1][0].type?(d=t.children[1][0].value,p=(a=this.findMapNode(d,i)).children[0],u=t.children[1].length>=2?t.children[1][1].value:a.children[0][0],h=a.children[1]):(h=t.children[1][0],p=["x"],u=t.children[1].length>=2?t.children[1][1].value:"x"),c=h,(_=t.children[1].length>=3?t.children[1][2].value:1)>=1)for(;_>=1;)c=this.derivative(c,u),c=this.removeTrivialNodes(c),_--;l="node_op"==e.type&&"op_assign"==e.value?this.createNode("node_op","op_map",p,c):c,this.setMath(l),t.type=l.type,t.value=l.value,t.children[0]=l.children[0],t.children[1]=l.children[1]}return t},removeTrivialNodes:function(t){var e,i,r,o,n;if(s.Z.isArray(t))for(i=t.length,e=0;e<i;++e)t[e]=this.removeTrivialNodes(t[e]);if("node_op"!=t.type||!t.children)return t;for(i=t.children.length,e=0;e<i;++e){this.mayNotBeSimplified=!1;do{t.children[e]=this.removeTrivialNodes(t.children[e])}while(this.mayNotBeSimplified)}switch(t.value){case"op_map":if(r=t.children[0],"node_var"==(o=t.children[1]).type)for(e=0;e<r.length;++e)if(r[e]==o.value){o.isMath=!0;break}break;case"op_add":if(r=t.children[0],o=t.children[1],"node_const"==r.type&&0===r.value)return o;if("node_const"==o.type&&0===o.value)return r;if("node_const"==r.type&&"node_const"==o.type)return r.value+=o.value,r;break;case"op_mul":if(r=t.children[0],o=t.children[1],"node_const"==r.type&&1==r.value)return o;if("node_const"==o.type&&1==o.value)return r;if("node_const"==r.type&&0===r.value)return r;if("node_const"==o.type&&0===o.value)return o;if("node_const"==o.type&&0===o.value)return o;if("node_op"==r.type&&"op_neg"==r.value&&"node_op"==o.type&&"op_neg"==o.value)return t.children=[r.children[0],o.children[0]],this.mayNotBeSimplified=!0,t;if("op_neg"==r.value&&"op_neg"!=o.value)return t.type="node_op",t.value="op_neg",t.children=[this.createNode("node_op","op_mul",r.children[0],o)],this.mayNotBeSimplified=!0,t;if("op_neg"!=r.value&&"op_neg"==o.value)return t.type="node_op",t.value="op_neg",t.children=[this.createNode("node_op","op_mul",r,o.children[0])],this.mayNotBeSimplified=!0,t;if("op_div"==r.value&&"node_const"==r.children[0].type&&1==r.children[0].value)return t.type="node_op",t.value="op_div",t.children=[o,r.children[1]],this.mayNotBeSimplified=!0,t;if("op_div"==o.value&&"node_const"==o.children[0].type&&1==o.children[0].value)return t.type="node_op",t.value="op_div",t.children=[r,o.children[1]],this.mayNotBeSimplified=!0,t;if("node_const"!=r.type&&"node_const"==o.type)return t.children=[o,r],this.mayNotBeSimplified=!0,t;if("node_const"!=r.type&&"node_op"==o.type&&"op_neg"==o.value&&"node_const"==o.children[0].type)return t.children=[o,r],this.mayNotBeSimplified=!0,t;if("node_op"==r.type&&"op_execfun"!=r.value&&("node_var"==o.type||"node_op"==o.type&&"op_execfun"==o.value))return t.children=[o,r],this.mayNotBeSimplified=!0,t;if("node_op"!=r.type&&"node_op"==o.type&&"op_neg"==o.value&&"node_var"==o.children[0].type)return t.children=[o,r],this.mayNotBeSimplified=!0,t;if("node_const"!=r.type&&"node_op"==o.type&&("op_mul"==o.value||"op_div"==o.value)&&"node_const"==o.children[0].type)return n=o.children[0],o.children[0]=r,t.children=[n,o],this.mayNotBeSimplified=!0,t;if("node_const"!=o.type&&"node_op"==r.type&&"op_mul"==r.value&&"node_const"==r.children[0].type)return t.children=[r.children[0],this.createNode("node_op","op_mul",r.children[1],o)],this.mayNotBeSimplified=!0,t;if("node_const"==r.type&&"node_const"==o.type)return r.value*=o.value,r;if("node_const"==r.type&&"node_op"==o.type&&("op_mul"==o.value||"op_div"==o.value)&&"node_const"==o.children[0].type)return o.children[0].value*=r.value,o;if(r.hash=this.parser.compile(r),o.hash=this.parser.compile(o),r.hash===o.hash)return t.value="op_exp",t.children[1]=this.createNode("node_const",2),t;if("node_const"==r.type&&"node_op"==o.type&&("op_mul"==o.value||"op_div"==o.value)&&"node_const"==o.children[0].type)return o.children[0].value*=r.value,o;if("node_op"==o.type&&"op_exp"==o.value&&(r.hash||(r.hash=this.parser.compile(r)),o.children[0].hash||(o.children[0].hash=this.parser.compile(o.children[0])),r.hash===o.children[0].hash))return o.children[1]=this.createNode("node_op","op_add",o.children[1],this.createNode("node_const",1)),this.mayNotBeSimplified=!0,o;if("node_op"==r.type&&"op_exp"==r.value&&"node_op"==o.type&&"op_exp"==o.value&&(r.children[0].hash=this.parser.compile(r.children[0]),o.children[0].hash=this.parser.compile(o.children[0]),r.children[0].hash===o.children[0].hash))return r.children[1]=this.createNode("node_op","op_add",r.children[1],o.children[1]),this.mayNotBeSimplified=!0,r;break;case"op_sub":if(r=t.children[0],o=t.children[1],"node_const"==r.type&&0===r.value)return t.value="op_neg",t.children[0]=o,t;if("node_const"==o.type&&0===o.value)return r;if("node_const"==r.type&&"node_const"==o.type&&r.value==o.value)return this.createNode("node_const",0);if("node_var"==r.type&&"node_var"==o.type&&r.value==o.value)return this.createNode("node_const",0);if("node_const"==r.type&&"node_const"==o.type)return r.value-=o.value,r;if("node_op"==r.type&&"op_mul"==r.value&&"node_op"==o.type&&"op_mul"==o.value&&(r.children[1].hash=this.parser.compile(r.children[1]),o.children[1].hash=this.parser.compile(o.children[1]),r.children[1].hash===o.children[1].hash))return t.value="op_mul",t.children=[this.createNode("node_op","op_sub",r.children[0],o.children[0]),r.children[1]],this.mayNotBeSimplified=!0,t;if("node_op"==r.type&&"op_mul"==r.value&&(r.children[1].hash=this.parser.compile(r.children[1]),o.hash=this.parser.compile(o),r.children[1].hash===o.hash))return t.value="op_mul",t.children=[this.createNode("node_op","op_sub",r.children[0],this.createNode("node_const",1)),o],this.mayNotBeSimplified=!0,t;if("node_op"==o.type&&"op_mul"==o.value&&(o.children[1].hash=this.parser.compile(o.children[1]),r.hash=this.parser.compile(r),o.children[1].hash===r.hash))return t.value="op_mul",t.children=[this.createNode("node_op","op_sub",this.createNode("node_const",1),o.children[0]),r],this.mayNotBeSimplified=!0,t;break;case"op_neg":if("node_const"==(r=t.children[0]).type&&0===r.value)return r;if("node_op"==r.type&&"op_neg"==r.value)return r.children[0];break;case"op_div":if(r=t.children[0],o=t.children[1],"node_const"==r.type&&"node_const"==o.type&&r.value==o.value&&0!==r.value)return r.value=1,r;if("node_const"==r.type&&0===r.value&&"node_const"==o.type&&0!==o.value)return r.value=0,r;if("node_const"==r.type&&0===r.value&&("node_op"==o.type||"node_var"==o.type))return t.type="node_const",t.value=0,t;if("node_var"==r.type&&"node_var"==o.type&&r.value==o.value)return this.createNode("node_const",1);if("node_const"==r.type&&0!==r.value&&"node_const"==o.type&&0===o.value)return r.value>0?r.value=1/0:r.value=-1/0,r;if("node_op"==r.type&&"op_neg"==r.value&&"node_op"==o.type&&"op_neg"==o.value)return t.children=[r.children[0],o.children[0]],this.mayNotBeSimplified=!0,t;if("op_neg"==r.value&&"op_neg"!=o.value)return t.type="node_op",t.value="op_neg",t.children=[this.createNode("node_op","op_div",r.children[0],o)],this.mayNotBeSimplified=!0,t;if("op_neg"!=r.value&&"op_neg"==o.value)return t.type="node_op",t.value="op_neg",t.children=[this.createNode("node_op","op_div",r,o.children[0])],this.mayNotBeSimplified=!0,t;if("node_op"==r.type&&"op_exp"==r.value&&(o.hash||(o.hash=this.parser.compile(o)),r.children[0].hash||(r.children[0].hash=this.parser.compile(r.children[0])),o.hash===r.children[0].hash))return r.children[1]=this.createNode("node_op","op_sub",r.children[1],this.createNode("node_const",1)),this.mayNotBeSimplified=!0,r;if("node_const"!=o.type&&"node_op"==r.type&&"op_mul"==r.value&&"node_const"==r.children[0].type)return t.value="op_mul",t.children=[r.children[0],this.createNode("node_op","op_div",r.children[1],o)],this.mayNotBeSimplified=!0,t;if("node_op"==r.type&&"op_exp"==r.value&&"node_op"==o.type&&"op_exp"==o.value&&(r.children[0].hash=this.parser.compile(r.children[0]),o.children[0].hash=this.parser.compile(o.children[0]),r.children[0].hash===o.children[0].hash))return r.children[1]=this.createNode("node_op","op_sub",r.children[1],o.children[1]),this.mayNotBeSimplified=!0,r;break;case"op_exp":if(r=t.children[0],"node_const"==(o=t.children[1]).type&&0===o.value)return o.value=1,o;if("node_const"==o.type&&1==o.value)return r;if("node_const"==r.type&&1==r.value)return r;if("node_const"==r.type&&0===r.value&&"node_const"==o.type&&0!==o.value)return r;if("node_op"==r.type&&"op_exp"==r.value)return t.children=[r.children[0],this.createNode("node_op","op_mul",r.children[1],o)],t}switch(t.value){case"op_add":if(r=t.children[0],o=t.children[1],"node_const"==r.type&&"node_const"==o.type&&r.value==o.value)return r.value+=o.value,r;if("node_var"==r.type&&"node_var"==o.type&&r.value==o.value)return t.children[0]=this.createNode("node_const",2),t.value="op_mul",t;if("node_op"==r.type&&"op_neg"==r.value)return t.value="op_sub",t.children[0]=o,t.children[1]=r.children[0],this.mayNotBeSimplified=!0,t;if("node_op"==o.type&&"op_neg"==o.value)return t.value="op_sub",t.children[1]=o.children[0],this.mayNotBeSimplified=!0,t;if("node_op"==r.type&&"op_mul"==r.value&&"node_op"==o.type&&"op_mul"==o.value&&(r.children[1].hash=this.parser.compile(r.children[1]),o.children[1].hash=this.parser.compile(o.children[1]),r.children[1].hash===o.children[1].hash))return t.value="op_mul",t.children=[this.createNode("node_op","op_add",r.children[0],o.children[0]),r.children[1]],this.mayNotBeSimplified=!0,t;if("node_op"==r.type&&"op_mul"==r.value&&(r.children[1].hash=this.parser.compile(r.children[1]),o.hash=this.parser.compile(o),r.children[1].hash===o.hash))return t.value="op_mul",t.children=[this.createNode("node_op","op_add",r.children[0],this.createNode("node_const",1)),o],this.mayNotBeSimplified=!0,t;if("node_op"==o.type&&"op_mul"==o.value&&(o.children[1].hash=this.parser.compile(o.children[1]),r.hash=this.parser.compile(r),o.children[1].hash===r.hash))return t.value="op_mul",t.children=[this.createNode("node_op","op_add",this.createNode("node_const",1),o.children[0]),r],this.mayNotBeSimplified=!0,t;break;case"op_sub":if(r=t.children[0],"node_op"==(o=t.children[1]).type&&"op_neg"==o.value)return t.value="op_add",t.children[1]=o.children[0],this.mayNotBeSimplified=!0,t;break;case"op_execfun":return this.simplifyElementary(t)}return t},simplifyElementary:function(t){var e=t.children[0].value,i=t.children[1];if(0==i.length)return t;switch(e){case"sin":case"tan":if("node_const"==i[0].type&&0===i[0].value)return t.type="node_const",t.value=0,t;if("node_var"==i[0].type&&"PI"==i[0].value)return t.type="node_const",t.value=0,t;if("node_op"==i[0].type&&"op_mul"==i[0].value&&"node_const"==i[0].children[0].type&&i[0].children[0].value%1==0&&"node_var"==i[0].children[1].type&&"PI"==i[0].children[1].value)return t.type="node_const",t.value=0,t;break;case"cos":if("node_const"==i[0].type&&0===i[0].value)return t.type="node_const",t.value=1,t;if("node_var"==i[0].type&&"PI"==i[0].value)return t.type="node_op",t.value="op_neg",t.children=[this.createNode("node_const",1)],t;break;case"exp":if("node_const"==i[0].type&&0===i[0].value)return t.type="node_const",t.value=1,t;break;case"pow":if("node_const"==i[1].type&&0===i[1].value)return t.type="node_const",t.value=1,t}return t}});t.Z.CA;t.Z.Dump={addMarkers:function(t,e,i){var r,o,n;for(r in s.Z.isArray(e)||(e=[e]),s.Z.isArray(i)||(i=[i]),o=Math.min(e.length,i.length),e.length=o,i.length=o,t.objects)if(t.objects.hasOwnProperty(r))for(n=0;n<o;n++)t.objects[r][e[n]]=i[n]},deleteMarkers:function(t,e){var i,r,o;for(i in s.Z.isArray(e)||(e=[e]),r=e.length,e.length=r,t.objects)if(t.objects.hasOwnProperty(i))for(o=0;o<r;o++)delete t.objects[i][e[o]]},str:function(t){return"string"==typeof t&&"function"!==t.substr(0,7)&&(t='"'+t+'"'),t},minimizeObject:function(e,i){var r,o,n,a={},h=s.Z.deepCopy(e),l=[];for(n=1;n<arguments.length;n++)l.push(arguments[n]);for(a=s.Z.deepCopy(a,t.Z.Options.elements,!0),n=l.length;n>0;n--)a=s.Z.deepCopy(a,l[n-1],!0);for(r in a)a.hasOwnProperty(r)&&(o=r.toLowerCase(),"object"!=typeof a[r]&&a[r]===h[o]&&delete h[o]);return h},prepareAttributes:function(e,i){var s,r;for(r in s=this.minimizeObject(i.getAttributes(),t.Z.Options[i.elType]),i.subs)i.subs.hasOwnProperty(r)&&(s[r]=this.minimizeObject(i.subs[r].getAttributes(),t.Z.Options[i.elType][r],t.Z.Options[i.subs[r].elType]),s[r].id=i.subs[r].id,s[r].name=i.subs[r].name);return s.id=i.id,s.name=i.name,s},setBoundingBox:function(t,e,i){return t.push({obj:i,method:"setBoundingBox",params:[e.getBoundingBox(),e.keepaspectratio]}),t},dump:function(t){var e,i,r,o,n=[],a=[],h=t.objectsList.length;for(this.addMarkers(t,"dumped",!1),e=0;e<h;e++)if(r={},!(i=t.objectsList[e]).dumped&&i.dump){for(r.type=i.getType(),r.parents=i.getParents().slice(),"point"===r.type&&1===r.parents[0]&&(r.parents=r.parents.slice(1)),o=0;o<r.parents.length;o++)s.Z.isString(r.parents[o])&&"'"!==r.parents[o][0]&&'"'!==r.parents[o][0]?r.parents[o]='"'+r.parents[o]+'"':s.Z.isArray(r.parents[o])&&(r.parents[o]="["+r.parents[o].toString()+"]");r.attributes=this.prepareAttributes(t,i),"glider"===r.type&&i.onPolygon&&n.push({obj:i.id,prop:"onPolygon",val:!0}),a.push(r)}return this.deleteMarkers(t,"dumped"),{elements:a,props:n,methods:[]}},arrayToParamStr:function(t,e){var i,s=[];for(i=0;i<t.length;i++)s.push(e.call(this,t[i]));return s.join(", ")},toJCAN:function(t){var e,i,r;switch(typeof t){case"object":if(t){if(i=[],s.Z.isArray(t)){for(e=0;e<t.length;e++)i.push(this.toJCAN(t[e]));return"["+i.join(",")+"]"}for(r in t)t.hasOwnProperty(r)&&i.push(r+": "+this.toJCAN(t[r]));return"<<"+i.join(", ")+">> "}return"null";case"string":return"'"+t.replace(/\\/g,"\\\\").replace(/(["'])/g,"\\$1")+"'";case"number":case"boolean":return t.toString();case"null":return"null"}},toJessie:function(t){var e,i,s,r=this.dump(t),o=[];for(r.methods=this.setBoundingBox(r.methods,t,"$board"),i=r.elements,e=0;e<i.length;e++)i[e].attributes.name.length>0&&o.push("// "+i[e].attributes.name),o.push("s"+e+" = "+i[e].type+"("+i[e].parents.join(", ")+") "+this.toJCAN(i[e].attributes).replace(/\n/,"\\n")+";"),"axis"===i[e].type&&(s=i[e].attributes.id,null===t.objects[s].defaultTicks&&o.push("s"+e+".removeAllTicks();")),o.push("");for(e=0;e<r.methods.length;e++)o.push(r.methods[e].obj+"."+r.methods[e].method+"("+this.arrayToParamStr(r.methods[e].params,this.toJCAN)+");"),o.push("");for(e=0;e<r.props.length;e++)o.push(r.props[e].obj+"."+r.props[e].prop+" = "+this.toJCAN(r.props[e].val)+";"),o.push("");return o.join("\n")},toJavaScript:function(t){var e,i,r,o=this.dump(t),n=[];for(o.methods=this.setBoundingBox(o.methods,t,"board"),i=o.elements,e=0;e<i.length;e++)n.push('board.create("'+i[e].type+'", ['+i[e].parents.join(", ")+"], "+s.Z.toJSON(i[e].attributes)+");"),"axis"===i[e].type&&(r=i[e].attributes.id,null===t.objects[r].defaultTicks&&n.push('board.objects["'+r+'"].removeTicks(board.objects["'+r+'"].defaultTicks);'));for(e=0;e<o.methods.length;e++)n.push(o.methods[e].obj+"."+o.methods[e].method+"("+this.arrayToParamStr(o.methods[e].params,s.Z.toJSON)+");"),n.push("");for(e=0;e<o.props.length;e++)n.push(o.props[e].obj+"."+o.props[e].prop+" = "+s.Z.toJSON(o.props[e].val)+";"),n.push("");return n.join("\n")}};t.Z.Dump;t.Z.createComb=function(e,i,r){var o,n,a,h,l;if(2!==i.length)throw l=i.map((function(t){return"'"+typeof t+"'"})),new Error("JSXGraph: Can't create comb with parent types "+l.join(", ")+".\nPossible parent types: [point,point], [[x1,y1],[x2,y2]]");if(s.Z.isArray(i[0])&&i[0].length>1)h=s.Z.copyAttributes(r,e.options,"comb","point1"),o=e.create("point",i[0],h);else if(s.Z.isString(i[0])||s.Z.isPoint(i[0]))o=e.select(i[0]);else if(s.Z.isFunction(i[0])&&s.Z.isPoint(i[0]()))o=i[0]();else{if(!(s.Z.isFunction(i[0])&&i[0]().length&&i[0]().length>=2))throw new Error("JSXGraph: Can't create comb with parent types '"+typeof i[0]+"' and '"+typeof i[1]+"'.\nPossible parent types: [point,point], [[x1,y1],[x2,y2]]");h=s.Z.copyAttributes(r,e.options,"comb","point1"),o=t.Z.createPoint(e,i[0](),h)}if(s.Z.isArray(i[1])&&i[1].length>1)h=s.Z.copyAttributes(r,e.options,"comb","point2"),n=e.create("point",i[1],h);else if(s.Z.isString(i[1])||s.Z.isPoint(i[1]))n=e.select(i[1]);else if(s.Z.isFunction(i[1])&&s.Z.isPoint(i[1]()))n=i[1]();else{if(!(s.Z.isFunction(i[1])&&i[1]().length&&i[1]().length>=2))throw new Error("JSXGraph: Can't create comb with parent types '"+typeof i[0]+"' and '"+typeof i[1]+"'.\nPossible parent types: [point,point], [[x1,y1],[x2,y2]]");h=s.Z.copyAttributes(r,e.options,"comb","point2"),n=t.Z.createPoint(e,i[1](),h)}return h=s.Z.copyAttributes(r,e.options,"comb"),s.Z.merge(h,s.Z.copyAttributes(r,e.options,"comb","curve")),(a=e.create("curve",[[0],[0]],h)).updateDataArray=function(){var t,e,i,r,h,l,c,d,u,p,_=0,f=o.Dist(n),b=o,g=n;for(d=s.Z.evaluate(a.visProp.frequency),u=-s.Z.evaluate(a.visProp.angle),p=s.Z.evaluate(a.visProp.width),s.Z.evaluate(a.visProp.reverse)&&(b=n,g=o,u=-u),t=Math.cos(u),e=Math.sin(u),i=(g.X()-b.X())/f,r=(g.Y()-b.Y())/f,t*=p/Math.abs(e),e*=p/Math.abs(e),this.dataX=[],this.dataY=[];_<f;)h=b.X()+i*_,l=b.Y()+r*_,e*=c=Math.min(t,f-_)/Math.abs(t),t*=c,this.dataX.push(h),this.dataY.push(l),this.dataX.push(h+i*t+r*e),this.dataY.push(l-i*e+r*t),this.dataX.push(NaN),this.dataY.push(NaN),_+=d},a},t.Z.registerElement("comb",t.Z.createComb);var K=function(){V.prototype.remove.call(this),this.board.removeObject(this.toppoint),this.board.removeObject(this.glider),this.board.removeObject(this.baseline),this.board.removeObject(this.basepoint),this.board.removeObject(this.label),this._isPrivateTangent&&this.board.removeObject(this.tangent)},q=function(){return this.tangent.getSlope()};t.Z.createSlopeTriangle=function(e,r,o){var n,a,h,l,c,d,u,p,_,f=!1;if(1===r.length&&r[0].type===i.Z.OBJECT_TYPE_TANGENT)a=r[0],h=a.glider;else if(1===r.length&&r[0].type===i.Z.OBJECT_TYPE_GLIDER)h=r[0],_=s.Z.copyAttributes(o,e.options,"slopetriangle","tangent"),a=e.create("tangent",[h],_),f=!0;else{if(2!==r.length||r[0].elementClass!==i.Z.OBJECT_CLASS_LINE||!s.Z.isPoint(r[1]))throw new Error("JSXGraph: Can't create slope triangle with parent types '"+typeof r[0]+"'.");a=r[0],h=r[1]}return _=s.Z.copyAttributes(o,e.options,"slopetriangle","basepoint"),u=e.create("point",[function(){return[h.X()+1,h.Y()]}],_),_=s.Z.copyAttributes(o,e.options,"slopetriangle","baseline"),d=e.create("line",[h,u],_),_=s.Z.copyAttributes(o,e.options,"slopetriangle","glider"),l=e.create("glider",[h.X()+1,h.Y(),d],_),_=s.Z.copyAttributes(o,e.options,"slopetriangle","toppoint"),c=e.create("point",[function(){return[l.X(),l.Y()+(l.X()-h.X())*a.getSlope()]}],_),(_=s.Z.copyAttributes(o,e.options,"slopetriangle")).borders=s.Z.copyAttributes(_.borders,e.options,"slopetriangle","borders"),(n=e.create("polygon",[h,l,c],_)).Value=q,n.tangent=a,n._isPrivateTangent=f,n.borders[2].setArrow(!1,!1),_=s.Z.copyAttributes(o,e.options,"slopetriangle","label"),(p=e.create("text",[function(){return l.X()+.1},function(){return.5*(l.Y()+c.Y())},function(){return""}],_))._setText((function(){return s.Z.toFixed(n.Value(),s.Z.evaluate(p.visProp.digits))})),p.fullUpdate(),n.glider=l,n.basepoint=u,n.baseline=d,n.toppoint=c,n.label=p,n.subs={glider:l,basePoint:u,baseLine:d,topPoint:c,label:p},n.inherits.push(l,u,d,c,p),n.methodMap=t.Z.deepCopy(n.methodMap,{tangent:"tangent",glider:"glider",basepoint:"basepoint",baseline:"baseline",toppoint:"toppoint",label:"label",Value:"Value",V:"Value"}),n.remove=K,n},t.Z.registerElement("slopetriangle",t.Z.createSlopeTriangle);var Q=function(){this._value=this.rendNodeCheckbox.checked,this.board.update()};t.Z.createCheckbox=function(i,r,o){var n,a,h=s.Z.copyAttributes(o,i.options,"checkbox");return a=[r[0],r[1],'<span style="display:inline"><input type="checkbox" /><label for=""></label></span>'],(n=i.create("text",a,h)).type=s.Z.OBJECT_TYPE_CHECKBOX,n.rendNodeCheckbox=n.rendNode.childNodes[0].childNodes[0],n.rendNodeLabel=n.rendNode.childNodes[0].childNodes[1],n.rendNodeTag=n.rendNodeCheckbox,n.rendNodeTag.disabled=!!h.disabled,n.rendNodeCheckbox.id=n.rendNode.id+"_checkbox",n.rendNodeLabel.id=n.rendNode.id+"_label",n.rendNodeLabel.setAttribute("for",n.rendNodeCheckbox.id),n.setText(r[2]),n.visPropOld.fontsize="0px",i.renderer.updateTextStyle(n,!1),n.rendNodeCheckbox.checked=h.checked,n._value=h.checked,n.Value=function(){return this._value},n.update=function(){return this.needsUpdate&&(t.Z.Text.prototype.update.call(this),this._value=this.rendNodeCheckbox.checked),this},e.Z.addEvent(n.rendNodeCheckbox,"change",Q,n),n},t.Z.registerElement("checkbox",t.Z.createCheckbox);var tt=function(t){this._value=this.rendNodeInput.value,this.board.update()};t.Z.createInput=function(i,r,o){var n,a,h=s.Z.copyAttributes(o,i.options,"input");return a=[r[0],r[1],'<span style="display:inline; white-space:nowrap; padding:0px;"><span></span><input type="text" maxlength="'+h.maxlength+'" style="width:100%"/></span>'],(n=i.create("text",a,h)).type=s.Z.OBJECT_TYPE_INPUT,n.rendNodeLabel=n.rendNode.childNodes[0].childNodes[0],n.rendNodeInput=n.rendNode.childNodes[0].childNodes[1],n.rendNodeInput.value=r[2],n.rendNodeTag=n.rendNodeInput,n.rendNodeTag.disabled=!!h.disabled,n.rendNodeLabel.id=n.rendNode.id+"_label",n.rendNodeInput.id=n.rendNode.id+"_input",n.setText(r[3]),n._value=r[2],n.update=function(){return this.needsUpdate&&(t.Z.Text.prototype.update.call(this),this._value=this.rendNodeInput.value),this},n.Value=function(){return this._value},n.set=function(t){return this._value=t,this.rendNodeInput.value=t,this},e.Z.addEvent(n.rendNodeInput,"input",tt,n),e.Z.addEvent(n.rendNodeInput,"mousedown",(function(t){s.Z.exists(t.stopPropagation)&&t.stopPropagation()}),n),e.Z.addEvent(n.rendNodeInput,"touchstart",(function(t){s.Z.exists(t.stopPropagation)&&t.stopPropagation()}),n),e.Z.addEvent(n.rendNodeInput,"pointerdown",(function(t){s.Z.exists(t.stopPropagation)&&t.stopPropagation()}),n),n.visPropOld.fontsize="0px",i.renderer.updateTextStyle(n,!1),n},t.Z.registerElement("input",t.Z.createInput);var et=function(){this._handler&&this._handler(),this.board.update()};t.Z.createButton=function(i,r,o){var n,a,h=s.Z.copyAttributes(o,i.options,"button");return a=[r[0],r[1],'<button type="button" style="width:100%;"></button>'],(n=i.create("text",a,h)).type=s.Z.OBJECT_TYPE_BUTTON,n.rendNodeButton=n.rendNode.childNodes[0],n.rendNodeButton.id=n.rendNode.id+"_button",n.rendNodeTag=n.rendNodeButton,n.rendNodeTag.disabled=!!h.disabled,n.setText(r[2]),n.visPropOld.fontsize="0px",i.renderer.updateTextStyle(n,!1),r[3]&&(s.Z.isString(r[3])?(n._jc=new t.Z.JessieCode,n._jc.use(i),n._handler=function(){n._jc.parse(r[3])}):n._handler=r[3]),e.Z.addEvent(n.rendNodeButton,"click",et,n),e.Z.addEvent(n.rendNodeButton,"mousedown",(function(t){s.Z.exists(t.stopPropagation)&&t.stopPropagation()}),n),e.Z.addEvent(n.rendNodeButton,"touchstart",(function(t){s.Z.exists(t.stopPropagation)&&t.stopPropagation()}),n),e.Z.addEvent(n.rendNodeButton,"pointerdown",(function(t){s.Z.exists(t.stopPropagation)&&t.stopPropagation()}),n),n},t.Z.registerElement("button",t.Z.createButton),t.Z.ForeignObject=function(e,r,o,n,a){this.constructor(e,o,i.Z.OBJECT_TYPE_FOREIGNOBJECT,i.Z.OBJECT_CLASS_OTHER),this.element=this.board.select(o.anchor),this.coordsConstructor(r),this._useUserSize=!1,this.size=[1,1],s.Z.exists(a)&&a.length>0&&(this._useUserSize=!0,this.W=s.Z.createFunction(a[0],this.board,""),this.H=s.Z.createFunction(a[1],this.board,""),this.addParentsFromJCFunctions([this.W,this.H]),this.usrSize=[this.W(),this.H()]),this.content=n,this.elType="foreignobject",this.id=this.board.setId(this,"Im"),this.board.renderer.drawForeignObject(this),this.board.finalizeAdding(this),this.methodMap=t.Z.deepCopy(this.methodMap,{addTransformation:"addTransform",trans:"addTransform"})},t.Z.ForeignObject.prototype=new G.Z,s.Z.copyPrototypeMethods(t.Z.ForeignObject,z.Z,"coordsConstructor"),t.Z.extend(t.Z.ForeignObject.prototype,{hasPoint:function(t,e){var r,n,a,h,l,d,u,p,_,f=this.transformations.length;return s.Z.isObject(s.Z.evaluate(this.visProp.precision))?(h=this.board._inputDevice,l=s.Z.evaluate(this.visProp.precision[h])):l=this.board.options.precision.hasPoint,0===f?(r=t-this.coords.scrCoords[1],n=this.coords.scrCoords[2]-e,r>=-(a=l)&&r-this.size[0]<=a&&n>=-a&&n-this.size[1]<=a):(u=[(d=(d=new c.Z(i.Z.COORDS_BY_SCREEN,[t,e],this.board)).usrCoords)[0]-this.span[0][0],d[1]-this.span[0][1],d[2]-this.span[0][2]],0<=(p=(_=o.Z.innerProduct)(u,this.span[1]))&&p<=_(this.span[1],this.span[1])&&0<=(p=_(u,this.span[2]))&&p<=_(this.span[2],this.span[2]))},update:function(t){return this.needsUpdate?(this.updateCoords(t),this.updateSize(),this):this},updateRenderer:function(){return this.updateRendererGeneric("updateForeignObject")},updateSize:function(){var t=[0,0];return this._useUserSize?(this.usrSize=[this.W(),this.H()],this.size=[Math.abs(this.usrSize[0]*this.board.unitX),Math.abs(this.usrSize[1]*this.board.unitY)]):this.rendNode.hasChildNodes()&&(t=this.rendNode.childNodes[0].getBoundingClientRect(),this.size=[t.width,t.height]),this},updateSpan:function(){var t,e,i=this.transformations.length,s=[];if(0===i)this.span=[[this.Z(),this.X(),this.Y()],[this.Z(),this.W(),0],[this.Z(),0,this.H()]];else{for(s[0]=[this.Z(),this.X(),this.Y()],s[1]=[this.Z(),this.X()+this.W(),this.Y()],s[2]=[this.Z(),this.X(),this.Y()+this.H()],t=0;t<i;t++)for(e=0;e<3;e++)s[e]=o.Z.matVecMult(this.transformations[t].matrix,s[e]);for(e=0;e<3;e++)s[e][1]/=s[e][0],s[e][2]/=s[e][0],s[e][0]/=s[e][0];for(e=1;e<3;e++)s[e][0]-=s[0][0],s[e][1]-=s[0][1],s[e][2]-=s[0][2];this.span=s}return this},addTransform:function(t){var e;if(s.Z.isArray(t))for(e=0;e<t.length;e++)this.transformations.push(t[e]);else this.transformations.push(t);return this},getParents:function(){var t=[this.url,[this.Z(),this.X(),this.Y()],this.usrSize];return 0!==this.parents.length&&(t=this.parents),t},setSize:function(t,e){return this.W=s.Z.createFunction(t,this.board,""),this.H=s.Z.createFunction(e,this.board,""),this._useUserSize=!0,this.addParentsFromJCFunctions([this.W,this.H]),this},W:function(){},H:function(){}}),t.Z.createForeignObject=function(e,i,r){var o,n,a=i[0],h=i[1],l=[];if(i.length>=2&&(l=i[2]),o=s.Z.copyAttributes(r,e.options,"foreignobject"),!(n=z.Z.create(t.Z.ForeignObject,e,h,o,a,l)))throw new Error("JSXGraph: Can't create foreignObject with parent types '"+typeof i[0]+"' and '"+typeof i[1]+"'.\nPossible parent types: [string, [x, y], [w, h]], [string, [x, y]], [element,transformation]");return n},t.Z.registerElement("foreignobject",t.Z.createForeignObject),t.Z.registerElement("fo",t.Z.createForeignObject);t.Z.ForeignObject;t.Z.extend(N.Z,{axes3d:{axesPosition:"center",xAxis:{visible:!0,point2:{name:"x"}},yAxis:{visible:!0,point2:{name:"y"}},zAxis:{visible:!0,point2:{name:"z"}},xPlaneRear:{visible:!0,layer:0,mesh3d:{layer:1}},yPlaneRear:{visible:!0,layer:0,mesh3d:{layer:1}},zPlaneRear:{visible:!0,layer:0,mesh3d:{layer:1}},xPlaneFront:{visible:!1,layer:0,mesh3d:{layer:1}},yPlaneFront:{visible:!1,layer:0,mesh3d:{layer:1}},zPlaneFront:{visible:!1,layer:0,mesh3d:{layer:1}},xPlaneRearYAxis:{visible:"inherit",strokeColor:"#888888",strokeWidth:1},xPlaneRearZAxis:{visible:"inherit",strokeColor:"#888888",strokeWidth:1},xPlaneFrontYAxis:{visible:"inherit",strokeColor:"#888888",strokeWidth:1},xPlaneFrontZAxis:{visible:"inherit",strokeColor:"#888888",strokeWidth:1},yPlaneRearXAxis:{visible:"inherit",strokeColor:"#888888",strokeWidth:1},yPlaneRearZAxis:{visible:"inherit",strokeColor:"#888888",strokeWidth:1},yPlaneFrontXAxis:{visible:"inherit",strokeColor:"#888888",strokeWidth:1},yPlaneFrontZAxis:{visible:"inherit",strokeColor:"#888888",strokeWidth:1},zPlaneRearXAxis:{visible:"inherit",strokeColor:"#888888",strokeWidth:1},zPlaneRearYAxis:{visible:"inherit",strokeColor:"#888888",strokeWidth:1},zPlaneFrontXAxis:{visible:"inherit",strokeColor:"#888888",strokeWidth:1},zPlaneFrontYAxis:{visible:"inherit",strokeColor:"#888888",strokeWidth:1}},axis3d:{highlight:!1,strokecolor:"black",strokeWidth:1,tabindex:null,point1:{visible:!1,name:""},point2:{visible:!1,name:"",label:{visible:!0}}},curve3d:{highlight:!1,tabindex:-1,strokeWidth:1,numberPointsHigh:200},mesh3d:{strokeWidth:1,strokeColor:"#9a9a9a",strokeOpacity:.6,highlight:!1,fillColor:"#9a9a9a",fillOpacity:.1,tabindex:null,visible:"inherit"},line3d:{strokeWidth:1,strokeColor:"black",fixed:!0,tabindex:null,gradient:"linear",gradientSecondColor:"#ffffff",point:{visible:!1,name:""},point1:{visible:!1,name:""},point2:{visible:!1,name:""}},plane3d:{strokeWidth:0,strokeColor:"black",strokeOpacity:1,highlight:!1,tabindex:null,gradient:"linear",gradientSecondColor:"#ffffff",gradientAngle:Math.PI,fillColor:"#a7a7a7",fillOpacity:.6,point:{visible:!1,name:"",fixed:!0}},point3d:{infoboxDigits:"auto",strokeWidth:0,gradient:"radial",gradientSecondColor:"#555555",fillColor:"yellow",highlightStrokeColor:"#555555"},surface3d:{highlight:!1,tabindex:-1,strokeWidth:1,stepsU:30,stepsV:30},view3d:{needsRegularUpdate:!0}});t.Z.Options;t.Z.View3D=function(t,e,r){this.constructor(t,r,i.Z.OBJECT_TYPE_VIEW3D,i.Z.OBJECT_CLASS_3D),this.objects={},this.objectsList=[],this.elementsByName={},this.defaultAxes=null,this.matrix3D=[[1,0,0,0],[0,1,0,0],[0,0,1,0]],this.llftCorner=e[0],this.size=e[1],this.bbox3D=e[2],this.r=-1,this.timeoutAzimuth=null,this.id=this.board.setId(this,"V"),this.board.finalizeAdding(this),this.elType="view3d",this.methodMap=s.Z.deepCopy(this.methodMap,{})},t.Z.View3D.prototype=new G.Z,t.Z.extend(t.Z.View3D.prototype,{create:function(t,e,i){var s=[];return t.indexOf("3d")>0&&(!0,s.push(this)),this.board.create(t,s.concat(e),i)},select:function(t,e){var i,r,o,n,a=t;if(null===a)return a;if(s.Z.isString(a)&&""!==a)s.Z.exists(this.objects[a])?a=this.objects[a]:s.Z.exists(this.elementsByName[a])&&(a=this.elementsByName[a]);else if(!e&&(s.Z.isFunction(a)||s.Z.isObject(a)&&!s.Z.isFunction(a.setAttribute))){for(r={},n=(i=s.Z.filterElements(this.objectsList,a)).length,o=0;o<n;o++)r[i[o].id]=i[o];a=new B(r)}else s.Z.isObject(a)&&s.Z.exists(a.id)&&!s.Z.exists(this.objects[a.id])&&(a=null);return a},update:function(){var t,e,i,r,n;return s.Z.exists(this.el_slide)&&s.Z.exists(this.az_slide)&&this.needsUpdate?(t=this.el_slide.Value(),e=this.r,i=this.az_slide.Value(),r=e*Math.sin(t),n=[[1,0,0],[0,1,0],[0,0,1]],this.matrix3D=[[1,0,0,0],[0,1,0,0],[0,0,1,0]],this.matrix3D[1][1]=e*Math.cos(i),this.matrix3D[1][2]=-e*Math.sin(i),this.matrix3D[2][1]=r*Math.sin(i),this.matrix3D[2][2]=r*Math.cos(i),this.matrix3D[2][3]=Math.cos(t),n[1][1]=this.size[0]/(this.bbox3D[0][1]-this.bbox3D[0][0]),n[2][2]=this.size[1]/(this.bbox3D[1][1]-this.bbox3D[1][0]),n[1][0]=this.llftCorner[0]-n[1][1]*this.bbox3D[0][0],n[2][0]=this.llftCorner[1]-n[2][2]*this.bbox3D[1][0],this.matrix3D=o.Z.matMatMult(n,this.matrix3D),this):this},updateRenderer:function(){return this.needsUpdate=!1,this},project3DTo2D:function(t,e,i){var s;return s=3===arguments.length?[1,t,e,i]:3===t.length?[1].concat(t):t,o.Z.matVecMult(this.matrix3D,s)},project2DTo3DPlane:function(t,e,i){var s,r,n,a,h=e.slice(1),l=[1,0,0,0];i=i||[1,0,0,0],a=o.Z.norm(h,3),n=o.Z.innerProduct(i.slice(1),h,3)/a,(s=this.matrix3D.slice(0,3)).push([0].concat(h)),r=t.coords.usrCoords.concat([n]);try{1===s[2][3]&&(s[2][1]=s[2][2]=.001*o.Z.eps),l=o.Z.Numerics.Gauss(s,r)}catch(t){l=[0,NaN,NaN,NaN]}return l},project3DToCube:function(t){var e=this.bbox3D;return t[1]<e[0][0]&&(t[1]=e[0][0]),t[1]>e[0][1]&&(t[1]=e[0][1]),t[2]<e[1][0]&&(t[2]=e[1][0]),t[2]>e[1][1]&&(t[2]=e[1][1]),t[3]<e[2][0]&&(t[3]=e[2][0]),t[3]>e[2][1]&&(t[3]=e[2][1]),t},intersectionLineCube:function(t,e,i){var s,r,o,n;for(s=i,r=0;r<3;r++)0!==e[r]&&(o=(this.bbox3D[r][0]-t[r])/e[r],n=(this.bbox3D[r][1]-t[r])/e[r],s=i<0?Math.max(s,Math.min(o,n)):Math.min(s,Math.max(o,n)));return s},isInCube:function(t){return t[0]>this.bbox3D[0][0]-o.Z.eps&&t[0]<this.bbox3D[0][1]+o.Z.eps&&t[1]>this.bbox3D[1][0]-o.Z.eps&&t[1]<this.bbox3D[1][1]+o.Z.eps&&t[2]>this.bbox3D[2][0]-o.Z.eps&&t[2]<this.bbox3D[2][1]+o.Z.eps},intersectionPlanePlane:function(t,e,i){var s,r,n,a,h=[[],[]];return i=i||e.d,s=o.Z.Geometry.meet3Planes(t.normal,t.d,e.normal,i,o.Z.crossProduct(t.normal,e.normal),0),r=o.Z.Geometry.meetPlanePlane(t.vec1,t.vec2,e.vec1,e.vec2),n=this.intersectionLineCube(s,r,1/0),a=o.Z.axpy(n,r,s),this.isInCube(a)&&(h[0]=a),n=this.intersectionLineCube(s,r,-1/0),a=o.Z.axpy(n,r,s),this.isInCube(a)&&(h[1]=a),h},getMesh:function(t,e,i){var r,o,n,a,h,l,c,d=[0,0,0],u=e[2],p=i[2],_=[],f=[];for(l=(s.Z.evaluate(e[1])-s.Z.evaluate(e[0]))/u,c=(s.Z.evaluate(i[1])-s.Z.evaluate(i[0]))/p,r=0;r<=u;r++){for(n=e[0]+l*r,o=0;o<=p;o++)a=i[0]+c*o,d=s.Z.isFunction(t)?t(n,a):[t[0](n,a),t[1](n,a),t[2](n,a)],h=this.project3DTo2D(d),_.push(h[1]),f.push(h[2]);_.push(NaN),f.push(NaN)}for(o=0;o<=p;o++){for(a=i[0]+c*o,r=0;r<=u;r++)n=e[0]+l*r,d=s.Z.isFunction(t)?t(n,a):[t[0](n,a),t[1](n,a),t[2](n,a)],h=this.project3DTo2D(d),_.push(h[1]),f.push(h[2]);_.push(NaN),f.push(NaN)}return[_,f]},animateAzimuth:function(){var t=this.az_slide._smin,e=this.az_slide._smax-t,i=this.az_slide.Value()+.1;this.az_slide.position=(i-t)/e,this.az_slide.position>1&&(this.az_slide.position=0),this.board.update(),this.timeoutAzimuth=setTimeout(function(){this.animateAzimuth()}.bind(this),200)},stopAzimuth:function(){clearTimeout(this.timeoutAzimuth),this.timeoutAzimuth=null}}),t.Z.createView3D=function(e,i,r){var o,n,a,h,l,c,d=i[0],u=i[1];return n=s.Z.copyAttributes(r,e.options,"view3d"),(o=new t.Z.View3D(e,i,n)).defaultAxes=o.create("axes3d",i,r),a=d[0],h=d[1],l=u[0],c=u[1],o.az_slide=e.create("slider",[[a-1,h-2],[a+l+1,h-2],[0,1,2*Math.PI]],{style:6,name:"az",point1:{frozen:!0},point2:{frozen:!0}}),o.el_slide=e.create("slider",[[a-1,h],[a-1,h+c],[0,.3,Math.PI/2]],{style:6,name:"el",point1:{frozen:!0},point2:{frozen:!0}}),o.board.highlightInfobox=function(t,e,i){var r,n,a,h,l=i.board,c=null;for(n=0;n<i.parents.length&&!(c=l.objects[i.parents[n]]).is3D;n++);if(c){if(h=[1,0,0,c.coords[3]],a=o.project2DTo3DPlane(c.element2D,[1,0,0,1],h),!o.isInCube(a))return void o.board.highlightCustomInfobox("",c);"auto"===(r=s.Z.evaluate(c.visProp.infoboxdigits))?o.board.highlightCustomInfobox("("+s.Z.autoDigits(c.X())+" | "+s.Z.autoDigits(c.Y())+" | "+s.Z.autoDigits(c.Z())+")",c):o.board.highlightCustomInfobox("("+s.Z.toFixed(c.X(),r)+" | "+s.Z.toFixed(c.Y(),r)+" | "+s.Z.toFixed(c.Z(),r)+")",c)}else o.board.highlightCustomInfobox("("+t+", "+e+")",i)},o.board.update(),o},t.Z.registerElement("view3d",t.Z.createView3D);t.Z.View3D;t.Z.GeometryElement3D=function(t,e){this.elType=e,this.id=this.board.setId(this,e),this.view=t,this.element2D=null,this.is3D=!0,this.view.objects[this.id]=this,this.view.objectsList.push(this),""!==this.name&&(this.view.elementsByName[this.name]=this)};t.Z.GeometryElement3D;t.Z.createAxes3D=function(t,e,i){var r,o,n,a,h,l,c,d,u,p,_,f,b,g,m,v,Z,C=e[0],y=["x","y","z"],P="Axis",E=["Rear","Front"],O=[0,0,0],x=[0,0,0],w={};if(s.Z.exists(C.bbox3D))for(r=0;r<y.length;r++)O[r]=C.bbox3D[r][0],x[r]=C.bbox3D[r][1];else for(r=0;r<y.length;r++)O[r]=e[1][r],x[r]=e[2][1];for(c=(l=s.Z.copyAttributes(i,t.options,"axes3d")).axesposition,r=0;r<y.length;r++)m=(d=y[r])+P,"center"===c?(u=[0,0,0],(p=[0,0,0])[r]=x[r],w[m]=C.create("axis3d",[u,p],l[m.toLowerCase()])):(m+="Border",u=O.slice(),p=x.slice(),2===r?(u[1]=x[1],p[0]=O[0]):(u[r]=x[r],p[2]=O[2]),p[r]=x[r],l[m.toLowerCase()].lastArrow=!1,w[m]=C.create("axis3d",[u,p],l[m.toLowerCase()]),Z={visible:!0,minorTicks:0,tickEndings:[0,1],drawLabels:!1},2===r&&(Z.tickEndings=[1,0]),w[m+"Ticks"]=C.create("ticks",[w[m],1],Z));for(w.O=C.create("intersection",[w[y[0]+P],w[y[1]+P]],{name:"",visible:!1,withLabel:!1}),r=0;r<y.length;r++)for(a=(r+1)%3,h=(r+2)%3,d=y[r],o=0;o<E.length;o++)(u=[0,0,0])[r]=0===o?O[r]:x[r],f=[0,0,0],(_=[0,0,0])[a]=1,f[h]=1,b=[O[a],x[a]],g=[O[h],x[h]],m=d+"Plane"+E[o],l=s.Z.copyAttributes(i,t.options,"axes3d",m),w[m]=C.create("plane3d",[u,_,f,b,g],l),w[m].elType="axisplane3d";for(r=0;r<y.length;r++)for(d=y[r],o=0;o<E.length;o++)for(n=1;n<=2;n++)m=d+"Plane"+E[o]+y[a=(r+n)%3].toUpperCase()+"Axis",v=d+"Plane"+E[o],(u=[0,0,0])[r]=(p=[0,0,0])[r]=0===o?O[r]:x[r],u[a]=O[a],p[a]=x[a],l=s.Z.copyAttributes(i,t.options,"axes3d",m),w[m]=C.create("axis3d",[u,p],l),w[v].addChild(w[m]),w[v].element2D.inherits.push(w[m]);return w},t.Z.registerElement("axes3d",t.Z.createAxes3D),t.Z.createAxis3D=function(t,e,i){var r,o,n,a,h,l,c=e[0],d=e[1],u=e[2];return r=s.Z.copyAttributes(i.point1,t.options,"axis3d","point1"),o=c.create("point",[(a=d[0],h=d[1],l=d[2],function(){return c.project3DTo2D(a,h,l)[1]}),function(t,e,i){return function(){return c.project3DTo2D(t,e,i)[2]}}(d[0],d[1],d[2])],r),r=s.Z.copyAttributes(i.point2,t.options,"axis3d","point2"),n=c.create("point",[function(t,e,i){return function(){return c.project3DTo2D(t,e,i)[1]}}(u[0],u[1],u[2]),function(t,e,i){return function(){return c.project3DTo2D(t,e,i)[2]}}(u[0],u[1],u[2])],r),r=s.Z.copyAttributes(i,t.options,"axis3d"),c.create("arrow",[o,n],r)},t.Z.registerElement("axis3d",t.Z.createAxis3D),t.Z.createMesh3D=function(e,i,r){var o,n=i[0],a=i[1],h=i[2],l=i[3],c=i[4],d=i[5];return(o=n.create("curve",[[],[]],r)).updateDataArray=function(){var e,i,r,o,u=l[0],p=l[1],_=d[0],f=d[1],b=[0,0,0],g=[0,0,0],m=[0,0,0];if(this.dataX=[],this.dataY=[],s.Z.isFunction(a))m=a().slice(1);else for(o=0;o<3;o++)m[o]=s.Z.evaluate(a[o]);for(o=0;o<3;o++)b[o]=s.Z.evaluate(h[o]),g[o]=s.Z.evaluate(c[o]);for(e=t.Z.Math.norm(b,3),i=t.Z.Math.norm(g,3),o=0;o<3;o++)b[o]/=e,g[o]/=i;r=n.getMesh([function(t,e){return m[0]+t*b[0]+e*g[0]},function(t,e){return m[1]+t*b[1]+e*g[1]},function(t,e){return m[2]+t*b[2]+e*g[2]}],[Math.ceil(u),Math.floor(p),(Math.ceil(p)-Math.floor(u))/1],[Math.ceil(_),Math.floor(f),(Math.ceil(f)-Math.floor(_))/1]),this.dataX=r[0],this.dataY=r[1]},o},t.Z.registerElement("mesh3d",t.Z.createMesh3D),t.Z.Point3D=function(t,e,r,o){this.constructor(t.board,o,i.Z.OBJECT_TYPE_POINT3D,i.Z.OBJECT_CLASS_3D),this.constructor3D(t,"point3d"),this.id=this.view.board.setId(this,"P3D"),this.board.finalizeAdding(this),this.coords=[0,0,0,0],this.F=e,this.slide=r,this.X=function(){return this.coords[1]},this.Y=function(){return this.coords[2]},this.Z=function(){return this.coords[3]},this._params=null,this._c2d=null,this.methodMap=s.Z.deepCopy(this.methodMap,{})},t.Z.Point3D.prototype=new t.Z.GeometryElement,s.Z.copyPrototypeMethods(t.Z.Point3D,t.Z.GeometryElement3D,"constructor3D"),t.Z.extend(t.Z.Point3D.prototype,{updateCoords:function(){var t;if(s.Z.isFunction(this.F))this.coords=[1].concat(s.Z.evaluate(this.F));else for(this.coords[0]=1,t=0;t<3;t++)s.Z.isFunction(this.F[t])&&(this.coords[t+1]=s.Z.evaluate(this.F[t]));return this},initCoords:function(){var t;if(s.Z.isFunction(this.F))this.coords=[1].concat(s.Z.evaluate(this.F));else for(this.coords[0]=1,t=0;t<3;t++)this.coords[t+1]=s.Z.evaluate(this.F[t]);return this},normalizeCoords:function(){return Math.abs(this.coords[0])>o.Z.eps&&(this.coords[1]/=this.coords[0],this.coords[2]/=this.coords[0],this.coords[3]/=this.coords[0],this.coords[0]=1),this},setPosition:function(t,e){var i=this.coords;this.coords.slice();return 3===t.length?(i[0]=1,i[1]=t[0],i[2]=t[1],i[3]=t[2]):(i[0]=t[0],i[1]=t[1],i[2]=t[2],i[3]=t[2],this.normalizeCoords()),this},update:function(t){var e,s;return this.element2D.draggable()&&0!==u.Z.distance(this._c2d,this.element2D.coords.usrCoords)?this.slide?this.projectCoords2Surface():(s=[1,0,0,this.coords[3]],0!==(e=this.view.project2DTo3DPlane(this.element2D,[1,0,0,1],s))[0]&&(this.coords=this.view.project3DToCube(e))):(this.updateCoords(),this.element2D.coords.setCoordinates(i.Z.COORDS_BY_USER,this.view.project3DTo2D([1,this.X(),this.Y(),this.Z()]))),this._c2d=this.element2D.coords.usrCoords.slice(),this},updateRenderer:function(){return this.needsUpdate=!1,this},projectCoords2Surface:function(){var t,e,r,n=[0,0],a=this.slide,h=this;null!==a&&(r=function(t,e,i,s){var r=[1,a.X(i[0],i[1]),a.Y(i[0],i[1]),a.Z(i[0],i[1])],o=h.view.project3DTo2D(r);return s[0]=h.element2D.X()-o[1],s[1]=h.element2D.Y()-o[2],s[0]*s[0]+s[1]*s[1]},s.Z.exists(this._params)&&(n=this._params.slice()),o.Z.Nlp.FindMinimum(r,2,2,n,5,1e-6,0,200),t=[1,a.X(n[0],n[1]),a.Y(n[0],n[1]),a.Z(n[0],n[1])],e=this.view.project3DTo2D(t),this._params=n,this.coords=t,this.element2D.coords.setCoordinates(i.Z.COORDS_BY_USER,e),this._c2d=e)},__evt__update3D:function(t){}}),t.Z.createPoint3D=function(e,i,r){var o,n,a,h,l,c=i[0];if(a=i.length>2&&s.Z.exists(i[i.length-1].is3D)?i.pop():null,2===i.length)n=i[1];else{if(4!==i.length)throw new Error("JSXGraph: Can't create point3d with parent types '"+typeof i[0]+"' and '"+typeof i[1]+"'.\nPossible parent types: [[x,y,z]], [x,y,z]");n=i.slice(1)}return o=s.Z.copyAttributes(r,e.options,"point3d"),(l=new t.Z.Point3D(c,n,a,o)).initCoords(),h=c.project3DTo2D(l.coords),o.name=l.name,l.element2D=c.create("point",h,o),l.addChild(l.element2D),l.inherits.push(l.element2D),l.element2D.setParents(l),l._c2d=l.element2D.coords.usrCoords.slice(),l},t.Z.registerElement("point3d",t.Z.createPoint3D),t.Z.Curve3D=function(t,e,r,o,n,a,h){this.constructor(t.board,h,i.Z.OBJECT_TYPE_CURVE3D,i.Z.OBJECT_CLASS_3D),this.constructor3D(t,"surface3d"),this.id=this.view.board.setId(this,"S3D"),this.board.finalizeAdding(this),this.F=e,this.X=r,this.Y=o,this.Z=n,null!==this.F&&(this.X=function(t){return this.F(t)[0]},this.Y=function(t){return this.F(t)[1]},this.Z=function(t){return this.F(t)[2]}),this.range=a,this.methodMap=s.Z.deepCopy(this.methodMap,{})},t.Z.Curve3D.prototype=new t.Z.GeometryElement,s.Z.copyPrototypeMethods(t.Z.Curve3D,t.Z.GeometryElement3D,"constructor3D"),t.Z.extend(t.Z.Curve3D.prototype,{updateDataArray:function(){var t,e,i,r,o,n,a,h,l=s.Z.evaluate(this.visProp.numberpointshigh),c=[0,0,0];if(a=[],h=[],s.Z.isArray(this.X))for(l=this.X.length,n=0;n<l;n++)c=[this.X[n],this.Y[n],this.Z[n]],o=this.view.project3DTo2D(c),a.push(o[1]),h.push(o[2]);else for(t=s.Z.evaluate(this.range),e=s.Z.evaluate(t[0]),r=((i=s.Z.evaluate(t[1]))-e)/(l-1),n=e;n<=i;n+=r)c=null!==this.F?this.F(n):[this.X(n),this.Y(n),this.Z(n)],o=this.view.project3DTo2D(c),a.push(o[1]),h.push(o[2]);return{X:a,Y:h}},update:function(){return this},updateRenderer:function(){return this.needsUpdate=!1,this}}),t.Z.createCurve3D=function(e,i,r){var o,n,a,h,l,c,d,u=i[0];return 3===i.length?(o=i[1],l=i[2],n=null,a=null,h=null):(n=i[1],a=i[2],h=i[3],l=i[4],o=null),c=s.Z.copyAttributes(r,e.options,"curve3d"),(d=new t.Z.Curve3D(u,o,n,a,h,l,c)).element2D=e.create("curve",[[],[]],c),d.element2D.updateDataArray=function(){var t=d.updateDataArray();this.dataX=t.X,this.dataY=t.Y},d.addChild(d.element2D),d.inherits.push(d.element2D),d.element2D.setParents(d),d.element2D.prepareUpdate().update(),e.isSuspendedUpdate||d.element2D.updateVisibility().updateRenderer(),d},t.Z.registerElement("curve3d",t.Z.createCurve3D),t.Z.Line3D=function(t,e,r,o,n){this.constructor(t.board,n,i.Z.OBJECT_TYPE_LINE3D,i.Z.OBJECT_CLASS_3D),this.constructor3D(t,"line3d"),this.id=this.view.board.setId(this,"L3D"),this.board.finalizeAdding(this),this.point=e,this.direction=r,this.range=o||[-1/0,1/0],this.point1=null,this.point2=null,this.methodMap=s.Z.deepCopy(this.methodMap,{})},t.Z.Line3D.prototype=new t.Z.GeometryElement,s.Z.copyPrototypeMethods(t.Z.Line3D,t.Z.GeometryElement3D,"constructor3D"),t.Z.extend(t.Z.Line3D.prototype,{getPointCoords:function(t){var e,i,r,o=[];if(e=[this.point.X(),this.point.Y(),this.point.Z()],s.Z.isFunction(this.direction))o=this.direction();else for(i=1;i<4;i++)o.push(s.Z.evaluate(this.direction[i]));return r=s.Z.evaluate(t),Math.abs(r)===1/0&&(t=this.view.intersectionLineCube(e,o,r)),[e[0]+o[0]*r,e[1]+o[1]*r,e[2]+o[2]*r]},update:function(){return this},updateRenderer:function(){return this.needsUpdate=!1,this}}),t.Z.createLine3D=function(e,i,r){var o,n,a,h,l,c,d,u,p=i[0];return o=s.Z.copyAttributes(r,e.options,"line3d"),a=s.Z.providePoints3D(p,[i[1]],r,"line3d",["point"])[0],s.Z.isPoint3D(i[2])||3===i.length&&(s.Z.isArray(i[2])||s.Z.isFunction(i[2]))?(c=a,d=s.Z.providePoints3D(p,[i[2]],r,"line3d",["point2"])[0],h=function(){return[d.X()-a.X(),d.Y()-a.Y(),d.Z()-a.Z()]},l=[0,1],u=new t.Z.Line3D(p,a,h,l,o)):(s.Z.isFunction(i[2])?h=i[2]:3===i[2].length?h=[1].concat(i[2]):4===i[2].length&&(h=i[2]),l=i[3],n=s.Z.providePoints3D(p,[[0,0,0],[0,0,0]],r,"line3d",["point1","point2"]),u=new t.Z.Line3D(p,a,h,l,o),n[0].F=function(){return u.getPointCoords(s.Z.evaluate(u.range[0]))},n[0].prepareUpdate().update(),c=n[0],n[1].F=function(){return u.getPointCoords(s.Z.evaluate(u.range[1]))},n[1].prepareUpdate().update(),d=n[1]),u.element2D=p.create("segment",[c.element2D,d.element2D],o),u.addChild(u.element2D),u.inherits.push(u.element2D),u.element2D.setParents(u),c.addChild(u),d.addChild(u),u.point1=c,u.point2=d,u.update(),u.element2D.prepareUpdate().update().updateRenderer(),u},t.Z.registerElement("line3d",t.Z.createLine3D),t.Z.Plane3D=function(t,e,r,o,n,a,h){this.constructor(t.board,h,i.Z.OBJECT_TYPE_PLANE3D,i.Z.OBJECT_CLASS_3D),this.constructor3D(t,"plane3d"),this.id=this.view.board.setId(this,"PL3D"),this.board.finalizeAdding(this),this.point=e,this.direction1=r,this.direction2=n,this.range1=o||[-1/0,1/0],this.range2=a||[-1/0,1/0],this.vec1=[0,0,0],this.vec2=[0,0,0],this.grid=null,this.normal=[0,0,0],this.d=0,this.updateNormal(),this.methodMap=s.Z.deepCopy(this.methodMap,{})},t.Z.Plane3D.prototype=new t.Z.GeometryElement,s.Z.copyPrototypeMethods(t.Z.Plane3D,t.Z.GeometryElement3D,"constructor3D"),t.Z.extend(t.Z.Plane3D.prototype,{updateNormal:function(){var t,e;for(t=0;t<3;t++)this.vec1[t]=s.Z.evaluate(this.direction1[t]),this.vec2[t]=s.Z.evaluate(this.direction2[t]);if(this.normal=o.Z.crossProduct(this.vec1,this.vec2),e=o.Z.norm(this.normal),Math.abs(e)>o.Z.eps)for(t=0;t<3;t++)this.normal[t]/=e;return this.d=o.Z.innerProduct(this.point.coords.slice(1),this.normal,3),this},updateDataArray:function(){var t,e,i,r,n,a,h,l,c,d,p,_,f,b,g=["xPlaneRear","yPlaneRear","zPlaneRear"],m=[],v=[0,0,0],Z=[0,0,0],C=[0,0,0],y=[0,0,0],P=this.view;if(this.dataX=[],this.dataY=[],this.updateNormal(),"axisplane3d"!==this.elType&&P.defaultAxes&&s.Z.evaluate(this.range1[0])===-1/0&&s.Z.evaluate(this.range1[1])===1/0&&s.Z.evaluate(this.range2[0])===-1/0&&s.Z.evaluate(this.range2[1])===1/0){for(d=0;d<g.length;d++){if(3===(y=P.intersectionPlanePlane(this,P.defaultAxes[g[d]]))[0].length&&3===y[1].length){for(c=0;c<m.length&&!(u.Z.distance(y[0],m[c][0],3)<o.Z.eps&&u.Z.distance(y[1],m[c][1],3)<o.Z.eps||u.Z.distance(y[0],m[c][1],3)<o.Z.eps&&u.Z.distance(y[1],m[c][0],3)<o.Z.eps);c++);c===m.length&&m.push(y.slice())}if((y=[0,0,0])[d]=P.bbox3D[d][1],l=o.Z.innerProduct(y,P.defaultAxes[g[d]].normal,3),3===(y=P.intersectionPlanePlane(this,P.defaultAxes[g[d]],l))[0].length&&3===y[1].length){for(c=0;c<m.length&&!(u.Z.distance(y[0],m[c][0],3)<o.Z.eps&&u.Z.distance(y[1],m[c][1],3)<o.Z.eps||u.Z.distance(y[0],m[c][1],3)<o.Z.eps&&u.Z.distance(y[1],m[c][0],3)<o.Z.eps);c++);c===m.length&&m.push(y.slice())}}0,f=0,c=0;do{for(3===(y=m[f][c]).length&&(n=P.project3DTo2D(y),this.dataX.push(n[1]),this.dataY.push(n[2])),c=(c+1)%2,y=m[f][c],b=f,d=0;d<m.length;d++){if(d!==f&&u.Z.distance(y,m[d][0])<o.Z.eps){f=d,c=0;break}if(d!==f&&u.Z.distance(y,m[d][1])<o.Z.eps){f=d,c=1;break}}if(f===b){console.log("Error: update plane3d: did not find next",f);break}}while(0!==f);n=P.project3DTo2D(m[0][0]),this.dataX.push(n[1]),this.dataY.push(n[2])}else{for(t=s.Z.evaluate(this.range1[0]),e=s.Z.evaluate(this.range1[1]),i=s.Z.evaluate(this.range2[0]),r=s.Z.evaluate(this.range2[1]),C=this.point.coords.slice(1),v=this.vec1.slice(),Z=this.vec2.slice(),a=o.Z.norm(v,3),h=o.Z.norm(Z,3),c=0;c<3;c++)v[c]/=a,Z[c]/=h;for(d=0;d<4;d++){switch(d){case 0:p=t,_=i;break;case 1:p=e,_=i;break;case 2:p=e,_=r;break;case 3:p=t,_=r}for(c=0;c<3;c++)y[c]=C[c]+p*v[c]+_*Z[c];n=P.project3DTo2D(y),this.dataX.push(n[1]),this.dataY.push(n[2])}this.dataX.push(this.dataX[0]),this.dataY.push(this.dataY[0])}return{X:this.dataX,Y:this.dataY}},update:function(){return this},updateRenderer:function(){return this.needsUpdate=!1,this}}),t.Z.createPlane3D=function(e,i,r){var o,n,a,h,l=i[0],c=i[2],d=i[3],u=i[4]||[-1/0,1/0],p=i[5]||[-1/0,1/0];return n=s.Z.providePoints3D(l,[i[1]],r,"plane3d",["point"])[0],o=s.Z.copyAttributes(r,e.options,"plane3d"),a=new t.Z.Plane3D(l,n,c,u,d,p,o),n.addChild(a),a.element2D=l.create("curve",[[],[]],o),a.element2D.updateDataArray=function(){var t=a.updateDataArray();this.dataX=t.X,this.dataY=t.Y},a.addChild(a.element2D),a.inherits.push(a.element2D),a.element2D.setParents(a),o=s.Z.copyAttributes(r.mesh3d,e.options,"mesh3d"),Math.abs(a.range1[0])!==1/0&&Math.abs(a.range1[1])!==1/0&&Math.abs(a.range2[0])!==1/0&&Math.abs(a.range2[1])!==1/0&&(h=l.create("mesh3d",[function(){return n.coords},c,u,d,p],o),a.grid=h,a.addChild(h),a.inherits.push(h),h.setParents(a)),a.element2D.prepareUpdate().update(),e.isSuspendedUpdate||a.element2D.updateVisibility().updateRenderer(),a},t.Z.registerElement("plane3d",t.Z.createPlane3D),t.Z.Surface3D=function(t,e,r,o,n,a,h,l){this.constructor(t.board,l,i.Z.OBJECT_TYPE_SURFACE3D,i.Z.OBJECT_CLASS_3D),this.constructor3D(t,"surface3d"),this.id=this.view.board.setId(this,"S3D"),this.board.finalizeAdding(this),this.F=e,this.X=r,this.Y=o,this.Z=n,null!==this.F&&(this.X=function(t,e){return this.F(t,e)[0]},this.Y=function(t,e){return this.F(t,e)[1]},this.Z=function(t,e){return this.F(t,e)[2]}),this.range_u=a,this.range_v=h,this.methodMap=s.Z.deepCopy(this.methodMap,{})},t.Z.Surface3D.prototype=new t.Z.GeometryElement,s.Z.copyPrototypeMethods(t.Z.Surface3D,t.Z.GeometryElement3D,"constructor3D"),t.Z.extend(t.Z.Surface3D.prototype,{updateDataArray:function(){var t,e,i=s.Z.evaluate(this.visProp.stepsu),r=s.Z.evaluate(this.visProp.stepsv),o=s.Z.evaluate(this.range_u),n=s.Z.evaluate(this.range_v);return t=null!==this.F?this.F:[this.X,this.Y,this.Z],{X:(e=this.view.getMesh(t,o.concat([i]),n.concat([r])))[0],Y:e[1]}},update:function(){return this},updateRenderer:function(){return this.needsUpdate=!1,this}}),t.Z.createParametricSurface3D=function(e,i,r){var o,n,a,h,l,c,d,u,p=i[0];return 4===i.length?(o=i[1],l=i[2],c=i[3],n=null,a=null,h=null):(n=i[1],a=i[2],h=i[3],l=i[4],c=i[5],o=null),d=s.Z.copyAttributes(r,e.options,"surface3d"),(u=new t.Z.Surface3D(p,o,n,a,h,l,c,d)).element2D=p.create("curve",[[],[]],d),u.element2D.updateDataArray=function(){var t=u.updateDataArray();this.dataX=t.X,this.dataY=t.Y},u.addChild(u.element2D),u.inherits.push(u.element2D),u.element2D.setParents(u),u.element2D.prepareUpdate().update(),e.isSuspendedUpdate||u.element2D.updateVisibility().updateRenderer(),u},t.Z.registerElement("parametricsurface3d",t.Z.createParametricSurface3D),t.Z.createFunctiongraph3D=function(t,e,i){var s=e[0],r=e[1],o=e[2],n=e[3];return s.create("parametricsurface3d",[function(t,e){return t},function(t,e){return e},r,o,n],i)},t.Z.registerElement("functiongraph3d",t.Z.createFunctiongraph3D);const it=t.Z.COORDS_BY_SCREEN,st=t.Z.COORDS_BY_USER,rt=t.Z.Dump,ot=t.Z.JSXGraph,nt=t.Z.Math,at=t.Z.Options,ht=t.Z.boards,lt=t.Z.elements,ct=t.Z.palette,dt=t.Z.paletteWong,ut=t.Z.Board,pt=t.Z.Chart,_t=t.Z.Circle,ft=t.Z.Complex,bt=t.Z.Composition,gt=t.Z.Coords,mt=t.Z.CoordsElement,vt=t.Z.Curve,Zt=t.Z.GeometryElement,Ct=t.Z.Group,yt=t.Z.Image,Pt=t.Z.JessieCode,Et=t.Z.Line,Ot=t.Z.Point,xt=t.Z.Polygon,wt=t.Z.Text,St=t.Z.Ticks,Tt=t.Z.Transformation,Mt=t.Z.Turtle,Nt=t.Z.View3D,At=t.Z.LMS2rgb,kt=t.Z.addEvent,Rt=t.Z.autoDigits,Dt=t.Z.autoHighlight,Lt=t.Z.bind,Bt=t.Z.capitalize,It=t.Z.clearVisPropOld,Yt=t.Z.clone,jt=t.Z.cloneAndCopy,Xt=t.Z.cmpArrays,Ut=t.Z.coordsArrayToMatrix,Ft=t.Z.copyAttributes,Jt=t.Z.createEvalFunction,Gt=t.Z.createFunction,zt=t.Z.createHTMLSlider,Ht=t.Z.debug,Wt=t.Z.debugInt,Vt=t.Z.debugLine,$t=t.Z.debugWST,Kt=t.Z.deepCopy,qt=t.Z.def,Qt=t.Z.deprecated,te=t.Z.eliminateDuplicates,ee=t.Z.escapeHTML,ie=t.Z.evalSlider,se=t.Z.evaluate,re=t.Z.filterElements,oe=t.Z.getBoardByContainerId,ne=t.Z.getCSSTransformMatrix,ae=t.Z.getCSSTransform,he=t.Z.getDimensions,le=t.Z.getOffset,ce=t.Z.getPosition,de=t.Z.getProp,ue=t.Z.hex2rgb,pe=t.Z.hsv2rgb,_e=t.Z.isAndroid,fe=t.Z.isApple,be=t.Z.isArray,ge=t.Z.isInArray,me=t.Z.isInObject,ve=t.Z.isMetroApp,Ze=t.Z.isMozilla,Ce=t.Z.isName,ye=t.Z.isNode,Pe=t.Z.isNumber,Ee=t.Z.isObject,Oe=t.Z.isPointType,xe=t.Z.isString,we=t.Z.isTouchDevice,Se=t.Z.isTransformationOrArray,Te=t.Z.isWebWorker,Me=t.Z.isWebkitAndroid,Ne=t.Z.isWebkitApple,Ae=t.Z.keys,ke=t.Z.merge,Re=t.Z.normalizePointFace,De=t.Z.providePoints,Le=t.Z.registerElement,Be=t.Z.registerReader,Ie=t.Z.removeAllEvents,Ye=t.Z.removeElementFromArray,je=t.Z.removeEvent,Xe=t.Z.rgb2LMS,Ue=t.Z.rgb2bw,Fe=t.Z.rgb2cb,Je=t.Z.rgb2css,Ge=t.Z.rgb2hex,ze=t.Z.rgb2hsv,He=t.Z.rgbParser,We=t.Z.rgba2rgbo,Ve=t.Z.rgbo2rgba,$e=t.Z.sanitizeHTML,Ke=t.Z.shortcut,qe=t.Z.str2Bool,Qe=t.Z.supportsCanvas,ti=t.Z.supportsPointerEvents,ei=t.Z.supportsSVG,ii=t.Z.supportsVML,si=t.Z.swap,ri=t.Z.timedChunk,oi=t.Z.toFixed,ni=t.Z.toFullscreen,ai=t.Z.toJSON,hi=t.Z.trim,li=t.Z.trimNumber,ci=t.Z.truncate,di=t.Z.unescapeHTML,ui=t.Z.uniqueArray,pi=t.Z.useBlackWhiteOptions,_i=t.Z.useStandardOptions,fi=t.Z.warn;e.Z.isBrowser?window.JXG=t.Z:e.Z.isWebWorker()&&(self.JXG=t.Z);const bi=t.Z})();var __webpack_exports__Board=__webpack_exports__.$l,__webpack_exports__COORDS_BY_SCREEN=__webpack_exports__.fy,__webpack_exports__COORDS_BY_USER=__webpack_exports__.JU,__webpack_exports__Chart=__webpack_exports__.kL,__webpack_exports__Circle=__webpack_exports__.Cd,__webpack_exports__Complex=__webpack_exports__.Zz,__webpack_exports__Composition=__webpack_exports__.fS,__webpack_exports__Coords=__webpack_exports__.mZ,__webpack_exports__CoordsElement=__webpack_exports__.L6,__webpack_exports__Curve=__webpack_exports__.Hy,__webpack_exports__Dump=__webpack_exports__.iG,__webpack_exports__GeometryElement=__webpack_exports__.QK,__webpack_exports__Group=__webpack_exports__.ZA,__webpack_exports__Image=__webpack_exports__.Ee,__webpack_exports__JSXGraph=__webpack_exports__.Nn,__webpack_exports__JessieCode=__webpack_exports__.n1,__webpack_exports__LMS2rgb=__webpack_exports__.IY,__webpack_exports__Line=__webpack_exports__.x1,__webpack_exports__Math=__webpack_exports__.ZX,__webpack_exports__Options=__webpack_exports__.Ei,__webpack_exports__Point=__webpack_exports__.E9,__webpack_exports__Polygon=__webpack_exports__.mg,__webpack_exports__Text=__webpack_exports__.xv,__webpack_exports__Ticks=__webpack_exports__.vb,__webpack_exports__Transformation=__webpack_exports__.zA,__webpack_exports__Turtle=__webpack_exports__.l8,__webpack_exports__View3D=__webpack_exports__.nY,__webpack_exports__addEvent=__webpack_exports__.vP,__webpack_exports__autoDigits=__webpack_exports__.lZ,__webpack_exports__autoHighlight=__webpack_exports__.I0,__webpack_exports__bind=__webpack_exports__.ak,__webpack_exports__boards=__webpack_exports__.tj,__webpack_exports__capitalize=__webpack_exports__.kC,__webpack_exports__clearVisPropOld=__webpack_exports__.HM,__webpack_exports__clone=__webpack_exports__.d9,__webpack_exports__cloneAndCopy=__webpack_exports__.V$,__webpack_exports__cmpArrays=__webpack_exports__.DV,__webpack_exports__coordsArrayToMatrix=__webpack_exports__.fG,__webpack_exports__copyAttributes=__webpack_exports__.DM,__webpack_exports__createEvalFunction=__webpack_exports__.OD,__webpack_exports__createFunction=__webpack_exports__.o5,__webpack_exports__createHTMLSlider=__webpack_exports__.JI,__webpack_exports__debug=__webpack_exports__.fF,__webpack_exports__debugInt=__webpack_exports__.Ql,__webpack_exports__debugLine=__webpack_exports__.yl,__webpack_exports__debugWST=__webpack_exports__.lU,__webpack_exports__deepCopy=__webpack_exports__.p$,__webpack_exports__def=__webpack_exports__.Nj,__webpack_exports__default=__webpack_exports__.ZP,__webpack_exports__deprecated=__webpack_exports__.x9,__webpack_exports__elements=__webpack_exports__.Rm,__webpack_exports__eliminateDuplicates=__webpack_exports__.XH,__webpack_exports__escapeHTML=__webpack_exports__.r,__webpack_exports__evalSlider=__webpack_exports__.Lw,__webpack_exports__evaluate=__webpack_exports__.ku,__webpack_exports__filterElements=__webpack_exports__.a2,__webpack_exports__getBoardByContainerId=__webpack_exports__.vn,__webpack_exports__getCSSTransform=__webpack_exports__.wx,__webpack_exports__getCSSTransformMatrix=__webpack_exports__.zL,__webpack_exports__getDimensions=__webpack_exports__.t_,__webpack_exports__getOffset=__webpack_exports__.os,__webpack_exports__getPosition=__webpack_exports__.bt,__webpack_exports__getProp=__webpack_exports__.WJ,__webpack_exports__hex2rgb=__webpack_exports__.wK,__webpack_exports__hsv2rgb=__webpack_exports__.XG,__webpack_exports__isAndroid=__webpack_exports__.Dt,__webpack_exports__isApple=__webpack_exports__.mL,__webpack_exports__isArray=__webpack_exports__.kJ,__webpack_exports__isInArray=__webpack_exports__.dB,__webpack_exports__isInObject=__webpack_exports__.oG,__webpack_exports__isMetroApp=__webpack_exports__.EE,__webpack_exports__isMozilla=__webpack_exports__.oP,__webpack_exports__isName=__webpack_exports__.K9,__webpack_exports__isNode=__webpack_exports__.UG,__webpack_exports__isNumber=__webpack_exports__.hj,__webpack_exports__isObject=__webpack_exports__.Kn,__webpack_exports__isPointType=__webpack_exports__.EJ,__webpack_exports__isString=__webpack_exports__.HD,__webpack_exports__isTouchDevice=__webpack_exports__.b1,__webpack_exports__isTransformationOrArray=__webpack_exports__.iI,__webpack_exports__isWebWorker=__webpack_exports__.n2,__webpack_exports__isWebkitAndroid=__webpack_exports__.E,__webpack_exports__isWebkitApple=__webpack_exports__.Ju,__webpack_exports__keys=__webpack_exports__.XP,__webpack_exports__merge=__webpack_exports__.TS,__webpack_exports__normalizePointFace=__webpack_exports__.ZL,__webpack_exports__palette=__webpack_exports__.DG,__webpack_exports__paletteWong=__webpack_exports__.od,__webpack_exports__providePoints=__webpack_exports__.bU,__webpack_exports__registerElement=__webpack_exports__.ui,__webpack_exports__registerReader=__webpack_exports__.yt,__webpack_exports__removeAllEvents=__webpack_exports__.aC,__webpack_exports__removeElementFromArray=__webpack_exports__.sL,__webpack_exports__removeEvent=__webpack_exports__.xC,__webpack_exports__rgb2LMS=__webpack_exports__.OK,__webpack_exports__rgb2bw=__webpack_exports__.OW,__webpack_exports__rgb2cb=__webpack_exports__.KJ,__webpack_exports__rgb2css=__webpack_exports__.dq,__webpack_exports__rgb2hex=__webpack_exports__.CO,__webpack_exports__rgb2hsv=__webpack_exports__.tu,__webpack_exports__rgb2rgba=__webpack_exports__.KW,__webpack_exports__rgb2rgbo=__webpack_exports__.uh,__webpack_exports__rgbParser=__webpack_exports__.cE,__webpack_exports__sanitizeHTML=__webpack_exports__.jW,__webpack_exports__shortcut=__webpack_exports__.Xl,__webpack_exports__strBool=__webpack_exports__.uw,__webpack_exports__supportsCanvas=__webpack_exports__.Fm,__webpack_exports__supportsPointerEvents=__webpack_exports__.kK,__webpack_exports__supportsSVG=__webpack_exports__.n,__webpack_exports__supportsVML=__webpack_exports__.SJ,__webpack_exports__swap=__webpack_exports__.LF,__webpack_exports__timeChunk=__webpack_exports__.J6,__webpack_exports__toFixed=__webpack_exports__.FH,__webpack_exports__toFullscreen=__webpack_exports__.Ls,__webpack_exports__toJSON=__webpack_exports__.au,__webpack_exports__trim=__webpack_exports__.A8,__webpack_exports__trimNumber=__webpack_exports__._V,__webpack_exports__truncate=__webpack_exports__.$G,__webpack_exports__unescapeHTML=__webpack_exports__.Uo,__webpack_exports__uniqueArray=__webpack_exports__.Nb,__webpack_exports__useBlackWhiteOptions=__webpack_exports__.zz,__webpack_exports__useStandardOptions=__webpack_exports__.W6,__webpack_exports__warn=__webpack_exports__.ZK;export{__webpack_exports__Board as Board,__webpack_exports__COORDS_BY_SCREEN as COORDS_BY_SCREEN,__webpack_exports__COORDS_BY_USER as COORDS_BY_USER,__webpack_exports__Chart as Chart,__webpack_exports__Circle as Circle,__webpack_exports__Complex as Complex,__webpack_exports__Composition as Composition,__webpack_exports__Coords as Coords,__webpack_exports__CoordsElement as CoordsElement,__webpack_exports__Curve as Curve,__webpack_exports__Dump as Dump,__webpack_exports__GeometryElement as GeometryElement,__webpack_exports__Group as Group,__webpack_exports__Image as Image,__webpack_exports__JSXGraph as JSXGraph,__webpack_exports__JessieCode as JessieCode,__webpack_exports__LMS2rgb as LMS2rgb,__webpack_exports__Line as Line,__webpack_exports__Math as Math,__webpack_exports__Options as Options,__webpack_exports__Point as Point,__webpack_exports__Polygon as Polygon,__webpack_exports__Text as Text,__webpack_exports__Ticks as Ticks,__webpack_exports__Transformation as Transformation,__webpack_exports__Turtle as Turtle,__webpack_exports__View3D as View3D,__webpack_exports__addEvent as addEvent,__webpack_exports__autoDigits as autoDigits,__webpack_exports__autoHighlight as autoHighlight,__webpack_exports__bind as bind,__webpack_exports__boards as boards,__webpack_exports__capitalize as capitalize,__webpack_exports__clearVisPropOld as clearVisPropOld,__webpack_exports__clone as clone,__webpack_exports__cloneAndCopy as cloneAndCopy,__webpack_exports__cmpArrays as cmpArrays,__webpack_exports__coordsArrayToMatrix as coordsArrayToMatrix,__webpack_exports__copyAttributes as copyAttributes,__webpack_exports__createEvalFunction as createEvalFunction,__webpack_exports__createFunction as createFunction,__webpack_exports__createHTMLSlider as createHTMLSlider,__webpack_exports__debug as debug,__webpack_exports__debugInt as debugInt,__webpack_exports__debugLine as debugLine,__webpack_exports__debugWST as debugWST,__webpack_exports__deepCopy as deepCopy,__webpack_exports__def as def,__webpack_exports__default as default,__webpack_exports__deprecated as deprecated,__webpack_exports__elements as elements,__webpack_exports__eliminateDuplicates as eliminateDuplicates,__webpack_exports__escapeHTML as escapeHTML,__webpack_exports__evalSlider as evalSlider,__webpack_exports__evaluate as evaluate,__webpack_exports__filterElements as filterElements,__webpack_exports__getBoardByContainerId as getBoardByContainerId,__webpack_exports__getCSSTransform as getCSSTransform,__webpack_exports__getCSSTransformMatrix as getCSSTransformMatrix,__webpack_exports__getDimensions as getDimensions,__webpack_exports__getOffset as getOffset,__webpack_exports__getPosition as getPosition,__webpack_exports__getProp as getProp,__webpack_exports__hex2rgb as hex2rgb,__webpack_exports__hsv2rgb as hsv2rgb,__webpack_exports__isAndroid as isAndroid,__webpack_exports__isApple as isApple,__webpack_exports__isArray as isArray,__webpack_exports__isInArray as isInArray,__webpack_exports__isInObject as isInObject,__webpack_exports__isMetroApp as isMetroApp,__webpack_exports__isMozilla as isMozilla,__webpack_exports__isName as isName,__webpack_exports__isNode as isNode,__webpack_exports__isNumber as isNumber,__webpack_exports__isObject as isObject,__webpack_exports__isPointType as isPointType,__webpack_exports__isString as isString,__webpack_exports__isTouchDevice as isTouchDevice,__webpack_exports__isTransformationOrArray as isTransformationOrArray,__webpack_exports__isWebWorker as isWebWorker,__webpack_exports__isWebkitAndroid as isWebkitAndroid,__webpack_exports__isWebkitApple as isWebkitApple,__webpack_exports__keys as keys,__webpack_exports__merge as merge,__webpack_exports__normalizePointFace as normalizePointFace,__webpack_exports__palette as palette,__webpack_exports__paletteWong as paletteWong,__webpack_exports__providePoints as providePoints,__webpack_exports__registerElement as registerElement,__webpack_exports__registerReader as registerReader,__webpack_exports__removeAllEvents as removeAllEvents,__webpack_exports__removeElementFromArray as removeElementFromArray,__webpack_exports__removeEvent as removeEvent,__webpack_exports__rgb2LMS as rgb2LMS,__webpack_exports__rgb2bw as rgb2bw,__webpack_exports__rgb2cb as rgb2cb,__webpack_exports__rgb2css as rgb2css,__webpack_exports__rgb2hex as rgb2hex,__webpack_exports__rgb2hsv as rgb2hsv,__webpack_exports__rgb2rgba as rgb2rgba,__webpack_exports__rgb2rgbo as rgb2rgbo,__webpack_exports__rgbParser as rgbParser,__webpack_exports__sanitizeHTML as sanitizeHTML,__webpack_exports__shortcut as shortcut,__webpack_exports__strBool as strBool,__webpack_exports__supportsCanvas as supportsCanvas,__webpack_exports__supportsPointerEvents as supportsPointerEvents,__webpack_exports__supportsSVG as supportsSVG,__webpack_exports__supportsVML as supportsVML,__webpack_exports__swap as swap,__webpack_exports__timeChunk as timeChunk,__webpack_exports__toFixed as toFixed,__webpack_exports__toFullscreen as toFullscreen,__webpack_exports__toJSON as toJSON,__webpack_exports__trim as trim,__webpack_exports__trimNumber as trimNumber,__webpack_exports__truncate as truncate,__webpack_exports__unescapeHTML as unescapeHTML,__webpack_exports__uniqueArray as uniqueArray,__webpack_exports__useBlackWhiteOptions as useBlackWhiteOptions,__webpack_exports__useStandardOptions as useStandardOptions,__webpack_exports__warn as warn};
//# sourceMappingURL=jsxgraphcore.mjs.map